<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../../mainfile.php');
}
getLanguageDef (_OPN_ROOT_PATH . 'admin/diagnostic/language/');

function _auto_defined_check_to_code (&$src, $dat, $module) {

	$definetestplug = '_DBCODE_' . str_replace ('.', '_', $dat);
	$definetest = $definetestplug . '_' . str_replace ('/', '_', $module);
	$content = '<?php' . _OPN_HTML_NL;
	$content .= 'if(!defined(\'' . $definetest . '\')) {' . _OPN_HTML_NL;
	$content .= 'define(\'' . $definetest . '\',1);' . _OPN_HTML_NL;
	$content .= '?>';
	$content .= $src;
	$content .= '<?php' . _OPN_HTML_NL;
	$content .= '}' . _OPN_HTML_NL;
	$content .= '?>';
	$src = $content;
	unset ($content);

}

function _reload_Header ($url) {

	$myurl = 'Refresh: 1; url=' . $url;
	Header ($myurl);

}

function _Redirect ($url, $needreferer = false) {

	global $opnConfig, ${$opnConfig['opn_server_vars']};

	$servervars = ${$opnConfig['opn_server_vars']};
	if ( (isset ($opnConfig['UseHeaderRefresh']) ) && (! ($needreferer) ) ) {
		$hlp = 'Refresh: ' . $opnConfig['HeaderRefreshTime'] . '; url=%s';
		$hlp1 = '<meta http-equiv="refresh" content="' . $opnConfig['HeaderRefreshTime'] . ';url=%s">';
		if ( (preg_match ('/IIS/', $servervars['SERVER_SOFTWARE']) ) || (trim ($opnConfig['opnOption']['client']->_browser_info['long_name']) == 'opera') ) {
			echo ' ';
		}
	} else {
		$hlp = 'Location: %s';
		$hlp1 = '<meta http-equiv="refresh" content="0;url=%s">';
	}
	if (substr_count ($url, '://') == 0) {
		if (strpos ($url, '/')<2) {
			$url = substr ($url, 1);
		}
		$url = $opnConfig['opn_url'] . '/' . $url;
	}
	if (!defined ('_OPN_HEADER_REDIRECT') ) {
		define ('_OPN_HEADER_REDIRECT', 1);
	}
	if (!headers_sent () ) {
		header ('Referer: ' . $opnConfig['opn_url'] . '/');
		Header (sprintf ($hlp, $url) );
		header ('Referer: ' . $opnConfig['opn_url']);
	} else {
		echo sprintf ($hlp1, $url);
	}

}

function autorepairredirect ($reccount, $maxperpage, $backurl = false) {

	global $opnConfig;

	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	if ($backurl === false) {
		$backurl = '/index.php';
	}
	$numberofPages = ceil ($reccount/ $maxperpage);
	$actualPage = ceil ( ($offset+1)/ $maxperpage);
	if ($actualPage<$numberofPages) {
		$offset = ($actualPage* $maxperpage);
		_Redirect (encodeurl (array ($opnConfig['opn_url'] . $backurl,
					'offset' => $offset) ) );
	} else {
		_Redirect (encodeurl (array ($opnConfig['opn_url'] . $backurl,
					'autorepairpluginoff' => '0') ) );
	}

}

function autorepairtheplugins () {

	global $opnTables, $opnConfig;

	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	include_once (_OPN_ROOT_PATH . '/class/class.installer.php');
	$plug = array ();
	$opnConfig['installedPlugins']->getplugin ($plug,
								'*pluginrepair*');
	ksort ($plug);
	reset ($plug);
	$maxperpage = 40;
	$reccount = count ($plug);
	$plug = array_slice ($plug, $offset, $maxperpage);
	$myreturn = array ();
	foreach ($plug as $var1) {
		include (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/repair/index.php');
		$mywayfunc = $var1['module'] . '_repair_plugin';
		$mywert = $var1['plugin'];
		if (function_exists ($mywayfunc) ) {
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_plugins'] . " WHERE plugin='$mywert'");
			$myfunc = $mywayfunc;
			$myfunc ($mywert);
			$repairresult = true;
		} else {
			$repairresult = $mywayfunc;
		}
		$myreturn[$var1['plugin']] = $repairresult;
	}
	autorepairredirect ($reccount, $maxperpage);

}

function autorepairinsertdata ($dat, $src) {

	global $opnConfig, $opnTables;

	$sid = -1;
	$result = &$opnConfig['database']->Execute ('SELECT sid, src, dat FROM ' . $opnTables['opn_script'] . " WHERE dat='$dat'");
	if ($result !== false) {
		if ($result->RecordCount () == 1) {
			$sid = $result->fields['sid'];
			$src .= $result->fields['src'];
			$dat = $result->fields['dat'];
		}
		$result->Close ();
	}
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_script'] . " WHERE dat='$dat'");
	if ($sid == -1) {
		$sid = $opnConfig['opnSQL']->get_new_number ('opn_script', 'sid');
	}
	$src = $opnConfig['opnSQL']->qstr ($src, 'src');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['opn_script'] . " (sid, src, dat) VALUES ($sid, $src, '$dat')");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['opn_script'], 'sid=' . $sid);

}

function autorepairdeletedata ($dat) {

	global $opnConfig, $opnTables;

	$result = &$opnConfig['database']->Execute ('SELECT sid FROM ' . $opnTables['opn_script'] . " WHERE dat='$dat'");
	if ($result !== false) {
		if ($result->RecordCount () == 1) {
			$sid = $result->fields['sid'];
		}
		$result->Close ();
	}
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_script'] . " WHERE dat='$dat'");

}

function autorepairthemenavi ($backurl = false) {

	global $opnConfig;

	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$plug = array ();
	$opnConfig['installedPlugins']->getplugin ($plug,
								'themenav');
	ksort ($plug);
	reset ($plug);
	$sid = -1;
	if ( ($offset == 0) OR ($offset == 1) ) {
		$dat = 'plugin.themenav';
		autorepairdeletedata ($dat);
	}
	$maxperpage = 40;
	$reccount = count ($plug);
	$plug = array_slice ($plug, $offset, $maxperpage);
	$dat = 'plugin.themenav';
	foreach ($plug as $var1) {
		$file = fopen (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/theme/index.php', 'r');
		$src = fread ($file, filesize (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/theme/index.php') );
		fclose ($file);
		_auto_defined_check_to_code ($src, $dat, $var1['plugin']);
		autorepairinsertdata ($dat, $src);
	}
	autorepairredirect ($reccount, $maxperpage, $backurl);

}

function autorepairwaiting () {

	global $opnConfig;

	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$plug = array ();
	$opnConfig['installedPlugins']->getplugin ($plug,
								'waitingcontent');
	ksort ($plug);
	reset ($plug);
	$sid = -1;
	if ( ($offset == 0) OR ($offset == 1) ) {
		$dat = 'plugin.waitingcontent';
		autorepairdeletedata ($dat);
	}
	$maxperpage = 40;
	$reccount = count ($plug);
	$plug = array_slice ($plug, $offset, $maxperpage);
	$dat = 'plugin.waitingcontent';
	foreach ($plug as $var1) {
		$file = fopen (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/sidebox/waiting/insert.php', 'r');
		$src = fread ($file, filesize (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/sidebox/waiting/insert.php') );
		fclose ($file);
		_auto_defined_check_to_code ($src, $dat, $var1['plugin']);
		autorepairinsertdata ($dat, $src);
	}
	autorepairredirect ($reccount, $maxperpage);

}

function autorepairmenus () {

	global $opnConfig;

	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$plug = array ();
	$opnConfig['installedPlugins']->getplugin ($plug,
								'menu');
	ksort ($plug);
	reset ($plug);
	$sid = -1;
	if ( ($offset == 0) OR ($offset == 1) ) {
		autorepairdeletedata ('plugin.sitemap');
		autorepairdeletedata ('plugin.usermenu');
		autorepairdeletedata ('plugin.adminmenu');
	}
	$maxperpage = 40;
	$reccount = count ($plug);
	$dat = 'plugin.menu';
	$plug = array_slice ($plug, $offset, $maxperpage);
	autorepairmenu ('sitemap', $plug, '/plugin/menu/index.php');
	autorepairmenu ('usermenu', $plug, '/plugin/menu/usermenu.php');
	autorepairmenu ('adminmenu', $plug, '/plugin/menu/adminmenu.php');
	autorepairredirect ($reccount, $maxperpage);

}

function autorepairmenu ($what, $plug, $filepath) {

	$dat = 'plugin.' . $what;
	foreach ($plug as $var1) {
		if (file_exists (_OPN_ROOT_PATH . $var1['plugin'] . $filepath) ) {
			$file = fopen (_OPN_ROOT_PATH . $var1['plugin'] . $filepath, 'r');
			$src = fread ($file, filesize (_OPN_ROOT_PATH . $var1['plugin'] . $filepath) );
			fclose ($file);
			_auto_defined_check_to_code ($src, $dat, $var1['plugin']);
			autorepairinsertdata ($dat, $src);
		}
	}

}

function opnsupport () {

	#	global $opnTables, $opnConfig;

	global $opnConfig;
	if ( (isset ($opnConfig['send_email_via']) ) && (isset ($opnConfig['opn_supporter']) ) && ($opnConfig['opn_supporter'] == '1') && (isset ($opnConfig['opn_supporter_email']) ) && ($opnConfig['opn_supporter_email'] != '') ) {
		$messages = 'Just testing mail system. Version: [' . $opnConfig['opn_version'] . ']';
		if (!defined ('_OPN_MAILER_INCLUDED') ) {
			include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
		}
		$subject = $opnConfig['opn_supporter_name'] . ' [' . $opnConfig['opn_supporter_customer'] . '] ' . $opnConfig['sitename'] . ' - automatic information';
		$mail = & new opn_mailer ();
		$mail->opn_mail_fill ($opnConfig['opn_supporter_email'], $subject, '', '', $messages, $opnConfig['adminmail'], $opnConfig['adminmail'], true);
		$mail->send ();
		$mail->init ();
	}

}

?>