<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function GetSysInfo () {

	global $opnConfig;
	if (strtoupper (substr (PHP_OS, 0, 3) ) === 'WIN') {
		$page_result = '<span class="normaltextbold">' . _DIAG_OPNINT_SYSINFO_SYS . '</span>';
	} else {
		$service[1] = _DIAG_OPNINT_SYSINFO_WWW;
		$service[2] = _DIAG_OPNINT_SYSINFO_FTP;
		$service[3] = _DIAG_OPNINT_SYSINFO_SSH;
		$service[4] = _DIAG_OPNINT_SYSINFO_8000;
		// Header
		$msg_general_info = _DIAG_OPNINT_SYSINFO_GINFO;
		$msg_system_time = _DIAG_OPNINT_SYSINFO_SYSTIME;
		$msg_kernel = _DIAG_OPNINT_SYSINFO_KERNEL;
		$msg_cpu = _DIAG_OPNINT_SYSINFO_CPU;
		$msg_cpu_cache = _DIAG_OPNINT_SYSINFO_CACHE;
		$msg_cpu_bogomips = _DIAG_OPNINT_SYSINFO_BOGOMIPS;
		$msg_uptime = _DIAG_OPNINT_SYSINFO_UPTIME;

		/*	Change service name - especially useful for services
		* 	that show up as port numbers - ie: 8000 - icecast
		*/

		$svcname[1] = _DIAG_OPNINT_SYSINFO_WEB;
		$svcname[2] = _DIAG_OPNINT_SYSINFO_FTP;
		$svcname[3] = _DIAG_OPNINT_SYSINFO_SSH;
		$svcname[4] = _DIAG_OPNINT_SYSINFO_ICECAST;
		// Connections
		$msg_connections = _DIAG_OPNINT_SYSINFO_CONNECTIONS;
		$msg_who_is_connected = _DIAG_OPNINT_SYSINFO_WILI;
		$msg_conn_user = _DIAG_OPNINT_SYSINFO_USER;
		$msg_conn_tty = _DIAG_OPNINT_SYSINFO_TTY;
		$msg_conn_from = _DIAG_OPNINT_SYSINFO_FROM;
		$msg_conn_login = _DIAG_OPNINT_SYSINFO_LOGIN;
		$msg_conn_idle = _DIAG_OPNINT_SYSINFO_IDLE;
		$msg_conn_jcpu = _DIAG_OPNINT_SYSINFO_JCPU;
		$msg_conn_pcpu = _DIAG_OPNINT_SYSINFO_PCPU;
		$msg_conn_what = _DIAG_OPNINT_SYSINFO_WHAT;
		// Memory and storage
		$msg_memory = _DIAG_OPNINT_SYSINFO_MEMORY;
		$msg_mounts = _DIAG_OPNINT_SYSINFO_MOUNTS;
		$msg_swap = _DIAG_OPNINT_SYSINFO_SWAP;
		$msg_used = _DIAG_OPNINT_SYSINFO_USED;
		$msg_usage = _DIAG_OPNINT_SYSINFO_USAGE;
		$msg_free = _DIAG_OPNINT_SYSINFO_FREE;
		$msg_buffered = _DIAG_OPNINT_SYSINFO_BUFFERED;
		$msg_cached = _DIAG_OPNINT_SYSINFO_CACHED;
		$msg_mount = _DIAG_OPNINT_SYSINFO_MOUNT;
		$msg_size = _DIAG_OPNINT_SYSINFO_SIZE;
		$msg_total = _DIAG_OPNINT_SYSINFO_TOTAL;
		$msg_percent = _DIAG_OPNINT_SYSINFO_PERCENT;
		$time = (exec ('date') );
		$temp = exec ('uname -a');
		if ($temp <> '') {
			list ($system, $host, $kernel) = split (' ', $temp, 5);
			$ip = gethostbyname ($host);
		} else {
			$system = _DIAG_OPNINT_SYSINFO_UNKNOWN;
			$host = _DIAG_OPNINT_SYSINFO_UNKNOWN;
			$kernel = _DIAG_OPNINT_SYSINFO_UNKNOWN;
			$ip ='';
			get_var('SERVER_ADDR',$ip,'server');
		}
		$uptime = (exec ('uptime') );
		$cpu_info = '';
		if (file_exists ('/proc/cpuinfo') ) {
			$cpuinfo = file ('/proc/cpuinfo');
		}
		if ( (isset ($cpuinfo) ) && ($cpuinfo != '') ) {
			$total_cpu = 0;
			for ($i = 0, $max = count ($cpuinfo)-1; $i< $max; $i++) {
				$item = '';
				$data = '';
				if (chop ($cpuinfo[$i]) != '') {
					list ($item, $data) = split (':', $cpuinfo[$i], 2);
					$item = chop ($item);
					$data = chop ($data);
				}
				if ($item == 'processor') {
					$total_cpu++;
					$cpu_info .= $total_cpu;
				}
				if ($item == 'vendor_id') {
					$cpu_info .= $data;
				}
				if ($item == 'model name') {
					$cpu_info .= $data;
				}
				if ($item == 'cpu MHz') {
					$cpu_info .= ' ' . floor ($data);
					$found_cpu = 'yes';
				}
				if ($item == 'cache size') {
					$cache = $data;
				}
				if ($item == 'bogomips') {
					$bogomips = $data;
				}
			}
		}
		if ( (!isset ($found_cpu) ) OR ($found_cpu != 'yes') ) {
			$cpu_info .= ' <span class="normaltextbold">' . _DIAG_OPNINT_SYSINFO_UNKNOWN . '</span>';
		}
		$cpu_info .= ' MHz' . _OPN_HTML_NL;
		if (file_exists ('/proc/meminfo') ) {
			$meminfo = file ('/proc/meminfo');
		}
		if ( (isset ($meminfo) ) && ($meminfo != '') ) {
			$max = count ($meminfo);
			for ($i = 0; $i< $max; $i++) {
				list ($item, $data) = split (':', $meminfo[$i], 2);
				$item = chop ($item);
				$data = chop ($data);
				if ($item == 'MemTotal') {
					$total_mem = $data;
				}
				if ($item == 'MemFree') {
					$free_mem = $data;
				}
				if ($item == 'SwapTotal') {
					$total_swap = $data;
				}
				if ($item == 'SwapFree') {
					$free_swap = $data;
				}
				if ($item == 'Buffers') {
					$buffer_mem = $data;
				}
				if ($item == 'Cached') {
					$cache_mem = $data;
				}
			}
			$used_mem = ($total_mem- $free_mem);
			$used_swap = ($total_swap- $free_swap);
			$percent_free = round ($free_mem/ $total_mem*100);
			$percent_used = round ($used_mem/ $total_mem*100);
			if ($total_swap != 0) {
				$percent_swap = round ( ($total_swap- $free_swap)/ $total_swap*100);
				$percent_swap_free = round ($free_swap/ $total_swap*100);
			} else {
				$percent_swap = 'N/A ';
				$percent_swap_free = 'N/A ';
			}
			$percent_buff = round ($buffer_mem/ $total_mem*100);
			$percent_cach = round ($cache_mem/ $total_mem*100);
		}
		$x = '';
		exec ('df -h', $x);
		$count = 1;
		$mount = array ();
		$avail = array ();
		$used = array ();
		while ($count<sizeof ($x) ) {
			list (, $size[$count], $used[$count], $avail[$count], $percent[$count], $mount[$count]) = split (' +', $x[$count]);
			$percent_part[$count] = str_replace ('%', '', $percent[$count]);
			$count++;
		}
		$idle = array ();
		$login = array ();
		$jcpu = array ();
		$pcpu = array ();
		$login = array ();
		$tty = array ();
		$from = array ();
		$siuser = array ();
		$who = '';
		exec ('w', $who);
		$countwho = 1;

		#	$up_header = array_shift ($who);

		while ($countwho<sizeof ($who) ) {
			list ($siuser[$countwho], $tty[$countwho], $from[$countwho], $login[$countwho], $idle[$countwho], $jcpu[$countwho], $pcpu[$countwho], $what[$countwho]) = split (' +', $who[$countwho]);
			$countwho++;
		}
		$list = 'netstat -t|grep ESTABLISHED';
		$svc = 1;
		$svctot = count ($service);
		while ($svc<= $svctot) {
			$daemon[$svc] = substr_count ($list, $service[$svc]);
			$svc++;
		}

		/*
		* Title
		*/

		$title_result = '<br /><div class="centertag"><span class="bigtextbold">' . $host . ' (' . $ip . ')</span></div>';

		/*
		* General info
		*/
		if (!isset ($cache) ) {
			$cache = "";
		}
		if (!isset ($bogomips) ) {
			$bogomips = "";
		}
		$table = & new opn_TableClass ('listalternator');
		$table->AddOpenHeadRow ();
		$table->AddHeaderCol ($msg_general_info, '', '2');
		$table->AddCloseRow ();
		$table->AddDataRow (array ($msg_system_time, $time) );
		$table->AddDataRow (array ($msg_kernel, $system . ' ' . $kernel) );
		$table->AddDataRow (array ($msg_cpu, $cpu_info) );
		$table->AddDataRow (array ($msg_cpu_cache, $cache) );
		$table->AddDataRow (array ($msg_cpu_bogomips, $bogomips) );
		$table->AddDataRow (array ($msg_uptime, $uptime) );
		$general_info_result = '';
		$table->GetTable ($general_info_result);

		/*
		* Connections
		*/

		$connections_result = '<br />';
		$table = & new opn_TableClass ('listalternator');
		$table->AddCols (array ('10%', '90%') );
		$table->AddOpenHeadRow ();
		$table->AddHeaderCol ($msg_connections, '', '2');
		$table->AddCloseRow ();
		// new variable 'svcname' is set in 'config.php'
		$svc = 1;
		$svctot = count ($service);
		while ($svc<= $svctot) {
			$table->AddDataRow (array ($svcname[$svc], $daemon[$svc]) );
			$svc++;
		}
		$table->GetTable ( ($connections_result) );

		/*
		* 'Who's logged in' : detail
		*/

		$who_result = '<br />';
		$table = & new opn_TableClass ('alternator');
		$table->AddHeaderRow (array ($msg_who_is_connected) );
		$table1 = & new opn_TableClass ('alternator');
		$table1->AddHeaderRow (array ($msg_conn_user, $msg_conn_tty, $msg_conn_from, $msg_conn_login, $msg_conn_idle, $msg_conn_jcpu, $msg_conn_pcpu, $msg_conn_what) );
		$countwho = 1;
		while ($countwho<sizeof ($who) ) {
			$table1->AddDataRow (array ($siuser[$countwho], $tty[$countwho], $from[$countwho], $login[$countwho], $idle[$countwho], $jcpu[$countwho], $pcpu[$countwho], $what[$countwho]) );
			$countwho++;
		}
		$help = '';
		$table1->GetTable ($help);
		$table->AddDataRow (array ($help) );
		$table->GetTable ($who_result);
		if (!isset ($total_mem) ) {
			$total_mem = '';
		}
		if (!isset ($used_mem) ) {
			$used_mem = '';
		}
		if (!isset ($percent_used) ) {
			$percent_used = '';
		}
		if (!isset ($free_mem) ) {
			$free_mem = '';
		}
		if (!isset ($percent_free) ) {
			$percent_free = '';
		}
		if (!isset ($buffer_mem) ) {
			$buffer_mem = '';
		}
		if (!isset ($percent_buff) ) {
			$percent_buff = '';
		}
		if (!isset ($cache_mem) ) {
			$cache_mem = '';
		}
		if (!isset ($percent_cach) ) {
			$percent_cach = '';
		}
		if (!isset ($total_swap) ) {
			$total_swap = '';
		}
		if (!isset ($used_swap) ) {
			$used_swap = '';
		}
		if (!isset ($percent_swap) ) {
			$percent_swap = '';
		}
		if (!isset ($free_swap) ) {
			$free_swap = '';
		}
		if (!isset ($percent_swap_free) ) {
			$percent_swap_free = '';
		}

		/*
		* Memory
		*/

		$memory_result = '<br />';
		$table = & new opn_TableClass ('alternator');
		$table->AddOpenHeadRow ();
		$table->AddHeaderCol ($msg_memory . ' : ' . $total_mem, '', '4');
		$table->AddCloseRow ();
		$table->AddHeaderRow (array ('&nbsp;', $msg_total, $msg_usage, $msg_percent) );
		$table->AddDataRow (array ($msg_used, $used_mem, '<img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img4.png" height="13" width="' . $percent_used . '" alt="" /><img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img11.png" height="13" width="' . (100- $percent_used) . '." alt="" />', $percent_used . ' ' . $msg_percent) );
		$table->AddDataRow (array ($msg_free, $free_mem, '<img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img1.png" height="13" width="' . $percent_free . '" alt="" /><img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img11.png" height="13" width="' . (100- $percent_free) . '." alt="" />', $percent_free . ' ' . $msg_percent) );
		$table->AddDataRow (array ($msg_buffered, $buffer_mem, '<img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img2.png" height="13" width="' . $percent_buff . '" alt="" /><img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img11.png" height="13" width="' . (100- $percent_buff) . '." alt="" />', $percent_buff . ' ' . $msg_percent) );
		$table->AddDataRow (array ($msg_cached, $cache_mem, '<img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img5.png" height="13" width="' . $percent_cach . '" alt="" /><img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img11.png" height="13" width="' . (100- $percent_cach) . '." alt="" />', $percent_cach . ' ' . $msg_percent) );
		$table->GetTable ($memory_result);

		/*
		* Mounts
		*/

		$mounts_result = '<br />';
		$table = & new opn_TableClass ('alternator');
		$table->AddOpenHeadRow ();
		$table->AddHeaderCol ($msg_mounts, '', '6');
		$table->AddCloseRow ();
		$table->AddHeaderRow (array ($msg_mount, $msg_size, $msg_free, $msg_used, $msg_usage, $msg_percent) );
		$count = 1;
		while ($count<sizeof ($x) ) {
			$table->AddDataRow (array ($mount[$count], $size[$count], $avail[$count], $used[$count], '<img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img' . $count . '.png" height="13" width="' . $percent_part[$count] . '" alt="" /><img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img11.png" height="13" width="' . (100- $percent_part[$count]) . '" alt="" />', $percent[$count]) );
			$count++;
		}
		$table->GetTable ($mounts_result);

		/*
		* Swap
		*/

		$swap_result = '<br />';
		$table = & new opn_TableClass ('alternator');
		$table->AddOpenHeadRow ();
		$table->AddHeaderCol ($msg_swap . ' : ' . $total_swap, '', '4');
		$table->AddHeaderRow (array ('&nbsp;', $msg_total, $msg_usage, $msg_percent) );
		$table->AddDataRow (array ($msg_used, $used_swap, '<img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img4.png" height="13" width="' . $percent_swap . '" alt="" /><img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img11.png" height="13" width="' . (100- $percent_swap) . '" alt="" />', $percent_swap . ' ' . $msg_percent) );
		$table->AddDataRow (array ($msg_free, $free_swap, '<img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img1.png" height="13" width="' . $percent_swap_free . '" alt="" /><img src="' . $opnConfig['opn_url'] . '/admin/diagnostic/images/img11.png" height="13" width="' . (100- $percent_swap_free) . '" alt="" />', $percent_swap_free . ' ' . $msg_percent) );
		$table->GetTable ($swap_result);
		$servermore = '<br />';
		$phpversion = phpversion ();
		$phpmemorylimit = @ini_get ("memory_limit");
		if ($opnConfig['dbdriver'] == 'mysql') {
			$mysqlserverversion = mysql_get_server_info ();
			$mysqlclientversion = mysql_get_client_info ();
		} else {
			$mysqlserverversion = '?';
			$mysqlclientversion = '?';
		}
		$webserverinterface = strtoupper (@php_sapi_name () );
		$table = & new opn_TableClass ('alternator');
		$table->InitTable ();
		$table->AddHeaderRow (array (_DIAG_RESOOURCEDETAILS, ' ') );
		$table->AddDataRow (array (_DIAG_PHP_VERSION, $phpversion) );
		$table->AddDataRow (array (_DIAG_PHP_MEMORY_LIMIT, $phpmemorylimit) );
		$table->AddDataRow (array (_DIAG_MYSQL_SERVER_VERSION, $mysqlserverversion) );
		$table->AddDataRow (array (_DIAG_MYSQL_CLIENT_VERSION, $mysqlclientversion) );
		$table->AddDataRow (array (_DIAG_WEBSERVER_INTERFACE, $webserverinterface) );
		$table->GetTable ($servermore);

		/*
		* Dump the whole stuff
		*/

		$page_result = $title_result . $general_info_result . $connections_result . $who_result . $memory_result . $swap_result . $mounts_result . $servermore;
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_DIAGNOSTIC_580_';
	$_display_dat['module'] = 'admin/diagnostic';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_DIAG_OPNINT_SYSINFO, $page_result);

}

?>