<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_HONEYPOT_INCLUDE') ) {
	define ('_OPN_HONEYPOT_INCLUDE', 1);

	class opn_honey_pot {
		var $_ip = '';
		var $_date = '';
		var $_ip1 = '';
		var $_hostname = '';

		/**
		* opn_honey_pot::GetHoneyPot()
		*
		* @return
		*/

		function GetHoneyPot () {

			global $opnConfig;
			if ( ($opnConfig['usehoneypot']) && ($opnConfig['honeypotdomain'] != '') ) {
				if ($this->_ip1 == '') {
					$this->_ip1 = get_real_ip ();
					$this->_hostname = gethostbyaddr ($this->_ip1);
				}
				$this->_ip = $this->_ip1;
				$this->_date = (string)time ();
				mt_srand ((double)microtime ()*1000000);
				$modus1 = '';
				$this->_endcodeip ($modus1);
				$modus2 = '';
				$this->_encodedate ($modus2);
				$hostname = '';
				$this->_gethotsname ($hostname);
				$parts[0] = $opnConfig['honeypotprefix'];
				$parts[1] = $modus2 . $this->_date;
				$parts[2] = $modus1 . $this->_ip;
				$index = array ();
				for ($i = 0; $i<3; $i++) {
					$test = mt_rand (0, 2);
					while (in_array ($test, $index) ) {
						$test = mt_rand (0, 2);
					}
					// while
					$index[$i] = $test;
					$part[$i] = $parts[$test];
				}
				unset ($index);
				unset ($parts);
				return '<a href="mailto:' . $part[0] . $part[1] . $part[2] . '@' . $hostname . '"></a>';
			}
			return '';

		}

		/**
		* opn_honey_pot::DecodeEmail()
		*
		* @param  $email
		* @return
		*/

		function DecodeEmail ($email) {

			global $opnConfig;

			$a = explode ('@', $email);
			$b = str_replace ($opnConfig['honeypotprefix'], '', $a[0]);
			$b = strtoupper ($b);
			$ippos = false;
			$a = array (0 => 'HOA',
				1 => 'ROA',
				2 => 'AOA');
			foreach ($a as $test) {
				if ($ippos === false) {
					$ippos = strpos ($b, $test);
				}
			}
			$datepos = false;
			$a = array (0 => 'HOD',
				1 => 'ROD',
				2 => 'AOD');
			foreach ($a as $test) {
				if ($datepos === false) {
					$datepos = strpos ($b, $test);
				}
			}
			$ipmode = substr ($b, $ippos, 1);
			$datemode = substr ($b, $datepos, 1);
			if ($datepos>$ippos) {
				$this->_ip = substr ($b, $ippos+3, $datepos- $ippos-3);
				$this->_date = substr ($b, $datepos+3);
			} elseif ( ($ippos !== FALSE) && ($datepos !== FALSE) ) {
				$this->_date = substr ($b, $datepos+3, $ippos- $datepos-3);
				$this->_ip = substr ($b, $ippos+3);
			} else {
				return FALSE;
			}
			$this->_decodedate ($datemode);
			$this->_decodeip ($ipmode);
			return TRUE;

		}

		/**
		* opn_honey_pot::GetDate()
		*
		* @return
		*/

		function GetDate () {
			return $this->_date;

		}

		/**
		* opn_honey_pot::GetIP()
		*
		* @return
		*/

		function GetIP () {
			return $this->_ip;

		}

		/**
		* opn_honey_pot::_datealpha()
		*
		* @return
		*/

		function _datealpha () {
			$max = strlen ($this->_date);
			for ($i = 0; $i< $max; $i++) {
				$this->_date[$i] = chr ($this->_date[$i]+65);
			}

		}

		/**
		* opn_honey_pot::_alphadate()
		*
		* @return
		*/

		function _alphadate () {
			$max = strlen ($this->_date);
			for ($i = 0; $i< $max; $i++) {
				$this->_date[$i] = ord ($this->_date[$i])-65;
			}

		}

		/**
		* opn_honey_pot::_ipalpha()
		*
		* @return
		*/

		function _ipalpha () {
			$max = strlen ($this->_ip);
			for ($i = 0; $i< $max; $i++) {
				if ($this->_ip[$i] != '.') {
					$this->_ip[$i] = chr ($this->_ip[$i]+65);
				}
			}

		}

		/**
		* opn_honey_pot::_alphaip()
		*
		* @return
		*/

		function _alphaip () {
			$max = strlen ($this->_ip);
			for ($i = 0; $i< $max; $i++) {
				if ($this->_ip[$i] != '.') {
					$this->_ip[$i] = ord ($this->_ip[$i])-65;
				}
			}

		}

		/**
		* opn_honey_pot::_endcodeip()
		*
		* @param  $modus1
		* @return
		*/

		function _endcodeip (&$modus1) {

			$modus = mt_rand (1, 3);
			switch ($modus) {
				case 1:
					// Hexconvert
					$parts = explode ('.', $this->_ip);
					$str = '';
					for ($i = 0; $i<4; $i++) {
						$str .= substr ('0' . dechex ($parts[$i]), -2);
					}
					unset ($parts);
					$this->_ip = $str;
					$modus1 = 'HOA';
					break;
				case 2:
					// ROT 13
					$this->_ipalpha ();
					$this->_ip = str_rot13 ($this->_ip);
					$modus1 = 'ROA';
					break;
				default:
					// Alphaconvert
					$this->_ipalpha ();
					$modus1 = 'AOA';
					break;
			}
			// switch

		}

		/**
		* opn_honey_pot::_decodeip()
		*
		* @param $ipmode
		* @return
		**/

		function _decodeip ($ipmode) {
			switch ($ipmode) {
				case 'H':
					$parts = explode ('.', wordwrap ($this->_ip, 2, '.', 1) );
					for ($i = 0; $i<4; $i++) {
						$parts[$i] = hexdec ($parts[$i]);
					}
					$this->_ip = implode ('.', $parts);
					unset ($parts);
					break;
				case 'R':
					$this->_ip = str_rot13 ($this->_ip);
					$this->_alphaip ();
					break;
				default:
					$this->_alphaip ();
					break;
			}
			// switch

		}

		/**
		* opn_honey_pot::_encodedate()
		*
		* @param  $modus2
		* @return
		*/

		function _encodedate (&$modus2) {

			$modus = mt_rand (1, 3);
			switch ($modus) {
				case 1:
					// Hexconvert
					$this->_date = dechex ($this->_date);
					$modus2 = 'HOD';
					break;
				case 2:
					// ROT 13
					$this->_datealpha ();
					$this->_date = str_rot13 ($this->_date);
					$modus2 = 'ROD';
					break;
				default:
					// Alphaconvert
					$this->_datealpha ();
					$modus2 = 'AOD';
					break;
			}
			// switch

		}

		/**
		* opn_honey_pot::_decodedate()
		*
		* @param  $atemode
		* @return
		*/

		function _decodedate ($datemode) {
			switch ($datemode) {
				case 'H':
					$this->_date = hexdec ($this->_date);
					break;
				case 'R':
					$this->_date = str_rot13 ($this->_date);
					$this->_alphadate ();
					break;
				default:
					$this->_alphadate ();
					break;
			}
			// switch
			$this->_date = strftime (_DATE_DATESTRING5, $this->_date);

		}

		/**
		* opn_honey_pot::_gethotsname()
		*
		* @param  $hostname
		* @return
		*/

		function _gethotsname (&$hostname) {

			global $opnConfig;

			$hostname = $opnConfig['honeypotdomain'];
			if ($opnConfig['poisonhoneypot']) {
				$test = mt_rand (1, 2);
				if ($test == 2) {
					$hostname = $opnConfig['honeypotdomain'];
				} else {
					$hostname = $this->_hostname;
				}
			}

		}

	}
}

?>