<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;

getLanguageDef (_OPN_ROOT_PATH . 'admin/honeypot/language/');
include_once (_OPN_ROOT_PATH . 'include/opn_admin_functions.php');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.adminmenu.php');
$opnConfig['permission']->HasRight ('admin/honeypot', _PERM_ADMIN);
$opnConfig['module']->InitModule ('admin/honeypot', true);
$pubsettings = $opnConfig['module']->GetPublicSettings ();
$opnConfig['opnOutput']->SetDisplayToAdminDisplay ();
getLanguageDef (_OPN_ROOT_PATH . 'admin/honeypot/language/');

function honeypot_allhiddens ($wichSave) {

	$values[] = array ('type' => _INPUT_BLANKLINE,
			'noautotable' => 1);
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => urlencode ($wichSave) );
	$nav[_HONEYPOT_SAVE_CHANGES] = _HONEYPOT_SAVE_CHANGES;
	$nav[_HONEYPOT_ADMIN] = _HONEYPOT_ADMIN;
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav);
	return $values;

}

function honeypotsettings () {

	global $opnConfig, $pubsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _HONEYPOT_GENERAL);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _HONEYPOT_ACTIVE,
			'name' => 'usehoneypot',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['usehoneypot'] == 1?true : false),
			 ($pubsettings['usehoneypot'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _HONEYPOT_POISION,
			'name' => 'poisonhoneypot',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['poisonhoneypot'] == 1?true : false),
			 ($pubsettings['poisonhoneypot'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _HONEYPOT_PREFIX,
			'name' => 'honeypotprefix',
			'value' => $pubsettings['honeypotprefix'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _HONEYPOT_DOMAIN,
			'name' => 'honeypotdomain',
			'value' => $pubsettings['honeypotdomain'],
			'size' => 50,
			'maxlength' => 100);
	$values = array_merge ($values, honeypot_allhiddens (_HONEYPOT_NAVGENERAL) );
	$set->GetTheForm (_HONEYPOT_SETTINGS, $opnConfig['opn_url'] . '/admin/honeypot/settings.php', $values);

}

function honeypot_dosavesettings () {

	global $opnConfig, $pubsettings;

	$opnConfig['module']->SetPublicSettings ($pubsettings);
	$opnConfig['module']->SavePublicSettings ();

}

function honeypot_dosaveuser ($vars) {

	global $pubsettings;
	if ($vars['honeypotdomain'] != '') {
		$pubsettings['usehoneypot'] = $vars['usehoneypot'];
	} else {
		$pubsettings['usehoneypot'] = 0;
	}
	$pubsettings['poisonhoneypot'] = $vars['poisonhoneypot'];
	$pubsettings['honeypotprefix'] = $vars['honeypotprefix'];
	$pubsettings['honeypotdomain'] = $vars['honeypotdomain'];
	honeypot_dosavesettings ();

}

function honeypot_dosave ($returns) {

	$op = urldecode ($returns['save']);
	switch ($op) {
		case _HONEYPOT_NAVGENERAL:
			honeypot_dosaveuser ($returns);
			break;
	}

}
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		honeypot_dosave ($result);
	} else {
		$result = '';
	}
}
$op = '';
get_var ('op', $op, 'form', _OOBJ_DTYPE_CLEAN);
$op = urldecode ($op);
switch ($op) {
	case _HONEYPOT_SAVE_CHANGES:
		$opnConfig['opnOutput']->Redirect ('/admin/honeypot/settings.php');
		CloseTheOpnDB ($opnConfig);
		break;
	case _HONEYPOT_ADMIN:
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/admin.php?fct=honeypot', false) );
		CloseTheOpnDB ($opnConfig);
		break;
	default:
		honeypotsettings ();
		break;
}

?>