<?php
/**
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;

$opnConfig['permission']->HasRight ('admin/modultheme', _PERM_ADMIN);
$opnConfig['module']->InitModule ('admin/modultheme', true);
include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');

function modultheme_Header () {

	global $opnConfig;

	$opnConfig['opnOutput']->EnableJavaScript ();
	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_MTH_CONFIG);
	$menu->InsertEntry (_MTH_MAIN, array ($opnConfig['opn_url'] . '/admin.php',
						'fct' => 'modultheme') );
	$menu->InsertEntry (_MTH_NEWTPL, array ($opnConfig['opn_url'] . '/admin.php',
						'fct' => 'modultheme',
						'op' => 'MakeNewTPL') );
	$menu->InsertEntry (_MTH_OVERVIEW, array ($opnConfig['opn_url'] . '/admin.php',
						'fct' => 'modultheme',
						'op' => 'overview') );
	$menu->InsertEntry (_MTH_OVERVIEW_NAV, array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'modultheme',
							'op' => 'onav') );
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function nav_box_overview () {

	global $opnConfig;

	$onav = '';
	get_var ('onav', $onav, 'both', _OOBJ_DTYPE_CLEAN);
	$hlp = array ();

	$options = array ();
	$groups = $opnConfig['permission']->UserGroups;
	foreach ($groups as $group) {
		$options[$group['id']] = $group['name'];
	}

	$options_theme = array ();
	$groups = $opnConfig['theme_groups'];
	foreach ($groups as $group) {
		$options_theme[$group['theme_group_id']] = $group['theme_group_text'];
	}

	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'themenav');
	$opnConfig['opnOption']['form'] = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOption']['form']->Init ($opnConfig['opn_url'] . '/admin.php', 'post');
	$opnConfig['opnOption']['form']->AddTable ();
	$opnConfig['opnOption']['form']->AddCols (array ('30%', '70%') );
	foreach ($plug as $var) {
		$tv = '';
		$tvl = '';
		include_once (_OPN_ROOT_PATH . $var['plugin'] . '/plugin/repair/features.php');
		include_once (_OPN_ROOT_PATH . $var['plugin'] . '/opn_item.php');
		$myfunc = $var['module'] . '_repair_nav_plugin';
		if (function_exists ($myfunc) ) {
			$hlp = $myfunc ();
			if ($hlp != '') {
				$tv = $hlp;
			}
		}
		$myfunc = $var['module'] . '_get_admin_config';
		if (function_exists ($myfunc) ) {
			$hlp = '';
			$myfunc ($hlp);
			if (is_array ($hlp) ) {
				$tvl = $hlp['description'];
			}
		}
		if ($tv != '') {
			if ($onav == '1') {
				$mthtv = 0;
				get_var ('MTH_' . $tv, $mthtv, 'both', _OOBJ_DTYPE_INT);
				$mthtv_right = 0;
				get_var ('MTH_RIGHT_' . $tv, $mthtv_right, 'both', _OOBJ_DTYPE_INT);
				$mthtv_theme = 0;
				get_var ('MTH_THEME_' . $tv, $mthtv_theme, 'both', _OOBJ_DTYPE_INT);
				$opnConfig['module']->SetModuleName ($var['plugin']);
				$opnConfig['module']->LoadPublicSettings ();
				$settings = $opnConfig['module']->GetPublicSettings ();
				$settings[$tv] = $mthtv;
				$settings[$var['plugin'].'_THEMENAV_PR'] = $mthtv_right;
				$settings[$var['plugin'].'_THEMENAV_TH'] = $mthtv_theme;
				$opnConfig['module']->SetPublicSettings ($settings);
				$opnConfig['module']->SavePublicSettings ();
				$opnConfig[$tv] = $mthtv;
				$opnConfig[$var['plugin'].'_THEMENAV_PR'] = $mthtv_right;
				$opnConfig[$var['plugin'].'_THEMENAV_TH'] = $mthtv_theme;
			}
			if (!isset ($opnConfig[$tv]) ) {
				echo $var['plugin'];
			}
			if (!isset ($opnConfig[$var['plugin'].'_THEMENAV_PR']) ) {
				$opnConfig[$var['plugin'].'_THEMENAV_PR'] = 0;
			}
			if (!isset ($opnConfig[$var['plugin'].'_THEMENAV_TH']) ) {
				$opnConfig[$var['plugin'].'_THEMENAV_TH'] = 0;
			}
			$opnConfig['opnOption']['form']->AddOpenRow ();
			$opnConfig['opnOption']['form']->AddLabel ('MTH_' . $tv, $tvl);
			$opnConfig['opnOption']['form']->SetSameCol ();
			$opnConfig['opnOption']['form']->AddCheckbox ('MTH_' . $tv, 1, $opnConfig[$tv]);
			$opnConfig['opnOption']['form']->AddSelect ('MTH_RIGHT_' . $tv, $options, $opnConfig[$var['plugin'].'_THEMENAV_PR']);
			$opnConfig['opnOption']['form']->AddLabel ('MTH_RIGHT_' . $tv, _MTH_USERGROUP);
			$opnConfig['opnOption']['form']->AddLabel ('MTH_THEME_' . $tv, _MTH_CATEGORY);
			$opnConfig['opnOption']['form']->AddSelect ('MTH_THEME_' . $tv, $options_theme, $opnConfig[$var['plugin'].'_THEMENAV_TH']);
			$opnConfig['opnOption']['form']->SetEndCol ();
			$opnConfig['opnOption']['form']->AddCloseRow ();
		}
	}
	$opnConfig['opnOption']['form']->AddOpenRow ();
	$opnConfig['opnOption']['form']->SetSameCol ();
	$opnConfig['opnOption']['form']->AddHidden ('op', 'onav');
	$opnConfig['opnOption']['form']->AddHidden ('onav', '1');
	$opnConfig['opnOption']['form']->AddHidden ('fct', 'modultheme');
	$opnConfig['opnOption']['form']->SetEndCol ();
	$opnConfig['opnOption']['form']->AddSubmit ('submity', _MTH_SAVE);
	$opnConfig['opnOption']['form']->AddCloseRow ();
	$opnConfig['opnOption']['form']->AddTableClose ();
	$opnConfig['opnOption']['form']->AddFormEnd ();
	$boxtxt = '';
	$opnConfig['opnOption']['form']->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_MODULTHEME_30_';
	$_display_dat['module'] = 'admin/modultheme';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ('', $boxtxt);

}

function modultheme_EditTPL () {

	global $opnTables, $opnConfig;

	$module = '';
	get_var ('module', $module, 'both', _OOBJ_DTYPE_CLEAN);
	$module = urldecode ($module);
	$_module = $opnConfig['opnSQL']->qstr ($module);
	$boxtxt = '';
	$query = 'SELECT id, sideright, sideleft, sidecenter, themegroup, tplurl FROM ' . $opnTables['opn_modultheme'] . " WHERE id=$_module";
	$result = &$opnConfig['database']->Execute ($query);
	if ( (is_object ($result) ) && (!$result->EOF) ) {
		$row = $result->GetRowAssoc ('0');
		$themegroup = $row['themegroup'];
		$result->Close ();
	} else {

		#$tplurl = '';

		$themegroup = '';
	}
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_ADMIN_MODULTHEME_40_', 'modultheme');
	$form->Init ($opnConfig['opn_url'] . '/admin.php', 'post', 'coolsus');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$options = array ();
	$groups = $opnConfig['theme_groups'];
	foreach ($groups as $group) {
		$options[$group['theme_group_id']] = $group['theme_group_text'];
	}
	$form->AddLabel ('themegroup', _MTH_CATEGORY);
	$form->AddSelect ('themegroup', $options, $themegroup);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('op', 'SaveTPL');
	$form->AddHidden ('fct', 'modultheme');
	$form->AddHidden ('module', urlencode ($module) );
	$form->AddSubmit ('submit', _MTH_SAVE);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_MODULTHEME_50_';
	$_display_dat['module'] = 'admin/modultheme';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ('', $boxtxt);

}

?>