<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_CLASS_OPN_AUTH_CRAMMD5_INCLUDED') ) {
	define ('_OPN_CLASS_OPN_AUTH_CRAMMD5_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'auth/class.opn_auth_common');

	class opn_auth_crammd5 extends opn_auth_common {

		/**
		* FUNCTION: getResponse
		* Implements the CRAM-MD5 SASL mechanism
		* This DOES NOT base64 encode the return value,
		* you will need to do that yourself.
		*
		* @param string $user	  Username
		* @param string $pass	  Password
		* @param string $challenge The challenge supplied by the server. this
		* should be already base64_decoded.
		* @return string
		*/

		function getResponse ($user, $pass, $challenge) {
			return $user . ' ' . $this->_hmac_md5 ($pass, $challenge);

		}
		// end function

	}
	// end class
}

?>