<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_HTML_DESTROY_INCLUDED') ) {
	define ('_OPN_CLASS_HTML_DESTROY_INCLUDED', 1);

	class html_destroy {

		/*<{php4}>
		var $htmlstring='';
		var $meta='';
		<{php4/}>*/

		/*<{php5}>
		public $htmlstring='';
		public $meta='';
		<{php5/}>*/

		/*<{delete}>*/
		var $htmlstring='';
		var $meta='';
		/*<{delete/}>*/

		/**
		* Constructor of class html_destroy
		*
		* @param string	$html_string
		* @return void
		*/

		function html_destroy ($html_string = '') {

			$this->htmlstring = $html_string;

		}

		/**
		* Returns the title
		*
		* @return string	title
		*/

		function get_title () {

			$this->htmlstring = strtolower ($this->htmlstring);
			$matches = '';
			preg_match_all ("|<title>(.*)</title>|U", $this->htmlstring, $matches, PREG_PATTERN_ORDER);
			return $matches[1][0];

		}

		/**
		* Returns the content of the body
		*
		* @return string
		*/

		function get_body () {

			$string = $this->htmlstring;
			$pattern = "|<body(.*)>|U";
			$matches = '';
			preg_match_all ($pattern, $string, $matches, PREG_PATTERN_ORDER);
			$string = str_replace ($matches[1][0], '', $string);
			$string = str_replace ("\n", '</br/>', $string);
			// Please Do not ask me why
			$pattern = "|<body>(.*)</body>|U";
			$matches = '';
			preg_match_all ($pattern, $string, $matches, PREG_SET_ORDER);
			$string = $matches;
			$str = '';
			$counted = count ($string);
			for ($i = 0; $i<$counted; $i++) {
				$str .= $string[$i][1];
			}
			$str = str_replace ('</br/>', "\n", $str);
			// Please Do not ask me why
			return $str;

		}

		/**
		* clean the content
		*
		* @param string	$body
		* @return void
		*/

		function clean_content (&$body) {

			$body = str_replace ('HREF=', 'href=', $body);
			$body = str_replace ('<body>', '', $body);
			$body = str_replace ('</body>', '', $body);
			$body = str_replace ('<BODY>', '', $body);
			$body = str_replace ('</BODY>', '', $body);
			$body = str_replace ('<html>', '', $body);
			$body = str_replace ('</html>', '', $body);
			$body = str_replace ('<HTML>', '', $body);
			$body = str_replace ('</HTML>', '', $body);
			$body = str_replace ('SRC=', 'src=', $body);
			$body = str_replace ('<BR>', '<br />', $body);
			$body = str_replace ('<br>', '<br />', $body);
			$body = str_replace ('<IMG', '<img', $body);
			$body = str_replace ('<A', '<a', $body);
			$body = str_replace ('</A>', '</a>', $body);

		}

		/**
		* longest common sub sequence
		*
		* @param string	$s1
		* @param string	$s2
		* @return unknown
		*/

		function LCS_Length ($s1, $s2) {

			$m = strlen ($s1);
			$n = strlen ($s2);
			// this table will be used to compute the LCS-Length, only 128 chars per string are considered
			$LCS_Length_Table = array (array (128),
							array (128) );
			// reset the 2 cols in the table
			for ($i = 1; $i< $m; $i++) {
				$LCS_Length_Table[$i][0] = 0;
			}
			for ($j = 0; $j< $n; $j++) {
				$LCS_Length_Table[0][$j] = 0;
			}
			for ($i = 1; $i<= $m; $i++) {
				for ($j = 1; $j<= $n; $j++) {
					if ($s1[$i-1] == $s2[$j-1]) {
						$LCS_Length_Table[$i][$j] = $LCS_Length_Table[$i-1][$j-1]+1;
					} elseif ($LCS_Length_Table[$i-1][$j] >= $LCS_Length_Table[$i][$j-1]) {
						$LCS_Length_Table[$i][$j] = $LCS_Length_Table[$i-1][$j];
					} else {
						$LCS_Length_Table[$i][$j] = $LCS_Length_Table[$i][$j-1];
					}
				}
			}
			return $LCS_Length_Table[$m][$n];

		}

		/**
		*
		* @param string	$s
		* @return string
		*/

		function str_lcsfix ($s) {

			$s = str_replace (" ", "", $s);
			$s = preg_replace ("/[]/", "e", $s);
			$s = preg_replace ("/[]/", "a", $s);
			$s = preg_replace ("/[]/", "i", $s);
			$s = preg_replace ("/[]/", "o", $s);
			$s = preg_replace ("/[]/", "u", $s);
			$s = preg_replace ("/[]/", "c", $s);
			return $s;

		}

		/**
		*
		* @param string	$s1
		* @param string	$s2
		* @return number
		*/

		function get_lcs ($s1, $s2) {
			// ok, now replace all spaces with nothing
			$s1 = strtolower ($this->str_lcsfix ($s1) );
			$s2 = strtolower ($this->str_lcsfix ($s2) );
			$lcs = $this->LCS_Length ($s1, $s2);
			// longest common sub sequence
			$ms = (strlen ($s1)+strlen ($s2) )/2;
			return ( ($lcs*100)/ $ms);

		}

		/**
		*
		* @param string	$tag
		* @param string	$txt
		* @param string	$starttag
		* @param string	$endtag
		* @return void
		*/

		function _isolate (&$tag, $txt, $starttag = '<a', $endtag = '/a>') {

			$j = -1;
			$starttagl = strlen ($starttag);
			$endtagl = strlen ($endtag);
			$mylen = strlen ($txt);
			for ($i = 0; $i<=$mylen; $i++) {
				if (substr ($txt, $i, $starttagl) == $starttag) {
					$j++;
					$st = $i;
					$k = $i;
					while (substr ($txt, $k, $endtagl) != $endtag) {
						$k++;
					}
					$en = $k+ $endtagl;
					$tag[$j] = substr ($txt, $st, $en- $st);
				}
			}

		}

		/**
		*
		* @param string	$_url
		* @param string	$_links
		* @param string	$_href
		* @param string	$_caption
		* @param string	$_txt
		* @return void
		*/

		function get_links ($_url, &$_links, &$_href, &$_caption, &$_txt) {

			$_links = array ();
			if ($_txt == '') {
				$_txt = file_get_contents ($_url);
			}
			$_txt = str_replace ('<A', '<a', $_txt);
			$_txt = str_replace ('</A>', '</a>', $_txt);
			$this->_isolate ($_links, $_txt);
			$p = 0;
			$counted = count ($_links);
			for ($i = 0; $i<$counted; $i++) {
				$mylen = strlen ($_links[$i]);
				for ($j = 0; $j<$mylen; $j++) {
					if (substr ($_links[$i], $j, 5) == 'href=') {
						$st = $j+5;
						$m = $j+5;
						while (substr ($_links[$i], $m, 1) != '>') {
							$m++;
						}
						$en = $m;
						$temp = substr ($_links[$i], $st, $en- $st);
						if (strpos ($temp, ' ')>0) {
							$temp = substr ($temp, 0, strpos ($temp, ' ') );
						}
						$temp = str_replace ('"', '', $temp);
						$temp = str_replace ("'", "", $temp);
						if (substr ($temp, 0, 1) == '/') {
							$temp = $_url . $temp;
						}
						if (substr ($temp, 0, 7) != 'http://') {
							$temp = $_url . '/' . $temp;
						}
						if (substr ($temp, 0, 7) == 'http://' && ( (!isset ($_href[$p]) ) || $temp != $_href[$p]) ) {
							$p++;
							$_href[$p] = $temp;
						}
						while (substr ($_links[$i], $m, 1) != '>') {
							$m++;
						}
						$st = $m+1;
						while (substr ($_links[$i], $m, 4) != '</a>') {
							$m++;
						}
						$en = $m;
						if (substr ($temp, 0, 7) == 'http://') {
							$_caption[$p] = substr ($_links[$i], $st, $en- $st);
						}
					}
				}
			}

		}

		/**
		*
		* @param string	$_url
		* @return void
		*/

		function GetLinks ($_url, &$links) {

			$depth = 3;
			$all_links = array ();
			$search_links = array ();
			$_links = '';
			$_href = '';
			$_caption = '';
			$_txt = '';
			$this->get_links ($_url, $_links, $_href, $_caption, $_txt);
			$max = count ($_href);
			for ($i = 1; $i<= $max; $i++) {
				$search_links[$_href[$i]] = $_href[$i];
				$all_links[$_href[$i]] = $_href[$i];
				// echo $i.'<->'.$_href[$i].'<br />';
			}
			while (count ($search_links) >= 1) {
				reset ($search_links);
				$testthis = current ($search_links);
				unset ($search_links[$testthis]);
				// echo $testthis.'<br />';
				if ( (substr_count ($testthis, $_url)>0) && ($depth>1) ) {
					$depth--;
					$new_links = array ();
					$new_href = array ();
					$new_caption = array ();
					$this->get_links ($testthis, $new_links, $new_href, $new_caption, $_txt);
					// echo '<br />inner: '.$testthis;
					$max = count ($new_href);
					for ($i = 1; $i<= $max; $i++) {
						if (!isset ($all_links[$new_href[$i]]) ) {
							$search_links[$new_href[$i]] = $new_href[$i];
							$all_links[$new_href[$i]] = $new_href[$i];
						}
					}
				}
			}
			reset ($all_links);
			$max = count ($all_links);
			for ($i = 1; $i<= $max; $i++) {
				// echo $i.'<->'.current($all_links).'<br />';
				$t = str_replace ('http://', '', current ($all_links) );
				$t = explode ('/', $t);
				$links[$t[0]] = $t[0];
				next ($all_links);
			}
			// $counted = count($_caption);
			// for ($i=1;$i<=$counted;$i++) {
			// echo $i.'<->'.$_caption[$i].'<br />';
			// }

		}

	}
}

?>