<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_INSTALLER_INCLUDED') ) {
	define ('_OPN_CLASS_INSTALLER_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.file.php');
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_vcs.php');
	include_once (_OPN_ROOT_PATH . 'include/opn_admin_functions.php');

	class OPN_AbstractPluginInDeinstaller {

		/*<{php4}>
		var $ItemToCheck = '';
		var $ItemDataSaveToCheck = '';
		var $ItemsDataSave =array();
		var $Tables = array();
		var $Items = array();
		var $Item_BIN = array();
		var $MetaSiteTags = false;
		var $ModuleName = '';
		var $Module = '';
		var $UserGroups = '';
		<{php4/}>*/

		/*<{php5}>
		public $ItemToCheck = '';
		public $ItemDataSaveToCheck = '';
		public $ItemsDataSave =array();
		public $Tables = array();
		public $Items = array();
		public $Item_BIN = array();
		public $MetaSiteTags = false;
		public $ModuleName = '';
		public $Module = '';
		public $UserGroups = '';
		<{php5/}>*/

		/*<{delete}>*/
		var $ItemToCheck = '';
		var $ItemDataSaveToCheck = '';
		var $ItemsDataSave =array();
		var $Tables = array();
		var $Items = array();
		var $Item_BIN = array();
		var $MetaSiteTags = false;
		var $ModuleName = '';
		var $Module = '';
		var $UserGroups = '';
		/*<{delete/}>*/

		/**
		* OPN_AbstractPluginInDeinstaller::IsItemThere()
		*
		* Is ItemToCheck not empty?
		*
		* @return true or false
		**/

		function IsItemThere () {
			if ( ($this->ItemToCheck != '') OR ($this->ItemToCheck == 'OPN_FIRST_INSTALL') ) {
				return true;
			}
			return false;

		}

		/**
		* OPN_AbstractPluginInDeinstaller::IsItemDataSaveThere()
		*
		* Is ItemDataSaveToCheck not empty?
		*
		* @return true or false
		**/

		function IsItemDataSaveThere () {
			if ( (isset ($this->ItemDataSaveToCheck) ) && ( ($this->ItemDataSaveToCheck != '') OR ($this->ItemDataSaveToCheck == 'OPN_FIRST_INSTALL') ) ) {
				return true;
			}
			return false;

		}

		/**
		* OPN_AbstractPluginInDeinstaller::ExecuteSQL()
		*
		* Execute a SQL Query.
		*
		* @param $sql	The query
		**/

		function ExecuteSQL ($sql) {

			global $opnConfig;

			$opnConfig['database']->Execute ($sql);
			if ($opnConfig['database']->_errorMsg <> '') {
				$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler;
				$eh->write_error_log ($opnConfig['database']->_errorMsg, 10, 'ExecuteSQL');
				unset ($eh);
			}

		}

		function SetItemsDataSave ($items) {

			$this->ItemsDataSave = $items;

		}

		function SetItemDataSaveToCheck ($item) {

			$this->ItemDataSaveToCheck = $item;

		}

		function BuildTableArray () {
			if ($this->ModuleName != '') {
				if (count ($this->Tables) == 0) {
					$file = _OPN_ROOT_PATH . $this->Module . '/plugin/sql/index.php';
					if (file_exists ($file) ) {
						include_once ($file);
						$this->Tables = array ();
						$myfuncSQLt = $this->ModuleName . '_repair_sql_table';
						$tables = $myfuncSQLt ();
						$this->Tables = array_keys ($tables['table']);
					}
				}
			}
		}

		function BuildItemArray () {
			if ( ($this->ItemToCheck == '') && (count ($this->Tables)>0) ) {
				$this->ItemToCheck = $this->ModuleName . ('1');
				$max = count ($this->Tables);
				for ($i = 0; $i< $max; $i++) {
					$this->Items[] = $this->ModuleName . ($i+1);
				}
			}

		}

		/**
		* OPN_AbstractPluginInDeinstaller::ExecuteSQL()
		*
		* Execute a SQL Query.
		*
		* @param $sql	The query
		**/

		function opnExecuteSQL ($sql, $onlyreturnsqls = false) {

			global $opnConfig;

			$i = 1;
			foreach ($sql as $k => $obj) {
				if ($k == 'table') {
					foreach ($obj as $tablename => $tablefields) {
						$sqlinfo[$i]['table'] = $tablename;
						$sqlinfo[$i]['action'] = 'Create';
						$sqls[$i] = 'CREATE TABLE ' . $opnConfig['tableprefix'] . $tablename . ' (';
						foreach ($tablefields as $fieldname => $fieldtype) {
							if (strpos ($fieldname, '__opn_key') ) {
								$sqls[$i] .= $fieldtype . ', ';
							} else {
								$sqls[$i] .= $fieldname . ' ' . $fieldtype . ', ';
							}
							// if
						}
						$temp = strrpos ($sqls[$i], ',');
						$sqls[$i][$temp] = ')';
						$i++;
					}
				}
				if ($k == 'index') {
					foreach ($obj as $tablename => $indices) {
						$j = 1;
						foreach ($indices as $value) {
							$sqlinfo[$i]['table'] = $tablename;
							$sqlinfo[$i]['action'] = 'Index';
							$sp = '';
							$qi = '';
							$qff = '(';
							$qzz = 0;
							$ar = explode (',', $value);
							$max = count ($ar);
							for ($x = 0; $x< $max; $x++) {
								if ($ar[$x] != 'UNIQUE') {
									$qi .= $ar[$x];
									if ($qzz != 0) {
										$qff .= ',';
									}
									$qff .= $ar[$x];
									$qzz++;
								} else {
									$sp = 'UNIQUE ';
								}
							}
							$qff .= ')';
							$sqls[$i] = $opnConfig['opnSQL']->CreateIndex ($sp, $tablename, $j, $opnConfig['tableprefix'] . $tablename, $qff);
							$i++;
							$j++;
						}
					}
				}
				if ($k == 'data') {
					foreach ($obj as $tablename => $tablevalues) {
						foreach ($tablevalues as $fieldvalue) {
							$sqlinfo[$i]['table'] = $tablename;
							$sqlinfo[$i]['action'] = 'Insert into';
							$sqls[$i] = 'INSERT INTO ' . $opnConfig['tableprefix'] . $tablename . ' VALUES (' . $fieldvalue . ', ';
							$temp = strrpos ($sqls[$i], ',');
							$sqls[$i][$temp] = ')';
							$i++;
						}
					}
				}
			}
			if (!$onlyreturnsqls) {
				$i = 1;
				if (is_array ($sqls) ) {
					foreach ($sqls as $k => $query) {
						$this->ExecuteSQL ($query);
						if ($opnConfig['database']->_errorMsg <> '') {
							$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler;
							$eh->write_error_log ($opnConfig['database']->_errorMsg, 10, 'opnExecuteSQL');
							unset ($eh);
						}
						// echo $query.'<br />';
						$i++;
					}
				}
				return false;
			}
			return $sqls;

		}

	}

	class OPN_PluginDeinstaller extends OPN_AbstractPluginInDeinstaller {

		/*<{php4}>
		var $RemoveSideboxes = false;
		var $RemoveMiddleboxes = false;
		var $RemoveOpnboxes = false;
		var $RemoveSettings = true;
		var $Remove_opn_exception_register = true;
		var $Remove_opn_class_register = true;
		var $RemoveRights = false;
		var $RemoveGroups = false;
		<{php4/}>*/

		/*<{php5}>
		public $RemoveSideboxes = false;
		public $RemoveMiddleboxes = false;
		public $RemoveOpnboxes = false;
		public $RemoveSettings = true;
		public $Remove_opn_exception_register = true;
		public $Remove_opn_class_register = true;
		public $RemoveRights = false;
		public $RemoveGroups = false;
		<{php5/}>*/

		/*<{delete}>*/
		var $RemoveSideboxes = false;
		var $RemoveMiddleboxes = false;
		var $RemoveOpnboxes = false;
		var $RemoveSettings = true;
		var $Remove_opn_exception_register = true;
		var $Remove_opn_class_register = true;
		var $RemoveRights = false;
		var $RemoveGroups = false;
		/*<{delete/}>*/

		function RemoveScriptFeature ($what, $filepath, $menutype = '') {

			global $opnConfig, $opnTables;

			$plug = array();
			$opnConfig['installedPlugins']->getplugin ($plug, $what);
			ksort ($plug);
			reset ($plug);
			if ($menutype == '') {
				$dat = 'plugin.' . $what;
			} else {
				$dat = 'plugin.' . $menutype;
			}
			$sid = -1;
			$definetestplug = '_DBCODE_' . str_replace ('.', '_', $dat);
			$content = '';
			foreach ($plug as $var1) {
				if ( (file_exists (_OPN_ROOT_PATH . $var1['plugin'] . $filepath) ) && ($this->Module != $var1['plugin']) ) {
					$file = fopen (_OPN_ROOT_PATH . $var1['plugin'] . $filepath, 'r');
					$src = fread ($file, filesize (_OPN_ROOT_PATH . $var1['plugin'] . $filepath) );
					fclose ($file);
					$definetest = $definetestplug . '_' . str_replace ('/', '_', $var1['plugin']);
					$content .= '<?php' . _OPN_HTML_NL;
					$content .= 'if (!defined (\'' . $definetest . '\')) {' . _OPN_HTML_NL;
					$content .= 'define (\'' . $definetest . '\',1);' . _OPN_HTML_NL;
					$content .= '?>';
					$content .= $src;
					$content .= '<?php' . _OPN_HTML_NL;
					$content .= '}' . _OPN_HTML_NL;
					$content .= '?>';
				} else {
					// wieso gibt es diese ?
					// if (!(file_exists(_OPN_ROOT_PATH.$var1['plugin'].$filepath)) ) {
					// echo _OPN_ROOT_PATH.$var1['plugin'].$filepath.'<br />';
					// }
				}
			}
			if ($content != '') {
				$result = &$opnConfig['database']->Execute ('SELECT sid FROM ' . $opnTables['opn_script'] . " WHERE dat='" . $dat . "'");
				if ( ($result !== false) && ($result->RecordCount () == 1) ) {
					$sid = $result->fields['sid'];
					$result->Close ();
				}
				$this->ExecuteSQL ('DELETE FROM ' . $opnTables['opn_script'] . " WHERE dat= '$dat'");
				if ($sid == -1) {
					$sid = $opnConfig['opnSQL']->get_new_number ('opn_script', 'sid');
				}
				$content = $opnConfig['opnSQL']->qstr ($content, 'src');
				$this->ExecuteSQL ('INSERT INTO ' . $opnTables['opn_script'] . " (sid, src, dat) VALUES ($sid, $content, '$dat')");
				$opnConfig['opnSQL']->UpdateBlobs ($opnTables['opn_script'], 'sid=' . $sid);
			}

		}

		/**
		* OPNDeinstaller::RemovePlugin()
		*
		* Performs the deinstallation of the plugin
		**/

		function DeinstallPlugin () {

			global $opnTables, $opnConfig;

			$this->BuildTableArray ();
			$this->BuildItemArray ();
			$opnConfig['opnSQL']->opn_dbcoreloader ('sql.opninit.php');
			$uid = $opnConfig['permission']->UserInfo ('uid');
			$opnConfig['webinclude'] =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ update_module ();
			if ($uid == 2) {
				$ok = 1;
			} else {
				if ($opnConfig['opn_multihome'] == 0) {
					$ok = 1;
				} else {
					if ($opnConfig['webinclude']->mhfix_check_module ($this->Module) == 1) {
						$ok = 1;
					} else {
						$ok = 0;
					}
				}
			}
			if ($ok == 1) {
				// Drop the tables and cleanup the catalog
				if ($this->IsItemThere () ) {
					$dbcat =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ catalog ($opnConfig, 'dbcat');
					if ($dbcat->catisitemincatalog ($this->ItemToCheck) ) {
						$max = count ($this->Tables);
						for ($i = 0; $i< $max; $i++) {
							$sqldrop = $opnConfig['opnSQL']->TableDrop ($opnTables[$this->Tables[$i]]);
							$this->ExecuteSQL ($sqldrop);
						}
						$max = count ($this->Items);
						for ($i = 0; $i< $max; $i++) {
							$dbcat->catremoveitem ($this->Items[$i]);
						}
						// for
						$dbcat->catsave ();
						dbconf_get_tables ($opnTables, $opnConfig);
					}
				}
				// Drop the DataSave and cleanup the catalog
				if ($this->IsItemDataSaveThere () ) {
					$dbcat =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ catalog ($opnConfig, 'opn_datasavecat');
					if ($dbcat->catisitemincatalog ($this->ItemDataSaveToCheck) ) {
						$max = count ($this->ItemsDataSave);
						for ($i = 0; $i< $max; $i++) {
							Check_Server ();
							$File =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opnFile;
							$File->delete_dir ($opnConfig['datasave'][$this->ItemsDataSave[$i]]['path']);
							if ($File->ERROR != '') {
								echo $File->ERROR . '<br />';
							}
						}
						$max = count ($this->ItemsDataSave);
						for ($i = 0; $i< $max; $i++) {
							$dbcat->catremoveitem ($this->ItemsDataSave[$i]);
						}
						// for
						$dbcat->catsave ();
						dbconf_get_DataSave ();
					}
				}

				// Remove the opn_exception_register tags
				if ($this->Remove_opn_exception_register) {
					$this->ExecuteSQL ('DELETE FROM ' . $opnTables['opn_exception_register'] . " WHERE module='" . $this->Module . "'");
				}

				// Remove the opn_class_register tags
				if ($this->Remove_opn_class_register) {
					$this->ExecuteSQL ('DELETE FROM ' . $opnTables['opn_class_register'] . " WHERE module='" . $this->Module . "'");
				}

				// Remove the metasitetags
				if ($this->MetaSiteTags) {
					$this->ExecuteSQL ('DELETE FROM ' . $opnTables['opn_meta_site_tags'] . " WHERE pagename='" . $this->Module . "'");
				}
				// Remove the sideboxes
				if ($this->RemoveSideboxes) {
					$this->ExecuteSQL ('DELETE FROM ' . $opnTables['opn_sidebox'] . " WHERE sbpath like '%" . $this->Module . "%'");
				}
				// Remove the sideboxes
				if ($this->RemoveMiddleboxes) {
					$this->ExecuteSQL ('DELETE FROM ' . $opnTables['opn_middlebox'] . " WHERE sbpath like '%" . $this->Module . "%'");
				}
				// Remove the opnboxes
				if ($this->RemoveOpnboxes) {
					$this->ExecuteSQL ('DELETE FROM ' . $opnTables['opn_opnbox'] . " WHERE sbpath like '%" . $this->Module . "%'");
				}
				// Delete the Settings
				if ($this->RemoveSettings) {
					$set =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ MySettings;
					$set->modulename = $this->Module;
					$set->DeleteTheSettings ();
				}
				// Remove the vcs info from the table
				$version =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ OPN_VersionsControllSystem ($this->Module);
				$version->DeleteVersion ();
				// Remove the rights
				if ($this->RemoveRights) {
					$this->ExecuteSQL ('DELETE FROM ' . $opnTables['user_group_rights'] . " WHERE perm_module='" . $this->Module . "'");
					$this->ExecuteSQL ('DELETE FROM ' . $opnTables['user_rights'] . " WHERE perm_module='" . $this->Module . "'");
				}
				// Remove usergroups
				if ($this->RemoveGroups) {
					$max = count ($this->UserGroups);
					for ($i = 0; $i< $max; $i++) {
						$result = &$opnConfig['database']->Execute ('SELECT user_group_id FROM ' . $opnTables['user_group'] . " WHERE user_group_orgtext = " . $opnConfig['opnSQL']->qstr ($this->UserGroups[$i]) );
						if ($result !== false) {
							while (! $result->EOF) {
								$uid = $result->fields['user_group_id'];
								$opnConfig['permission']->DeleteUserGroup ($uid);
								$result->MoveNext ();
							}
							$result->Close ();
							unset ($result);
						}
					}
				}
				if (count ($this->Item_BIN)>0) {
					$File =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opnFile;
					$max = count ($this->Item_BIN);
					for ($i = 0; $i< $max; $i++) {
						$File->delete_File (_OPN_ROOT_PATH . 'opn-bin/' . $this->Item_BIN[$i]);
					}
				}
				// Remove the script features for the plugin
				// this is not a good way; but ...
				$this->RemoveScriptFeature ('waitingcontent', '/plugin/sidebox/waiting/insert.php');
				$this->RemoveScriptFeature ('themenav', '/plugin/theme/index.php');
				$this->RemoveScriptFeature ('menu', '/plugin/menu/index.php', 'sitemap');
				$this->RemoveScriptFeature ('menu', '/plugin/menu/usermenu.php', 'usermenu');
				$this->RemoveScriptFeature ('menu', '/plugin/menu/adminmenu.php', 'adminmenu');
				// Remove the module from the plugintable
				$opnConfig['installedPlugins']->DeletePluginFromTable ($this->Module);
			}

		}

	}

	class OPN_PluginInstaller extends OPN_AbstractPluginInDeinstaller {

		/*<{php4}>
		var $opnCreateSQL_index = '';
		var $opnCreateSQL_data = '';
		var $opnCreateSQL_table = '';
		var $IsTheme = false;

		var $opn_exception_register = false;
		var $opn_class_register = false;

		var $Features = '';
		var $Sideboxes = '';
		var $Middleboxes = '';
		var $Opnboxes = '';
		var $PrivateSettings = '';
		var $PublicSettings = '';
		var $HaveRightforIndex = 0;
		var $Rights = '';
		var $RightsGroup = '';
		var $GroupRights = '';
		<{php4/}>*/

		/*<{php5}>
		public $opnCreateSQL_index = '';
		public $opnCreateSQL_data = '';
		public $opnCreateSQL_table = '';
		public $IsTheme = false;

		public $opn_exception_register = false;
		public $opn_class_register = false;

		public $Features = '';
		public $Sideboxes = '';
		public $Middleboxes = '';
		public $Opnboxes = '';
		public $PrivateSettings = '';
		public $PublicSettings = '';
		public $HaveRightforIndex = 0;
		public $Rights = '';
		public $RightsGroup = '';
		public $GroupRights = '';
		<{php5/}>*/

		/*<{delete}>*/
		var $opnCreateSQL_index = '';
		var $opnCreateSQL_data = '';
		var $opnCreateSQL_table = '';
		var $IsTheme = false;

		var $opn_exception_register = false;
		var $opn_class_register = false;

		var $Features = '';
		var $Sideboxes = '';
		var $Middleboxes = '';
		var $Opnboxes = '';
		var $PrivateSettings = '';
		var $PublicSettings = '';
		var $HaveRightforIndex = 0;
		var $Rights = '';
		var $RightsGroup = '';
		var $GroupRights = '';
		/*<{delete/}>*/

		/**
		* OPN_PluginInstaller()
		*
		* Sets the features for the installer
		**/

		function OPN_PluginInstaller () {

			$this->HaveRightforIndex = 1;

		}

		/**
		* OPN_PluginInstaller::InsertScriptFeature()
		*
		* Sets the script features for the plugin
		**/

		function InsertScriptFeature ($what, $filepath, $menutype = '') {

			global $opnConfig, $opnTables;

			$do = false;
			if (is_array ($this->Features) ) {
				$max = count ($this->Features);
				for ($i = 0; $i< $max; $i++) {
					if ($this->Features[$i] == $what) {
						$do = true;
					}
				}
			}
			if ($do) {
				$sid = -1;
				if (file_exists (_OPN_ROOT_PATH . $this->Module . $filepath) ) {
					$file = fopen (_OPN_ROOT_PATH . $this->Module . $filepath, 'r');
					$src1 = fread ($file, filesize (_OPN_ROOT_PATH . $this->Module . $filepath) );
					fclose ($file);
					if ($menutype == '') {
						$dat = 'plugin.' . $what;
					} else {
						$dat = 'plugin.' . $menutype;
					}
					$definetestplug = '_DBCODE_' . str_replace ('.', '_', $dat);
					$definetest = $definetestplug . '_' . str_replace ('/', '_', $this->Module);
					$content = '<?php' . _OPN_HTML_NL;
					$content .= 'if (!defined (\'' . $definetest . '\')) {' . _OPN_HTML_NL;
					$content .= 'define (\'' . $definetest . '\',1);' . _OPN_HTML_NL;
					$content .= '?>';
					$content .= $src1;
					$content .= '<?php' . _OPN_HTML_NL;
					$content .= '}' . _OPN_HTML_NL;
					$content .= '?>';
					$src = '';
					$result = &$opnConfig['database']->Execute ('SELECT sid, src, dat FROM ' . $opnTables['opn_script'] . " WHERE dat='$dat'");
					if ($result !== false) {
						if ($result->RecordCount () == 1) {
							$sid = $result->fields['sid'];
							$src .= $result->fields['src'];
							$dat = $result->fields['dat'];
						}
						$result->Close ();
					}
					if ( (substr_count ($src, $src1) == 0) || ($src == '') ) {
						$src = $content . $src;
						$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_script'] . " WHERE dat='$dat'");
						if ($sid == -1) {
							$sid = $opnConfig['opnSQL']->get_new_number ('opn_script', 'sid');
						}
						$src = $opnConfig['opnSQL']->qstr ($src, 'src');
						$dat = $opnConfig['opnSQL']->qstr ($dat);
						$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['opn_script'] . " (sid, src, dat) VALUES ($sid, $src, $dat)");
						$opnConfig['opnSQL']->UpdateBlobs ($opnTables['opn_script'], 'sid=' . $sid);
					}
					unset ($src);
					unset ($src1);
					unset ($content);
				}
			}

		}

		/**
		* OPN_PluginInstaller::SetPluginFeature()
		*
		* Sets the features for the plugin
		**/

		function SetPluginFeature ($doset = true) {

			global $opnConfig, $opnTables;

			$file = _OPN_ROOT_PATH . $this->Module . '/plugin/repair/features.php';
			if ($this->ModuleName != '') {
				if (file_exists ($file) ) {
					include_once ($file);
					$funcF = $this->ModuleName . '_repair_features_plugin';
					$funcM = $this->ModuleName . '_repair_middleboxes_plugin';
					$funcO = $this->ModuleName . '_repair_opnboxes_plugin';
					$funcS = $this->ModuleName . '_repair_sideboxes_plugin';
					$this->Features = $funcF ();
					if (function_exists( $funcS ) ) {
						$this->Sideboxes = $funcS ();
					} else {
						$this->Sideboxes = array ();
					}
					if (function_exists( $funcM ) ) {
						$this->Middleboxes = $funcM ();
					} else {
						$this->Middleboxes = array ();
					}
					if (function_exists( $funcO ) ) {
						$this->Opnboxes = $funcO ();
					} else {
						$this->Opnboxes = array ();
					}
					unset ($funcF);
					unset ($funcS);
					unset ($funcO);
					unset ($funcM);

					$func = $this->ModuleName . '_repair_opn_exception_register';
					if (function_exists( $func ) ) {
						$this->opn_exception_register = $func();
					}
					$func = $this->ModuleName . '_repair_opn_class_register';
					if (function_exists( $func ) ) {
						$this->opn_class_register = $func();
					}

					if ( ($this->opn_exception_register !== false) && ($doset) ){
						/*
						$opn_plugin_sql_table['table']['opn_exception_register']['id'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 11, 0);
						$opn_plugin_sql_table['table']['opn_exception_register']['module'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 100, "");
						$opn_plugin_sql_table['table']['opn_exception_register']['exception_name'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 255, "");
						$opn_plugin_sql_table['table']['opn_exception_register']['exception_point'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 255, "");
						$opn_plugin_sql_table['table']['opn_exception_register']['exception_text'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 255, "");
						$opn_plugin_sql_table['table']['opn_exception_register']['function_name'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 255, "");
						$opn_plugin_sql_table['table']['opn_exception_register']['options'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_BLOB, 0, "");
						*/

					}

					if ( ($this->opn_class_register !== false) && ($doset) ) {

						$this->ExecuteSQL ('DELETE FROM ' . $opnTables['opn_class_register'] . " WHERE module='" . $this->Module . "'");

						if (is_array ($this->opn_class_register) ) {
							foreach ($this->opn_class_register as $key => $value) {

								$myoptions = $value;
								$class_name = $key;

								$options = $opnConfig['opnSQL']->qstr (serialize (addslashesinarray ($myoptions) ), 'options');
								$module = $opnConfig['opnSQL']->qstr ($this->Module);
								$shared_class = $opnConfig['opnSQL']->qstr ('');
								$shared_opn_class = $opnConfig['opnSQL']->qstr ($class_name);
								$id = $opnConfig['opnSQL']->get_new_number ('opn_class_register', 'id');
								$sql  = 'INSERT INTO ' . $opnTables['opn_class_register'] . " (id, module, shared_class, shared_opn_class, options)";
								$sql .= " VALUES ($id,$module,$shared_class, $shared_opn_class, $options)";
								$opnConfig['database']->Execute ($sql);
								$opnConfig['opnSQL']->UpdateBlobs ($opnTables['opn_class_register'], 'id=' . $id);

							} // for
						}
					}



				}
			} else {
				$doset = false;
			}
			if ($doset) {
				if (is_array ($this->Features) ) {
					$opnConfig['installedPlugins']->SetFeatures ('00000X00000X00000X00000X00000X00000');
					$max = count ($this->Features);
					for ($i = 0; $i< $max; $i++) {
						$opnConfig['installedPlugins']->setpluginfeature ($this->Features[$i]);
					}
					// for
					$opnConfig['installedPlugins']->InsertPluginIntoTable ($this->Module, $this->Sideboxes, $this->Middleboxes, $this->Opnboxes);
				}
			}

		}


		/**
		* OPN_PluginInstaller::SetSettings()
		*
		* Saves the settings for the plugin
		**/

		function SetSettings () {
			if ( (is_array ($this->PrivateSettings) ) || (is_array ($this->PublicSettings) ) ) {
				$set =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ MySettings;
				$set->modulename = $this->Module;
				$set->DeleteTheSettings ();
				// Save the private settings
				if (is_array ($this->PrivateSettings) ) {
					$set->settings = $this->PrivateSettings;
					$set->SaveTheSettings (false);
				}
				// Save the public settings
				if (is_array ($this->PublicSettings) ) {
					$set->settings = $this->PublicSettings;
					$set->SaveTheSettings ();
				}
				unset ($set);
			}

		}

		/**
		* OPN_PluginInstaller::InstallPlugin()
		*
		* Install the plugin
		**/

		function InstallPlugin ($update = false) {

			global $opnTables, $opnConfig;

			$this->BuildTableArray ();
			$this->BuildItemArray ();
			$opnConfig['opnSQL']->opn_dbcoreloader ('sql.opninit.php');
			$uid = $opnConfig['permission']->UserInfo ('uid');
			$opnConfig['webinclude'] =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ update_module ();
			if ($uid == 2) {
				$ok = 1;
			} elseif ($update) {
				$ok = 1;
			} else {
				if ($opnConfig['opn_multihome'] == 0) {
					$ok = 1;
				} else {
					if ($opnConfig['webinclude']->mhfix_check_module ($this->Module) == 1) {
						$ok = 1;
					} else {
						$ok = 0;
					}
				}
			}
			if ($ok == 1) {
				// If ItemDataSaveToCheck not empty process
				if ($this->IsItemDataSaveThere () ) {
					$dbcat =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ catalog ($opnConfig, 'opn_datasavecat');
					// If ItemDataSaveToCheck not in the catalog install the plugin
					if (!$dbcat->catisitemincatalog ($this->ItemDataSaveToCheck) ) {
						// Set the catalogentries and save it
						if ($this->ItemDataSaveToCheck != 'OPN_FIRST_INSTALL') {
							$max = count ($this->ItemsDataSave);
							for ($i = 0; $i< $max; $i++) {
								srand ( ((double)microtime () )*1000000);
								$thedir = $this->ItemsDataSave[$i] . '_' . (Time ()+rand (1, 12305) );
								Check_Server ();
								$dbcat->catset ($this->ItemsDataSave[$i], $opnConfig['root_path_datasave'] . $thedir . '/');
								$File =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opnFile;
								$File->make_dir ($opnConfig['root_path_datasave'] . $thedir);
								if ($File->ERROR == '') {
									$File->copy_file ($opnConfig['root_path_datasave'] . 'index.html', $opnConfig['root_path_datasave'] . $thedir . '/index.html');
									if ($File->ERROR != '') {
										echo $File->ERROR . '<br />';
									}
								} else {
									echo $File->ERROR . '<br />';
								}
							}
							// for
							$dbcat->catsave ();
							dbconf_get_DataSave ();
						}
					}
				}
				// If ItemToCheck not empty process
				if ($this->IsItemThere () ) {
					$dbcat =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ catalog ($opnConfig, 'dbcat');
					// If ItemToCheck not in the catalog install the plugin
					if (!$dbcat->catisitemincatalog ($this->ItemToCheck) ) {
						// Set the catalogentries and save it
						if ($this->ItemToCheck != 'OPN_FIRST_INSTALL') {
							$max = count ($this->Items);
							for ($i = 0; $i< $max; $i++) {
								$dbcat->catset ($this->Items[$i], $this->Tables[$i]);
							}
							// for
							$dbcat->catsave ();
							dbconf_get_tables ($opnTables, $opnConfig);
						}
						$file = _OPN_ROOT_PATH . $this->Module . '/plugin/sql/index.php';
						if (file_exists ($file) ) {
							include_once ($file);
							$myfuncSQLt = $this->ModuleName . '_repair_sql_table';
							$this->opnCreateSQL_table = $myfuncSQLt ();
							$myfuncSQLi = $this->ModuleName . '_repair_sql_index';
							if (function_exists ($myfuncSQLi) ) {
								$this->opnCreateSQL_index = $myfuncSQLi ();
							} else {
								$this->opnCreateSQL_index = '';
							}
							$myfuncSQLd = $this->ModuleName . '_repair_sql_data';
							if (function_exists ($myfuncSQLd) ) {
								$this->opnCreateSQL_data = $myfuncSQLd ();
							} else {
								$this->opnCreateSQL_data = '';
							}
						}
						// Create the needed tables if necassery (new system)
						if (is_array ($this->opnCreateSQL_table) ) {
							$this->opnExecuteSQL ($this->opnCreateSQL_table);
						}
						if ($this->HaveRightforIndex == 1) {
							if (is_array ($this->opnCreateSQL_index) ) {
								$this->opnExecuteSQL ($this->opnCreateSQL_index);
							}
						}
						if (is_array ($this->opnCreateSQL_data) ) {
							$this->opnExecuteSQL ($this->opnCreateSQL_data);
						}
					}
				}
				$file = _OPN_ROOT_PATH . $this->Module . '/plugin/repair/setting.php';
				if ($this->ModuleName != '') {
					if (file_exists ($file) ) {
						include_once ($file);
						if (!$this->IsTheme) {
							$myfunc = $this->ModuleName . '_repair_setting_plugin';
						} else {
							$myfunc = $this->ModuleName . '_repair_theme_setting_plugin';
						}
						$this->PublicSettings = $myfunc (0);
						$this->PrivateSettings = $myfunc (1);
					} else {
						$this->PublicSettings = '';
						$this->PrivateSettings = '';
					}
				}
				// Sets the pluginfeatures
				$this->SetPluginFeature ();
				// Insert the Script Features
				$this->InsertScriptFeature ('waitingcontent', '/plugin/sidebox/waiting/insert.php');
				$this->InsertScriptFeature ('themenav', '/plugin/theme/index.php');
				$this->InsertScriptFeature ('menu', '/plugin/menu/index.php', 'sitemap');
				$this->InsertScriptFeature ('menu', '/plugin/menu/usermenu.php', 'usermenu');
				$this->InsertScriptFeature ('menu', '/plugin/menu/adminmenu.php', 'adminmenu');
				// Create an entrie in the meta_site_tags table if necassery
				if ($this->MetaSiteTags) {
					$this->ExecuteSQL ('INSERT INTO ' . $opnTables['opn_meta_site_tags'] . " (pagename,keywords,description,title) VALUES ('" . $this->Module . "','','','')");
				}
				// Save the settings for the plugin
				$this->SetSettings ();
				// Set the rights for the module
				if (is_array ($this->Rights) ) {
					if ($this->RightsGroup == '') {
						$this->RightsGroup = 'Anonymous';
					}
					$data = array ();
					$modulen = $this->Module;
					$id = $opnConfig['opnSQL']->get_new_number ('user_group_rights', 'perm_id');
					if (is_array ($this->RightsGroup) ) {
						$max = count ($this->RightsGroup);
						for ($i = 0; $i< $max; $i++) {
							$gid = 0;
							$this->GetUsergroup ($this->RightsGroup[$i], $gid);
							$flag = '';
							$opnConfig['permission']->BuildFlag ($flag, $this->Rights[$i]);
							$data['data']['user_group_rights'][] = "$id,$gid,'$modulen','$flag'";
							$id++;
						}
					} else {
						$gid = 0;
						$this->GetUsergroup ($this->RightsGroup, $gid);
						$flag = '';
						$opnConfig['permission']->BuildFlag ($flag, $this->Rights);
						$data['data']['user_group_rights'][] = "$id,$gid,'$modulen','$flag'";
					}
					$this->opnExecuteSQL ($data);
				}
				// Create usergroups
				if (is_array ($this->UserGroups) ) {
					$datasql = array ();
					$id = $opnConfig['opnSQL']->get_new_number ('user_group_rights', 'perm_id');
					$gid = $opnConfig['opnSQL']->get_new_number ('user_group', 'gid');
					$result = &$opnConfig['database']->Execute ('SELECT max(user_group_id)+1 as maxug FROM ' . $opnTables['user_group']);
					$maxug = $result->fields['maxug'];
					$max = count ($this->UserGroups);
					for ($i = 0; $i< $max; $i++) {
						$name = $opnConfig['opnSQL']->qstr ($this->UserGroups[$i]);
						$result->Close ();
						$datasql['data']['user_group'][] = "$gid,$maxug,$name,'',0,$name";
						$flag = '';
						$opnConfig['permission']->BuildFlag ($flag, $this->GroupRights[$i]);
						$datasql['data']['user_group_rights'][] = "$id,$maxug,'" . $this->Module . "','$flag'";
						$id++;
						$gid++;
						$maxug++;
					}
					$this->opnExecuteSQL ($datasql);
				}
				if (count ($this->Item_BIN)>0) {
					$File =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opnFile;
					$max = count ($this->Item_BIN);
					for ($i = 0; $i< $max; $i++) {
						$File->copy_file (_OPN_ROOT_PATH . $this->Module . '/plugin/opn-bin/' . $this->Item_BIN[$i], _OPN_ROOT_PATH . 'opn-bin/' . $this->Item_BIN[$i], '0777');
					}
				}
				// Save the vcs for the plugin if necassery
				if (!$update) {
					if (file_exists (_OPN_ROOT_PATH . $this->Module . '/plugin/version/index.php') ) {
						$version =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ OPN_VersionsControllSystem ($this->Module);
						$version->ReadVersionFile ();
						if ($version->IsVersionThere () ) {
							$version->UpdateVersion ();
						} else {
							$version->InsertVersion ();
						}
					}
				}
			}

		}

		function GetUsergroup ($groupname, &$gid) {

			global $opnConfig, $opnTables;

			$result = &$opnConfig['database']->Execute ('SELECT user_group_id FROM ' . $opnTables['user_group'] . " WHERE user_group_orgtext='" . $groupname . "'");
			$gid = $result->fields['user_group_id'];
			$result->Close ();
			unset ($result);

		}

	}

	class OPN_PluginInstallerChoose {

		function AccessDenied () {

			$help = '<div class="extratext" align="center">' . _PLUGIN_ACCDENIED . '</div>' . _OPN_HTML_NL;
			return $help;

		}

		function AccesDenied_MissingModule ($missing = '') {

			$help = '<div class="extratext" align="center">' . _OPN_HTML_NL;
			$help .= _PLUGIN_ACCDENIED . _OPN_HTML_NL;
			$help .= '</div>' . _OPN_HTML_NL;
			$help .= '<br />' . _OPN_HTML_NL;
			$help .= '<div class="extratext">' . _OPN_HTML_NL;
			$help .= _AF_MISSINGMODUL . _OPN_HTML_NL;
			$help .= '<br />' . _OPN_HTML_NL;
			$help .= '<br />' . _OPN_HTML_NL;
			$help .= $missing . _OPN_HTML_NL;
			$help .= '<br />' . _OPN_HTML_NL;
			$help .= '</div>' . _OPN_HTML_NL;
			return $help;

		}

		function BuildLinks ($text, $module, $yesurl, &$boxtitle, $installed, $mh1url = '', $mh2url = '') {

			global $opnConfig;

			$admin_item = explode ('/', $module);
			$folder = _OPN_ROOT_PATH . $module;
			$module = $admin_item[1];
			$wfolder = $admin_item[0];
			$update = false;
			$admin_item_array = get_plugins ($folder, $module, $installed, $wfolder, $update);
			$doit = true;
			$missing = '';
			if ( (isset ($admin_item_array['need']) ) && ($admin_item_array['need'] != '') && (!$installed) ) {
				$need = explode (',', $admin_item_array['need']);
				$max = count ($need);
				for ($i = 0; $i< $max; $i++) {
					if (!$opnConfig['installedPlugins']->isplugininstalled ($need[$i]) ) {
						$doit = false;
						$missing .= $need[$i] . '<br />';
					}
				}
			}
			$table =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_TableClass ('alternator');
			$table->AddHeaderRow (array ($admin_item_array['description'], $text . ' ' . $admin_item_array['description'] . '&nbsp;' . _PLUGIN_PLUGIN . '?') );
			$table->AddOpenRow ();
			$table->AddDataCol (admin_menu_item ($admin_item_array) );
			if ($doit) {
				$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/' . $yesurl) . '">' . _YES . '</a>&nbsp;&nbsp;' . '<a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/admin.php?fct=plugins') . '">' . _NO . '</a>');
			} else {
				$table->AddDataCol ($this->AccesDenied_MissingModule ($missing) );
			}
			$table->AddCloseRow ();
			$help = '';
			$table->GetTable ($help);
			$opnConfig['opnSQL']->opn_dbcoreloader ('sql.opninit.php');
			if ( ($opnConfig['permission']->UserInfo ('uid') == 2) && ($opnConfig['opn_multihome'] == 1) ) {
				$help .= '<br />';
				$table =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_TableClass ('alternator');
				$table->AddHeaderRow (array (_PLUGIN_MH_ACCESS . ' ' . $admin_item_array['description'] . '&nbsp;' . _PLUGIN_PLUGIN . '?', _PLUGIN_MH_REMOVEACCESS . ' ' . $admin_item_array['description'] . '&nbsp;' . _PLUGIN_PLUGIN . '?') );
				$table->AddOpenRow ();
				$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/' . $mh1url) . '">' . _YES . '</a>');
				$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/' . $mh2url) . '">' . _YES . '</a>');
				$table->AddCloseRow ();
				$table->GetTable ($help);
			}
			$boxtitle = $admin_item_array['description'];
			return $help;

		}

		function UpdatePluginWindow ($module, $plugback) {

			global $opnConfig;
			// Only admins can install plugins
			$boxtitle = '';
			if ($opnConfig['permission']->HasRight ('admin/openphpnuke', _PERM_ADMIN) ) {
				$help = $this->BuildLinks (_PLUGIN_UPDATE, $module, 'admin/updatemanager/index.php?fct=mirrorfixes&module=' . $module . '&plugback=' . $plugback, $boxtitle, true);
			} else {
				$help = $this->AccessDenied ();
			}
			$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle . '&nbsp;' . _PLUGIN_PLUGIN, $help);
			unset ($help);

		}

		function InstallPluginWindow ($module, $plugback) {

			global $opnConfig;
			// Only admins can install plugins
			$boxtitle = '';
			if ($opnConfig['permission']->HasRight ('admin/openphpnuke', _PERM_ADMIN) ) {
				$help = $this->BuildLinks (_PLUGIN_INSTALL, $module, $module . '/plugin/index.php?op=doinstall&module=' . $module . '&plugback=' . $plugback, $boxtitle, false, 'admin/updatemanager/index.php?fct=mhfix_on&module=' . $module . '&plugback=' . $plugback, 'admin/updatemanager/index.php?fct=mhfix_off&module=' . $module . '&plugback=' . $plugback);
			} else {
				$help = $this->AccessDenied ();
			}
			$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle . '&nbsp;' . _PLUGIN_PLUGIN, $help);
			unset ($help);

		}

		function RemovePluginWindow ($module, $plugback) {

			global $opnConfig;
			// Only admins can remove plugins
			$boxtitle = '';
			if ($opnConfig['permission']->HasRight ('admin/openphpnuke', _PERM_ADMIN) ) {
				$help = $this->BuildLinks (_PLUGIN_REMOVE, $module, $module . '/plugin/index.php?op=doremove&module=' . $module . '&plugback=' . $plugback, $boxtitle, true, 'admin/updatemanager/index.php?fct=mhfix_on&module=' . $module . '&plugback=' . $plugback, 'admin/updatemanager/index.php?fct=mhfix_off&module=' . $module . '&plugback=' . $plugback);
			} else {
				$help = $this->AccessDenied ();
			}
			$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle . '&nbsp;' . _PLUGIN_PLUGIN, $help);
			unset ($help);

		}

	}
}

?>