<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_MULTICHECKER_INCLUDED') ) {
	define ('_OPN_CLASS_MULTICHECKER_INCLUDED', 1);

	class multichecker {

		/*<{php4}>
		var $error = '';
		var $clear = true;
		<{php4/}>*/

		/*<{php5}>
		public $error = '';
		public $clear = true;
		<{php5/}>*/

		/*<{delete}>*/
		var $error = '';
		var $clear = true;
		/*<{delete/}>*/

		function multichecker () {

			$this->clear_error ();
			return;

		}

		function clear_error () {

			$this->error = '';
			$this->clear = true;

		}

		/*
		This checks the email format
		return true or false
		look for something@hostname
		*/

		function is_email ($Address = '') {

			global $opnConfig;
			if ($this->clear == true) {
				$this->clear_error ();
			}
			if (empty ($Address) == true) {
				$this->error = 'No email address submitted';
				return false;
			}
			if (!preg_match ('/@/', $Address) ) {
				$this->error = 'Invalid, no @ symbol is in string';
				return false;
			}
			$da = split ('@', $Address);
			if (isset ($da[0]) == true) {
				$User = $da[0];
			}
			if (isset ($da[1]) == true) {
				$Host = $da[1];
			}
			if ( (empty ($User) ) or (empty ($Host) ) ) {
				$this->error = 'missing data [' . $User . ']@[' . $Host . ']';
				return false;
			}
			if ( ($this->has_space ($User) ) or ($this->has_space ($Host) ) ) {
				$this->error = 'Whitespace in [' . $User . ']@[' . $Host . ']';
				return false;
			}
			if (! (preg_match ('/^[_\.0-9a-z-]+@[a-z0-9]+([-_\.]?[a-z0-9])+\.[a-z]{2,4}/i', $Address) ) ) {
				return false;
			}
			if ( (!isset ($opnConfig['opn_list_domainname']) ) || !is_array ($opnConfig['opn_list_domainname']) ) {
				$opnConfig['opn_list_domainname'] = array ();
			}
			$mycount = count ($opnConfig['opn_list_domainname']);
			$listcheck = FALSE;
			if ($mycount >= 1) {
				$userhost = array_reverse (explode ('.', $Host) );
				$userhost = implode ('.', $userhost);
				$lenuserhost = strlen ($userhost);
				foreach ($opnConfig['opn_list_domainname'] as $value) {
					$tmphost = array_reverse (explode ('.', $value) );
					$tmphost = implode ('.', $tmphost);
					$lentmphost = strlen ($tmphost);
					if ($lentmphost<=$lenuserhost) {
						if (substr ($userhost, 0, $lentmphost) == $tmphost) {
							$listcheck = TRUE;
						}
					}
					if ($listcheck) {
						break;
					}
				}
				if ( ((bool) $opnConfig['opn_new_user_actasblacklist']) === $listcheck) {
					$this->error = 'blocked email-host';
					return FALSE;
				}
			}
			return true;

		}

		/*
		Check a string for whitespace
		Return true or false
		*/

		function has_space ($text) {
			if (preg_match ('/[ 	]/', $text) == true) {
				return true;
			}
			return false;

		}

		function email_validatehost ($email, $return_mxhost = 0) {
			if (!$this->is_email ($email) ) {
				return false;
			}
			list (, $domain) = explode ('@', $email, 2);
			$mxhosts = array ();
			if (!checkdnsrr ($domain, 'MX') || !getmxrr ($domain, $mxhosts) ) {
				return false;
			}
			if ($return_mxhost) {
				return $mxhosts;
			}
			return true;

		}

		function email_validateexists ($email) {

			$mxhosts = $this->email_validatehost ($email, true);
			if (!is_array ($mxhosts) ) {
				return false;
			}
			$found = false;
			$localhost = $this->email_localhost ();
			$mxsize = sizeof ($mxhosts);
			for ($i = 0; $i< $mxsize; $i++) {
				if (substr_count ($mxhosts[$i], 'hotmail.com')>0) {
					return false;
				}
				if (substr_count ($mxhosts[$i], 'yahoo.com')>0) {
					return false;
				}
				$socket = @fsockopen ($mxhosts[$i], 25);
				if (!$socket) {
					continue;
				}
				$foo = fgets ($socket, 4096);

				# 220 <domain> Service ready
				if (!preg_match ('/^220/i', $foo) ) {
					$this->email_closesocket ($socket);
					continue;
				}
				fputs ($socket, 'HELO ' . $localhost . _OPN_HTML_CRLF);
				$foo = fgets ($socket, 4096);
				while (preg_match ('/^220/i', $foo) ) {
					$foo = fgets ($socket, 4096);
				}
				fputs ($socket, 'VRFY ' . $email . _OPN_HTML_CRLF);
				$foo = fgets ($socket, 4096);

				# 250 Requested mail action okay, completed
				if (preg_match ('/^250/i', $foo) ) {
					$found = true;
					$this->email_closesocket ($socket);
					break;
				}

				# 550 Requested action: mailbox unavailable
				if (preg_match ('/^550/i', $foo) == true) {
					$this->email_closesocket ($socket);
					continue;
				}
				fputs ($socket, 'MAIL FROM: <' . $email . '>' . _OPN_HTML_CRLF);
				$foo = fgets ($socket, 4096);
				fputs ($socket, 'RCPT TO: <' . $email . '>' . _OPN_HTML_CRLF);
				$foo = fgets ($socket, 4096);

				# 250 Requested mail action okay, completed

				# 251 User not local; will forward to <forward-path>
				if (preg_match ('/^[220|251]/i', $foo) ) {
					$found = true;
					$this->email_closesocket ($socket);
					break;
				}
				$this->email_closesocket ($socket);
			}
			return $found;

		}

		function email_closesocket ($socket) {

			fputs ($socket, 'QUIT' . _OPN_HTML_CRLF);
			fclose ($socket);
			return true;

		}

		function email_localhost () {

			$localhost = getenv ('SERVER_NAME');
			if (!strlen ($localhost) ) {
				$localhost = getenv ('HOST');
			}
			return $localhost;

		}

		/**
		* Validate a number according to Luhn check algorithm
		*
		* This function checks given number according Luhn check
		* algorithm. It is published on several places, also here:
		*
		*	  http://www.webopedia.com/TERM/L/Luhn_formula.html
		*	  http://www.merriampark.com/anatomycc.htm
		*	  http://hysteria.sk/prielom/prielom-12.html#3 (Slovak language)
		*	  http://www.speech.cs.cmu.edu/~sburke/pub/luhn_lib.html (Perl lib)
		*
		* @param  string  $number number (only numeric chars will be considered)
		* @return bool	true if number is valid, otherwise false
		*/

		function checkCreditCard ($cardnumber) {

			$cardnumber = preg_replace ('/[^0-9]/', '', $cardnumber);
			if (empty ($cardnumber) || ($len_number = strlen ($cardnumber) )<=0) {
				return false;
			}
			$sum = 0;
			for ($k = $len_number%2; $k< $len_number; $k += 2) {
				if ( (intval ($cardnumber{$k})*2)>9) {
					$sum += (intval ($cardnumber{$k})*2)-9;
				} else {
					$sum += intval ($cardnumber{$k})*2;
				}
			}
			for ($k = ($len_number%2)^1; $k< $len_number; $k += 2) {
				$sum += intval ($cardnumber{$k});
			}
			return $sum%10?false : true;

		}

		/**
		* Validate a ISBN number
		*
		* This function checks given number according
		*
		* @param  string  $isbn number (only numeric chars will be considered)
		* @return bool	true if number is valid, otherwise false
		*/

		function checkISBN ($isbn) {
			if (preg_match ("/[^0-9 IXSBN-]/", $isbn) == true) {
				return false;
			}
			if (!preg_match ("/^ISBN/", $isbn) ) {
				return false;
			}
			$isbn = preg_replace ("/-/", "", $isbn);
			$isbn = preg_replace ("/ /", "", $isbn);
			$isbn = preg_replace ("/isbn/i", "", $isbn);
			if (strlen ($isbn) != 10) {
				return false;
			}
			if (preg_match ("/[^0-9]{9}[^0-9X]/", $isbn) == true) {
				return false;
			}
			$t = 0;
			for ($i = 0; $i<strlen ($isbn)-1; $i++) {
				$t += $isbn[$i]* (10- $i);
			}
			$f = $isbn[9];
			if ($f == "X") {
				$t += 10;
			} else {
				$t += $f;
			}
			if ($t%11) {
				return false;
			}
			return true;

		}

		/**
		* Validate an ISSN (International Standard Serial Number)
		*
		* This function checks given ISSN number
		* ISSN identifies periodical publications:
		* http://www.issn.org
		*
		* @param  string  $issn number (only numeric chars will be considered)
		* @return bool	true if number is valid, otherwise false
		*/

		function checkISSN ($issn) {

			static $weights_issn = array (8,
							7,
							6,
							5,
							4,
							3,
							2);
			$issn = strtoupper ($issn);
			$issn = preg_replace ("/issn/i", "", $issn);
			$issn = str_replace (array ('-',
						'/',
						' ',
						"\t",
						"\n"),
						'',
						$issn);
			$issn_num = preg_replace ("/x/i", "0", $issn);
			// check if this is an 8-digit number
			if (!is_numeric ($issn_num) || strlen ($issn) != 8) {
				return false;
			}
			return $this->_check_control_number ($issn, $weights_issn, 11, 11);

		}

		/**
		* Validate a ISMN (International Standard Music Number)
		*
		* This function checks given ISMN number (ISO Standard 10957)
		* ISMN identifies all printed music publications from all over the world
		* whether available for sale, hire or gratis--whether a part, a score,
		* or an element in a multi-media kit:
		* http://www.ismn-international.org/
		*
		* @param  string  $ismn ISMN number
		* @return bool	true if number is valid, otherwise false
		*/

		function checkISMN ($ismn) {

			static $weights_ismn = array (3,
							1,
							3,
							1,
							3,
							1,
							3,
							1,
							3);
			$ismn = preg_replace ("/ismn/i", "", $ismn);
			$ismn = preg_replace ("/m/i", "3", $ismn);
			// change first M to 3
			$ismn = str_replace (array ('-',
						'/',
						' ',
						"\t",
						"\n"),
						'',
						$ismn);
			// check if this is a 10-digit number
			if (!is_numeric ($ismn) || strlen ($ismn) != 10) {
				return false;
			}
			return $this->_check_control_number ($ismn, $weights_ismn, 10, 10);

		}

		/**
		* Validate a EAN/UCC-8 number
		*
		* This function checks given EAN8 number
		* used to identify trade items and special applications.
		* http://www.ean-ucc.org/
		* http://www.uc-council.org/checkdig.htm
		*
		* @param  string  $ean number (only numeric chars will be considered)
		* @return bool	true if number is valid, otherwise false
		*/

		function checkEAN8 ($ean) {

			static $weights_ean8 = array (3,
							1,
							3,
							1,
							3,
							1,
							3);
			$ean = str_replace (array ('-',
						'/',
						' ',
						"\t",
						"\n"),
						'',
						$ean);
			// check if this is a 8-digit number
			if (!is_numeric ($ean) || strlen ($ean) != 8) {
				return false;
			}
			return $this->_check_control_number ($ean, $weights_ean8, 10, 10);

		}

		/**
		* Validate a EAN/UCC-13 number
		*
		* This function checks given EAN/UCC-13 number used to identify
		* trade items, locations, and special applications (e.g., coupons)
		* http://www.ean-ucc.org/
		* http://www.uc-council.org/checkdig.htm
		*
		* @param  string  $ean number (only numeric chars will be considered)
		* @return bool	true if number is valid, otherwise false
		*/

		function checkEAN13 ($ean) {

			static $weights_ean13 = array (1,
							3,
							1,
							3,
							1,
							3,
							1,
							3,
							1,
							3,
							1,
							3);
			$ean = str_replace (array ('-',
						'/',
						' ',
						"\t",
						"\n"),
						'',
						$ean);
			// check if this is a 13-digit number
			if (!is_numeric ($ean) || strlen ($ean) != 13) {
				return false;
			}
			return $this->_check_control_number ($ean, $weights_ean13, 10, 10);

		}

		/**
		* Validate a EAN/UCC-14 number
		*
		* This function checks given EAN/UCC-14 number
		* used to identify trade items.
		* http://www.ean-ucc.org/
		* http://www.uc-council.org/checkdig.htm
		*
		* @param  string  $ean number (only numeric chars will be considered)
		* @return bool	true if number is valid, otherwise false
		*/

		function checkEAN14 ($ean) {

			static $weights_ean14 = array (3,
							1,
							3,
							1,
							3,
							1,
							3,
							1,
							3,
							1,
							3,
							1,
							3);
			$ean = str_replace (array ('-',
						'/',
						' ',
						"\t",
						"\n"),
						'',
						$ean);
			// check if this is a 14-digit number
			if (!is_numeric ($ean) || strlen ($ean) != 14) {
				return false;
			}
			return $this->_check_control_number ($ean, $weights_ean14, 10, 10);

		}

		/**
		* Validate a UCC-12 (U.P.C.) ID number
		*
		* This function checks given UCC-12 number used to identify
		* trade items, locations, and special applications (e.g., * coupons)
		* http://www.ean-ucc.org/
		* http://www.uc-council.org/checkdig.htm
		*
		* @param  string  $ucc number (only numeric chars will be considered)
		* @return bool	true if number is valid, otherwise false
		*/

		function checkUCC12 ($ucc) {

			static $weights_ucc12 = array (3,
							1,
							3,
							1,
							3,
							1,
							3,
							1,
							3,
							1,
							3);
			$ucc = str_replace (array ('-',
						'/',
						' ',
						"\t",
						"\n"),
						'',
						$ucc);
			// check if this is a 12-digit number
			if (!is_numeric ($ucc) || strlen ($ucc) != 12) {
				return false;
			}
			return $this->_check_control_number ($ucc, $weights_ucc12, 10, 10);

		}

		/**
		* Validate a SSCC (Serial Shipping Container Code)
		*
		* This function checks given SSCC number
		* used to identify logistic units.
		* http://www.ean-ucc.org/
		* http://www.uc-council.org/checkdig.htm
		*
		* @param  string  $sscc number (only numeric chars will be considered)
		* @return bool	true if number is valid, otherwise false
		*/

		function sscc ($sscc) {

			static $weights_sscc = array (3,
							1,
							3,
							1,
							3,
							1,
							3,
							1,
							3,
							1,
							3,
							1,
							3,
							1,
							3,
							1,
							3);
			$sscc = str_replace (array ('-',
						'/',
						' ',
						"\t",
						"\n"),
						'',
						$sscc);
			// check if this is a 18-digit number
			if (!is_numeric ($sscc) || strlen ($sscc) != 18) {
				return false;
			}
			return $this->_check_control_number ($sscc, $weights_sscc, 10, 10);

		}

		/**
		* Validates a number
		*
		* @param string $number number to validate
		* @param array $weights reference to array of weights
		* @param int $modulo (optionsl) number
		* @param int $subtract (optional) numbier
		* @returns bool
		**/

		function _check_control_number ($number, $weights, $modulo = 10, $subtract = 0) {
			if (strlen ($number)<count ($weights) ) {
				return false;
			}
			$target_digit = substr ($number, count ($weights), 1);
			$control_digit = $this->_get_control_number ($number, $weights, $modulo, $subtract, $target_digit === 'X');
			if ($control_digit == -1) {
				return false;
			}
			if ($target_digit === 'X' && $control_digit == 10) {
				return true;
			}
			if ($control_digit != $target_digit) {
				return false;
			}
			return true;

		}

		/**
		* Calculates control digit for a given number
		*
		* @param string $number number string
		* @param array $weights reference to array of weights
		* @param int $modulo (optionsl) number
		* @param int $subtract (optional) number
		* @param bool $allow_high (optional) true if function can return number higher than 10
		* @returns int -1 calculated control number is returned
		*/

		function _get_control_number ($number, $weights, $modulo = 10, $subtract = 0, $allow_high = false) {
			// calc sum
			$sum = $this->_mult_weights ($number, $weights);
			if ($sum == -1) {
				return -1;
			}
			$mod = $this->_modf ($sum, $modulo);

			/* calculate control digit  */
			if ($subtract>$mod) {
				$mod = $subtract- $mod;
			}
			if ($allow_high === false) {
				$mod %= 10;

				/* change 10 to zero		*/
			}
			return $mod;

		}

		/**
		* Calculates sum of product of number digits with weights
		*
		* @param string $number number string
		* @param array $weights reference to array of weights
		* @returns int returns product of number digits with weights
		*/

		function _mult_weights ($number, $weights) {
			if (!is_array ($weights) ) {
				return -1;
			}
			$sum = 0;
			$count = min (count ($weights), strlen ($number) );
			if ($count == 0) {
				// empty string or weights array
				return -1;
			}
			for ($i = 0; $i< $count; ++ $i) {
				$sum += intval (substr ($number, $i, 1) )* $weights[$i];
			}
			return $sum;

		}

		function _modf ($val, $div) {
			if (function_exists ('bcmod') == true) {
				return bcmod ($val, $div);
			}
			if (function_exists ('fmod') == true) {
				return fmod ($val, $div);
			}
			$r = $val/ $div;
			$i = intval ($r);
			return intval ( ($r- $i)* $div);

		}

	}
}

?>