<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_OPN_IMAGES_INCLUDED') ) {
	define ('_OPN_CLASS_OPN_IMAGES_INCLUDED', 1);

	class ImgThumb {

		/*<{php4}>
		var $bg_red;
		var $bg_green;
		var $bg_blue;
		var $maxSize;
		var $image;
		<{php4/}>*/

		/*<{php5}>
		public $bg_red;
		public $bg_green;
		public $bg_blue;
		public $maxSize;
		public $image;
		<{php5/}>*/

		/*<{delete}>*/
		var $bg_red;
		var $bg_green;
		var $bg_blue;
		var $maxSize;
		var $image;
		/*<{delete/}>*/

		function ImgThumb ($filename, $newxsize = 60, $newysize = 60, $fileout = '', $thumbMaxSize = 0, $bgred = 0, $bggreen = 0, $bgblue = 0) {
			if ($thumbMaxSize) {
				$this->maxSize = true;
			} else {
				$this->maxSize = false;
			}
			if ($bgred >= 0 || $bgred<=255) {
				$this->bg_red = $bgred;
			} else {
				$this->bg_red = 0;
			}
			if ($bggreen >= 0 || $bggreen<=255) {
				$this->bg_green = $bggreen;
			} else {
				$this->bg_green = 0;
			}
			if ($bgblue >= 0 || $bgblue<=255) {
				$this->bg_blue = $bgblue;
			} else {
				$this->bg_blue = 0;
			}
			$this->NewImgCreate ($filename, $newxsize, $newysize, $fileout);

		}

		function NewImgCreate ($filename, $newxsize, $newysize, $fileout) {

			$type = $this->GetImgType ($filename);
			$orig_img = false;
			switch ($type) {
				case 'gif':
					if (function_exists ('imagecreatefromgif') ) {
						$orig_img = imagecreatefromgif ($filename);
					}
					break;
				case 'jpg':
					if (function_exists ('imagecreatefromjpeg') ) {
						$orig_img = imagecreatefromjpeg ($filename);
					}
					break;
				case 'png':
					if (function_exists ('imagecreatefrompng') ) {
						$orig_img = imagecreatefrompng ($filename);
					}
					break;
			}
			if ($orig_img) {
				$new_img = $this->NewImgResize ($orig_img, $newxsize, $newysize, $filename);
				if (!empty ($fileout) ) {
					$this->NewImgSave ($new_img, $fileout, $type);
				} else {
					$this->NewImgShow ($new_img, $type);
				}
				ImageDestroy ($new_img);
				ImageDestroy ($orig_img);
			}

		}

		function NewImgResize ($orig_img, $newxsize, $newysize, $filename) {

			global $opnConfig;

			$orig_size = getimagesize ($filename);
			$maxX = $newxsize;
			$maxY = $newysize;
			if ($orig_size[0]<$orig_size[1]) {
				$newxsize = $newysize* ($orig_size[0]/ $orig_size[1]);
				$adjustX = ($maxX- $newxsize)/2;
				$adjustY = 0;
			} else {
				$newysize = $newxsize/ ($orig_size[0]/ $orig_size[1]);
				$adjustX = 0;
				$adjustY = ($maxY- $newysize)/2;
			}
			if ($this->maxSize) {
				$func = $opnConfig['opn_gfx_imagecreate'];
				$im_out = $func ($maxX, $maxY);
				$bgfill = imagecolorallocate ($im_out, $this->bg_red, $this->bg_green, $this->bg_blue);
				imagefill ($im_out, 0, 0, $bgfill);
				$func = $opnConfig['opn_gfx_imagecopyresized'];
				$func ($im_out, $orig_img, $adjustX, $adjustY, 0, 0, $newxsize, $newysize, $orig_size[0], $orig_size[1]);
			} else {
				$func = $opnConfig['opn_gfx_imagecreate'];
				$im_out = $func ($newxsize, $newysize);
				$bgfill = imagecolorallocate ($im_out, $this->bg_red, $this->bg_green, $this->bg_blue);
				imagefill ($im_out, 0, 0, $bgfill);
				$func = $opnConfig['opn_gfx_imagecopyresized'];
				$func ($im_out, $orig_img, 0, 0, 0, 0, $newxsize, $newysize, $orig_size[0], $orig_size[1]);
			}
			return $im_out;

		}

		function NewImgSave ($new_img, $fileout, $type) {
			switch ($type) {
				case 'gif':
					if (function_exists ('imagegif') ) {
						if (substr ($fileout, strlen ($fileout)-4, 4) != '.gif') {
							$fileout .= '.gif';
						}
						return imagegif ($new_img, $fileout);
				}
				$this->NewImgSave ($new_img, $fileout, 'jpg');
				break;
				case 'jpg':
					if (substr ($fileout, strlen ($fileout)-4, 4) != '.jpg') {
						$fileout .= '.jpg';
					}
					return imagejpeg ($new_img, $fileout);
				case 'png':
					if (substr ($fileout, strlen ($fileout)-4, 4) != '.png') {
						$fileout .= '.png';
					}
					return imagepng ($new_img, $fileout);
			}
			return false;

		}

		function NewImgShow ($new_img, $type) {
			switch ($type) {
				case 'gif':
					if (function_exists ('imagegif') ) {
						header ('Content-type: image/gif');
						imagegif ($new_img);
					} else {
						$this->NewImgShow ($new_img, 'jpg');
					}
					break;
				case 'jpg':
					header ('Content-type: image/jpeg');
					imagejpeg ($new_img);
					break;
				case 'png':
					header ('Content-type: image/png');
					imagepng ($new_img);
					break;
			}

		}

		function GetImgType ($filename) {

			$size = getimagesize ($filename);
			switch ($size[2]) {
				case 1:
					return 'gif';
				case 2:
					return 'jpg';
				case 3:
					return 'png';
			}
			return '';

		}

		function GetImgTag ($dir, $image, $alttext = '', $border = 0, $align = '', $height = 0, $width = 0, $hspace = 0, $vspace = 0, $bordercolor = '', $class = '') {

			global $opnConfig;
			if ($image == '') {
				$ImgTag = '';
			} else {
				if (strrpos ($dir, '/') == strlen ($dir)-1) {
					$dir = substr ($dir, 0, strlen ($dir)-1);
					$hpath = $dir;
				} else {
					$hpath = $dir;
				}
				if (substr_count ($dir, 'http://') == 0) {
					$hpath = $opnConfig['opn_url'] . '/' . $dir;
					$hpath1 = _OPN_ROOT_PATH . $dir;
				} elseif (substr_count ($dir, $opnConfig['opn_url'])>0) {
					$hpath1 = _OPN_ROOT_PATH . str_replace ($opnConfig['opn_url'] . '/', '', $hpath);
				} else {
					$hpath1 = $hpath;
				}
				$path = $hpath . '/' . $opnConfig['language'] . '/' . $image;
				$path1 = $hpath1 . '/' . $opnConfig['language'] . '/' . $image;
				if (!file_exists ($path1) ) {
					$path = $hpath . '/' . $image;
					$path1 = $hpath1 . '/' . $image;
				}
				if (file_exists ($path1) ) {
					$size = GetImageSize ($path1);
					$help = '<img src="' . $path . '"';
					if ($width != -1) {
						if ( ($size[0]) && ($width == 0) ) {
							$help .= ' width="' . $size[0] . '"';
						} elseif ($width != 0) {
							$help .= ' width="' . $width . '"';
						}
					}
					if ($height != -1) {
						if ( ($size[1]) && ($height == 0) ) {
							$help .= ' height="' . $size[1] . '"';
						} elseif ($height != 0) {
							$help .= ' height="' . $height . '"';
						}
					}
					if ($alttext != '') {
						$help .= ' alt="' . $alttext . '" title="' . $alttext . '"';
					} else {
						$help .= ' alt="' . $alttext . '"';
					}
					$help .= ' border="' . $border . '"';
					if ($align != '') {
						$help .= ' align="' . $align . '"';
					}
					if ($hspace != 0) {
						$help .= ' hspace="' . $hspace . '"';
					}
					if ($vspace != 0) {
						$help .= ' vspace="' . $vspace . '"';
					}
					if ($class != '') {
						$help .= ' class="' . $class . '"';
					}
					if ($bordercolor != '') {
						$help .= ' bordercolor="' . $bordercolor . '"';
					}
					$help .= ' />';
					$ImgTag = $help;
				} else {
					$ImgTag = '';
				}
			}
			unset ($help);
			unset ($hpath);
			unset ($hpath1);
			unset ($path1);
			return ($ImgTag);

		}

	}

	class ImageWork {
		var $x;
		var $y;
		var $type;
		var $img;
		var $font;
		var $error;
		var $size;

		function ImageWork ($filename, $path, $col = NULL) {

			global $opnConfig;

			$this->font = false;
			$this->error = false;
			$this->size = 25;
			if (is_numeric ($filename) && is_numeric ($path) ) {
				$this->x = $filename;
				$this->y = $path;
				$this->type = 'jpg';
				$func = $opnConfig['opn_gfx_imagecreate'];
				$this->img = $func ($this->x, $this->y);
				if (is_array ($col) ) {
					$colour = ImageColorAllocate ($this->img, $col[0], $col[1], $col[2]);
					ImageFill ($this->img, 0, 0, $colour);
				}
			} else {
				if (file_exists ($path . $filename) ) {
					$file = $path . $filename;
				} elseif (file_exists ($path . '/' . $filename) ) {
					$file = $path . '/' . $filename;
				} else {
					$this->errorImage ('File Could Not Be Loaded');
				}
				if (! ($this->error) ) {
					$this->type = strtolower (end (explode ('.', $filename) ) );
					if ($this->type == 'jpg' || $this->type == 'jpeg') {
						$this->img = @imagecreatefromjpeg ($file);
					} elseif ($this->type == 'png') {
						$this->img = @imagecreatefrompng ($file);
					} elseif ($this->type == 'gif') {
						if (function_exists ('imagecreatefromgif') ) {
							$this->img = @imagecreatefromgif ($file);
						}
					}
					if ($this->img) {
						$this->x = imagesx ($this->img);
						$this->y = imagesy ($this->img);
					}
				}
			}

		}

		function resize ($width, $height) {

			global $opnConfig;
			if (!$this->error) {
				$func = $opnConfig['opn_gfx_imagecreate'];
				$tmpimage = $func ($width, $height);
				imagecopyresampled ($tmpimage, $this->img, 0, 0, 0, 0, $width, $height, $this->x, $this->y);
				imagedestroy ($this->img);
				$this->img = $tmpimage;
				$this->y = $height;
				$this->x = $width;
			}

		}

		function crop ($x, $y, $width, $height) {

			global $opnConfig;
			if (!$this->error) {
				$func = $opnConfig['opn_gfx_imagecreate'];
				$tmpimage = $func ($width, $height);
				imagecopyresampled ($tmpimage, $this->img, 0, 0, $x, $y, $width, $height, $width, $height);
				imagedestroy ($this->img);
				$this->img = $tmpimage;
				$this->y = $height;
				$this->x = $width;
			}

		}

		function addText ($str, $x, $y, $col) {
			if (!$this->error) {
				if ($this->font) {
					$colour = ImageColorAllocate ($this->img, $col[0], $col[1], $col[2]);
					if (!imagettftext ($this->img, $this->size, 0, $x, $y, $colour, $this->font, $str) ) {
						$this->font = false;
						$this->errorImage ('Error Drawing Text');
					}
				} else {
					$colour = ImageColorAllocate ($this->img, $col[0], $col[1], $col[2]);
					Imagestring ($this->img, 5, $x, $y, $str, $colour);
				}
			}

		}

		function shadowText ($str, $x, $y, $col1, $col2, $offset = 2) {

			$this->addText ($str, $x, $y, $col1);
			$this->addText ($str, $x- $offset, $y- $offset, $col2);

		}

		function addLine ($x1, $y1, $x2, $y2, $col) {
			if (!$this->error) {
				$colour = ImageColorAllocate ($this->img, $col[0], $col[1], $col[2]);
				ImageLine ($this->img, $x1, $y1, $x2, $y2, $colour);
			}

		}

		function outputImage () {
			if ($this->type == 'jpg' || $this->type == 'jpeg') {
				header ('Content-type: image/jpeg');
				imagejpeg ($this->img);
			} elseif ($this->type == 'png') {
				header ('Content-type: image/png');
				imagepng ($this->img);
			} elseif ($this->type == 'gif') {
				header ('Content-type: image/gif');
				imagegif ($this->img);
			}

		}

		function outputFile (&$filename, $path) {
			if ($this->type == 'jpg' || $this->type == 'jpeg') {
				imagejpeg ($this->img, ($path . $filename) );
			} elseif ($this->type == 'png') {
				imagepng ($this->img, ($path . $filename) );
			} elseif ($this->type == 'gif') {
				if (function_exists ('imagegif') ) {
					imagegif ($this->img, ($path . $filename) );
				} else {
					$this->setImageType ('jpg');
					$filename = str_replace ('.gif', '.jpg', $filename);
					$this->outputFile ($filename, $path);
				}
			}

		}

		function setImageType ($type) {

			$this->type = $type;

		}

		function setFont ($font) {

			$this->font = $font;

		}

		function setSize ($size) {

			$this->size = $size;

		}

		function getWidth () {
			return $this->x;

		}

		function getHeight () {
			return $this->y;

		}

		function getImageType () {
			return $this->type;

		}

		function errorImage ($str) {

			global $opnConfig;

			$this->error = false;
			$this->x = 235;
			$this->y = 50;
			$this->type = 'jpg';
			$func = $opnConfig['opn_gfx_imagecreate'];
			$this->img = $func ($this->x, $this->y);
			$this->addText ('AN ERROR OCCURED:', 10, 5, array (250,
									70,
									0) );
			$this->addText ($str, 10, 30, array (255,
							255,
							255) );
			$this->error = true;

		}

	}
}

?>