<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_CLASS_OPN_LOCK_INCLUDED') ) {
	define ('_OPN_CLASS_OPN_LOCK_INCLUDED', 1);

	class opn_lock {

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_module = '';
		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_what = '';

		/**
		 * Set the module for locking
		 * 		
		 * @param $module
		 */
		function SetModule ($module) {

			$this->_module = $module;

		}

		/**
		 * Set what to lock
		 * 		
		 * @param $what
		 */
		function SetWhat ($what) {

			$this->_what = $what;
		}

		/**
		 * Check if a specified locking record exists
		 * 		
		 * @return boolean
		 */	
		function IsLocked () {

			global $opnConfig, $opnTables;

			$module = $opnConfig['opnSQL']->qstr ($this->_module);
			$what = $opnConfig['opnSQL']->qstr ($this->_what);
			$query = 'SELECT COUNT(module) AS counter from ' . $opnTables['opn_lock'] . " WHERE module=$module AND lockwhat=$what";
			$result = &$opnConfig['database']->Execute ($query);
			$count = 0;
			if ($result !== false) {
				if ( ($result->fields !== false) && (isset ($result->fields['counter']) ) ) {
					$count = $result->fields['counter'];
					$result->Close ();
				}
			}
			if ($count) {
				return true;
			}
			return false;

		}

		/**
		 * Create a specified locking record
		 * 		
		 */
		function Lock () {

			global $opnConfig, $opnTables;

			$module = $opnConfig['opnSQL']->qstr ($this->_module);
			$what = $opnConfig['opnSQL']->qstr ($this->_what);
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['opn_lock'] . " VALUES ($module, $what)");

		}

		/**
		 * Remove a specified locking record
		 * 		
		 */
		function Unlock () {

			global $opnConfig, $opnTables;

			$module = $opnConfig['opnSQL']->qstr ($this->_module);
			$what = $opnConfig['opnSQL']->qstr ($this->_what);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_lock'] . " WHERE module=$module AND lockwhat=$what");

		}

		/**
		 * Remove all locking records
		 * 		
		 */
		function UnlockAll () {

			global $opnConfig, $opnTables;

			$opnConConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_lock']);

		}
	}

}
?>