<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_PAGEBAR_INCLUDED') ) {
	define ('_OPN_CLASS_PAGEBAR_INCLUDED', 1);
	getLanguageDef (_OPN_ROOT_PATH . 'language/opn_pagebar_class/language/');
	define ('_CLASS_PAGEBAR_BEFORE', 1);
	define ('_CLASS_PAGEBAR_AFTER', 2);
	define ('_CLASS_PAGEBAR_START', 3);
	define ('_CLASS_PAGEBAR_END', 4);
	define ('_CLASS_PAGEBAR_TEXT', 5);
	define ('_CLASS_PAGEBAR_URL', 6);
	define ('_CLASS_PAGEBAR_BREAK', 7);

	class opn_page_bar {

		/*<{php4}>
		var $_limit = 0;
		var $_pagesize = 0;
		var $_page = 0;
		var $_offset = 0;
		var $_url = '';
		var $_urljumpname = '';
		var $_setindex = 'page';
		var $_foundtext = _PAGEBAR_IN_OUR_DATABASE_ARE;
		var $_maxrecords = 0;
		var $_letter = '';
		var $_total_pages =0;
		var $_query = '';
		var $_pos = '';
		var $_sql = '';
		var $_renderdata = array();
		<{php4/}>*/

		/*<{php5}>
		public $_limit = 0;
		public $_pagesize = 0;
		public $_page = 0;
		public $_offset = 0;
		public $_url = '';
		public $_urljumpname = '';
		public $_setindex = 'page';
		public $_foundtext = _PAGEBAR_IN_OUR_DATABASE_ARE;
		public $_maxrecords = 0;
		public $_letter = '';
		public $_total_pages =0;
		public $_query = '';
		public $_pos = '';
		public $_sql = '';
		public $_renderdata = array();
		<{php5/}>*/

		/*<{delete}>*/
		var $_limit = 0;
		var $_pagesize = 0;
		var $_page = 0;
		var $_offset = 0;
		var $_url = '';
		var $_urljumpname = '';
		var $_setindex = 'page';
		var $_foundtext = _PAGEBAR_IN_OUR_DATABASE_ARE;
		var $_maxrecords = 0;
		var $_letter = '';
		var $_total_pages =0;
		var $_query = '';
		var $_pos = '';
		var $_sql = '';
		var $_renderdata = array();
		/*<{delete/}>*/

		/**
		* opn_page_bar::SetLimit()
		* Sets the numbers of records returned from the query.
		*
		* @access public
		* @param integter $limit
		*/

		function SetLimit ($limit) {

			$this->_limit = $limit;

		}
		// function

		/**
		* opn_page_bar::SetPagesize()
		* Sets the max displayed records per page.
		*
		* @access public
		* @param integer $size
		*/

		function SetPagesize ($size) {

			$this->_pagesize = $size;

		}
		// function

		/**
		* opn_page_bar::SetPage()
		* Sets the actual displayed page.
		*
		* @access public
		* @param integer $page
		*/

		function SetPage ($page) {

			$this->_page = $page;

		}
		// function

		/**
		* opn_page_bar::SetOffset()
		* Sets the offset for sopme pagebar methodes.
		*
		* @access public
		* @param integer $offest
		*/

		function SetOffset ($offset) {

			$this->_offset = $offset;
			$this->_limit = $offset;

		}
		// function

		/**
		* opn_page_bar::SetUrl()
		* Sets the URL for the pages.
		*
		* @access public
		* @param array $url
		*/

		function SetUrl ($url) {

			$this->_url = $url;

		}
		// function

		/**
		* opn_page_bar::SetUrljumpname()
		* Sets the URL for the pages.
		*
		* @access public
		* @param array $urljumpname
		*/

		function SetUrljumpname ($urljumpname) {

			$this->_urljumpname = $urljumpname;

		}
		// function

		/**
		* opn_page_bar::SetPageIndex()
		* Sets the index for the array index which contains the pagenumber.
		*
		* @access public
		* @param string $index
		*/

		function SetPageIndex ($index) {

			$this->_setindex = $index;

		}
		// function

		/**
		* opn_page_bar::SetFoundText()
		* Sets the text for displaying who many entries where found.
		*
		* @access public
		* @param string $text
		*/

		function SetFoundText ($text) {

			$this->_foundtext = $text;

		}
		// function

		/**
		* opn_page_bar::SetMaxRecords()
		* Sets the max. numbers of records found in the table.
		*
		* @access public
		* @param integer $max
		*/

		function SetMaxRecords ($max) {

			$this->_maxrecords = $max;

		}
		// function

		/**
		* opn_page_bar::SetLetter()
		* Sets the letter for displaying it in the foundtext.
		*
		* @access public
		* @param string $letter
		*/

		function SetLetter ($letter) {

			$this->_letter = $letter;

		}
		// function

		function SetQuery ($query) {

			$this->_query = $query;

		}
		// function

		function SetPos ($pos) {

			$this->_pos = $pos;

		}
		// function

		function SetSQL ($sql) {

			$this->_sql = $sql;

		}
		// function

		/**
		* opn_page_bar::GetNicePagebar()
		* Displays a Pagebar with the pagenumbers.
		*
		* @access public
		* @param integer $renderas
		*/

		function GetNicePagebar () {
			if (!$this->_pagesize) {
				$this->_pagesize = 1;
			}
			$this->_calc_total_pages ();
			if (!$this->_total_pages) {
				return '';
			}
			$actualPage = ceil ( ($this->_offset+1)/ $this->_pagesize);
			$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_START);
			if ($this->_foundtext != _PAGEBAR_IN_OUR_DATABASE_ARE) {
				if ($this->_total_pages>1) {
					$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_BEFORE,
									'text' => sprintf (_PAGEBAR_YOU_ARE_ON_PAGE,
									number_format ($actualPage,
									0,
									_DEC_POINT,
									_THOUSANDS_SEP),
									number_format ($this->_total_pages,
									0,
									_DEC_POINT,
									_THOUSANDS_SEP) ) );
				}
			}
			if ($actualPage>1) {
				$this->_url['offset'] = 0;
				$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_URL,
								'url' => $this->_url,
								'title' => _PAGEBAR_FIRST,
								'name' => '|&lt;',
								'pos' => 'left');
			}
			if ($actualPage>20) {
				$this->_url['offset'] = ( ($actualPage-21)* $this->_pagesize);
				$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_URL,
								'url' => $this->_url,
								'title' => _PAGEBAR_TWENTY_BACK,
								'name' => '&lt;&lt;',
								'pos' => 'left');
			}
			if ($actualPage>1) {
				$this->_url['offset'] = ( ($actualPage-2)* $this->_pagesize);
				$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_URL,
								'url' => $this->_url,
								'title' => _PAGEBAR_PREVIOUSPAGE,
								'name' => '&lt;',
								'pos' => 'left');
			}
			if ($actualPage<=6) {
				$counter = 1;
				if ($this->_total_pages<11) {
					if ($this->_total_pages == 1) {
						$counter = 3;
					}
					$countermax = $this->_total_pages;
				} else {
					$countermax = 11;
				}
			} else {
				$counter = $actualPage-5;
				$countermax = $actualPage+5;
				if ($countermax>$this->_total_pages) {
					$countermax = $this->_total_pages;
				}
			}
			for ($i = $counter; $i<= $countermax; $i++) {
				if ($i == $actualPage) {
					$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_TEXT,
									'text' => $i,
									'span' => 'pagebaraktiv',
									'pos' => 'main');
				} else {
					$this->_url['offset'] = ( ($i-1)* $this->_pagesize);
					$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_URL,
									'url' => $this->_url,
									'title' => _PAGEBAR_PAGE . $i,
									'name' => $i,
									'pos' => 'main');
				}
			}
			if ($actualPage<$this->_total_pages) {
				$this->_url['offset'] = ( ($actualPage)* $this->_pagesize);
				$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_URL,
								'url' => $this->_url,
								'title' => _PAGEBAR_NEXTPAGE,
								'name' => '&gt;',
								'pos' => 'right');
			}
			if ( ($this->_total_pages-$actualPage) >= 20) {
				$this->_url['offset'] = ( ($actualPage+20-1)* $this->_pagesize);
				$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_URL,
								'url' => $this->_url,
								'title' => _PAGEBAR_TWENTY_NEXT,
								'name' => '&gt;&gt;',
								'pos' => 'right');
			}
			if ($actualPage<$this->_total_pages) {
				$this->_url['offset'] = ( ($this->_total_pages-1)* $this->_pagesize);
				$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_URL,
								'url' => $this->_url,
								'title' => _PAGEBAR_LAST,
								'name' => '&gt;|',
								'pos' => 'right');
			}
			$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_AFTER,
							'text' => sprintf ($this->_foundtext,
							number_format ($this->_maxrecords,
							0,
							_DEC_POINT,
							_THOUSANDS_SEP),
							number_format ($this->_total_pages,
							0,
							_DEC_POINT,
							_THOUSANDS_SEP) ) );
			$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_END);
			$returntext = '';
			$this->_renderpagebar ($returntext);
			$this->_renderdata = array ();
			return $returntext;

		}

		/**
		* opn_page_bar::GetNiceLetterPagebar()
		* Returns a Navigationbar with the letters of the alpabet.
		*
		* @access public
		* @param integer $renderas
		*
		*/

		function GetNiceLetterPagebar () {

			global $opnConfig;
			if ($this->_pos == 'ALL') {
				$pos = _PAGEBAR_LETTERPAGEBAR_ALL;
			} elseif ($this->_pos == '123') {
				$pos = _PAGEBAR_LETTERPAGEBAR_OTHER;
			}
			$boxtxt = '';
			$alphabet = array ( _PAGEBAR_A,
					_PAGEBAR_B,
					_PAGEBAR_C,
					_PAGEBAR_D,
					_PAGEBAR_E,
					_PAGEBAR_F,
					_PAGEBAR_G,
					_PAGEBAR_H,
					_PAGEBAR_I,
					_PAGEBAR_J,
					_PAGEBAR_K,
					_PAGEBAR_L,
					_PAGEBAR_M,
					_PAGEBAR_N,
					_PAGEBAR_O,
					_PAGEBAR_P,
					_PAGEBAR_Q,
					_PAGEBAR_R,
					_PAGEBAR_S,
					_PAGEBAR_T,
					_PAGEBAR_U,
					_PAGEBAR_V,
					_PAGEBAR_W,
					_PAGEBAR_X,
					_PAGEBAR_Y,
					_PAGEBAR_Z,
					_PAGEBAR_LETTERPAGEBAR_ALL,
					_PAGEBAR_LETTERPAGEBAR_OTHER);
			$i = 0;
			$dummy = '';
			$usedetectchars = false;
			$hasothers = false;
			$temp = '';
			if ($this->_sql != '') {
				$result = &$opnConfig['database']->Execute ($this->_sql);
				if (!$result === false) {
					$usedetectchars = true;
					while (! $result->EOF) {
						$temp .= $result->fields['orderchar'];
						if ( (ord ($temp)<65) || (ord ($temp)>91) ) {
							$hasothers = true;
						}
						$result->MoveNext ();
					}
				}
			}
			$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_START);
			foreach ($alphabet as $ltr) {
				$renderit = 0;
				$class = '';
				if ($i == 13) {
					$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_BREAK);
					$i = 0;
				}
				if ($usedetectchars && ! ($ltr == _PAGEBAR_LETTERPAGEBAR_OTHER) ) {
					$mypos = strstr ($temp, $ltr);
				} else {
					$mypos = 1;
				}
				switch ($ltr) {
					case _PAGEBAR_LETTERPAGEBAR_ALL:
						if ($this->_pos == 'ALL') {
							$renderit = 1;
						} else {
							$renderit = 3;
							$query = 'ALL';
							$class = 'letterpagebar';
						}
						break;
					case _PAGEBAR_LETTERPAGEBAR_OTHER:
						if ( ($hasothers) || (!$usedetectchars) ) {
							if ($this->_pos == '123') {
								$renderit = 1;
							} else {
								$renderit = 3;
								$query = '123';
								$class = 'letterpagebar';
							}
						} else {
							$renderit = 2;
						}
						break;
					default:
						if ($mypos === false) {
							$renderit = 2;
						} elseif ($this->_pos == $ltr) {
							$renderit = 1;
						} else {
							$renderit = 3;
							$query = $ltr;
						}
						break;
				}
				// switch
				switch ($renderit) {
					case 1:
						$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_TEXT,
										'text' => '' . $ltr . '',
										'span' => 'letterpagebaraktiv',
										'pos' => 'main');
						break;
					case 2:
						$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_TEXT,
										'text' => $ltr,
										'span' => 'letterpagebardeaktiv',
										'pos' => 'main');
						break;
					case 3:
						$this->_url[$this->_query] = $query;
						if ($class == '') {
							$class = 'letterpagebar';
						}
						$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_URL,
										'url' => $this->_url,
										'title' => '',
										'name' => $ltr,
										'pos' => 'main',
										'class' => $class);
						break;
				}
				// switch
				$i++;
			}
			$this->_renderdata[] = array ('type' => _CLASS_PAGEBAR_END);
			$this->_renderletterpagebar ($boxtxt);
			$this->_renderdata = array ();
			return $boxtxt;

		}
		// function
		// private functions

		/**
		* opn_page_bar::_calc_total_pages()
		* Calculates the number of total pages.
		*
		* @access private
		*/

		function _calc_total_pages () {

			$this->_total_pages = ceil ($this->_maxrecords/ $this->_pagesize);
			// How many pages are we dealing with here??

		}
		// function

		/**
		* opn_page_bar::_get_actual_page()
		* Returns the formatted actual pagenumber.
		*
		* @access private
		* @param string 	text
		* @param integer 	$page
		* @param bool 		$span
		*/

		function _get_actual_page (&$text, $page, $span = false) {
			if ($span) {
				$text .= '<span class="normaltextbold">' . $page . '</span>';
			}
			// if

		}
		// function

		/**
		* opn_page_bar::_get_page_url()
		* Builds the needed Page URL.
		*
		* @access private
		* @param string  $text
		* @param integer $page
		*/

		function _get_page_url (&$text, $page, $class = true) {

			$t = $class;
			$text .= '<a class="opncenterbox" href="' . encodeurl ($this->_url, true, true, false, $this->_urljumpname) . '">' . $page . '</a>';

		}
		// function

		/**
		* opn_page_bar::_renderpagebar()
		* Renders the Pagebar data.
		*
		* @access private
		* @param string $cssclass
		* @param string $returntext
		* @param boll $isletter
		*/

		function _renderpagebar (&$returntext) {

			foreach ($this->_renderdata as $value) {
				switch ($value['type']) {
					case _CLASS_PAGEBAR_START:
						$returntext .= '<div class="pagebar"><ul class="pagebar">' . _OPN_HTML_NL;
						break;
					case _CLASS_PAGEBAR_END:
						$returntext .= '</ul></div>' . _OPN_HTML_NL;
						break;
					case _CLASS_PAGEBAR_BEFORE:
						$returntext .= '<li class="pagebarstarttext">' . $value['text'] . '</li>' . _OPN_HTML_NL;
						break;
					case _CLASS_PAGEBAR_AFTER:
						$returntext .= '<li class="pagebarendtext">' . $value['text'] . '</li>' . _OPN_HTML_NL;
						break;
					case _CLASS_PAGEBAR_TEXT:
						$returntext .= '<li class="pagebaraktiv">';
						if ( (isset ($value['span']) ) && ($value['span'] != '') ) {
							$returntext .= '<span class="' . $value['span'] . '">&nbsp;';
						}
						$returntext .= $value['text'];
						if ( (isset ($value['span']) ) && ($value['span'] != '') ) {
							$returntext .= '&nbsp;</span>';
						}
						$returntext .= '</li>' . _OPN_HTML_NL;
						break;
					case _CLASS_PAGEBAR_URL:
						$returntext .= '<li class="pagebar"><a';
						if ( (isset ($value['class']) ) && ($value['class'] != '') ) {
							$returntext .= ' class="' . $value['class'] . '"';
						} else {
							$returntext .= ' class="pagebar"';
						}
						$returntext .= ' href="' . encodeurl ($value['url'], true, true, false, $this->_urljumpname) . '"';
						if ( (isset ($value['title']) ) && ($value['title'] != '') ) {
							$returntext .= ' title="' . $value['title'] . '"';
						}
						$returntext .= '>&nbsp;' . $value['name'] . '&nbsp;</a></li>' . _OPN_HTML_NL;
						break;
					case _CLASS_PAGEBAR_BREAK:
						$returntext .= '<li class="pagebarbr">&nbsp;</li>' . _OPN_HTML_NL;
						break;
				}
				// switch
			}
			// foreach

		}
		// function

		/**
		* opn_page_bar::_renderletterpagebar()
		* Renders the Letterpagebar data.
		*
		* @access private
		* @param string $cssclass
		* @param string $returntext
		* @param boll $isletter
		*/

		function _renderletterpagebar (&$returntext) {

			foreach ($this->_renderdata as $value) {
				switch ($value['type']) {
					case _CLASS_PAGEBAR_START:
						$returntext .= '<div class="letterpagebar"><ul class="letterpagebar">' . _OPN_HTML_NL;
						break;
					case _CLASS_PAGEBAR_END:
							$returntext .= '</ul></div>' . _OPN_HTML_NL;
						break;
					case _CLASS_PAGEBAR_BEFORE:
						$returntext .= $value['text'];
						break;
					case _CLASS_PAGEBAR_AFTER:
						$returntext .= $value['text'];
						break;
					case _CLASS_PAGEBAR_TEXT:
						$returntext .= '<li class="letterpagebaraktiv">';
						if ( (isset ($value['span']) ) && ($value['span'] != '') ) {
							$returntext .= '<span class="' . $value['span'] . '">&nbsp;';
						}
						$returntext .= $value['text'];
						if ( (isset ($value['span']) ) && ($value['span'] != '') ) {
							$returntext .= '&nbsp;</span>';
						}
						$returntext .= '</li>' . _OPN_HTML_NL;
						break;
					case _CLASS_PAGEBAR_URL:
						$returntext .= '<li class="letterpagebar"><a';
						if ( (isset ($value['class']) ) && ($value['class'] != '') ) {
							$returntext .= ' class="' . $value['class'] . '"';
						} else {
							$returntext .= ' class="letterpagebar"';
						}
						$returntext .= ' href="' . encodeurl ($value['url'], true, true, false, $this->_urljumpname) . '"';
						if ( (isset ($value['title']) ) && ($value['title'] != '') ) {
							$returntext .= ' title="' . $value['title'] . '"';
						}
						$returntext .= '>&nbsp;' . $value['name'] . '&nbsp;</a></li>' . _OPN_HTML_NL;
						break;
					case _CLASS_PAGEBAR_BREAK:
						$returntext .= '<li class="letterpagebarbr">&nbsp;</li>' . _OPN_HTML_NL;
						break;
				}
				// switch
			}
			// foreach

		}
		// function

	}
	// class
}
// if

?>