<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_OPN_PERMISSIONS_INCLUDED') ) {
	define ('_OPN_CLASS_OPN_PERMISSIONS_INCLUDED', 1);
	define ('_PERM_READ', 0);
	// Can Read the modul sides
	define ('_PERM_WRITE', 1);
	// Can post new thinks, like article, guestbook, forumposting and so on
	define ('_PERM_BOT', 2);
	// Allow bots on the side
	define ('_PERM_EDIT', 3);
	// Can edit something in the moduleadmin
	define ('_PERM_NEW', 4);
	// Can create something in the moduleadmin
	define ('_PERM_DELETE', 5);
	// Can delete something in the moduleadmin
	define ('_PERM_SETTING', 6);
	// Can access the modulesettings
	define ('_PERM_ADMIN', 7);
	// Has full adminrights for the module
	define ('_PERM_USER_STATUS_DELETE', 0);
	define ('_PERM_USER_STATUS_ACTIVE', 1);
	define ('_PERM_USER_STATUS_MODERATOR', 2);
	define ('_PERM_USER_STATUS_WAIT_TO_ACTIVE', 50);

	class OPNPermissions {

		/*<{php4}>
		// Public vars.
		var $UserGroups = array();
		var $UserGroupNames = array();

		// private vars. Don't touch or modify it via a script.
		var $_ui = array('user_group' => 0);
		var $_flags = 0;
		var $_module = '';
		var $_hasAdmin = false;
		var $_last_user_group_user = 0;
		var $_user_group = array();
		var $_groups = array();
		var $_belongto = array();
		var $_usercache = array();
		var $_rightcache = array();
		var $_groupscache = array();
		var $_userscache = array();
		var $_override = array();
		var $_error = 0;
		var $opnCookieuid = '';
		<{php4/}>*/

		/*<{php5}>
		// Public vars.
		public $UserGroups = array();
		public $UserGroupNames = array();

		// private vars. Don't touch or modify it via a script.
		public $_ui = array('user_group' => 0);
		public $_flags = 0;
		public $_module = '';
		public $_hasAdmin = false;
		public $_last_user_group_user = 0;
		public $_user_group = array();
		public $_groups = array();
		public $_belongto = array();
		public $_usercache = array();
		public $_rightcache = array();
		public $_groupscache = array();
		public $_userscache = array();
		public $_override = array();
		public $_error = 0;
		public $opnCookieuid = '';
		<{php5/}>*/

		/*<{delete}>*/
		// Public vars.
		var $UserGroups = array();
		var $UserGroupNames = array();

		// private vars. Don't touch or modify it via a script.
		var $_ui = array('user_group' => 0);
		var $_flags = 0;
		var $_module = '';
		var $_hasAdmin = false;
		var $_last_user_group_user = 0;
		var $_user_group = array();
		var $_groups = array();
		var $_belongto = array();
		var $_usercache = array();
		var $_rightcache = array();
		var $_groupscache = array();
		var $_userscache = array();
		var $_override = array();
		var $_error = 0;
		var $opnCookieuid = '';
		/*<{delete/}>*/

		function OPNPermissions () {

			$this->_flags =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ MyBitFlags ();

		}

		/**
		*	Init
		*	Constructor for the class.
		*/

		function Init () {

			global $opnConfig, $opnTables, $user;
			if (!isset ($opnConfig['opn_anonymous_name']) ) {
				$opnConfig['opn_anonymous_name'] = 'anonymous';
			}
			if (!isset ($opnConfig['opn_anonymous_id']) ) {
				$opnConfig['opn_anonymous_id'] = 1;
			}
			$result = &$opnConfig['database']->Execute ('SELECT user_group_id, user_group_text, user_group_members, user_group_webmaster FROM ' . $opnTables['user_group'] . ' WHERE user_group_id>=0 ORDER BY user_group_id');
			if (!$result === false) {
				while (! $result->EOF) {
					$this->UserGroups[$result->fields['user_group_id']]['id'] = $result->fields['user_group_id'];
					$this->UserGroups[$result->fields['user_group_id']]['name'] = $result->fields['user_group_text'];
					$this->UserGroups[$result->fields['user_group_id']]['members'] = $result->fields['user_group_members'];
					$this->UserGroups[$result->fields['user_group_id']]['webmaster'] = $result->fields['user_group_webmaster'];
					$this->UserGroups[$result->fields['user_group_id']]['groupmembers'] = unserialize ($result->fields['user_group_members']);
					$this->UserGroupNames[$result->fields['user_group_id']] = $result->fields['user_group_text'];
					$result->MoveNext ();
				}
				$result->Close ();
			}
			$fl = '';
			$this->_ui = $this->GetUser ($user, 'user', $fl, true);
			$this->_get_groups ();
			$this->_hasAdmin = $this->_IsAdmin ();
			if (!$this->_hasAdmin) {
				$this->_read_group_rights ();
				$result = &$opnConfig['database']->Execute ('SELECT perm_module, perm_rights FROM ' . $opnTables['user_rights'] . ' WHERE perm_uid=' . $this->_ui['uid'] . ' ORDER BY perm_id ');
				if (!$result === false) {
					while (! $result->EOF) {
						$this->_userscache[$result->fields['perm_module']] = $result->fields['perm_rights'];
						$result->MoveNext ();
					}
					// while
					$result->Close ();
				}
			}

		}

		function InitPermissions ($module) {
			if (file_exists (_OPN_ROOT_PATH . $module . '/plugin/userrights/rights.php') ) {
				include_once (_OPN_ROOT_PATH . $module . '/plugin/userrights/rights.php');
			}

		}

		/**
		*	HasRight
		*	Check about the needed right.
		*
		*	@access	public
		*   @param  string  module	   Wich module should be checked?
		*   @param  integer right	   Wich right should be checked?
		*   @param  bool	private	   true = Method is called from another classmethod
		*	@return bool	true = user has the right, false = user has not the right.
		*/

		function HasRight ($module, $right, $private = false) {

			global $opnConfig;
			if (!isset ($this->_ui['user_group']) ) {
				$this->_ui['user_group'] = 0;
			}
			if ( (!isset ($this->_rightcache[$module]) ) && (!$this->_hasAdmin) ) {
				$this->_rightcache[$module]['group'] = '00000X00000X00000X00000X00000X00000';
				$this->_GetGroupRights ($this->_ui['user_group'], $module);
				$this->_GetGroupMembersGroupRights ($this->_ui['user_group'], $module);
				foreach ($this->_belongto as $gid) {
					$this->_GetGroupRights ($gid, $module);
					$this->_GetGroupMembersGroupRights ($gid, $module);
				}
				$this->_rightcache[$module]['user'] = '00000X00000X00000X00000X00000X00000';
				if (isset ($this->_userscache[$module]) ) {
					$this->_rightcache[$module]['user'] = $this->_userscache[$module];
				}
				$this->_module = $module;
			}
			if (!$this->_hasAdmin) {
				$hasgflag = $this->_CheckRight ($this->_rightcache[$module]['group'], $right, 'group/' . $module);
				$hasuflag = $this->_CheckRight ($this->_rightcache[$module]['user'], $right, 'user/' . $module);
			} else {
				$hasgflag = true;
				$hasuflag = true;
			}
			if (isset ($this->_override[$module]) ) {
				if ( ( ($right == _PERM_READ) && ($this->_override[$module]['read']) ) || ( ($right == _PERM_WRITE) && ($this->_override[$module]['write']) ) ) {
					$hasuflag = true;
				}
			}
			$opnConfig['centerbox']->_insert ('access_error', 0);
			if ( ($right == _PERM_BOT) && (!$hasgflag) && ($opnConfig['opnOption']['client']->property ('browser') == 'bot') ) {
				if (!$private) {
					if ( (isset ($opnConfig['opnOutput']) ) && (is_object ($opnConfig['opnOutput']) ) ) {
						if (!$opnConfig['opnOption']['isInCenterbox']) {
							$this->_DisplayError (0);
						}
					}
				}
				return false;
			}
			if ($hasuflag || $hasgflag || $this->_hasAdmin) {
				return true;
			}
			if (!$private) {
				if ( (isset ($opnConfig['opnOutput']) ) && (is_object ($opnConfig['opnOutput']) ) ) {
					if (!$opnConfig['opnOption']['isInCenterbox']) {
						if ($right == _PERM_READ) {
							$this->_DisplayError (1);
							$this->_error = 1;
						} else {
							$this->_DisplayError (0);
							$this->_error = 0;
						}
					}
				}
			}
			return false;

		}

		/**
		*	HasRights
		*	Check about the needed rights.
		*
		*	@access	public
		*   @param  string  module	   Wich module should be checked?
		*   @param  array	rights	   Wich rights should be checked?
		*	@return bool	true = user has one of the rights, false = user has no of this rights.
		*/

		function HasRights ($module, $rights, $private = false) {

			global $opnConfig;

			$right = false;
			$opnConfig['centerbox']->_insert ('access_error', 0);
			if ($this->_hasAdmin) {
				$right = true;
			} else {
				$max = count ($rights);
				for ($i = 0; $i< $max; $i++) {
					if ($this->HasRight ($module, $rights[$i], true) ) {
						$right = true;
						break;
					}
				}
				if ($opnConfig['opnOption']['client']->property ('browser') == 'bot') {
					$botallowed = array_search (_PERM_BOT, $rights);
					if (!is_null ($botallowed) && $botallowed !== false) {
						if (!$this->HasRight ($module, $rights[$botallowed], true) ) {
							$right = false;
						}
					}
				}
			}
			if (!$right) {
				if (!$private) {
					if (!$opnConfig['opnOption']['isInCenterbox']) {
						$this->_DisplayError ($this->_error);
					}
				}
			}
			return $right;

		}

		function OverrideRead ($module, $override = true) {

			$this->_override[$module]['read'] = $override;

		}

		function OverrideWrite ($module, $override = true) {

			$this->_override[$module]['write'] = $override;

		}

		/**
		*	HasGroupRight
		*	Check about the needed right.
		*
		*	@access	public
		*   @param  string  module	   Wich module should be checked?
		*   @param  integer right	   Wich right should be checked?
		*   @param  string	gid		The Usergroup
		*	@return bool	true = user has the right, false = user has not the right.
		*/

		function HasGroupRight ($module, $right, $gid) {
			if (!isset ($this->_groupscache[$module][$gid]) ) {
				$this->_read_group_rights ();
			}
			$this->_rightcache[$module]['group'] = '00000X00000X00000X00000X00000X00000';
			$this->_GetGroupMembersGroupRights ($gid, $module);
			return $this->_CheckRight ($this->_rightcache[$module]['group'], $right);

		}

		/**
		* OPNPermissions::HasUserGroupRigth()
		*
		* @param $module
		* @param $right
		* @return
		**/

		function HasUserGroupRigth ($module, $right, $uid) {

			global $opnConfig, $opnTables;

			static $ui = '';
			static $belongto = array ();
			if ($ui == '') {
				$ui = $this->GetUser ($uid, '', '');
			}
			$gid = $ui['user_group'];
			if (count ($belongto) == 0) {
				$result = $opnConfig['database']->Execute ('SELECT ugu_gid FROM ' . $opnTables['user_group_users'] . ' WHERE ugu_uid=' . $ui['uid']);
				if (!$result === false) {
					while (! $result->EOF) {
						$belongto[$result->fields['ugu_gid']] = $result->fields['ugu_gid'];
						$result->MoveNext ();
					}
					$result->Close ();
				}
				unset ($result);
			}
			if (!isset ($this->_groupscache[$module][$gid]) ) {
				$this->_read_group_rights ();
			}
			$this->_rightcache[$module]['group'] = '00000X00000X00000X00000X00000X00000';
			$this->_GetGroupRights ($gid, $module);
			$this->_GetGroupMembersGroupRights ($gid, $module);
			foreach ($belongto as $gid) {
				if (!isset ($this->_groupscache[$module][$gid]) ) {
					$this->_read_group_rights ();
				}
				$this->_GetGroupRights ($gid, $module);
				$this->_GetGroupMembersGroupRights ($gid, $module);
			}
			return $this->_CheckRight ($this->_rightcache[$module]['group'], $right);

		}

		/**
		*	IsWebmaster
		*	Perform a check that the user is in the webmaster usergroup or not.
		*
		*	@access	public
		*	@return bool	true user is in group, false is not in group.
		*/

		function IsWebmaster () {
			if ($this->UserGroups[$this->_ui['user_group']]['webmaster'] == 1) {
				return true;
			}
			return false;

		}

		/**
		 * Checks if a Group is a webmaster group
		 * 		
		 * @param $gid
		 * @return boolean
		 */
		function IsWebmasterGroup ($gid) {
			if ($this->UserGroups[$gid]['webmaster'] == 1) {
				return true;
			}
			return false;

		}

		/**
		*	IsUser
		*	Perform a check that the user is registered in this site.
		*
		*	@access	public
		*	@return bool	true user is registered, false is not registered.
		*/

		function IsUser () {

			global $opnConfig;
			if ($opnConfig['opnOption']['user_login']) {
				return true;
			}
			return false;

		}

		/**
		*	SaveUserSettings
		*
		*	@access private
		*/

		function SaveUserSettings ($modulename, $modul_pos = '') {

			global $opnTables, $opnConfig;
			if ($opnConfig['opnOption']['user_login']) {
				if ( (isset ($opnConfig['usersettings'][$modulename]) ) && (is_array ($opnConfig['usersettings'][$modulename]) ) ) {
					$settings = $opnConfig['usersettings'][$modulename];
				} else {
					$settings = array ();
				}
				$thesettings = $opnConfig['opnSQL']->qstr (serialize (addslashesinarray ($settings) ), 'settings');
				$sql = 'SELECT COUNT(modulename) AS counter FROM ' . $opnTables['opn_user_configs'] . " WHERE modulename = '" . $modulename . "' AND uid ='" . $this->_ui['uid'] . "'";
				$result = &$opnConfig['database']->Execute ($sql);
				$counter = 0;
				if (isset ($result->fields['counter']) ) {
					$counter = $result->fields['counter'];
				}
				$result->Close ();
				unset ($result);
				if ($counter == 1) {
					$sql = 'UPDATE ' . $opnTables['opn_user_configs'] . ' SET ';
					$sql .= 'module_pos=' . "'$modul_pos', settings=$thesettings";
					$sql .= " WHERE modulename='" . $modulename . "' AND uid ='" . $this->_ui['uid'] . "'";
				} else {
					$sql = 'INSERT INTO ' . $opnTables['opn_user_configs'] . " (modulename, uid, settings, module_pos) values ('" . $modulename . "',";
					$sql .= "'" . $this->_ui['uid'] . "', $thesettings, '$modul_pos')";
				}
				$opnConfig['database']->Execute ($sql);
				$opnConfig['opnSQL']->UpdateBlobs ($opnTables['opn_user_configs'], 'modulename=' . $modulename . ' AND uid =' . $this->_ui['uid']);
				unset ($sql);
				unset ($settings);
				unset ($thesettings);
			}

		}

		/**
		*	LoadUserSettings
		*
		*	@access private
		*/

		function LoadUserSettings ($modulename) {

			global $opnTables, $opnConfig;
			// if ( !( (isset($opnConfig['usersettings'][$modulename])) && (is_array($opnConfig['usersettings'][$modulename])) ) ) {
			$settings = array ();
			if ($opnConfig['opnOption']['user_login']) {
				$result = &$opnConfig['database']->SelectLimit ('SELECT settings FROM ' . $opnTables['opn_user_configs'] . " WHERE modulename='" . $modulename . "' AND uid ='" . $this->_ui['uid'] . "'", 1);
				if ($result !== false) {
					if ($result->RecordCount () == 1) {
						$settings = $result->fields['settings'];
						if ( ($settings != '') && (substr ($settings, 0, 3) != 's:0') && (substr ($settings, 0, 3) != 'a:0') ) {
							$settings = stripslashesinarray (unserialize ($settings) );
						}
					}
					$result->Close ();
				}
				unset ($result);
			}
			if ( (isset ($opnConfig['usersettings'][$modulename]) ) && (is_array ($opnConfig['usersettings'][$modulename]) ) ) {
				$opnConfig['usersettings'][$modulename] = array_merge ($opnConfig['usersettings'][$modulename], $settings);
			} else {
				$opnConfig['usersettings'][$modulename] = $settings;
			}
			unset ($settings);
			// }

		}

		/**
		*	GetUserSetting
		*
		*	@access private
		*/

		function GetUserSetting ($field, $module, $var_default = 1) {

			global $opnConfig;
			if (isset ($opnConfig['usersettings'][$module][$field]) ) {
				return $opnConfig['usersettings'][$module][$field];
			}
			return $var_default;

		}

		/**
		*	SetUserSetting
		*
		*	@access private
		*/

		function SetUserSetting ($var, $field, $module) {

			global $opnConfig;

			$opnConfig['usersettings'][$module][$field] = $var;

		}

		/**
		*	BuildFlag
		*	Determines the rights for the chosen group.
		*
		*	@access private
		*	@param  integer flag	   return param for the needed flagvalue
		*	@param  array	rights	   wich rights should be set?
		*/

		function BuildFlag (&$flag, $rights) {

			$this->_flags->SetFlag ('00000X00000X00000X00000X00000X00000');
			$max = count ($rights);
			for ($i = 0; $i< $max; $i++) {
				$this->_flags->SetBit ($rights[$i]);
			}
			$this->_flags->GetFlag ($flag);

		}

		/**
		*	SetSingleRight
		*	Sets a single right.
		*
		*	@access private
		*   @param  integer flag	   return param for the needed rightvalue
		*   @param  integer	right	   wich right should be set?
		*/

		function SetSingleRight (&$flag, $right) {

			$this->_flags->SetFlag ($flag);
			$this->_flags->SetBit ($right);
			$this->_flags->GetFlag ($flag);

		}

		/**
		*	UnsetSingleRight
		*	Unsets a single right.
		*
		*	@access private
		*   @param  integer flag	   return param for the needed rightvalue
		*   @param  integer	right	   wich right should be unsset?
		*/

		function UnsetSingleRight (&$flag, $right) {

			$this->_flags->SetFlag ($flag);
			$this->_flags->ResetBit ($right);
			$this->_flags->GetFlag ($flag);

		}

		/**
		*	IsRightSet
		*	Checks if a special right is set or not.
		*
		*	@access private
		*   @param  integer right	   the complete rights.
		*   @param  integer	wichRight  wich right should be test?
		*	@return bool				true right is set, false right is not set.
		*/

		function IsRightSet ($right, $wichRight, $cacher = 'X1X') {

			$this->_flags->SetFlag ($right, $cacher);
			return $this->_flags->TestBit ($wichRight);

		}

		/**
		*	GetGroupMembers
		*/

		function GetGroupMembers ($gid) {

			$this->_user_group = array ();
			$this->_get_list ($gid, $this->_user_group);
			$this->_check_for_membership ($gid, $this->_user_group);
			$this->_last_user_group_user = 0;
			return implode (',', $this->_user_group);

		}

		function GetGroupMember ($gid) {

			$this->_user_group = array ();
			$this->_get_list ($gid, $this->_user_group);
			$this->_last_user_group_user = 0;
			return implode (',', $this->_user_group);

		}

		function GetUsersForGroup ($gid) {

			global $opnConfig, $opnTables;

			$result = &$opnConfig['database']->Execute ('SELECT u.uid AS uid, u.uname AS uname FROM ' . $opnTables['users'] . ' u, ' . $opnTables['users_status'] . ' us WHERE ( (us.uid=u.uid) AND (us.level1<>' . _PERM_USER_STATUS_DELETE . ') ) AND (u.user_group=' . $gid . ') ORDER BY u.uid');
			$users = array ();
			while (! $result->EOF) {
				$users[$result->fields['uid']] = $result->fields['uname'];
				$result->MoveNext ();
			}
			$result = &$opnConfig['database']->Execute ('SELECT u.uid AS uid, u.uname AS uname FROM ' . $opnTables['users'] . ' u, ' . $opnTables['users_status'] . ' us,' . $opnTables['user_group_users'] . ' ug WHERE ((u.uid=ug.ugu_uid) AND (us.uid=u.uid) AND (us.level1<>' . _PERM_USER_STATUS_DELETE . ') ) AND (ug.ugu_gid=' . $gid . ') ORDER BY u.uid');
			while (! $result->EOF) {
				$users[$result->fields['uid']] = $result->fields['uname'];
				$result->MoveNext ();
			}
			$result->Close ();
			unset ($result);
			return $users;

		}

		function GetUsersForGroupname ($name) {

			global $opnConfig, $opnTables;

			$result = &$opnConfig['database']->Execute ('SELECT u.uid AS uid, u.uname AS uname FROM ' . $opnTables['users'] . ' u, ' . $opnTables['users_status'] . ' us, ' . $opnTables['user_group'] . ' g WHERE ((u.user_group=g.user_group_id) AND (us.uid=u.uid) AND (us.level1<>' . _PERM_USER_STATUS_DELETE . ") ) AND (g.user_group_orgtext='$name') ORDER BY u.uid");
			$users = array ();
			while (! $result->EOF) {
				$users[$result->fields['uid']] = $result->fields['uname'];
				$result->MoveNext ();
			}
			$result = &$opnConfig['database']->Execute ('SELECT u.uid AS uid, u.uname AS uname FROM ' . $opnTables['users'] . ' u, ' . $opnTables['users_status'] . ' us,' . $opnTables['user_group_users'] . ' ug ,' . $opnTables['user_group'] . ' g WHERE ((g.user_group_id=ug.ugu_gid) AND (u.uid=ug.ugu_uid) AND (us.uid=u.uid) AND (us.level1<>' . _PERM_USER_STATUS_DELETE . ") ) AND (g.user_group_orgtext='$name') ORDER BY u.uid");
			while (! $result->EOF) {
				$users[$result->fields['uid']] = $result->fields['uname'];
				$result->MoveNext ();
			}
			$result->Close ();
			unset ($result);
			return $users;

		}

		/**
		*	GetUserGroups
		*/

		function GetUserGroups () {
			if (isset ($this->_ui['uid']) && ($this->_ui['uid'] >= 2) ) {
				if ($this->_last_user_group_user == $this->_ui['uid']) {
					return implode (',', $this->_user_group);
				}
				$this->_last_user_group_user = $this->_ui['uid'];
				$this->_user_group = array ();
				if (!$this->IsWebmaster () ) {
					$this->_get_list ($this->_ui['user_group'], $this->_user_group);
					$this->_user_group = $this->_user_group+ $this->_belongto;
				} else {
					$tmparr = array_keys ($this->UserGroups);
					foreach ($tmparr as $key) {
						$this->_user_group[] = $key;
					}
					unset ($tmparr);
				}
				return implode (',', $this->_user_group);
			}
			return '0';

		}

		/**
		*	GetUserGroupsUser
		*/

		function GetUserGroupsUser ($uid) {

			global $opnConfig, $opnTables;

			$ui = $this->GetUser ($uid, 'useruid', '');
			if (isset ($ui['uid']) && ($uid >= 2) ) {
				if ($this->_last_user_group_user == $ui['uid']) {
					return implode (',', $this->_user_group);
				}
				$belongto = array ();
				$result = $opnConfig['database']->Execute ('SELECT ugu_gid FROM ' . $opnTables['user_group_users'] . ' WHERE ugu_uid=' . $ui['uid']);
				if (!$result === false) {
					while (! $result->EOF) {
						$belongto[$result->fields['ugu_gid']] = $result->fields['ugu_gid'];
						$result->MoveNext ();
					}
					$result->Close ();
				}
				unset ($result);
				$this->_last_user_group_user = $uid;
				$this->_user_group = array ();
				$this->_get_list ($ui['user_group'], $this->_user_group);
				if (count ($belongto) ) {
					foreach ($belongto as $value) {
						$this->_get_list ($value, $this->_user_group);
					}
				}
				unset ($belongto);
				$this->_user_group = array_unique ($this->_user_group);
				foreach ($this->_user_group as $group) {
					if ($this->IsWebmasterGroup ($group)) {
						$tmparr = array_keys ($this->UserGroups);
						$this->_user_group = array ();
						foreach ($tmparr as $key) {
							$this->_user_group[] = $key;
						}
						unset ($tmparr);
						break;
					}
				}
				return implode (',', $this->_user_group);
			}
			return 0;

		}

		/**
		*	CheckUserGroup
		*	Perform a check that the user is in a special Group.
		*
		*	@access	public
		*	@return bool	true user is in group, false is not in group.
		*/

		function CheckUserGroup ($check) {
			if ($this->_ui['uid'] >= 2) {
				if ($this->_last_user_group_user != $this->_ui['uid']) {
					$this->_user_group = array ();
					$this->_get_list ($this->_ui['user_group'], $this->_user_group);
					$this->_user_group = $this->_user_group+ $this->_belongto;
					$this->_last_user_group_user = $this->_ui['uid'];
				}
				if (isset ($this->_user_group[$check]) ) {
					return true;
				}
			} else {
				if ($check == 0) {
					return true;
				}
			}
			return false;

		}

		/**
		*	UserInfo
		*	Gives a speical userinfo from the userinfo array.
		*
		*	@access	public
		*	@param  string index	which Index from the array should be returned?
		*	@return mixed			The value from the array.
		*/

		function UserInfo ($index) {

			$help = '';
			if ($index != '') {
				if (isset ($this->_ui[$index]) ) {
					$help = $this->_ui[$index];
				}
			}
			return $help;

		}

		/**
		*	GetGroupsOfUID
		*	Gives a array of the UID has Group Right.
		*
		*	@access	public
		*	@param  uid index	which uid?
		*	@return mixed		The value from the array.
		*/

		function GetGroupsOfUID ($uid = 0) {

			global $opnConfig, $opnTables;
			if ($uid == 0) {
				$uid = $this->_ui['uid'];
			}
			$arr = array ();
			$a = 0;
			$result = $opnConfig['database']->Execute ('SELECT perm_id, perm_uid, perm_module, perm_rights FROM ' . $opnTables['user_rights'] . ' WHERE perm_uid=' . $uid);
			if (!$result === false) {
				while (! $result->EOF) {
					$arr[$a]['id'] = $result->fields['perm_id'];
					$arr[$a]['uid'] = $result->fields['perm_uid'];
					$arr[$a]['module'] = $result->fields['perm_module'];
					$arr[$a]['rights'] = $result->fields['perm_rights'];
					$a++;
					$result->MoveNext ();
				}
				$result->Close ();
			}
			unset ($result);
			return $arr;

		}

		/**
		*	DeleteUserGroup
		*	Deletes the requested usergroup.
		*
		*	@access	public
		*   @param  integer id	The id of the usergroup
		*/

		function DeleteUserGroup ($id) {

			global $opnConfig, $opnTables;
			if ($this->_CanDelete ($id) ) {
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_group'] . " WHERE user_group_id=$id");
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_group_rights'] . " WHERE perm_user_group=$id");
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_group_users'] . " WHERE ugu_gid=$id");
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_group_users'] . ' WHERE ugu_gid=' . $id);
			}

		}

		function GetSelectUserList () {

			global $opnConfig, $opnTables;
			return $opnConfig['database']->Execute ('SELECT u.uid AS uid, u.uname AS uname FROM ' . $opnTables['users'] . ' u, ' . $opnTables['users_status'] . ' us WHERE ((us.level1<>' . _PERM_USER_STATUS_DELETE . ') AND (u.uid=us.uid) and (u.uid<>' . $opnConfig['opn_anonymous_id'] . ')) ORDER BY u.uname');

		}

		function CheckUserIsDelete (&$ui) {
			if ( (isset ($ui['level1']) ) && ($ui['level1'] == _PERM_USER_STATUS_DELETE) ) {
				return true;
			}
			return false;

		}

		/**
		*	GetUserinfo
		*	Return the userinfoarray.
		*
		*	@access	public
		*   @param  array result	The array to return
		*/

		function GetUserinfo () {
			return $this->_ui;

		}
		// This Function give only the user_group and/or the seclvl from infos about a user to a array
		//
		// The input is
		//
		// useruid	-> the User id number
		// useruname  -> the user uname
		// user	   -> the infos about the regi. user (in that moment)
		//
		// output is the array
		//

		function GetUser ($daten, $datentype, $frommodul, $first = false) {

			global $user, $opnConfig;

			$t = $frommodul;
			if ($first) {
				$opnConfig['opnOption']['user_login'] = true;
			}
			if ( ($datentype == 'user') OR ($first) ) {
				$cookie = $this->_cookiedecode ($user);
				if (isset ($cookie[_OPN_OPNSESSION_USER_UNAME]) ) {
					$username = $cookie[_OPN_OPNSESSION_USER_UNAME];
				}
				if (!isset ($username) ) {
					$data = $opnConfig['opn_anonymous_name'];
					$user2 = base64_decode ($daten);
					$user3 = explode (':', $user2);
					$userinfo = array();
					if (isset ($user3[_OPN_OPNSESSION_USER_THEME]) ) {
						$this->_GetAnonData($userinfo, $first, $user3[_OPN_OPNSESSION_USER_THEME]);
					} else {
						$this->_GetAnonData($userinfo, $first);
					}
					return $userinfo;
				}
				if (!is_array ($daten) ) {
					$please_decode_it = 1;
					if (strstr ($daten, ':') ) {
						$cookiedummy = explode (':', $daten);
						if (isset ($cookiedummy[_OPN_OPNSESSION_USER_PASS]) ) {
							unset ($cookiedummy);
							$please_decode_it = 0;
						}
					}
					if ($please_decode_it == 1) {
						$user2 = base64_decode ($daten);
					} else {
						$user2 = $daten;
					}
					$user3 = explode (':', $user2);
					$data = $user3[_OPN_OPNSESSION_USER_UNAME];
					$pass = $user3[_OPN_OPNSESSION_USER_PASS];
					$modus = 0;
				} else {
					$data = $daten[_OPN_OPNSESSION_USER_UNAME];
					$pass = $daten[_OPN_OPNSESSION_USER_PASS];
					$modus = 0;
				}
			} elseif ($datentype == 'useruname') {
				$data = $daten;
				$pass = '';
				$modus = 1;
			} else {
				$data = $daten;
				$pass = '';
				$modus = 2;
			}
			if ( ($first) && ($daten != '') ) {
				$userinfo = $this->_getuserinfodata ($data, $pass, $modus, 1);
				$userinfo['user_group_id'] = $userinfo['user_group'];
				$userinfo['user_group_text'] = $opnConfig['permission']->UserGroups[$userinfo['user_group']]['name'];
				if ($userinfo['uname'] == $opnConfig['opn_anonymous_name']) {
					$opnConfig['opnOption']['user_login'] = false;
				}
			} elseif ( (! $first) && ($daten != '') ) {
				$compare = '';
				$holder = 0;
				$max = count ($this->_usercache);
				for ($i = 0; $i< $max; $i++) {
					if (!isset ($this->_usercache[$i]['uid']) ) {
						$this->_usercache[$i]['uid'] = $opnConfig['opn_anonymous_id'];
					}
					if (!isset ($this->_usercache[$i]['uname']) ) {
						$this->_usercache[$i]['uname'] = $opnConfig['opn_anonymous_name'];
					}
					if ($this->_usercache[$i]['uid'] == $data) {
						$compare = $this->_usercache[$i]['uid'];
						$holder = $i;
						break;
					}
					if ($this->_usercache[$i]['uname'] == $data) {
						$compare = $this->_usercache[$i]['uname'];
						$holder = $i;
						break;
					}
				}
				if ( ($compare == $data) ) {
					$userinfo = $this->_usercache[$holder];
				} else {
					$userinfo = $this->_getuserinfodata ($data, $pass, $modus, 1);
					$this->_usercache[] = $userinfo;
				}
			} else {
				$userinfo = array();
				$this->_GetAnonData($userinfo, $first);
			}
			return $userinfo;

		}
		// Private functions

		/**
		 * Gets the Anondata
		 * 		
		 * @param $userinfo
		 * @param $theme
		 */
		function _GetAnonData (&$userinfo, $first, $theme = '') {

			global $opnConfig, $opnTables;

			$userinfo['uname'] = $opnConfig['opn_anonymous_name'];
			$userinfo['uid'] = $opnConfig['opn_anonymous_id'];
			$userinfo['pass'] = '';
			if ($theme != '') {
				$userinfo['theme'] = $theme;
			} else {
				$userinfo['theme'] = $opnConfig['Default_Theme'];
			}
			$userinfo['user_group'] = 0;
			$userinfo['user_group_id'] = 0;
			$result = $opnConfig['database']->Execute ('SELECT thold, uorder, umode, commentmax FROM ' . $opnTables['users'] . ' WHERE uid=' . $opnConfig['opn_anonymous_id']);
			$userinfo['thold'] = $result->fields['thold'];
			$userinfo['uorder'] = $result->fields['uorder'];
			$userinfo['umode'] = $result->fields['umode'];
			if ($result->fields['commentmax'] > 0) {
				$userinfo['commentmax'] = $result->fields['commentmax'];
			}
			$result->Close ();
			if ($first) {
				$opnConfig['opnOption']['user_login'] = false;
			}

		}

		/**
		*	_GetGroupRights
		*	Determines the rights for the chosen group.
		*
		*	@access private
		*   @param  integer groupid	   The id of the group
		*   @param  string  module	   the module
		*   @param  integer rights	 return param for the rights
		*/

		function _GetGroupRights ($groupid, $module) {
			if (isset ($this->_groupscache[$module][$groupid]) ) {
				$right = $this->_groupscache[$module][$groupid];
				for ($i = 0; $i<32; $i++) {
					if ($this->IsRightSet ($right, $i, $groupid . '/' . $module) ) {
						$this->SetSingleRight ($this->_rightcache[$module]['group'], $i);
					}
				}
			}

		}

		/**
		*	_GetGroupMembersGroupRights
		*	Determines the rights for the usergroupmembers of a usergroup.
		*
		*	@access private
		*   @param  integer usergroup  The id of the group
		*   @param  string  module	   the module
		*   @param  integer rights	 return param for the rights
		*/

		function _GetGroupMembersGroupRights ($usergroup, $module) {

			$this->_get_list ($usergroup, $this->_groups);
			unset ($this->_groups[$usergroup]);
			foreach ($this->_groups as $gid) {
				$this->_GetGroupRights ($gid, $module);
			}

		}

		/**
		*	_IsAdmin
		*	Look if usergroup is checked as webmastergroup
		*
		*	@access private
		*	@return bool	true = group is webmastergroup, false = group is not webmastergroup.
		*/

		function _IsAdmin () {

			$isAdmin = FALSE;
			if ($this->UserGroups[$this->_ui['user_group']]['webmaster'] == 1) {
				$isAdmin = TRUE;
			} else {
				foreach ($this->_belongto as $gid) {
					if ($this->UserGroups[$gid]['webmaster'] == 1) {
						$isAdmin = TRUE;
						break;
					}
				}
			}
			return $isAdmin;

		}

		/**
		*	DisplayError
		*	Displays the needed errormessage.
		*
		*	@access private
		*/

		function _DisplayError ($error) {

			global $opnConfig;

			$opnConfig['centerbox']->_insert ('access_error', 1);
			include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.message.php');
			$message =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_message ();
			if ($opnConfig['centerbox']->property ('no_footer') == 1) {
				$message->opn_message_footer ('0');
			}
			if ($error == 0) {
				$message->show_opn_message ();
			} elseif ($error == 1) {
				$message->show_no_user ();
			}
			unset ($message);
			exit ();

		}

		/**
		*	_CheckRight
		*	Is the needed right set ind the flagvar?
		*
		*	@access private
		*   @param  integer flags		The flag that will be chekcked
		*   @param  integer right		The right that will checked
		*	@return bool	true = right is in flagvar, false = right is not if flagvar.
		*/

		function _CheckRight ($flags, $right, $cacher = 'X1X') {

			$this->_flags->SetFlag ($flags, $cacher);
			return $this->_flags->Testbit ($right);

		}

		function _check_for_membership ($gid, &$groups) {
			$max = count ($this->UserGroups);
			for ($i = 0; $i< $max; $i++) {
				if ( (isset ($this->UserGroups[$i]['members']) ) && ($this->UserGroups[$i]['members']) && ($this->UserGroups[$i]['members'] != '') ) {
					$user_group_members = $this->UserGroups[$i]['groupmembers'];
					if (is_array ($user_group_members) ) {
						if (in_array ($gid, $user_group_members) ) {
							$groups[] = $i;
						}
					}
					unset ($user_group_members);
				}
			}

		}

		function _get_list ($lookfor, &$alreadylookedup) {
			if (!isset ($alreadylookedup[$lookfor]) ) {
				$user_group_id = 0;
				$max = count ($this->UserGroups);
				for ($i = 0; $i< $max; $i++) {
					if ( ($i == $lookfor) ) {
						$user_group_id = $i;
						if ( ($this->UserGroups[$i]['members']) && ($this->UserGroups[$i]['members'] != '') ) {
							$user_group_members = $this->UserGroups[$i]['groupmembers'];
							if (is_array ($user_group_members) ) {
								foreach ($user_group_members as $v) {
									if ($v !== '') {
										$this->_get_list ($v, $alreadylookedup);
									}
								}
							}
							unset ($user_group_members);
						}
					}
				}
				$alreadylookedup[$lookfor] = $user_group_id;
			}

		}

		/**
		*	_CanDelete
		*	Can the usergroup be deleted?
		*
		*	@access private
		*   @param  integer group	The usergroup that will be deleted
		*	@return boolean			true = Usergroup can be deleted, false = Usergroup can nit be deleted.
		*/

		function _CanDelete ($group) {

			global $opnConfig, $opnTables;

			$result = true;
			$max = count ($this->UserGroups);
			for ($i = 0; $i< $max; $i++) {
				if (isset ($this->UserGroups[$i]) ) {
					if (is_array ($this->UserGroups[$i]['groupmembers']) ) {
						if (in_array ($group, $this->UserGroups[$i]['groupmembers']) ) {
							$result = false;
							break;
						}
					}
				}
			}
			if (!$result) {
				$result1 = &$opnConfig['database']->Execute ('SELECT COUNT(perm_id) AS counter FROM ' . $opnTables['user_group_rights'] . " WHERE perm_user_group=$group");
				$count = 0;
				if (isset ($result1->fields['counter']) ) {
					$count = $result1->fields['counter'];
				}
				$result1->Close ();
				if ($count>0) {
					$result = false;
				} else {
					$result1 = &$opnConfig['database']->Execute ('SELECT COUNT(ugu_id) AS counter FROM ' . $opnTables['user_group_users'] . " WHERE ugu_gid=$group");
					$count = 0;
					if (isset ($result1->fields['counter']) ) {
						$count = $result1->fields['counter'];
					}
					$result1->Close ();
					if ($count>0) {
						$result = false;
					} else {
						$result1 = &$opnConfig['database']->Execute ('SELECT COUNT(user_group) AS counter FROM ' . $opnTables['users'] . " WHERE user_group=$group");
						$count = 0;
						if (isset ($result1->fields['counter']) ) {
							$count = $result1->fields['counter'];
						}
						$result1->Close ();
						if ($count>0) {
							$result = false;
						}
					}
				}
				unset ($result1);
			}
			return $result;

		}

		function _get_groups () {

			global $opnConfig, $opnTables;

			$result = $opnConfig['database']->Execute ('SELECT ugu_gid FROM ' . $opnTables['user_group_users'] . ' WHERE ugu_uid=' . $this->_ui['uid']);
			if (!$result === false) {
				while (! $result->EOF) {
					$this->_belongto[$result->fields['ugu_gid']] = $result->fields['ugu_gid'];
					$result->MoveNext ();
				}
				$result->Close ();
			}
			unset ($result);

		}

		function _build_user_sql (&$hlp, $function) {

			global $opnConfig;

			$plug = array();
			$opnConfig['installedPlugins']->getplugin ($plug, 'userindex');
			if (is_array ($plug) ) {
				foreach ($plug as $var) {
					include_once (_OPN_ROOT_PATH . $var['plugin'] . '/plugin/user/index.php');
					$myfunc = $var['module'] . $function;
					if (function_exists ($myfunc) ) {
						$work = $myfunc ();
						if ($work != '') {
							if ($function == '_get_tables') {
								$hlp .= $work;
							} else {
								$hlp .= ',' . $work;
							}
						}
					}
				}
			}
			unset ($plug);

		}

		function _getuserinfodata ($data, $pass = '', $modus = 0, $all = 0) {

			global $opnConfig, $opnTables;

			$sql_d = '';
			$sql = 'SELECT u.uid AS uid, u.uname AS uname, u.email AS email, u.user_regdate AS user_regdate, u.user_xt_option AS user_xt_option, u.user_debug AS user_debug, u.pass AS pass, u.storynum AS storynum, u.umode AS umode, u.uorder AS uorder, u.thold AS thold, u.noscore AS noscore, u.ublockon AS ublockon, u.ublock AS ublock, u.theme AS theme, u.commentmax AS commentmax, u.counter AS counter, u.rights AS rights, u.user_group AS user_group, us.rank AS rank, us.posts AS posts, us.specialrang AS specialrang, us.level1 AS level1, us.warning AS warning, us.wertung AS wertung';
			if ($all == 1) {
				$this->_build_user_sql ($sql, '_get_fields');
			}
			$sql .= ' FROM ' . $opnTables['users'] . ' u';
			$sql .= ' LEFT JOIN ' . $opnTables['users_status'] . ' us ON u.uid=us.uid ';
			if ($all == 1) {
				$this->_build_user_sql ($sql, '_get_tables');
			}
			if ( ($modus == 0) && ($data != $opnConfig['opn_anonymous_name']) ) {
				$data = $opnConfig['opnSQL']->qstr ($data);
				$pass = $opnConfig['opnSQL']->qstr ($pass);
				$sql .= " WHERE (u.uname=$data AND u.pass=$pass)";
				$sql_d .= " WHERE (u.uname=$data)";
			} elseif ( ($modus == 0) && ($data == $opnConfig['opn_anonymous_name']) ) {
				$data = $opnConfig['opnSQL']->qstr ($data);
				$sql .= " WHERE (u.uname=$data)";
				$sql_d .= " WHERE (u.uname=$data)";
			} elseif ($modus == 1) {
				$data = $opnConfig['opnSQL']->qstr ($data);
				$sql .= " WHERE (u.uname=$data)";
				$sql_d .= " WHERE (u.uname=$data)";
			} elseif ($modus == 2) {
				$sql .= " WHERE (u.uid=$data)";
				$sql_d .= " WHERE (u.uid=$data)";
			}
			$hlp = array ();
			$error_add = '';
			$result = &$opnConfig['database']->Execute ($sql);
			if ($result !== false) {
				if ($result->RecordCount () == 1) {
					$hlp = $result->GetRowAssoc ('0');
				} else {
					$error_add = ' *Zusatz: ' . $result->RecordCount ();
					$error_add .= print_array ($opnConfig);
					$error_add .= print_array ($result);
				}
				$result->Close ();
			}
			unset ($result);
			if (empty ($hlp) ) {
				$result_d = &$opnConfig['database']->Execute ('SELECT u.uname AS uname FROM ' . $opnTables['users'] . ' u, ' . $opnTables['users_status'] . ' us ' . $sql_d . ' AND (u.uid=us.uid) ');
				if ($result_d !== false) {
					if ($result_d->RecordCount () == 1) {
						$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler ();
						$message = 'Mglicherweise Fehler in der DB bitte prfen!!!';
						global ${$opnConfig['opn_server_vars']};

						$opn_server_vars = ${$opnConfig['opn_server_vars']};
						$docroot = $opn_server_vars['SERVER_NAME'];
						$today = getdate ();
						$errortime = $today['mday'] . '/' . $today['mon'] . '/' . $today['year'] . ' at ' . $today['hours'] . ':' . $today['minutes'];
						$message .= _OPN_HTML_NL . _OPN_HTML_NL;
						$ip = get_real_IP ();
						if (isset ($ip) ) {
							$message .= 'Ausgelst von der IP Adresse:' . $ip . ' am ' . $errortime . _OPN_HTML_NL;
						} else {
							$message .= 'Ausgelst am ' . $errortime . _OPN_HTML_NL;
						}
						$message .= ' ' . _OPN_HTML_NL;
						if (isset ($opn_server_vars['REQUEST_URI']) ) {
							$message .= 'Die URI die den Fehler ausgelst hat war: ' . _OPN_HTML_NL . $docroot . $opn_server_vars['REQUEST_URI'] . _OPN_HTML_NL;
						}
						$message .= ' ' . _OPN_HTML_NL;
						if (isset ($opn_server_vars['HTTP_REFERER']) ) {
							$message .= 'Die Error-Seite wurde aufgerufen von:' . _OPN_HTML_NL . $opn_server_vars['HTTP_REFERER'] . _OPN_HTML_NL;
						}
						$message .= _OPN_HTML_NL . _OPN_HTML_NL;
						$message .= 'So und jetzt noch ein paar Infos' . _OPN_HTML_NL . _OPN_HTML_NL;
						if (isset ($opn_server_vars['HTTP_USER_AGENT']) ) {
							$message .= 'Browser des Users: ' . $opn_server_vars['HTTP_USER_AGENT'] . _OPN_HTML_NL;
						}
						if (isset ($opn_server_vars['REMOTE_PORT']) ) {
							$message .= 'REMOTE_PORT	  : ' . $opn_server_vars['REMOTE_PORT'] . _OPN_HTML_NL;
						}
						if (isset ($opn_server_vars['REMOTE_HOST']) ) {
							$message .= 'REMOTE_HOST	  : ' . $opn_server_vars['REMOTE_HOST'] . _OPN_HTML_NL;
						}
						$ip = get_real_IP ();
						$message .= 'Remote_Name	  : ' . gethostbyaddr ($ip) . _OPN_HTML_NL;
						if (isset ($opn_server_vars['SERVER_PORT']) ) {
							$message .= 'SERVER_PORT	  : ' . $opn_server_vars['SERVER_PORT'] . _OPN_HTML_NL;
						}
						if (isset ($opn_server_vars['SERVER_PROTOCOL']) ) {
							$message .= 'SERVER_PROTOCOL  : ' . $opn_server_vars['SERVER_PROTOCOL'] . _OPN_HTML_NL;
						}
						if (isset ($opn_server_vars['SERVER_SOFTWARE']) ) {
							$message .= 'SERVER_SOFTWARE  : ' . $opn_server_vars['SERVER_SOFTWARE'] . _OPN_HTML_NL;
						}
						if (isset ($opn_server_vars['SERVER_NAME']) ) {
							$message .= 'SERVER_NAME	  : ' . $opn_server_vars['SERVER_NAME'] . _OPN_HTML_NL;
						}
						if (isset ($opn_server_vars['SERVER_ADDR']) ) {
							$message .= 'SERVER_ADDR	  : ' . $opn_server_vars['SERVER_ADDR'] . _OPN_HTML_NL;
						}
						$message .= _OPN_HTML_NL . _OPN_HTML_NL . _OPN_HTML_NL;
						$message .= $sql;
						$message .= _OPN_HTML_NL . _OPN_HTML_NL;
						$message .= $error_add;
						$eh->write_error_log ($message, 0, 'master.php');
						unset ($eh);
						unset ($message);
					}
				}
			} else {
				if ( (isset ($hlp['user_xt_option']) ) && ($hlp['user_xt_option'] != '') ) {
					$myoptions = unserialize ($hlp['user_xt_option']);
					if ( (isset ($myoptions) ) && (is_array ($myoptions) ) && (isset ($myoptions['plugin']) ) && (is_array ($myoptions['plugin']) ) ) {
						for ($k = 0; $k<count ($myoptions['plugin']); $k++) {
							$modul = explode ('/', $myoptions['plugin'][$k]);
							$myfunc = $modul[1] . '_get_user_xt_option';
							if (function_exists ($myfunc) ) {
								$hlp[$modul[1] . '_user_dat'] = array ();
								$myfunc ($hlp[$modul[1] . '_user_dat'],
														$hlp['uname']);
							}
						}
					}

					/*
					if ( (isset($myoptions[0])) && (isset($myoptions)) && (is_array($myoptions)) && (is_array($myoptions[0])) ) {
					$myfunc = $myoptions[0]['module'].'_get_user_xt_option';
					if (function_exists ($myfunc)) {
					$myfunc ($hlp[$myoptions[0]['module'].'_user_dat'] = array(), $hlp['uname']);
					}
					}
					*/

					unset ($myoptions);
				}
				unset ($hlp['user_xt_option']);
			}
			unset ($sql);
			return $hlp;

		}
		// Bitte in keinem Modul mehr weiter benutzen nur noch hier in der master
		// steht auf der liste kommt weg
		// stefan

		function _cookiedecode ($user) {

			global $opnTables, $opnConfig;

			$please_decode_it = 1;
			if (strstr ($user, ':') ) {
				$cookiedummy = explode (':', $user);
				if (isset ($cookiedummy[2]) ) {
					unset ($cookiedummy);
					$please_decode_it = 0;
				}
			}
			if ($please_decode_it == 1) {
				$user = base64_decode ($user);
			}
			if (strstr ($user, "'") ) {
				$user = str_replace ('\'', '"', $user);
			}
			$cookie = explode (':', $user);
			$skipit = false;
			if (is_array ($cookie)) {
				if ( ($this->opnCookieuid == '') && (isset ($cookie[_OPN_OPNSESSION_USER_UNAME]) ) ) {
					$result = &$opnConfig['database']->Execute ('SELECT uid FROM ' . $opnTables['users'] . " WHERE uname='" . $cookie[_OPN_OPNSESSION_USER_UNAME] . "'");
					if ($result === false) {
						$skipit = true;
					} elseif ($result->RecordCount () == 0) {
						$skipit = true;
						$result->Close ();
					} else {
						$this->opnCookieuid = $result->fields['uid'];
						// $opnConfig['opnOption']['themegroup'] = (int)$cookie[_OPN_OPNSESSION_USER_THEME_GROUP];
						$result->Close ();
					}
					unset ($result);
				}
				if (isset ($cookie[_OPN_OPNSESSION_USER_THEME_GROUP]) ) {
					$opnConfig['opnOption']['themegroup'] = (int) $cookie[_OPN_OPNSESSION_USER_THEME_GROUP];
				}
				if (isset ($cookie[_OPN_OPNSESSION_USER_LANG]) ) {
					$opnConfig['opnOption']['language'] = $cookie[_OPN_OPNSESSION_USER_LANG];
					$opnConfig['language'] = $cookie[_OPN_OPNSESSION_USER_LANG];
				}
			}
			if ($skipit) {
				unset ($user);
				unset ($cookie);
				return 0;
			}
			return $cookie;

		}

		function _read_group_rights () {

			global $opnConfig, $opnTables;

			$result = &$opnConfig['database']->Execute ('SELECT perm_user_group, perm_module, perm_rights FROM ' . $opnTables['user_group_rights'] . ' WHERE perm_id>0 ORDER BY perm_id ');
			if (!$result === false) {
				while (! $result->EOF) {
					$this->_groupscache[$result->fields['perm_module']][$result->fields['perm_user_group']] = $result->fields['perm_rights'];
					$result->MoveNext ();
				}
				// while
				$result->Close ();
			}
			unset ($result);

		}

	}
}

?>