<?php
/**
* OpenPHPNuke: Great Web Portal System
* Pro-Module
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is NOT free software.
* See LICENSE for details.
*
*/
if (!defined ('_OPN_CLASS_OPN_SEARCHING_INCLUDED') ) {
	define ('_OPN_CLASS_OPN_SEARCHING_INCLUDED', 1);

	class opn_opnsearching {

		/*<{php4}>
		var $_data = array('error' => '');
		<{php4/}>*/

		/*<{php5}>
		public $_data = array('error' => '');
		<{php5/}>*/

		/*<{delete}>*/
		var $_data = array('error' => '');
		/*<{delete/}>*/

		/*
		*	 clean the last error
		*/

		function clear_error () {

			$this->_insert ('error', '');

		}

		/*
		*	 class input
		*/

		function _insert ($k, $v) {

			$this->_data[strtolower ($k)] = $v;

		}

		/*
		*	 class output
		*/

		function property ($p = null) {
			if ($p == null) {
				return $this->_data;
			}
			return $this->_data[strtolower ($p)];

		}

		function init () {

			$this->SetFields (array () );
			$this->SetTable ('');
			$this->SetQuery ('');
			$this->SetSearchfields (array () );
			$this->SetWhere ('');
			$this->_insert ('sql', '');

		}

		function opn_opnsearching () {

			$this->init ();

		}

		function SetFields ($fields) {

			$this->_insert ('fields', $fields);

		}

		function SetTable ($table) {

			$this->_insert ('table', $table);

		}

		function SetQuery ($query) {

			$this->_insert ('query', $query);

		}

		function SetSearchfields ($fields) {

			$this->_insert ('searchfields', $fields);

		}

		function SetWhere ($where) {

			$this->_insert ('where', $where);

		}

		function GetSQL () {

			$this->GenerateSQL ();
			return $this->property ('sql');

		}

		function GenerateSQL () {

			$fields = $this->property ('fields');
			$table = $this->property ('table');
			$query = $this->property ('query');
			$searchfields = $this->property ('searchfields');
			$where = $this->property ('where');
			$sql = 'SELECT ';
			$sql .= implode (',', $fields);
			$sql .= ' FROM ' . $table;
			$sql .= ' WHERE ';
			if ($where != '') {
				$sql .= $where;
			}
			$sql .= ' ( (';
			$max = count ($searchfields);
			for ($i = 0; $i< $max; $i++) {
				$sql .= $this->MakeGlobalSearchSql ($searchfields[$i], $query);
				$sql .= ') OR (';
			}
			$sql = strrev (substr (strstr (strrev ($sql), strrev (') OR (') ), strlen (') OR (') ) );
			$sql .= ') )';
			$this->_insert ('sql', $sql);

		}

		function MakeGlobalSearchSql ($feld, $query) {

			global $opnConfig;

			$addquery = '';
			$andor = 'AND';
			$terms = explode (' ', $query);
			$addquery .= '(';
			$like_search = $opnConfig['opnSQL']->AddLike ($terms[0]);
			$addquery .= '(' . $feld . ' LIKE ' . $like_search . ')';
			$size = sizeof ($terms);
			for ($i = 1; $i< $size; $i++) {
				if (strtolower ($terms[$i]) == 'and') {
					$andor = 'AND';
				} elseif (strtolower ($terms[$i]) == 'or') {
					$andor = 'OR';
				} else {
					$like_search = $opnConfig['opnSQL']->AddLike ($terms[$i]);
					$addquery .= ' ' . $andor . ' (' . $feld . ' LIKE ' . $like_search . ')';
				}
			}
			$addquery .= ' )';
			return $addquery;

		}

	}
}
// if

?>