<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_OPN_SHAREDMEM_INCLUDED') ) {
	define ('_OPN_CLASS_OPN_SHAREDMEM_INCLUDED', 1);

	class opn_shared_mem {

		/**
		* FUNCTION: Store
		*
		* Stores the data into the tables
		*
		* @param string $key
		* @param string $data
		* @access public
		*/

		function Store ($key, $data) {

			global $opnConfig, $opnTables;

			$key = $opnConfig['opnSQL']->qstr ($key);
			$data = $opnConfig['opnSQL']->qstr ($data, 'data');
			$opnConfig['opndate']->now ();
			$time = '';
			$opnConfig['opndate']->opnDataTosql ($time);
			$select = 'SELECT id FROM ' . $opnTables['opn_mem'] . ' WHERE id=' . $key;
			$update = 'UPDATE ' . $opnTables['opn_mem'] . " SET wtime=$time, data=$data WHERE id=$key";
			$insert = 'INSERT INTO ' . $opnTables['opn_mem'] . " VALUES ($key, $data, $time)";
			$opnConfig['opnSQL']->ensure_dbwrite ($select, $update, $insert);
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables['opn_mem'], 'id=' . $key);

		}
		// end function

		/**
		* FUNCTION: Fetch
		*
		* Fetch the data from the table.
		*
		* @param string $key
		* @access public
		*/

		function Fetch ($key) {

			global $opnConfig, $opnTables;

			$key = $opnConfig['opnSQL']->qstr ($key);
			$result = $opnConfig['database']->Execute ('SELECT data FROM ' . $opnTables['opn_mem'] . ' WHERE id=' . $key);
			$data = '';
			if (!$result->EOF) {
				$data = $result->fields['data'];
				if ($data == 's:0:"";') {
					$data = '';
				}
			}
			return $data;

		}
		// end function

		/**
		* FUNCTION: Delete
		*
		* Deletes a record.
		*
		* @param string $key
		* @access public
		*/

		function Delete ($key) {

			global $opnConfig, $opnTables;

			$key = $opnConfig['opnSQL']->qstr ($key);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_mem'] . ' WHERE id=' . $key);

		}
		// end function

		/**
		* FUNCTION: DeleteTime
		*
		* Deletes the old records via master.php
		*
		* @param float $time
		* @access public
		*/

		function DeleteTime ($time) {

			global $opnConfig, $opnTables;

			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_mem'] . ' WHERE wtime<' . $time);

		}
		// end function

	}
	// end class
}

?>