<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2002 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_VERSIONCONTROLL_INCLUDED') ) {
	define ('_OPN_CLASS_VERSIONCONTROLL_INCLUDED', 1);

	class OPN_VersionsControllSystem {

		/*<{php4}>
		var $_fileversion = '';
		var $_dbversion = '';
		var $_progversion = '';
		var $_id = 0;
		var $_modulename = '';
		var $_filevars = array();
		var $_oldvars = array();
		var $_error = '';
		var $_debug = 0;
		var $_repairdat = '';
		var $_htmlChange = '<br />';
		<{php4/}>*/

		/*<{php5}>
		public $_fileversion = '';
		public $_dbversion = '';
		public $_progversion = '';
		public $_id = 0;
		public $_modulename = '';
		public $_filevars = array();
		public $_oldvars = array();
		public $_error = '';
		public $_debug = 0;
		public $_repairdat = '';
		public $_htmlChange = '<br />';
		<{php5/}>*/

		/*<{delete}>*/
		var $_fileversion = '';
		var $_dbversion = '';
		var $_progversion = '';
		var $_id = 0;
		var $_modulename = '';
		var $_filevars = array();
		var $_oldvars = array();
		var $_error = '';
		var $_debug = 0;
		var $_repairdat = '';
		var $_htmlChange = '<br />';
		/*<{delete/}>*/

		/**
		* OPN_VersionsControllSystem::OPN_VersionsControllSystem()
		*
		* Classconstructor
		*
		* @param string $modulename
		*/

		function OPN_VersionsControllSystem ($modulename) {

			$this->SetModulename ($modulename);
			$this->_error = '';

		}

		function DoDummy () {

			$x = '';
			unset ($x);

		}

		/**
		* OPN_VersionsControllSystem::SetErrorMsg()
		*
		* Set the Error Msg
		*
		* @param string $msg
		*/

		function SetErrorMsg ($message) {

			$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler;
			$eh->write_error_log ($message);
			unset ($eh);
			$this->_error .= str_replace (_OPN_HTML_NL, $this->_htmlChange, $message);

		}

		/**
		* OPN_VersionsControllSystem::GetErrorMsg()
		*
		* Get the last Error Msg
		*
		* @return $msg
		*/

		function GetErrorMsg () {
			return $this->_error;

		}

		/**
		* OPN_VersionsControllSystem::ClearErrorMsg()
		*
		* CLear the Error Msg
		*
		*/

		function CleanErrorMsg () {

			$this->_error = '';

		}

		function SetRepairSql ($message) {

			$this->_repairdat .= $message . ';<br />';

		}

		function GetRepairSql () {
			return $this->_repairdat;

		}

		function CleanRepairSql () {

			$this->_repairdat = '';

		}

		/**
		* OPN_VersionsControllSystem::SetModulename()
		*
		* Set the modulename property and reads the record from the Table if this record exisist
		*
		* @param  $modulename
		*/

		function SetModulename ($modulename) {

			global $opnConfig, $opnTables;

			$this->_modulename = $modulename;
			$this->_id = 0;
			$this->_fileversion = '';
			$this->_dbversion = '';
			$this->_progversion = '';
			$this->_filevars = array ();
			$this->_oldvars = array ();
			if ($modulename != '') {
				$modulename = $opnConfig['opnSQL']->qstr ($this->_modulename);
				$sql = 'SELECT vcs_id, vcs_fileversion, vcs_dbversion, vcs_progversion FROM ' . $opnTables['opn_opnvcs'] . " WHERE vcs_progpluginname= $modulename";
				$result = &$opnConfig['database']->Execute ($sql);
				if ( (!$result === false) ) {
					while (! $result->EOF) {
						$this->_id = $result->fields['vcs_id'];
						$this->_fileversion = $result->fields['vcs_fileversion'];
						$this->_oldvars['fileversion'] = $result->fields['vcs_fileversion'];
						$this->_dbversion = $result->fields['vcs_dbversion'];
						$this->_oldvars['dbversion'] = $result->fields['vcs_dbversion'];
						$this->_progversion = $result->fields['vcs_progversion'];
						$this->_oldvars['progversion'] = $result->fields['vcs_progversion'];
						$result->MoveNext ();
					}
				}
			}

		}

		/**
		* OPN_VersionsControllSystem::SetFileversion()
		*
		* Set the fileversion property
		*
		* @param string $version
		*/

		function SetFileversion ($version) {

			$this->_fileversion = $version;

		}

		/**
		* OPN_VersionsControllSystem::GetFileversion()
		*
		* Return the fileversion property
		*
		* @return string
		*/

		function GetFileversion () {
			return $this->_fileversion;

		}

		/**
		* OPN_VersionsControllSystem::SetDBversion()
		*
		* Set the dbversion property
		*
		* @param string $version
		*/

		function SetDBversion ($version) {

			$this->_dbversion = $version;

		}

		/**
		* OPN_VersionsControllSystem::GetDBversion()
		*
		* Return the dbversion property
		*
		* @return string
		*/

		function GetDBversion () {
			return $this->_dbversion;

		}

		/**
		* OPN_VersionsControllSystem::SetProgversion()
		*
		* Set the progversion property
		*
		* @param string $version
		*/

		function SetProgversion ($version) {

			$this->_progversion = $version;

		}

		/**
		* OPN_VersionsControllSystem::GetProgversion()
		*
		* Return the progversion property
		*
		* @return string
		*/

		function GetProgversion () {
			return $this->_progversion;

		}

		/**
		* OPN_VersionsControllSystem::IsVersionThere()
		*
		* Return true if the versionrecord exists in the table;
		*
		* @return bool
		*/

		function IsVersionThere () {
			if ($this->_id>0) {
				return true;
			}
			return false;

		}

		/**
		* OPN_VersionsControllSystem::InsertVersion()
		*
		* Insert a new record into the opn_opnvcs table
		*
		*/

		function InsertVersion () {

			global $opnConfig, $opnTables;

			$message = _VCSLOG_INSERT . _OPN_HTML_NL;
			$message .= _VCSLOG_MODULE . $this->_modulename . _OPN_HTML_NL;
			$message .= sprintf (_VCSLOG_FILEVERSION, $this->_fileversion) . _OPN_HTML_NL;
			$message .= sprintf (_VCSLOG_DBVERSION, $this->_dbversion) . _OPN_HTML_NL;
			$message .= sprintf (_VCSLOG_PROGVERSION, $this->_progversion) . _OPN_HTML_NL;
			$this->SetErrorMsg ($message);
			$id = $opnConfig['opnSQL']->get_new_number ('opn_opnvcs', 'vcs_id');
			$this->_fileversion = $opnConfig['opnSQL']->qstr ($this->_fileversion);
			$this->_dbversion = $opnConfig['opnSQL']->qstr ($this->_dbversion);
			$this->_progversion = $opnConfig['opnSQL']->qstr ($this->_progversion);
			$modulename = $opnConfig['opnSQL']->qstr ($this->_modulename);
			$sql = 'INSERT INTO ' . $opnTables['opn_opnvcs'] . " VALUES ($id," . $this->_fileversion . "," . $this->_dbversion . "," . $this->_progversion . "," . $modulename . ")";
			$opnConfig['database']->Execute ($sql);

		}

		/**
		* OPN_VersionsControllSystem::UpdateVersion()
		*
		* Update an existing record in the opn_opnvcs table
		*
		*/

		function UpdateVersion () {

			global $opnConfig, $opnTables;
			if ($this->_id != 0) {
				$message = _VCSLOG_UPDATE . _OPN_HTML_NL;
				$message .= _VCSLOG_MODULE . $this->_modulename . _OPN_HTML_NL;
				if ($this->_oldvars['fileversion'] !== $this->_fileversion) {
					$message .= sprintf (_VCSLOG_UPFILEVERSION, $this->_oldvars['fileversion'], $this->_fileversion) . _OPN_HTML_NL;
				}
				if ($this->_oldvars['dbversion'] !== $this->_dbversion) {
					$message .= sprintf (_VCSLOG_UPDBVERSION, $this->_oldvars['dbversion'], $this->_dbversion) . _OPN_HTML_NL;
				}
				if ($this->_oldvars['progversion'] !== $this->_progversion) {
					$message .= sprintf (_VCSLOG_UPPROGVERSION, $this->_oldvars['progversion'], $this->_progversion) . _OPN_HTML_NL;
				}
				$this->SetErrorMsg ($message);
				$this->_fileversion = $opnConfig['opnSQL']->qstr ($this->_fileversion);
				$this->_dbversion = $opnConfig['opnSQL']->qstr ($this->_dbversion);
				$this->_progversion = $opnConfig['opnSQL']->qstr ($this->_progversion);
				$sql = 'UPDATE ' . $opnTables['opn_opnvcs'] . " set vcs_fileversion=" . $this->_fileversion . ", vcs_dbversion=" . $this->_dbversion . ", vcs_progversion=" . $this->_progversion . " WHERE vcs_id=" . $this->_id;
				$opnConfig['database']->Execute ($sql);
			} else {
				$this->InsertVersion ();
			}

		}

		/**
		* OPN_VersionsControllSystem::DeleteVersion()
		*
		* Delete an existiin version from the Table
		*
		*/

		function DeleteVersion () {

			global $opnConfig, $opnTables;

			$modulename = $opnConfig['opnSQL']->qstr ($this->_modulename);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_opnvcs'] . " WHERE vcs_progpluginname=" . $modulename);
			$message = _VCSLOG_DELETE . _OPN_HTML_NL;
			$message .= _VCSLOG_MODULE . $this->_modulename . _OPN_HTML_NL;
			$message .= sprintf (_VCSLOG_FILEVERSION, $this->_fileversion) . _OPN_HTML_NL;
			$message .= sprintf (_VCSLOG_DBVERSION, $this->_dbversion) . _OPN_HTML_NL;
			$message .= sprintf (_VCSLOG_PROGVERSION, $this->_progversion) . _OPN_HTML_NL;
			$this->SetErrorMsg ($message);

		}

		/**
		* OPN_VersionsControllSystem::DeleteVersions()
		* Deletes all entries from the table
		*/

		function DeleteVersions () {

			global $opnConfig, $opnTables;

			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_opnvcs']);

		}

		function CheckVersion () {

			global $opnConfig, $opnTables;
			if ($this->_modulename != '') {
				$modulename = $opnConfig['opnSQL']->qstr ($this->_modulename);
				$sql = 'SELECT vcs_id, vcs_fileversion, vcs_dbversion, vcs_progversion FROM ' . $opnTables['opn_opnvcs'] . " WHERE vcs_progpluginname=$modulename";
				$result = &$opnConfig['database']->Execute ($sql);
				if ( (!$result === false) ) {
					while (! $result->EOF) {
						$fileversion = $result->fields['vcs_fileversion'];
						$dbversion = $result->fields['vcs_dbversion'];
						$progversion = $result->fields['vcs_progversion'];
						$result->MoveNext ();
					}
				}
				if ( ($this->_fileversion !== $fileversion) || ($this->_dbversion !== $dbversion) || ($this->_progversion !== $progversion) ) {
					$message = _VCSLOG_WRONG . _OPN_HTML_NL;
					$message .= _VCSLOG_MODULE . $this->_modulename . _OPN_HTML_NL;
					if ($fileversion !== $this->_fileversion) {
						$message .= sprintf (_VCSLOG_WRFILEVERSION, $fileversion, $this->_fileversion) . _OPN_HTML_NL;
					}
					if ($dbversion !== $this->_dbversion) {
						$message .= sprintf (_VCSLOG_WRDBVERSION, $dbversion, $this->_dbversion) . _OPN_HTML_NL;
					}
					if ($progversion !== $this->_progversion) {
						$message .= sprintf (_VCSLOG_WRPROGVERSION, $progversion, $this->_progversion) . _OPN_HTML_NL;
					}
					$this->SetErrorMsg ($message);
				}
			}

		}

		/**
		* OPN_VersionsControllSystem::_higherversion($versionA, $versionB)
		*
		* Returns true if versionB newer than versionA
		* works with any versionnummer in style x.x or x.x.x or x.x.x.x
		* WHERE x must be a numeric value
		*
		* @return Bool
		*/

		function _higherversion ($versionA, $versionB) {

			$segmentsversionA = explode ('.', $versionA);
			$segmentsversionB = explode ('.', $versionB);
			$ret = false;
			if ( (!is_array ($segmentsversionA) ) && (!is_array ($segmentsversionA) ) ) {
				if ($segmentsversionA<$segmentsversionB) {
					$ret = true;
				}
			} elseif (!is_array ($segmentsversionA) ) {
				if ($segmentsversionA<$segmentsversionB[0]) {
					$ret = true;
				}
			} elseif (!is_array ($segmentsversionB) ) {
				if ($segmentsversionA[0]<$segmentsversionB) {
					$ret = true;
				}
			} else {
				$max = sizeof ($segmentsversionA);
				for ($x = 0; $x< $max; $x++) {
					if (isset ($segmentsversionB[$x]) ) {
						if ($segmentsversionA[$x]<$segmentsversionB[$x]) {
							$ret = true;
							break;
						}
					}
				}
				if (sizeof ($segmentsversionB)>$max) {
					$ret = true;
				}
			}
			return $ret;

		}

		/**
		* OPN_VersionsControllSystem::IsFileversionNewer()
		*
		* Returns true if the fileversion newer as the stored version
		*
		* @return bool
		*/

		function IsFileversionNewer () {
			return $this->_higherversion ($this->_fileversion, $this->_filevars['fileversion']);

		}

		/**
		* OPN_VersionsControllSystem::IsDBversionNewer()
		*
		* Returns true if the dbversion newer as the stored version
		*
		* @return bool
		*/

		function IsDBversionNewer () {
			return $this->_higherversion ($this->_dbversion, $this->_filevars['dbversion']);

		}

		/**
		* OPN_VersionsControllSystem::IsProgversionNewer()
		*
		* Returns true if the progversion newer as the stored version
		*
		* @return bool
		*/

		function IsProgversionNewer () {
			return $this->_higherversion ($this->_progversion, $this->_filevars['version']);

		}

		/**
		* OPN_VersionsControllSystem::IsAnyVersionNewer()
		*
		* Return true if any of the 3 versions is newer as the stored versions
		*
		* @return bool
		*/

		function IsAnyVersionNewer () {
			if ( ($this->IsProgversionNewer () ) || ($this->IsFileversionNewer () ) || ($this->IsDBversionNewer () ) ) {
				return true;
			}
			return false;

		}

		/**
		* OPN_VersionsControllSystem::ReadVersionFile()
		*
		* Read the moduleversionfile and sets the properties for an update or insert
		*
		*/

		function ReadVersionFile () {

			$module = explode ('/', $this->_modulename);
			$module = $module[1];
			if (file_exists (_OPN_ROOT_PATH . $this->_modulename . '/plugin/version/index.php') ) {
				include_once (_OPN_ROOT_PATH . $this->_modulename . '/plugin/version/index.php');
				$myfunc = $module . '_getversion';
				$help = array ();
				$myfunc ($help);
				$this->SetFileversion ($help['fileversion']);
				$this->SetDBversion ($help['dbversion']);
				$this->SetProgversion ($help['version']);
			}

		}

		/**
		* OPN_VersionsControllSystem::ReadVersionFileIntoArray()
		*
		* Read the moduleversionfile into a private array
		*
		*/

		function ReadVersionFileIntoArray () {

			$module = explode ('/', $this->_modulename);
			$module = $module[1];
			if (file_exists (_OPN_ROOT_PATH . $this->_modulename . '/plugin/version/index.php') ) {
				include_once (_OPN_ROOT_PATH . $this->_modulename . '/plugin/version/index.php');
				$myfunc = $module . '_getversion';
				$this->_filevars = array ();
				$myfunc ($this->_filevars);
				if (!isset ($this->_filevars['dbversion']) ) {
					$this->_filevars['dbversion'] = '';
				}
			}

		}

		/**
		* OPN_VersionsControllSystem::GetDBVersionFromArray()
		*
		* Return the dbversion property from the ReadVersionFileIntoArray
		*
		* @return string
		*/

		function GetDBVersionFromArray () {
			return $this->_filevars['dbversion'];

		}

		/**
		* OPN_VersionsControllSystem::GetFileVersionFromArray()
		*
		* Return the fileversion property from the ReadVersionFileIntoArray
		*
		* @return string
		*/

		function GetFileVersionFromArray () {
			return $this->_filevars['fileversion'];

		}

		/**
		* OPN_VersionsControllSystem::GetProgNameFromArray()
		*
		* Return the progname property from the ReadVersionFileIntoArray
		*
		* @return string
		*/

		function GetProgNameFromArray () {
			return $this->_filevars['prog'];

		}

		/**
		* OPN_VersionsControllSystem::GetVersionFromArray()
		*
		* Return the version property from the ReadVersionFileIntoArray
		*
		* @return string
		*/

		function GetVersionFromArray () {
			return $this->_filevars['version'];

		}

		/**
		* OPN_VersionsControllSystem::GetAdditionalInfoFromArray()
		*
		* Return the addtional infomations from the ReadVersionFileIntoArray
		*
		* @return array
		*/

		function GetAdditionalInfoFromArray () {

			foreach ($this->_filevars as $temp => $value) {
				if ( ($temp != 'prog') && ($temp != 'version') && ($temp != 'dbversion') && ($temp != 'fileversion') ) {
					$ret[$temp] = $value;
				}
			}
			return $ret;

		}

		function echoBool ($thevalue) {
			if ($thevalue === FALSE) {
				return 'FALSE';
			}
			if ($thevalue === TRUE) {
				return 'TRUE';
			}
			return 'unknown value - should never happen';

		}

		function CheckDBField ($table, $fieldname, $checkfunc = '', $origmodulefields = '', $origdbfields = '') {

			global $opnConfig;

			$t = $checkfunc;
			if (substr ($fieldname, 0, 3) != '___') {
				if (!isset ($opnConfig['opn_expert_autorepair']) ) {
					$opnConfig['opn_expert_autorepair'] = 0;
				}
				$module = explode ('/', $this->_modulename);
				$module = $module[1];
				if ($origmodulefields == '') {
					include_once (_OPN_ROOT_PATH . $this->_modulename . '/plugin/sql/index.php');

					$myfunc = $module . '_repair_sql_table';
					if (function_exists ($myfunc) ) {
						$opnConfig['return_tableinfo_as_array'] = TRUE;
						$modulefields = $myfunc ();
						$modulefields = $modulefields['table'][$table];
					}
				} else {
					$modulefields = $origmodulefields[$fieldname];
				}
				if ($origdbfields == '') {
					$dbfields = $opnConfig['database']->MetaColumns ($opnConfig['tableprefix'] . $table);
				} else {
					$dbfields = $origdbfields;
				}
				if ($modulefields->name == '') {
					$modulefields->name = strtolower ($fieldname);
				}
				if (isset ($dbfields[strtolower ($fieldname)]) ) {
					$dbfields = $dbfields[strtolower ($fieldname)];
					$errors = $opnConfig['opnSQL']->CheckDBField ($dbfields, $modulefields);
					if (is_array ($errors) ) {
						$opnConfig['return_tableinfo_as_array'] = FALSE;
						$thefunc = $module . '_repair_sql_table';
						$arr = $thefunc ();
						$opnConfig['return_tableinfo_as_array'] = TRUE;
						$repairsql = 'ALTER TABLE ' . $opnConfig['tableprefix'] . $table . ' CHANGE ' . $fieldname . ' ' . $fieldname . ' ' . $arr['table'][$table][$fieldname];
						if ($opnConfig['opn_expert_autorepair'] == 1) {
							$opnConfig['database']->Execute ($repairsql);
						}
						$this->SetRepairSql ($repairsql);
						$message = sprintf (_VCSLOG_FIELDERROR, $fieldname, $opnConfig['tableprefix'] . $table) . _OPN_HTML_NL;
						foreach ($errors as $errordetails) {
							switch ($errordetails) {
								case _OPNSQL_FIELDERRORNAME:
									// trustudio_magic: ignore_warning
									$message .= '--&gt;&nbsp;' . sprintf (_VCSLOG_WRONGFIELDNAME, $dbfields->name, $modulefields->name) . _OPN_HTML_NL;
									break;
								case _OPNSQL_FIELDERRORLENGTH:
									// trustudio_magic: ignore_warning
									$message .= '--&gt;&nbsp;' . sprintf (_VCSLOG_WRONGFIELDLENGHT, $dbfields->max_length, $modulefields->max_length) . _OPN_HTML_NL;
									break;
								case _OPNSQL_FIELDERRORTYPE:
									// trustudio_magic: ignore_warning
									$message .= '--&gt;&nbsp;' . sprintf (_VCSLOG_WRONGFIELDTYPE, $dbfields->type, $modulefields->type) . _OPN_HTML_NL;
									break;
								case _OPNSQL_FIELDERRORNOTNULL:
									// trustudio_magic: ignore_warning
									$message .= '--&gt;&nbsp;' . sprintf (_VCSLOG_WRONGFIELDNULL, $dbfields->not_null, $modulefields->not_null) . _OPN_HTML_NL;
									break;
								case _OPNSQL_FIELDERRORHASDEFAULT:
									// trustudio_magic: ignore_warning
									$message .= '--&gt;&nbsp;' . sprintf (_VCSLOG_WRONGFIELDHASDEFAULT, $this->echoBool ($dbfields->has_default), $this->echoBool ($modulefields->has_default) ) . _OPN_HTML_NL;
									break;
								case _OPNSQL_FIELDERRORSCALE:
									// trustudio_magic: ignore_warning
									$message .= '--&gt;&nbsp;' . sprintf (_VCSLOG_WRONGFIELDSCALE, $dbfields->scale, $modulefields->scale) . _OPN_HTML_NL;
									break;
							}
							// switch
						}
						$this->SetErrorMsg ($message . '<br />');
					}
				} else {
					$opnConfig['return_tableinfo_as_array'] = FALSE;
					$thefunc = $module . '_repair_sql_table';
					$arr = $thefunc ();
					$opnConfig['return_tableinfo_as_array'] = TRUE;
					if ($opnConfig['opnSQL']->CanAddRepairField) {
						$repairsql = 'AddRepairField (\'' . $this->_modulename . '\', \'' . $table . '\', \'' . $modulefields->name . '\')';
						if ($opnConfig['opn_expert_autorepair'] == 1) {
							$opnConfig['opnSQL']->AddRepairField ($this->_modulename, $table, $modulefields->name);
						}
						$this->SetRepairSql ($repairsql);
					} elseif ($opnConfig['opnSQL']->CanAlterColumnAdd) {
						$repairsql = 'ALTER TABLE ' . $opnConfig['tableprefix'] . $table . ' ADD ' . $fieldname . ' ' . $arr['table'][$table][$fieldname];
						$this->SetRepairSql ($repairsql);
						if ($opnConfig['opn_expert_autorepair'] == 1) {
							$opnConfig['database']->Execute ($repairsql);
						}
					} elseif ($opnConfig['opnSQL']->CanExecuteColumnAdd) {
						// $repairsql = 'alter table '.$opnConfig['tableprefix'] . $table.' CHANGE '.$fieldname.' '.$fieldname.' '.$arr['table'][$table][$fieldname];
						// $this->SetRepairSql ($repairsql);
					}
					$message = sprintf (_VCSLOG_NOFIELDINDB, $fieldname, $opnConfig['tableprefix'] . $table) . _OPN_HTML_NL;
					$this->SetErrorMsg ($message . '<br />');
				}
			}

		}

		function CheckTable ($table) {

			global $opnConfig;

			include_once (_OPN_ROOT_PATH . $this->_modulename . '/plugin/sql/index.php');
			$module = explode ('/', $this->_modulename);
			$myfunc = $module[1] . '_repair_sql_table';
			if (function_exists ($myfunc) ) {
				$opnConfig['return_tableinfo_as_array'] = TRUE;
				$modulefields = $myfunc ();
				$modulefields = $modulefields['table'][$table];
				$dbfields = $opnConfig['database']->MetaColumns ($opnConfig['tableprefix'] . $table);
				$temparr = array_keys ($modulefields);
				foreach ($temparr as $fieldname) {
					$this->CheckDBField ($table, $fieldname, $myfunc, $modulefields, $dbfields);
				}
				unset ($opnConfig['return_tableinfo_as_array']);
			} else {
				$message = _VCSLOG_NOSQL . _OPN_HTML_NL;
				$message .= _VCSLOG_MODULE . $this->_modulename . _OPN_HTML_NL;
				$this->SetErrorMsg ($message);
			}

		}

		function CheckModuleSQL () {

			global $opnConfig;
			if (isset ($opnConfig['opn_expert_autorepair']) ) {
				$save = $opnConfig['opn_expert_autorepair'];
			}
			$file = _OPN_ROOT_PATH . $this->_modulename . '/plugin/sql/index.php';
			if (file_exists ($file) ) {
				include_once ($file);
				$module = explode ('/', $this->_modulename);
				$myfunc = $module[1] . '_repair_sql_table';
				$opnConfig['opn_expert_autorepair'] = 0;
				if (function_exists ($myfunc) ) {
					$opnConfig['return_tableinfo_as_array'] = TRUE;
					$modulefields = $myfunc ();
					$temparr1 = array_keys ($modulefields['table']);
					foreach ($temparr1 as $table) {
						$this->CheckTable ($table);
					}
					unset ($opnConfig['return_tableinfo_as_array']);
				} else {
					$message = _VCSLOG_NOSQL . _OPN_HTML_NL;
					$message .= _VCSLOG_MODULE . $this->_modulename . _OPN_HTML_NL;
					$this->SetErrorMsg ($message);
				}
			}
			if (isset ($save) ) {
				$opnConfig['opn_expert_autorepair'] = $save;
			}

		}

		function _debug_echo ($txt) {
			if ( ($this->_debug == 1) && ($txt != '') ) {
				echo '<br /><br />';
				echo '<hr>' . $txt . '<hr>';
				echo '<br /><br />';

				$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler;
				$eh->write_error_log ($txt);
				unset ($eh);

			}

		}

		function dbupdate_field () {

			global $opnTables, $opnConfig;

			$dat = func_get_args ();
			$code = '';
			if (substr_count (func_get_arg(1), '***')>0) {
				$hlp = str_replace ('***', '', $dat[1]);

				$shared_opn_class = $opnConfig['opnSQL']->qstr ($hlp);
				$sql = 'SELECT module, options FROM ' . $opnTables['opn_class_register']. ' WHERE (shared_opn_class='.$shared_opn_class.')';
				$info = &$opnConfig['database']->Execute ($sql);
				while (! $info->EOF) {
					$myoptions = unserialize ($info->fields['options']);
					if (isset($myoptions['field'])) {
						$myfield = $myoptions['field'];
						$code .= '$this->dbupdate_field ("' . $dat[0] . '","' . $info->fields['module'] . '","'.$myfield . $dat[2].'"';
						$countdat = count ($dat);
						for ($x = 3; $x<$countdat; $x++) {
							if ($dat[$x] === '') {
								$code .= ', ""';
							} else {
								if (is_string ($dat[$x])) {
									$code .= ',"' . $dat[$x] . '"';
								} else {
									$code .= ',' . $dat[$x];
								}
							}
						}
						$code .= ');' . _OPN_HTML_NL;
					}
					$info->MoveNext ();
				}
				$info->Close ();
				$this->_debug_echo ($code);

			} elseif (func_get_arg(0) == 'add') {
				if ($opnConfig['opnSQL']->CanAddRepairField) {
					$code = '$opnConfig[\'opnSQL\']->AddRepairField  (\'' . func_get_arg (1) . '\', \'' . func_get_arg (2) . '\', \'' . func_get_arg (3) . '\');';
				} elseif ($opnConfig['opnSQL']->CanAlterColumnAdd) {
					$code = '$opnConfig[\'database\']->Execute(\'alter table ' . $opnTables[func_get_arg (2)] . ' add ' . func_get_arg (3) . ' \'.$opnConfig[\'opnSQL\']->GetDBType(';
					$code .= $dat[4];
					$countdat = count ($dat);
					for ($x = 5; $x<$countdat; $x++) {
						if ($dat[$x] === '') {
							$code .= ', ""';
						} else {
							$code .= ',' . $dat[$x];
						}
					}
					$code .= '));';
				} elseif ($opnConfig['opnSQL']->CanExecuteColumnAdd) {
					$code = '$opnConfig[\'opnSQL\']->ExecuteColumnAdd (\'' . func_get_arg (2) . '\', \'' . func_get_arg (3) . '\'';
					$countdat = count ($dat);
					for ($x = 4; $x<$countdat; $x++) {
						if ($dat[$x] === '') {
							$code .= ', ""';
						} else {
							$code .= ',' . $dat[$x];
						}
					}
					$code .= ');';
				}
			} elseif (func_get_arg(0) == 'alter') {
				if ($opnConfig['opnSQL']->CanChangeRepairField) {
					$code = '$opnConfig[\'opnSQL\']->ChangeRepairField  (\'' . func_get_arg (1) . '\', \'' . func_get_arg (2) . '\', \'' . func_get_arg (3) . '\');';
				} elseif ($opnConfig['opnSQL']->CanAlterColumnChange) {
					$code = '$opnConfig[\'database\']->Execute(\'alter table ' . $opnTables[func_get_arg (2)] . ' change ' . func_get_arg (3) . ' ' . func_get_arg (3) . ' \'.$opnConfig[\'opnSQL\']->GetDBType(';
					$code .= $dat[4];
					$countdat = count ($dat);
					for ($x = 5; $x<$countdat; $x++) {
						if ($dat[$x] === '') {
							$code .= ', ""';
						} else {
							$code .= ',' . $dat[$x];
						}
					}
					$code .= '));';
				} elseif ($opnConfig['opnSQL']->CanExecuteColumnChange) {
					$code = '$opnConfig[\'opnSQL\']->ExecuteColumnChange (\'' . func_get_arg (2) . '\', \'' . func_get_arg (3) . '\'';
					$countdat = count ($dat);
					for ($x = 4; $x<$countdat; $x++) {
						if ($dat[$x] === '') {
							$code .= ', ""';
						} else {
							$code .= ',' . $dat[$x];
						}
					}
					$code .= ');';
				}
			} elseif (func_get_arg(0) == 'rename') {
				$code = '$opnConfig[\'opnSQL\']->ChangeFieldname (\'' . func_get_arg (1) . '\', \'' . func_get_arg (2) . '\', \'' . func_get_arg (3) . '\', \'' . func_get_arg (4) . '\'';
				$countdat = count ($dat);
				for ($x = 5, $max = $countdat; $x< $max; $x++) {
					if ($dat[$x] === '') {
						$code .= ', ""';
					} else {
						$code .= ',' . $dat[$x];
					}
				}
				$code .= ');';
			}
			$this->_debug_echo ($code);
			ob_start ();
			eval ($code);
			$rt = ob_get_contents ();
			ob_end_clean ();
			$this->_debug_echo ($rt);

		}

		function dbupdate_tablerename () {

			global $opnConfig;

			$p1 = func_get_arg (0);
			$p2 = func_get_arg (1);
			$p3 = func_get_arg (2);
			$opnConfig['opnSQL']->ChangeTablename ($p1, $p2, $p3);

		}

		function dbupdate_tablecreate () {

			global $opnConfig;

			$p1 = func_get_arg (0);
			$p2 = func_get_arg (1);
			$opnConfig['opnSQL']->CreateTable ($p1, $p2);

		}

		function dbupdate_tabledrop () {

			global $opnConfig;

			$p1 = func_get_arg (0);
			$p2 = func_get_arg (1);
			$opnConfig['opnSQL']->DropTableDB ($p1, $p2);

		}

		function dbupdate_masstablerename () {

			global $opnConfig;

			$result = $opnConfig['database']->MetaTables ();
			$module = func_get_arg (0);
			$oldname = func_get_arg (1);
			$newname = func_get_arg (2);
			$len = strlen ($opnConfig['tableprefix']);
			foreach ($result as $var) {
				if (substr_count ($var, $oldname)>0) {
					$hlp = str_replace ($oldname, $newname, $var);
					$var1 = substr ($var, $len);
					$hlp = substr ($hlp, $len);
					$opnConfig['opnSQL']->ChangeTablename ($module, $var1, $hlp);
				}
			}
			unset ($result);
			unset ($hlp);

		}

		function UpdateModule (&$info, $modulename) {

			$info['vcs_dbversion'] = '';
			$info['vcs_fileversion'] = '';
			$info['actual_dbversion'] = '';
			$info['actual_fileversion'] = '';
			$info['whathasbeendone'] = '';
			$info['status'] = 0;
			$this->SetModulename ($modulename['plugin']);
			$info['vcs_dbversion'] = $this->GetDBversion ();
			$info['vcs_fileversion'] = $this->GetFileversion ();
			$this->ReadVersionFileIntoArray ();
			// $info['actual_dbversion'] = $this->GetDBVersionFromArray();
			// $info['actual_fileversion'] = $this->GetFileVersionFromArray();
			// $info['vcs_dbversion'] = $this->GetDBversion();
			if ($this->IsDBversionNewer () ) {
				$info['actual_dbversion'] = $this->GetDBVersionFromArray ();
				$info['whathasbeendone'] = 'DB UPDATE.';
				$help = array ();
				if (file_exists (_OPN_ROOT_PATH . $modulename['plugin'] . '/plugin/repair/updates.php') ) {
					include_once (_OPN_ROOT_PATH . $modulename['plugin'] . '/plugin/repair/updates.php');
					$myfunc = $modulename['module'] . '_updates_ini';
					$myfunc ($help);
				}
				if ( (substr_count ($info['vcs_dbversion'], '.')>0) && ($info['vcs_dbversion'] != '') ) {
					$key = opn_array_search ($info['vcs_dbversion'], $help);
				} else {
					if ( ($info['vcs_dbversion'] == '') || ($info['vcs_dbversion'] == '1') ) {
						$key = 0;
						if (isset ($help[$key+1]) ) {
							$first = true;
						}
						$help[$key+1] = '1.0';
					} else {
						$key = opn_array_search ($info['vcs_dbversion'] . '.0', $help);
					}
				}
				if ( ($key !== FALSE) && ($key !== NULL) ) {
					$info['whathasbeendone'] .= ' VersionP: ' . $key . ' ';
					if (isset ($help[$key+1]) ) {
						$splity = explode ('.', $help[$key+1]);
						$myfunc = $modulename['module'] . '_updates_data_' . $splity[0] . '_' . $splity[1];
						$info['whathasbeendone'] .= $myfunc;
						if (function_exists ($myfunc) ) {
							$myfunc ($this);
							if ( (!isset ($help[$key+2]) ) && (!isset ($first) ) ) {
								$this->CheckModuleSQL ();
								$info['whathasbeendone'] .= '<br /> ' . $modulename['plugin'] . ' --&gt; done';
							} else {
								$info['whathasbeendone'] .= '<br /> ' . $modulename['plugin'] . ' set to version ' . $help[$key+1];
							}
							$this->SetDBversion ($help[$key+1]);
							$this->UpdateVersion ();
						}
					}
				}
				$info['status'] = 1;
				unset ($first);
			} elseif ( ($this->IsAnyVersionNewer () ) || (! (substr_count ($info['vcs_dbversion'], '.')>0) ) ) {
				$info['actual_fileversion'] = $this->GetFileVersionFromArray ();
				$this->CheckModuleSQL ();
				$this->ReadVersionFile ();
				$this->UpdateVersion ();
				$info['whathasbeendone'] = 'FILE UPDATE';
				$info['status'] = 2;
			} else {
				$info['whathasbeendone'] = 'SAME VERSION';
			}

		}

	}
}

?>