<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_OPNSESSION_INCLUDED') ) {
	define ('_OPN_CLASS_OPNSESSION_INCLUDED', 1);
	define ('_OPN_OPNSESSION_USER_UID', 0);
	define ('_OPN_OPNSESSION_USER_UNAME', 1);
	define ('_OPN_OPNSESSION_USER_PASS', 2);
	define ('_OPN_OPNSESSION_USER_THEME', 3);
	define ('_OPN_OPNSESSION_USER_THEME_GROUP', 4);
	define ('_OPN_OPNSESSION_USER_LANG', 5);

	class opnsession {

		/*<{php4}>
		var $_class_data = array(	'error'			=> '',
		'domain' => '', 'domain' => '', 'sessionid' => '', 'cookie' => '', 'uid' => '', 'uname' => '', 'user' => '');
		<{php4/}>*/

		/*<{php5}>
		public $_class_data = array(	'error'			=> '',
		'domain' => '', 'domain' => '', 'sessionid' => '', 'cookie' => '', 'uid' => '', 'uname' => '', 'user' => '');
		<{php5/}>*/

		/*<{delete}>*/
		var $_class_data = array(	'error'			=> '',
		'domain' => '', 'domain' => '', 'sessionid' => '', 'cookie' => '', 'uid' => '', 'uname' => '', 'user' => '');
		/*<{delete/}>*/

		function _insert ($k, $v) {

			$this->_class_data[strtolower ($k)] = $v;

		}

		function property ($p = null) {
			if ($p == null) {
				return $this->_class_data;
			}
			return $this->_class_data[strtolower ($p)];

		}
		// Init

		function opnsession () {

			global $opnConfig, $opnTables, ${$opnConfig['opn_server_vars']};

			$opnConfig['sessioncookie'] = 'opnsession';
			if (!isset ($opnConfig['isBackend']) ) {
				$sessionid = '';
				get_var ($opnConfig['sessioncookie'], $sessionid, 'cookie');
				// echo $sessionid.' |-| ';
				$this->_init_check_sec ($sessionid);
			} else {
				$sessionid = '';
			}
			$HTTP_HOST = '';
			get_var ('HTTP_HOST', $HTTP_HOST, 'server');
			$this->_insert ('cookie', $opnConfig['sessioncookie']);
			$this->_insert ('expiretime', (int) $opnConfig['sessionexpire']);
			$this->_insert ('expiretime_bonus', (int) $opnConfig['sessionexpire_bonus']);

			/* maybe removed later - just because if you not have not all settings */
			if (!isset ($opnConfig['opn_cookie_domainname']) ) {
				$opnConfig['opn_cookie_domainname'] = 0;
			}

			/* end of remove later */

			$temp = parse_url ($opnConfig['opn_url']);
			$dummy = explode ('.', $temp['host']);
			$dummymax = count ($dummy);
			if ( (strtolower ($HTTP_HOST) != 'localhost') && (substr ($HTTP_HOST, 0, 6) != '127.0.') ) {
				switch ($opnConfig['opn_cookie_domainname']) {
					case 0:
						$this->_insert ('domain', $dummy[$dummymax-2] . '.' . $dummy[$dummymax-1]);
						break;
					case 1:
						$this->_insert ('domain', $temp['host']);
						break;

					/*				case 2:
					$this->_insert('domain' ,$dummy[$dummymax-2]);
					break;*/
				}
				// switch
			} else {
				$this->_insert ('domain', '');
			}
			$this->_insert ('user', '');
			if ($sessionid != '') {
				$this->_insert ('sessionid', $sessionid);
				$_sessionid = $opnConfig['opnSQL']->qstr ($sessionid);
				$result = &$opnConfig['database']->Execute ('SELECT user1 FROM ' . $opnTables['opn_opnsession'] . ' WHERE session=' . $_sessionid);
				if ($result !== false) {
					$numrows = $result->RecordCount ();
					if ($numrows == 1) {
						$this->_insert ('user', $result->fields['user1']);
					} else {
						$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_opnsession'] . " WHERE session='" . $this->property ('sessionid') . "'");
						$this->savenewsession ('');
					}
				}
			} else {
				$this->savenewsession ('');
			}
			$this->init_session ();

		}

		function savenewsession ($user) {

			global $opnConfig, $opnTables;
			if (!isset ($opnConfig['isBackend']) ) {
				$ip = get_real_IP ();
				$this->_insert ('user', $user);
				$this->setopncookie ($this->property ('cookie'), $this->property ('sessionid'), time ()-3600);
				if (isset ($opnTables['opn_opnsession']) ) {
					if ($this->property ('sessionid') != '') {
						$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_opnsession'] . " WHERE session='" . $this->property ('sessionid') . "'");
					}
					if ( (isset ($opnConfig['opn_safetyadjustment']) ) && ($opnConfig['opn_safetyadjustment'] == 1) ) {
						$result = &$opnConfig['database']->Execute ('SELECT ip FROM ' . $opnTables['opn_opnsession'] . " WHERE ip='$ip'");
						if ($result !== false) {
							$numrows = $result->RecordCount ();
							if ($numrows != 1) {
								$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_opnsession'] . " WHERE ip='$ip'");
							}
						}
					}
					$this->_insert ('sessionid', $this->makeSessionID () );
					$sessionid = $opnConfig['opnSQL']->qstr ($this->property ('sessionid') );
					$user1 = $opnConfig['opnSQL']->qstr ($user, 'user1');
					$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['opn_opnsession'] . " (session, uid, time1, ip, user1) VALUES ($sessionid, '" . $this->property ('uid') . "', '" . time () . "', '$ip', $user1)");
					$opnConfig['opnSQL']->UpdateBlobs ($opnTables['opn_opnsession'], "session=$sessionid");
				}
				$this->setopncookie ($this->property ('cookie'), $this->property ('sessionid'), time ()+ $this->property ('expiretime')+ $this->property ('expiretime_bonus') );
			}

		}

		function updatesession ($user) {

			global $opnConfig, $opnTables;
			if (!isset ($opnConfig['isBackend']) ) {
				$mintime = time ()- $this->property ('expiretime');
				$ip = get_real_IP ();
				$this->_insert ('user', $user);
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_opnsession'] . " WHERE time1 < $mintime");
				$sessionid = $opnConfig['opnSQL']->qstr ($this->property ('sessionid') );
				$user1 = $opnConfig['opnSQL']->qstr ($user, 'user1');
				$opnConfig['database']->Execute ('UPDATE ' . $opnTables['opn_opnsession'] . " SET time1='" . time () . "', ip='$ip', user1=$user1 WHERE session=$sessionid");
				$opnConfig['opnSQL']->UpdateBlobs ($opnTables['opn_opnsession'], 'session=' . $sessionid);
			}

		}

		function checksession (&$user) {

			global $opnConfig, $opnTables;
			if (!isset ($opnConfig['isBackend']) ) {
				$this->updatesession ($user);
				$result = &$opnConfig['database']->Execute ('SELECT user1 FROM ' . $opnTables['opn_opnsession'] . " WHERE session='" . $this->property ('sessionid') . "'");
				if ($result !== false) {
					$numrows = $result->RecordCount ();
					if ($numrows == 1) {
						$user = $result->fields['user1'];
						$this->_insert ('user', $user);
						return true;
					}
					opn_reload_Header ('/index.php');
					die ();
				}
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_opnsession'] . " WHERE session='" . $this->property ('sessionid') . "'");
				$this->_insert ('user', '');
				$user = '';
				return false;
			}
			$user = '';
			return true;

		}

		function delsession (&$user) {

			global $opnConfig, $opnTables;

			$mintime = time ()- $this->property ('expiretime');
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_opnsession'] . ' WHERE time1 < ' . $mintime);
			if (!isset ($opnConfig['isBackend']) ) {
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_opnsession'] . " WHERE session='" . $this->property ('sessionid') . "'");
				$mytdummy = time ()-360000;
				setcookie ($this->property ('cookie'), $this->property ('sessionid'), $mytdummy, '/', '', 0);
			}
			$this->_insert ('user', '');
			$user = '';

		}

		function setuser ($v) {

			$this->_insert ('user', $v);

		}

		function getuser () {
			return $this->property ('user');

		}

		function makeSessionID () {

			global $opnConfig;

			mt_srand ((double)microtime ()*1000000);
			$loop = mt_rand (5, 50);
			for ($i = 1; $i<= $loop; $i++) {
				mt_srand ((double)microtime ()*1000000);
				$id = uniqid (mt_rand (), true);
			}
			unset ($loop);
			unset ($i);
			return rtrim (make_the_secret (md5 ($opnConfig['encoder']), md5 ($id) ), '=');

		}

		function makeRAND () {

			mt_srand ((double)microtime ()*1000000);
			$loop = mt_rand (5, 50);
			for ($i = 1; $i<= $loop; $i++) {
				mt_srand ((double)microtime ()*1000000);
				$id = uniqid (mt_rand (), true);
			}
			unset ($loop);
			unset ($i);
			return $id;

		}

		function setopncookie ($name, $wert, $zeit) {

			global $opnConfig;

			$zeit = (int) $zeit;
			if (!isset ($opnConfig['isBackend']) ) {
				setcookie ($name, $wert, $zeit, '/', ltrim ($this->property ('domain'), '.'), 0);
			}

		}
		// sets a session-variable

		function set_var ($varname, $varvalue) {

			global $opnConfig, ${$opnConfig['opn_session_vars']};
			if (isset ($varname) && isset ($varvalue) ) {
				if (phpversion () >= '4.1.0') {
					$_SESSION[$varname] = $varvalue;
					if (!isset ($GLOBALS[$varname]) ) {
						$GLOBALS[$varname] = $varvalue;
					}
				} else {
					session_register ($varname);
					$GLOBALS['HTTP_SESSION_VARS'][$varname] = $varvalue;
					if (!isset ($GLOBALS[$varname]) ) {
						$GLOBALS[$varname] = $varvalue;
					}
				}
			}

		}
		// returns the value of a certain session-variable

		function get_var ($varname) {
			if (!isset ($varname) ) {
				die ('Function getvar( String $varname ) expects a parameter!');
			}
			if (phpversion () >= '4.1.0') {
				if (isset ($GLOBALS[$varname]) ) {
					return $GLOBALS[$varname];
				}
				if (isset ($GLOBALS['_SESSION'][$varname]) ) {
					$GLOBALS[$varname] = $GLOBALS['_SESSION'][$varname];
					return $GLOBALS['_SESSION'][$varname];
				}
			} else {
				if (isset ($GLOBALS[$varname]) ) {
					return $GLOBALS[$varname];
				}
				if (isset ($GLOBALS['HTTP_SESSION_VARS'][$varname]) ) {
					$GLOBALS[$varname] = $GLOBALS['HTTP_SESSION_VARS'][$varname];
					return $GLOBALS['HTTP_SESSION_VARS'][$varname];
				}
			}
			return null;

		}

		function _init_check () {

			global $opnConfig, ${$opnConfig['opn_post_vars']}, ${$opnConfig['opn_get_vars']}, ${$opnConfig['opn_server_vars']}, ${$opnConfig['opn_file_vars']}, ${$opnConfig['opn_cookie_vars']}, ${$opnConfig['opn_session_vars']}, ${$opnConfig['opn_request_vars']}, ${$opnConfig['opn_env_vars']};

			$sname = session_name ();
			$test = ${$opnConfig['opn_get_vars']};
			if (isset ($test[$sname]) ) {
				$this->_init_check_sec ($test[$sname]);
			}
			$test = ${$opnConfig['opn_post_vars']};
			if (isset ($test[$sname]) ) {
				$this->_init_check_sec ($test[$sname]);
			}
			$test = ${$opnConfig['opn_cookie_vars']};
			if (isset ($test[$sname]) ) {
				$this->_init_check_sec ($test[$sname]);
			}
			$test = ${$opnConfig['opn_request_vars']};
			if (isset ($test[$sname]) ) {
				$this->_init_check_sec ($test[$sname]);
			}
			$test = ${$opnConfig['opn_file_vars']};
			if (isset ($test[$sname]) ) {
				$this->_init_check_sec ($test[$sname]);
			}
			$test = ${$opnConfig['opn_server_vars']};
			if (isset ($test[$sname]) ) {
				$this->_init_check_sec ($test[$sname]);
			}
			$test = ${$opnConfig['opn_env_vars']};
			if (isset ($test[$sname]) ) {
				$this->_init_check_sec ($test[$sname]);
			}
			$test = ${$opnConfig['opn_session_vars']};
			if (isset ($test[$sname]) ) {
				$this->_init_check_sec ($test[$sname]);
			}

		}

		function _stop_for_hack ($msg) {
			global $opnTables, $opnConfig, ${$opnConfig['opn_server_vars']};

			getLanguageDef (_OPN_ROOT_PATH . 'admin/openphpnuke/language/');
			$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler ();
			$message = 'Hack try!!!';

			$opn_server_vars = ${$opnConfig['opn_server_vars']};
			$docroot = $opn_server_vars['SERVER_NAME'];
			$today = getdate ();
			$month = $today['mon'];
			$mday = $today['mday'];
			$year = $today['year'];
			$hours = $today['hours'];
			$minutes = $today['minutes'];
			$errortime = $mday . '/' . $month . '/' . $year . ' at ' . $hours . ':' . $minutes;
			$message .= _OPN_HTML_NL._OPN_HTML_NL;
			$ip = get_real_IP ();
			$message .= sprintf (_OPN_ERRORS_TRIGGERED1, $ip, $errortime) . _OPN_HTML_NL;
			$message .= ' ' . _OPN_HTML_NL;
			if (isset ($opn_server_vars['REQUEST_URI']) ) {
				$message .= _OPN_ERRORS_ERRORURI . _OPN_HTML_NL . $docroot . $opn_server_vars['REQUEST_URI'] . _OPN_HTML_NL;
			}
			$message .= ' ' . _OPN_HTML_NL;
			if (isset ($opn_server_vars['HTTP_REFERER']) ) {
				$message .= _OPN_ERRORS_ERRORPAGECALLED . _OPN_HTML_NL . $opn_server_vars['HTTP_REFERER'] . _OPN_HTML_NL;
			}
			$message .= _OPN_HTML_NL . _OPN_HTML_NL;
			$message .= _OPN_ERRORS_ADDITIONALINFOS . _OPN_HTML_NL;
			$message .= _OPN_HTML_NL;
			if (isset ($opn_server_vars['HTTP_USER_AGENT']) ) {
				$message .= 'Browser		  : ' . $opn_server_vars['HTTP_USER_AGENT'] . _OPN_HTML_NL;
			}
			if (isset ($opn_server_vars['REMOTE_PORT']) ) {
				$message .= 'REMOTE_PORT	  : ' . $opn_server_vars['REMOTE_PORT'] . _OPN_HTML_NL;
			}
			if (isset ($opn_server_vars['REMOTE_HOST']) ) {
				$message .= 'REMOTE_HOST	  : ' . $opn_server_vars['REMOTE_HOST'] . _OPN_HTML_NL;
			}
			$message .= 'Remote_Name	  : ' . gethostbyaddr ($ip) . _OPN_HTML_NL;
			if (isset ($opn_server_vars['SERVER_PORT']) ) {
				$message .= 'SERVER_PORT	  : ' . $opn_server_vars['SERVER_PORT'] . _OPN_HTML_NL;
			}
			if (isset ($opn_server_vars['SERVER_PROTOCOL']) ) {
				$message .= 'SERVER_PROTOCOL  : ' . $opn_server_vars['SERVER_PROTOCOL'] . _OPN_HTML_NL;
			}
			if (isset ($opn_server_vars['SERVER_SOFTWARE']) ) {
					$message .= 'SERVER_SOFTWARE  : ' . $opn_server_vars['SERVER_SOFTWARE'] . _OPN_HTML_NL;
			}
			if (isset ($opn_server_vars['SERVER_NAME']) ) {
				$message .= 'SERVER_NAME	  : ' . $opn_server_vars['SERVER_NAME'] . _OPN_HTML_NL;
			}
			if (isset ($opn_server_vars['SERVER_ADDR']) ) {
				$message .= 'SERVER_ADDR	  : ' . $opn_server_vars['SERVER_ADDR'] . _OPN_HTML_NL;
			}
			$message .= _OPN_HTML_NL;
			$message .= $msg._OPN_HTML_NL;

			$ui = $opnConfig['permission']->GetUserinfo ();
			$message .= _OPN_HTML_NL . 'user information: UNAME:'.$ui['uname'].'UID:'.$ui['uid'];

			$eh->write_error_log ($message, 0, 'class.opnsession.php');
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_opnsession']);
			opn_reload_Header ('html/error_hack.html');
			die ();
		}

		function _init_check_sec ($seccheck) {
			if (is_array ($seccheck) ) {
				$seccheck = implode (',', $seccheck);
			}
			if ( (substr_count ($seccheck, 'http')>0) OR (substr_count ($seccheck, 'ftp')>0) OR (substr_count ($seccheck, '@')>0)  ) {
				$this->_stop_for_hack('');
			}

		}

		function init_session () {

			$this->_init_check ();
			if (!defined ('_OPN_SHELL_RUN') ) {
				session_start ();
			}

		}
		// returns a string like 'PHPSESSID=b188e8c9c45b347cdded2...'

		function get_sid_string () {
			return session_name () . '=' . session_id ();

		}
		// returns the session-id

		function get_sid () {
			return session_id ();

		}
		// unsets a certain session-variable

		function var_unset ($varname) {

			global $opnConfig, ${$opnConfig['opn_session_vars']};
			if (!isset ($varname) ) {
				die ('Function var_unset( String $varname ) expects a parameter!');
			}
			if (phpversion () >= '4.1.0') {
				if (isset ($GLOBALS[$varname]) ) {
					unset ($GLOBALS[$varname]);
				}
				if (isset ($GLOBALS['_SESSION'][$varname]) ) {
					unset ($GLOBALS['_SESSION'][$varname]);
				}
			} else {
				if (isset ($GLOBALS[$varname]) ) {
					unset ($GLOBALS[$varname]);
				}
				if (isset ($GLOBALS['HTTP_SESSION_VARS'][$varname]) ) {
					unset ($GLOBALS['HTTP_SESSION_VARS'][$varname]);
				}
			}

		}
		// unsets a certain session-variable

		function _unset ($varname) {

			global $opnConfig, ${$opnConfig['opn_session_vars']};
			if (!isset ($varname) ) {
				die ('Function var_unset( String $varname ) expects a parameter!');
			}
			if (phpversion () >= '4.1.0') {
				if (isset ($GLOBALS['_SESSION'][$varname]) ) {
					unset ($GLOBALS['_SESSION'][$varname]);
				}
			} else {
				if (isset ($GLOBALS['HTTP_SESSION_VARS'][$varname]) ) {
					unset ($GLOBALS['HTTP_SESSION_VARS'][$varname]);
				}
			}

		}
		// unsets the value of every session-variable

		function ses_unset_session () {

			global $opnConfig, ${$opnConfig['opn_session_vars']};
			if (isset (${$opnConfig['opn_session_vars']}) ) {
				$a = array_keys (${$opnConfig['opn_session_vars']});
				foreach ($a as $key) {
					$this->_unset ($key);
				}
			}

		}
		// unsets the value of every session-variable

		function ses_unset () {

			global $opnConfig, ${$opnConfig['opn_session_vars']};
			if (isset (${$opnConfig['opn_session_vars']}) ) {
				$a = array_keys (${$opnConfig['opn_session_vars']});
				foreach ($a as $key) {
					$this->var_unset ($key);
				}
			}

		}
		// deletes every session-variable and destroys the Session

		function destroy () {

			global $opnConfig, ${$opnConfig['opn_session_vars']};
			if (isset (${$opnConfig['opn_session_vars']}) ) {
				$this->ses_unset_session ();
				session_destroy ();
			}

		}
		// shows the variables currently set in the session

		function show () {

			global $opnConfig, ${$opnConfig['opn_session_vars']};

			$txt = 'Variables set in current session:';
			if ( (isset (${$opnConfig['opn_session_vars']}) ) && is_array (${$opnConfig['opn_session_vars']}) ) {
				$a = ${$opnConfig['opn_session_vars']};
				foreach ($a as $key => $value) {
					$txt .= 'variable: ' . $key . ' - Value: ' . $value . '<br />';
				}
			}
			return $txt;

		}

	}
}

?>