<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
* @package RSSBuilder
* @category FLP
*/

/**
* Abstract class for getting ini preferences
*
* Tested with WAMP (XP-SP1/1.3.24/4.0.12/4.3.0)
* Last change: 2003-05-30
*
* @desc Abstract class for the RSS classes
* @access protected
* @author Michael Wimmer <flaimo@gmx.net>
* @copyright Michael Wimmer
* @link http://www.flaimo.com/
//* @global array $GLOBALS['_TICKER_ini_settings']
* @abstract
* @package RSSBuilder
* @category FLP
* @version 1.001
*/

class RSSBase {

	/*-----------------------*/

	/* C O N S T R U C T O R */

	/*-----------------------*/

	/**
	* Constructor
	*
	* @desc Constructor
	* @return (void)
	* @access private
	*/

	function RSSBase () {

	}
	// end constructor

}
// end class RSSBase
// ---------------------------------------------------------------------------

/**
* Class for creating a RSS file
*
* Tested with WAMP (XP-SP1/1.3.24/4.0.12/4.3.0)
* Last change: 2003-05-30
*
* @desc Class for creating a RSS file
* @access public
* @author Michael Wimmer <flaimo@gmx.net>
* @copyright Michael Wimmer
* @link http://www.flaimo.com/
* @example rss_sample_script.php Sample script
* @package RSSBuilder
* @category FLP
* @version 1.001
*/

class RSSBuilder extends RSSBase {

	/*-------------------*/

	/* V A R I A B L E S */

	/*-------------------*/

	/**
	* encoding of the XML file
	*
	* @desc encoding of the XML file
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $encoding;
	<{php4/}>*/

	/*<{php5}>
	public $encoding;
	<{php5/}>*/

	/*<{delete}>*/
	var $encoding;
	/*<{delete/}>*/

	/**
	* URL WHERE the RSS document will be made available
	*
	* @desc URL WHERE the RSS document will be made available
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $about;
	<{php4/}>*/

	/*<{php5}>
	public $about;
	<{php5/}>*/

	/*<{delete}>*/
	var $about;
	/*<{delete/}>*/

	/**
	* title of the rss stream
	*
	* @desc title of the rss stream
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $title;
	<{php4/}>*/

	/*<{php5}>
	public $title;
	<{php5/}>*/

	/*<{delete}>*/
	var $title;
	/*<{delete/}>*/

	/**
	* description of the rss stream
	*
	* @desc description of the rss stream
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $description;
	<{php4/}>*/

	/*<{php5}>
	public $description;
	<{php5/}>*/

	/*<{delete}>*/
	var $description;
	/*<{delete/}>*/

	/**
	* publisher of the rss stream (person, an organization, or a service)
	*
	* @desc publisher of the rss stream
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $publisher;
	<{php4/}>*/

	/*<{php5}>
	public $publisher;
	<{php5/}>*/

	/*<{delete}>*/
	var $publisher;
	/*<{delete/}>*/

	/**
	* creator of the rss stream (person, an organization, or a service)
	*
	* @desc creator of the rss stream
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $creator;
	<{php4/}>*/

	/*<{php5}>
	public $creator;
	<{php5/}>*/

	/*<{delete}>*/
	var $creator;
	/*<{delete/}>*/

	/**
	* creation date of the file (format: 2003-05-29T00:03:07+0200)
	*
	* @desc creation date of the file (format: 2003-05-29T00:03:07+0200)
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $date;
	<{php4/}>*/

	/*<{php5}>
	public $date;
	<{php5/}>*/

	/*<{delete}>*/
	var $date;
	/*<{delete/}>*/

	/**
	* iso format language
	*
	* @desc iso format language
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $language;
	<{php4/}>*/

	/*<{php5}>
	public $language;
	<{php5/}>*/

	/*<{delete}>*/
	var $language;
	/*<{delete/}>*/

	/**
	* copyrights for the rss stream
	*
	* @desc copyrights for the rss stream
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $rights;
	<{php4/}>*/

	/*<{php5}>
	public $rights;
	<{php5/}>*/

	/*<{delete}>*/
	var $rights;
	/*<{delete/}>*/

	/**
	* URL to an small image
	*
	* @desc URL to an small image
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $image_link;
	<{php4/}>*/

	/*<{php5}>
	public $image_link;
	<{php5/}>*/

	/*<{delete}>*/
	var $image_link;
	/*<{delete/}>*/

	/**
	* spatial location (a place name or geographic coordinates), temporal period (a period label, date, or date range) or jurisdiction (such as a named administrative entity)
	*
	* @desc spatial location (a place name or geographic coordinates), temporal period (a period label, date, or date range) or jurisdiction (such as a named administrative entity)
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $coverage;
	<{php4/}>*/

	/*<{php5}>
	public $coverage;
	<{php5/}>*/

	/*<{delete}>*/
	var $coverage;
	/*<{delete/}>*/

	/**
	* person, an organization, or a service
	*
	* @desc person, an organization, or a service
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $contributor;
	<{php4/}>*/

	/*<{php5}>
	public $contributor;
	<{php5/}>*/

	/*<{delete}>*/
	var $contributor;
	/*<{delete/}>*/

	/**
	* 'hourly' | 'daily' | 'weekly' | 'monthly' | 'yearly'
	*
	* @desc 'hourly' | 'daily' | 'weekly' | 'monthly' | 'yearly'
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $period;
	<{php4/}>*/

	/*<{php5}>
	public $period;
	<{php5/}>*/

	/*<{delete}>*/
	var $period;
	/*<{delete/}>*/

	/**
	* every X hours/days/weeks/...
	*
	* @desc every X hours/days/weeks/...
	* @var int
	* @access private
	*/

	/*<{php4}>
	var $frequency;
	<{php4/}>*/

	/*<{php5}>
	public $frequency;
	<{php5/}>*/

	/*<{delete}>*/
	var $frequency;
	/*<{delete/}>*/

	/**
	* date (format: 2003-05-29T00:03:07+0200)
	*
	* Defines a base date to be used in concert with updatePeriod and
	* updateFrequency to calculate the publishing schedule.
	*
	* @desc base date to calculate from (format: 2003-05-29T00:03:07+0200)
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $base;
	<{php4/}>*/

	/*<{php5}>
	public $base;
	<{php5/}>*/

	/*<{delete}>*/
	var $base;
	/*<{delete/}>*/

	/**
	* category (rss 2.0)
	*
	* @desc category (rss 2.0)
	* @var string
	* @access private
	* @since 1.001 - 2003/05/30
	*/

	/*<{php4}>
	var $category;
	<{php4/}>*/

	/*<{php5}>
	public $category;
	<{php5/}>*/

	/*<{delete}>*/
	var $category;
	/*<{delete/}>*/

	/**
	* caching time in minutes (rss 2.0)
	*
	* @desc caching time in minutes (rss 2.0)
	* @var int
	* @access private
	* @since 1.001 - 2003/05/30
	*/

	/*<{php4}>
	var $cache;
	<{php4/}>*/

	/*<{php5}>
	public $cache;
	<{php5/}>*/

	/*<{delete}>*/
	var $cache;
	/*<{delete/}>*/

	/**
	* array wich all the rss items
	*
	* @desc array wich all the rss items
	* @var array
	* @access private
	*/

	/*<{php4}>
	var $items = array();
	<{php4/}>*/

	/*<{php5}>
	public $items = array();
	<{php5/}>*/

	/*<{delete}>*/
	var $items = array();
	/*<{delete/}>*/

	/**
	* compiled outputstring
	*
	* @desc compiled outputstring
	* @var string
	* @access private
	*/

	/*<{php4}>
	var $output;
	<{php4/}>*/

	/*<{php5}>
	public $output;
	<{php5/}>*/

	/*<{delete}>*/
	var $output;
	/*<{delete/}>*/

	/**
	* use DC data
	*
	* @desc use DC data
	* @var boolean
	* @access private
	*/

	/*<{php4}>
	var $use_dc_data = FALSE;
	<{php4/}>*/

	/*<{php5}>
	public $use_dc_data = FALSE;
	<{php5/}>*/

	/*<{delete}>*/
	var $use_dc_data = FALSE;
	/*<{delete/}>*/

	/**
	* use SY data
	*
	* @desc use SY data
	* @var boolean
	* @access private
	*/

	/*<{php4}>
	var $use_sy_data = FALSE;

	var $_version = '';

	var $_fromcharset = '';
	var $_tocharset = '';
	var $_converter = '';
	var $_trans_tbl = array();
	<{php4/}>*/

	/*<{php5}>
	public $use_sy_data = FALSE;

	public $_version = '';

	public $_fromcharset = '';
	public $_tocharset = '';
	public $_converter = '';
	public $_trans_tbl = array();
	<{php5/}>*/

	/*<{delete}>*/
	var $use_sy_data = FALSE;

	var $_version = '';

	var $_fromcharset = '';
	var $_tocharset = '';
	var $_converter = '';
	var $_trans_tbl = array();
	/*<{delete/}>*/

	/**
	* Constructor
	*
	* @desc Constructor
	* @param (string) $encoding  encoding of the xml file
	* @param (string) $about  URL WHERE the RSS document will be made available
	* @param (string) $title
	* @param (string) $description
	* @param (string) $image_link  URL
	* @return (void)
	* @uses setEncoding(), setAbout(), setTitle(), setDescription(), setImageLink(), setCategory(), setCache()
	* @access private
	*/

	function RSSBuilder ($encoding = '', $about = '', $title = '', $description = '', $image_link = '', $category = '', $cache = '') {

		$this->setEncoding ($encoding);
		$this->setAbout ($about);
		$this->setTitle ($title);
		$this->setDescription ($description);
		$this->setImageLink ($image_link);
		$this->setCategory ($category);
		$this->setCache ($cache);
		include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_convert_charset.php');
		$this->_convert =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ ConvertCharset;
		$this->_trans_tbl['ASCII'] = array ('&',
						'<',
						'>');
		$this->_trans_tbl['UNICODE'] = array ('&#x26;',
							'&#x3C;',
							'&#x3E;');

	}
	// end constructor

	/*-------------------*/

	/* F U N C T I O N S */

	/*-------------------*/

	/**
	* add additional DC data
	*
	* @desc add additional DC data
	* @param (string) $publisher person, an organization, or a service
	* @param (string) $creator person, an organization, or a service
	* @param (string) $date  format: 2003-05-29T00:03:07+0200
	* @param (string) $language  iso-format
	* @param (string) $rights  copyright information
	* @param (string) $coverage  spatial location (a place name or geographic coordinates), temporal period (a period label, date, or date range) or jurisdiction (such as a named administrative entity)
	* @param (string) $contributor  person, an organization, or a service
	* @return (void)
	* @uses setPublisher(), setCreator(), setDate(), setLanguage(), setRights(), setCoverage(), setContributor()
	* @access public
	*/

	function addDCdata ($publisher = '', $creator = '', $date = '', $language = '', $rights = '', $coverage = '', $contributor = '') {

		$this->setPublisher ($publisher);
		$this->setCreator ($creator);
		$this->setDate ($date);
		$this->setLanguage ($language);
		$this->setRights ($rights);
		$this->setCoverage ($coverage);
		$this->setContributor ($contributor);
		$this->use_dc_data = (boolean)TRUE;

	}
	// end function

	/**
	* add additional SY data
	*
	* @desc add additional DC data
	* @param (string) $period  'hourly' | 'daily' | 'weekly' | 'monthly' | 'yearly'
	* @param (int) $frequency  every x hours/days/weeks/...
	* @param (string) $base  format: 2003-05-29T00:03:07+0200
	* @return (void)
	* @uses setPeriod(), setFrequency(), setBase()
	* @access public
	*/

	function addSYdata ($period = '', $frequency = '', $base = '') {

		$this->setPeriod ($period);
		$this->setFrequency ($frequency);
		$this->setBase ($base);
		$this->use_sy_data = (boolean)TRUE;

	}
	// end function

	/**
	* Checks if a given string is a valid iso-language-code
	*
	* @desc Checks if a given string is a valid iso-language-code
	* @param (string) $code  String that should validated
	* @return (boolean) $isvalid  If string is valid or not
	* @access public
	* @static
	*/

	function isValidLanguageCode ($code = '') {
		return (boolean) ( (preg_match ('(^([a-zA-Z]{2})$)', $code)>0)?TRUE : FALSE);

	}
	// end function

	/**
	* Sets $encoding variable
	*
	* @desc Sets $encoding variable
	* @param (string) $encoding  encoding of the xml file
	* @return (void)
	* @access private
	* @see $encoding
	*/

	function setEncoding ($encoding = '') {
		if (!isset ($this->encoding) ) {
			$this->encoding = (string) ( (strlen (trim ($encoding) )>0)?trim ($encoding) : 'UTF-8');
		}
		// end if

	}
	// end function

	/**
	* Sets $about variable
	*
	* @desc Sets $about variable
	* @param (string) $about
	* @return (void)
	* @access private
	* @see $about
	*/

	function setAbout ($about = '') {
		if (!isset ($this->about) && strlen (trim ($about) )>0) {
			$this->about = (string)trim ($about);
		}
		// end if

	}
	// end function

	/**
	* Sets $title variable
	*
	* @desc Sets $title variable
	* @param (string) $title
	* @return (void)
	* @access private
	* @see $title
	*/

	function setTitle ($title = '') {
		if (!isset ($this->title) && strlen (trim ($title) )>0) {
			$this->title = (string)trim ($title);
		}
		// end if

	}
	// end function

	function setToCharset ($charset) {

		$this->_tocharset = $charset;

	}

	function setFromCharset ($charset) {

		$this->_fromcharset = $charset;

	}

	function ConvertToUTF ($text) {

		global $opnConfig;

		$opnConfig['cleantext']->un_htmlentities ($text);
		$text = str_replace ($this->_trans_tbl['ASCII'], $this->_trans_tbl['UNICODE'], $text);
		$text = $this->_convert->Convert ($text, $this->_fromcharset, 'utf-8', true);
		return $text;

	}

	/**
	* Sets $description variable
	*
	* @desc Sets $description variable
	* @param (string) $description
	* @return (void)
	* @access private
	* @see $description
	*/

	function setDescription ($description = '') {
		if (!isset ($this->description) && strlen (trim ($description) )>0) {
			$this->description = (string)trim ($description);
		}
		// end if

	}
	// end function

	/**
	* Sets $publisher variable
	*
	* @desc Sets $publisher variable
	* @param (string) $publisher
	* @return (void)
	* @access private
	* @see $publisher
	*/

	function setPublisher ($publisher = '') {
		if (!isset ($this->publisher) && strlen (trim ($publisher) )>0) {
			$this->publisher = (string)trim ($publisher);
		}
		// end if

	}
	// end function

	/**
	* Sets $creator variable
	*
	* @desc Sets $creator variable
	* @param (string) $creator
	* @return (void)
	* @access private
	* @see $creator
	*/

	function setCreator ($creator = '') {
		if (!isset ($this->creator) && strlen (trim ($creator) )>0) {
			$this->creator = (string)trim ($creator);
		}
		// end if

	}
	// end function

	/**
	* Sets $date variable
	*
	* @desc Sets $date variable
	* @param (string) $date  format: 2003-05-29T00:03:07+0200
	* @return (void)
	* @access private
	* @see $date
	*/

	function setDate ($date = 0) {
		if (!isset ($this->date) && $date) {
			$this->date = $date;
		}
		// end if

	}
	// end function

	/**
	* Sets $language variable
	*
	* @desc Sets $language variable
	* @param (string) $language
	* @return (void)
	* @access private
	* @see $language
	* @uses isValidLanguageCode()
	*/

	function setLanguage ($language = '') {
		if (!isset ($this->language) && $this->isValidLanguageCode ($language) === TRUE) {
			$this->language = (string)trim ($language);
		}
		// end if

	}
	// end function

	/**
	* Sets $rights variable
	*
	* @desc Sets $rights variable
	* @param (string) $rights
	* @return (void)
	* @access private
	* @see $rights
	*/

	function setRights ($rights = '') {
		if (!isset ($this->rights) && strlen (trim ($rights) )>0) {
			$this->rights = (string)trim ($rights);
		}
		// end if

	}
	// end function

	/**
	* Sets $coverage variable
	*
	* @desc Sets $coverage variable
	* @param (string) $coverage
	* @return (void)
	* @access private
	* @see $coverage
	*/

	function setCoverage ($coverage = '') {
		if (!isset ($this->coverage) && strlen (trim ($coverage) )>0) {
			$this->coverage = (string)trim ($coverage);
		}
		// end if

	}
	// end function

	/**
	* Sets $contributor variable
	*
	* @desc Sets $contributor variable
	* @param (string) $contributor
	* @return (void)
	* @access private
	* @see $contributor
	*/

	function setContributor ($contributor = '') {
		if (!isset ($this->contributor) && strlen (trim ($contributor) )>0) {
			$this->contributor = (string)trim ($contributor);
		}
		// end if

	}
	// end function

	/**
	* Sets $image_link variable
	*
	* @desc Sets $image_link variable
	* @param (string) $image_link
	* @return (void)
	* @access private
	* @see $image_link
	*/

	function setImageLink ($image_link = '') {
		if (!isset ($this->image_link) && strlen (trim ($image_link) )>0) {
			$this->image_link = (string)trim ($image_link);
		}
		// end if

	}
	// end function

	/**
	* Sets $period variable
	*
	* @desc Sets $period variable
	* @param (string) $period  'hourly' | 'daily' | 'weekly' | 'monthly' | 'yearly'
	* @return (void)
	* @access private
	* @see $period
	*/

	function setPeriod ($period = '') {
		if (!isset ($this->period) && strlen (trim ($period) )>0) {
			switch ($period) {
				case 'hourly':
				case 'daily':
				case 'weekly':
				case 'monthly':
				case 'yearly':
					$this->period = (string)trim ($period);
					break;
				default:
					$this->period = (string)'';
					break;
			}
			// end switch
		}
		// end if

	}
	// end function

	/**
	* Sets $frequency variable
	*
	* @desc Sets $frequency variable
	* @param (int) $frequency
	* @return (void)
	* @access private
	* @see $frequency
	*/

	function setFrequency ($frequency = '') {
		if (!isset ($this->frequency) && strlen (trim ($frequency) )>0) {
			$this->frequency = (int) $frequency;
		}
		// end if

	}
	// end function

	/**
	* Sets $base variable
	*
	* @desc Sets $base variable
	* @param (string) $base
	* @return (void)
	* @access private
	* @see $base
	*/

	function setBase ($base = '') {
		if (!isset ($this->base) && strlen (trim ($base) )>0) {
			$this->base = (string)trim ($base);
		}
		// end if

	}
	// end function

	/**
	* Sets $category variable
	*
	* @desc Sets $category variable
	* @param (string) $category
	* @return (void)
	* @access private
	* @see $category
	* @since 1.001 - 2003/05/30
	*/

	function setCategory ($category = '') {
		if (strlen (trim ($category) )>0) {
			$this->category = (string)trim ($category);
		}
		// end if

	}
	// end function

	/**
	* Sets $cache variable
	*
	* @desc Sets $cache variable
	* @param (int) $cache
	* @return (void)
	* @access private
	* @see $cache
	* @since 1.001 - 2003/05/30
	*/

	function setCache ($cache = '') {
		if (strlen (trim ($cache) )>0) {
			$this->cache = (int) $cache;
		}
		// end if

	}
	// end function

	/**
	* Returns $encoding variable
	*
	* @desc Returns $encoding variable
	* @return (string) $encoding
	* @access public
	* @see $image_link
	*/

	function getEncoding () {
		return (string) $this->encoding;

	}
	// end function

	/**
	* Returns $about variable
	*
	* @desc Returns $about variable
	* @return (string) $about
	* @access public
	* @see $about
	*/

	function getAbout () {
		return (string) $this->about;

	}
	// end function

	/**
	* Returns $title variable
	*
	* @desc Returns $title variable
	* @return (string) $title
	* @access public
	* @see $title
	*/

	function getTitle () {
		return (string) $this->title;

	}
	// end function

	/**
	* Returns $description variable
	*
	* @desc Returns $description variable
	* @return (string) $description
	* @access public
	* @see $description
	*/

	function getDescription () {
		return (string) $this->description;

	}
	// end function

	/**
	* Returns $publisher variable
	*
	* @desc Returns $publisher variable
	* @return (string) $publisher
	* @access public
	* @see $publisher
	*/

	function getPublisher () {
		return (string) $this->publisher;

	}
	// end function

	/**
	* Returns $creator variable
	*
	* @desc Returns $creator variable
	* @return (string) $creator
	* @access public
	* @see $creator
	*/

	function getCreator () {
		return (string) $this->creator;

	}
	// end function

	/**
	* Returns $date variable
	*
	* @desc Returns $date variable
	* @return (string) $date
	* @access public
	* @see $date
	*/

	function getDate ($dc = false) {

		global $opnConfig;

		$opnConfig['opndate']->sqlToopnData ($this->date);
		if ( ($this->_version == 'atom') || ($dc) ) {
			$date = '';
			$opnConfig['opndate']->GetISO8601Date ($date);
		} else {
			$date = '';
			$opnConfig['opndate']->GetRFC822Date ($date);
		}
		return (string) $date;

	}
	// end function

	/**
	* Returns $language variable
	*
	* @desc Returns $language variable
	* @return (string) $language
	* @access public
	* @see $language
	*/

	function getLanguage () {
		return (string) $this->language;

	}
	// end function

	/**
	* Returns $rights variable
	*
	* @desc Returns $rights variable
	* @return (string) $rights
	* @access public
	* @see $rights
	*/

	function getRights () {
		return (string) $this->rights;

	}
	// end function

	/**
	* Returns $coverage variable
	*
	* @desc Returns $coverage variable
	* @return (string) $coverage
	* @access public
	* @see $coverage
	*/

	function getCoverage () {
		return (string) $this->coverage;

	}
	// end function

	/**
	* Returns $contributor variable
	*
	* @desc Returns $contributor variable
	* @return (string) $contributor
	* @access public
	* @see $contributor
	*/

	function getContributor () {
		return (string) $this->contributor;

	}
	// end function

	/**
	* Returns $image_link variable
	*
	* @desc Returns $image_link variable
	* @return (string) $image_link
	* @access public
	* @see $image_link
	*/

	function getImageLink () {
		return (string) $this->image_link;

	}
	// end function

	/**
	* Returns $period variable
	*
	* @desc Returns $period variable
	* @return (string) $period
	* @access public
	* @see $period
	*/

	function getPeriod () {
		return (string) $this->period;

	}
	// end function

	/**
	* Returns $frequency variable
	*
	* @desc Returns $frequency variable
	* @return (string) $frequency
	* @access public
	* @see $frequency
	*/

	function getFrequency () {
		return (int) $this->frequency;

	}
	// end function

	/**
	* Returns $base variable
	*
	* @desc Returns $base variable
	* @return (string) $base
	* @access public
	* @see $base
	*/

	function getBase () {
		return (string) $this->base;

	}
	// end function

	/**
	* Returns $category variable
	*
	* @desc Returns $category variable
	* @return (string) $category
	* @access public
	* @see $category
	* @since 1.001 - 2003/05/30
	*/

	function getCategory () {
		return (string) $this->category;

	}
	// end function

	/**
	* Returns $cache variable
	*
	* @desc Returns $cache variable
	* @return (int) $cache
	* @access public
	* @see $cache
	* @since 1.001 - 2003/05/30
	*/

	function getCache () {
		return (int) $this->cache;

	}
	// end function

	/**
	* Adds another rss item to the object
	*
	* @desc Adds another rss item to the object
	* @param (string) $about  URL
	* @param (string) $title
	* @param (string) $link  URL
	* @param (string) $description (optional)
	* @param (string) $subject  some sort of category (optional dc value - only shows up if DC data has been set before)
	* @param (string) $date  format: 2003-05-29T00:03:07+0200 (optional dc value - only shows up if DC data has been set before)
	* @return (void)
	* @access public
	* @see $items
	* @uses RSSItem
	*/

	function addItem ($about = '', $title = '', $link = '', $description = '', $subject = '', $date = '', $author = '', $comments = '', $guid = '') {

		$item =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ RSSItem ($about, $title, $link, $description, $subject, $date, $author, $comments, $guid);
		$this->items[] = $item;

	}
	// end function

	/**
	* Deletes a rss item from the array
	*
	* @desc Deletes a rss item from the array
	* @param (int) $id  id of the element in the $items array
	* @return (boolean) true if item was deleted
	* @access public
	* @see $items
	*/

	function deleteItem ($id = -1) {
		if (array_key_exists ($id, $this->items) ) {
			unset ($this->items[$id]);
			return (boolean)TRUE;
		}
		// end if
		return (boolean)FALSE;

	}
	// end function

	/**
	* Returns an array with all the keys of the $items array
	*
	* @desc Returns an array with all the keys of the $items array
	* @return (array) array with all the keys of the $items array
	* @access public
	* @see $items
	*/

	function getItemList () {
		return (array)array_keys ($this->items);

	}
	// end function

	/**
	* Returns the $items array
	*
	* @desc Returns the $items array
	* @return (array) $items
	* @access public
	*/

	function getItems () {
		return (array) $this->items;

	}
	// end function

	/**
	* Returns a single rss item by ID
	*
	* @desc Returns a single rss item by ID
	* @param (int) $id  id of the element in the $items array
	* @return (mixed) RSSItem or FALSE
	* @access public
	* @see RSSItem
	*/

	function getItem ($id = -1) {
		if (array_key_exists ($id, $this->items) ) {
			return (object) $this->items[$id];
		}
		// end if
		return (boolean)FALSE;

	}
	// end function

	/**
	* creates the output based on HTML
	*
	* @desc creates the output based on the HTML
	* @return (void)
	* @access private
	* @see $output
	* @since 1.001 - 2003/05/30
	*/

	function createOutputHTML () {

		$this->output .= (string)'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' . "\n";
		$this->output .= (string)'<html xmlns="http://www.w3.org/1999/xhtml">' . _OPN_HTML_NL;
		$this->output .= (string)'<head>' . _OPN_HTML_NL;
		if (strlen ($this->title)>0) {
			$this->output .= (string)'<title>' . $this->title . '</title>' . _OPN_HTML_NL;
		}
		// end if
		$this->output .= (string)'<meta http-equiv="refresh" content="600" />' . _OPN_HTML_NL;
		if (strlen ($this->rights)>0) {
			$this->output .= (string)'<meta name="copyright" content="' . $this->rights . '" />' . _OPN_HTML_NL;
		}
		if (strlen ($this->date)>0) {
			$this->output .= (string)'<meta name="Date" content="' . $this->getDate () . '" />' . _OPN_HTML_NL;
		}
		if (strlen ($this->description)>0) {
			$this->output .= (string)'<meta name="description" content="' . $this->description . '" />' . _OPN_HTML_NL;
		}
		if (strlen ($this->creator)>0) {
			$this->output .= (string)'<meta name="generator" content="' . $this->creator . '" />' . _OPN_HTML_NL;
		}
		if (strlen ($this->publisher)>0) {
			$this->output .= (string)'<meta name="author" content="' . $this->publisher . '" />' . _OPN_HTML_NL;
			$this->output .= (string)'<meta name="Publisher" content="' . $this->publisher . '" />' . _OPN_HTML_NL;
		}
		if (strlen ($this->language)>0) {
			$this->output .= (string)'<meta name="language" content="' . $this->language . '" />' . _OPN_HTML_NL;
		}
		$this->output .= (string)'</head><body>' . _OPN_HTML_NL;
		if (count ($this->getItemList () )>0) {
			$this->output .= (string)'<table width="140" border="0" cellspacing="0" cellpadding="0" align="center">' . _OPN_HTML_NL;
			if (strlen ($this->about)>0) {
				$this->output .= (string)'<tr><td colspan="2">' . _OPN_HTML_NL;
				$this->output .= (string)'<a href="' . $this->about . '" target="_blank">' . $this->title . '</a></td></tr>' . _OPN_HTML_NL;
			}
			foreach ($this->getItemList () as $id) {
				$item = &$this->items[$id];
				if (strlen ($item->getTitle () )>0 && strlen ($item->getLink () )>0) {
					$this->output .= (string)'<tr><td valign="top"><strong>*</strong></td><td>' . _OPN_HTML_NL;
					$this->output .= (string)'<a href="' . $item->getLink () . '" target="_blank">' . $item->getTitle () . '</a><br />' . _OPN_HTML_NL;
					$this->output .= (string)'</td></tr>' . _OPN_HTML_NL;
				}
				// end if
			}
			// end foreach
			$this->output .= (string)'</table>' . _OPN_HTML_NL;
		}
		// end if
		$this->output .= (string)'</body></html>' . _OPN_HTML_NL;

	}

	function createOutputV200 () {

		$this->output = (string)'<rss version="2.0" xmlns:im="http://purl.org/rss/1.0/item-images/" ';
		if ($this->use_dc_data === TRUE) {
			$this->output .= (string)'xmlns:dc="http://purl.org/dc/elements/1.1/" ';
		}
		// end if
		if ($this->use_sy_data === TRUE) {
			$this->output .= (string)'xmlns:sy="http://purl.org/rss/1.0/modules/syndication/" ';
		}
		// end if
		$this->output .= (string)'>' . _OPN_HTML_NL;
		$this->output .= (string)'  <channel>' . _OPN_HTML_NL;
		if (strlen ($this->rights)>0) {
			$this->output .= (string)'	<copyright>' . $this->rights . '</copyright>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->date)>0) {
			$this->output .= (string)'	<pubDate>' . $this->getDate () . '</pubDate>' . _OPN_HTML_NL;
			$this->output .= (string)'	<lastBuildDate>' . $this->getDate () . '</lastBuildDate>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->about)>0) {
			$this->output .= (string)'	<docs>' . $this->about . '</docs>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->description)>0) {
			$this->output .= (string)'	<description>' . $this->description . '</description>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->about)>0) {
			$this->output .= (string)'	<link>' . $this->about . '</link>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->title)>0) {
			$this->output .= (string)'	<title>' . $this->title . '</title>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->image_link)>0) {
			$this->output .= (string)'	<image>' . _OPN_HTML_NL;
			$this->output .= (string)'	  <title>' . $this->title . '</title>' . _OPN_HTML_NL;
			$this->output .= (string)'	  <url>' . $this->image_link . '</url>' . _OPN_HTML_NL;
			$this->output .= (string)'	  <link>' . $this->about . '</link>' . _OPN_HTML_NL;
			if (strlen ($this->description)>0) {
				$this->output .= (string)'	  <description>' . $this->description . '</description>' . _OPN_HTML_NL;
			}
			// end if
			$this->output .= (string)'	</image>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->publisher)>0) {
			$this->output .= (string)'	<managingEditor>' . $this->publisher . '</managingEditor>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->creator)>0) {
			$this->output .= (string)'	<generator>' . $this->creator . '</generator>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->language)>0) {
			$this->output .= (string)'	<language>' . $this->language . '</language>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->category)>0) {
			$this->output .= (string)'	<category>' . $this->category . '</category>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->cache)>0) {
			$this->output .= (string)'	<ttl>' . $this->cache . '</ttl>' . _OPN_HTML_NL;
		}
		// end if
		// additional dc data
		if ($this->use_dc_data === TRUE) {
			if (strlen ($this->publisher)>0) {
				$this->output .= (string)'	<dc:publisher>' . $this->publisher . '</dc:publisher>' . _OPN_HTML_NL;
			}
			// end if
			if (strlen ($this->creator)>0) {
				$this->output .= (string)'	<dc:creator>' . $this->creator . '</dc:creator>' . _OPN_HTML_NL;
			}
			// end if
			if (strlen ($this->rights)>0) {
				$this->output .= (string)'	<dc:rights>' . $this->rights . '</dc:rights>' . _OPN_HTML_NL;
			}
			// end if
			if (strlen ($this->coverage)>0) {
				$this->output .= (string)'	<dc:coverage>' . $this->coverage . '</dc:coverage>' . _OPN_HTML_NL;
			}
			// end if
			if (strlen ($this->contributor)>0) {
				$this->output .= (string)'	<dc:contributor>' . $this->contributor . '</dc:contributor>' . _OPN_HTML_NL;
			}
			// end if
		}
		// additional SY data
		if ($this->use_sy_data === TRUE) {
			if (strlen ($this->period)>0) {
				$this->output .= (string)'	<sy:updatePeriod>' . $this->period . '</sy:updatePeriod>' . _OPN_HTML_NL;
			}
			// end if
			if (strlen ($this->frequency)>0) {
				$this->output .= (string)'	<sy:updateFrequency>' . $this->frequency . '</sy:updateFrequency>' . _OPN_HTML_NL;
			}
			// end if
			if (strlen ($this->base)>0) {
				$this->output .= (string)'	<sy:updateBase>' . $this->base . '</sy:updateBase>' . _OPN_HTML_NL;
			}
			// end if
		}
		if (count ($this->getItemList () )>0) {
			foreach ($this->getItemList () as $id) {
				$item = &$this->items[$id];
				if (strlen ($item->getTitle () )>0 && strlen ($item->getLink () )>0) {
					$this->output .= (string)'	<item>' . _OPN_HTML_NL;
					$this->output .= (string)'	  <title>' . $item->getTitle () . '</title>' . _OPN_HTML_NL;
					$this->output .= (string)'	  <link>' . $item->getLink () . '</link>' . _OPN_HTML_NL;
					if (strlen ($item->getDescription () )>0) {
						$this->output .= (string)'	  <description>' . $item->getDescription () . '</description>' . _OPN_HTML_NL;
					}
					// end if
					if ($this->use_dc_data === TRUE && strlen ($item->getSubject () )>0) {
						$this->output .= (string)'	  <category>' . $item->getSubject () . '</category>' . _OPN_HTML_NL;
					}
					// end if
					if ($item->date) {
						$this->output .= (string)'	  <pubDate>' . $item->getDate ($this->_version) . '</pubDate>' . _OPN_HTML_NL;
					}
					// end if
					if (strlen ($item->getAbout () )>0) {
						$this->output .= (string)'	  <guid>' . $item->getAbout () . '</guid>' . _OPN_HTML_NL;
					}
					// end if
					if ($this->use_dc_data === TRUE) {
						if (strlen ($item->getAuthor () )>0) {
							$this->output .= (string)'	  <dc:creator>' . $item->getAuthor () . '</dc:creator>' . _OPN_HTML_NL;
						}
						// end if
					}
					if (strlen ($item->getComments () )>0) {
						$this->output .= (string)'	  <comments>' . $item->getComments () . '</comments>' . _OPN_HTML_NL;
					}
					// end if
					$this->output .= (string)'	</item>' . _OPN_HTML_NL;
				}
				// end if
			}
			// end foreach
		}
		// end if
		$this->output .= (string)'  </channel>' . _OPN_HTML_NL;
		$this->output .= (string)'</rss>' . _OPN_HTML_NL;

	}
	// end function

	function createOutputAtom () {

		$this->output = '<feed version="0.3" xmlns="http://purl.org/atom/ns#"';
		if ($this->language>0) {
			$this->output .= ' xml:lang="' . $this->language . '"';
		}
		$this->output .= (string)'>' . _OPN_HTML_NL;
		if (strlen ($this->title)>0) {
			$this->output .= (string)'  <title>' . $this->title . '</title>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->description)>0) {
			$this->output .= (string)'  <tagline>' . $this->description . '</tagline>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->about)>0) {
			$this->output .= (string)'  <link href="' . $this->about . '" rel="alternate" type="text/html" />' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->date)>0) {
			$this->output .= (string)'  <modified>' . $this->getDate () . '</modified>' . _OPN_HTML_NL;
		}
		// end if
		if (strlen ($this->creator)>0) {
			$this->output .= (string)'  <generator>' . $this->creator . '</generator>' . _OPN_HTML_NL;
		}
		// end if
		if (count ($this->getItemList () )>0) {
			foreach ($this->getItemList () as $id) {
				$item = &$this->items[$id];
				if (strlen ($item->getTitle () )>0 && strlen ($item->getLink () )>0) {
					$this->output .= (string)'  <entry>' . _OPN_HTML_NL;
					$this->output .= (string)'	<title>' . $item->getTitle () . '</title>' . _OPN_HTML_NL;
					$this->output .= (string)'	<link href="' . $item->getLink () . '" rel="alternate" type="text/html" />' . _OPN_HTML_NL;
					$this->output .= (string)'	<id>' . $item->getLink () . '</id>' . _OPN_HTML_NL;
					if ($item->date) {
						$date = $item->getDate ($this->_version);
						$this->output .= (string)'	<created>' . $date . '</created>' . _OPN_HTML_NL;
						$this->output .= (string)'	<issued>' . $date . '</issued>' . _OPN_HTML_NL;
						$this->output .= (string)'	<modified>' . $date . '</modified>' . _OPN_HTML_NL;
					}
					// end if
					if (strlen ($item->getAuthor () )>0) {
						$this->output .= (string)'	<author>' . _OPN_HTML_NL;
						$this->output .= (string)'	  <name>' . $item->getAuthor () . '</name>' . _OPN_HTML_NL;
						$this->output .= (string)'	</author>' . _OPN_HTML_NL;
					}
					// end if
					if (strlen ($item->getDescription () )>0) {
						$this->output .= (string)'	<summary>' . $item->getDescription () . '</summary>' . _OPN_HTML_NL;
					}
					// end if
					$this->output .= (string)'  </entry>' . _OPN_HTML_NL;
				}
				// end if
			}
			// end foreach
		}
		// end if
		$this->output .= (string)'</feed>' . _OPN_HTML_NL;

	}
	// end function

	/**
	* creates the output
	*
	* @desc creates the output
	* @return (void)
	* @access private
	* @uses createOutputV100()
	*/

	function createOutput ($version = '') {
		if (strlen (trim ($version) ) === 0) {
			$version = (string)'2.0';
		}
		// end if
		$this->_version = $version;
		switch ($version) {
			case '2.00':
				$this->createOutputV200 ();
				break;
			case 'html':
				$this->createOutputHTML ();
				break;
			case 'atom':
				$this->createOutputAtom ();
				break;
			default:
				$this->createOutputV200 ();
				break;
		}
		// end switch

	}
	// end function

	/**
	* echos the output
	*
	* use this function if you want to directly output the rss stream
	*
	* @desc echos the output
	* @return (void)
	* @access public
	* @uses createOutput()
	*/

	function outputRSS ($version = '') {
		if (!isset ($this->output) ) {
			$this->createOutput ($version);
		}
		// end if
		if ($version != 'html') {
			header ('content-type: text/xml');
			// header ('Content-Disposition: inline; filename=rss_' . str_replace(' ','',$this->title) . '.xml');
			// header ('Content-Length: '.strlen($this->output));
		} else {
			header ('content-type: text/html');
			header ('Content-Disposition: inline; filename=rss_' . str_replace (' ', '', $this->title) . '.html');
		}
		$this->output = '<?xml version="1.0" encoding="' . $this->encoding . '"?>' . _OPN_HTML_NL . $this->output;
		echo $this->output;

	}
	// end function

	/**
	* returns the output
	*
	* use this function if you want to have the output stream as a string (for example to write it in a cache file)
	*
	* @desc returns the output
	* @return (void)
	* @access public
	* @uses createOutput()
	*/

	function getRSSOutput ($version = '') {
		if (!isset ($this->output) ) {
			$this->createOutput ($version);
		}
		// end if
		return (string)'<?xml version="1.0" encoding="' . $this->encoding . '"?>' . _OPN_HTML_NL . $this->output;

	}
	// end function

}
// end class RSSBuilder
// ---------------------------------------------------------------------------

/**
* single rss item object
*
* Tested with WAMP (XP-SP1/1.3.24/4.0.12/4.3.0)
* Last change: 2003-05-30
*
* @desc single rss item object
* @access private
* @author Michael Wimmer <flaimo@gmx.net>
* @copyright Michael Wimmer
* @link http://www.flaimo.com/
* @package RSSBuilder
* @category FLP
* @version 1.001
*/

class RSSItem extends RSSBase {

	/*-------------------*/

	/* V A R I A B L E S */

	/*-------------------*/

	/**
	* URL
	*
	* @desc URL
	* @var string
	* @access private
	*/
	var $about;

	/**
	* headline
	*
	* @desc headline
	* @var string
	* @access private
	*/
	var $title;

	/**
	* URL to the full item
	*
	* @desc URL to the full item
	* @var string
	* @access private
	*/
	var $link;

	/**
	* optional description
	*
	* @desc optional description
	* @var string
	* @access private
	*/
	var $description1;

	/**
	* optional subject (category)
	*
	* @desc optional subject (category)
	* @var string
	* @access private
	*/
	var $subject;

	/**
	* optional date
	*
	* @desc optional date
	* @var string
	* @access private
	*/
	var $date;

	/**
	* author of item
	*
	* @desc author of item
	* @var string
	* @access private
	* @since 1.001 - 2003/05/30
	*/
	var $author;

	/**
	* url to comments page (rss 2.0)
	*
	* @desc url to comments page (rss 2.0)
	* @var string
	* @access private
	* @since 1.001 - 2003/05/30
	*/
	var $comments;
	var $guid;

	/*-----------------------*/

	/* C O N S T R U C T O R */

	/*-----------------------*/

	/**
	* Constructor
	*
	* @desc Constructor
	* @param (string) $about  URL
	* @param (string) $title
	* @param (string) $link  URL
	* @param (string) $description (optional)
	* @param (string) $subject  some sort of category (optional)
	* @param (string) $date  format: 2003-05-29T00:03:07+0200 (optional)
	* @return (void)
	* @uses setAbout(), setTitle(), setLink(), setDescription(), setSubject(), setDate(), setAuthor(), setComments()
	* @access private
	*/

	function RSSItem ($about = '', $title = '', $link = '', $description = '', $subject = '', $date = '', $author = '', $comments = '', $guid = '') {

		$this->setAbout ($about);
		$this->setTitle ($title);
		$this->setLink ($link);
		$this->setDescription1 ($description);
		$this->setSubject ($subject);
		$this->setDate ($date);
		$this->setAuthor ($author);
		$this->setComments ($comments);
		$this->setGuid ($guid);

	}
	// end constructor

	/**
	* Sets $about variable
	*
	* @desc Sets $about variable
	* @param (string) $about
	* @return (void)
	* @access private
	* @see $about
	*/

	function setAbout ($about = '') {
		if (!isset ($this->about) && strlen (trim ($about) )>0) {
			$this->about = (string)trim ($about);
		}
		// end if

	}
	// end function

	/**
	* Sets $title variable
	*
	* @desc Sets $title variable
	* @param (string) $title
	* @return (void)
	* @access private
	* @see $title
	*/

	function setTitle ($title = '') {
		if (!isset ($this->title) && strlen (trim ($title) )>0) {
			$this->title = (string)trim ($title);
		}
		// end if

	}
	// end function

	/**
	* Sets $link variable
	*
	* @desc Sets $link variable
	* @param (string) $link
	* @return (void)
	* @access private
	* @see $link
	*/

	function setLink ($link = '') {
		if (!isset ($this->link) && strlen (trim ($link) )>0) {
			$this->link = (string)trim ($link);
		}
		// end if

	}
	// end function

	/**
	* Sets $description variable
	*
	* @desc Sets $description variable
	* @param (string) $description
	* @return (void)
	* @access private
	* @see $description
	*/

	function setDescription1 ($description = '') {
		if (!isset ($this->description1) && strlen (trim ($description) )>0) {
			$this->description1 = (string)trim ($description);
		}
		// end if

	}
	// end function

	/**
	* Sets $subject variable
	*
	* @desc Sets $subject variable
	* @param (string) $subject
	* @return (void)
	* @access private
	* @see $subject
	*/

	function setSubject ($subject = '') {
		if (!isset ($this->subject) && strlen (trim ($subject) )>0) {
			$this->subject = (string)trim ($subject);
		}
		// end if

	}
	// end function

	/**
	* Sets $date variable
	*
	* @desc Sets $date variable
	* @param (string) $date
	* @return (void)
	* @access private
	* @see $date
	*/

	function setDate ($date = 0) {
		if (!isset ($this->date) && $date) {
			$this->date = $date;
		}
		// end if

	}
	// end function

	/**
	* Sets $author variable
	*
	* @desc Sets $author variable
	* @param (string) $author
	* @return (void)
	* @access private
	* @see $author
	* @since 1.001 - 2003/05/30
	*/

	function setAuthor ($author = '') {
		if (!isset ($this->author) && strlen (trim ($author) )>0) {
			$this->author = (string)trim ($author);
		}
		// end if

	}
	// end function

	/**
	* Sets $comments variable
	*
	* @desc Sets $comments variable
	* @param (string) $comments
	* @return (void)
	* @access private
	* @see $comments
	* @since 1.001 - 2003/05/30
	*/

	function setComments ($comments = '') {
		if (!isset ($this->comments) && strlen (trim ($comments) )>0) {
			$this->comments = (string)trim ($comments);
		}
		// end if

	}
	// end function

	function setGuid ($guid = '') {
		if (!isset ($this->guid) && strlen (trim ($guid) )>0) {
			$this->guid = (string)trim ($guid);
		}
		// end if

	}
	// end function

	/**
	* Returns $about variable
	*
	* @desc Returns $about variable
	* @return (string) $about
	* @access public
	* @see $about
	*/

	function getAbout () {
		return (string) $this->about;

	}
	// end function

	/**
	* Returns $title variable
	*
	* @desc Returns $title variable
	* @return (string) $title
	* @access public
	* @see $title
	*/

	function getTitle () {
		return (string) $this->title;

	}
	// end function

	/**
	* Returns $link variable
	*
	* @desc Returns $link variable
	* @return (string) $link
	* @access public
	* @see $link
	*/

	function getLink () {
		return (string) $this->link;

	}
	// end function

	/**
	* Returns $description variable
	*
	* @desc Returns $description variable
	* @return (string) $description
	* @access public
	* @see $description
	*/

	function getDescription () {
		return (string) $this->description1;

	}
	// end function

	/**
	* Returns $subject variable
	*
	* @desc Returns $subject variable
	* @return (string) $subject
	* @access public
	* @see $subject
	*/

	function getSubject () {
		return (string) $this->subject;

	}
	// end function

	/**
	* Returns $date variable
	*
	* @desc Returns $date variable
	* @return (string) $date
	* @access public
	* @see $date
	*/

	function getDate ($version) {

		global $opnConfig;

		$opnConfig['opndate']->sqlToopnData ($this->date);
		if ($version == 'atom') {
			$date = '';
			$opnConfig['opndate']->GetISO8601Date ($date);
		} else {
			$date = '';
			$opnConfig['opndate']->GetRFC822Date ($date);
		}
		return (string) $date;

	}
	// end function

	/**
	* Returns $author variable
	*
	* @desc Returns $author variable
	* @return (string) $author
	* @access public
	* @see $author
	* @since 1.001 - 2003/05/30
	*/

	function getAuthor () {
		return (string) $this->author;

	}
	// end function

	/**
	* Returns $comments variable
	*
	* @desc Returns $comments variable
	* @return (string) $comments
	* @access public
	* @see $comments
	* @since 1.001 - 2003/05/30
	*/

	function getComments () {
		return (string) $this->comments;

	}
	// end function

	function getGuid () {
		return (string) $this->guid;

	}
	// end function

}
// end class RSSItem

?>