<?php
/**
* OpenPHPNuke: Great Web Portal System
* Pro-Module
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is NOT free software.
* See LICENSE for details.
*
*/
if (!defined ('_OPN_CLASS_CUSTOM_SPAMFILTER_INCLUDED') ) {
	define ('_OPN_CLASS_CUSTOM_SPAMFILTER_INCLUDED', 1);

	class custom_spamfilter {

		/*<{php4}>
		var $_data = array('error' => '');
		<{php4/}>*/

		/*<{php5}>
		public $_data = array('error' => '');
		<{php5/}>*/

		/*<{delete}>*/
		var $_data = array('error' => '');
		/*<{delete/}>*/

		/*
		*	 clean the last error
		*/

		function clear_error () {

			$this->_insert ('error', '');

		}

		/*
		*	 class input
		*/

		function _insert ($k, $v) {

			$this->_data[strtolower ($k)] = $v;

		}

		/*
		*	 class output
		*/

		function property ($p = null) {
			if ($p == null) {
				return $this->_data;
			}
			return $this->_data[strtolower ($p)];

		}

		/*
		*	 class init
		*/

		function init () {

			global $opnConfig, $opnTables;

			$result = $opnConfig['database']->Execute ('SELECT name, description, modus, score, searchon, search FROM ' . $opnTables['opn_spam_filter']);
			if ($result !== false) {
				while (! $result->EOF) {
					$name = $result->fields['name'];
					$description = $result->fields['description'];
					$modus = $result->fields['modus'];
					$score = $result->fields['score'];
					$searchon = $result->fields['searchon'];
					$search = $result->fields['search'];
					$ar = array ();
					$ar['name'] = $name;
					$ar['modus'] = $modus;
					$ar['score'] = $score;
					$ar['searchon'] = $searchon;
					$ar['search'] = $search;
					$this->_data['data'][] = $ar;
					$result->MoveNext ();
				}
			}
		}

		/*
		*	 the class starting
		*/

		function custom_spamfilter () {

			$this->_data = array ();
			$this->_data['error'] = '';
			$this->init ();

		}

		function should_del ($body, $email = false, $url = false) {

			global $opnConfig;
			if ( (isset ($opnConfig['opn_filter_spam_score']) ) && ($opnConfig['opn_filter_spam_score']) ) {
				$score_body = 0;
				$score_email = 0;
				$score_url = 0;

				$score_body = $this->body_test ($body);
				if ($email !== false) {
					$score_email = $this->body_test ($email);
				}
				if ($url !== false) {
					$score_url = $this->body_test ($url);
				}
				$score = $score_body + $score_email + $score_url;
				if ($score >= $opnConfig['opn_filter_spam_score']) {
					return $score;
				}
			}
			return false;

		}

		function check ($body, $email = false, $url = false) {

			global $opnConfig;

			$score_body = 0;
			$score_email = 0;
			$score_url = 0;

			$score_body = $this->body_test ($body);
			if ($email !== false) {
				$score_email = $this->email_test ($email);
			}
			if ($url !== false) {
				$score_url = $this->url_test ($url);
			}
			$score = $score_body + $score_email + $score_url;
			return $score;

		}


		/*
		*/

		function body_test ($txt) {

			return $this->_check ($txt, 2);

		}

		function url_test ($txt) {

			return $this->_check ($txt, 4);

		}

		function email_test ($txt) {

			return $this->_check ($txt, 3);

		}

		function _check ($txt, $searchon) {

			$score = 0;
			if ( (isset ($this->_data['data']) ) && (is_array ($this->_data['data']) ) ) {
				foreach ($this->_data['data'] as $var1) {
					if ( ($var1['searchon'] == $searchon) OR ($var1['searchon'] == 0) ) {
						if ($var1['modus'] == 1) {
							$find = '=' . preg_quote ($var1['search']) . '=siU';
							if (ereg ($find, $txt) ) {
								$score = $score+ $var1['score'];
							}
						} elseif ($var1['modus'] == 2) {
							$find = '/'.$var1['search'].'/';
							if (preg_match ($find, $txt) ) {
								$score = $score+ $var1['score'];
							}
						} else {
							$find = '' . preg_quote ($var1['search']) . '';
							$find = $var1['search'];
							if (ereg ($find, $txt) ) {
								$score = $score+ $var1['score'];
							}
						}
					}
				}
			}
			if ($score >= 100) {
				$score = $score/100;
			}
			return $score;

		}



	}
}
// if

?>