<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
*
* Abstract	base class for form	elements
*
* @package engine
* @subpackage form
*
* @author Stefan Kaletta stefan@kaletta.de
*
*/

class opnFormElement {

	/**
	* "name" attribute	of the element
	* @var string
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_name;

	/**
	* "formname" attribute	of the back	form
	* @var string
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_formname;

	/**
	* caption of the element
	* @var string
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_caption;

	/**
	* Accesskey for this element
	* @var string
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_accesskey = '';

	/**
	* HTML	class for this element
	* @var string
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_class = '';

	/**
	* hidden?
	* @var bool
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_hidden = false;

	/**
	* extra attributes	to go in the tag
	* @var string
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_extra = "";

	/**
	* required	field?
	* @var bool
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_required = false;

	/**
	* description of the field
	* @var string
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_description = '';

	/**
	* features
	*
	* @var array
	* @access private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_default_features = array ();

	/**
	* constructor
	*
	*/

	function opnFormElement () {

		exit ("This class cannot be instantiated!");

	}

	function setFeatures ($var) {

		$this->_default_features = $var;

	}

	function getFeatures () {
		return $this->_default_features;

	}

	/**
	* Is this element a container of other	elements?
	*
	* @return	bool false
	*/

	function isContainer () {
		return false;

	}

	/**
	* set the "name" attribute	for	the	element
	*
	* @param	string	$name	"name" attribute for the element
	*/

	function setName ($name) {

		$this->_name = trim ($name);

	}

	/**
	* get the "name" attribute	for	the	element
	*
	* @param	bool	encode?
	* @return string	"name" attribute
	*/

	function getName ($encode = true) {
		if (false != $encode) {
			return str_replace ("&amp;", "&", str_replace ("'", "&#039;", htmlspecialchars ($this->_name) ) );
		}
		return $this->_name;

	}

	/**
	* set the "accesskey" attribute for the element
	*
	* @param	string	$key   "accesskey" attribute for the element
	*/

	function setAccessKey ($key) {

		$this->_accesskey = trim ($key);

	}

	/**
	* get the "accesskey" attribute for the element
	*
	* @return string	"accesskey"	attribute value
	*/

	function getAccessKey () {
		return $this->_accesskey;

	}

	/**
	* If the accesskey	is found in	the	specified string, underlines it
	*
	* @param	string	$str   String where	to search the accesskey	occurence
	* @return string	Enhanced string	with the 1st occurence of accesskey	underlined
	*/

	function getAccessString ($str) {

		$access = $this->getAccessKey ();
		if (!empty ($access) && (false !== ($pos = strpos ($str, $access) ) ) ) {
			return substr ($str, 0, $pos) . '<span style="text-decoration:underline">' . substr ($str, $pos, 1) . '</span>' . substr ($str, $pos+1);
		}
		return $str;

	}

	/**
	* set the "class" attribute for the element
	*
	* @param	string	$key   "class" attribute for the element
	*/

	function setClass ($class) {

		$class = trim ($class);
		if (empty ($class) ) {
			$this->_class = '';
		} else {
			$this->_class .= (empty ($this->_class)?'' : '	') . $class;
		}

	}

	/**
	* get the "class" attribute for the element
	*
	* @return string	"class"	attribute value
	*/

	function getClass () {
		return $this->_class;

	}

	/**
	* set the caption for the element
	*
	* @param	string	$caption
	*/

	function setCaption ($caption) {

		$this->_caption = trim ($caption);

	}

	/**
	* get the caption for the element
	*
	* @return string
	*/

	function getCaption () {
		return $this->_caption;

	}

	/**
	* set the element's description
	*
	* @param	string	$description
	*/

	function setDescription ($description) {

		$this->_description = trim ($description);

	}

	/**
	* get the element's description
	*
	* @return string
	*/

	function getDescription () {
		return $this->_description;

	}

	/**
	* flag	the	element	as "hidden"
	*
	*/

	function setHidden () {

		$this->_hidden = true;

	}

	/**
	* Find	out	if an element is "hidden".
	*
	* @return	bool
	*/

	function isHidden () {
		return $this->_hidden;

	}

	/**
	* Add extra attributes	to the element.
	*
	* This	string will	be inserted	verbatim and unvalidated in	the
	* element's tag. Know what	you	are	doing!
	*
	* @param	string	$extra
	* @param	string	$replace If	true, passed string	will replace current content otherwise it will be appended to it
	* @return string New content of the extra	string
	*/

	function setExtra ($extra, $replace = false) {
		if ($replace) {
			$this->_extra = trim ($extra);
		} else {
			$this->_extra .= " " . trim ($extra);
		}
		return $this->_extra;

	}

	/**
	* Get the extra attributes	for	the	element
	*
	* @return string
	*/

	function getExtra () {
		if (isset ($this->_extra) ) {
			return $this->_extra;
		}
		return '';

	}

	/**
	* Generates output	for	the	element.
	*
	* This	method is abstract and must	be overwritten by the child	classes.
	* @abstract
	*/

	function render (&$form) {

		$x = $form;

	}

}

?>