<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
*
* A textarea
*
* @package	 engine
* @subpackage  form
*
* @author		Stefan Kaletta	stefan@kaletta.de
*
*/

class opnFormTextArea extends opnFormElement {

	/**
	* number of columns
	* @var int
	* @access  private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_cols;

	/**
	* number of rows
	* @var int
	* @access  private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_rows;

	/**
	* initial content
	* @var string
	* @access  private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_value;

	/**
	* do it on onselect
	* @var string
	* @access  private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_onselect;

	/**
	* do it on ononclick
	* @var string
	* @access  private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_onclick;

	/**
	* do it on onkeyup
	* @var string
	* @access  private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_onkeyup;

	/**
	* what do you want
	* @var string
	* @access  private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_options;

	/**
	* Constuctor
	*
	* @param	string  $caption	caption
	* @param string $name
	* @param integer $cols
	* @param integer $rows
	* @param string $wrap
	* @param string $value
	* @param string $onselect
	* @param string $onclick
	* @param string $onkeyup
	*/

	function opnFormTextArea ($caption, $name, $cols = 0, $rows = 0, $wrap = '', $value = '', $onselect = '', $onclick = '', $onkeyup = '') {

		$x = $wrap;
		$this->setCaption ($caption);
		$this->setName ($name);
		$this->_rows = intval ($rows);
		$this->_cols = intval ($cols);
		$this->_onselect = $onselect;
		$this->_onclick = $onclick;
		$this->_onkeyup = $onkeyup;
		$this->setValue ($value);

	}

	/**
	* get number of rows
	*
	* @return	int
	*/

	function getRows () {
		return $this->_rows;

	}

	/**
	* Get number of columns
	*
	* @return	int
	*/

	function getCols () {
		return $this->_cols;

	}

	/**
	* Get initial content
	*
	* @return string
	*/

	function getValue () {
		return $this->_value;

	}

	/**
	* Set initial content
	*
	* @param	$value	string
	*/

	function setValue ($value) {

		$this->_value = $value;

	}

	/**
	* Set initial options
	*
	* @param	$value	string
	*/

	function setOption ($value) {

		$this->_options[$value] = true;

	}

	/**
	* prepare HTML for output
	*
	* @return	sting HTML
	*/

	function render (&$form) {

		global $opnConfig;

		$opnConfig['permission']->LoadUserSettings (__USER_CONFIG__);
		$options = $this->getFeatures ();
		if ($options === false) {
			$options = array ();
			$options[_OOBJ_DTYPE_HTML] = true;
			$options[_OOBJ_DTYPE_BBCODE] = true;
			$options[_OOBJ_DTYPE_CBR] = true;
			$options[_OOBJ_DTYPE_SMILE] = true;
			$options[_OOBJ_DTYPE_UIMAGES] = true;
			$options[_OOBJ_DTYPE_SIG] = true;
		}
		$options[_OOBJ_DTYPE_HTML . '_SHOW'] = $opnConfig['permission']->GetUserSetting (_USER_CONFIG_FORM_HTML_, __USER_CONFIG__, $options[_OOBJ_DTYPE_HTML]);
		$options[_OOBJ_DTYPE_SMILE . '_SHOW'] = $opnConfig['permission']->GetUserSetting (_USER_CONFIG_FORM_SMILE_, __USER_CONFIG__, $options[_OOBJ_DTYPE_SMILE]);
		$options[_OOBJ_DTYPE_UIMAGES . '_SHOW'] = $opnConfig['permission']->GetUserSetting (_USER_CONFIG_FORM_UIMAGES_, __USER_CONFIG__, $options[_OOBJ_DTYPE_UIMAGES]);
		$form->SetSameCol ();
		$form->AddLabel ($this->getName (), $this->getCaption () );
		$form->AddHidden ($this->getName () . '_use_', 'opn');
		$form->AddNewline (2);
		if ($options[_OOBJ_DTYPE_HTML] == 1) {
			$form->AddLabel ($this->getName () . '_use_html', _OPN_ENGINE_FORM_HTML);
			$form->AddCheckbox ($this->getName () . '_use_html', 1, $options[_OOBJ_DTYPE_HTML]);
			$form->AddNewline (1);
		}
		if ($options[_OOBJ_DTYPE_BBCODE] == 1) {
			$form->AddLabel ($this->getName () . '_use_bbcode', _OPN_ENGINE_FORM_BBCODE);
			$form->AddCheckbox ($this->getName () . '_use_bbcode', 1, $options[_OOBJ_DTYPE_BBCODE]);
			$form->AddNewline (1);
		}
		if ($options[_OOBJ_DTYPE_SMILE] == 1) {
			$form->AddLabel ($this->getName () . '_use_smile', _OPN_ENGINE_FORM_SMILIES);
			$form->AddCheckbox ($this->getName () . '_use_smile', 1, $options[_OOBJ_DTYPE_SMILE]);
			$form->AddNewline (1);
		}
		$form->SetEndCol ();
		if ( ( ($options[_OOBJ_DTYPE_HTML]) OR ($options[_OOBJ_DTYPE_BBCODE]) ) && $options[_OOBJ_DTYPE_HTML . '_SHOW']) {
			$form->UseEditor (true);
			$form->UseWysiwyg (true);
		}
		if ( ($options[_OOBJ_DTYPE_SMILE]) && ($options[_OOBJ_DTYPE_SMILE . '_SHOW']) ) {
			$form->UseSmilies (true);
		}
		if ( ($options[_OOBJ_DTYPE_UIMAGES]) && ($options[_OOBJ_DTYPE_UIMAGES . '_SHOW']) ) {
			$form->UseImages (true);
		}
		$form->AddTextarea ($this->getName (), $this->getCols (), $this->getRows (), '', $this->getValue (), $this->_onselect, $this->_onclick, $this->_onkeyup);

	}

}

?>