<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_SMARTTEMPLATEPARSER_INCLUDED') ) {
	define ('_OPN_CLASS_SMARTTEMPLATEPARSER_INCLUDED', 1);

	/**
	* SmartTemplateParser Class
	* Used by SmartTemplate Class
	*
	* @author Philipp v. Criegern philipp@criegern.com
	* @version 1.01 08.05.2002
	* @desc Used by SmartTemplate Class
	*/

	class SmartTemplateParser {

		/**
		* The template itself
		*
		* @access private
		*/

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $template;

		/**
		* List of used SmartTemplate Extensions
		*
		* @access private
		*/

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $extension_tagged = array ();

		/**
		* Error messages
		*
		* @access public
		*/

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $error;

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $template_file = '';

		/**
		 * Classconstructor
		 * 		
		 * @param $template_filename
		 */
		function /*<{4php5}>SmartTemplateParser!!__construct<{4php5/}>*//*<{delete}>*/SmartTemplateParser/*<{delete/}>*/ ($template_filename) {

			// Load Template
			if ($hd = @fopen ($template_filename, 'r') ) {
				$this->template = fread ($hd, filesize ($template_filename) );
				fclose ($hd);
				$this->template_file = $template_filename;
			} else {
				$this->template = 'File not found: ' . $template_filename;
			}
		}

		/**
		* Main Template Parser
		*
		* @param string $compiled_template_filename Compiled Template Filename
		* @desc Creates Compiled PHP Template
		*/

		function compile ($compiled_template_filename = '') {

			if (empty ($this->template) ) {
				return;
			}
			// END, ELSE Blocks
			$page = preg_replace ("/<!-- ENDIF.+?-->/", '<?php' . _OPN_HTML_CRLF . '}' . _OPN_HTML_CRLF .'?>', $this->template);
			$page = preg_replace ("/<!-- END[ a-zA-Z0-9_.]* -->/", '<?php' . _OPN_HTML_CRLF . '}' . _OPN_HTML_CRLF . '$_obj=$_stack[--$_stack_cnt];}' . _OPN_HTML_CRLF . '?>', $page);
			$page = str_replace ("<!-- ELSE -->", '<?php' . _OPN_HTML_CRLF . '} else {' . _OPN_HTML_CRLF .'?>', $page);
			// 'BEGIN - END' Blocks
			$var = '';
			if (preg_match_all ('/<!-- BEGIN ([a-zA-Z0-9_.]+) -->/', $page, $var) ) {
				foreach ($var[1] as $tag) {
					list ($parent, $block) = $this->var_name ($tag);
					$code = '<?php' . _OPN_HTML_CRLF
						. 'if (!empty($' . $parent . '[\'' . $block . '\'])) {'  . _OPN_HTML_CRLF
						. 'if (!is_array($' . $parent . '[\'' . $block . '\'])) {'  . _OPN_HTML_CRLF
						. '$' . $parent . '[\'' . $block . '\']=array(array(\'' . $block . '\'=>$' . $parent . '[\'' . $block . '\']));'  . _OPN_HTML_CRLF
						. '}' . _OPN_HTML_CRLF
						. '$_tmp_arr_keys=array_keys($' . $parent . '[\'' . $block . '\']);' . _OPN_HTML_CRLF
						. 'if ($_tmp_arr_keys[0]!=\'0\') {' . _OPN_HTML_CRLF
						. '$' . $parent . '[\'' . $block . '\']=array(0=>$' . $parent . '[\'' . $block. '\']);' . _OPN_HTML_CRLF
						. '}' . _OPN_HTML_CRLF
						. '$_stack[$_stack_cnt++]=$_obj;' . _OPN_HTML_CRLF
						. '$_a' . $block .'=0;' . _OPN_HTML_CRLF
						. '$_b' . $block .'=0;' . _OPN_HTML_CRLF
						. 'foreach ($' . $parent . '[\'' . $block . '\'] as $rowcnt=>$' . $block. '){' . _OPN_HTML_CRLF
						. '$' . $block . '[\'ROWCNT\']=$rowcnt;' . _OPN_HTML_CRLF
						. '$' . $block . '[\'ALTROW\']=$rowcnt%2;' . _OPN_HTML_CRLF
						. '$' . $block . '[\'ROWBIT\']=$rowcnt%2;' . _OPN_HTML_CRLF
						. '$_a' . $block .' == 0 ? $' . $block . '[\'ALTERNATOR\']=\'alternator2\' : $' . $block . '[\'ALTERNATOR\']=\'alternator1\';' . _OPN_HTML_CRLF
						. '$_a' . $block .' == 1 ? $_a' . $block .' = 0 : $_a' . $block .' = 1;' . _OPN_HTML_CRLF
						. '$_b' . $block .' == 0 ? $' . $block . '[\'LISTALTERNATOR\']=\'listalternator2\' : $' . $block . '[\'LISTALTERNATOR\']=\'listalternator1\';' . _OPN_HTML_CRLF
						. '$_b' . $block .' == 1 ? $_b' . $block .' = 0 : $_b' . $block .' = 1;' . _OPN_HTML_CRLF
						. '$_obj=&$' . $block . ';?>';
					$page = str_replace ("<!-- BEGIN $tag -->", $code, $page);
				}
			}

			// 'IF nnn="mmm"' Blocks
			$var = '';
			if (preg_match_all ('/<!-- (ELSE)?IF ([a-zA-Z0-9_.]+)([!=<>]+)"([^"]*)" -->/', $page, $var) ) {
				foreach ($var[2] as $cnt => $tag) {
					list ($parent, $block) = $this->var_name ($tag);
					$cmp = $var[3][$cnt];
					$val = $var[4][$cnt];
					$else = ($var[1][$cnt] == 'ELSE')?'} else' : '';
					if ($cmp == '=') {
						$cmp = '==';
					}
					$code = '<?php' . _OPN_HTML_CRLF . $else . 'if ($' . $parent . '[\'' . $block . '\'] ' . $cmp . $val. '){' . _OPN_HTML_CRLF .'?>';
					$page = str_replace ($var[0][$cnt], $code, $page);
				}
			}
			// 'IF nnn={mmm}' Blocks
			if (preg_match_all ('/<!-- (ELSE)?IF ([a-zA-Z0-9_.]+)([!=<>]+) {([^"]*)} -->/', $page, $var) ) {
				foreach ($var[2] as $cnt => $tag) {
					list ($parent, $block) = $this->var_name ($tag);
					list ($parent1, $block1) = $this->var_name ($var[4][$cnt]);
					$cmp = $var[3][$cnt];
					$else = ($var[1][$cnt] == 'ELSE')?'} else' : '';
					if ($cmp == '=') {
						$cmp = '==';
					}
					$code = '<?php' . _OPN_HTML_CRLF . $else . 'if ($' . $parent . '[\'' . $block . '\'] ' . $cmp . '$' . $parent1 . '[\'' . $block1 . '\']){' . _OPN_HTML_CRLF .'?>';
					$page = str_replace ($var[0][$cnt], $code, $page);
				}
			}
			// 'IF nnn' Blocks
			if (preg_match_all ('/<!-- (ELSE)?IF ([a-zA-Z0-9_.]+) -->/', $page, $var) ) {
				foreach ($var[2] as $cnt => $tag) {
					$else = ($var[1][$cnt] == 'ELSE')?'} else' : '';
					list ($parent, $block) = $this->var_name ($tag);
					$code = '<?php' . _OPN_HTML_CRLF . $else . 'if (!empty($' . $parent . '[\'' . $block . '\'])){' . _OPN_HTML_CRLF .'?>';
					$page = str_replace ($var[0][$cnt], $code, $page);
				}
			}
			// Replace Scalars
			if (preg_match_all ('/{([a-zA-Z0-9_. >]+)}/', $page, $var) ) {
				foreach ($var[1] as $fulltag) {
					// Determin Command (echo / $obj[n]=)
					list ($cmd, $tag) = $this->cmd_name ($fulltag);
					list ($block, $skalar) = $this->var_name ($tag);
					$code = '<?php ' . $cmd . '$' . $block . '[\''. $skalar . '\']; ?>';
					$page = str_replace ('{' . $fulltag . '}', $code, $page);
				}
			}
			// OPN Special: Replace constants
			if (preg_match_all ('/{"([a-zA-Z0-9_.]+)"}/', $page, $var) ) {
				foreach ($var[1] as $tag) {
					list ($block, $skalar) = $this->var_name ($tag);
					$code = '<?php echo '. $skalar . '; ?>';
					$page = str_replace ('{"' . $tag . '"}', $code, $page);
				}
			}
			// ROSI Special: Replace Translations
			if (preg_match_all ('/<"([a-zA-Z0-9_.]+)">/', $page, $var) ) {
				foreach ($var[1] as $tag) {
					list ($block, $skalar) = $this->var_name ($tag);
					$code = '<?php echo gettext('. $skalar . '); ?>';
					$page = str_replace ('<"' . $tag . '">', $code, $page);
				}
			}
			// Include Extensions
			$header = '';
			if (preg_match_all ('/{([a-zA-Z0-9_]+):([^}]*)}/', $page, $var) ) {
				foreach ($var[2] as $cnt => $tag) {
					// Determin Command (echo / $obj[n]=)
					list ($cmd, $tag) = $this->cmd_name ($tag);
					$extension = $var[1][$cnt];
					if ( (!isset ($this->extension_tagged[$extension]) ) || (!$this->extension_tagged[$extension]) ) {
						$header .= 'include_once \'' . _OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'smarttemplate/smarttemplate_extensions/smarttemplate_extension_' . $extension . '.php\';' . _OPN_HTML_CRLF;
						$this->extension_tagged[$extension] = true;
					}
					if (!strlen ($tag) ) {
						$code = '<?php ' . $cmd . 'smarttemplate_extension_' . $extension . '(); ?>';
					} elseif (strpos ($tag, ',') ) {
						list ($tag, $addparam) = explode (',', $tag, 2);
						$code = '<?php '. $cmd . 'smarttemplate_extension_' .$extension . '(';
						if (preg_match_all ('/"([a-zA-Z0-9_.]+)"/', $tag, $var1) ) {
							foreach ($var1[1] as $nexttag) {
								list ($block, $skalar) = $this->var_name ($nexttag);
								$code .= '$' . $block . '[\'' . $skalar . '\']';
							}
						} elseif (preg_match_all ('/\'([a-zA-Z0-9_.]+)\'/', $tag, $var1) ) {
							foreach ($var1[1] as $nexttag) {
								$code .= '\'' . $nexttag .'\'';
							}
						} else {
							$code .= $tag;
						}
						$addparam = explode (',', $addparam);
						foreach ($addparam as $value) {
							if (preg_match_all ('/"([a-zA-Z0-9_.]+)"/', $value, $var1) ) {
								foreach ($var1[1] as $nexttag) {
									list ($nextblock, $nextskalar) = $this->var_name ($nexttag);
									$code .= ',$' . $nextblock . '[\'' . $nextskalar . '\']';
								}
							} elseif (preg_match_all ('/\'([a-zA-Z0-9_.]+)\'/', $value, $var1) ) {
								foreach ($var1[1] as $nexttag) {
									$code .= ',\'' . $nexttag .'\'';
								}
							} else {
								$code .= ',' . $value;
							}
						}
						$code .= '); ?>';
						unset($addparam);
					} elseif (substr ($tag, 0, 1) == '"') {
						$code = '<?php '. $cmd . 'smarttemplate_extension_' . $extension . '(' . $tag. '); ?>';
					} else {
						list ($block, $skalar) = $this->var_name ($tag);
						$code = '<?php '. $cmd . 'smarttemplate_extension_' . $extension . '($' . $block . '[\''. $skalar . '\']); ?>';
					}
					$page = str_replace ($var[0][$cnt], $code, $page);
				}
			}
			// Add Include Header
			if ($header != '') {
				$page = '<?php' . _OPN_HTML_CRLF . $header . '?>' . $page;
			}
			// Store Code to Temp Dir
			if (strlen ($compiled_template_filename) ) {
				if ($hd = fopen ($compiled_template_filename, 'w') ) {
					fwrite ($hd, $page);
					fclose ($hd);
					return true;
				}
				$this->error = 'Could not write compiled file.';
				return false;
			}
			return $page;
		}

		/**
		* Splits Template-Style Variable Names into an Array-Name/Key-Name Components
		* {example}               :  array( "_obj",                   "example" )  ->  $_obj['example']
		* {example.value}         :  array( "_obj['example']",        "value" )    ->  $_obj['example']['value']
		* {example.0.value}       :  array( "_obj['example'][0]",     "value" )    ->  $_obj['example'][0]['value']
		* {top.example}           :  array( "_stack[0]",              "example" )  ->  $_stack[0]['example']
		* {parent.example}        :  array( "_stack[$_stack_cnt-1]",  "example" )  ->  $_stack[$_stack_cnt-1]['example']
		* {parent.parent.example} :  array( "_stack[$_stack_cnt-2]",  "example" )  ->  $_stack[$_stack_cnt-2]['example']
		*
		* @param string $tag Variale Name used in Template
		* @return array  Array Name, Key Name
		* @access private
		* @desc Splits Template-Style Variable Names into an Array-Name/Key-Name Components
		*/

		function var_name ($tag) {

			$parent_level = 0;
			while (substr ($tag, 0, 7) == 'parent.') {
				$tag = substr ($tag, 7);
				$parent_level++;
			}
			if (substr ($tag, 0, 4) == 'top.') {
				$obj = '_stack[0]';
				$tag = substr ($tag, 4);
			} elseif ($parent_level) {
				$obj = '_stack[$_stack_cnt-' . $parent_level . ']';
			} else {
				$obj = '_obj';
			}
			while (is_int (strpos ($tag, '.') ) ) {
				list ($parent, $tag) = explode ('.', $tag, 2);
				if (is_numeric ($parent) ) {
					$obj .= "[" . $parent . "]";
				} else {
					$obj .= "['" . $parent . "']";
				}
			}
			return array ($obj,
					$tag);

		}

		/**
		* Determine Template Command from Variable Name
		* {variable}             :  array( "echo",              "variable" )  ->  echo $_obj['variable']
		* {variable > new_name}  :  array( "_obj['new_name']=", "variable" )  ->  $_obj['new_name']= $_obj['variable']
		*
		* @param string $tag Variale Name used in Template
		* @return array  Array Command, Variable
		* @access private
		* @desc Determine Template Command from Variable Name
		*/

		function cmd_name ($tag) {

			if (preg_match ('/^(.+) > ([a-zA-Z0-9_.]+)$/', $tag, $tagvar) ) {
				$tag = $tagvar[1];
				list ($newblock, $newskalar) = $this->var_name ($tagvar[2]);
				$cmd = '$' . $newblock . '[\'' . $newskalar . '\']=';
			} else {
				$cmd = 'echo ';
			}
			return array ($cmd,
					$tag);

		}
	}
}

?>