<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_DRIVERMYSQLT_INCLUDED') ) {
	define ('_OPN_CLASS_DRIVERMYSQLT_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'sql/drivers/driver-mysql.php');

	/**
	* Extends the SQL Connection class for MySQL Database access with transactions
	*/

	class SQLLayer_mysqlt extends SQLLayer_mysql {

		/*<{php4}>
		var $databaseType = 'mysqlt';
		var $ansiOuter = true;
		// for Version 3.23.17 or later
		var $autoRollback = true;
		// apparently mysql does not autorollback properly
		<{php4/}>*/

		/*<{php5}>
		public $databaseType = 'mysqlt';
		public $ansiOuter = true;
		// for Version 3.23.17 or later
		public $autoRollback = true;
		// apparently mysql does not autorollback properly
		<{php5/}>*/

		/*<{delete}>*/
		var $databaseType = 'mysqlt';
		var $ansiOuter = true;
		// for Version 3.23.17 or later
		var $autoRollback = true;
		// apparently mysql does not autorollback properly
		/*<{delete/}>*/

		/**
		* Constructor for SQLLayer_mysqlt
		*
		* @access public
		* @return void
		*/

		function SQLLayer_mysqlt () {

			$this->SQLLayer_mysql ();

		}

		/**
		* Start a transaction.
		*
		* @access public
		* @return boolean
		*/

		function BeginTrans () {
			if ($this->transOff) {
				return true;
			}
			$this->transCnt += 1;
			$this->Execute ('SET AUTOCOMMIT=0');
			$this->Execute ('BEGIN');
			return true;

		}

		/**
		* Commit a transaction.
		*
		* @access public
		* @param bool	$ok
		* @return boolean
		*/

		function CommitTrans ($ok = true) {
			if ($this->transOff) {
				return true;
			}
			if (!$ok) {
				return $this->RollbackTrans ();
			}
			if ($this->transCnt) {
				$this->transCnt -= 1;
			}
			$this->Execute ('COMMIT');
			$this->Execute ('SET AUTOCOMMIT=1');
			return true;

		}

		/**
		* Rollback a transaction.
		*
		* @access public
		* @return boolean
		*/

		function RollbackTrans () {
			if ($this->transOff) {
				return true;
			}
			if ($this->transCnt) {
				$this->transCnt -= 1;
			}
			$this->Execute ('ROLLBACK');
			$this->Execute ('SET AUTOCOMMIT=1');
			return true;

		}

	}

	/* class SQLLayer_mysqlt */

	class SQLLayerRecordSet_mysqlt extends SQLLayerRecordSet_mysql {

		/*<{php4}>
		var $databaseType = "mysqlt";
		<{php4/}>*/

		/*<{php5}>
		public $databaseType = "mysqlt";
		<{php5/}>*/

		/*<{delete}>*/
		var $databaseType = "mysqlt";
		/*<{delete/}>*/

		/**
		* Constructor
		*
		* @access public
		* @param ressource	$id
		* @param bool		$mode
		* @return void
		*/

		function SQLLayerRecordSet_mysqlt ($id, $mode = true) {

			$this->SQLLayerRecordSet_mysql ($id, $mode);

		}

	}

	/* class SQLLayerRecordSet_mysqlt */
}

?>