<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_INCLUDE_MODULE_BOXTPL_PHP') ) {
	define ('_OPN_INCLUDE_MODULE_BOXTPL_PHP', 1);

	/**
	* adds a mainpagebutton and a submitbutton to the boxtext when needed
	*
	* @access privat
	* @param string $box_array_dat
	* @param string $mainurl
	* @param string $pageurl
	* @param string $title
	* @param string $content
	* @return void
	**/

	function get_box_footer ($box_array_dat, $mainurl, $pageurl, $title, &$content) {
		if ( (isset ($box_array_dat['box_options']['show_link']) ) && ($box_array_dat['box_options']['show_link'] == 1) ) {
			$content1 = '%s';
			$content1 .= '<a href="' . $mainurl . '" class="txtbutton">' . _MAINPAGE . '</a>' . _OPN_HTML_NL;
			$content1 .= '%s' . _OPN_HTML_NL;
			$content1 .= '<a href="' . encodeurl ($pageurl) . '" class="txtbutton">' . $title . '</a>';
			$content1 .= '%s</div>';
			if ($box_array_dat['box_options']['opnbox_class'] == 'center') {
				$content .= sprintf ($content1, '<div class="centertag"><span style="display:table-row;">', '&nbsp;', '</span>');
			} elseif ($box_array_dat['box_options']['opnbox_class'] == 'side') {
				$content .= sprintf ($content1, '<div class="sideboxsmalltext" align="center"><br />', '</div><br /><div class="sideboxsmalltext" align="center">', '');
			}
			unset ($content1);
		}

	}

	/**
	* adds a mainpagebutton to the boxtext when needed
	*
	* @access privat
	* @param string $box_array_dat
	* @param string $mainurl
	* @param string $content
	* @return void
	**/

	function get_box_footersingle ($box_array_dat, $mainurl, &$content) {
		if ( (isset ($box_array_dat['box_options']['show_link']) ) && ($box_array_dat['box_options']['show_link'] == 1) ) {
			$content1 = '%s';
			$content1 .= '<a href="' . $mainurl . '" class="txtbutton">' . _MAINPAGE . '</a>' . _OPN_HTML_NL;
			$content1 .= '%s</div>';
			if ($box_array_dat['box_options']['opnbox_class'] == 'center') {
				$content .= sprintf ($content1, '<div class="centertag"><span style="display:table-row;">', '</span>');
			} elseif ($box_array_dat['box_options']['opnbox_class'] == 'side') {
				$content .= sprintf ($content1, '<div class="sideboxsmalltext" align="center"><br />', '');
			}
			unset ($content1);
		}

	}

	/**
	* Parse the boxtemplate
	*
	* @access privat
	* @param string $box_array_dat
	* @param array  $cases
	* @param array  $opnliste
	* @param int	$limit
	* @param int	$counter
	* @param string $boxstuff
	* @param string $title
	* @return void
	**/

	function get_box_template ($box_array_dat, $cases, $opnliste, $limit, $counter, &$boxstuff, $title = '') {

		global $opnConfig, $opnTheme;
		if (!defined ('_OPN_TEMPLATE_CLASS_INCLUDED') ) {
			include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_theme_template.php');
		}
		$tpl = & new opn_template (_OPN_ROOT_PATH);
		$tpl->set ('title', $title);
		if ($title == '') {
			$tpl->set ('is_title', FALSE, TRUE);
		} else {
			$tpl->set ('is_title', TRUE, TRUE);
		}
		$tpl->set_cloop ('opnliste', $opnliste, $cases);
		if ($opnConfig['_THEME_HAVE_opnliste'] == 0) {
			$boxstuff .= $tpl->fetch ('themes/opn_themes_include/tpl/' . $box_array_dat['box_options']['use_tpl']);
		} else {
			$boxstuff .= $tpl->fetch ('themes/' . $opnTheme['thename'] . '/tpl/' . $box_array_dat['box_options']['use_tpl']);
		}
		unset ($tpl);
		$max = ($limit - $counter);
		for ($i = 0; $i<$max; $i++) {
			$boxstuff .= '&nbsp;<br />';
		}

	}
}

?>