<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_INCLUDE_MODULE_BUILD_PAGEBAR_PHP') ) {
	define ('_OPN_INCLUDE_MODULE_BUILD_PAGEBAR_PHP', 1);
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_pagebar.php');

	function build_pagebar ($url, $rows, $maxperpage, $offset, $_ALLINOURDATABASEARE = '') {
		if (!$maxperpage) {
			$maxperpage = 1;
		}
		$bar = & new opn_page_bar;
		$bar->SetUrl ($url);
		$bar->SetMaxRecords ($rows);
		$bar->SetPagesize ($maxperpage);
		$bar->SetOffset ($offset);
		if ($_ALLINOURDATABASEARE != '') {
			$bar->SetFoundText ($_ALLINOURDATABASEARE);
		}
		return $bar->GetNicePagebar ();

	}

	function build_smallpagebar ($url, $rows, $maxperpage, $_CHOOSEPAGE, $around = 3) {
		if (!$maxperpage) {
			$maxperpage = 1;
		}
		$numberofPages = ceil ($rows/ $maxperpage);
		if ($numberofPages<=1) {
			return '';
		}
		$returntext = $_CHOOSEPAGE . '&nbsp;';
		if ( ($numberofPages-$around)>1) {
			$countfrom = $numberofPages- $around+1;
			$returntext .= '<a href="' . encodeurl ($url) . '" class="opncenterbox">1</a>&nbsp;...&nbsp;';
		} else {
			$countfrom = 1;
		}
		for ($i = $countfrom; $i<= $numberofPages; $i++) {
			$url['offset'] = ( ($i-1)* $maxperpage);
			$returntext .= '<a href="' . encodeurl ($url) . '" class="opncenterbox">' . $i . '</a>&nbsp;';
		}
		return $returntext;

	}

	function build_onelinepagebar ($url, $rows, $maxperpage, $offset, $_CHOOSEPAGE, $around = 5) {
		if (!$maxperpage) {
			$maxperpage = 1;
		}
		$numberofPages = ceil ($rows/ $maxperpage);
		if ($numberofPages<=1) {
			return '';
		}
		$actualPage = ceil ( ($offset+1)/ $maxperpage);
		$returntext = $_CHOOSEPAGE . '&nbsp;';
		if ( ($actualPage-$around)>1) {
			$countfrom = $actualPage- $around;
			$returntext .= '<a href="' . encodeurl ($url) . '" class="opncenterbox">1</a>&nbsp;...&nbsp;';
		} else {
			$countfrom = 1;
		}
		if ( ($actualPage+$around)<$numberofPages) {
			$countto = $actualPage+ $around;
		} else {
			$countto = $numberofPages;
		}
		if ($countto+1 == $numberofPages) {
			$countto++;
		}
		for ($i = $countfrom; $i<= $countto; $i++) {
			if ($i <> $actualPage) {
				$url['offset'] = ( ($i-1)* $maxperpage);
				$returntext .= '<a href="' . encodeurl ($url) . '" class="opncenterbox">' . $i . '</a>&nbsp;';
			} else {
				$returntext .= $i . '&nbsp;';
			}
		}
		if ($countfrom<$actualPage) {
			$url['offset'] = ( ($actualPage-2)* $maxperpage);
			$returntext .= '<a href="' . encodeurl ($url) . '" class="opncenterbox">' . _DNT_PREVIOUSPAGE . '</a>&nbsp;';
		}
		if ($countto>$actualPage) {
			$url['offset'] = ( ($actualPage)* $maxperpage);
			$returntext .= '<a href="' . encodeurl ($url) . '" class="opncenterbox">' . _DNT_NEXTPAGE . '</a>&nbsp;';
		}
		if ($countto <> $numberofPages) {
			$url['offset'] = ( ($numberofPages-1)* $maxperpage);
			$returntext .= '...&nbsp;<a href="' . encodeurl ($url) . '" class="opncenterbox">' . $numberofPages . '</a>&nbsp;';
		}
		return $returntext;

	}

	function build_letterpagebar ($url, $query, $pos = '', $sql = '') {

		$bar = & new opn_page_bar;
		$bar->SetUrl ($url);
		$bar->SetQuery ($query);
		$bar->SetPos ($pos);
		$bar->SetSQL ($sql);
		return $bar->GetNiceLetterPagebar ();

	}
}

?>