<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_INCLUDE_MODULE_USERMEMBERLIST_PHP') ) {
	define ('_OPN_INCLUDE_MODULE_USERMEMBERLIST_PHP', 1);
	define ('_MUI_BYNUMBER', 0);
	// Get userinfo by uid
	define ('_MUI_BYNAME', 1);
	// Get userinfo by loginname
	// Sortingstuff
	define ('_MUI_SORTBYNUMBER', 0);
	// Sort by userid
	define ('_MUI_SORTBYNAME', 1);
	// Sort by username
	// Fieldstuff
	define ('_MUI_FIELDNUMBER', 0);
	define ('_MUI_FIELDTEXT', 1);
	define ('_MUI_FIELDIMAGE', 2);
	define ('_MUI_FIELDURL', 3);
	define ('_MUI_FIELDMAILTO', 4);
	define ('_MUI_FIELDIMGURL', 5);
	define ('_MUI_FIELDIMGMAILTO', 6);
	define ('_MUI_FIELDIMGTEXT', 7);
	define ('_MUI_FIELDDATE', 8);
	define ('_MUI_FIELDIMAGECHECK', 9);

	function GetATag ($wichUrl, $wichText, $target = '', $class = 'opncenterbox') {

		$help = '<a href="' . $wichUrl . '" class="' . $class . '"';
		if ($target != '') {
			$help .= ' target="' . $target . '"';
		}
		$help .= '>' . $wichText . '</a>';
		return $help;

	}

	/******************************************************************************
	* Function: formatValue
	* Purpose : Formats the userinfo.
	* Input   : $type      = The fieldtype.
	*           $formattag = The formatstring.
	*           $value     = The fieldvalue
	* Output  : The formatted value.
	* Author  : Hombergs
	******************************************************************************/

	function formatValue ($type, $formattag, $value) {

		global $opnConfig;
		if ($value == '') {
			$help = '';
		} elseif ($type == _MUI_FIELDIMAGE) {
			if (substr_count ($formattag, '%s')>0) {
				$help1 = sprintf ($formattag, $value);
			} else {
				$help1 = $formattag . $value;
			}
			$help = '<img src="' . $help1 . '" class="imgtag" alt="" />' . _OPN_HTML_NL;
		} elseif ($type == _MUI_FIELDIMAGECHECK) {
			$height = '';
			$width = '';
			if ($formattag['width']) {
				$width = ' width="' . $formattag['width'] . '"';
			}
			if ($formattag['height']>$formattag['height']) {
				$height = ' height="' . $formattag['height'] . '"';
			}
			$help = '<img src="' . $value . '"' . $width . $height . ' alt="" class="imgtag" />' . _OPN_HTML_NL;
		} elseif ($type == _MUI_FIELDURL) {
			if (trim ($value != 'http://') ) {
				if ($formattag != '') {
					if (substr_count ($formattag, '%s')>0) {
						$help1 = sprintf ($formattag, $value);
					} else {
						$help1 = $formattag . $value;
					}
				} else {
					$help1 = $value;
				}
				$help = GetATag ($help1, $value, "_blank") . _OPN_HTML_NL;
			} else {
				$help = '';
			}
		} elseif ($type == _MUI_FIELDMAILTO) {
			if ($formattag != '') {
				if (substr_count ($formattag, '%s')>0) {
					$help1 = sprintf ($formattag, $value);
				} else {
					$help1 = $formattag . $value;
				}
			} else {
				$help1 = 'mailto:' . $value;
			}
			$help = GetATag ($help1, $value) . _OPN_HTML_NL;
		} elseif ($type == _MUI_FIELDIMGURL) {
			if (trim ($value != 'http://') ) {
				if (empty ($formattag) ) {
					$help1 = $value;
				} else {
					$imgt = $formattag[0];
					$urlt = $formattag[1];
					if ($urlt != '') {
						if (substr_count ($urlt, '%s')>0) {
							$help1 = sprintf ($urlt, $value);
						} else {
							$help1 = $urlt . $value;
						}
					} else {
						$help1 = $value;
					}
					$help1 = '<a href="' . $help1 . '" class="opncenterbox" target="_blank">';
					if ($imgt != '') {
						$help1 .= '<img src="' . $imgt . '" class="imgtag" title="' . $value . '" alt="' . $value . '" />';
					}
					$help1 .= '</a>' . _OPN_HTML_NL;
				}
				$help = $help1;
			} else {
				$help = '';
			}
		} elseif ($type == _MUI_FIELDIMGMAILTO) {
			if (empty ($formattag) ) {
				$help1 = $value;
			} else {
				$imgt = $formattag[0];
				if ($imgt != '') {
					$help1 = $opnConfig['crypttext']->CodeImageEmail ($value, $imgt, 'opncenterbox');
				} else {
					$help1 = $opnConfig['crypttext']->CodeEmail ($value, '', 'opncenterbox');
				}
			}
			$help = $help1;
		} elseif ($type == _MUI_FIELDIMGTEXT) {
			if (empty ($formattag) ) {
				$help1 = $value;
			} else {
				$imgt = $formattag[0];
				if ($imgt != '') {
					$help1 = '<img src="' . $imgt . '" class="imgtag" title="' . $value . '" alt="' . $value . '" />';
				} else {
					$help1 = $value;
				}
			}
			$help = $help1 . _OPN_HTML_NL;
		} elseif ($type == _MUI_FIELDDATE) {
			if ($value>0) {
				$opnConfig['opndate']->sqlToopnData ($value);
				$help = '';
				$opnConfig['opndate']->formatTimestamp ($help, _DATE_DATESTRING4);
			} else {
				$help = '';
			}
		} else {
			$help = $value . _OPN_HTML_NL;
		}
		return $help;

	}
}

?>