<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_INI_OPTIONS_GET') ) {
	define ('_OPN_INI_OPTIONS_GET', 1);

	function get_accessibility_options () {

		$options = array ();
		$options[_OPN_ACCESSIBILITY_DEFAULT] = _OPN_VAR_ACCESSIBILITY_DEFAULT;
		$options[_OPN_ACCESSIBILITY_ACCESSIBILITY] = _OPN_VAR_ACCESSIBILITY_ACCESSIBILITY;
		$options[_OPN_ACCESSIBILITY_NOGFX] = _OPN_VAR_ACCESSIBILITY_NOGFX;
		return $options;

	}

	function get_language_filterfile ($var) {

		$rc = 0;
		if (substr ($var, 0, 5) == 'lang-') {
			$rc = 1;
		}
		return $rc;

	}

	function get_language_options () {

		$options = array ();
		$filelist = get_file_list (_OPN_ROOT_PATH . 'language/');
		arrayfilter ($filelist, $filelist, 'get_language_filterfile');
		natcasesort ($filelist);
		reset ($filelist);
		$options['0'] = _OPN_ALL;
		foreach ($filelist as $file) {
			$lang = substr ($file, 5);
			$lang = explode ('.', $lang);
			$options[$lang[0]] = $lang[0];
		}
		return $options;

	}

	function get_theme_tpl_options ($makeall = true) {

		global $opnConfig;

		$options = array ();
		$options['opnindex'] = '*' . _AF_INDEXHOME . '*';
		if ($makeall) {
			$options[''] = '*' . _OPN_ALL . '*';
		}
		$plug = array ();
		$opnConfig['installedPlugins']->getplugin ($plug, 'theme_tpl');
		foreach ($plug as $var1) {
			$options[$var1['plugin']] = $var1['module'];
		}
		$plug = array ();
		$opnConfig['installedPlugins']->getplugin ($plug, 'own_theme_tpl');
		foreach ($plug as $var1) {
			include_once (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/own_theme_tpl/index.php');
			$func = $var1['module'] . '_get_own_theme_tpl';
			$func ($options);
		}
		asort ($options);
		return $options;

	}
}

?>