<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_INCLUDE_OPN_SYSTEM_FUNCTION_TEXT_PHP') ) {
	define ('_OPN_INCLUDE_OPN_SYSTEM_FUNCTION_TEXT_PHP', 1);
	// opn - systemfunction
	// this was the older text handling functions

	function FixQuotes ($what = "") {
		// #opn_use_stripslashes
		// # Set to 0 calls the old function
		// # Set to 1 calls StripSlashes($what)
		$what = str_replace ("'", "''", $what);
		while (preg_match ("/\\\\'/i", $what) ) {
			$what = preg_replace ("/\\\\'/", "'", $what);
		}
		return $what;

	}

	/*********************************************************/

	/* text filter										   */

	/*********************************************************/

	/**
	* removes "bad" words according to defined censors text
	*
	* @param string $Message
	* @return string
	*/

	function check_words ($Message) {

		global $opnConfig;

		$EditedMessage = $Message;
		if ($opnConfig['CensorMode'] != 0) {
			if (is_array ($opnConfig['CensorList']) ) {
				$Replacement = $opnConfig['CensorReplace'];
				$CensorList = $opnConfig['CensorList'];
				if ($opnConfig['CensorMode'] == 1) {

					# Exact match
					$max = count ($CensorList);
					for ($i = 0; $i< $max; $i++) {
						$EditedMessage = preg_replace ('/' . $CensorList[$i] . '([^a-zA-Z0-9])/i', $Replacement . '\\1', $EditedMessage);
					}
				} elseif ($opnConfig['CensorMode'] == 2) {

					# Word beginning
					$max = count ($CensorList);
					for ($i = 0; $i< $max; $i++) {
						$EditedMessage = preg_replace ('/(^|[^[a-z0-9]])$/i' . $CensorList[$i], '\\1' . $Replacement, $EditedMessage);
					}
				} elseif ($opnConfig['CensorMode'] == 3) {

					# Word fragment
					$max = count ($CensorList);
					for ($i = 0; $i < $max; $i++) {
						$EditedMessage = preg_replace ('/' . $CensorList[$i] . '/i', $Replacement, $EditedMessage);
					}
				}
			}
		}
		return ($EditedMessage);

	}

	/**
	* Removes the options for the named html tags in $tags
	*
	* @param string $html
	* @param string $tags use | to seperate the tags inside the string
	* @return string
	*/

	function restrictedHTML ($html, $tags = 'br') {

		$html = preg_replace ('/<([' . $tags . '])[^>]*>/', '<\\1>', $html);
		return $html;

	}

	/**
	* builds a valid tag string for restricted HTML
	*
	* @return string
	*/

	function get_restrictedTags () {

		global $opnConfig;

		$allowedstr = '';
		if (is_array ($opnConfig['AllowableHTML']) ) {
			foreach ($opnConfig['AllowableHTML'] as $key => $v) {
				if ($v == 1) {
					if ($allowedstr <> '') {
						$allowedstr .= '|';
					}
					$allowedstr .= $key;
				}
			}
		}
		return $allowedstr;

	}

	/**
	* builds a tag string with all allowed tagnames
	*
	* @return string
	*/

	function get_allowedTags () {

		global $opnConfig;

		$allowedstr = '';
		if (is_array ($opnConfig['AllowableHTML']) ) {
			$tmparr = array_keys ($opnConfig['AllowableHTML']);
			foreach ($tmparr as $key) {
				$allowedstr .= '<' . $key . '>';
			}
		}
		return $allowedstr;

	}

	/**
	* removes all non html stuff from $str
	*
	* @param string $str
	* @param string strip - if set to "nohtml" you may override the allowed tags to nothing
	* @return string
	*/

	function check_html ($str, $strip = '') {

		$allowedTags = get_allowedTags ();
		$restrictedTags = get_restrictedTags ();
		if ($strip == 'nohtml') {
			$allowedTags = '';
			$restrictedTags = '';
		}
		$str = strip_tags ($str, $allowedTags);
		if ($restrictedTags <> '') {
			$str = restrictedHTML ($str, $restrictedTags);
		}
		// Squash PHP tags unconditionally
		$str = preg_replace ('/<\?/', '', $str);
		return $str;

	}

	/**
	* Filters $Message trough a html check and replaces bad words
	*
	* @param string $Message
	* @param string $strip
	* @return string
	*/

	function filter_text ($Message, $strip = '') {

		$EditedMessage = check_words ($Message);
		$EditedMessage = check_html ($EditedMessage, $strip);
		return $EditedMessage;

	}
}

?>