<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_INCLUDE_OPNSERVERINI_PHP') ) {
	define ('_OPN_INCLUDE_OPNSERVERINI_PHP', 1);

	/* accessibility */

	define ('_OPN_VAR_ACCESSIBILITY_DEFAULT', 0);
	define ('_OPN_VAR_ACCESSIBILITY_ACCESSIBILITY', 1);
	define ('_OPN_VAR_ACCESSIBILITY_NOGFX', 2);

	/* table sorting */

	define ('_OPN_VAR_TABLE_SORT_PREFIX', '');
	define ('_OPN_VAR_TABLE_SORT_VAR', 'sortby');

	/* table hidden */

	define ('_OPN_VAR_TABLE_HIDDEN_PREFIX', 'hidden_');
	define ('_OPN_VAR_TABLE_HIDDEN_VAR', 'hidethefield');

	/* main user settings */

	define ('__USER_CONFIG__', 'admin/openphpnuke');
	define ('_USER_CONFIG_FORM_HTML_', __USER_CONFIG__ . 'use_form_html');
	define ('_USER_CONFIG_FORM_SMILE_', __USER_CONFIG__ . 'use_form_smile');
	define ('_USER_CONFIG_FORM_UIMAGES_', __USER_CONFIG__ . 'use_form_uimages');

	/* Highlighting */

	/**
	* Perform a simple text replace
	* This should be used when the string does not contain HTML
	* (off by default)
	*/

	define ('STR_HIGHLIGHT_SIMPLE', 1);

	/**
	* Only match whole words in the string
	* (off by default)
	*/

	define ('STR_HIGHLIGHT_WHOLEWD', 2);

	/**
	* Case sensitive matching
	* (off by default)
	*/

	define ('STR_HIGHLIGHT_CASESENS', 4);

	/**
	* Overwrite links if matched
	* This should be used when the replacement string is a link
	* (off by default)
	*/

	define ('STR_HIGHLIGHT_STRIPLINKS', 8);

	/**
	* opn object datatype
	*
	**/

	define ('_OOBJ_DTYPE_EMAIL', '10010');
	define ('_OOBJ_DTYPE_URL', '10020');
	define ('_OOBJ_DTYPE_CLEAN', '10030');
	define ('_OOBJ_DTYPE_CHECK', '10040');
	define ('_OOBJ_DTYPE_INT', '10050');
	define ('_OOBJ_DTYPE_ODATE', '10060');
	define ('_OOBJ_DTYPE_HTML', '20010');
	define ('_OOBJ_DTYPE_BBCODE', '20020');
	define ('_OOBJ_DTYPE_CBR', '20030');
	define ('_OOBJ_DTYPE_SMILE', '20040');
	define ('_OOBJ_DTYPE_UIMAGES', '20050');
	define ('_OOBJ_DTYPE_SIG', '20060');

	/**
	* opn object class types
	*
	**/

	define ('_OOBJ_CLASS_REGISTER_POLL', '*class.opn_poll.php*');
	define ('_OOBJ_CLASS_REGISTER_COMMENTS', '*class.opn_comments.php*');
	define ('_OOBJ_CLASS_REGISTER_CATS', '*class.opn_categorie.php*');
	define ('_OOBJ_CLASS_REGISTER_OWNFIELDS', '*class.opn_ownfields.php*');
	if (!function_exists ('print_array') ) {

		function print_array ($array, $html = true) {
			if (gettype ($array) == 'array') {
				if ($html) {
					$boxtxt = '<ul>';
				}
				foreach ($array as $index => $subarray) {
					if ($html) {
						$boxtxt .= '<li>' . $index . ' ::=&gt; ';
					} else {
						$boxtxt .= '>>' . $index . ' ::=> ';
					}
					$boxtxt .= print_array ($subarray);
					if ($html) {
						$boxtxt .= '</li>';
					} else {
						$boxtxt .= _OPN_HTML_NL;
					}
				}
				if ($html) {
					$boxtxt .= '</ul>';
				}
			} else {
				$boxtxt = $array;
			}
			return $boxtxt;

		}
	}

	function opn_version () {
		return versionnr () . ' ' . versionname () . ' (Revision ' . _get_core_revision_version () . ')';

	}

	function opn_version_complete () {
		return versionnr () . ' ' . versionname () . ' (Revision ' . _get_core_revision_version () . _get_dev_revision_version () . _get_indev_revision_version () . _get_pro_revision_version () . _get_professional_revision_version () . _get_themes_revision_version () . ')';

	}

	function buildnr () {
		return _get_core_major_version () . _get_core_minor_version () . _get_core_bugfix_version ();

	}

	function versionnr () {
		return _get_core_major_version () . '.' . _get_core_minor_version () . '.' . _get_core_bugfix_version ();

	}
	if (!function_exists ('init_prg_master') ) {

		function init_prg_master (&$initprg) {

			global $opnConfig;

			$initprg .= "\$opnConfig['root_path'] = \$root_path;";
			$initprg .= "define('_OPN_ROOT_PATH',\"\$root_path\");";
			$initprg .= "\$opnConfig['opn_mysql_pconnect']=0;";
			$initprg .= "\$opnConfig['opnOption']['show_middleblock']=0;";
			$initprg .= "\$opnConfig['opnOption']['show_rblock']=" . $opnConfig['show_rblock'] . ';';
			$initprg .= "\$opnConfig['cookiePrefix'] = \"openphpnuke\";";
			$initprg .= "include_once (_OPN_ROOT_PATH.'admin/openphpnuke/version.php');";
			$initprg .= "\$opnConfig['opn_version']='openPHPnuke '.opn_version();";

		}
	}
	if (!function_exists ('init_prg_ini') ) {

		function init_prg_ini (&$initprg) {

			$initprg .= "\$opnConfig['dbhost'] = \$dbhost;";
			$initprg .= "\$opnConfig['dbconnstr'] = \$dbconnstr;";
			$initprg .= "unset(\$dbconnstr);";
			$initprg .= "unset(\$dbhost);";
			$initprg .= "\$opnConfig['theserver']=\$serveradr;";
			$initprg .= "\$opnConfig['dbuname'] = \$dbuname;";
			$initprg .= "\$opnConfig['dbpass'] = \$dbpass;";
			$initprg .= "\$opnConfig['dbname'] = \$dbname;";
			$initprg .= "\$opnConfig['system'] = \$system;";
			$initprg .= "\$opnConfig['dbdriver'] = \$dbdriver;";
			$initprg .= "\$opnConfig['tableprefix'] = \$opn_tableprefix;";
			$initprg .= "\$opnConfig['dbdialect'] = \$dbdialect;";
			$initprg .= "\$opnConfig['dbcharset'] = \$dbcharset;";
			$initprg .= "\$opnConfig['opn_installdir']=\$installdir;";
			$initprg .= "\$opnConfig['multihome_config'] = false;";
			$initprg .= "\$a=\$serveradr;";

		}
	}
	if (!function_exists ('init_prg_multihome') ) {

		function init_prg_multihome (&$initprg) {

			$initprg .= "\$opnConfig['multihome'] = array ();";
			$initprg .= "\$opnConfig['multihome_config'] = true;";
			$initprg .= "\$multihomeConfig = array ();";
			$initprg .= "\$multihomeConfig['dbhost'] = \$master_dbhost;";
			$initprg .= "\$multihomeConfig['dbconnstr'] = '';";
			$initprg .= "unset(\$master_dbhost);";
			$initprg .= "\$multihomeConfig['theserver']=\$serveradr;";
			$initprg .= "\$multihomeConfig['dbuname'] = \$master_dbuname;";
			$initprg .= "\$multihomeConfig['dbpass'] = \$master_dbpass;";
			$initprg .= "\$multihomeConfig['dbname'] = \$master_dbname;";
			$initprg .= "\$multihomeConfig['system'] = \$system;";
			$initprg .= "\$multihomeConfig['dbdriver'] = \$master_dbdriver;";
			$initprg .= "\$multihomeConfig['tableprefix'] = \$master_opn_tableprefix;";
			$initprg .= "\$multihomeConfig['dbdialect'] = '';";
			$initprg .= "\$multihomeConfig['dbcharset'] = '';";
			$initprg .= "\$multihomeConfig['opn_installdir']=\$installdir;";

		}
	}
	if (!function_exists ('DebugBreak') ) {

		function DebugBreak () {

			/*Just a Dummy Function if no dbg is installed on the Server */

		}
	}
	if (!function_exists ('memory_get_usage') ) {

		function memory_get_usage () {
			return 'no info - its windows';

			/*Just a Dummy Function if this is no Linux Server */

		}
	}
	if (!function_exists ('checkdnsrr') ) {

		function checkdnsrr ($host, $type = 'MX') {
			if (!empty ($host) ) {
				$output = '';
				@exec ("nslookup -type=$type $host", $output);
				foreach ($output as $line) {

					# Valid records begin with host name:
					if (preg_match ("/^$host/i", $line) ) {
						return true;
					}
				}
			}
			return false;

		}
	}
	if (!function_exists ('getmxrr') ) {

		function getmxrr ($hostname, &$mxhosts) {
			if (!is_array ($mxhosts) ) {
				$mxhosts = array ();
			}
			if (!empty ($hostname) ) {
				#$output='';
				#$ret='';
				#			@exec( "nslookup -type=MX $hostname", $output, $ret);
				$output = '';
				@exec ("nslookup -type=MX $hostname", $output);
				foreach ($output as $line) {

					# Valid records begin with hostname:
					$parts = '';
					if (preg_match ("/^$hostname\tMX preference = ([0-9]+), mail exchanger = (.*)$/", $line, $parts) ) {
						$mxhosts[$parts[1]] = $parts[2];
					}
				}
				if (count ($mxhosts) ) {
					reset ($mxhosts);
					ksort ($mxhosts);
					$i = 0;
					foreach ($mxhosts as $host) {
						$mxhosts2[$i] = $host;
						$i++;
					}
					$mxhosts = $mxhosts2;
					return true;
				}
				return false;
			}
			return false;

		}
	}
	if (!function_exists ('file_get_contents') ) {

		function file_get_contents ($filename, $incpath = false, $resource_context = null) {

			$tn = $resource_context;
			if (false === $fh = fopen ($filename, 'rb', $incpath) ) {
				trigger_error ('file_get_contents() failed to open stream: No such file or directory', E_USER_WARNING);
				return false;
			}
			clearstatcache ();
			if ($fsize = filesize ($filename) ) {
				$data = fread ($fh, $fsize);
			} else {
				while (!feof ($fh) ) {
					$data .= fread ($fh, 8192);
				}
			}
			fclose ($fh);
			return $data;

		}
	}
	if (!function_exists ('array_diff_assoc') ) {

		function array_diff_assoc () {
			// Check we have enough arguments
			$args = func_get_args ();
			$count = count ($args);
			if (count ($args)<2) {
				trigger_error ('Wrong parameter count for array_diff_assoc()', E_USER_WARNING);
				return null;
			}
			// Check arrays
			for ($i = 0; $i< $count; $i++) {
				if (!is_array ($args[$i]) ) {
					trigger_error ('array_diff_assoc() Argument #' . ($i+1) . ' is not an array', E_USER_WARNING);
					return null;
				}
			}
			// Get the comparison array
			$array_comp = array_shift ($args);
			-- $count;
			// Traverse values of the first array
			foreach ($array_comp as $key => $value) {
				// Loop through the other arrays
				for ($i = 0; $i< $count; $i++) {
					// Loop through this arrays key/value pairs and compare
					foreach ($args[$i] as $comp_key => $comp_value) {
						if ((string) $key === (string) $comp_key && (string) $value === (string) $comp_value) {
							unset ($array_comp[$key]);
						}
					}
				}
			}
			return $array_comp;

		}
	}
	if (!function_exists ('vsprintf') ) {

		function vsprintf ($format, $args) {
			if (count ($args)<2) {
				trigger_error ('vsprintf() Too few arguments', E_USER_WARNING);
				return;
			}
			array_unshift ($args, $format);
			return call_user_func_array ('sprintf', $args);

		}
	}
	if (!function_exists ('vprintf') ) {

		function vprintf ($format, $args) {
			if (count ($args)<2) {
				trigger_error ('vprintf() Too few arguments', E_USER_WARNING);
				return;
			}
			array_unshift ($args, $format);
			return call_user_func_array ('printf', $args);

		}
	}
	if (!function_exists ('fprintf') ) {

		function fprintf () {

			$args = func_get_args ();
			if (count ($args)<2) {
				trigger_error ('Wrong parameter count for fprintf()', E_USER_WARNING);
				return false;
			}
			$resource_handle = array_shift ($args);
			$format = array_shift ($args);
			if (!is_resource ($resource_handle) ) {
				trigger_error ('fprintf(): supplied argument is not a valid stream resource', E_USER_WARNING);
				return false;
			}
			return fwrite ($resource_handle, vsprintf ($format, $args) );

		}
	}
	if (!function_exists ('str_highlight') ) {

		function str_highlight ($text, $needle, $options = null, $highlight = null) {
			// Default highlighting
			if ($highlight === null) {
				$highlight = '<strong>\1</strong>';
			}
			// Select pattern to use
			if ($options&STR_HIGHLIGHT_SIMPLE) {
				$pattern = '#(%s)#';
			} else {
				$pattern = '#(?!<.*?)(%s)(?![^<>]*?>)#';
				$sl_pattern = '#<a\s(?:.*?)>(%s)</a>#';
			}
			// Case sensitivity
			if ($options^STR_HIGHLIGHT_CASESENS) {
				$pattern .= 'i';
				$sl_pattern .= 'i';
			}
			$needle = (array) $needle;
			foreach ($needle as $needle_s) {
				if ($needle_s == '') {
					continue;
				}
				$needle_s = opn_preg_quote ($needle_s);
				// Escape needle with optional whole word check
				if ($options&STR_HIGHLIGHT_WHOLEWD) {
					$needle_s = '\b' . $needle_s . '\b';
				}
				// Strip links
				if ($options&STR_HIGHLIGHT_STRIPLINKS) {
					$sl_regex = sprintf ($sl_pattern, $needle_s);
					$text = preg_replace ($sl_regex, '\1', $text);
				}
				$regex = sprintf ($pattern, $needle_s);
				$text = preg_replace ($regex, $highlight, $text);
			}
			return $text;

		}
	}
	if (!function_exists ('version_compare') ) {

		function version_compare ($version1, $version2, $operator = '<') {
			// Check input
			if (!is_scalar ($version1) ) {
				trigger_error ('version_compare() expects parameter 1 to be string, ' . gettype ($version1) . ' given', E_USER_WARNING);
				return;
			}
			if (!is_scalar ($version2) ) {
				trigger_error ('version_compare() expects parameter 2 to be string, ' . gettype ($version2) . ' given', E_USER_WARNING);
				return;
			}
			if (!is_scalar ($operator) ) {
				trigger_error ('version_compare() expects parameter 3 to be string, ' . gettype ($operator) . ' given', E_USER_WARNING);
				return;
			}
			// Standardise versions
			$v1 = explode ('.', str_replace ('..', '.', preg_replace ('/([^0-9\.]+)/', '.$1.', str_replace (array ('-',
																'_',
																'+'),
																'.',
																trim ($version1) ) ) ) );
			$v2 = explode ('.', str_replace ('..', '.', preg_replace ('/([^0-9\.]+)/', '.$1.', str_replace (array ('-',
																'_',
																'+'),
																'.',
																trim ($version2) ) ) ) );
			// Replace empty entries at the start of the array
			while (empty ($v1[0]) && array_shift ($v1) ) {
			}
			while (empty ($v2[0]) && array_shift ($v2) ) {
			}
			// Describe our release states
			$versions = array ('dev' => 0,
					'alpha' => 1,
					'a' => 1,
					'beta' => 2,
					'b' => 2,
					'RC' => 3,
					'p' => 4,
					'pl' => 4);
			// Loop through each segment in the version string
			$compare = 0;
			for ($i = 0, $x = min (count ($v1), count ($v2) ); $i< $x; $i++) {
				if ($v1[$i] == $v2[$i]) {
					continue;
				}
				if (is_numeric ($v1[$i]) && is_numeric ($v2[$i]) ) {
					$compare = ($v1[$i]< $v2[$i])?-1 : 1;
				} elseif (is_numeric ($v1[$i]) ) {
					$compare = 1;
				} elseif (is_numeric ($v2[$i]) ) {
					$compare = -1;
				} elseif (isset ($versions[$v1[$i]]) && isset ($versions[$v2[$i]]) ) {
					$compare = ($versions[$v1[$i]]< $versions[$v2[$i]])?-1 : 1;
				} else {
					$compare = strcmp ($v2[$i], $v1[$i]);
				}
				break;
			}
			// If previous loop didn't find anything, compare the "extra" segments
			if ($compare == 0) {
				if (count ($v2)>count ($v1) ) {
					if (isset ($versions[$v2[$i]]) ) {
						$compare = ($versions[$v2[$i]]<4)?1 : -1;
					} else {
						$compare = -1;
					}
				} elseif (count ($v2)<count ($v1) ) {
					if (isset ($versions[$v1[$i]]) ) {
						$compare = ($versions[$v1[$i]]<4)?-1 : 1;
					} else {
						$compare = 1;
					}
				}
			}
			// Compare the versions
			if (func_num_args ()>2) {
				switch ($operator) {
					case '>':
					case 'gt':
						return (bool) ($compare>0);
					case '>=':
					case 'ge':
						return (bool) ($compare >= 0);
					case '<=':
					case 'le':
						return (bool) ($compare<=0);
					case '==':
					case '=':
					case 'eq':
						return (bool) ($compare == 0);
					case '<>':
					case '!=':
					case 'ne':
						return (bool) ($compare != 0);
					case '':
					case '<':
					case 'lt':
						return (bool) ($compare<0);
					default:
						return;
					}
				}
				return $compare;

		}
	}
	if (!function_exists ('stripos') ) {

		function stripos ($haystack, $needle, $offset = 0) {
			return strpos (strtolower ($haystack), strtolower ($needle), $offset);

		}
	}
	if (!function_exists ('strripos') ) {

		function strepos ($haystack, $needle, $offset = 0) {

			$pos_rule = ($offset<0)?strlen ($haystack)+ ($offset-1) : $offset;
			$last_pos = false;
			$first_run = true;
			do {
				$pos = strpos ($haystack, $needle, (intval ($last_pos)+ ( ($first_run)?0 : strlen ($needle) ) ) );
				if ($pos !== false && ( ($offset<0 && $pos<=$pos_rule) || $offset >= 0) ) {
					$last_pos = $pos;
				} else {
					break;
				}
				$first_run = false;
			}
			while ($pos !== false);
			if ($offset>0 && $last_pos<$pos_rule) {
				$last_pos = false;
			}
			return $last_pos;

		}

		function strripos ($haystack, $needle, $offset = 0) {
			return strepos (strtolower ($haystack), strtolower ($needle), $offset);

		}
	}
}
if (!function_exists ('str_ireplace') ) {

	function str_ireplace ($search, $replace, $subject, $count = null) {
		// Sanity check
		if (is_string ($search) && is_array ($replace) ) {
			user_error ('Array to string conversion', E_USER_NOTICE);
			$replace = (string) $replace;
		}
		// If search isn't an array, make it one
		if (!is_array ($search) ) {
			$search = array ($search);
		}
		$search = array_values ($search);
		// If replace isn't an array, make it one, and pad it to the length of search
		if (!is_array ($replace) ) {
			$replace_string = $replace;
			$replace = array ();
			$counted = count ($search);
			for ($i = 0, $c = $counted; $i< $c; $i++) {
				$replace[$i] = $replace_string;
			}
		}
		$replace = array_values ($replace);
		// Check the replace array is padded to the correct length
		$length_replace = count ($replace);
		$length_search = count ($search);
		if ($length_replace<$length_search) {
			for ($i = $length_replace; $i< $length_search; $i++) {
				$replace[$i] = '';
			}
		}
		// If subject is not an array, make it one
		$was_array = false;
		if (!is_array ($subject) ) {
			$was_array = true;
			$subject = array ($subject);
		}
		// Loop through each subject
		$count = 0;
		foreach ($subject as $subject_key => $subject_value) {
			// Loop through each search
			foreach ($search as $search_key => $search_value) {
				// Split the array into segments, in between each part is our search
				$segments = explode (strtolower ($search_value), strtolower ($subject_value) );
				// The number of replacements done is the number of segments minus the first
				$count += count ($segments)-1;
				$pos = 0;
				// Loop through each segment
				foreach ($segments as $segment_key => $segment_value) {
					// Replace the lowercase segments with the upper case versions
					$segments[$segment_key] = substr ($subject_value, $pos, strlen ($segment_value) );
					// Increase the position relative to the initial string
					$pos += strlen ($segment_value)+strlen ($search_value);
				}
				// Put our original string back together
				$subject_value = implode ($replace[$search_key], $segments);
			}
			$result[$subject_key] = $subject_value;
		}
		// Check if subject was initially a string and return it as a string
		if ($was_array === true) {
			return $result[0];
		}
		// Otherwise, just return the array
		return $result;

	}
}
if ( (!function_exists ('Check_Server') ) && (defined ('_OPN_MAINFILE_INCLUDED') ) ) {

	function Check_Server () {

		global $opnConfig;

		$opnConfig['root_path_datasave'] = _OPN_ROOT_PATH . 'cache/';

	}
}
if ( (!function_exists ('init_prg') ) && (defined ('_OPN_MAINFILE_INCLUDED') ) ) {

	function init_prg (&$initprg) {

		$initprg .= "\$opnConfig['root_path_datasave'] = \$root_path.\"cache/\";";

	}
}

?>