#!/usr/bin/perl -w
#
# OpenPHPNuke: Great Web Portal System
# Professionell-Module
#
# Copyright (c) 2001-2006 by
# Heinz Hombergs heinz@hhombergs.de
# Stefan Kaletta stefan@kaletta.de
# Alexander Weber xweber@kamelfreunde.de
#
# This program is NOT free software.
# See LICENSE for details.
#
#
# Compilerpragma strict um keine Fehler zu machen :-)
use strict;

# Benutzung der Perl-Module CGI, Switch
use CGI;
use DBI;
use Switch;

# Global variables

%main::cfg = ();

$main::cfg_file = '/etc/openphpnuke.cfg';
$main::cfg_re = '^([\_A-Za-z0-9]+) *= *([^\n\r]*)[\n\r]';

#$main::engine_debug = '_on_';
$main::engine_debug = 'off';

$main::el_sep = "\t#\t";
@main::el = ();

%main::opnTables = ();
%main::opnConfig = ();
%main::sysConfig = ();

$main::db_host = undef;
$main::db_user = undef;
$main::db_pwd = undef;
$main::db_name = undef;
@main::db_connect = ();
#$main::db = undef;

sub push_el {
	
	my ($el, $sub_name, $msg) = @_;
	
	push @$el, "$sub_name".$main::el_sep."$msg";
	
	if ($main::engine_debug eq '') {
		
		print STDOUT "DEBUG: push_el() sub_name: $sub_name, msg: $msg\n";
		
	}
}

sub get_file {
	
	my ($fname) = @_;
	
	push_el(\@main::el, 'get_file()', 'Starting...');
	
	if (!defined($fname) || ($fname eq '')) {
		
		push_el(
				\@main::el, 
				'get_file()', 
				"ERROR: Undefined input data, fname: |$fname| !"
			   );
		
		return (-1, '');
	}
	
	if (! -e $fname) {
		
		push_el(
				\@main::el, 
				'get_file()', 
				"ERROR: File '$fname' does not exist !"
			   );
		
		return (-1, '');
		
	}
	
	my $res = open(F, '<', $fname);
	
	if (!defined($res)) {
		
		push_el(
				\@main::el, 
				'get_file()', 
				"ERROR: Can't open '$fname' for reading !"
			   );
		
		return (-1, '');
	
	}
	
	my @fdata = <F>;
	
	close(F);
	
	my $line = join('', @fdata);
	
	push_el(\@main::el, 'get_file()', 'Ending...');
	
	return (0, $line);
	
}

sub setup_main_vars {
	
	push_el(\@main::el, 'setup_main_vars()', 'Starting...');
	
	# Database backend vars;
	
	$main::db_host = $main::cfg{'DATABASE_HOST'};
	$main::db_user = $main::cfg{'DATABASE_USER'};
	$main::db_pwd = $main::cfg{'DATABASE_PASSWORD'};
	$main::db_name = $main::cfg{'DATABASE_NAME'};
	
	@main::db_connect = (
						 "DBI:mysql:$main::db_name:$main::db_host",
						 $main::db_user,
						 $main::db_pwd
						);
	
	push_el(\@main::el, 'setup_main_vars()', 'Ending...');
	
	return 0;
}

sub get_conf {
	
	push_el(\@main::el, 'get_conf()', 'Starting...');
	
	my ($rs, $fline) = get_file($main::cfg_file);
	
	return -1 if ($rs != 0);
	
	my @frows = split(/\n/, $fline);
	
	my $i = '';
	
	for ($i = 0; $i < scalar(@frows); $i++) {
		
		$frows[$i] = "$frows[$i]\n";
		
		if ($frows[$i] =~ /$main::cfg_re/) {
			
			$main::cfg{$1} = $2; 
			
		}
	}
	
	return -1 if (setup_main_vars() != 0);
	
	push_el(\@main::el, 'get_conf()', 'Ending...');

	require $main::cfg{'ROOT_PATH'}.'class/shell/perl/opn_common_code.pl';

	my ($dummy, $rdata, $row) = (undef, undef, undef);

	my $sql = 'SELECT * FROM opn_dbcat;';
		($rs, $rdata) = doSQL($sql);

	for $row (@$rdata) {
		my($id, $var) = @$row;
		$main::opnTables{$var}='opn_'.$var;
	}


	$sql = 'SELECT modulename, settings, psettings FROM '. $main::opnTables{'configs'}.' WHERE modulename="admin/openphpnuke";';
		($rs, $rdata) = doSQL($sql);

	for $row (@$rdata) {
		my($modulename, $settings, $psettings) = @$row;

		$dummy = unserialize($settings);

		%main::opnConfig = %{$dummy};

		$dummy = unserialize($psettings);

		%main::sysConfig = %{$dummy};


	}

	
	return 0;

}

my ($rs, $rdata) = (undef, undef);

# Read Config into array

$rs = get_conf();

# Neues CGI-Objekt erzeugen
my $cgi_obj = new CGI;
my $module = $cgi_obj->param('module');

switch ($module) {
	case 'errorlog' {
		require $main::cfg{'ROOT_PATH'}.'class/shell/perl/opn_errorlog_code.pl';
		$rs = main_errorlog();
 	} case 'session' {
		require $main::cfg{'ROOT_PATH'}.'class/shell/perl/opn_opnsession_code.pl';
		$rs = main_opnsession();
 	} case 'spooling' {
		require $main::cfg{'ROOT_PATH'}.'class/shell/perl/opn_spooling_code.pl';
		$rs = main_spooling();
 	} case 'sysinfo' {
		require $main::cfg{'ROOT_PATH'}.'class/shell/perl/opn_sysinfo_code.pl';
		$rs = main_sysinfo();
 	} case 'pro' {
		require $main::cfg{'ROOT_PATH'}.'class/shell/perl/opn_pro_code.pl';
		$rs = main_pro();
 	} else {
		print "\n";
		print "worng parameter used\n";
		print "\n";
		print "$module not found \n";
 	}
}

#print $main::opnConfig{'opn_url'}."<-\n";
#print $main::sysConfig{'path_to_vhost'}."<-\n";
#dump_hash($main::opnConfig, []);

