/** Arraycontent
	array ('fieldname', 'checktype', 'errormessage', 'regex', length)

	Checktype:
	b	=	Element must not contain any spaces.
	c	=	Correct the name.
	e	=	Element can't be empty.
	f	=	Checks an element against another.
	f+	=	Checks an element against another only when elment contains something.
	l	=	Element can't exceed the given length.
	l +	=	Element can't exceed the given length only when elment contains something.
	l-	=	Element must have the given length.
	l-+	=	Element must have the given length only when elment contains something.
	m	=	Element must be a valid emailaddress.
	n	=	Element must be a number.
	p	=	Element must be a price with decimalcomma.
	p.	=	Element must be a price with decimalpoint.
	r	=	Element must match the given regex.
	r-	=	Element must not match the given regex.
	s	=	Element len should'nt be selected.
	<	=	Element can't be lesser then x.
	>	=	Element can't be greater then x.
*/
var validateFields = new Array();
var var_msg	= 'Errors:';

function initvalidateFields() {
	validateFields = new Array();
}

function setMessage (msg) {
	var_msg = msg;
}

function setValidatorValues (field, check, message, regex, len) {
	validateFields[validateFields.length] = new Array(field, check, message, regex, len);
}

function validateForm (sender,myarray,err_hd) {
	var err_msg = !err_hd?new Array('Folgende Fehler sind aufgetreten:\n'):new Array(err_hd+'\n');
	var error = false;
	var field = '';

	for (var i=0;i<myarray.length;i++){
		field = document.forms[sender].elements[myarray[i][0]];

		/* Block 1 berprft Felder, die ausgef?llt sein m?ssen */
		if (myarray[i][1].indexOf('e')>-1){
			if (field.value == ''){
				error = true;
				err_msg.push(myarray[i][2]);
			}
		}

		/* Block 2 berprft, ob die Emailadresse formal richtig ist */
		else if (myarray[i][1].indexOf('m')>-1) {
			if (field.value) {
				var usr = "([a-zA-Z0-9][a-zA-Z0-9_.-]*|\"([^\\\\\x80-\xff\015\012\"]|\\\\[^\x80-\xff])+\")";
				var domain = "([a-zA-Z0-9][a-zA-Z0-9._-]*\\.)*[a-zA-Z0-9][a-zA-Z0-9._-]*\\.[a-zA-Z]{2,5}";
				var regex = "^"+usr+"\@"+domain+"$";
				var myrxp = new RegExp(regex);
				var check = (myrxp.test(field.value));
				if (check!=true) {
					error=true;
					err_msg.push(field.value+" "+myarray[i][2]);
				}
			}
		}

		/* Block 3 berprft Felder, deren Wert eine Zahl sein muss */
		else if (myarray[i][1].indexOf('n')>-1) {
			var num_error = false;
			if(field.value) {
				var myvalue = field.value;
				var num = myvalue.match(/[^0-9,\.]/gi)
				var dot = myvalue.match(/\./g);
				var com = myvalue.match(/,/g);
				if (num!=null) {
					num_error = true;
				} else if ((dot!=null)&&(dot.length>1)) {
					num_error = true;
				} else if ((com!=null)&&(com.length>1)) {
					num_error = true;
				} else if ((com!=null)&&(dot!=null)) {
					num_error = true;
				}
			}
			if (num_error==true) {
				error = true;
				err_msg.push(myvalue+" "+myarray[i][2]);
			}
		}

		/* Block 4 berprft Wert anhand eines regul?ren Audrucks auf bestimmte Muster */
		else if (myarray[i][1].indexOf('r')>-1) {
			var notregex = myarray[i][1].substr(1,1)?myarray[i][1].substr(1,1):'';
			var regexp = myarray[i][3];
			var erg = regexp.test (field.value);

			if (field.value) {
				if (notregex == '-') {
					if (erg == true) {
						error = true;
						err_msg.push(field.value+" "+myarray[i][2]);
					}
				} else {
					alert ('regex');
					if (erg == false) {
						error = true;
						err_msg.push(field.value+" "+myarray[i][2]);
					}
				}
			}
		}

		/* Block 5 berprft Felder, die als Preis formatiert sein m?ssen, ndert die Formatierung eventuell */
		else if (myarray[i][1].indexOf('p')>-1) {
			var myvalue = field.value;
			var reg = /,-{1,}|\.-{1,}/;
			var nantest_value = myvalue.replace(reg,"");
			var num = nantest_value.match(/[^0-9,\.]/gi)
			var sep = myarray[i][1].substr(1,1)?myarray[i][1].substr(1,1):',';
			if (field.value) {
				var myvalue = field.value.replace(/\./,',');
				if (myvalue.indexOf(',')==-1) {
					field.value = myvalue+sep+'00';
				} else if (myvalue.indexOf(",--")>-1) {
					field.value = myvalue.replace(/,--/,sep+'00');
				} else if (myvalue.indexOf(",-")>-1) {
					field.value = myvalue.replace(/,-/,sep+'00');
				} else if (!myvalue.substring(myvalue.indexOf(',') + 2)) {
					error=true;
					err_msg.push(field.value+" "+myarray[i][2]);
				} else if (myvalue.substring(myvalue.indexOf(',') + 3)!='') {
					error=true;
					err_msg.push(field.value+" "+myarray[i][2]);
				} else if (num!=null) {
					error=true;
					err_msg.push(field.value+" "+myarray[i][2]);
				}
			}
		}

		/* Block 6 berprft Namensfelder, und korrigiert evtl. die Gross-/Kleinschreibung */
		else if (myarray[i][1].indexOf('c')>-1) {
			var noble = new Array("de","von","van","der","d","la","da","of");
			var newvalue='';
			var myvalue = field.value.split(/\b/);
			for (k=0;k<myvalue.length;k++) {
				newvalue+= myvalue[k].substr(0,1).toUpperCase()+myvalue[k].substring(1);
			}
			for(k=0;k<noble.length;k++){
				var reg = new RegExp ("\\b"+noble[k]+"\\b","gi");
				newvalue = newvalue.replace(reg,noble[k]);
			}
			field.value = newvalue;
		}

		/* Block 7 berprft auf die L?nge */
		else if (myarray[i][1].indexOf('l')>-1){
			var min = myarray[i][1].substr(1,1)?myarray[i][1].substr(1,1):'';
			var minthere = myarray[i][1].substr(2,2)?myarray[i][1].substr(2,2):'';
			if (minthere == '+') {
				if (field.value) {
					if (min == '-') {
						if (field.value.length < myarray[i][4]){
							error = true;
							err_msg.push(myarray[i][2]);
						}
					} else {
						if (field.value.length > myarray[i][4]){
							error = true;
							err_msg.push(myarray[i][2]);
						}
					}
				}
			} else {
				if (min == '-') {
					if (field.value.length < myarray[i][4]){
						error = true;
						err_msg.push(myarray[i][2]);
					}
				} else {
					if (field.value.length > myarray[i][4]){
						error = true;
						err_msg.push(myarray[i][2]);
					}
				}
			}
		}

		/* Block 8 berprft die Selectbox */
		else if (myarray[i][1].indexOf('s')>-1){
			if (field.selectedIndex == myarray[i][4]){
				error = true;
				err_msg.push(myarray[i][2]);
			}
		}

		/* Block 9 berprft Feld gegen Feld */
		else if (myarray[i][1].indexOf('f')>-1){
			var field1 = document.forms[sender].elements[myarray[i][3]];
			var there = myarray[i][1].substr(1,1)?myarray[i][1].substr(1,1):'';
			if (there == '+') {
				if (field.value) {
					if (field.value != field1.value){
						error = true;
						err_msg.push(myarray[i][2]);
					}
				}
			} else {
				if (field.value != field1.value){
					error = true;
					err_msg.push(myarray[i][2]);
				}
			}
		}

		/* Block 10 berprft auf Leerstellen */
		else if (myarray[i][1].indexOf('b')>-1){
			var text = field.value;
			if (field.value) {
				if (text.indexOf(' ') > -1){
					error = true;
					err_msg.push(myarray[i][2]);
				}
			}
		}

		/* Block 11 berprft auf kleiner als */
		else if (myarray[i][1].indexOf('<')>-1){
			if (field.value < myarray[i][4]){
				error = true;
				err_msg.push(myarray[i][2]);
			}
		}

		/* Block 12 berprft auf grsser als */
		else if (myarray[i][1].indexOf('>')>-1){
			if (field.value > myarray[i][4]){
				error = true;
				err_msg.push(myarray[i][2]);
			}
		}
	}

	/* im Fehlerfall werden hier die gesammelten Fehlermeldungen verarbeitet und angezeigt. Wenn das
	Formular ohne Beanstandung ist, wird es ?bertragen */
	if (error) {
		err_msg = err_msg.join('\n\xB7 ');
		alert(err_msg);
		return false;
	} else {
		return true;
	}
}