<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig, $opnTables;

$opnConfig['module']->InitModule ('modules/bookcorner', true);
getLanguageDef (_OPN_ROOT_PATH . 'modules/bookcorner/admin/language/');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorie.functions.php');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorie.php');
$mf = & new CatFunctions ('bookcorner', false);
$mf->itemtable = $opnTables['bookcorner_books'];
$mf->itemid = 'bid';
$mf->itemlink = 'cid';
$categories = & new opn_categorie ('bookcorner', 'bookcorner_books');
$categories->SetModule ('modules/bookcorner');
$categories->SetImagePath ($opnConfig['datasave']['bookcorner_cat']['path']);
$categories->SetItemID ('bid');
$categories->SetItemLink ('cid');
$categories->SetScriptname ('index');
$categories->SetWarning (_BOOKCORNERADM_AREYOUSUREYOUWANTTODELETETHISCATEGORIEANDALLITSBOOKS);

function bookmenu () {

	global $opnConfig;

	$menu = & new OPN_Adminmenu (_BOOKCORNERADM_BOOKSADMINISTRATION);
	$menu->InsertEntry (_BOOKCORNERADM_MAIN, $opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php');
	if ($opnConfig['permission']->HasRights ('modules/bookcorner', array (_PERM_EDIT, _PERM_NEW, _PERM_DELETE, _PERM_ADMIN), true) ) {
		$menu->InsertEntry (_BOOKCORNERADM_ACCOUNTS,
											array ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php',
			'op' => 'bookcorner_AccAdmin') );
		$menu->InsertEntry (_BOOKCORNERADM_CATEGORY, array ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php',
								'op' => 'catConfigMenu') );
		$menu->InsertEntry (_BOOKCORNERADM_BOOKS, array ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php',
								'op' => 'BooksAdmin'),
								'',
								true);
	}
	if ($opnConfig['permission']->HasRights ('modules/bookcorner', array (_PERM_SETTING, _PERM_ADMIN), true) ) {
		$menu->InsertEntry (_BOOKCORNERADM_CONFIGURATION,
											$opnConfig['opn_url'] . '/modules/bookcorner/admin/settings.php');
	}
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function BooksAdmin () {

	global $opnTables, $opnConfig, $mf;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$cid = 0;
	get_var ('cid', $cid, 'both', _OOBJ_DTYPE_INT);
	// Books List
	$boxtxt = '<div align="center" class="normaltextbold">' . _BOOKCORNERADM_CURRENTACTIVEBOOKS . '</div>';
	if ($cid == 0) {
		$sql = 'SELECT COUNT(cid) AS help FROM ' . $opnTables['bookcorner_books'];
	} else {
		$sql = 'SELECT COUNT(cid) AS help FROM ' . $opnTables['bookcorner_books'] . ' WHERE cid=' . $cid;
	}
	include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
	$result = &$opnConfig['database']->Execute ($sql);
	if (isset ($result->fields['help']) ) {
		$numrecords = $result->fields['help'];
	} else {
		$numrecords = 0;
	}
	$limit = $opnConfig['bookcorner_books_per_page_admin'];
	$navigate = build_pagebar (array ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php',
					'op' => 'BooksAdmin',
					'cid' => $cid),
					$numrecords,
					$limit,
					$offset,
					_BOOKCORNERADM_ALLNEWMEDIASINOURDATABASEARE);
	if ($numrecords>0) {
		$boxtxt .= $navigate . '<br />';
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BOOKCORNERADM_10_', 'bookcorner');
		$form->Init ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php');
		$form->AddText ('<br /><br /><div align="center" class="normaltext">' . _BOOKCORNERADM_ONLYSHOWCAT . '&nbsp;');
		$mf->makeMySelBox ($cid, $form, 2);
		$form->AddHidden ('op', 'BooksAdmin');
		$form->AddSubmit ('submit', _BOOKCORNERADM_GO);
		$form->AddText ('</div>');
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$boxtxt .= '<br />';
		$table = & new opn_TableClass ('alternator');
		$table->AddHeaderRow (array (_BOOKCORNERADM_ID, _BOOKCORNERADM_TITLE, _BOOKCORNERADM_AUTHOR, '&nbsp;') );
		$table->AddHeaderRow (array (_BOOKCORNERADM_HITS, _BOOKCORNERADM_CATEGORY, _BOOKCORNERADM_ACCOUNTS, _BOOKCORNERADM_FUNCTIONS) );
		if (!$cid) {
			$result = &$opnConfig['database']->SelectLimit ('SELECT bid, cid, acid, hits, title, author FROM ' . $opnTables['bookcorner_books'] . ' WHERE bid>0 ORDER BY bid', $limit, $offset);
		} else {
			$result = &$opnConfig['database']->SelectLimit ('SELECT bid, cid, acid, hits, title, author FROM ' . $opnTables['bookcorner_books'] . ' WHERE cid=' . $cid . ' ORDER BY bid', $limit, $offset);
		}
		while (! $result->EOF) {
			$bid = $result->fields['bid'];
			$cid = $result->fields['cid'];
			$acid = $result->fields['acid'];
			$hits = $result->fields['hits'];
			$title = $result->fields['title'];
			$author = $result->fields['author'];
			$c_name = $mf->getPathFromId ($cid);
			$c_name = substr ($c_name, 1);
			$aresult = &$opnConfig['database']->Execute ('SELECT name FROM ' . $opnTables['bookcorner_books_acc'] . ' WHERE acid=' . $acid);
			$a_name = $aresult->fields['name'];
			$aresult->Close ();
			$table->AddDataRow (array ($bid, $title, $author, $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php', 'op' => 'EditBooks', 'bid' => $bid) ) . ' ' . $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php', 'op' => 'DelBooks', 'bid' => $bid, 'ok' => '0') )), array ('center', 'center', 'center', 'center') );
			$table->SetAutoAlternator ('off');
			$table->AddDataRow (array ($hits, $c_name, $a_name, '&nbsp;'), array ('center', 'center', 'center', 'center') );
			$table->SetAutoAlternator ();
			$result->MoveNext ();
		}
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br />' . $navigate . '<br />';
	} else {
		$boxtxt .= '<div class="centertag">' . _BOOKCORNERADM_NOBOOKSFOUND . '</div>';
	}
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_20_';
	$_display_dat['module'] = 'modules/bookcorner';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_CURRENTACTIVEBOOKS, $boxtxt);
	// Add books
	$result = &$opnConfig['database']->Execute ('SELECT cat_id FROM ' . $opnTables['bookcorner_cats'] . ' WHERE cat_id>0');
	$numrows = $result->RecordCount ();
	if ($numrows>0) {
		$boxtxt = '<div align="center" class="normaltextbold">' . _BOOKCORNERADM_ADDANEWBOOK . '</div><br /><br />';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BOOKCORNERADM_30_', 'bookcorner');
		$form->Init ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php');
		$form->AddTable ();
		$form->AddOpenRow ();
		$form->AddLabel ('acid', _BOOKCORNERADM_ACCOUNTS);
		$options = array ();
		$result_a = &$opnConfig['database']->Execute ('SELECT acid,name FROM ' . $opnTables['bookcorner_books_acc'] . ' WHERE acid>0 ORDER BY name');
		while (! $result_a->EOF) {
			$options[$result_a->fields['acid']] = $result_a->fields['name'];
			$result_a->MoveNext ();
		}
		$form->AddSelect ('acid', $options);
		$form->AddChangeRow ();
		$form->AddLabel ('cid', _BOOKCORNERADM_CATEGORY);
		$mf->makeMySelBox (0, $form, 0, 'cid');
		$form->AddChangeRow ();
		$form->AddLabel ('imageurl', _BOOKCORNERADM_IMAGEURL);
		$form->AddTextfield ('imageurl', 50, 200);
		$form->AddChangeRow ();
		$form->AddLabel ('asin', _BOOKCORNERADM_ASIN);
		$form->AddTextfield ('asin', 50, 20);
		$form->AddChangeRow ();
		$form->AddLabel ('title', _BOOKCORNERADM_TITLE);
		$form->AddTextfield ('title', 50, 100);
		$form->AddChangeRow ();
		$form->AddLabel ('author', _BOOKCORNERADM_AUTHOR);
		$form->AddTextfield ('author', 50, 100);
		$form->AddChangeRow ();
		$form->AddLabel ('des', _BOOKCORNERADM_DESCRIPTION);
		$form->AddTextarea ('des');
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'AddBooks');
		$form->AddSubmit ('submit', _BOOKCORNERADM_ADDBOOK);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$boxtxt .= '<br />';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_40_';
		$_display_dat['module'] = 'modules/bookcorner';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_ADDANEWBOOK, $boxtxt);
	}

}

function bookcorner_AccAdmin () {

	global $opnTables, $opnConfig;
	// Account List
	$boxtxt = '<div align="center" class="normaltextbold">' . _BOOKCORNERADM_ADVERTISINGACCOUNT . '</div><br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_BOOKCORNERADM_ID, _BOOKCORNERADM_NAME, _BOOKCORNERADM_URL, _BOOKCORNERADM_PARTNERID, _BOOKCORNERADM_FUNCTIONS), array ('center', 'left', 'left', 'left', 'center') );
	$result = &$opnConfig['database']->Execute ('SELECT acid, name, amurl, amid FROM ' . $opnTables['bookcorner_books_acc'] . ' WHERE acid>0 ORDER BY acid');
	while (! $result->EOF) {
		$acid = $result->fields['acid'];
		$name = $result->fields['name'];
		$amurl = $result->fields['amurl'];
		$amid = $result->fields['amid'];
		$table->AddOpenRow ();
		$table->AddDataCol ($acid, 'center');
		$table->AddDataCol ($name, 'left');
		$table->AddDataCol ($amurl, 'left');
		$table->AddDataCol ($amid, 'left');
		$hlp = '';
		if ($opnConfig['permission']->HasRights ('modules/bookcorner', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
			$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php',
										'op' => 'EditAccount',
										'acid' => $acid) ) . ' ';
		}
		if ($opnConfig['permission']->HasRights ('modules/bookcorner', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
			$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php',
										'op' => 'DelAccount',
										'acid' => $acid) );
		}
		$table->AddDataCol ($hlp, 'center');
		$table->AddCloseRow ();
		$result->MoveNext ();
	}
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_50_';
	$_display_dat['module'] = 'modules/bookcorner';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_CATEGORIELIST, $boxtxt);
	// Add Account
	if ($opnConfig['permission']->HasRights ('modules/bookcorner', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$boxtxt = '<div align="center" class="normaltextbold">' . _BOOKCORNERADM_ADDANEWACCOUNT . '</div><br /><br />';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BOOKCORNERADM_60_', 'bookcorner');
		$form->Init ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('a_name', _BOOKCORNERADM_NAME);
		$form->AddTextfield ('a_name', 30, 60);
		$form->AddChangeRow ();
		$form->AddLabel ('amurl', _BOOKCORNERADM_URL);
		$form->AddTextfield ('amurl', 30, 150, 'http://');
		$form->AddChangeRow ();
		$form->AddLabel ('amid', _BOOKCORNERADM_PARTNERID);
		$form->AddTextfield ('amid', 30, 20);
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'AddAccount');
		$form->AddSubmit ('submit', _BOOKCORNERADM_ADDACCOUNT);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$boxtxt .= '<br />';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_70_';
		$_display_dat['module'] = 'modules/bookcorner';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_CATEGORIENEW, $boxtxt);
	}

}

function AddBooks () {

	global $opnTables, $opnConfig;

	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$acid = 0;
	get_var ('acid', $acid, 'form', _OOBJ_DTYPE_INT);
	$imageurl = '';
	get_var ('imageurl', $imageurl, 'form', _OOBJ_DTYPE_URL);
	$asin = '0';
	get_var ('asin', $asin, 'form', _OOBJ_DTYPE_CLEAN);
	$title = '';
	get_var ('title', $title, 'form', _OOBJ_DTYPE_CLEAN);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$des = '';
	get_var ('des', $des, 'form', _OOBJ_DTYPE_CHECK);
	$asin1 = $opnConfig['opnSQL']->qstr ($asin);
	$result = &$opnConfig['database']->Execute ('SELECT COUNT(asin) AS counter FROM ' . $opnTables['bookcorner_books'] . ' WHERE asin=' . $asin1);
	$numrows = $result->fields['counter'];
	if (isset ($result->fields['counter']) ) {
		$numrows = $result->fields['counter'];
	} else {
		$numrows = 0;
	}
	$result->Close ();
	if ($numrows>0) {
		$boxtxt = '<div class="bigtext" align="center"><span class="alerttextcolor">';
		$boxtxt .= _BOOKCORNERADM_ERRORTHISASINNISALREADYINTHEDATABASE . '</span><br /><br />' . '<a href="' . $opnConfig['opn_url'] . '/modules/bookcorner/index.php">' . _BOOKCORNERADM_BACK . '</a></div>';
		CloseTable ($boxtxt);
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_80_';
		$_display_dat['module'] = 'modules/bookcorner';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_NEWBOOKS, $boxtxt);
	} else {
		if ($acid == '') {
			$acid = 0;
		}
		$result_a = &$opnConfig['database']->Execute ('SELECT amurl, amid FROM ' . $opnTables['bookcorner_books_acc'] . ' WHERE acid=' . $acid);
		$amurl = $result_a->fields['amurl'];
		$amid = $result_a->fields['amid'];
		$clickurl = $amurl . '/exec/obidos/ASIN/' . $asin . '/' . $amid;
		$date = date ('Y-m-d');
		$bid = $opnConfig['opnSQL']->get_new_number ('bookcorner_books', 'bid');
		$title = $opnConfig['opnSQL']->qstr ($title);
		$author = $opnConfig['opnSQL']->qstr ($author);
		$_imageurl = $opnConfig['opnSQL']->qstr ($imageurl);
		$_clickurl = $opnConfig['opnSQL']->qstr ($clickurl);
		$_date = $opnConfig['opnSQL']->qstr ($date);
		$des = $opnConfig['opnSQL']->qstr ($des, 'des');
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['bookcorner_books'] . " (bid, cid, acid, hits, imageurl, asin, title, author, des, clickurl, bdate) VALUES ($bid, $cid, $acid, 0, $_imageurl, $asin1, $title, $author, $des, $_clickurl, $_date)");
		if ($opnConfig['database']->ErrorNo ()>0) {
			$boxtxt = $opnConfig['database']->ErrorNo () . ' --- ' . $opnConfig['database']->ErrorMsg () . '<br />';
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_90_';
			$_display_dat['module'] = 'modules/bookcorner';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_NEWBOOKS, $boxtxt);
		} else {
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables['bookcorner_books'], 'bid=' . $bid);
			$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php?op=BooksAdmin', false) );
			CloseTheOpnDB ($opnConfig);
		}
	}

}

function EditBooks () {

	global $opnTables, $opnConfig, $mf;

	$bid = '';
	get_var ('bid', $bid, 'url', _OOBJ_DTYPE_CLEAN);
	$result = &$opnConfig['database']->Execute ('SELECT cid, acid, hits, imageurl, asin, title, author, des, bdate FROM ' . $opnTables['bookcorner_books'] . ' WHERE bid=' . $bid);
	$cid = $result->fields['cid'];
	$acid = $result->fields['acid'];
	$hits = $result->fields['hits'];
	$imageurl = $result->fields['imageurl'];
	$asin = $result->fields['asin'];
	$title = $result->fields['title'];
	$author = $result->fields['author'];
	$des = $result->fields['des'];
	$date = $result->fields['bdate'];
	if ($imageurl != '') {
		$boxtxt = '<br /><br /><img src="' . $imageurl . ' class="imgtag" align="right" hspace="10" vspace="10" alt="" />';
	} else {
		$boxtxt = '';
	}
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BOOKCORNERADM_100_', 'bookcorner');
	$form->Init ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php');
	$form->AddTable ();
	$form->AddOpenRow ();
	$form->AddText (_BOOKCORNERADM_BOOKID);
	$form->AddText ($bid);
	$form->AddChangeRow ();
	$form->AddText (_BOOKCORNERADM_ADDEDON);
	$form->AddText ($date);
	$form->AddChangeRow ();
	$form->AddText (_BOOKCORNERADM_HITS);
	$form->AddText ($hits);
	$form->AddChangeRow ();
	$form->AddLabel ('acid', _BOOKCORNERADM_ACCOUNTS);
	$result_a = &$opnConfig['database']->Execute ('SELECT acid,name FROM ' . $opnTables['bookcorner_books_acc'] . ' WHERE acid>0');
	$form->AddSelectDB ('acid', $result_a, $acid);
	$form->AddChangeRow ();
	$form->AddLabel ('cid', _BOOKCORNERADM_CATEGORY);
	$mf->makeMySelBox ($cid, $form, 0, 'cid');
	$form->AddChangeRow ();
	$form->AddLabel ('imageurl', _BOOKCORNERADM_IMAGEURL);
	$form->AddTextfield ('imageurl', 50, 200, $imageurl);
	$form->AddChangeRow ();
	$form->AddLabel ('asin', _BOOKCORNERADM_ASIN);
	$form->AddTextfield ('asin', 50, 20, $asin);
	$form->AddChangeRow ();
	$form->AddLabel ('title', _BOOKCORNERADM_TITLE);
	$form->AddTextfield ('title', 50, 100, $title);
	$form->AddChangeRow ();
	$form->AddLabel ('author', _BOOKCORNERADM_AUTHOR);
	$form->AddTextfield ('author', 50, 100, $author);
	$form->AddChangeRow ();
	$form->AddLabel ('des', _BOOKCORNERADM_DESCRIPTION);
	$form->AddTextarea ('des', 0, 0, '', $des);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('bid', $bid);
	$form->AddHidden ('op', 'ChangeBooks');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _BOOKCORNERADM_CHANGEBOOK);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_110_';
	$_display_dat['module'] = 'modules/bookcorner';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_CHANGEBOOK, $boxtxt);

}

function ChangeBooks () {

	global $opnTables, $opnConfig;

	$bid = 0;
	get_var ('bid', $bid, 'form', _OOBJ_DTYPE_INT);
	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$acid = 0;
	get_var ('acid', $acid, 'form', _OOBJ_DTYPE_INT);
	$imageurl = '';
	get_var ('imageurl', $imageurl, 'form', _OOBJ_DTYPE_URL);
	$asin = '';
	get_var ('asin', $asin, 'form', _OOBJ_DTYPE_CLEAN);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$title = '';
	get_var ('title', $title, 'form', _OOBJ_DTYPE_CLEAN);
	$des = '';
	get_var ('des', $des, 'form', _OOBJ_DTYPE_CHECK);
	$result_a = &$opnConfig['database']->Execute ('SELECT amurl, amid FROM ' . $opnTables['bookcorner_books_acc'] . ' WHERE acid=' . $acid);
	$amurl = $result_a->fields['amurl'];
	$amid = $result_a->fields['amid'];
	$clickurl = $amurl . '/exec/obidos/ASIN/' . $asin . '/' . $amid;
	$insert = 'cid=' . $cid . ', ';
	$title = $opnConfig['opnSQL']->qstr ($title);
	$author = $opnConfig['opnSQL']->qstr ($author);
	$asin1 = $opnConfig['opnSQL']->qstr ($asin);
	$_imageurl = $opnConfig['opnSQL']->qstr ($imageurl);
	$_clickurl = $opnConfig['opnSQL']->qstr ($clickurl);
	$des = $opnConfig['opnSQL']->qstr ($des, 'des');
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bookcorner_books'] . ' SET ' . $insert . "acid=$acid, imageurl=$_imageurl, asin=$asin1, title=$title, des=$des, clickurl=$_clickurl, author=$author WHERE bid=$bid");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['bookcorner_books'], 'bid=' . $bid);
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php?op=BooksAdmin', false) );
	CloseTheOpnDB ($opnConfig);

}

function DelBooks () {

	global $opnTables, $opnConfig;

	$bid = 0;
	get_var ('bid', $bid, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bookcorner_books'] . ' WHERE bid=' . $bid);
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php?op=BooksAdmin', false) );
		CloseTheOpnDB ($opnConfig);
	} else {
		$boxtxt = '';
		$result = &$opnConfig['database']->Execute ('SELECT cid, acid, hits, imageurl, asin, title, author, des, bdate FROM ' . $opnTables['bookcorner_books'] . ' WHERE bid=' . $bid);
		$cid = $result->fields['cid'];
		$acid = $result->fields['acid'];
		$hits = $result->fields['hits'];
		$imageurl = $result->fields['imageurl'];
		$asin = $result->fields['asin'];
		$title = $result->fields['title'];
		$author = $result->fields['author'];
		$des = $result->fields['des'];
		$date = $result->fields['bdate'];
		$boxtxt .= '<img src="' . $imageurl . '" class="imgtag" align="right" hspace="10" vspace="10" alt="" />';
		$result2 = &$opnConfig['database']->Execute ('SELECT cat_name FROM ' . $opnTables['bookcorner_cats'] . ' WHERE cat_id=' . $cid);
		$c_name = $result2->fields['name'];
		$result3 = &$opnConfig['database']->Execute ('SELECT name FROM ' . $opnTables['bookcorner_books_acc'] . ' WHERE acid=' . $acid);
		$a_name = $result3->fields['name'];
		$table = & new opn_TableClass ('default');
		$table->AddCols (array ('15%', '85%') );
		$table->AddDataRow (array (_BOOKCORNERADM_BOOKID, $bid) );
		$table->AddDataRow (array (_BOOKCORNERADM_ADDEDON, $date) );
		$table->AddDataRow (array (_BOOKCORNERADM_HITS, $hits) );
		$table->AddDataRow (array (_BOOKCORNERADM_ACCOUNTS, $a_name) );
		$table->AddDataRow (array (_BOOKCORNERADM_CATEGORY, $c_name) );
		$table->AddDataRow (array (_BOOKCORNERADM_IMAGEURL, $imageurl) );
		$table->AddDataRow (array (_BOOKCORNERADM_ASIN, $asin) );
		$table->AddDataRow (array (_BOOKCORNERADM_TITLE, $title) );
		$table->AddDataRow (array (_BOOKCORNERADM_AUTHOR, $author) );
		$table->AddDataRow (array (_BOOKCORNERADM_DESCRIPTION, $des) );
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br /><br /><div class="centertag">' . _BOOKCORNERADM_AREYOUSUREYOUWANTTODELETETHISBOOK . '<br /><br />' . '<a href="' . $opnConfig['opn_url'] . '/modules/bookcorner/index.php">' . _NO . '</a>&nbsp;&nbsp;&nbsp;<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php',
																																	'op' => 'DelBooks',
																																	'bid' => $bid,
																																	'ok' => '1') ) . '">' . _YES . '</a></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_120_';
		$_display_dat['module'] = 'modules/bookcorner';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_BOOKDELETE, $boxtxt);
	}

}

function AddAccount () {

	global $opnTables, $opnConfig;

	$a_name = '';
	get_var ('a_name', $a_name, 'form', _OOBJ_DTYPE_CLEAN);
	$amurl = '';
	get_var ('amurl', $amurl, 'form', _OOBJ_DTYPE_URL);
	$amid = '';
	get_var ('amid', $amid, 'form', _OOBJ_DTYPE_URL);
	$amid = $opnConfig['opnSQL']->qstr ($amid);
	$result = &$opnConfig['database']->Execute ('SELECT amid FROM ' . $opnTables['bookcorner_books_acc'] . ' WHERE amid=' . $amid);
	$numrows = $result->RecordCount ();
	if ($numrows>0) {
		$boxtxt = '';
		OpenTable ($boxtxt);
		$boxtxt .= '<div class="bigtextbold" align="center"><span class="alerttextcolor">';
		$boxtxt .= _BOOKCORNERADM_ERRORTHISPARTNERIDISALREADYLISTEDINTHEDATABASE . '</span><br /><br />';
		$boxtxt .= '<a href="' . $opnConfig['opn_url'] . '/modules/bookcorner/index.php">' . _BOOKCORNERADM_BACK . '</a></div>';
		CloseTable ($boxtxt);
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_130_';
		$_display_dat['module'] = 'modules/bookcorner';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_ACCOUNTADD, $boxtxt);
	} else {
		$acid = $opnConfig['opnSQL']->get_new_number ('bookcorner_books_acc', 'acid');
		$a_name = $opnConfig['opnSQL']->qstr ($a_name);
		$_amurl = $opnConfig['opnSQL']->qstr ($amurl);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['bookcorner_books_acc'] . " (acid, name, amurl, amid) VALUES ($acid, $a_name, $_amurl, $amid)");
		if ($opnConfig['database']->ErrorNo ()>0) {
			$boxtxt = $opnConfig['database']->ErrorNo () . ' --- ' . $opnConfig['database']->ErrorMsg () . '<br />';
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_140_';
			$_display_dat['module'] = 'modules/bookcorner';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_ACCOUNTADD, $boxtxt);
		} else {
			$opnConfig['opnOutput']->Redirect (encodeurl (array($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php', 'op' => 'bookcorner_AccAdmin'), false) );
			CloseTheOpnDB ($opnConfig);
		}
	}

}

function EditAccount () {

	global $opnTables, $opnConfig;

	$acid = 0;
	get_var ('acid', $acid, 'url', _OOBJ_DTYPE_INT);
	$result = &$opnConfig['database']->Execute ('SELECT name, amurl, amid FROM ' . $opnTables['bookcorner_books_acc'] . ' WHERE acid=' . $acid);
	$a_name = $result->fields['name'];
	$amurl = $result->fields['amurl'];
	$amid = $result->fields['amid'];
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BOOKCORNERADM_150_', 'bookcorner');
	$form->Init ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('15%', '85%') );
	$form->AddOpenRow ();
	$form->AddText (_BOOKCORNERADM_ACCOUNTID);
	$form->AddText ($acid);
	$form->AddChangeRow ();
	$form->AddLabel ('a_name', _BOOKCORNERADM_NAME);
	$form->AddTextfield ('a_name', 30, 60, $a_name);
	$form->AddChangeRow ();
	$form->AddLabel ('amurl', _BOOKCORNERADM_URL);
	$form->AddTextfield ('amurl', 30, 150, $amurl);
	$form->AddChangeRow ();
	$form->AddLabel ('amid', _BOOKCORNERADM_PARTNERID);
	$form->AddTextfield ('amid', 30, 20, $amid);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('acid', $acid);
	$form->AddHidden ('op', 'ChangeAccount');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _BOOKCORNERADM_CHANGEACCOUNT);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_160_';
	$_display_dat['module'] = 'modules/bookcorner';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ('Account', $boxtxt);

}

function ChangeAccount () {

	global $opnTables, $opnConfig;

	$acid = 0;
	get_var ('acid', $acid, 'form', _OOBJ_DTYPE_INT);
	$a_name = '';
	get_var ('a_name', $a_name, 'form', _OOBJ_DTYPE_CLEAN);
	$amurl = '';
	get_var ('amurl', $amurl, 'form', _OOBJ_DTYPE_URL);
	$amid = '';
	get_var ('amid', $amid, 'form', _OOBJ_DTYPE_CLEAN);
	$a_name = $opnConfig['opnSQL']->qstr ($a_name);
	$_amurl = $opnConfig['opnSQL']->qstr ($amurl);
	$_amid = $opnConfig['opnSQL']->qstr ($amid);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bookcorner_books_acc'] . " SET name=$a_name, amurl=$_amurl, amid=$_amid WHERE acid=$acid");
	$opnConfig['opnOutput']->Redirect (encodeurl (array($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php', 'op' => 'bookcorner_AccAdmin'), false) );
	CloseTheOpnDB ($opnConfig);

}

function DelAccount () {

	global $opnTables, $opnConfig;

	$acid = 0;
	get_var ('acid', $acid, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bookcorner_books_acc'] . ' WHERE acid=' . $acid);
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php?op=BooksAdmin', false) );
		CloseTheOpnDB ($opnConfig);
	} else {
		$result = &$opnConfig['database']->Execute ('SELECT name, amurl, amid FROM ' . $opnTables['bookcorner_books_acc'] . ' WHERE acid=' . $acid);
		$a_name = $result->fields['name'];
		$amurl = $result->fields['amurl'];
		$amid = $result->fields['amid'];
		$boxtxt = '<div class="normaltextbold" align="center">' . _BOOKCORNERADM_DELACCOUNT . '</div><br /><br />';
		$table = & new opn_TableClass ('default');
		$table->AddCols (array ('15%', '85%') );
		$table->AddDataRow (array (_BOOKCORNERADM_ACCOUNTID, $acid) );
		$table->AddDataRow (array (_BOOKCORNERADM_NAME, $a_name) );
		$table->AddDataRow (array (_BOOKCORNERADM_URL, $amurl) );
		$table->AddDataRow (array (_BOOKCORNERADM_PARTNERID, $amid) );
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br /><br /><div class="centertag">' . _BOOKCORNERADM_AREYOUSUREYOUWANTTODELETETHISACCOUNT . '<br /><br />' . '<a href="' . $opnConfig['opn_url'] . '/modules/bookcorner/index.php">' . _NO . '</a>&nbsp;&nbsp;&nbsp;<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bookcorner/admin/index.php',
																																		'op' => 'DelAccount',
																																		'acid' => $acid,
																																		'ok' => '1') ) . '">' . _YES . '</a>' . '</div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_170_';
		$_display_dat['module'] = 'modules/bookcorner';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_ACCOUNTDELETE, $boxtxt);
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$opnConfig['opnOutput']->EnableJavaScript ();
$opnConfig['opnOutput']->DisplayHead ();
bookmenu ();
switch ($op) {
	case 'AddBooks':
		AddBooks ();
		break;
	case 'EditBooks':
		EditBooks ();
		break;
	case 'ChangeBooks':
		ChangeBooks ();
		break;
	case 'DelBooks':
		DelBooks ();
		break;
	case 'AddAccount':
		if ($opnConfig['permission']->HasRights ('modules/bookcorner', array (_PERM_NEW, _PERM_ADMIN), true) ) {
			AddAccount ();
		}
		break;
	case 'EditAccount':
		if ($opnConfig['permission']->HasRights ('modules/bookcorner', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
			EditAccount ();
		}
		break;
	case 'DelAccount':
		if ($opnConfig['permission']->HasRights ('modules/bookcorner', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
			DelAccount ();
		}
		break;
	case 'ChangeAccount':
		ChangeAccount ();
		break;
	case 'bookcorner_AccAdmin':
		bookcorner_AccAdmin ();
		break;
	case 'BooksAdmin':
		BooksAdmin ();
		break;
	case 'catConfigMenu':
		$boxtxt = $categories->DisplayCats ();
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_180_';
		$_display_dat['module'] = 'modules/bookcorner';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_BOODESC, $boxtxt);
		break;
	case 'delCat':
		$ok = 0;
		get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
		if (!$ok) {
			$boxtxt = $categories->DeleteCat ('');
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_190_';
			$_display_dat['module'] = 'modules/bookcorner';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_BOODESC, $boxtxt);
		} else {
			$categories->DeleteCat ('');
		}
		break;
	case 'modCat':
		$boxtxt = $categories->ModCat ();
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BOOKCORNERADM_200_';
		$_display_dat['module'] = 'modules/bookcorner';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_BOOKCORNERADM_BOODESC, $boxtxt);
		break;
	case 'modCatS':
		$categories->ModCatS ();
		break;
	case 'addCat':
		$categories->AddCat ();
		break;
	case 'OrderCat':
		$categories->OrderCat ();
		break;
	default:
		BooksAdmin ();
		break;
}
$opnConfig['opnOutput']->DisplayFoot ();

?>