<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

global $opnConfig, $opnTables;

$opnConfig['module']->InitModule ('modules/bug_tracking', true);
include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/bugs.constants.php');
include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugs.php');
include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsattachments.php');
getLanguageDef (_OPN_ROOT_PATH . 'modules/bug_tracking/admin/language/');

function BugTrackingConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->EnableJavaScript ();
	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_BUGADMIN_CONFIG);
	$menu->InsertEntry (_BUGADMIN_MAIN, array ($opnConfig['opn_url'] . '/modules/bug_tracking/admin/index.php') );
	$menu->InsertEntry (_BUGADMIN_SETTINGS, array ($opnConfig['opn_url'] . '/modules/bug_tracking/admin/settings.php') );
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function BugtrackingAttachment () {

	global $opnConfig, $opnTables;

	$boxtxt = '';
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$sortby = 'asc_filename';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$attachments = & new BugsAttachments ();
	$bugs = & new Bugs ();
	$reccount = $attachments->GetCount ();
	$order = '';
	$oldsortby = $sortby;
	$progurl = array ($opnConfig['opn_url'] . '/modules/bug_tracking/admin/index.php');
	$boxtxt .= '<span class="extratextbold">' . _BUGADMIN_ATTACHMENT_DELETE_BY_DATE . '</span>';
	$boxtxt .= '<br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_190_', 'bug_tracking');
	$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('days', _BUGADMIN_ATTACHMENT_OLDER);
	$form->SetSameCol ();
	$form->AddTextfield ('days', 5, 5, 25);
	$form->AddText ('&nbsp;' . _BUGADMIN_ATTACHMENT_DAYS);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'BugTrackingAttachmentDelDays');
	$form->AddSubmit ('submit', _BUGADMIN_DELETE1);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<br /><br />';
	$boxtxt .= '<span class="extratextbold">' . _BUGADMIN_ATTACHMENT_DELETE_BY_SIZE . '</span>';
	$boxtxt .= '<br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_200_', 'bug_tracking');
	$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('size', _BUGADMIN_ATTACHMENT_SIZE);
	$form->SetSameCol ();
	$form->AddTextfield ('size', 5, 5, 100);
	$form->AddText ('&nbsp;' . _BUGADMIN_ATTACHMENT_KB);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'BugTrackingAttachmentDelSize');
	$form->AddSubmit ('submit', _BUGADMIN_DELETE1);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	if ($reccount >= 1) {
		$boxtxt .= '<br /><br />';
		$form = & new opn_FormularClass ('alternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_210_', 'modukes/bug_tracking');
		$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/admin/index.php', 'post', 'attach');
		$form->AddTable ();
		$form->get_sort_order ($order, array ('filename',
							'filesize',
							'date'),
							$sortby);
		$form->AddOpenHeadRow ();
		$form->SetIsHeader (true);
		$form->AddText ($form->get_sort_feld ('filename', _BUGADMIN_ATTACHMENT_NAME, $progurl) );
		$form->AddText ($form->get_sort_feld ('filesize', _BUGADMIN_ATTACHMENT_SIZE, $progurl) );
		$form->AddText ($form->get_sort_feld ('date', _BUGADMIN_ATTACHMENT_DATE, $progurl) );
		$form->AddCheckbox ('delall', 'Check All', 0, 'CheckAll(\'attach\',\'delall\');');
		$form->SetIsHeader (false);
		$form->AddCloseRow ();
		$attachments->SetOrderby ($order);
		$info = $attachments->GetLimit ($maxperpage, $offset);
		while (! $info->EOF) {
			$id = $info->fields['attachment_id'];
			$filename = $info->fields['filename'];
			$filesize = $info->fields['filesize'];
			$bug_id = $info->fields['bug_id'];
			$date = $info->fields['date_added'];
			$form->AddOpenRow ();
			$url[0] = $opnConfig['opn_url'] . '/modules/bug_tracking/viewattachment.php';
			$url['action'] = 'dlattach';
			$url['id'] = $id;
			$help = '<a class="%alternate%" href="' . encodeurl ($url) . '">' . $filename . '</a>';
			$form->AddText ($help);
			$form->SetAlign ('right');
			$help = round ($filesize/1024, 2) . ' ' . _BUGADMIN_ATTACHMENT_KB;
			$form->AddText ($help);
			$form->SetAlign ('');
			$opnConfig['opndate']->sqlToopnData ($date);
			$opnConfig['opndate']->formatTimestamp ($date, _DATE_DATESTRING5);
			$date .= '<br />' . _BUGADMIN_ATTACHMENT_AT . '&nbsp;';
			unset ($url);
			$url[0] = $opnConfig['opn_url'] . '/modules/bug_tracking/index.php';
			$url['op'] = 'view_bug';
			$url['bug_id'] = $bug_id;
			$bug = $bugs->RetrieveSingle ($bug_id);
			$date .= '<a class="%alternate%" href="' . encodeurl ($url) . '">' . $bug['summary'] . '</a>';
			$form->AddText ($date);
			$form->SetAlign ('center');
			$form->AddCheckbox ('del_id[]', $id, 0, 'CheckCheckAll(\'attach\',\'delall\');');
			$form->SetAlign ('');
			$form->AddCloseRow ();
			unset ($url);
			$info->MoveNext ();
		}
		// while
		$form->AddOpenRow ();
		$form->SetColspan ('5');
		$form->SetAlign ('right');
		$form->SetSameCol ();
		$form->AddHidden ('op', 'BugTrackingAttachmentDelete');
		$form->AddSubmit ('submit', _BUGADMIN_DELETE1);
		$form->SetEndCol ();
		$form->SetAlign ('');
		$form->SetColspan ('');
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$boxtxt .= '<br /><br />';
		$boxtxt .= build_pagebar (array ($opnConfig['opn_url'] . '/modules/bug_tracking/admin/index.php',
						'sortby' => $oldsortby),
						$reccount,
						$maxperpage,
						$offset);
	}
	return $boxtxt;

}

function BugTrackingAttachmentDelSize () {

	global $opnConfig, $opnTables;

	$size = 0;
	get_var ('size', $size, 'both', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$attachments = & new BugsAttachments ();
		$attachments->DeleteBySize ($size);
		return '';
	}
	$boxtxt = '<div class="bigtextbold" align="center"><br />';
	$boxtxt .= '<span class="alerttextcolor">';
	$boxtxt .= sprintf (_BUGADMIN_ATTACHMENT_WARNING_SIZE, $size) . '<br /><br /></span>';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/admin/index.php',
									'op' => 'BugTrackingAttachmentDelSize',
									'size' => $size,
									'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/bug_tracking/admin/index.php') . '">' . _NO . '</a><br /><br /></div>';
	return $boxtxt;

}

function BugTrackingAttachmentDelDays () {

	global $opnConfig, $opnTables;

	$days = 0;
	get_var ('days', $days, 'both', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$attachments = & new BugsAttachments ();
		$attachments->DeleteByDate ($days);
		return '';
	}
	$boxtxt = '<div class="bigtextbold" align="center"><br />';
	$boxtxt .= '<span class="alerttextcolor">';
	$boxtxt .= sprintf (_BUGADMIN_ATTCHMENT_WARNING_DAYS, $days) . '<br /><br /></span>';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/admin/index.php',
									'op' => 'BugTrackingAttachmentDelDays',
									'days' => $days,
									'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/bug_tracking/admin/index.php') . '">' . _NO . '</a><br /><br /></div>';
	return $boxtxt;

}

function BugTrackingAttachmentDelete () {

	global $opnConfig;

	$del_id = array ();
	get_var ('del_id', $del_id,'both',_OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		if (count ($del_id) ) {
			$attachments = & new BugsAttachments ();
			$attachments->DeleteByIds ($del_id);
		}
		return '';
	}
	$boxtxt = '<div class="bigtextbold" align="center"><br />';
	$boxtxt .= '<span class="alerttextcolor">';
	$boxtxt .= _BUGADMIN_ATTCHMENT_WARNING_SELECTED . '<br /><br /></span>';
	$url[0] = $opnConfig['opn_url'] . '/modules/bug_tracking/admin/index.php';
	$url['op'] = 'BugTrackingAttachmentDelete';
	$count = 0;
	foreach ($del_id as $value) {
		$url['del_id[' . $count . ']'] = $value;
		$count++;
	}
	$url['ok'] = 1;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($url) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/bug_tracking/admin/index.php') . '">' . _NO . '</a><br /><br /></div>';
	return $boxtxt;

}
$boxtxt = '';
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'BugTrackingAttachmentDelSize':
		$boxtxt .= BugTrackingAttachmentDelSize ();
		if ($boxtxt == '') {
			$boxtxt .= BugtrackingAttachment ();
		}
		break;
	case 'BugTrackingAttachmentDelDays':
		$boxtxt .= BugTrackingAttachmentDelDays ();
		if ($boxtxt == '') {
			$boxtxt .= BugtrackingAttachment ();
		}
		break;
	case 'BugTrackingAttachmentDelete':
		$boxtxt .= BugTrackingAttachmentDelete ();
		if ($boxtxt == '') {
			$boxtxt .= BugtrackingAttachment ();
		}
		break;
	default:
		$boxtxt .= BugtrackingAttachment ();
		break;
}
BugTrackingConfigHeader ();
if ($boxtxt != '') {
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_180_';
	$_display_dat['module'] = 'modules/bug_tracking';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_BUGADMIN_CONFIG, $boxtxt);
}
$opnConfig['opnOutput']->DisplayFoot ();

?>