<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/* Parts are based on email_api.php from the mantis project */

global $opnConfig, $opnTables;

global $bugs, $bugshistory, $bugsmonitoring, $bugsnotes;

global $project, $category, $version;

global $bugvalues, $settings, $bugusers;
// --------------------
// email_notify_flag
// Get the value associated with the specific action and flag.
// For example, you can get the value associated with notifying "admin"
// on action "new", i.e. notify administrators on new bugs which can be
// 1 (ON) or 0 (OFF).

function BugTracking_email_notify_flag ($action, $flag) {

	global $opnConfig;
	return $opnConfig['bug_send_email_on'][$action][$flag];

}

function BugTracking_email_collect_recipients ($p_bug_id, $p_notify_type, $p_notify) {

	global $opnConfig, $bugs, $bugsnotes;

	global $bugsmonitoring, $bugusers;

	$t_recipients = array ();
	$bug = $bugs->RetrieveSingle ($p_bug_id);
	$uid = $opnConfig['permission']->Userinfo ('uid');
	// New Bug (Admins only)
	if ($p_notify == 'new') {
		if ($opnConfig['bug_send_to_project_admin']) {
			$admin = & new ProjectUser ();
			$admin->SetProject ($bug['project_id']);
			$a = $admin->GetArray ();
			$admins = array ();
			foreach ($a as $value) {
				$admins[] = $value['user_id'];
			}
			// foreach
			unset ($a);
		} else {
			$admins = array_keys ($bugusers);
		}
		if ($opnConfig['bug_send_email_on_new']) {
			foreach ($admins as $value) {
				$t_admin_id = $value;
				$t_recipients[$t_admin_id] = true;
			}
		} else {
			$settings = & new BugsUserSettings ();
			foreach ($admins as $value) {
				$sett = $settings->RetrieveSingle ($value);
				if ($sett['email_on_new']) {
					$t_admin_id = $value;
					$t_recipients[$t_admin_id] = true;
				}
			}
		}
	} else {
		// Reporter
		if (BugTracking_email_notify_flag ($p_notify_type, 'reporter') ) {
			$t_reporter_id = $bug['reporter_id'];
			$t_recipients[$t_reporter_id] = true;
		}
		// Handler
		if (BugTracking_email_notify_flag ($p_notify_type, 'handler') ) {
			$t_handler_id = $bug['handler_id'];
			if ($t_handler_id) {
				$t_recipients[$t_handler_id] = true;
			}
		}
		// monitor
		if (BugTracking_email_notify_flag ($p_notify_type, 'monitor') ) {
			$bugsmonitoring->ClearCache ();
			$bugsmonitoring->SetBug ($p_bug_id);
			if ($bugsmonitoring->GetCount () ) {
				$moni = $bugsmonitoring->GetArray ();
				foreach ($moni as $value) {
					$t_user_id = $value['user_id'];
					$t_recipients[$t_user_id] = true;
				}
				unset ($moni);
			}
		}
		// bugnotes
		if (BugTracking_email_notify_flag ($p_notify_type, 'bugnotes') ) {
			$bugsnotes->ClearCache ();
			$bugsnotes->SetBug ($p_bug_id);
			if ($bugsnotes->GetCount () ) {
				$notes = $bugsnotes->GetArray ();
				foreach ($notes as $value) {
					$t_user_id = $value['reporter_id'];
					$t_recipients[$t_user_id] = true;
				}
			}
		}
	}
	$t_pref_field = 'email_on_' . $p_notify;
	// @@@ we could optimize by modifiying user_cache() to take an array
	// of user ids so we could pull them all in.  We'll see if it's necessary
	// Check whether users should receive the emails
	$settings = & new BugsUserSettings ();
	$help = array_keys ($t_recipients);
	foreach ($help as $t_id) {
		// Possibly eliminate the current user
		if ( ($uid == $t_id) && ($opnConfig['bug_email_receive_own'] == 0) ) {
			unset ($t_recipients[$t_id]);
			continue;
		}
		// Exclude users who have this notification type turned off
		$sett = $settings->RetrieveSingle ($t_id);
		if (!$sett[$t_pref_field]) {
			unset ($t_recipients[$t_id]);
			continue;
		}
		// Finally, let's get their emails, if they've set one
		$ui = $opnConfig['permission']->GetUser ($t_id, 'useruid', '');
		$t_email = $ui['email'];
		$t_recipients[$t_id] = $t_email;
	}
	unset ($sett);
	unset ($settings);
	return $t_recipients;

}
// --------------------
// Build the bcc list

function BugTracking_email_build_bcc_list ($p_bug_id, $p_notify_type, $p_notify) {

	$t_recipients = BugTracking_email_collect_recipients ($p_bug_id, $p_notify_type, $p_notify);
	if (!$t_recipients) {
		return '';
	}
	// win-bcc-bug
	$t_emails = array_values ($t_recipients);
	$t_bcc['Bcc'] = implode (', ', $t_emails);
	return $t_bcc;

}
// --------------------
// send a generic email
// $p_notify_type: use check who she get notified of such event.
// $p_message_id: message id to be translated and included at the top of the email message.
// $p_notify the notify event.

function BugTracking_email_generic ($p_bug_id, $p_notify_type, $p_message_id, $p_notify) {

	$t_bcc = BugTracking_email_build_bcc_list ($p_bug_id, $p_notify_type, $p_notify);
	BugTracking_email_bug_info ($p_bug_id, $p_message_id, $t_bcc);

}
// --------------------
// send notices when a new bug is added

function BugTracking_email_new_bug ($p_bug_id) {

	BugTracking_email_generic ($p_bug_id, 'new', _BUG_EMAIL_TITLE_NEW, 'new');

}
// --------------------
// send notices when a new bugnote

function BugTracking_email_bugnote_add ($p_bug_id) {

	BugTracking_email_generic ($p_bug_id, 'bugnote', _BUG_EMAIL_TITLE_BUGNOTE, 'bugnote');

}
// --------------------
// send notices when a bug is RESOLVED

function BugTracking_email_resolved ($p_bug_id) {

	BugTracking_email_generic ($p_bug_id, 'resolved', _BUG_EMAIL_TITLE_RESOLVED, 'resolved');

}
// --------------------
// send notices when a bug is CLOSED

function BugTracking_email_close ($p_bug_id) {

	BugTracking_email_generic ($p_bug_id, 'closed', _BUG_EMAIL_TITLE_CLOSED, 'closed');

}
// --------------------
// send notices when a bug is REOPENED

function BugTracking_email_reopen ($p_bug_id) {

	BugTracking_email_generic ($p_bug_id, 'reopened', _BUG_EMAIL_TITLE_REOPENED, 'reopened');

}
// --------------------
// send notices when a bug is ASSIGNED

function BugTracking_email_assign ($p_bug_id) {

	BugTracking_email_generic ($p_bug_id, 'assigned', _BUG_EMAIL_TITLE_ASSIGNED, 'assigned');

}
// --------------------
// send notices when a bug is DELETED

function BugTracking_email_bug_deleted ($p_bug_id) {

	BugTracking_email_generic ($p_bug_id, 'deleted', _BUG_EMAIL_TITLE_DELETED, 'deleted');

}
// --------------------
// send notices when a bug is UPDATED

function BugTracking_email_bug_updated ($p_bug_id) {

	BugTracking_email_generic ($p_bug_id, 'updated', _BUG_EMAIL_TITLE_UPDATED, 'updated');

}
// --------------------
// Build the bug info part of the message

function BugTracking_email_build_bug_message ($p_bug_id, $p_message_id, &$p_category, &$vars) {

	global $opnConfig, $bugs, $project, $category, $version, $bugvalues;

	$bugs->ClearCache ();
	$bug = $bugs->RetrieveSingle ($p_bug_id);
	$pro = $project->RetrieveSingle ($bug['project_id']);
	$vars['{PROJECT}'] = $pro['project_name'];
	$ui = $opnConfig['permission']->GetUser ($bug['reporter_id'], 'useruid', '');
	$vars['{REPORTER_NAME}'] = $ui['uname'];
	if ($bug['handler_id']) {
		$ui = $opnConfig['permission']->GetUser ($bug['handler_id'], 'useruid', '');
		$vars['{HANDLER_NAME}'] = $ui['uname'];
	} else {
		$vars['{HANDLER_NAME}'] = '';
	}
	$opnConfig['opndate']->sqlToopnData ($bug['date_submitted']);
	$time = '';
	$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
	$vars['{DATE_SUBMITTED}'] = $time;
	$opnConfig['opndate']->sqlToopnData ($bug['date_updated']);
	$time = '';
	$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
	$vars['{DATE_MODIFIED}'] = $time;
	$vars['{BUG_ID}'] = $p_bug_id;
	$vars['{BUG_TITLE}'] = $p_message_id;
	if ($bug['category']) {
		$cat = $category->RetrieveSingle ($bug['category']);
		$vars['{CATEGORY}'] = $cat['category'];
	} else {
		$vars['{CATEGORY}'] = '';
		$cat['categroy'] = '';
	}
	if ($bug['version']) {
		$ver = $version->RetrieveSingle ($bug['version']);
		$vars['{VERSION}'] = $ver['version'];
	} else {
		$vars['{VERSION}'] = '';
	}
	$vars['{REPRODUCIBILITY}'] = $bugvalues['reproducibility'][$bug['reproducibility']];
	$vars['{SEVERITY}'] = $bugvalues['severity'][$bug['severity']];
	$vars['{PRIORITY}'] = $bugvalues['priority'][$bug['priority']];
	$vars['{STATUS}'] = $bugvalues['status'][$bug['status']];
	$vars['{RESOLUTION}'] = $bugvalues['resolution'][$bug['resolution']];
	if ($p_message_id != _BUG_EMAIL_TITLE_DELETED) {
		$vars['{BUG_URL}'] = encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $p_bug_id,
							'sel_project' => $bug['project_id']) );
	} else {
		$vars['{BUG_URL}'] = '';
	}
	$vars['{SUMMARY}'] = $bug['summary'];
	$vars['{DESCRIPTION}'] = wordwrap ($bug['description']);
	$p_category = '[' . $pro['project_name'] . '] ' . $cat['category'];

}
// --------------------
// Build the bugnotes part of the message

function BugTracking_email_build_bugnote_message ($p_bug_id, &$vars) {

	global $opnConfig, $bugsnotes;

	$bugsnotes->SetBug ($p_bug_id);
	$bugsnotes->ClearCache ();
	$vars['{NOTES}'] = '';
	// BUILT MESSAGE
	if ($bugsnotes->GetCount () ) {
		$notes = $bugsnotes->GetArray ();
		foreach ($notes as $note) {
			$vars['{NOTES}'] .= '-------------------------------------------------------------------------' . _OPN_HTML_NL;
			$ui = $opnConfig['permission']->GetUser ($note['reporter_id'], 'useruid', '');
			$opnConfig['opndate']->sqlToopnData ($note['date_updated']);
			$time = '';
			$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
			$vars['{NOTES}'] .= $ui['uname'] . ' - ' . $time . _OPN_HTML_NL;
			$vars['{NOTES}'] .= '-------------------------------------------------------------------------' . _OPN_HTML_NL;
			$vars['{NOTES}'] .= wordwrap ($note['note']) . _OPN_HTML_NL . _OPN_HTML_NL;
		}
	}

}
// --------------------
// Builds the bug history portion of the bug e-mail

function BugTracking_email_build_history_message ($p_bug_id, &$vars) {

	global $bugshistory;

	$bugshistory->SetBug ($p_bug_id);
	$bugshistory->ClearCache ();
	$history = $bugshistory->GetArray ();
	$vars['{HISTORY}'] = '';
	foreach ($history as $value) {
		$vars['{HISTORY}'] .= str_pad ($value['date'], 20) . str_pad ($value['username'], 15) . str_pad ($value['note'], 18) . str_pad ($value['change'], 15) . _OPN_HTML_NL;
	}

}
// --------------------
// Send bug info to reporter and handler

function BugTracking_email_bug_info ($p_bug_id, $p_message_id, $p_headers = '') {

	global $opnConfig;
	// build subject
	$t_subject = BugTracking_email_build_subject ($p_bug_id);
	// build message
	$t_category = '';
	$vars = array ();
	BugTracking_email_build_bug_message ($p_bug_id, $p_message_id, $t_category, $vars);
	BugTracking_email_build_bugnote_message ($p_bug_id, $vars);
	BugTracking_email_build_history_message ($p_bug_id, $vars);
	// send mail
	// Send Email
	BugTracking_email_send ($opnConfig['bugtrack_sender_email'], $t_subject, $vars, $p_headers, $t_category);

}
// --------------------
// this function sends the actual email

function BugTracking_email_send ($p_recipient, $p_subject, $vars, $p_header, $p_category, $mailfile = 'bug_info') {

	global $opnConfig;

	$t_recipient = trim ($p_recipient);
	$mail = & new opn_mailer ();
	$mail->setHeader ('Errors-To', $opnConfig['adminmail']);
	if ($opnConfig['send_email_via'] != 'smtp') {
		$mail->setHeader ('Return-Path', $opnConfig['adminmail']);
	}
	if ( ($p_header != '') && (is_array ($p_header) ) ) {
		foreach ($p_header as $key => $value) {
			$mail->setHeader ($key, $value);
		}
	}
	$mail->setHeader ('X-Sender', $opnConfig['bugtrack_reply_email']);
	$mail->setHeader ('X-Mailer', 'OPN Bugtracking');
	// $mail->setHeader('User-Agent','OPN Bugtracking');
	$mail->setHeader ('Keywords', $p_category);
	$mail->setHeader ('X-Keywords', $p_category);
	$mail->opn_mail_fill ($t_recipient, $p_subject, 'modules/bug_tracking', $mailfile, $vars, $opnConfig['bugtrack_reply_email'], $opnConfig['bugtrack_reply_email']);
	$mail->send ();
	$mail->init ();

}
// --------------------
// formats the subject correctly
// we include the project name, bug id, and summary.

function BugTracking_email_build_subject ($p_bug_id) {

	global $bugs, $project;

	$bug = $bugs->RetrieveSingle ($p_bug_id);
	$pro = $project->RetrieveSingle ($bug['project_id']);
	// grab the project name
	$p_project_name = $pro['project_name'];
	// grab the subject (summary)
	$p_subject = $bug['summary'];
	return '[' . $p_project_name . ' ' . $p_bug_id . ']: ' . $p_subject;

}

function BugTracking_email_reminder ($send_to, $body, $bug_id) {

	global $opnConfig, $bugs, $project, $category, $bugsnotes;

	$t_subject = BugTracking_email_build_subject ($bug_id);
	$bug = $bugs->RetrieveSingle ($bug_id);
	$pro = $project->RetrieveSingle ($bug['project_id']);
	if ($bug['category']) {
		$cat = $category->RetrieveSingle ($bug['category']);
	} else {
		$cat['categroy'] = '';
	}
	$vars = array ();
	$t_category = '[' . $pro['project_name'] . '] ' . $cat['category'];
	$opnConfig['opndate']->now ();
	$time = '';
	$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
	$t_body = $opnConfig['cleantext']->FixQuotes ($body);
	$vars['{DATE}'] = $time;
	$vars['{USERNAME}'] = $opnConfig['permission']->Userinfo ('uname');
	$vars['{USERMAIL}'] = $opnConfig['permission']->Userinfo ('email');
	$vars['{BUGURL}'] = encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'view_bug',
						'bug_id' => $bug_id,
						'sel_project' => $bug['project_id']) );
	$vars['{REMINDETEXT}'] = $t_body;
	$t_recipients = array ();
	foreach ($send_to as $value) {
		$ui = $opnConfig['permission']->GetUser ($value, 'useruid', '');
		$t_recipients[$value] = $ui['email'];
	}
	$t_emails = array_values ($t_recipients);
	$p_headers['Bcc'] = implode (', ', $t_emails);
	BugTracking_email_send ($opnConfig['bugtrack_sender_email'], $t_subject, $vars, $p_headers, $t_category, 'bug_reminder');
	set_var ('reporter_id', $opnConfig['permission']->Userinfo ('uid'), 'form');
	set_var ('view_state', _OPN_BUG_STATE_PUBLIC, 'form');
	set_var ('note', $body, 'form');
	$bugsnotes->AddRecord ($bug_id);

}

?>