<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/bug_tracking_graphviz_funcs.php');

function BugTracking_GraphRelation () {

	global $opnConfig, $bugs;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$text = mainheaderbug_tracking (1, 'graph_relation', $sel_project, '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, '', $bug_id);
	$t_graph = BugTracking_relgraph_generate_rel_graph ($bug_id, $sel_project);
	$maintable = & new opn_TableClass ('alternator');
	$maintable->AddCols (array ('50%', '50%') );
	$hlp = '<strong>' . _BUG_GRAPH_REALATION . '</strong>';
	$url[0] = $opnConfig['opn_url'] . '/modules/bug_tracking/index.php';
	$url['sel_project'] = $sel_project;
	$url['bug_id'] = $bug_id;
	$url['op'] = 'view_bug';
	$hlp1 = '[ <a class="%alternate%" href="' . encodeurl ($url) . '">' . _BUG_DISPLAY_BUG . '</a> ]';
	$url['op'] = 'graph_dependency';
	$hlp1 .= '[ <a class="%alternate%" href="' . encodeurl ($url) . '">' . _BUG_GRAPH_DEPENDENCY . '</a> ]';
	$maintable->Alternate ();
	$maintable->AddDataRow (array ($hlp, $hlp1), array ('left', 'right') );
	$table = & new opn_TableClass ('default');
	$table->AddCols (array ('100%') );
	$url[0] = $opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/relgraph.php';
	$url['bug_id'] = $bug_id;
	$url['sel_project'] = $sel_project;
	$name = 'relationship_graph_map' . $bug_id . '.map';
	BugTracking_relgraph_output_map ($t_graph, $name);
	$map = file_get_contents ($opnConfig['root_path_datasave'] . $name);
	unlink ($opnConfig['root_path_datasave'] . $name);
	$pattern = '=^(.*)<map(.*)id\="?(\S+)"([^>]*)>(.*)</map>(.*)$=msiU';
	$txt = '';
	preg_match ($pattern, $map, $txt);
	$help = '<img src="' . encodeurl ($url) . '" border="0" usemap="#' . str_replace ('"', '', $txt[3]) . '" alt="" />' . _OPN_HTML_NL;
	$table->AddDataRow (array ($map . $help), array ('center') );
	$hlp1 = '';
	$table->GetTable ($hlp1);
	$table = & new opn_TableClass ('default');
	$table->AddOpenRow ();
	$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/modules/bug_tracking/images/rel_related.png" alt="" />&nbsp;' . _BUG_RELATED_TO);
	$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/modules/bug_tracking/images/rel_dependant.png" alt="" />&nbsp;' . _BUG_DEPENDANT_OF);
	$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/modules/bug_tracking/images/rel_duplicate.png" alt="" />&nbsp;' . _BUG_DUPLICATE_OF);
	$table->AddCloseRow ();
	$hlp2 = '';
	$table->GetTable ($hlp2);
	$maintable->AddOpenRow ();
	$maintable->AddDataCol ($hlp1 . $hlp2, '', '2');
	$maintable->AddCloseRow ();
	$maintable->GetTable ($text);
	$text .= '<br />';
	$form = & new opn_BugFormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_10_', 'bug_tracking');
	$form->UseEditor (false);
	$form->UseWysiwyg (false);
	$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php');
	$bug = $bugs->RetrieveSingle ($bug_id);
	BugTracking_DisplayBug ($form, $bug, $sel_project);
	$form->AddFormEnd ();
	$form->GetFormular ($text);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_20_';
	$_display_dat['module'] = 'modules/bug_tracking';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $text);

}

function BugTracking_GraphDependency () {

	global $opnConfig, $bugs;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$graphr = '';
	get_var ('graphr', $graphr, 'both', _OOBJ_DTYPE_CLEAN);
	$p_horizontal = false;
	$ori = 'vertical';
	if ($graphr == '') {
		if ($opnConfig['bugtracking_graph_orientation'] == 'horizontal') {
			$p_horizontal = true;
			$ori = 'horizontal';
		}
	} elseif ($graphr == 'horizontal') {
		$p_horizontal = true;
		$ori = 'horizontal';
	}
	$text = mainheaderbug_tracking (1, 'graph_relation', $sel_project, '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, '', $bug_id);
	$t_graph = BugTracking_relgraph_generate_dep_graph ($bug_id, $sel_project, $p_horizontal);
	$maintable = & new opn_TableClass ('alternator');
	$maintable->AddCols (array ('50%', '50%') );
	$hlp = '<strong>' . _BUG_GRAPH_DEPENDENCY . '</strong>';
	$url[0] = $opnConfig['opn_url'] . '/modules/bug_tracking/index.php';
	$url['sel_project'] = $sel_project;
	$url['bug_id'] = $bug_id;
	$url['op'] = 'view_bug';
	$hlp1 = '[ <a class="%alternate%" href="' . encodeurl ($url) . '">' . _BUG_DISPLAY_BUG . '</a> ]';
	$url['op'] = 'graph_relation';
	$hlp1 .= ' [ <a class="%alternate%" href="' . encodeurl ($url) . '">' . _BUG_GRAPH_REALATION . '</a> ]';
	$url['op'] = 'graph_dependency';
	if ($p_horizontal) {
		$url['graphr'] = 'vertical';
		$linktext = _BUG_GRAPH_VERTICAL;
	} else {
		$url['graphr'] = 'horizontal';
		$linktext = _BUG_GRAPH_HORIZONTAL;
	}
	$hlp1 .= ' [ <a class="%alternate%" href="' . encodeurl ($url) . '">' . $linktext . '</a> ]';
	$maintable->Alternate ();
	$maintable->AddDataRow (array ($hlp, $hlp1), array ('left', 'right') );
	$table = & new opn_TableClass ('default');
	$table->AddCols (array ('100%') );
	$url[0] = $opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/depgraph.php';
	$url['bug_id'] = $bug_id;
	$url['sel_project'] = $sel_project;
	$url['graphr'] = $ori;
	$name = 'relationship_graph_map' . $bug_id . '.map';
	BugTracking_relgraph_output_map ($t_graph, $name);
	$map = file_get_contents ($opnConfig['root_path_datasave'] . $name);
	unlink ($opnConfig['root_path_datasave'] . $name);
	$pattern = '=^(.*)<map(.*)id\="?(\S+)"([^>]*)>(.*)</map>(.*)$=msiU';
	$txt = '';
	preg_match ($pattern, $map, $txt);
	$help = '<img src="' . encodeurl ($url) . '" border="0" usemap="#' . str_replace ('"', '', $txt[3]) . '" alt="" />' . _OPN_HTML_NL;
	$table->AddDataRow (array ($map . $help), array ('center') );
	$hlp1 = '';
	$table->GetTable ($hlp1);
	$table = & new opn_TableClass ('default');
	$table->AddOpenRow ();
	$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/modules/bug_tracking/images/rel_related.png" alt="" />&nbsp;' . _BUG_RELATED_TO);
	$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/modules/bug_tracking/images/rel_dependant.png" alt="" />&nbsp;' . _BUG_DEPENDANT_OF);
	$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/modules/bug_tracking/images/rel_duplicate.png" alt="" />&nbsp;' . _BUG_DUPLICATE_OF);
	$table->AddCloseRow ();
	$hlp2 = '';
	$table->GetTable ($hlp2);
	$maintable->AddOpenRow ();
	$maintable->AddDataCol ($hlp1 . $hlp2, '', '2');
	$maintable->AddCloseRow ();
	$maintable->GetTable ($text);
	$text .= '<br />';
	$form = & new opn_BugFormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_30_', 'bug_tracking');
	$form->UseEditor (false);
	$form->UseWysiwyg (false);
	$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php');
	$bug = $bugs->RetrieveSingle ($bug_id);
	BugTracking_DisplayBug ($form, $bug, $sel_project);
	$form->AddFormEnd ();
	$form->GetFormular ($text);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_40_';
	$_display_dat['module'] = 'modules/bug_tracking';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $text);

}

?>