<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_BUGS_HISTORY_INCLUDED') ) {
	define ('_OPN_BUGS_HISTORY_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsabstract.php');
	getLanguageDef (_OPN_ROOT_PATH . 'modules/bug_tracking/include/language/');

	class BugsHistory extends AbstractBugs {
		var $_bug = 0;

		function BugsHistory () {

			$this->_fieldname = 'history_id';
			$this->_tablename = 'bugs_history';

		}

		function SetBug ($bug) {

			$this->_bug = $bug;

		}

		function RetrieveAll () {

			global $opnConfig, $opnTables, $bugvalues;

			$this->_cache = array ();
			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->Execute ('SELECT history_id, bug_id, user_id, date_modified, field_name, old_value, new_value, wtype FROM ' . $opnTables['bugs_history'] . $where . ' ORDER BY date_modified ASC');
			$this->_cache = array ();
			$i = 0;
			$v_date_modified = '';
			$v_field_name = '';
			$v_old_value = '';
			$v_new_value = '';
			$v_wtype = '';
			$v_user_id = '';
			while (! $result->EOF) {
				$row = $result->GetRowAssoc ('0');
				extract ($row, EXTR_PREFIX_ALL, 'v');
				$opnConfig['opndate']->now ();
				$opnConfig['opndate']->sqlToopnData ($v_date_modified);
				$v_date_modified = '';
				$opnConfig['opndate']->formatTimestamp ($v_date_modified, _DATE_DATESTRING5);
				switch ($v_field_name) {
					case 'category':
						include_once (_OPN_ROOT_PATH . 'modules/project/include/class.category.php');
						$cats = & new ProjectCategory ();
						$cat = $cats->RetrieveSingle ($v_old_value);
						$v_old_value = $cat['category'];
						$cat = $cats->RetrieveSingle ($v_new_value);
						$v_new_value = $cat['category'];
						unset ($cats);
						unset ($cat);
						$t_field_localized = _BUG_INC_CATEGORY;
						break;
					case 'version':
						include_once (_OPN_ROOT_PATH . 'modules/project/include/class.version.php');
						$vers = & new ProjectVersion ();
						if ($v_old_value != 0) {
							$ver = $vers->RetrieveSingle ($v_old_value);
							$v_old_value = $ver['version'];
						} else {
							$v_old_value = '';
						}
						if ($v_new_value != 0) {
							$ver = $vers->RetrieveSingle ($v_new_value);
							$v_new_value = $ver['version'];
						} else {
							$v_new_value = '';
						}
						unset ($vers);
						unset ($ver);
						$t_field_localized = _BUG_INC_VERSION;
						break;
					case 'duplicate_id':
						$t_field_localized = _BUG_INC_DUPLICATE_ID;
						break;
					case 'fixed_in_version':
						include_once (_OPN_ROOT_PATH . 'modules/project/include/class.version.php');
						$vers = & new ProjectVersion ();
						if ($v_old_value != 0) {
							$ver = $vers->RetrieveSingle ($v_old_value);
							$v_old_value = $ver['version'];
						} else {
							$v_old_value = '';
						}
						if ($v_new_value != 0) {
							$ver = $vers->RetrieveSingle ($v_new_value);
							$v_new_value = $ver['version'];
						} else {
							$v_new_value = '';
						}
						unset ($vers);
						unset ($ver);
						$t_field_localized = _BUG_INC_SOLVED_IN_VERSION;
						break;
					case 'status':
						$v_old_value = $bugvalues['status'][$v_old_value];
						$v_new_value = $bugvalues['status'][$v_new_value];
						$t_field_localized = _BUG_INC_STATUS;
						break;
					case 'severity':
						$v_old_value = $bugvalues['severity'][$v_old_value];
						$v_new_value = $bugvalues['severity'][$v_new_value];
						$t_field_localized = _BUG_INC_SEVERITY;
						break;
					case 'reproducibility':
						$v_old_value = $bugvalues['reproducibility'][$v_old_value];
						$v_new_value = $bugvalues['reproducibility'][$v_new_value];
						$t_field_localized = _BUG_INC_REPRO;
						break;
					case 'resolution':
						$v_old_value = $bugvalues['resolution'][$v_old_value];
						$v_new_value = $bugvalues['resolution'][$v_new_value];
						$t_field_localized = _BUG_INC_RESOLUTION;
						break;
					case 'priority':
						$v_old_value = $bugvalues['priority'][$v_old_value];
						$v_new_value = $bugvalues['priority'][$v_new_value];
						$t_field_localized = _BUG_INC_PRIORITY;
						break;
					case 'eta':
						$v_old_value = $bugvalues['eta'][$v_old_value];
						$v_new_value = $bugvalues['eta'][$v_new_value];
						$t_field_localized = _BUG_INC_ETA;
						break;
					case 'view_state':
						$v_old_value = $bugvalues['state'][$v_old_value];
						$v_new_value = $bugvalues['state'][$v_new_value];
						$t_field_localized = _BUG_INC_DISPLAY_STATE;
						break;
					case 'projection':
						$v_old_value = $bugvalues['projection'][$v_old_value];
						$v_new_value = $bugvalues['projection'][$v_new_value];
						$t_field_localized = _BUG_INC_PROJECTION;
						break;
					case 'project_id':
						include_once (_OPN_ROOT_PATH . 'modules/project/include/class.project.php');
						$pros = & new Project ();
						$pro = $pros->RetrieveSingle ($v_old_value);
						$v_old_value = $pro['project_name'];
						$pro = $pros->RetrieveSingle ($v_new_value);
						$v_new_value = $pro['project_name'];
						unset ($pros);
						unset ($pro);
						$t_field_localized = _BUG_INC_PROJECT;
						break;
					case 'handler_id':
						if (intval ($v_old_value) == 0) {
							$v_old_value = '';
						} else {
							$v_old_value = $opnConfig['permission']->GetUser (intval ($v_old_value), 'useruid', '');
							$v_old_value = $v_old_value['uname'];
						}
						if (intval ($v_new_value) == 0) {
							$v_new_value = '';
						} else {
							$v_new_value = $opnConfig['permission']->GetUser (intval ($v_new_value), 'useruid', '');
							$v_new_value = $v_new_value['uname'];
						}
						$t_field_localized = _BUG_INC_HANDLER;
						break;
					case 'reporter_id':
						if (intval ($v_old_value) == 0) {
							$v_old_value = '';
						} else {
							$v_old_value = $opnConfig['permission']->GetUser (intval ($v_old_value), 'useruid', '');
							$v_old_value = $v_old_value['uname'];
						}
						if (intval ($v_new_value) == 0) {
							$v_new_value = '';
						} else {
							$v_new_value = $opnConfig['permission']->GetUser (intval ($v_new_value), 'useruid', '');
							$v_new_value = $v_new_value['uname'];
						}
						$t_field_localized = _BUG_INC_REPORTER;
						break;
					case 'summary':
						$t_field_localized = _BUG_INC_SUMMARY;
						break;
					default:
						$t_field_localized = $v_field_name;
						break;
				}
				if (_OPN_HISTORY_NORMAL_TYPE != $v_wtype) {
					switch ($v_wtype) {
						case _OPN_HISTORY_NEW_BUG:
							$t_note = _BUG_INC_HISTORY_NEW_BUG;
							break;
						case _OPN_HISTORY_BUGNOTE_ADDED:
							$t_note = sprintf (_BUG_INC_HISTORY_BUGNOTE_ADDED, $v_old_value);
							break;
						case _OPN_HISTORY_BUGNOTE_UPDATED:
							$t_note = sprintf (_BUG_INC_HISTORY_BUGNOTE_UPDATED, $v_old_value);
							break;
						case _OPN_HISTORY_BUGNOTE_DELETED:
							$t_note = sprintf (_BUG_INC_HISTORY_BUGNOTE_DELETED, $v_old_value);
							break;
						case _OPN_HISTORY_SUMMARY_UPDATED:
							$t_note = _BUG_INC_HISTORY_SUMMARY_UPDATED;
							break;
						case _OPN_HISTORY_DESCRIPTION_UPDATED:
							$t_note = _BUG_INC_HISTORY_DESCRIPTION_UPDATED;
							break;
						case _OPN_HISTORY_ADDITIONAL_INFO_UPDATED:
							$t_note = _BUG_INC_HISTORY_ADDITIONAL_INFO_UPDATED;
							break;
						case _OPN_HISTORY_STEP_TO_REPRODUCE_UPDATED:
							$t_note = _BUG_INC_HISTORY_STEP_TO_REPRODUCE_UPDATED;
							break;
						case _OPN_HISTORY_FILE_ADDED:
							$t_note = sprintf (_BUG_INC_HISTORY_FILE_ADDED, $v_old_value);
							break;
						case _OPN_HISTORY_FILE_DELETED:
							$t_note = sprintf (_BUG_INC_HISTORY_FILE_DELETED, $v_old_value);
							break;
						case _OPN_HISTORY_BUGNOTE_STATE_CHANGED:
							$v_old_value = $bugvalues['state'][$v_old_value];
							$t_note = sprintf (_BUG_INC_HISTORY_BUGNOTE_STATE_CHANGED, $v_old_value, $v_new_value);
							break;
						case _OPN_HISTORY_BUG_MONITOR:
							$v_old_value = $opnConfig['permission']->GetUser (intval ($v_old_value), 'userid', '');
							$v_old_value = $v_old_value['uname'];
							$t_note = sprintf (_BUG_INC_HISTORY_BUG_MONITOR, $v_old_value);
							break;
						case _OPN_HISTORY_BUG_UNMONITOR:
							$v_old_value = $opnConfig['permission']->GetUser (intval ($v_old_value), 'userid', '');
							$v_old_value = $v_old_value['uname'];
							$t_note = sprintf (_BUG_INC_HISTORY_BUG_UNMONITOR, $v_old_value);
							break;
						case _OPN_HISTORY_BUG_DELETED:
							$t_note = sprintf (_BUG_INC_HISTORY_BUG_DELETED, $v_old_value);
							break;
						case _OPN_HISTORY_BUG_RELEATION:
						case _OPN_HISTORY_BUG_RELEATION_DELETE:
							$t_note = _BUG_INC_RELATION_ADDED;
							if ($v_wtype == _OPN_HISTORY_BUG_RELEATION_DELETE) {
								$t_note = _BUG_INC_RELATION_DELETED;
							}
							switch ($v_old_value) {
							case _OPN_BUG_RELATION_RELATED:
								$v_new_value = _BUG_INC_RELATED_TO . ' ' . $v_new_value;
								break;
							case _OPN_BUG_RELATION_DEPENDANT_ON:
								$v_new_value = _BUG_INC_DEPENDANT_ON . ' ' . $v_new_value;
								break;
							case _OPN_BUG_RELATION_DEPENDANT_OF:
								$v_new_value = _BUG_INC_DEPENDANT_OF . ' ' . $v_new_value;
								break;
							case _OPN_BUG_RELATION_DUPLICATE_OF:
								$v_new_value = _BUG_INC_DUPLICATE_OF . ' ' . $v_new_value;
								break;
							case _OPN_BUG_RELATION_HAS_DUPLICATE:
								$v_new_value = _BUG_INC_HAS_DUPLICATE . ' ' . $v_new_value;
								break;
						}
						// switch
						break;
					}
				}
				$this->_cache[$i]['date'] = $v_date_modified;
				$this->_cache[$i]['userid'] = $v_user_id;
				$ui = $opnConfig['permission']->GetUser (intval ($v_user_id), 'userid', '');
				$this->_cache[$i]['username'] = $ui['uname'];

				# output special cases
				if (_OPN_HISTORY_NORMAL_TYPE != $v_wtype) {
					$this->_cache[$i]['note'] = $t_note;
					$this->_cache[$i]['change'] = '';
					if ( ($v_wtype == _OPN_HISTORY_BUG_RELEATION) || ($v_wtype == _OPN_HISTORY_BUG_RELEATION_DELETE) ) {
						$this->_cache[$i]['change'] = $v_new_value;
					}
				} else {

					# output normal changes

					$this->_cache[$i]['note'] = $t_field_localized;
					$this->_cache[$i]['change'] = $v_old_value . ' => ' . $v_new_value;
				}

				# end if DEFAULT

				$i++;
				$result->MoveNext ();
			}

			# end for loop

			$result->Close ();

		}

		function RetrieveSingle ($id) {

			global $opnConfig, $opnTables;
			if (!isset ($this->_cache[$id]) ) {
				$where = ' WHERE history_id=' . $id;
				$result = $opnConfig['database']->Execute ('SELECT history_id, bug_id, user_id, date_modified, field_name, old_value, new_value FROM ' . $opnTables['bugs_history'] . $where);
				$this->_cache[$result->fields['history_id']]['history_id'] = $result->fields['history_id'];
				$this->_cache[$result->fields['history_id']]['bug_id'] = $result->fields['bug_id'];
				$this->_cache[$result->fields['history_id']]['user_id'] = $result->fields['user_id'];
				$this->_cache[$result->fields['history_id']]['date_modified'] = $result->fields['date_modified'];
				$this->_cache[$result->fields['history_id']]['old_value'] = $result->fields['old_value'];
				$this->_cache[$result->fields['history_id']]['new_value'] = $result->fields['new_value'];
				$this->_cache[$result->fields['history_id']]['wtype'] = $result->fields['wtype'];
				$result->Close ();
			}
			return $this->_cache[$id];

		}

		function AddRecord () {

			global $opnConfig, $opnTables;

			$bug_id = func_get_arg (0);
			$user_id = 0;
			get_var ('user_id', $user_id, 'form', _OOBJ_DTYPE_INT);
			$field_name = '';
			get_var ('field_name', $field_name, 'form', _OOBJ_DTYPE_CHECK);
			$old_value = '';
			get_var ('old_value', $old_value, 'form', _OOBJ_DTYPE_CHECK);
			$new_value = '';
			get_var ('new_value', $new_value, 'form', _OOBJ_DTYPE_CHECK);
			$wtype = 0;
			get_var ('wtype', $wtype, 'form', _OOBJ_DTYPE_INT);
			$opnConfig['opndate']->now ();
			$time = '';
			$opnConfig['opndate']->opnDataTosql ($time);
			$history_id = $opnConfig['opnSQL']->get_new_number ('bugs_history', 'history_id');
			$this->_cache[$history_id]['history_id'] = $history_id;
			$this->_cache[$history_id]['bug_id'] = $bug_id;
			$this->_cache[$history_id]['user_id'] = $user_id;
			$this->_cache[$history_id]['date_modified'] = $time;
			$this->_cache[$history_id]['field_name'] = $field_name;
			$this->_cache[$history_id]['old_value'] = $old_value;
			$this->_cache[$history_id]['new_value'] = $new_value;
			$this->_cache[$history_id]['wtype'] = $wtype;
			$field_name = $opnConfig['opnSQL']->qstr ($field_name);
			$old_value = $opnConfig['opnSQL']->qstr ($old_value);
			$new_value = $opnConfig['opnSQL']->qstr ($new_value);
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['bugs_history'] . "(history_id, bug_id,user_id,date_modified,field_name,old_value,new_value,wtype) VALUES ($history_id,$bug_id,$user_id,$time,$field_name,$old_value,$new_value,$wtype)");

		}

		function DeleteRecord ($id = '') {

			global $opnConfig, $opnTables;

			$t = $id;
			$history_id = 0;
			get_var ('history_id', $history_id, 'both', _OOBJ_DTYPE_INT);
			unset ($this->_cache[$history_id]);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_history'] . ' WHERE history_id=' . $history_id);

		}

		function DeleteByBug ($bug_id) {

			global $opnConfig, $opnTables;

			$this->cache = array ();
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_history'] . ' WHERE bug_id=' . $bug_id);

		}

		function BuildWhere () {
			if ($this->_bug) {
				return ' WHERE bug_id=' . $this->_bug;
			}
			return '';

		}

	}
}

?>