<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_BUGS_USERSETTINGS_INCLUDED') ) {
	define ('_OPN_BUGS_USERSETTINGS_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsabstract.php');

	class BugsUserSettings extends AbstractBugs {
		var $_userid = 0;

		function BugsUserSettings () {

			$this->_fieldname = 'uid';
			$this->_tablename = 'bugs_user_pref';

		}

		function SetUser ($userid) {

			$this->_userid = $userid;

		}

		function RetrieveAll () {

			global $opnConfig, $opnTables;

			$this->_cache = array ();
			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->Execute ('SELECT uid, default_project, block_resolved, block_closed, bugs_perpage, refresh_delay, email_on_new, email_on_updated, email_on_deleted, email_on_assigned, email_on_feedback, email_on_resolved,email_on_closed, email_on_reopened, email_on_bugnote, email_on_status,email_on_priority, print_pref, block_feature FROM ' . $opnTables['bugs_user_pref'] . $where . ' ORDER BY uid');
			while (! $result->EOF) {
				$id = $result->fields['uid'];
				$this->_cache[$id]['uid'] = $result->fields['uid'];
				$this->_cache[$id]['default_project'] = $result->fields['default_project'];
				$this->_cache[$id]['block_resolved'] = $result->fields['block_resolved'];
				$this->_cache[$id]['block_closed'] = $result->fields['block_closed'];
				$this->_cache[$id]['bugs_perpage'] = $result->fields['bugs_perpage'];
				$this->_cache[$id]['refresh_delay'] = $result->fields['refresh_delay'];
				$this->_cache[$id]['email_on_new'] = $result->fields['email_on_new'];
				$this->_cache[$id]['email_on_updated'] = $result->fields['email_on_updated'];
				$this->_cache[$id]['email_on_deleted'] = $result->fields['email_on_deleted'];
				$this->_cache[$id]['email_on_assigned'] = $result->fields['email_on_assigned'];
				$this->_cache[$id]['email_on_feedback'] = $result->fields['email_on_feedback'];
				$this->_cache[$id]['email_on_resolved'] = $result->fields['email_on_resolved'];
				$this->_cache[$id]['email_on_closed'] = $result->fields['email_on_closed'];
				$this->_cache[$id]['email_on_reopened'] = $result->fields['email_on_reopened'];
				$this->_cache[$id]['email_on_bugnote'] = $result->fields['email_on_bugnote'];
				$this->_cache[$id]['email_on_status'] = $result->fields['email_on_status'];
				$this->_cache[$id]['email_on_priority'] = $result->fields['email_on_priority'];
				$this->_cache[$id]['print_pref'] = $result->fields['print_pref'];
				$this->_cache[$id]['block_feature'] = $result->fields['block_feature'];
				$result->MoveNext ();
			}
			$result->Close ();

		}

		function RetrieveSingle ($id) {

			global $opnConfig, $opnTables;
			if (!isset ($this->_cache[$id]) ) {
				$where = ' WHERE uid=' . $id;
				$result = $opnConfig['database']->Execute ('SELECT uid, default_project, block_resolved, block_closed, bugs_perpage, refresh_delay, email_on_new, email_on_updated, email_on_deleted, email_on_assigned, email_on_feedback, email_on_resolved,email_on_closed, email_on_reopened, email_on_bugnote, email_on_status,email_on_priority, print_pref, block_feature FROM ' . $opnTables['bugs_user_pref'] . $where);
				$this->_cache[$id]['uid'] = $result->fields['uid'];
				$this->_cache[$id]['default_project'] = $result->fields['default_project'];
				$this->_cache[$id]['block_resolved'] = $result->fields['block_resolved'];
				$this->_cache[$id]['block_closed'] = $result->fields['block_closed'];
				$this->_cache[$id]['bugs_perpage'] = $result->fields['bugs_perpage'];
				$this->_cache[$id]['refresh_delay'] = $result->fields['refresh_delay'];
				$this->_cache[$id]['email_on_new'] = $result->fields['email_on_new'];
				$this->_cache[$id]['email_on_updated'] = $result->fields['email_on_updated'];
				$this->_cache[$id]['email_on_deleted'] = $result->fields['email_on_deleted'];
				$this->_cache[$id]['email_on_assigned'] = $result->fields['email_on_assigned'];
				$this->_cache[$id]['email_on_feedback'] = $result->fields['email_on_feedback'];
				$this->_cache[$id]['email_on_resolved'] = $result->fields['email_on_resolved'];
				$this->_cache[$id]['email_on_closed'] = $result->fields['email_on_closed'];
				$this->_cache[$id]['email_on_reopened'] = $result->fields['email_on_reopened'];
				$this->_cache[$id]['email_on_bugnote'] = $result->fields['email_on_bugnote'];
				$this->_cache[$id]['email_on_status'] = $result->fields['email_on_status'];
				$this->_cache[$id]['email_on_priority'] = $result->fields['email_on_priority'];
				$this->_cache[$id]['print_pref'] = $result->fields['print_pref'];
				$this->_cache[$id]['block_feature'] = $result->fields['block_feature'];
				$result->Close ();
			}
			return $this->_cache[$id];

		}

		function ModifyRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/bug_tracking', array (_PERM_WRITE, _PERM_NEW, _PERM_ADMIN) );
			$uid = 0;
			get_var ('uid', $uid, 'form', _OOBJ_DTYPE_INT);
			$default_project = 0;
			get_var ('default_project', $default_project, 'form', _OOBJ_DTYPE_INT);
			$block_resolved = 0;
			get_var ('block_resolved', $block_resolved, 'form', _OOBJ_DTYPE_INT);
			$block_closed = 0;
			get_var ('block_closed', $block_closed, 'form', _OOBJ_DTYPE_INT);
			$bugs_perpage = 0;
			get_var ('bugs_perpage', $bugs_perpage, 'form', _OOBJ_DTYPE_INT);
			$refresh_delay = 0;
			get_var ('refresh_delay', $refresh_delay, 'form', _OOBJ_DTYPE_INT);
			$email_on_new = 0;
			get_var ('email_on_new', $email_on_new, 'form', _OOBJ_DTYPE_INT);
			$email_on_updated = 0;
			get_var ('email_on_updated', $email_on_updated, 'form', _OOBJ_DTYPE_INT);
			$email_on_deleted = 0;
			get_var ('email_on_deleted', $email_on_deleted, 'form', _OOBJ_DTYPE_INT);
			$email_on_assigned = 0;
			get_var ('email_on_assigned', $email_on_assigned, 'form', _OOBJ_DTYPE_INT);
			$email_on_feedback = 0;
			get_var ('email_on_feedback', $email_on_feedback, 'form', _OOBJ_DTYPE_INT);
			$email_on_resolved = 0;
			get_var ('email_on_resolved', $email_on_resolved, 'form', _OOBJ_DTYPE_INT);
			$email_on_closed = 0;
			get_var ('email_on_closed', $email_on_closed, 'form', _OOBJ_DTYPE_INT);
			$email_on_reopened = 0;
			get_var ('email_on_reopened', $email_on_reopened, 'form', _OOBJ_DTYPE_INT);
			$email_on_bugnote = 0;
			get_var ('email_on_bugnote', $email_on_bugnote, 'form', _OOBJ_DTYPE_INT);
			$email_on_status = 0;
			get_var ('email_on_status', $email_on_status, 'form', _OOBJ_DTYPE_INT);
			$email_on_priority = 0;
			get_var ('email_on_priority', $email_on_priority, 'form', _OOBJ_DTYPE_INT);
			$print_pref = '';
			get_var ('print_pref', $print_pref, 'form', _OOBJ_DTYPE_CHECK);
			$block_feature = 0;
			get_var ('block_feature', $block_feature, 'form', _OOBJ_DTYPE_INT);
			$print_pref = $opnConfig['opnSQL']->qstr ($print_pref);
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bugs_user_pref'] . " SET default_project = $default_project, block_resolved=$block_resolved, " . "block_closed=$block_closed, bugs_perpage=$bugs_perpage, refresh_delay=$refresh_delay, " . "email_on_new=$email_on_new, email_on_updated=$email_on_updated, email_on_deleted=$email_on_deleted, " . "email_on_assigned=$email_on_assigned, email_on_feedback=$email_on_feedback, " . "email_on_resolved=$email_on_resolved, email_on_closed=$email_on_closed, email_on_reopened=$email_on_reopened, " . "email_on_bugnote=$email_on_bugnote, email_on_status=$email_on_status, email_on_priority=$email_on_priority, " . "print_pref=$print_pref, block_feature=$block_feature WHERE uid=" . $uid);

		}

		function DeleteRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/bug_tracking', array (_PERM_DELETE, _PERM_ADMIN) );
			$uid = 0;
			get_var ('uid', $uid, 'both', _OOBJ_DTYPE_INT);
			unset ($this->_cache[$uid]);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_user_pref'] . ' WHERE uid=' . $uid);

		}

		function BuildWhere () {
			if ($this->_userid) {
				return ' WHERE uid=' . $this->_userid;
			}
			return '';

		}

	}
}

?>