<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../../../mainfile.php');
}
global $opnConfig, $opnTables;

getLanguageDef (_OPN_ROOT_PATH . 'modules/bug_tracking/include/graphics/language/');
$opnConfig['module']->InitModule ('modules/bug_tracking');
if (!isset ($opnConfig['ttffont']) ) {
	$opnConfig['ttffont'] = 'NONE';
}
if (!isset ($opnConfig['xres']) ) {
	$opnConfig['xres'] = 800;
}
if (!isset ($opnConfig['yres']) ) {
	$opnConfig['yres'] = 600;
}
$project_id = 0;
get_var ('project_id', $project_id, 'url', _OOBJ_DTYPE_INT);
$pie = 0;
get_var ('pie', $pie, 'url', _OOBJ_DTYPE_INT);
$where = ' WHERE handler_id>0';
if ($project_id) {
	$where .= ' AND project_id=' . $project_id;
}
$query = 'SELECT handler_id,count(bug_ID) as counter FROM ' . $opnTables['bugs'] . $where . ' GROUP BY handler_id';
$t_last_handler = -1;
$t_bugs_total = 0;
$result = $opnConfig['database']->Execute ($query);
$data = array ();
$counter1 = 0;
while (! $result->EOF) {
	if (isset ($result->fields['counter']) ) {
		$counter = $result->fields['counter'];
	} else {
		$counter = 0;
	}
	if ( ($result->fields['handler_id'] != $t_last_handler) && ($t_last_handler != -1) ) {
		$ui = $opnConfig['permission']->GetUser ($t_last_handler, 'useruid', '');
		$data[] = array ($ui['uname'],
				$counter1);
	}
	$counter1 = $counter;
	$t_bugs_total += $counter;
	$t_last_handler = $result->fields['handler_id'];
	$result->MoveNext ();
}
if (0<$t_bugs_total) {
	$ui = $opnConfig['permission']->GetUser ($t_last_handler, 'useruid', '');
	$data[] = array ($ui['uname'],
			$counter1);
}
$result->Close ();
if (count ($data) ) {
	if ($pie) {
		$legend = array ();
		foreach ($data as $value) {
			$legend[] = $value[0];
		}
	}
	include_once (_OPN_ROOT_PATH . 'modules/phplot/class/phplot.php');
	$graph = & new PHPlot ($opnConfig['xres'], $opnConfig['yres']);
	if (!$pie) {
		$graph->SetDataType ('text-data');
	} else {
		$graph->SetDataType ('text-data-single');
	}
	$graph->SetDataValues ($data);
	$graph->SetFileFormat ('jpg');
	$graph->SetYLabelType ('data');
	$graph->SetDrawXGrid (TRUE);
	$graph->SetDrawYGrid (TRUE);
	$graph->SetXTickIncrement (1);
	$graph->SetXTickLength (5);
	$graph->SetXTickCrossing (3);
	$graph->SetXTickPos ('plotdown');
	$graph->SetXTickLabelPos ('plotdown');
	$graph->SetXDataLabelPos ('plotdown');
	$graph->SetDrawDashedGrid (1);
	if (!$pie) {
		$graph->SetPrecisionY (0);
		$graph->SetTitle (_BUG_GRAPH_BY_DEVELOPER);
	} else {
		$graph->SetPrecisionY (2);
		$graph->SetPrecisionX (2);
		$graph->SetRGBArray ('small');
		$graph->SetDataColors (array ('yellow',
						'green',
						'orange',
						'blue',
						'DarkGreen',
						'red',
						'gold',
						'lavender',
						'magenta'),
						array ('black') );
		$graph->SetTitle (_BUG_GRAPH_BY_DEVELOPER_PERCENTAGE);
		$graph->SetLegend ($legend);
	}
	$graph->SetBrowserCache (true);
	$graph->SetXTitle ('');
	$graph->SetYTitle ('');
	if (!$pie) {
		$graph->SetPlotType ('bars');
		$graph->SetMarginsPixels (50, 50, 50, 150);
		$graph->SetPlotAreaWorld ();
		$graph->SetPlotAreaPixels ();
		$graph->SetXLabelAngle (90);
	} else {
		$graph->SetPlotType ('pie');
	}
	if ($opnConfig['ttffont'] != 'NONE') {
		$graph->SetUseTTF (true);
		$graph->SetDefaultTTFont ($opnConfig['ttffont']);
	}
	$graph->SetLineWidth (1);
	$graph->DrawGraph ();
	$graph->PrintImage ();
}

?>