<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig, $opnTables;

global $bugs, $bugshistory, $bugsmonitoring, $bugsnotes;

global $project, $category, $version, $bugrelation;

global $bugvalues, $settings, $bugusers, $bugsattachments;

$opnConfig['permission']->InitPermissions ('modules/bug_tracking');
$opnConfig['module']->InitModule ('modules/bug_tracking');
$opnConfig['opnOutput']->setMetaPageName ('modules/bug_tracking');
if ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_PERM_READ, _PERM_BOT), true) ) {
	$opnConfig['module']->InitModule ('modules/bug_tracking');
	$opnConfig['opnOutput']->setMetaPageName ('modules/bug_tracking');
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/function_center.php');
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/bug_tracking_email.php');
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/bugs.constants.php');
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugs.php');
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsattachments.php');
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugshistory.php');
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsmonitoring.php');
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsnotes.php');
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsrelation.php');
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsusersettings.php');
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bug.formular.php');
	include_once (_OPN_ROOT_PATH . 'modules/project/include/class.project.php');
	include_once (_OPN_ROOT_PATH . 'modules/project/include/class.category.php');
	include_once (_OPN_ROOT_PATH . 'modules/project/include/class.version.php');
	include_once (_OPN_ROOT_PATH . 'modules/project/include/class.user.php');
	include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_cssparser.php');
	getLanguageDef (_OPN_ROOT_PATH . 'modules/bug_tracking/language/');
	if (!defined ('_OPN_MAILER_INCLUDED') ) {
		include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
	}
	BugTracking_InitArrays ();
	$bugs = & new Bugs ();
	$bugsattachments = & new BugsAttachments ();
	$bugshistory = & new BugsHistory ();
	$bugsmonitoring = & new BugsMonitoring ();
	$bugsnotes = & new BugsNotes ();
	$bugsrelation = & new BugsRelation ();
	$project = & new Project ();
	$category = & new ProjectCategory ();
	$version = & new ProjectVersion ();
	$op = '';
	get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
	$add_note = '';
	get_var ('add_note', $add_note, 'form', _OOBJ_DTYPE_CHECK);
	$monitorbug = '';
	get_var ('monitorbug', $monitorbug, 'form', _OOBJ_DTYPE_CHECK);
	$unmonitorbug = '';
	get_var ('unmonitorbug', $unmonitorbug, 'form', _OOBJ_DTYPE_CHECK);
	$delete_bug = '';
	get_var ('delete_bug', $delete_bug, 'form', _OOBJ_DTYPE_CHECK);
	$reopenresolve_bug = '';
	get_var ('reopenresolve_bug', $reopenresolve_bug, 'form', _OOBJ_DTYPE_CHECK);
	$resolve_bug = '';
	get_var ('resolve_bug', $resolve_bug, 'form', _OOBJ_DTYPE_CHECK);
	$reopenclose_bug = '';
	get_var ('reopenclose_bug', $reopenclose_bug, 'form', _OOBJ_DTYPE_CHECK);
	$close_bug = '';
	get_var ('close_bug', $close_bug, 'form', _OOBJ_DTYPE_CHECK);
	$assign_to = '';
	get_var ('assign_to', $assign_to, 'form', _OOBJ_DTYPE_CHECK);
	$move_bug = '';
	get_var ('move_bug', $move_bug, 'form', _OOBJ_DTYPE_CHECK);
	$edit_bug = '';
	get_var ('edit_bug', $edit_bug, 'form', _OOBJ_DTYPE_CHECK);
	$bug_changer = '';
	get_var ('bug_changer', $bug_changer, 'form', _OOBJ_DTYPE_CHECK);
	$add_addrelation = '';
	get_var ('add_addrelation', $add_addrelation, 'form', _OOBJ_DTYPE_CHECK);
	$add_file = '';
	get_var ('add_file', $add_file, 'form', _OOBJ_DTYPE_CHECK);
	if ($add_note != '') {
		$op = 'add_note';
	}
	if ($monitorbug != '') {
		$op = 'monitor_bug';
	}
	if ($unmonitorbug != '') {
		$op = 'unmonitor_bug';
	}
	if ($delete_bug != '') {
		$op = 'delete_bug';
	}
	if ($reopenresolve_bug != '') {
		$op = 'reopenresolve_bug';
	}
	if ($resolve_bug != '') {
		$op = 'resolve_bug';
	}
	if ($reopenclose_bug != '') {
		$op = 'reopenclose_bug';
	}
	if ($close_bug != '') {
		$op = 'close_bug';
	}
	if ($assign_to != '') {
		$op = 'assign_to';
	}
	if ($move_bug != '') {
		$op = 'move_bug';
	}
	if ($edit_bug != '') {
		$op = 'edit_bug';
	}
	if ($bug_changer != '') {
		$op = 'bug_changer';
	}
	if ($add_addrelation != '') {
		$op = 'add_addrelation';
	}
	if ($add_file != '') {
		$op = 'add_file';
	}
	switch ($op) {
		case 'graph_dependency':
			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/bug_tracking_graphviz.php');
			BugTracking_GraphDependency ();
			break;
		case 'graph_relation':
			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/bug_tracking_graphviz.php');
			BugTracking_GraphRelation ();
			break;
		case 'delete_relation':
			BugTracking_DeleteRelation ();
			break;
		case 'add_addrelation':
			BugTracking_AddRelation ();
			break;
		case 'changelog':
			BugTracking_ChangeLog ();
			break;
		case 'csvexport':
			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/bug_tracking_export.php');
			BugTracking_CSV_Export ();
			break;
		case 'summary_graph':
			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/bug_tracking_stats_graph.php');
			BugTracking_Summary_Graph ();
			break;
		case 'summary':
			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/bug_tracking_stats.php');
			BugTracking_Summary ();
			break;
		case 'do_reminder':
			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/bug_tracking_stats.php');
			BugTracking_do_reminder ();
			break;
		case 'reminder':
			BugTracking_Reminder ();
			break;
		case 'do_change_status_bugs':
			BugTracking_DoChangeStatusBugs ();
			break;
		case 'do_change_view':
			BugTracking_DoChangeViewBugs ();
			break;
		case 'do_change_prio_bugs':
			BugTracking_DoChangePrioBugs ();
			break;
		case 'do_resolve_bugs':
			BugTracking_DoResolveBugs ();
			break;
		case 'do_delete_bugs':
			BugTracking_DoDeleteBugs ();
			break;
		case 'do_close_bugs':
			BugTracking_DoCloseBugs ();
			break;
		case 'do_assign_bugs':
			BugTracking_DoAssignBugs ();
			break;
		case 'do_move_bugs':
			BugTracking_DoMoveBugs ();
			break;
		case 'bug_changer':
			BugTracking_BugChange ();
			break;
		case 'do_add_bug':
			BugTracking_AddBug ();
			break;
		case 'submit_bug':
			BugTracking_SubmitBug ();
			break;
		case 'do_modify_bug':
			BugTracking_ModifyBug ();
			break;
		case 'edit_bug':
			BugTracking_EditBug ();
			break;
		case 'assign_to':
			BugTracking_Assign_To ();
			break;
		case 'do_move_bug':
			BugTracking_DoMoveBug ();
			break;
		case 'move_bug':
			BugTracking_MoveBug ();
			break;
		case 'do_close':
			BugTracking_DoCloseBug ();
			break;
		case 'close_bug':
			BugTracking_CloseBug ();
			break;
		case 'doreopen_close':
			BugTracking_DoReopenBug ();
			break;
		case 'reopenclose_bug':
			BugTracking_ReopenBug ();
			break;
		case 'do_resolve':
			BugTracking_DoResolveBug ();
			break;
		case 'resolve_bug':
			BugTracking_ResolveBug ();
			break;
		case 'doreopen_resolve':
			BugTracking_DoReopenResolveBug ();
			break;
		case 'reopenresolve_bug':
			BugTracking_ReopenResolveBug ();
			break;
		case 'delete_bug':
			BugTracking_DeleteBug ();
			break;
		case 'monitor_bug':
			BugTracking_MonitorBug ();
			break;
		case 'unmonitor_bug':
			BugTracking_UnMonitorBug ();
			break;
		case 'change_view_state_note':
			BugTracking_ChangeViewStateNote ();
			break;
		case 'delete_note':
			BugTracking_DeleteNote ();
			break;
		case 'edit_note':
			BugTracking_EditNote ();
			break;
		case 'modify_note':
			BugTracking_ModifyNote ();
			break;
		case 'add_note':
			BugTracking_AddNote ();
			break;
		case 'add_file':
			BugTracking_AddFile ();
			break;
		case 'delete_attachment':
			BugTracking_DeleteFile ();
			break;
		case 'view_bug':
			BugTracking_ViewBug ();
			break;
		default:
			BugTracking_Index ($project, $category, $bugvalues, $settings, $bugusers);
			break;
	}
}

?>