<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/bug_tracking/plugin/middlebox/newbugs/language/');

function newbugs_get_data ($result, $box_array_dat, $css, &$data) {

	global $opnConfig;

	$i = 0;
	while (! $result->EOF) {
		$bug_id = $result->fields['bug_id'];
		$link = $result->fields['summary'];
		$project = $result->fields['project_id'];
		if ($link == '') {
			$link = '---';
		}
		$title = $link;
		$opnConfig['cleantext']->opn_shortentext ($link, $box_array_dat['box_options']['strlength']);
		$data[$i]['link'] = '<a class="' . $css . '" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
											'op' => 'view_bug',
											'bug_id' => $bug_id,
											'sel_project' => $project) ) . '" title="' . htmlspecialchars ($title,
											ENT_QUOTES) . '">' . $link . '</a>';
		$i++;
		$result->MoveNext ();
	}

}

function newbugs_get_middlebox_result (&$box_array_dat) {

	global $opnConfig;

	$boxstuff = $box_array_dat['box_options']['textbefore'];
	$order = ' ORDER BY date_submitted DESC';
	$limit = $box_array_dat['box_options']['limit'];
	if (!isset ($box_array_dat['box_options']['project']) ) {
		$box_array_dat['box_options']['project'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['use_tpl']) ) {
		$box_array_dat['box_options']['use_tpl'] = '';
	}
	if (!isset ($box_array_dat['box_options']['strlength']) ) {
		$box_array_dat['box_options']['strlength'] = 22;
	}
	if (!isset ($box_array_dat['box_options']['block_feature']) ) {
		$box_array_dat['box_options']['block_feature'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['only_feature']) ) {
		$box_array_dat['box_options']['only_feature'] = 0;
	}
	if ( ($box_array_dat['box_options']['block_feature']) && ($box_array_dat['box_options']['only_feature']) ) {
		$box_array_dat['box_options']['only_feature'] = 0;
		$box_array_dat['box_options']['block_feature'] = 0;
	}
	if (!$limit) {
		$limit = 5;
	}
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugs.php');
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/bugs.constants.php');
	$bugs = & new Bugs ();
	if ($box_array_dat['box_options']['project']) {
		$bugs->SetProject ($box_array_dat['box_options']['project']);
	}
	if ($box_array_dat['box_options']['only_feature']) {
		$bugs->SetSeverity (_OPN_BUG_SEVERITY_FEATURE);
	}
	if ($box_array_dat['box_options']['block_feature']) {
		$bugs->SetBlockSeverity (_OPN_BUG_SEVERITY_FEATURE);
	}
	$bugs->SetStatus (_OPN_BUG_STATUS_NEW);
	$bugs->SetOrderby ($order);
	$result = $bugs->GetLimit ($limit, 0);
	unset ($bugs);
	$css = 'opn' . $box_array_dat['box_options']['opnbox_class'] . 'box';
	if ($result !== false) {
		$counter = $result->RecordCount ();
		$data = array ();
		newbugs_get_data ($result, $box_array_dat, $css, $data);
		if ($box_array_dat['box_options']['use_tpl'] == '') {
			$boxstuff .= '<ul class="' . $css . '">';
			foreach ($data as $val) {
				$boxstuff .= '<li class="' . $css . '">' . $val['link'];
				$boxstuff .= '</li>' . _OPN_HTML_NL;
			}
			$themax = $limit - $counter;
			for ($i = 0; $i<$themax; $i++) {
				$boxstuff .= '<li class="invisible">&nbsp;</li>';
			}
			$boxstuff .= '</ul>';
		} else {
			$pos = 0;
			$dcol1 = '2';
			$dcol2 = '1';
			$a = 0;
			$opnliste = array ();
			foreach ($data as $val) {
				$dcolor = ($a == 0? $dcol1 : $dcol2);
				$opnliste[$pos]['topic'] = $val['link'];
				$opnliste[$pos]['case'] = 'nosubtopic';
				$opnliste[$pos]['alternator'] = $dcolor;
				$opnliste[$pos]['image'] = '';
				$opnliste[$pos]['subtopic'][0] = '';
				$pos++;
				$a = ($dcolor == $dcol1?1 : 0);
			}
			get_box_template ($box_array_dat, array ('subtopic',
								'nosubtopic'),
								$opnliste,
								$limit,
								$counter,
								$boxstuff);
		}
		unset ($data);
		$result->Close ();
	}
	get_box_footer ($box_array_dat, $opnConfig['opn_url'] . '/modules/bug_tracking/index.php', $opnConfig['opn_url'] . '/modules/bug_tracking/index.php?op=submit_bug', _MID_BUGTRACKINGNEW_ADD, $boxstuff);
	$boxstuff .= $box_array_dat['box_options']['textafter'];
	$box_array_dat['box_result']['skip'] = false;
	$box_array_dat['box_result']['title'] = $box_array_dat['box_options']['title'];
	$box_array_dat['box_result']['content'] = $boxstuff;
	unset ($boxstuff);

}

?>