<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

define ('_CALENDAR_CALVERSION', '1.1.1 (16)');
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;

getLanguageDef (_OPN_ROOT_PATH . 'modules/calendar/language/');
$opnConfig['permission']->HasRights ('modules/calendar', array (_PERM_READ, _PERM_BOT, _PERM_WRITE) );
$opnConfig['module']->InitModule ('modules/calendar');
$opnConfig['opnOutput']->setMetaPageName ('modules/calendar');
include_once (_OPN_ROOT_PATH . 'include/opn_system_function_text.php');

function buildMonthSelectCAL () {

	$options = array ();
	for ($i = 1; $i<=12; $i++) {
		$month = sprintf ('%02d', $i);
		$options[$month] = (string) $month;
	}
	return $options;

}

function buildDaySelectCAL () {

	$options = array ();
	for ($i = 1; $i<=31; $i++) {
		$day = sprintf ('%02d', $i);
		$options[$day] = (string) $day;
	}
	return $options;

}

function buildYearSelectCAL () {

	$options = array ();
	for ($i = 1999; $i<=2030; $i++) {
		$options[$i] = (string) $i;
	}
	return $options;

}

function printAppt ($sql) {

	global $opnConfig;

	$catemp = '';
	$caparesult = &$opnConfig['database']->Execute ($sql);
	if ($caparesult->RecordCount () == 0) {
		$catemp .= '<br />';
	}
	if ($opnConfig['calendar_eventsopeninnewwindow']) {
		$frame = ' target="blank"';
	} else {
		$frame = '';
	}
	while (! $caparesult->EOF) {
		$eid = $caparesult->fields['eid'];
		$eventdate = $caparesult->fields['eventdate'];
		$opnConfig['opndate']->sqlToopnData ($eventdate);
		$UToday_d = '';
		$opnConfig['opndate']->formatTimestamp ($UToday_d, '%d');
		$UToday_m = '';
		$opnConfig['opndate']->formatTimestamp ($UToday_m, '%m');
		$UToday_y = '';
		$opnConfig['opndate']->formatTimestamp ($UToday_y, '%Y');
		$title = $caparesult->fields['title'];
		$startTime = $caparesult->fields['starttime'];
		$endTime = $caparesult->fields['endtime'];
		$barcolor = $caparesult->fields['barcolor'];
		if ($barcolor == 'r') {
			$barcolorchar = 'r';
		} elseif ($barcolor == 'g') {
			$barcolorchar = 'g';
		} elseif ($barcolor == 'b') {
			$barcolorchar = 'b';
		} elseif ($barcolor == 'y') {
			$barcolorchar = 'y';
		} else {
			$barcolorchar = 'w';
		}
		$opnConfig['opndate']->sqlToopnData ($startTime);
		$hour = '';
		$opnConfig['opndate']->getHour ($hour);
		$minute = '';
		$opnConfig['opndate']->getMinute ($minute);
		$startTime = $hour . ':' . $minute;
		$opnConfig['opndate']->sqlToopnData ($endTime);
		$opnConfig['opndate']->getHour ($hour);
		$opnConfig['opndate']->getMinute ($minute);
		$endTime = $hour . ':' . $minute;
		$catemp .= '<br /><img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ball' . $barcolorchar . '.gif" class="imgtag" alt="" />' . ' <a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
																								'type' => 'view',
																								'eid' => $eid,
																								'Date' => $UToday_y . '-' . sprintf ('%02d-02%d',
																								$UToday_m,
																								$UToday_d) ) ) . '"' . $frame . '>' . $startTime . '-' . $endTime . ', ' . $title . '</a>';
		$caparesult->MoveNext ();
	}
	$caparesult->Close ();
	return $catemp;

}

function getMonthName () {

	global $opnConfig;

	$temp = '';
	$opnConfig['opndate']->formatTimestamp ($temp, '%B');
	return $temp;

}

function getLongDayName () {

	global $opnConfig;

	$temp = '';
	$opnConfig['opndate']->formatTimestamp ($temp, '%A');
	return $temp;

}

function valueToText ($tmp) {

	$tmp = str_replace ( array( chr(10), chr(9), '<', '>', '\'', chr(13)), array ('', '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',
		'&lt;', '&gt;', '&quot;', '<br />'), $tmp);
	return $tmp;

}

function loadPopups () {

	global $opnConfig;
	return '<div id="topdeck" class="modcalpopup">' . _OPN_HTML_NL . '&nbsp;' . _OPN_HTML_NL . '</div>' . _OPN_HTML_NL . '<script type="text/javascript">' . _OPN_HTML_NL . 'var popback="' . $opnConfig['calendar_popbgcolorcontent'] . '";' . _OPN_HTML_NL . 'var popbord="' . $opnConfig['calendar_popcolormain'] . '";' . _OPN_HTML_NL . 'var nav=(document.layers);' . _OPN_HTML_NL . 'var iex=(document.all);' . _OPN_HTML_NL . 'var skn=(nav) ? document.topdeck : topdeck.style;' . _OPN_HTML_NL . 'if (nav) document.captureEvents(Event.MOUSEMOVE);' . _OPN_HTML_NL . 'document.onmousemove = get_mouse;' . _OPN_HTML_NL . 'function pop(title,msg,bord,back) {' . 'var content =\'<table  width="260" border="0" cellpadding="2" cellspacing="0" bgcolor="\'+bord+\'">' . '<tr><td><table  width="100%" border="0" cellpadding="0" cellspacing="0"><tr><td>' . '<div class="centertag"><font color="' . $opnConfig['calendar_popcolormainheadfont'] . '" size="2">' . '<span class="normaltextbold">\'+title+\'</span></font></div></td></tr></table>' . '<table  width="100%" border="0" cellpadding="2" cellspacing="0" bgcolor="\'+back+\'">' . '<tr><td>\'+msg+\'</td></tr></table></td></tr></table>\';' . _OPN_HTML_NL . 'if (nav) {' . _OPN_HTML_NL . '	skn.document.write(content);' . _OPN_HTML_NL . '	skn.document.close();' . _OPN_HTML_NL . '	skn.visibility = "visible";' . _OPN_HTML_NL . '} else if (iex) {' . _OPN_HTML_NL . '	document.all("topdeck").innerHTML = content;' . _OPN_HTML_NL . '	skn.visibility = "visible";' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'function get_mouse(e) {' . _OPN_HTML_NL . 'var x = (nav) ? e.pageX : event.x+document.body.scrollLeft;' . _OPN_HTML_NL . 'var y = (nav) ? e.pageY : event.y+document.body.scrollTop;' . _OPN_HTML_NL . 'skn.left = x - 60;' . _OPN_HTML_NL . 'skn.top  = y+20;' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'function kill() {' . _OPN_HTML_NL . 'skn.visibility = "hidden";' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . '</script>';

}

function buildYear ($Date) {

	global $opnConfig, $opnTables;

	$cabytxt = '';
	if (!$Date) {
		$opnConfig['opndate']->now ();
		$Date = '';
		$opnConfig['opndate']->opnDataTosql ($Date);
	} else {
		$opnConfig['opndate']->setTimestamp ($Date);
	}
	$opnConfig['opndate']->opnDataTosql ($Date);

	/***** Header */

	$day = '';
	$opnConfig['opndate']->getDay ($day);
	$month = '';
	$opnConfig['opndate']->getMonth ($month);
	$year = '';
	$opnConfig['opndate']->getYear ($year);
	$Prev_Year = ($year-1) . '-' . $month . '-' . $day;
	$Next_Year = ($year+1) . '-' . $month . '-' . $day;
	$opnConfig['opndate']->setDate ($Prev_Year);
	$Prev_Date = '';
	$opnConfig['opndate']->formatTimestamp ($Prev_Date, '%Y-%m-%d');
	$opnConfig['opndate']->setDate ($Next_Year);
	$Next_Date = '';
	$opnConfig['opndate']->formatTimestamp ($Next_Date, '%Y-%m-%d');
	$opnConfig['opndate']->sqlToopnData ($Date);
	$printit = '';
	get_var ('printit', $printit, 'both', _OOBJ_DTYPE_CLEAN);
	if ($printit == '') {
		$Previous_Year_Button = '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
											'Date' => $Prev_Date,
											'type' => 'year') ) . '">&lt;&lt;&lt; ' . _CALENDAR_CALPREVIOUS . '</a>';
		$Next_Year_Button = '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
											'Date' => $Next_Date,
											'type' => 'year') ) . '">' . _CALENDAR_CALNEXT . ' &gt;&gt;&gt;</a>';
	} else {
		$Previous_Year_Button = '';
		$Next_Year_Button = '';
	}
	$start = $year . '-01-01';
	$end = $year . '-12-31';
	$opnConfig['opndate']->setTimestamp ($start);
	$opnConfig['opndate']->opnDataTosql ($start);
	$opnConfig['opndate']->setTimestamp ($end);
	$opnConfig['opndate']->opnDataTosql ($end);
	$opnConfig['opndate']->sqlToopnData ($Date);
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$sql = 'SELECT eventdate,enddate FROM ' . $opnTables['calendar_events'] . ' WHERE (' . $opnConfig['opnSQL']->CreateBetween ('eventdate', $start, $end) . ' OR ' . $opnConfig['opnSQL']->CreateBetween ('enddate', $start, $end) . ')' . ' AND (user_group IN (' . $checkerlist . '))' . 'ORDER BY eventdate';
	$result = $opnConfig['database']->Execute ($sql);
	$events = array ();
	while (! $result->EOF) {
		$eventdate = $result->fields['eventdate'];
		$enddate = $result->fields['enddate'];
		for ($xx = $eventdate; $xx<= $enddate; $xx++) {
			$opnConfig['opndate']->sqlToopnData ($xx);
			$day1 = '';
			$opnConfig['opndate']->formatTimestamp ($day1, '%j');
			if (!isset ($events[$day1]) ) {
				$events[$day1] = true;
			}
		}
		$result->MoveNext ();
	}
	$opnConfig['opndate']->sqlToopnData ($Date);
	$table = & new opn_TableClass ();
	$table->AddDataRow (array ($Previous_Year_Button, $year, $Next_Year_Button), array ('left', 'center', 'right') );
	$table->GetTable ($cabytxt);
	$cabytxt .= '<table  border="0" cellpadding="6" width="100%"><tr>';
	$Day_of_First_Week = '';
	$Date1 = '';
	for ($i = 1; $i<13; $i++) {

		/**** Get the Day (Integer) for the first day in the month */

		$opnConfig['opndate']->setDate ($year . '-' . sprintf ('%02d', $i) . '-01');
		$opnConfig['opndate']->GetFirstDayinMonth ();
		$opnConfig['opndate']->opnDataTosql ($Date1);
		$opnConfig['opndate']->formatTimestamp ($Day_of_First_Week, '%w');
		if (!isset ($opnConfig['opn_start_day']) ) {
			$opnConfig['opn_start_day'] = 1;
		}
		if ($opnConfig['opn_start_day']) {
			if ($Day_of_First_Week == 0) {
				$Day_of_First_Week = 6;
			} else {
				$Day_of_First_Week--;
			}
		}

		/**** Find the last day of the month */

		$Last_Day = 0;
		$opnConfig['opndate']->daysInMonth ($Last_Day, $i, $year);
		$opnConfig['opndate']->now ();

		/**** Get todays date */

		$Today_d = '';
		$opnConfig['opndate']->getDay ($Today_d);
		$Today_m = '';
		$opnConfig['opndate']->getMonth ($Today_m);
		$Today_y = '';
		$opnConfig['opndate']->getYear ($Today_y);
		$opnConfig['opndate']->sqlToopnData ($Date1);

		/**** Build Month */
		if ( ($i == 4) || ($i == 7) || ($i == 10) ) {
			$cabytxt .= '</tr><tr><td colspan="3"><br /></td></tr><tr>';
		}
		$cabytxt .= '<td valign="top" align="center">';
		$cabytxt .= '<table  border="' . $opnConfig['calendar_yeartableborder'] . '" cellspacing="' . $opnConfig['calendar_yeartablecellspacing'] . '" cellpadding="' . $opnConfig['calendar_yeartablecellpadding'] . '">';
		$cabytxt .= '<tr bgcolor="' . $opnConfig['calendar_trimbgcolor'] . '"><th colspan="7"><font size="1" color="' . $opnConfig['calendar_trimtextcolor'] . '">' . '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.',
																												'Date' => $year . '-' . sprintf ('%02d',
																												$i) . '-01',
																												'type' => 'month') ) . '">';
		$cabytxt .= getMonthName ();
		$cabytxt .= '</a></font></th></tr>' . _OPN_HTML_NL;

		/**** Previous Greyed month days */

		$cabytxt .= '<tr>';
		$greyed = FALSE;
		if ($Day_of_First_Week != 0) {
			$cabytxt .= '<td colspan="' . $Day_of_First_Week . '"><span class="normaltext">&nbsp;</span></td>' . _OPN_HTML_NL;
			$greyed = TRUE;
		}
		$day_of_week = $Day_of_First_Week+1;

		/**** Build Current Month */

		for ($day = 1; $day<= $Last_Day; $day++) {
			if ($day_of_week == 1) {
				if ( ($greyed == TRUE) ) {
					$cabytxt .= '<tr>';
				}
				$switched = FALSE;
			}
			$greyed = TRUE;
			$opnConfig['opndate']->getYear ($year);
			$opnConfig['opndate']->getMonth ($month);
			if ( ($day == $Today_d) && ($month == $Today_m) && ($year == $Today_y) ) {
				$cabytxt .= '<td width="10" align="center" bgcolor="' . $opnConfig['calendar_selecteddaycolor'] . '">' . '<font color="' . $opnConfig['calendar_yeartextcolor'] . '" size="1">' . '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
																																'Date' . $year . '-' . $month . '-' . sprintf ('%02d',
																																$day),
																																'type' => 'day') ) . '">' . $day . '</a></font></td>';
			} else {
				$hlp = '';
				$opnConfig['opndate']->opnDataTosql ($hlp);
				$opnConfig['opndate']->setDate ($year . '-' . $month . '-' . sprintf ('%02d', $day) );
				$day1 = '';
				$opnConfig['opndate']->formatTimestamp ($day1, '%j');
				if (!isset ($events[$day1]) ) {
					$bgcolor = $opnConfig['calendar_yearbgcolor'];
				} else {
					$bgcolor = $opnConfig['calendar_daytextcolor'];
				}
				$opnConfig['opndate']->sqlToopnData ($hlp);
				$cabytxt .= '<td width="10" align="center" bgcolor="' . $bgcolor . '">' . '<font color="' . $opnConfig['calendar_yeartextcolor'] . '" size="1">' . '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
																													'Date' => $year . '-' . $month . '-' . sprintf ('%02d',
																													$day),
																													'type' => 'day') ) . '">' . $day . '</a></font></td>';
			}
			if ($day_of_week == 7) {
				$day_of_week = 0;
				$cabytxt .= '</tr>' . _OPN_HTML_NL;
				$switched = TRUE;
			}
			$day_of_week += 1;
		}

		/**** Next Greyed month days */

		$day = 1;
		if ($day_of_week != 1) {
			$tmp = 8- $day_of_week;
			$cabytxt .= '<td colspan="' . $tmp . '"><font size="1"></font></td>';
			$switched = FALSE;
		}
		if ($switched == FALSE) {
			$cabytxt .= '</tr></table></td>' . _OPN_HTML_NL;
		} else {
			$cabytxt .= '</table></td>' . _OPN_HTML_NL;
		}
	}
	$cabytxt .= '</tr></table>' . _OPN_HTML_NL;
	return $cabytxt;

}

function addTimeRange ($startTime, $endTime, $year, $month, $day) {

	global $opnConfig, $opnTables;

	$t = '';
	$opnConfig['opndate']->opnDataTosql ($t);
	$opnConfig['opndate']->sqlToopnData ($startTime);
	$tmpTime = '';
	$opnConfig['opndate']->formatTimestamp ($tmpTime, '%H:%M');
	$opnConfig['opndate']->sqlToopnData ($endTime);
	$tmpTime2 = '';
	$opnConfig['opndate']->formatTimestamp ($tmpTime2, '%H:%M');
	$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . $day);
	$cabytxt = '<br /><br /><span class="normaltextbold">' . $tmpTime . ' - ' . $tmpTime2 . '</span>';
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$sql = 'SELECT eid, eventdate, title, starttime, endtime, barcolor FROM ' . $opnTables['calendar_events'] . ' WHERE ' . ' (user_group IN (' . $checkerlist . ')) AND ' . "(eventdate<=$t AND enddate >=" . "$t AND alldayevent=0 AND starttime >= $startTime AND starttime <" . "$endTime) ORDER BY starttime, endtime ASC;";
	$cabytxt .= printAppt ($sql);
	return $cabytxt;

}

function buildDay ($Date) {

	global $opnConfig, $opnTables;

	$cabytxt = '';
	$Prev_Date = '';
	$opnConfig['opndate']->prevDay ($Prev_Date, $Date);
	$Next_Date = '';
	$opnConfig['opndate']->nextDay ($Next_Date, $Date);
	if ($Date == '') {
		$opnConfig['opndate']->now ();
	} else {
		$opnConfig['opndate']->setTimestamp ($Date);
	}
	$opnConfig['opndate']->opnDataTosql ($Date);

	/**** Header */

	$day = '';
	$opnConfig['opndate']->getDay ($day);
	$month = '';
	$opnConfig['opndate']->getMonth ($month);
	$year = '';
	$opnConfig['opndate']->getYear ($year);
	$opnConfig['opndate']->sqlToopnData ($Date);
	$printit = '';
	get_var ('printit', $printit, 'both', _OOBJ_DTYPE_CLEAN);
	if ($printit == '') {
		$Previous_Day_Button = '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
											'Date' => $Prev_Date,
											'type' => 'day') ) . '">&lt;&lt;&lt; ' . _CALENDAR_CALPREVIOUS . '</a>';
		$Next_Day_Button = '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
											'Date' => $Next_Date,
											'type' => 'day') ) . '">' . _CALENDAR_CALNEXT . ' &gt;&gt;&gt;</a>';
	} else {
		$Previous_Day_Button = '';
		$Next_Day_Button = '';
	}
	if ($opnConfig['calendar_useInternationalDates'] == 0) {
		$temp = '';
		$opnConfig['opndate']->formatTimestamp ($temp, '%d, %Y');
		$Month_Name_and_Year = getLongDayName () . ', ' . getMonthName () . ' ' . $temp;
	} else {
		$temp = '';
		$opnConfig['opndate']->formatTimestamp ($temp, '%d. ');
		$temp2 = '';
		$opnConfig['opndate']->formatTimestamp ($temp2, '%Y');
		$Month_Name_and_Year = getLongDayName () . ', ' . $temp . getMonthName () . ' ' . $temp2;
	}
	$table = & new opn_TableClass ();
	$table->AddDataRow (array ($Previous_Day_Button, $Month_Name_and_Year, $Next_Day_Button), array ('left', 'center', 'right') );
	$table->GetTable ($cabytxt);
	$cabytxt .= '<div class="centertag"><table  border="0" cellspacing="5" cellpadding="6" width="100%"><tr>' . _OPN_HTML_NL;

	/**** Appointments */

	$cabytxt .= '<td class="alternator1" width="50%" valign="top">';
	$cabytxt .= '<table  width="100%" class="alternator4" border="1" cellspacing="0"><tr><td align="center">' . _CALENDAR_CALAPPOINTMENTS . '</td></tr></table><br />';
	$cabytxt .= _CALENDAR_CALMORNING;
	$opnConfig['opndate']->setTimestamp ($opnConfig['calendar_times'][0]);
	$caltimes = '';
	$opnConfig['opndate']->opnDataTosql ($caltimes);
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$sql = 'SELECT eid, eventdate, title, starttime, endtime, barcolor FROM ' . $opnTables['calendar_events'] . ' WHERE ' . ' (user_group IN (' . $checkerlist . ')) AND ' . "(eventdate<=$Date AND enddate >=" . "$Date AND alldayevent=0 AND starttime < $caltimes) ORDER BY starttime, endtime ASC";
	$cabytxt .= printAppt ($sql);
	$i = 0;
	$caltimes = '';
	$caltimes1 = '';
	while ($opnConfig['calendar_times'][$i]) {
		$day = '';
		$opnConfig['opndate']->getDay ($day);
		//$mon='';
		// $opnConfig['opndate']->getMonth($mon);
		$year = '';
		$opnConfig['opndate']->getYear ($year);
		$opnConfig['opndate']->setTimestamp ($opnConfig['calendar_times'][$i]);
		$opnConfig['opndate']->opnDataTosql ($caltimes);
		$opnConfig['opndate']->setTimestamp ($opnConfig['calendar_times'][$i+1]);
		$opnConfig['opndate']->opnDataTosql ($caltimes1);
		$opnConfig['opndate']->sqlToopnData ($Date);
		$cabytxt .= addTimeRange ($caltimes, $caltimes1, $year, $month, $day);
		// echo $opnConfig['calendar_times'][$i].'<br />';
		$i++;
		if ( (! (isset ($opnConfig['calendar_times'][$i+1]) ) ) OR (! ($opnConfig['calendar_times'][$i+1]) ) ) {
			break;
		}
	}
	$opnConfig['opndate']->setTimestamp ($opnConfig['calendar_times'][$i]);
	$opnConfig['opndate']->opnDataTosql ($caltimes);
	$cabytxt .= '<br /><br />' . _CALENDAR_CALEVENING;
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$sql = 'SELECT eid, eventdate, title, starttime, endtime, barcolor FROM ' . $opnTables['calendar_events'] . " WHERE (user_group IN (" . $checkerlist . ")) AND (eventdate<=$Date AND enddate >= $Date AND alldayevent=0 AND starttime >= $caltimes) ORDER BY starttime, endtime ASC;";
	$cabytxt .= printAppt ($sql);
	$cabytxt .= '</td>' . _OPN_HTML_NL;

	/**** Events */

	$cabytxt .= '<td class="alternator1" width="50%" valign="top">';
	$cabytxt .= '<table  width="100%" class="alternator4" border="1" cellspacing="0"><tr><td align="center">' . _CALENDAR_CALEVENTS . '</td></tr></table><br />';
	$cabdresult = &$opnConfig['database']->Execute ("SELECT eid,eventdate,title,barcolor FROM " . $opnTables['calendar_events'] . " WHERE (user_group IN (" . $checkerlist . ")) AND (eventdate <= $Date AND enddate >= $Date AND alldayevent=1) ORDER BY title ASC");
	if ($opnConfig['calendar_eventsopeninnewwindow']) {
		$frame = ' target="_blank"';
	} else {
		$frame = '';
	}
	while (! $cabdresult->EOF) {
		$eid = $cabdresult->fields['eid'];
		$eventdate = $cabdresult->fields['eventdate'];
		$opnConfig['opndate']->sqlToopnData ($eventdate);
		$Today_d = '';
		$opnConfig['opndate']->formatTimestamp ($Today_d, '%d');
		$Today_m = '';
		$opnConfig['opndate']->formatTimestamp ($Today_m, '%m');
		$Today_y = '';
		$opnConfig['opndate']->formatTimestamp ($Today_y, '%Y');
		$title = $cabdresult->fields['title'];
		$barcolor = $cabdresult->fields['barcolor'];
		if ($barcolor == 'r') {
			$barcolorchar = 'r';
		} elseif ($barcolor == 'g') {
			$barcolorchar = 'g';
		} elseif ($barcolor == 'b') {
			$barcolorchar = 'b';
		} elseif ($barcolor == 'y') {
			$barcolorchar = 'y';
		} else {
			$barcolorchar = 'w';
		}
		$cabytxt .= '<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ball' . $barcolorchar . '.gif" class="imgtag" alt="" />&nbsp;<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
																							'type' => 'view',
																							'eid' => $eid,
																							'Date' => $Today_y . '-' . sprintf ('%02d-%02d',
																							$Today_m,
																							$Today_d) ) ) . '"' . $frame . '>' . $title . '</a><br />';
		$cabdresult->MoveNext ();
	}
	$cabytxt .= '</td></tr>';
	$cabytxt .= '</table></div>';
	return $cabytxt;

}

function buildMonth ($Date) {

	global $opnConfig, $opnTables;

	$cabytxt = '';
	if ($Date == '') {
		$opnConfig['opndate']->now ();
	} else {
		$opnConfig['opndate']->setTimestamp ($Date);
	}
	$opnConfig['opndate']->opnDataTosql ($Date);
	$cabytxt .= loadPopups ();
	// $day='';
	// $opnConfig['opndate']->getDay($day);
	$month = '';
	$opnConfig['opndate']->getMonth ($month);
	$year = '';
	$opnConfig['opndate']->getYear ($year);

	/**** Header */
	if ($month == 1) {
		$pmo = 12;
		$pye = $year-1;
		$nmo = 2;
		$nye = $year;
	} elseif ($month == 12) {
		$pmo = 11;
		$pye = $year;
		$nmo = 1;
		$nye = $year+1;
	} else {
		$pmo = $month-1;
		$pye = $year;
		$nmo = $month+1;
		$nye = $year;
	}
	$Prev_Month = $pye . '-' . sprintf ('%02d', ($pmo) ) . '-01';
	$Next_Month = $nye . '-' . sprintf ('%02d', ($nmo) ) . '-01';
	$opnConfig['opndate']->setDate ($Prev_Month);
	$Prev_Date = '';
	$opnConfig['opndate']->formatTimestamp ($Prev_Date, '%Y-%m-%d');
	$opnConfig['opndate']->setDate ($Next_Month);
	$Next_Date = '';
	$opnConfig['opndate']->formatTimestamp ($Next_Date, '%Y-%m-%d');
	$opnConfig['opndate']->sqlToopnData ($Date);
	$printit = '';
	get_var ('printit', $printit, 'both', _OOBJ_DTYPE_CLEAN);
	if ($printit == '') {
		$Previous_Month_Button = '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
											'Date' => $Prev_Date,
											'type' => 'month') ) . '">&lt;&lt;&lt; ' . _CALENDAR_CALPREVIOUS . '</a>';
		$Next_Month_Button = '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
											'Date' => $Next_Date,
											'type' => 'month') ) . '">' . _CALENDAR_CALNEXT . ' &gt;&gt;&gt;</a>';
	} else {
		$Previous_Month_Button = '';
		$Next_Month_Button = '';
	}
	$temp = '';
	$opnConfig['opndate']->formatTimestamp ($temp, '%Y');
	$Month_Name_and_Year = getMonthName () . ' ' . $temp;
	$table = & new opn_TableClass ();
	$table->AddDataRow (array ($Previous_Month_Button, $Month_Name_and_Year, $Next_Month_Button), array ('left', 'center', 'right') );
	$table->GetTable ($cabytxt);

	/**** Get the Day (Integer) for the first day in the month */

	$opnConfig['opndate']->GetFirstDayinMonth ();
	$Date1='';
	// $opnConfig['opndate']->opnDataTosql($Date1);
	$Day_of_First_Week = '';
	$opnConfig['opndate']->formatTimestamp ($Day_of_First_Week, '%w');
	if (!isset ($opnConfig['opn_start_day']) ) {
		$opnConfig['opn_start_day'] = 1;
	}
	if ($opnConfig['opn_start_day']) {
		if ($Day_of_First_Week == 0) {
			$Day_of_First_Week = 6;
		} else {
			$Day_of_First_Week--;
		}
	}

	/**** Find the last day of the month */

	$Last_Day = 0;
	$opnConfig['opndate']->daysInMonth ($Last_Day, $month, $year);
	$opnConfig['opndate']->now ();

	/**** Get todays date */

	$Today_d = '';
	$opnConfig['opndate']->getDay ($Today_d);
	$Today_m = '';
	$opnConfig['opndate']->getMonth ($Today_m);
	$Today_y = '';
	$opnConfig['opndate']->getYear ($Today_y);

	/**** Set up data */

	$count = -1;
	$opnConfig['opndate']->sqlToopnData ($Date);

	/*	$day='';
	$opnConfig['opndate']->getDay($day);
	$mon='';
	$opnConfig['opndate']->getMonth($mon);
	$year='';
	$opnConfig['opndate']->getYear($year);*/

	$start = $year . '-' . $month . '-01';
	$end = $year . '-' . $month . '-' . $Last_Day;
	$opnConfig['opndate']->setTimestamp ($start);
	$opnConfig['opndate']->opnDataTosql ($start);
	$opnConfig['opndate']->setTimestamp ($end);
	$opnConfig['opndate']->opnDataTosql ($end);
	$opnConfig['opndate']->sqlToopnData ($Date);
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$sql = 'SELECT eid,title,hometext,eventdate,enddate,barcolor FROM ' . $opnTables['calendar_events'] . ' WHERE ((' . $opnConfig['opnSQL']->CreateBetween ('eventdate', $start, $end) . ' OR ' . $opnConfig['opnSQL']->CreateBetween ('enddate', $start, $end) . ' OR (enddate >= ' . $end . ' AND eventdate <= ' . $start . '))' . ' AND alldayevent=1)' . ' AND (user_group IN (' . $checkerlist . '))' . 'ORDER BY eventdate ASC';
	$result = $opnConfig['database']->Execute ($sql);
	while (! $result->EOF) {
		$eid = $result->fields['eid'];
		$title = $result->fields['title'];
		$description = $result->fields['hometext'];
		$eventDate = $result->fields['eventdate'];
		$endDate = $result->fields['enddate'];
		$barcolor = $result->fields['barcolor'];
		$eid_Array[] = $eid;
		$title_Array[] = $title;
		$eventDate_Array[] = $eventDate;
		$endDate_Array[] = $endDate;
		$barcolor_Array[] = $barcolor;
		$desc_Array[] = valueToText ($description);
		$count++;
		$result->MoveNext ();
	}
	$result->Close ();

	/**** Build Month */

	$cabytxt .= '<div class="centertag"><table  class="alternatorhead" border="' . $opnConfig['calendar_monthtableborder'] . '" cellspacing="' . $opnConfig['calendar_monthtablecellspacing'] . '" cellpadding="' . $opnConfig['calendar_monthtablecellpadding'] . '" width="100%">';
	$day_of_week = 1;
	$cabytxt .= '<tr class="alternator2">' . _OPN_HTML_NL;
	for ($wday = 0; $wday<7; $wday++) {
		$cabytxt .= '<th width="15%">';
		$opnConfig['opndate']->getWeekdayAbbrnameodspecial ($cabytxt, $wday);
		$cabytxt .= '</th>';
	}
	$cabytxt .= '</tr>' . _OPN_HTML_NL;

	/**** Previous Greyed month days */

	while ($day_of_week< ($Day_of_First_Week+1) ) {
		if ($day_of_week == 1) {
			$cabytxt .= '<tr class="alternator2">' . _OPN_HTML_NL;
		}
		$Tmp_Date = mktime ('', '', '', $month, 1- ( ($Day_of_First_Week+1)- $day_of_week), $year);
		$Tmp_Day = Date ('d', $Tmp_Date);
		$cabytxt .= '<td class="alternator1" height="70" valign="top" align="center"><table><tr class="alternator1"><td>' . $Tmp_Day . '</td></tr></table></td>';
		$day_of_week += 1;
	}
	$usedcount = 0;
	$cellcount = 0;
	$cellDate = '';
	$t = '';
	$t1 = '';
	$cellArrayTitle = array ();
	$cellArrayEventDate = array ();
	$cellArrayEndDate = array ();
	$cellArrayBarColor = array ();
	$cellArrayDesc = array ();

	/*	$opnConfig['opndate']->getMonth($month);
	$opnConfig['opndate']->getYear($year);*/

	/**** Build Current Month */

	for ($day = 1; $day<= $Last_Day; $day++) {
		if ($day_of_week == 1) {
			$cabytxt .= '<tr class="alternator2">' . _OPN_HTML_NL;
			$switched = FALSE;
		}
		if ( ($day == $Today_d) && ($month == $Today_m) && ($year == $Today_y) ) {
			$cabytxt .= '<td height="70" valign="top"><table  width="100%" cellpadding="0" cellspacing="0" ' . 'class="alternator2bg" border="0"><tr><td align="center">' . '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
																													'Date' => $year . '-' . $month . '-' . sprintf ('%02d',
																													$day),
																													'type' => 'day') ) . '">' . $day . '</a></td></tr></table>';
		} else {
			$cabytxt .= '<td height="70" valign="top"><table  width="100%" cellpadding="0" cellspacing="0" border="0"><tr class="alternator2">' . '<td align="center">' . '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
																													'Date' => $year . '-' . $month . '-' . sprintf ('%02d',
																													$day),
																													'type' => 'day') ) . '">' . $day . '</a></td></tr></table>';
		}

		/************************/

		/**** SET UP DATA!!! ****/

		/************************/

		/**** Reset Cell Array */

		$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . sprintf ('%02d', $day) );
		$opnConfig['opndate']->opnDataTosql ($cellDate);
		$opnConfig['opndate']->sqlToopnData ($Date);
		for ($i = 0; $i<= $cellcount-1; $i++) {
			if ($cellArrayEndDate[$i]<$cellDate) {
				$cellArray[$i] = FALSE;
			}
		}

		/**** Clean out Cell Array */
		if ($cellcount != 0) {
			$j = $cellcount;
			for ($i = $cellcount-1; $i >= 0; $i--) {
				if ($cellArray[$i] == FALSE) {
					array_pop ($cellArray);
					array_pop ($cellArrayTitle);
					array_pop ($cellArrayEventDate);
					array_pop ($cellArrayEndDate);
					array_pop ($cellArrayBarColor);
					array_pop ($cellArrayDesc);
					$j--;
				} else {
					break;
				}
			}
			$cellcount = $j;
		}

		/**** Add neccessary additions to cellArray */
		if ( (isset ($eventDate_Array[$usedcount]) ) && (is_array ($eventDate_Array) ) ) {
			$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . sprintf ('%02d', $day) );
			$opnConfig['opndate']->opnDataTosql ($t1);
			$opnConfig['opndate']->sqlToopnData ($Date);
			while ( (isset ($eventDate_Array[$usedcount]) ) && ( ($eventDate_Array[$usedcount]<= $t1) && ($usedcount<= ($count) ) ) ) {
				$added = FALSE;

				/**** First Try to find a spot in the cell for the event */

				for ($i = 0; $i<= $cellcount-1; $i++) {
					if ($cellArray[$i] == FALSE) {

						/**** Found spot in cellArray */

						$cellArray[$i] = $eid_Array[$usedcount];
						$cellArrayTitle[$i] = $title_Array[$usedcount];
						$cellArrayEventDate[$i] = $eventDate_Array[$usedcount];
						$cellArrayEndDate[$i] = $endDate_Array[$usedcount];
						$cellArrayBarColor[$i] = $barcolor_Array[$usedcount];
						$cellArrayDesc[$i] = $desc_Array[$usedcount];
						$added = TRUE;
						break 1;
					}
				}

				/**** If all spots are taken in the current cellArray then add it to the end */
				if ($added == FALSE) {
					$cellArray[] = $eid_Array[$usedcount];
					$cellArrayTitle[] = $title_Array[$usedcount];
					$cellArrayEventDate[] = $eventDate_Array[$usedcount];
					$cellArrayEndDate[] = $endDate_Array[$usedcount];
					$cellArrayBarColor[] = $barcolor_Array[$usedcount];
					$cellArrayDesc[] = $desc_Array[$usedcount];
					$cellcount++;

					/**** Increase cell count since added to the end of the array */
				}
				$usedcount++;
			}
		}

		/**************************************/

		/**** INSERT DATA INTO CALENDAR!!! ****/

		/**************************************/
		if ($opnConfig['calendar_eventsopeninnewwindow'] == 1) {
			$frame = ' target="_blank"';
		} else {
			$frame = '';
		}
		for ($i = 0; $i<= $cellcount-1; $i++) {
			$cabytxt .= '<table  width="100%" cellpadding="0" cellspacing="0" border="0"><tr>' . _OPN_HTML_NL;
			$switched = FALSE;
			if ($cellArrayBarColor[$i] == 'r') {
				$barcolorchar = 'r';
			} elseif ($cellArrayBarColor[$i] == 'g') {
				$barcolorchar = 'g';
			} elseif ($cellArrayBarColor[$i] == 'b') {
				$barcolorchar = 'b';
			} elseif ($cellArrayBarColor[$i] == 'y') {
				$barcolorchar = 'y';
			} else {
				$barcolorchar = 'w';
			}
			$thisday = $cellArrayEventDate[$i];
			$opnConfig['opndate']->sqlToopnData ($thisday);
			$UToday_d = '';
			$opnConfig['opndate']->formatTimestamp ($UToday_d, '%d');
			$UToday_m = '';
			$opnConfig['opndate']->formatTimestamp ($UToday_m, '%m');
			$UToday_y = '';
			$opnConfig['opndate']->formatTimestamp ($UToday_y, '%Y');
			if ($cellArray[$i] != FALSE) {
				if ($opnConfig['calendar_textEvents']) {
					$cabytxt .= '<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ball' . $barcolorchar . '.gif" class="imgtag" alt="" /> <a class="normaltext" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/calendar/index.php?', true, true, array ('type' => 'view',
																																				'eid' => $cellArray[$i],
																																				'Date' => $UToday_y . '-' . sprintf ('%02d-%02d',
																																				$UToday_m,
																																				$UToday_d) ) ) . '"' . $frame . '>' . $cellArrayTitle[$i] . '</a><br />';
				} else {
					$url1 = array ();
					$url2 = array ();
					$url1[0] = $opnConfig['opn_url'] . '/modules/calendar/index.php';
					$url2[0] = $opnConfig['opn_url'] . '/modules/calendar/index.php';
					$url1['type'] = 'view';
					$url1['eid'] = $cellArray[$i];
					$url2['type'] = 'view';
					$url2['eid'] = $cellArray[$i];
					$url1['Date'] = $UToday_y . '-' . sprintf ('%02d-%02d', $UToday_m, $UToday_d);
					$popuptext = ' onmouseover="pop(\'' . $cellArrayTitle[$i] . '\',\'' . $cellArrayDesc[$i] . '\',popbord,popback)" onmouseout=\'kill()\'';
					if ( ($cellDate == $cellArrayEndDate[$i]) && ($cellArrayEndDate[$i] == $cellArrayEventDate[$i]) ) {
						$cabytxt .= '<td><a class="normaltext" href="' . encodeurl ($url1) . '"' . $frame . ' ' . $popuptext . '><img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/leftbar' . $barcolorchar . '.gif" class="imgtag" alt="" /></a></td>' . '<td align="right" width="100%" background="' . $opnConfig['opn_url'] . '/modules/calendar/images/mainbar' . $barcolorchar . '.gif"><a href="' . encodeurl ($url2) . '"' . $frame . ' ' . $popuptext . '><img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/mainbar2' . $barcolorchar . '.gif" class="imgtag" alt="" /></a></td>' . '<td align="right"><a class="normaltext" href="' . encodeurl ($url2) . '"' . $frame . ' ' . $popuptext . '><img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/rightbarcap' . $barcolorchar . '.gif" class="imgtag" alt="" /></a></td>';
					} elseif ($cellDate == $cellArrayEventDate[$i]) {
						$cabytxt .= '<td><a class="normaltext" href="' . encodeurl ($url1) . '"' . $frame . ' ' . $popuptext . '><img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/leftbar' . $barcolorchar . '.gif" class="imgtag" alt="" /></a></td>' . '<td align="center" width="100%" background="' . $opnConfig['opn_url'] . '/modules/calendar/images/mainbar' . $barcolorchar . '.gif"><a href="' . encodeurl ($url2) . '"' . $frame . ' ' . $popuptext . '><img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/mainbar2' . $barcolorchar . '.gif" class="imgtag" alt="" /></a></td>';
					} elseif ($cellDate == $cellArrayEndDate[$i]) {
						$cabytxt .= '<td align="center" width="100%" background="' . $opnConfig['opn_url'] . '/modules/calendar/images/mainbar' . $barcolorchar . '.gif"><a href="' . encodeurl ($url2) . '"' . $frame . ' ' . $popuptext . '><img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/mainbar2' . $barcolorchar . '.gif" class="imgtag" alt="" /></a></td>' . '<td><a class="normaltext" href="' . encodeurl ($url1) . '"' . $frame . ' ' . $popuptext . '><img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/rightbar' . $barcolorchar . '.gif" class="imgtag" alt="" /></a></td>';
					} else {
						if ($day == 1) {
							$cabytxt .= '<td><a class="normaltext" href="' . encodeurl ($url2) . '"' . $frame . ' ' . $popuptext . '><img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/leftbar2' . $barcolorchar . '.gif" class="imgtag" alt="" /></a></td>' . '<td align="center" width="99%" background="' . $opnConfig['opn_url'] . '/modules/calendar/images/mainbar' . $barcolorchar . '.gif"><a href="' . encodeurl ($url2) . '"' . $frame . ' ' . $popuptext . '><img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/mainbar2' . $barcolorchar . '.gif" class="imgtag" alt="" /></a></td>';
						} else {
							$cabytxt .= '<td align="center" background="' . $opnConfig['opn_url'] . '/modules/calendar/images/mainbar' . $barcolorchar . '.gif"><a class="normaltext" href="' . encodeurl ($url1) . '"' . $frame . ' ' . $popuptext . '><img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/mainbar' . $barcolorchar . '.gif" class="imgtag" alt="" /></a></td>';
						}
					}
				}
			} else {
				if (!$opnConfig['calendar_textEvents']) {
					$cabytxt .= '<td width="100%"><img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/blankbar.gif" alt="" />&nbsp;</td>';
				}
			}
			$cabytxt .= '</tr></table>';
		}
		$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . sprintf ('%02d', $day) );
		$opnConfig['opndate']->opnDataTosql ($t);
		$opnConfig['opndate']->sqlToopnData ($Date);
		$checkerlist = $opnConfig['permission']->GetUserGroups ();
		$resultAPPT = &$opnConfig['database']->Execute ("SELECT eid,title,eventdate,enddate,starttime,endtime,barcolor FROM " . $opnTables['calendar_events'] . " WHERE (user_group IN (" . $checkerlist . ")) AND (eventdate <= $t AND enddate >= $t AND alldayevent=0) ORDER BY starttime, endtime ASC");
		while (! $resultAPPT->EOF) {
			$eid = $resultAPPT->fields['eid'];
			$title = $resultAPPT->fields['title'];
			$eventDate = $resultAPPT->fields['eventdate'];
			$opnConfig['opndate']->sqlToopnData ($eventDate);
			$UToday_d = '';
			$opnConfig['opndate']->formatTimestamp ($UToday_d, '%d');
			$UToday_m = '';
			$opnConfig['opndate']->formatTimestamp ($UToday_m, '%m');
			$UToday_y = '';
			$opnConfig['opndate']->formatTimestamp ($UToday_y, '%Y');
			$endDate = $resultAPPT->fields['enddate'];
			$startTime = $resultAPPT->fields['starttime'];
			$endTime = $resultAPPT->fields['endtime'];
			$barcolor = $resultAPPT->fields['barcolor'];
			if ($barcolor == 'r') {
				$barcolorchar = 'r';
			} elseif ($barcolor == 'g') {
				$barcolorchar = 'g';
			} elseif ($barcolor == 'b') {
				$barcolorchar = 'b';
			} elseif ($barcolor == 'y') {
				$barcolorchar = 'y';
			} else {
				$barcolorchar = 'w';
			}
			$opnConfig['opndate']->sqlToopnData ($startTime);
			$opnConfig['opndate']->formatTimestamp ($startTime, '%H:%M');
			$opnConfig['opndate']->sqlToopnData ($endTime);
			$opnConfig['opndate']->formatTimestamp ($endTime, '%H:%M');
			$opnConfig['opndate']->sqlToopnData ($Date);
			$cabytxt .= '<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ball' . $barcolorchar . '.gif" class="imgtag" alt="" /> <a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
																							'type' => 'view',
																							'eid' => $eid,
																							'Date' => $UToday_y . '-' . sprintf ('%02d-%02d',
																							$UToday_m,
																							$UToday_d) ) ) . '"' . $frame . '>' . $startTime . ' - ' . $endTime . '<br /> ' . $title . '</a><br />';
			$resultAPPT->MoveNext ();
		}
		$resultAPPT->Close ();
		$cabytxt .= '</td>';
		if ($day_of_week == 7) {
			$day_of_week = 0;
			$cabytxt .= '</tr>' . _OPN_HTML_NL;
			$switched = TRUE;
		}
		$day_of_week += 1;
	}

	/**** Next Greyed month days */

	$day = 1;
	while ( ($day_of_week<=7) && ($day_of_week != 1) ) {
		$cabytxt .= '<td class="alternator1" height="70" valign="top" align="center"><table><tr class="alternator1"><td>' . $day . '</td></tr></table></td>';
		$day_of_week += 1;
		$day += 1;
	}
	if ($switched == TRUE) {
		$cabytxt .= '</table></div>' . _OPN_HTML_NL;
	} else {
		$cabytxt .= '</tr></table></div>' . _OPN_HTML_NL;
	}
	return $cabytxt;

}

function viewEvent ($eid) {

	global $opnConfig, $opnTables;

	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$result = &$opnConfig['database']->Execute ('SELECT eid, aid, title, wtime, hometext, comments, counter, topic, informant, eventdate, enddate, starttime, endtime, alldayevent FROM ' . $opnTables['calendar_events'] . " WHERE (user_group IN (" . $checkerlist . ")) AND eid=$eid");
	$eid = $result->fields['eid'];
	$aid = $result->fields['aid'];
	$title = $result->fields['title'];
	$datePosted = $result->fields['wtime'];
	$body = $result->fields['hometext'];
	$topic = $result->fields['topic'];
	$informant = $result->fields['informant'];
	$eventDate = $result->fields['eventdate'];
	$endDate = $result->fields['enddate'];
	$startTime = $result->fields['starttime'];
	$endTime = $result->fields['endtime'];
	$alldayevent = $result->fields['alldayevent'];
	opn_nl2br ($body);
	if ( ($topic != '') && ($topic != 0) ) {
		$_topic = $opnConfig['opnSQL']->qstr ($topic);
		$result = &$opnConfig['database']->Execute ('SELECT topicimage FROM ' . $opnTables['article_topics'] . " WHERE topicid=$_topic");
		if ($result !== false) {
			$topicimage = $result->fields['topicimage'];
		} else {
			$topicimage = 'AllTopics.gif';
		}
	} else {
		$topicimage = 'AllTopics.gif';
	}
	if ($topicimage == '') {
		$topicimage = 'AllTopics.gif';
	}
	$opnConfig['opndate']->sqlToopnData ($eventDate);
	$d1 = '';
	$opnConfig['opndate']->formatTimestamp ($d1, '%Y-%m-%d');
	$d2 = '';
	$opnConfig['opndate']->formatTimestamp ($d2, _DATE_DATESTRING4);
	$opnConfig['opndate']->sqlToopnData ($endDate);
	$e1 = '';
	$opnConfig['opndate']->formatTimestamp ($e1, '%Y-%m-%d');
	$e2 = '';
	$opnConfig['opndate']->formatTimestamp ($e2, _DATE_DATESTRING4);
	$opnConfig['opndate']->sqlToopnData ($datePosted);
	$d3 = '';
	$opnConfig['opndate']->formatTimestamp ($d3, _DATE_DATESTRING4);
	$opnConfig['opndate']->sqlToopnData ($startTime);
	$s1 = '';
	$opnConfig['opndate']->formatTimestamp ($s1, '%H:%M');
	$opnConfig['opndate']->sqlToopnData ($endTime);
	$ee1 = '';
	$opnConfig['opndate']->formatTimestamp ($ee1, '%H:%M');
	$cavetxt = '<div class="centertag"><span class="bigtextbold">' . _CALENDAR_CALVIEWEVENT . ': \'' . $title . '\'</span>';
	if ($opnConfig['permission']->HasRight ('modules/calendar', _PERM_ADMIN, true) ) {
		$cavetxt .= '<br />[ <a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/admin/index.php',
											'op' => 'CalendarEditStory',
											'eid' => $eid) ) . '">' . _CALENDAR_CALEDIT . '</a> |' . ' <a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/admin/index.php',
															'op' => 'CalendarRemoveStory',
															'eid' => $eid) ) . '">' . _CALENDAR_CALDELETE . '</a> ]' . _OPN_HTML_NL;
	}
	$cavetxt .= '<br /><br />';
	$cavetxt .= '<table  align="center"><tr><td><span class="normaltext">' . _CALENDAR_CALEVENTDATEPREVIEW . ': </span></td><td>';
	$cavetxt .= '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
									'type' => 'day',
									'Date' => $d1) ) . '">' . $d2 . '</a></td></tr>';
	if ($eventDate != $endDate) {
		$cavetxt .= '<tr><td><span class="normaltext">' . _CALENDAR_CALENDDATEPREVIEW . ': </span></td><td>';
		$cavetxt .= '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
										'type' => 'day',
										'Date' => $e1) ) . '">' . $e2 . '</a><br /></td></tr>';
	}
	$cavetxt .= '</table><table  width="90%" align="center">';
	if ($alldayevent == '0') {
		$cavetxt .= '<tr class="alternator2"><td width="90%" valign="top" colspan="2"><table><tr><td><span class="normaltextbold">' . _CALENDAR_CALSTARTTIME . ': </span></td><td><span class="normaltextbold">' . $s1 . '</span></td></tr>' . '<tr><td><span class="normaltextbold">' . _CALENDAR_CALENDTIME . ': </span></td><td><span class="normaltextbold">' . $ee1 . '</span></td></tr></table></td></tr>';
	}
	$mywhois = $opnConfig['permission']->GetUser ($aid, '', '');
	$cavetxt .= '<tr class="alternator1"><td width="90%" valign="top">';
	$cavetxt .= '<span class="normaltextbold">' . _CALENDAR_CALARTICLETEXT . ':</span><br /><br /><span class="normaltext">' . $body . '</span></td>' . '<td valign="top" align="right">';
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		$cavetxt .= '<img src="' . $opnConfig['datasave']['art_topic_path']['url'] . '/' . $topicimage . '" class="imgtag" alt="" />';
	}
	$cavetxt .= '</td></tr></table><br /><br /><span class="smalltext">' . _CALENDAR_CALPOSTEDBY . ' <a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
																			'op' => 'userinfo',
																			'uname' => $informant) ) . '">' . $informant . '</a> ' . _CALENDAR_CALPOSTEDON . ' ' . $d3 . '&nbsp;' . _CALENDAR_CALACCEPTEDBY . ' ' . $mywhois['uname'] . '</span>';
	$cavetxt .= '</div>';
	return $cavetxt;

}

function CalendarIndex () {

	global $opnConfig;

	$boxtxt = '';
	$Date = '';
	get_var ('Date', $Date, 'both', _OOBJ_DTYPE_CLEAN);
	$type = '';
	get_var ('type', $type, 'both', _OOBJ_DTYPE_CLEAN);
	$printit = '';
	get_var ('printit', $printit, 'both', _OOBJ_DTYPE_CLEAN);
	$eid = 0;
	get_var ('eid', $eid, 'both', _OOBJ_DTYPE_INT);
	$change = '';
	get_var ('change', $change, 'form', _OOBJ_DTYPE_CLEAN);
	if ($change != '') {
		$jumpyear = 0;
		get_var ('jumpyear', $jumpyear, 'form', _OOBJ_DTYPE_INT);
		$jumpmonth = 0;
		get_var ('jumpmonth', $jumpmonth, 'form', _OOBJ_DTYPE_INT);
		$jumpday = 0;
		get_var ('jumpday', $jumpday, 'form', _OOBJ_DTYPE_INT);
		$Date = $jumpyear . '-' . $jumpmonth . '-' . $jumpday;
	}
	$today = '';
	get_var ('today', $today, 'form', _OOBJ_DTYPE_CLEAN);
	$Date1 = '';
	if ($today != '') {
		$Date1 = '';
		get_var ('Date1', $Date1, 'form', _OOBJ_DTYPE_CLEAN);
		$Date = $Date1;
	}
	$boxtxt .= '<table  cellpadding="8" width="100%"><tr><td>';
	if ( ($type == 'month') || ! ($type) ) {
		$boxtxt .= buildMonth ($Date);
	} elseif ($type == 'day') {
		$boxtxt .= buildDay ($Date);
	} elseif ($type == 'year') {
		$boxtxt .= buildYear ($Date);
	} elseif ($type == 'view') {
		$boxtxt .= viewEvent ($eid);
		$type = 'day';
	}
	$boxtxt .= '</td></tr></table>';
	$boxtxt .= _CALENDAR_CALLEGENDE . '<br /><br />';
	$boxtxt .= '<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballr.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorred'] . '&nbsp;&nbsp;';
	$boxtxt .= '<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballg.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorgreen'] . '&nbsp;&nbsp;';
	$boxtxt .= '<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballb.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorblue'] . '&nbsp;&nbsp;';
	$boxtxt .= '<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballw.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorwhite'] . '&nbsp;&nbsp;';
	$boxtxt .= '<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/bally.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcoloryellow'];
	if ( ($printit == '') && (! ( ($opnConfig['calendar_eventsopeninnewwindow']) && ($type == 'view') ) ) ) {
		$boxtxt .= '<br /><br />';

		/**** Get todays date */

		$opnConfig['opndate']->now ();
		$Today_d = '';
		$opnConfig['opndate']->getDay ($Today_d);
		$Today_m = '';
		$opnConfig['opndate']->getMonth ($Today_m);
		$Today_y = '';
		$opnConfig['opndate']->getYear ($Today_y);
		$form = & new opn_FormularClass ('default');
		$form->Init ($opnConfig['opn_url'] . '/modules/calendar/index.php', 'post', 'jump');
		$form->AddTable ();
		$form->AddOpenRow ();
		$form->AddText ('<span class="normaltextbold">' . _CALENDAR_CALJUMPTOTEXT . ':</span>');
		$form->AddText ('&nbsp;');
		$form->AddChangeRow ();
		$form->SetSameCol ();
		if ($Date != '') {
			$opnConfig['opndate']->setTimestamp ($Date);
			$tag = '';
			$opnConfig['opndate']->getDay ($tag);
			$monat = '';
			$opnConfig['opndate']->getMonth ($monat);
			$jahr = '';
			$opnConfig['opndate']->getYear ($jahr);
		} else {
			$tag = $Today_d;
			$monat = $Today_m;
			$jahr = $Today_y;
		}
		if ($opnConfig['calendar_useInternationalDates']) {
			$form->AddSelect ('jumpday', buildDaySelectCAL (), $tag);
			$form->AddSelect ('jumpmonth', buildMonthSelectCAL (), $monat);
		} else {
			$form->AddSelect ('jumpmonth', buildMonthSelectCAL (), $monat);
			$form->AddSelect ('jumpday', buildDaySelectCAL (), $tag);
		}
		$form->AddSelect ('jumpyear', buildYearSelectCAL (), $jahr);
		$options['day'] = _CALENDAR_CALDAYVIEW;
		$options['month'] = _CALENDAR_CALMONTHVIEW;
		$options['year'] = _CALENDAR_CALYEARVIEW;
		$form->AddSelect ('type', $options, $type);
		$form->SetEndCol ();
		$form->SetSameCol ();
		$form->AddText ('&nbsp;' . _OPN_HTML_NL);
		$form->AddSubmit ('change', _CALENDAR_CALJUMPBUTTON);
		$form->AddText ('&nbsp;' . _OPN_HTML_NL);
		$form->AddHidden ('Date1', $Today_y . '-' . $Today_m . '-' . $Today_d);
		$form->AddSubmit ('today', _CALENDAR_CALTODAY);
		$form->SetEndCol ();
		if ($opnConfig['permission']->HasRight ('modules/calendar', _PERM_WRITE, true) ) {
			$form->AddChangeRow ();
			$form->AddText ('<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/calendar/submit.php?Date=' . $jahr . '-' . sprintf ('%02d-%02d', $monat, $tag) ) . '">' . _CALENDAR_CALSUBMITEVENT . '</a>');
			$form->AddText ('&nbsp;');
		}
		$form->AddChangeRow ();
		$form->AddText ('<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/index.php',
										'Date' => $jahr . '-' . sprintf ('%02d-%02d',
										$monat,
										$tag),
										'Date1' => $Date1,
										'today' => $today,
										'change' => $change,
										'eid' => $eid,
										'type' => $type,
										'printit' => 1) ) . '" target="_blank">' . _CALENDAR_CALPRINT . '</a>');
		$form->AddText ('&nbsp;');
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	if ($printit != '') {
		echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\"><html>" . '<head><title>' . $opnConfig['sitename'] . '</title></head>' . '<body bgcolor="#FFFFFF" text="#000000">' . $boxtxt . '</body>' . '</html>';
	} else {
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CALENDAR_130_';
		$_display_dat['module'] = 'modules/calendar';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_CALENDAR_CALNAME, $boxtxt);
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	default:
		CalendarIndex ();
	}

	?>