<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

define ('_CALENDAR_CALVERSION', '1.1.1 (16)');
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;

$opnConfig['permission']->HasRight ('modules/calendar', _PERM_WRITE);
$opnConfig['module']->InitModule ('modules/calendar');
getLanguageDef (_OPN_ROOT_PATH . 'modules/calendar/language/');

function themepreview ($title, $hometext, $bodytext = '', $notes = '') {
	return '<p><span class="normaltextbold">' . $title . '</span><br />' . $hometext . ' ' . $bodytext . ' ' . $notes . '</p>' . _OPN_HTML_NL;

}

function buildMonthSelectCAL () {

	$options = array ();
	for ($i = 1; $i<=12; $i++) {
		$options[$i] = $i;
	}
	return $options;

}

function buildDaySelectCAL () {

	$options = array ();
	for ($i = 1; $i<=31; $i++) {
		$options[$i] = $i;
	}
	return $options;

}

function buildYearSelectCAL () {

	$options = array ();
	for ($i = 2001; $i<=2030; $i++) {
		$options[$i] = $i;
	}
	return $options;

}

function buildHourSelectCAL () {

	$options = array ();
	for ($i = 0; $i<=23; $i++) {
		if ($i<10) {
			$i1 = '0' . $i;
		} else {
			$i1 = $i;
		}
		$options[$i] = $i1;
	}
	return $options;

}

function buildMinSelectCAL () {

	$options = array ();
	for ($i = 0; $i<=45; ) {
		if ($i == 0) {
			$i1 = ':00';
		} else {
			$i1 = ':' . $i;
		}
		$options[$i] = $i1;
		$i = $i+15;
	}
	return $options;

}

function printJavaScript () {

	$catemp = "<script type='text/javascript'>
		function verify() {
			var msg = '" . _CALENDAR_CALVALIDERRORMSG . "\\n__________________________________________________\\n\\n';
			var errors = 'FALSE';
			var starthour;
			var endhour;
			var startampm;
			var endampm;
			eventDate = new Date(document.calendar.month.options[document.calendar.month.selectedIndex].value +'/'+ document.calendar.day.options[document.calendar.day.selectedIndex].value+'/'+document.calendar.year.options[document.calendar.year.selectedIndex].value);
			endDate = new Date(document.calendar.endmonth.options[document.calendar.endmonth.selectedIndex].value + '/' + document.calendar.endday.options[document.calendar.endday.selectedIndex].value + '/' + document.calendar.endyear.options[document.calendar.endyear.selectedIndex].value);

			if (document.calendar.subject.value == '') {
				errors = 'TRUE';
				msg += '" . _CALENDAR_CALVALIDSUBJECT . "\\n';
			}
			if (eventDate.getMonth()+1 != document.calendar.month.options[document.calendar.month.selectedIndex].value) {
				errors = 'TRUE';
				msg += '** " . _CALENDAR_CALVALIDEVENTDATE . "\\n';
			}
			if (endDate.getMonth()+1 != document.calendar.endmonth.options[document.calendar.endmonth.selectedIndex].value) {
				errors = 'TRUE';
				msg += '** " . _CALENDAR_CALVALIDENDDATE . "\\n';
			}
			if (endDate.getTime() < eventDate.getTime()) {
				errors = 'TRUE';
				msg += '** " . _CALENDAR_CALVALIDDATES . "\\n';
			}
			if (errors == 'TRUE') {
				msg += '__________________________________________________\\n\\n" . _CALENDAR_CALVALIDFIXMSG . "\\n';
				alert(msg);
				return false;
			}
		}
		</script>";
	return $catemp;

}

function defaultDisplay () {

	global $opnConfig, $opnTables;

	$type = '';
	get_var ('type', $type, 'url', _OOBJ_DTYPE_CLEAN);
	$Date = '';
	get_var ('Date', $Date, 'url', _OOBJ_DTYPE_CLEAN);
	$boxtxt = printJavaScript ();
	$boxtxt .= '<span class="bigtextbold">' . _CALENDAR_CALSUBMITNAME . '</span><br /><br />';
	$boxtxt .= '<span class="normaltext">' . _CALENDAR_CALSUBMITADVICE . '</span><br />';
	$boxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_CALENDAR_150_', 'calendar');
	$form->Init ($opnConfig['opn_url'] . '/modules/calendar/submit.php', 'post', 'calendar', '', 'return verify();');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText (_CALENDAR_CALYOURNAME . ': ');
	if ($opnConfig['permission']->IsUser () ) {
		$ui = $opnConfig['permission']->GetUserinfo ();
		$form->AddText ('<a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . $ui['uname'] . '</a> [ <a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user/index.php?op=logout') . '">' . _CALENDAR_CALLOGOUT . '</a> ]');
	} else {
		$form->AddText ($opnConfig['opn_anonymous_name']);
	}
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddLabel ('subject', _CALENDAR_CALSUBTITLE);
	$form->AddText ('<br />(' . _CALENDAR_CALBEDESCRIPTIVE . ')');
	$form->SetEndCol ();
	$form->AddTextfield ('subject', 50, 80);
	$form->AddChangeRow ();
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		$form->AddLabel ('topic', _CALENDAR_CALTOPIC . ': ');
		$toplist = &$opnConfig['database']->Execute ('SELECT topicid, topictext FROM ' . $opnTables['article_topics'] . ' ORDER BY topictext');
		$options[0] = _CALENDAR_CALSELECTTOPIC;
		if ($toplist !== false) {
			while (! $toplist->EOF) {
				$topicid = $toplist->fields['topicid'];
				$topics = $toplist->fields['topictext'];
				$options[$topicid] = $topics;
				$toplist->MoveNext ();
			}
		}
		$form->AddSelect ('topic', $options);
	} else {
		$form->AddText ('&nbsp;');
		$form->AddHidden ('topic', _CALENDAR_CALSELECTTOPIC);
	}
	$form->AddChangeRow ();
	$form->AddText (_CALENDAR_CALEVENTDATETEXT . ':');
	$year = '';
	$month = '';
	$day = '';
	if ($Date != '') {
		$opnConfig['opndate']->setTimestamp ($Date);
	} else {
		$opnConfig['opndate']->now ();
	}
	$opnConfig['opndate']->getDay ($day);
	$opnConfig['opndate']->getMonth ($month);
	$opnConfig['opndate']->getYear ($year);
	$opnConfig['opndate']->now ();
	$hour = '';
	$opnConfig['opndate']->getHour ($hour);
	//$min='';
	// $opnConfig['opndate']->getMinute($min);
	$form->SetSameCol ();
	if ($opnConfig['calendar_useInternationalDates']) {
		$form->AddSelect ('day', buildDaySelectCAL (), $day);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('month', buildMonthSelectCAL (), $month);
	} else {
		$form->AddSelect ('month', buildMonthSelectCAL (), $month);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('day', buildDaySelectCAL (), $day);
	}
	$form->AddText ('&nbsp;');
	$form->AddSelect ('year', buildYearSelectCAL (), $year);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDAR_CALENDDATETEXT . ':');
	$form->SetSameCol ();
	if ($opnConfig['calendar_useInternationalDates']) {
		$form->AddSelect ('endday', buildDaySelectCAL (), $day);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('endmonth', buildMonthSelectCAL (), $month);
	} else {
		$form->AddSelect ('endmonth', buildMonthSelectCAL (), $month);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('endday', buildDaySelectCAL (), $day);
	}
	$form->AddText ('&nbsp;');
	$form->AddSelect ('endyear', buildYearSelectCAL (), $year);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDAR_CALSTARTTIME . ':');
	$form->SetSameCol ();
	$form->AddSelect ('startHour', buildHourSelectCAL (), $hour);
	$form->AddText ('&nbsp;');
	$form->AddSelect ('startMin', buildMinSelectCAL (), 0);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDAR_CALENDTIME . ':');
	$form->SetSameCol ();
	$hour += 2;
	if ($hour>23) {
		$hour -= 24;
	}
	$form->AddSelect ('endHour', buildHourSelectCAL (), $hour);
	$form->AddText ('&nbsp;');
	$form->AddSelect ('endMin', buildMinSelectCAL (), 0);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('alldayevent', _CALENDAR_CALALLDAYEVENT);
	$form->SetSameCol ();
	$form->AddCheckbox ('alldayevent', 1);
	$form->AddText ('<br />(' . _CALENDAR_CALTIMEIGNORED . ')');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDAR_CALBARCOLORTEXT . ':');
	$form->SetSameCol ();
	$form->AddRadio ('barcolor', 'r');
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballr.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorred'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'g', 1);
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballg.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorgreen'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'b');
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballb.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorblue'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'w');
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballw.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorwhite'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'y');
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/bally.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcoloryellow']);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('story', _CALENDAR_CALARTICLETEXT . ':');
	$form->AddTextarea ('story');
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->SetSameCol ();
	$form->AddText ('<br />(' . _CALENDAR_CALHTMLISFINE . ')<br />');
	$form->AddText ('<br />' . _CALENDAR_CALALLOWEDHTML . '<br />');
	if (is_array ($opnConfig['AllowableHTML']) ) {
		foreach ($opnConfig['AllowableHTML'] as $key => $v) {
			$form->AddText (" &lt;" . $key . "&gt;");
		}
	}
	$form->AddText ('<br />(' . _CALENDAR_CALAREYOUSURE . ')<br /><br />');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddHidden ('type', $type);
	$form->SetSameCol ();
	$form->AddSubmit ('op2', _CALENDAR_CALPREVIEW);
	$form->AddText (' (' . _CALENDAR_CALSUBPREVIEW . ')');
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$opnConfig['opnOutput']->EnableJavaScript ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CALENDAR_160_';
	$_display_dat['module'] = 'modules/calendar';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_CALENDAR_CALNAME, $boxtxt);

}

function PreviewStory () {

	global $opnConfig, $opnTables;

	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$endday = 0;
	get_var ('endday', $endday, 'form', _OOBJ_DTYPE_INT);
	$endmonth = 0;
	get_var ('endmonth', $endmonth, 'form', _OOBJ_DTYPE_INT);
	$endyear = 0;
	get_var ('endyear', $endyear, 'form', _OOBJ_DTYPE_INT);
	$story = '';
	get_var ('story', $story, 'form', _OOBJ_DTYPE_CHECK);
	$topic = 0;
	get_var ('topic', $topic, 'form', _OOBJ_DTYPE_INT);
	$type = '';
	get_var ('type', $type, 'form', _OOBJ_DTYPE_CLEAN);
	$startHour = 0;
	get_var ('startHour', $startHour, 'form', _OOBJ_DTYPE_INT);
	$startMin = 0;
	get_var ('startMin', $startMin, 'form', _OOBJ_DTYPE_INT);
	$endHour = 0;
	get_var ('endHour', $endHour, 'form', _OOBJ_DTYPE_INT);
	$endMin = 0;
	get_var ('endMin', $endMin, 'form', _OOBJ_DTYPE_INT);
	$alldayevent = 0;
	get_var ('alldayevent', $alldayevent, 'form', _OOBJ_DTYPE_INT);
	$barcolor = '';
	get_var ('barcolor', $barcolor, 'form', _OOBJ_DTYPE_CLEAN);
	$subject = stripslashes ($opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml') );
	$story = stripslashes ($story);
	$boxtxt = printJavaScript ();
	$boxtxt .= '<span class="bigtextbold">' . _CALENDAR_CALNEWSUBPREVIEW . '</span>';
	$boxtxt .= '<br />';
	$boxtxt .= '<div align="center" class="normaltext">' . _CALENDAR_CALSTORYLOOK . '</div><br /><br />';
	$warning = '';
	$table = & new opn_TableClass ('alternator');
	$table->AddOpenRow ();
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		if ($topic == '') {
			$topicimage = 'AllTopics.gif';
			$warning = '<div align="center" class="alerttext">' . _CALENDAR_CALTOPICERROR . '</div>';
		} else {
			$_topic = $opnConfig['opnSQL']->qstr ($topic);
			$result = &$opnConfig['database']->Execute ('SELECT topicimage FROM ' . $opnTables['article_topics'] . " WHERE topicid=$_topic");
			$topicimage = $result->fields['topicimage'];
		}
		if ($topicimage == '') {
			$topicimage = 'AllTopics.gif';
		}
	}
	$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . $day . ' ' . $startHour . ':' . $startMin . ':00');
	$mydate = '';
	$opnConfig['opndate']->formatTimestamp ($mydate, _DATE_DATESTRING5);
	$hlp = '';
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		$hlp .= '<img src="' . $opnConfig['datasave']['art_topic_path']['url'] . '/' . $topicimage . '" class="imgtag" align="right" alt="" />';
	}
	$hlp .= '<span class="normaltextbold">' . _CALENDAR_CALEVENTDATEPREVIEW . '</span>' . '<span class="normaltext"> ' . $mydate . '</span><br /><br />';
	$table->AddDataCol ($hlp);
	$storypreview = $story;
	opn_nl2br ($storypreview);
	$hlp = themepreview ($subject, $storypreview);
	$hlp .= $warning;
	$table->AddChangeRow ();
	$table->AddDataCol ($hlp);
	$table->AddCloseRow ();
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br /><div align="center" class="normaltext">' . _CALENDAR_CALCHECKSTORY . '</div>';
	$boxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_CALENDAR_170_', 'calendar');
	$form->Init ($opnConfig['opn_url'] . '/modules/calendar/submit.php', 'post', 'calendar', 'return verify();');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddText (_CALENDAR_CALYOURNAME . ': ');
	if ($opnConfig['permission']->IsUser () ) {
		$ui = $opnConfig['permission']->GetUserinfo ();
		$form->AddText ('<a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . $ui['uname'] . '</a> [ <a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user/index.php?op=logout') . '">' . _CALENDAR_CALLOGOUT . '</a> ]');
	} else {
		$form->AddText ($opnConfig['opn_anonymous_name']);
	}
	$form->AddChangeRow ();
	$form->AddLabel ('subject', _CALENDAR_CALSUBTITLE . ':');
	$form->AddTextfield ('subject', 50, 80, $subject);
	$form->AddChangeRow ();
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		$form->AddLabel ('topic', _CALENDAR_CALTOPIC . ':');
		$toplist = &$opnConfig['database']->Execute ('SELECT topicid, topictext FROM ' . $opnTables['article_topics'] . " ORDER BY topictext");
		$options[0] = _CALENDAR_CALSELECTTOPIC;
		while (! $toplist->EOF) {
			$topicid = $toplist->fields['topicid'];
			$topics = $toplist->fields['topictext'];
			$options[$topicid] = $topics;
			$toplist->MoveNext ();
		}
		$form->AddSelect ('topic', $options, (int) $topic);
	} else {
		$form->AddText ('&nbsp;');
		$form->AddHidden ('topic', '');
	}
	$form->AddChangeRow ();
	$form->AddText (_CALENDAR_CALEVENTDATETEXT . ':');
	$form->SetSameCol ();
	if ($opnConfig['calendar_useInternationalDates']) {
		$form->AddSelect ('day', buildDaySelectCAL (), $day);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('month', buildMonthSelectCAL (), $month);
	} else {
		$form->AddSelect ('month', buildMonthSelectCAL (), $month);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('day', buildDaySelectCAL (), $day);
	}
	$form->AddText ('&nbsp;');
	$form->AddSelect ('year', buildYearSelectCAL (), $year);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDAR_CALENDDATETEXT . ':');
	$form->SetSameCol ();
	if ($opnConfig['calendar_useInternationalDates']) {
		$form->AddSelect ('endday', buildDaySelectCAL (), $endday);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('endmonth', buildMonthSelectCAL (), $endmonth);
	} else {
		$form->AddSelect ('endmonth', buildMonthSelectCAL (), $endmonth);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('endday', buildDaySelectCAL (), $endday);
	}
	$form->AddText ('&nbsp;');
	$form->AddSelect ('endyear', buildYearSelectCAL (), $endyear);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDAR_CALSTARTTIME . ':');
	$form->SetSameCol ();
	$form->AddSelect ('startHour', buildHourSelectCAL (), $startHour);
	$form->AddText ('&nbsp;');
	$form->AddSelect ('startMin', buildMinSelectCAL (), $startMin);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDAR_CALENDTIME . ':');
	$form->SetSameCol ();
	$form->AddSelect ('endHour', buildHourSelectCAL (), $endHour);
	$form->AddText ('&nbsp;');
	$form->AddSelect ('endMin', buildMinSelectCAL (), $endMin);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('alldayevent', _CALENDAR_CALALLDAYEVENT);
	$form->SetSameCol ();
	$form->AddCheckbox ('alldayevent', 1, $alldayevent);
	$form->AddText ('<br />(' . _CALENDAR_CALTIMEIGNORED . ')');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDAR_CALBARCOLORTEXT . ':');
	$form->SetSameCol ();
	$form->AddRadio ('barcolor', 'r', ($barcolor == 'r'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballr.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorred'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'g', ($barcolor == 'g'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballg.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorgreen'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'b', ($barcolor == 'b'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballb.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorblue'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'w', ($barcolor == 'w'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballw.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorwhite'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'y', ($barcolor == 'y'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/bally.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcoloryellow']);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('story', _CALENDAR_CALARTICLETEXT . ':');
	$form->SetSameCol ();
	$form->AddTextarea ('story', 0, 0, '', $story);
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->SetSameCol ();
	$form->AddText ('<br />(' . _CALENDAR_CALHTMLISFINE . ')<br />');
	$form->AddText ('<br />(' . _CALENDAR_CALAREYOUSURE . ')');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddHidden ('type', $type);
	$form->SetSameCol ();
	$form->AddSubmit ('op2', _CALENDAR_CALPREVIEW);
	$form->AddText ('&nbsp;');
	$form->AddSubmit ('op2', _CALENDAR_CALSUBMIT);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$opnConfig['opnOutput']->EnableJavaScript ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CALENDAR_180_';
	$_display_dat['module'] = 'modules/calendar';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_CALENDAR_CALNAME, $boxtxt);

}

function SubmitStory () {

	global $opnConfig, $opnTables;

	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$endday = 0;
	get_var ('endday', $endday, 'form', _OOBJ_DTYPE_INT);
	$endmonth = 0;
	get_var ('endmonth', $endmonth, 'form', _OOBJ_DTYPE_INT);
	$endyear = 0;
	get_var ('endyear', $endyear, 'form', _OOBJ_DTYPE_INT);
	$story = '';
	get_var ('story', $story, 'form', _OOBJ_DTYPE_CHECK);
	$topic = 0;
	get_var ('topic', $topic, 'form', _OOBJ_DTYPE_INT);
	$type = '';
	get_var ('type', $type, 'form', _OOBJ_DTYPE_CLEAN);
	$startHour = 0;
	get_var ('startHour', $startHour, 'form', _OOBJ_DTYPE_INT);
	$startMin = 0;
	get_var ('startMin', $startMin, 'form', _OOBJ_DTYPE_INT);
	$endHour = 0;
	get_var ('endHour', $endHour, 'form', _OOBJ_DTYPE_INT);
	$endMin = 0;
	get_var ('endMin', $endMin, 'form', _OOBJ_DTYPE_INT);
	$alldayevent = 0;
	get_var ('alldayevent', $alldayevent, 'form', _OOBJ_DTYPE_INT);
	$barcolor = '';
	get_var ('barcolor', $barcolor, 'form', _OOBJ_DTYPE_CLEAN);
	$boxtxt = '';
	if ($opnConfig['permission']->IsUser () ) {
		$ui = $opnConfig['permission']->GetUserinfo ();
	} else {
		$ui['uid'] = 1;
		$ui['uname'] = $opnConfig['opn_anonymous_name'];
	}
	$subject = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml') );
	opn_nl2br ($story);
	$story = $opnConfig['cleantext']->filter_text ($story, true, true);
	$newDate = $year . '-' . $month . '-' . $day;
	$endDate = $endyear . '-' . $endmonth . '-' . $endday;
	$startTime = $startHour . ':' . $startMin . ':00';
	$endTime = $endHour . ':' . $endMin . ':00';
	$qid = $opnConfig['opnSQL']->get_new_number ('calendar_events_queue', 'qid');
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->opnDataTosql ($now);
	$opnConfig['opndate']->setTimestamp ($newDate);
	$opnConfig['opndate']->opnDataTosql ($newDate);
	$opnConfig['opndate']->setTimestamp ($endDate);
	$opnConfig['opndate']->opnDataTosql ($endDate);
	$opnConfig['opndate']->setTimestamp ($startTime);
	$opnConfig['opndate']->opnDataTosql ($startTime);
	$opnConfig['opndate']->setTimestamp ($endTime);
	$opnConfig['opndate']->opnDataTosql ($endTime);
	if ($alldayevent == '') {
		$alldayevent = 0;
	}
	$_topic = $opnConfig['opnSQL']->qstr ($topic);
	$_barcolor = $opnConfig['opnSQL']->qstr ($barcolor);
	$_author = $opnConfig['opnSQL']->qstr ($ui['uname']);
	if ( (isset ($opnConfig['calendar_calnocheck']) ) && ($opnConfig['calendar_calnocheck'] == 1) ) {
		$story = $opnConfig['opnSQL']->qstr ($story, 'hometext');
		$eid = $opnConfig['opnSQL']->get_new_number ('calendar_events', 'eid');
		$casql = 'INSERT INTO ' . $opnTables['calendar_events'] . " values ($eid, " . $ui['uid'] . ",$subject,$now, $story, 0, 0, $topic, $_author,$newDate,$endDate,$startTime,$endTime, $alldayevent, $_barcolor, 0)";
		$opnConfig['database']->Execute ($casql);
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['calendar_events'], 'eid=' . $eid);
	} else {
		$story = $opnConfig['opnSQL']->qstr ($story, 'story');
		$qid = $opnConfig['opnSQL']->get_new_number ('calendar_events_queue', 'qid');
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['calendar_events_queue'] . " values ($qid, " . $ui['uid'] . ", $_author, $subject, $story, $now, $_topic                          , $newDate,$endDate,$startTime,$endTime, $alldayevent, $_barcolor)");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['calendar_events_queue'], 'story', $story, 'qid=' . $qid);
		$result = &$opnConfig['database']->Execute ('SELECT COUNT(qid) AS counter FROM ' . $opnTables['calendar_events_queue'] . ' WHERE qid>0');
		if (isset ($result->fields['counter']) ) {
			$waiting = $result->fields['counter'];
		} else {
			$waiting = 0;
		}
		$boxtxt .= '<div class="centertag"><span class="bigtextbold">' . _CALENDAR_CALSUBSENT . '</span><br /><br />' . '<span class="normaltext">' . _CALENDAR_CALTHANKSSUB . '<br /><br />' . _CALENDAR_CALSUBTEXT . '<br />' . _CALENDAR_CALWEHAVESUB . ' ' . $waiting . '&nbsp;' . _CALENDAR_CALWAITING . '</span></div>';
		$boxtxt .= '<br /><br />';
	}
	if ($opnConfig['database']->ErrorNo ()>0) {
		echo $opnConfig['database']->ErrorNo () . ': ' . $opnConfig['database']->ErrorMsg () . '<br />';
		exit ();
	}

	/**** Get todays date */

	$opnConfig['opndate']->now ();
	$Today_d = '';
	$opnConfig['opndate']->getDay ($Today_d);
	$Today_m = '';
	$opnConfig['opndate']->getMonth ($Today_m);
	$Today_y = '';
	$opnConfig['opndate']->getYear ($Today_y);
	$boxtxt .= '<div class="centertag">';
	$table = & new opn_TableClass ('default');
	$table->AddCols (array ('10') );
	$table->AddOpenRow ();
	$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/kalender_blau.jpg" alt="" />', '', '', 'top', '3');
	$table->AddChangeRow ();
	$table->AddDataCol ('<span class="bigtextbold">' . _CALENDAR_CALNAME . '</span>', 'center');
	$table->AddChangeRow ();
	$hlp = '<br /><a href="' . $opnConfig['opn_url'] . '/modules/calendar/submit.php">' . _CALENDAR_CALEVENTLINK . '</a><br /><br />';
	$form = & new opn_FormularClass ();
	$form->Init ($opnConfig['opn_url'] . '/modules/calendar/index.php', 'post', 'jump');
	if ($opnConfig['calendar_useInternationalDates']) {
		$form->AddSelect ('jumpday', buildDaySelectCAL (), $Today_d);
		$form->AddSelect ('jumpmonth', buildMonthSelectCAL (), $Today_m);
		$form->AddSelect ('jumpyear', buildYearSelectCAL (), $Today_y);
	} else {
		$form->AddSelect ('jumpmonth', buildMonthSelectCAL (), $Today_m);
		$form->AddSelect ('jumpday', buildDaySelectCAL (), $Today_d);
		$form->AddSelect ('jumpyear', buildYearSelectCAL (), $Today_y);
	}
	$options['day'] = _CALENDAR_CALDAYVIEW;
	$options['month'] = _CALENDAR_CALMONTHVIEW;
	$options['year'] = _CALENDAR_CALYEARVIEW;
	$form->AddSelect ('view', $options, $type);
	$form->AddText ('&nbsp;');
	$form->AddButton ('change', _CALENDAR_CALJUMPBUTTON, '', '', 'location.href=\'' . $opnConfig['opn_url'] . '/modules/calendar/index.php?type=\' + document.jump.view.options[document.jump.view.options.selectedIndex].value + \'&Date=\' + document.jump.jumpyear.options[document.jump.jumpyear.options.selectedIndex].value + \'-\' + document.jump.jumpmonth.options[document.jump.jumpmonth.options.selectedIndex].value + \'-\' + document.jump.jumpday.options[document.jump.jumpday.options.selectedIndex].value');
	$form->AddText ('&nbsp;');
	$form->AddButton ('today', _CALENDAR_CALTODAY, '', '', 'location.href=\'' . $opnConfig['opn_url'] . '/modules/calendar/index.php?type=\' + document.jump.view.options[document.jump.view.options.selectedIndex].value + \'&Date=' . $Today_y . '-' . $Today_m . '-' . $Today_d . '\'');
	$form->AddFormEnd ();
	$form->GetFormular ($hlp);
	$table->AddDataCol ($hlp, 'center');
	$table->AddCloseRow ();
	$table->GetTable ($boxtxt);
	$boxtxt .= '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CALENDAR_190_';
	$_display_dat['module'] = 'modules/calendar';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_CALENDAR_CALNAME, $boxtxt);

}
$op2 = '';
get_var ('op2', $op2, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op2) {
	case _CALENDAR_CALPREVIEW:
		PreviewStory ();
		break;
	case _CALENDAR_CALSUBMIT:
		SubmitStory ();
		break;
	default:
		defaultDisplay ();
		break;
}

?>