<?php
/**
* OpenPHPNuke: Great Web Portal System
* Pro-Module
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is NOT free software.
* See LICENSE for details.
*
*/

function _importchangelog_clean_message (&$message) {

	global $opnConfig;

	$message = str_replace ('trunk/openphpnuke/html/', '', $message);
	$message = preg_replace ("#branches\/openphpnuke-{1,3}.{1,3}\/openphpnuke\/html\/#i", '', $message);
	if (substr_count ($message, ',') > 0) {
		$message = str_replace (',', _OPN_HTML_NL, $message);
	}
}

function import_changelog () {

	global $opnConfig, $opnTables;

	$result = $opnConfig['database']->Execute ('SELECT reproid, catid, lastrev FROM ' . $opnTables['changelog_repros'] . ' ORDER BY reproid');
	while (!$result->EOF) {
		$lastimported = 0;
		$reproid = $result->fields['reproid'];
		$catid = $result->fields['catid'];
		$lastrev = $result->fields['lastrev'];
		$svn = $opnConfig['database']->Execute ('SELECT revnr, revmessage, revupdated, revadded, revdeleted, revauthor, revdate FROM ' . $opnTables['svnchangelog'] . ' WHERE revrepro=' . $reproid . ' AND revnr>' . $lastrev . ' ORDER BY revnr');
		while (!$svn->EOF) {
			$revnr = $svn->fields['revnr'];
			$lastimported = $revnr;
			$revmessage = $svn->fields['revmessage'];
			$revupdated = $svn->fields['revupdated'];
			$revadded = $svn->fields['revadded'];
			$revdeleted = $svn->fields['revdeleted'];
			$revauthor = $svn->fields['revauthor'];
			$revdate = $svn->fields['revdate'];
			_importchangelog_clean_message ($revupdated);
			_importchangelog_clean_message ($revadded);
			_importchangelog_clean_message ($revdeleted);
			$revmessage = $opnConfig['opnSQL']->qstr ($revmessage, 'changelogs');
			$revupdated = $opnConfig['opnSQL']->qstr ($revupdated, 'revupdated');
			$revadded = $opnConfig['opnSQL']->qstr ($revadded, 'revadded');
			$revdeleted = $opnConfig['opnSQL']->qstr ($revdeleted, 'revdeleted');
			$revauthor = $opnConfig['opnSQL']->qstr ($revauthor);
			$revnr = $opnConfig['opnSQL']->qstr ($revnr);
			$id = $opnConfig['opnSQL']->get_new_number ('changelog', 'id');
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['changelog']. " VALUES ($id, $revauthor, '', $revdate, $revnr, $revmessage, '', $catid, $revupdated, $revadded, $revdeleted)");
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables['changelog'], 'id=' . $id);
			$svn->MoveNext ();
		}
		$svn->Close ();
		if ($lastimported !=0) {
			$opnConfig['database']->Execute ('UPDATE ' .  $opnTables['changelog_repros'] . " SET lastrev=$lastimported WHERE reproid=$reproid AND catid=$catid");
		}
		$result->MoveNext ();
	}
	$result->Close ();
}
?>