<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function changelog_back () {

	global $opnConfig;
	return '<div align="center" class="normaltextbold"><a class="normaltextbold" href="' . $opnConfig['opn_url'] . '/modules/changelog/index.php">' . _CHLOG_BACKTOMAIN . '</a></div><br /><br />';

}

function changelog_nav ($function, $cid, &$changelognav) {

	global $opnConfig;

	$boxtxt = '';
	if ($opnConfig['permission']->HasRights ('modules/changelog', array (_PERM_EDIT, _PERM_NEW, _PERM_DELETE, _PERM_ADMIN), true) ) {
		$table = & new opn_TableClass ('default');
		$table->AddCols (array ('33%', '34%', '33%') );
		$table->AddOpenRow ();
		if ($opnConfig['permission']->HasRights ('modules/changelog', array (_PERM_NEW, _PERM_ADMIN), true) ) {
			if ($function != 1) {

				$table->AddDataCol ('<a class="txtbutton" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/changelog/index.php?op=add_changelog') . '">' . _CHLOG_ADDCHANGELOG . '</a>');
			} else {
				$table->AddDataCol ('<span class="txtbutton">' . _CHLOG_ADDCHANGELOG . '</span>');
			}
		}
		$table->AddCloseRow ();
		$table->GetTable ($boxtxt);
	}
	if ($cid != '') {
		$boxtxt .= '<br />';
		$boxtxt .= $changelognav->SubNavigation ($cid);
	} else {
		$hlptxt = $changelognav->MainNavigation ();
		if ($hlptxt != '') {
			$boxtxt .= '<br />';
			$boxtxt .= $hlptxt . '<br />';
		}
	}
	return $boxtxt;

}

function display_changelog_box ($name, $date, $buildversion, $changelogs, $bugs, $mod, $del, $id, $catid, &$mf, $updated = '', $added = '', $deleted = '') {

	global $opnConfig;

	$opnConfig['permission']->HasRights ('modules/changelog', array (_PERM_READ, _PERM_DELETE, _PERM_EDIT, _PERM_ADMIN) );
	$edittext = '';
	if ($mod === TRUE) {
		$edittext .= '&nbsp;[ <a class="listalternatorfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/changelog/index.php',
												'op' => 'mod_changelog',
												'id' => $id,
												'offset' => 0) ) . '">' . _CHLOG_MODTHIS . '</a> ]';
	}
	if ($del === TRUE) {
		$edittext .= '&nbsp;[ <a class="listalternatorfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/changelog/index.php',
												'op' => 'del_changelog',
												'id' => $id,
												'offset' => 0) ) . '">' . _CHLOG_DELTHIS . '</a> ]';
	}
	$table = & new opn_TableClass ('listalternator');
	$opnConfig['opndate']->sqlToopnData ($date);
	$hdate = '';
	$opnConfig['opndate']->formatTimestamp ($hdate, _DATE_DATESTRING5);
	$table->AddCols (array ('20%', '80%') );
	$table->AddOpenHeadRow ();
	$table->AddHeaderCol (_CHLOG_MODFILES . '&nbsp;' . $buildversion . '&nbsp;' . _CHLOG_DATEBY . '&nbsp;' . $hdate, 'left', '2');
	$table->AddCloseRow ();
	$path = $mf->getPathFromId ($catid);
	$path = substr ($path, 1);
	$path = str_replace ('/', ' <span class="alerttext">&raquo;&raquo;</span> ', $path);
	if ($path != '') {
		$table->AddDataRow (array (_CHLOG_CATEGORY . ':', $path) );
	}
	$table->AddDataRow (array (_CHLOG_CHANGEDETAILS, $changelogs) );
	if ($bugs != '') {
		$table->AddDataRow (array (_CHLOG_POSBUGS, $bugs) );
	}
	$table->AddDataRow (array (_CHLOG_BY, $name) );
	if ($updated != '') {
		$table->AddDataRow ( array (_CHLOG_FILESUPDATED, $updated));
	}
	if ($added != '') {
		$table->AddDataRow ( array (_CHLOG_FILESADDED, $added));
	}
	if ($deleted != '') {
		$table->AddDataRow ( array (_CHLOG_FILESDELETED, $deleted));
	}
	if ($edittext != '') {
		$table->AddOpenFootRow ('center');
		$table->AddFooterCol ($edittext, '', '2');
		$table->AddCloseRow ();
	}
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	return $boxtxt;

}

function add_changelog (&$mf, &$changelognav) {

	global $opnConfig;

	$opnConfig['permission']->HasRights ('modules/changelog', array (_PERM_NEW, _PERM_ADMIN) );
	$cookie = $opnConfig['permission']->GetUserinfo ();
	if ( (isset ($cookie['firstname']) ) AND ($cookie['firstname'] . $cookie['lastname'] != '') ) {
		$uname = $cookie['firstname'] . ' ' . $cookie['lastname'];
	} else {
		$uname = $cookie['uname'];
	}
	$email = $cookie['email'];
	$boxtxt = changelog_nav (1, '', $changelognav);
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_CHANGELOG_50_', 'changelog_add');
	$form->Init ($opnConfig['opn_url'] . '/modules/changelog/index.php');
	$form->AddTable ();
	$form->AddCols (array ('15%', '45%', '40%') );
	$form->AddOpenRow ();
	$form->SetColspan ('3');
	$form->AddText (_CHLOG_ACCSPECS);
	$form->SetColspan ('');
	$form->AddChangeRow ();
	$form->AddLabel ('catid', _CHLOG_CATEGORY);
	$mf->makeMySelBox ('', $form, 0, 'catid');
	$form->AddText ('&nbsp;');
	$form->AddChangeRow ();
	$form->AddLabel ('name', _CHLOG_FULLNAME);
	$form->AddTextfield ('name', 25, 40, $uname);
	$form->AddText (_CHLOG_FULLNAMEEG);
	$form->AddChangeRow ();
	$form->AddLabel ('email', _CHLOG_EMAILADDR);
	$form->AddTextfield ('email', 25, 40, $email);
	$form->AddText (_CHLOG_EMAILADDREG);
	$form->AddChangeRow ();
	$form->AddLabel ('buildversion', _CHLOG_FILES);
	$form->AddTextfield ('buildversion', 25, 40);
	$form->AddText (_CHLOG_FILESEG);
	$form->AddChangeRow ();
	$form->AddLabel ('changelogs', _CHLOG_DETAILS);
	$form->AddTextarea ('changelogs');
	$form->AddText (_CHLOG_DETAILSEG);
	$form->AddChangeRow ();
	$form->AddLabel ('bugs', _CHLOG_BUGS);
	$form->AddTextarea ('bugs');
	$form->AddText (_CHLOG_BUGSEG);
	$form->AddChangeRow ();
	$form->SetColspan ('3');
	$form->AddText (_CHLOG_VALID);
	$form->AddChangeRow ();
	$form->SetAlign ('center');
	$form->SetSameCol ();
	$form->AddHidden ('op', 'add');
	$form->AddSubmit ('submit', _CHLOG_ADD);
	$form->AddText ('&nbsp;');
	$form->AddButton ('Cancel', _CHLOG_CANCEL, '', '', 'history.go(-1)');
	$form->SetEndCol ();
	$form->SetColspan ('');
	$form->SetAlign ('');
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CHANGELOG_60_';
	$_display_dat['module'] = 'modules/changelog';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_CHLOG_DESC, $boxtxt);

}

function addCHANGE ($mf) {

	global $opnConfig;

	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$buildversion = '';
	get_var ('buildversion', $buildversion, 'form', _OOBJ_DTYPE_CLEAN);
	$changelogs = '';
	get_var ('changelogs', $changelogs, 'form', _OOBJ_DTYPE_CLEAN);
	$bugs = '';
	get_var ('bugs', $bugs, 'form', _OOBJ_DTYPE_CLEAN);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/changelog', array (_PERM_NEW, _PERM_ADMIN) );
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_CHANGELOG_70_', 'changelog');
	$form->Init ($opnConfig['opn_url'] . '/modules/changelog/index.php');
	$form->AddHidden ('op', 'add_changelog_send');
	$error = 0;
	if ($name == '') {
		$error = 1;
		$form->AddText (_CHLOG_INVNAME . '<br />');
	}
	if ( ($opnConfig['changelog_buildnrrequired'] == '1') && ($buildversion == '') ) {
		$error = 1;
		$form->AddText (_CHLOG_INVFILE . '<br />');
	}
	if ($changelogs == '') {
		$error = 1;
		$form->AddText (_CHLOG_INVCHANGELOGS . '<br />');
	}
	if (! (preg_match ('/^([a-zA-Z0-9_\-])+(\.([a-zA-Z0-9_\-])+)*@((\[(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5])))\.(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5])))\.(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5])))\.(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5]))\]))|((([a-zA-Z0-9])+(([\-])+([a-zA-Z0-9])+)*\.)+([a-zA-Z])+(([\-])+([a-zA-Z0-9])+)*))$/i', $email) ) ) {
		$error = 1;
		$form->AddText (_CHLOG_INVEMAIL . '<br />');
	}
	if ($error == 1) {
		$form->AddText ('<br />');
		$form->AddButton ('Back', _CHLOG_GOBACK, '', '', 'history.go(-1)');
	} else {
		$changelogs1 = $changelogs;
		$bugs1 = $bugs;
		opn_nl2br ($changelogs1);
		opn_nl2br ($bugs1);
		$opnConfig['opndate']->now ();
		$date = '';
		$opnConfig['opndate']->opnDataTosql ($date);
		$mod = 0;
		$del = 0;
		$id = 0;
		$form->AddText (display_changelog_box ($name, $date, $buildversion, $changelogs1, $bugs1, $mod, $del, $id, $catid, $mf) );
		$form->AddText ('<p><span class="normaltextitalic">' . _CHLOG_LOOKRIGHT . ' </span>');
		$changelogs = urlencode ($changelogs);
		$bugs = urlencode ($bugs);
		$form->AddHidden ('name', $name);
		$form->AddHidden ('email', $email);
		$form->AddHidden ('buildversion', $buildversion);
		$form->AddHidden ('changelogs', $changelogs);
		$form->AddHidden ('bugs', $bugs);
		$form->AddHidden ('catid', $catid);
		$form->AddSubmit ('submit', _YES_SUBMIT);
		$form->AddButton ('Cancel', _NO_SUBMIT, '', '', 'history.go(-1)');
		$form->AddText ('</p>');
	}
	$form->AddFormEnd ();
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CHANGELOG_80_';
	$_display_dat['module'] = 'modules/changelog';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_CHLOG_DESC, $boxtxt);

}

function add_changelog_send () {

	global $opnTables, $opnConfig;

	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$buildversion = '';
	get_var ('buildversion', $buildversion, 'form', _OOBJ_DTYPE_CLEAN);
	$changelogs = '';
	get_var ('changelogs', $changelogs, 'form', _OOBJ_DTYPE_CLEAN);
	$bugs = '';
	get_var ('bugs', $bugs, 'form', _OOBJ_DTYPE_CLEAN);
	$cid = 0;
	get_var ('catid', $cid, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/changelog', array (_PERM_NEW, _PERM_ADMIN) );
	$doit = 1;
	if ($opnConfig['changelog_buildnrrequired'] == '1') {
		$buildversion1 = $opnConfig['opnSQL']->qstr ($buildversion);
		$result = &$opnConfig['database']->Execute ('SELECT id, name, wdate, buildversion, changelogs, bugs FROM ' . $opnTables['changelog'] . ' WHERE buildversion=' . $buildversion1);
		if ($result !== false) {
			while (! $result->EOF) {
				$id = $result->fields['id'];
				$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
				$hdate = '';
				$opnConfig['opndate']->formatTimestamp ($hdate, _DATE_DATESTRING5);
				$changelogs .= _OPN_HTML_NL;
				$changelogs .= _OPN_HTML_NL;
				$changelogs .= _OPN_HTML_NL;
				$changelogs .= '***' . $result->fields['name'] . '***' . $hdate . '***';
				$changelogs .= _OPN_HTML_NL;
				$changelogs .= _OPN_HTML_NL;
				$changelogs .= $result->fields['changelogs'];
				if ($result->fields['bugs'] != '') {
					$bugs .= _OPN_HTML_NL;
					$bugs .= _OPN_HTML_NL;
					$bugs .= _OPN_HTML_NL;
					$bugs .= '***' . $result->fields['name'] . '***' . $hdate . '***';
					$bugs .= _OPN_HTML_NL;
					$bugs .= _OPN_HTML_NL;
					$bugs .= $result->fields['bugs'];
				}
				$doit = 0;
				$result->MoveNext ();
			}
			$result->Close ();
		}
	}
	$changelogs = $opnConfig['opnSQL']->qstr (urldecode ($changelogs), 'changelogs');
	$bugs = $opnConfig['opnSQL']->qstr (urldecode ($bugs), 'bugs');
	$_email = $opnConfig['opnSQL']->qstr ($email);
	$name = $opnConfig['opnSQL']->qstr ($name);
	if ($doit == 1) {
		$buildversion = $opnConfig['opnSQL']->qstr ($buildversion);
		$id = $opnConfig['opnSQL']->get_new_number ('changelog', 'id');
		$opnConfig['opndate']->now ();
		$now = '';
		$opnConfig['opndate']->opnDataTosql ($now);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['changelog'] . " values ($id, $name, $_email, $now, $buildversion, $changelogs, $bugs, $cid, '', '', '')");
		if ($opnConfig['database']->ErrorNo ()>0) {
			$boxtxt = $opnConfig['database']->ErrorMsg () . '<br />';
			$boxtxt .= "$id, $name, $email, $buildversion, $changelogs, $bugs";
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CHANGELOG_90_';
			$_display_dat['module'] = 'modules/changelog';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayContent (_CHLOG_DESC, $boxtxt);
		} else {
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables['changelog'], 'id=' . $id);
			$opnConfig['opnOutput']->Redirect ('/modules/changelog/index.php');
		}
	} else {
		$opnConfig['opndate']->now ();
		$now = '';
		$opnConfig['opndate']->opnDataTosql ($now);
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['changelog'] . " SET changelogs=$changelogs,bugs=$bugs,name=$name, email=$_email, wdate=$now WHERE id = $id");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['changelog'], 'id=' . $id);
		$opnConfig['opnOutput']->Redirect ('/modules/changelog/index.php');
	}

}

function del_changelog (&$changelognav, &$mf) {

	global $opnTables, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_CLEAN);
	$opnConfig['permission']->HasRights ('modules/changelog', array (_PERM_DELETE, _PERM_ADMIN) );
	$boxtxt = changelog_nav (3, '', $changelognav);
	if ($id == 0) {
		$boxtxt .= list_changelogs ($mf, $offset);
	} elseif ($id != 0) {
		$result = &$opnConfig['database']->Execute ('SELECT id, name, wdate, buildversion, changelogs, bugs, catid FROM ' . $opnTables['changelog'] . ' WHERE id=' . $id);
		$id = $result->fields['id'];
		$name = $result->fields['name'];
		$date = $result->fields['wdate'];
		$buildversion = $result->fields['buildversion'];
		$changelogs = $result->fields['changelogs'];
		$bugs = $result->fields['bugs'];
		$catid = $result->fields['catid'];
		$mod = 0;
		$del = 1;
		$boxtxt .= display_changelog_box ($name, $date, $buildversion, $changelogs, $bugs, $mod, $del, $id, $catid, $mf);
		$boxtxt .= '<br />';
		$result->Close ();
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_CHANGELOG_100_', 'changelog');
		$form->Init ($opnConfig['opn_url'] . '/modules/changelog/index.php');
		$form->AddHidden ('op', 'del_changelog_send');
		$form->AddText ('<span class="normaltextitalic">' . _CHLOG_SUREDELETE . '</span><p>');
		$form->AddHidden ('id', $id);
		$form->AddSubmit ('submit', _YES_SUBMIT);
		$form->AddText ('&nbsp;&nbsp;');
		$form->AddButton ('Cancel', _NO_SUBMIT, '', '', 'history.go(-1)');
		$form->AddText ('</p>');
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CHANGELOG_110_';
	$_display_dat['module'] = 'modules/changelog';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_CHLOG_DESC, $boxtxt);

}

function del_changelog_send () {

	global $opnTables, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/changelog', array (_PERM_DELETE, _PERM_ADMIN) );
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['changelog'] . ' WHERE id=' . $id);
	$opnConfig['opnOutput']->Redirect ('/modules/changelog/index.php');

}

function index_changelog (&$mf, &$changelognav) {

	global $opnConfig;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_CLEAN);
	$cid = '';
	get_var ('catid', $cid, 'url', _OOBJ_DTYPE_CLEAN);
	if ($cid == '') {
		$cid = '';
		get_var ('cat_id', $cid, 'url', _OOBJ_DTYPE_CLEAN);
	}
	$boxtxt = changelog_nav (0, $cid, $changelognav);
	$boxtxt .= list_changelogs ($mf, $offset, $cid);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CHANGELOG_120_';
	$_display_dat['module'] = 'modules/changelog';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_CHLOG_DESC, $boxtxt);

}

function list_changelogs (&$mf, $offset = 0, $category = '') {

	global $opnConfig;

	$boxtxt = '';
	if ($opnConfig['permission']->HasRights ('modules/changelog', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
		$canedit = TRUE;
	} else {
		$canedit = FALSE;
	}
	if ($opnConfig['permission']->HasRights ('modules/changelog', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
		$candelete = TRUE;
	} else {
		$candelete = FALSE;
	}
	if ($category != '') {
		$where1 = 'catid=' . $category;
	} else {
		$where1 = '';
	}
	$pagesize = $opnConfig['pagesize_changelog'];
	$num_rows_per_order = $mf->GetItemCount ($where1);
	$result = $mf->GetItemLimit (array ('id',
					'name',
					'wdate',
					'buildversion',
					'changelogs',
					'bugs',
					'catid',
					'revupdated',
					'revadded',
					'revdeleted'),
					array ('i.id DESC'),
		$pagesize,
		$where1,
		$offset);
	if ($num_rows_per_order>0) {
		while (! $result->EOF) {
			$myrow = $result->GetRowAssoc ('0');
			$boxtxt .= '<br /><br />';
			opn_nl2br ($myrow['changelogs']);
			opn_nl2br ($myrow['bugs']);
			opn_nl2br ($myrow['revupdated']);
			opn_nl2br ($myrow['revadded']);
			opn_nl2br ($myrow['revdeleted']);
			$boxtxt .= display_changelog_box ($myrow['name'], $myrow['wdate'], $myrow['buildversion'], $myrow['changelogs'], $myrow['bugs'], $canedit, $candelete, $myrow['id'], $myrow['catid'], $mf, $myrow['revupdated'], $myrow['revadded'], $myrow['revdeleted']);
			$result->MoveNext ();
		}
	}
	$boxtxt .= _OPN_HTML_NL . '<br /><br />';
	$boxtxt .= _OPN_HTML_TAB;
	$boxtxt .= build_pagebar (array ($opnConfig['opn_url'] . '/modules/changelog/index.php'), $num_rows_per_order, $pagesize, $offset);
	$result->Close ();
	return $boxtxt;

}

function mod_changelog (&$mf, &$changelognav) {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/changelog', array (_PERM_EDIT, _PERM_ADMIN) );
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_CLEAN);
	$boxtxt = changelog_nav (2, '', $changelognav);
	if ($id == 0) {
		$boxtxt .= list_changelogs ($mf, $offset);
	} elseif ($id != 0) {
		$result = &$opnConfig['database']->Execute ('SELECT id, name, email, wdate, buildversion, changelogs, bugs, catid FROM ' . $opnTables['changelog'] . ' WHERE id=' . $id);
		$id = $result->fields['id'];
		$name = $result->fields['name'];
		$email = $result->fields['email'];
		$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
		$date = '';
		$opnConfig['opndate']->formatTimestamp ($date);
		$buildversion = $result->fields['buildversion'];
		$changelogs = $result->fields['changelogs'];
		$bugs = $result->fields['bugs'];
		$catid = $result->fields['catid'];
		$changelogs1 = $changelogs;
		$bugs1 = $bugs;
		opn_nl2br ($changelogs1);
		opn_nl2br ($bugs1);
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_CHANGELOG_130_', 'changelog');
		$form->Init ($opnConfig['opn_url'] . '/modules/changelog/index.php', 'post', 'changelog');
		$form->AddTable ('listalternator');
		$form->AddCols (array ('12%', '38%', '38%') );
		$form->AddOpenRow ();
		$form->AddDataCol (_CHLOG_ORGINFO, '', '2');
		$form->AddDataCol (_CHLOG_MODINFO, '', '1', '', '', 'listalternator');
		$form->AddChangeRow ();
		$form->AddLabel ('catid', _CHLOG_CATEGORY);
		$form->AddText ($catid);
		$mf->makeMySelBox ($catid, $form, 0, 'catid');
		$form->AddChangeRow ();
		$form->AddLabel ('name', _CHLOG_NAME);
		$form->AddText ($name);
		$form->AddTextfield ('name', 25, 40, $name);
		$form->AddChangeRow ();
		$form->AddLabel ('email', _CHLOG_EMAIL);
		$form->AddText ($email);
		$form->AddTextfield ('email', 25, 40, $email);
		$form->AddChangeRow ();
		$form->AddLabel ('buildversion', _CHLOG_FILES2);
		$form->AddText ($buildversion);
		$form->AddTextfield ('buildversion', 25, 40, $buildversion);
		$form->AddChangeRow ();
		$form->AddLabel ('changelogs', _CHLOG_CHANGELOGS);
		$form->AddText ($changelogs1);
		$form->AddTextarea ('changelogs', 0, 0, '', $changelogs);
		$form->AddChangeRow ();
		$form->AddLabel ('bugs', _CHLOG_BUGS2);
		$form->AddText ($bugs);
		$form->AddTextarea ('bugs', 0, 0, '', $bugs);
		$form->AddChangeRow ();
		$form->AddLabel ('date', _CHLOG_DATE);
		$form->AddText ($date);
		$form->AddTextfield ('date', 25, 19, $date);
		$form->AddChangeRow ();
		$form->SetColspan ('3');
		$form->SetAlign ('center');
		$form->SetSameCol ();
		$form->AddHidden ('op', 'mod_changelog_send');
		$form->AddHidden ('id', $id);
		$form->AddSubmit ('submit', _CHLOG_APPLYMOD);
		$form->AddText (' ', '');
		$form->AddButton ('Cancel', _CHLOG_CANCEL, '', '', 'history.go(-1)');
		$form->SetEndCol ();
		$form->SetColspan ('');
		$form->SetAlign ('');
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		// memory flush
		$result->Close ();
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CHANGELOG_140_';
	$_display_dat['module'] = 'modules/changelog';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_CHLOG_DESC, $boxtxt);

}

function mod_changelog_send () {

	global $opnTables, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$date = '';
	get_var ('date', $date, 'form', _OOBJ_DTYPE_CLEAN);
	$buildversion = '';
	get_var ('buildversion', $buildversion, 'form', _OOBJ_DTYPE_CLEAN);
	$changelogs = '';
	get_var ('changelogs', $changelogs, 'form', _OOBJ_DTYPE_CLEAN);
	$bugs = '';
	get_var ('bugs', $bugs, 'form', _OOBJ_DTYPE_CLEAN);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/changelog', array (_PERM_EDIT, _PERM_ADMIN) );
	$boxtxt = '';
	$errormsg = '';
	if ($name == '') {
		$errormsg .= _CHLOG_INVNAME . '<br />';
	}
	if ( ($opnConfig['changelog_buildnrrequired'] == '1') && ($buildversion == '') ) {
		$errormsg .= _CHLOG_INVFILE . '<br />';
	}
	if ($changelogs == '') {
		$errormsg .= _CHLOG_INVCHANGELOGS . '<br />';
	}
	if (! (preg_match ('/^([a-zA-Z0-9_\-])+(\.([a-zA-Z0-9_\-])+)*@((\[(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5])))\.(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5])))\.(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5])))\.(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5]))\]))|((([a-zA-Z0-9])+(([\-])+([a-zA-Z0-9])+)*\.)+([a-zA-Z])+(([\-])+([a-zA-Z0-9])+)*))$/i', $email) ) ) {
		$errormsg .= _CHLOG_INVEMAIL . '<br />';
	}
	if ($errormsg != '') {
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_CHANGELOG_150_', 'changelog');
		$form->Init ($opnConfig['opn_url'] . '/modules/changelog/index.php');
		$form->AddHidden ('op', 'add_changelog_send');
		$form->AddText ($errormsg . '<br />');
		$form->AddButton ('Back', _CHLOG_GOBACK, '', '', 'history.go(-1)');
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CHANGELOG_160_';
		$_display_dat['module'] = 'modules/changelog';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_CHLOG_DESC, $boxtxt);
	} else {
		$changelogs = $opnConfig['opnSQL']->qstr (urldecode ($changelogs), 'changelogs');
		$bugs = $opnConfig['opnSQL']->qstr (urldecode ($bugs), 'bugs');
		$opnConfig['opndate']->setTimestamp ($date);
		$opnConfig['opndate']->opnDataTosql ($date);
		$email = $opnConfig['opnSQL']->qstr ($email);
		$_name = $opnConfig['opnSQL']->qstr ($name);
		$_buildversion = $opnConfig['opnSQL']->qstr ($buildversion);
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['changelog'] . " SET name=$_name, email=$email, buildversion=$_buildversion, changelogs=$changelogs, bugs=$bugs, wdate=$date, catid=$catid WHERE id = $id");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['changelog'], 'id=' . $id);
		$opnConfig['opnOutput']->Redirect ('/modules/changelog/index.php');
	}

}

?>