<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../../mainfile.php');
}
global $opnConfig;

$module = '';
get_var ('module', $module, 'both', _OOBJ_DTYPE_CLEAN);
$opnConfig['permission']->HasRight ($module, _PERM_ADMIN);
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.installer.php');

/**
* @return void
* @desc Plugin De-Install Part
*/

function edit_fckeditor_DoRemove () {

	global $opnConfig;

	$module = '';
	get_var ('module', $module, 'both', _OOBJ_DTYPE_CLEAN);
	$plugback = '';
	get_var ('plugback', $plugback, 'both', _OOBJ_DTYPE_CLEAN);
	$auto = 0;
	get_var ('auto', $auto, 'both', _OOBJ_DTYPE_INT);
	if ( ( ($opnConfig['permission']->IsWebmaster () ) && ($auto == 1) ) || ( ($opnConfig['permission']->IsWebmaster () ) && ($auto == 0) ) ) {
		$inst = & new OPN_PluginDeinstaller;
		$inst->SetItemDataSaveToCheck ('fckeditor');
		$inst->SetItemsDataSave (array ('fckeditor') );
		$inst->Module = $module;
		$inst->ModuleName = 'edit_fckeditor';
		$inst->RemoveRights = true;
		$inst->RemoveMiddleboxes = true;
		$inst->MetaSiteTags = true;
		$inst->DeinstallPlugin ();
	}
	if ($auto == 0) {
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
								'fct' => 'plugins',
								'plugback' => $plugback),
								false) );
		CloseTheOpnDB ($opnConfig);
	}

}

/**
* @return void
* @desc Plugin Install Part
*/

function edit_fckeditor_DoInstall () {

	global $opnConfig, $opnTables;

	function edit_fckeditor_install_dirs ($dir) {

		global $opnConfig;

		$File = & new opnFile;
		$File->make_dir ($opnConfig['datasave']['fckeditor']['path'] . $dir);
		if ($File->ERROR == '') {
			$File->copy_file ($opnConfig['root_path_datasave'] . 'index.html', $opnConfig['datasave']['fckeditor']['path'] . $dir . '/index.html');
			if ($File->ERROR != '') {
				echo $File->ERROR . '<br />';
			}
		} else {
			echo $File->ERROR . '<br />';
		}

	}
	$module = '';
	get_var ('module', $module, 'both', _OOBJ_DTYPE_CLEAN);
	$auto = 0;
	get_var ('auto', $auto, 'both', _OOBJ_DTYPE_INT);
	$plugback = '';
	get_var ('plugback', $plugback, 'both', _OOBJ_DTYPE_CLEAN);
	// Only admins can install plugins
	if ( ( ($opnConfig['permission']->IsWebmaster () ) && ($auto == 1) ) || ( ($opnConfig['permission']->IsWebmaster () ) && ($auto == 0) ) ) {
		$inst = & new OPN_PluginInstaller;
		$inst->SetItemDataSaveToCheck ('fckeditor');
		$inst->SetItemsDataSave (array ('fckeditor') );
		$inst->Module = $module;
		$inst->ModuleName = 'edit_fckeditor';
		$inst->MetaSiteTags = true;
		$opnConfig['permission']->InitPermissions ('modules/edit_fckeditor');
		$inst->Rights = array (_FCK_PERM_LINKBROWSER,
					_FCK_PERM_IMAGEBROWSER);
		$inst->RightsGroup = 'User';
		$inst->InstallPlugin ();
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['user_fck'] . ' SELECT uid, user_debug FROM ' . $opnTables['users']);
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_fck'] . ' SET use_fck=1');
		include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.installer.php');
		edit_fckeditor_install_dirs ('File');
		edit_fckeditor_install_dirs ('Flash');
		edit_fckeditor_install_dirs ('Image');
		edit_fckeditor_install_dirs ('Media');
	}
	if ($auto == 0) {
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
								'fct' => 'plugins',
								'plugback' => $plugback),
								false) );
		CloseTheOpnDB ($opnConfig);
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'doremove':
		edit_fckeditor_DoRemove ();
		break;
	case 'doinstall':
		edit_fckeditor_DoInstall ();
		break;
}

?>