<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/egallery/admin/gallery/language/');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.file.php');
$File = & new opnFile;
// UNITE DE TAILLE DES FICHIER (octets "o", bytes "b")
// (Unit of file size, "o" or "b")
$size_unit = 'o';
// Police des caractres (letters span)
$span = 'normaltext';
$max_caracteres = 80;
// -----------------------------------------------------------------------------------------------------------------------------------------
// FUNCTIONS
// -----------------------------------------------------------------------------------------------------------------------------------------

function slash () {

	global $racine;
	if (preg_match ("/\\\\/", $racine) ) {
		$slash = "\\";
	} else {
		$slash = '/';
	}
	return $slash;

}

function traite_nom_fichier ($nom) {

	global $max_caracteres;

	$nom = stripslashes ($nom);
	$nom = str_replace ("'", "", $nom);
	$nom = str_replace ("\"", "", $nom);
	$nom = str_replace ("&", "", $nom);
	$nom = str_replace (",", "", $nom);
	$nom = str_replace (";", "", $nom);
	$nom = str_replace ("/", "", $nom);
	$nom = str_replace ("\\", "", $nom);
	$nom = str_replace ("`", "", $nom);
	$nom = str_replace ("<", "", $nom);
	$nom = str_replace (">", "", $nom);
	$nom = str_replace ("_", "", $nom);
	$nom = str_replace ("-", "", $nom);
	$nom = str_replace (" ", "", $nom);
	$nom = str_replace ("%", "", $nom);
	$nom = str_replace ("?", "", $nom);
	$nom = str_replace (":", "", $nom);
	$nom = str_replace ("*", "", $nom);
	$nom = str_replace ("|", "", $nom);
	$nom = str_replace ("?", "", $nom);
	$nom = str_replace ("", "e", $nom);
	$nom = str_replace ("", "e", $nom);
	$nom = str_replace ("", "c", $nom);
	$nom = str_replace ("@", "", $nom);
	$nom = str_replace ("", "a", $nom);
	$nom = str_replace ("", "e", $nom);
	$nom = str_replace ("", "i", $nom);
	$nom = str_replace ("", "o", $nom);
	$nom = str_replace ("", "u", $nom);
	$nom = str_replace ("", "u", $nom);
	$nom = str_replace ("", "a", $nom);
	$nom = str_replace ("!", "", $nom);
	$nom = str_replace ("", "", $nom);
	$nom = str_replace ("+", "", $nom);
	$nom = str_replace ("^", "", $nom);
	$nom = str_replace ("(", "", $nom);
	$nom = str_replace (")", "", $nom);
	$nom = str_replace ("#", "", $nom);
	$nom = str_replace ("=", "", $nom);
	$nom = str_replace ("$", "", $nom);
	$nom = str_replace ("%", "", $nom);
	$nom = str_replace ('', 'ae', $nom);
	$nom = str_replace ('', 'Ae', $nom);
	$nom = str_replace ('', 'oe', $nom);
	$nom = str_replace ('', 'Oe', $nom);
	$nom = str_replace ('', 'ue', $nom);
	$nom = str_replace ('', 'Ue', $nom);
	$nom = str_replace ('', 'ss', $nom);
	if (strlen ($nom)>$max_caracteres) {
		$ext = substr ($nom, (strrpos ($nom, '.')+1) );
		$nom = substr ($nom, 0, $max_caracteres-4);
		$nom = $nom . '.' . $ext;
	}
	return $nom;

}

function makeDir ($rep, $dirname, $nothumb = false) {

	global $File;
	if (!$File->make_dir ("$rep/$dirname") ) {
		return sprintf (_EGALLERY_GALCATCREATERROR, $File->ERROR);
	}

	/* cause we created the dir successfull, now let us also create the thumb dir */
	if (!$nothumb) {
		if (!$File->make_dir ("$rep/$dirname/thumb") ) {
			return sprintf (_EGALLERY_GALCATCREATERROR, $File->ERROR);
		}
		return 'OK';
	}
	return 'ERROR';

}

function copyFile ($from, $to) {

	global $File;
	if (!$File->copy_file ($from, $to) ) {
		return sprintf (_EGALLERY_GALCOPYFILEERROR, $File->ERROR);
	}
	return 'OK';

}

function checkDir ($rep, $dirname, $gallpicturename) {

	global $File;

	$status = array ();
	if (!file_exists ($rep . '/' . $dirname . '/thumb') ) {
		if (!$File->make_dir ($rep . '/' . $dirname . '/thumb') ) {
			$status['thumbdir'] = 'FALSE';
		} else {
			$status['thumbdir'] = 'OK';
		}
	} else {
		$status['thumbdir'] = 'OK';
	}
	$iuserfile = _OPN_ROOT_PATH . 'modules/egallery/images/index.html';
	$iuserfile_name = 'index.html';
	$icres = copyFile ($iuserfile, "$rep/$dirname/$iuserfile_name");
	if ($icres == 'OK') {
		$status['copindex'] = 'OK';
	} else {
		$status['copindex'] = 'FALSE';
	}
	$icres = copyFile ($iuserfile, "$rep/$dirname/thumb/$iuserfile_name");
	if ($icres == 'OK') {
		$status['copindexthumb'] = 'OK';
	} else {
		$status['copindexthumb'] = 'FALSE';
	}
	$userfile = _OPN_ROOT_PATH . 'modules/egallery/images/' . $gallpicturename;
	$userfile_name = $gallpicturename;
	$cres = copyFile ($userfile, "$rep/$dirname/$userfile_name");
	if ($cres == 'OK') {
		$status['copcatpic'] = 'OK';
	} else {
		$status['copcatpic'] = 'FALSE';
	}
	return $status;

}
// -----------------------------------------------------------------------------------------------------------------------------------------
// UPLOAD
// -----------------------------------------------------------------------------------------------------------------------------------------

function UploadFile ($rep, &$userfile) {

	global $opnConfig;
	// just testing
	get_var ('userfile', $userfile, 'file');
	require (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.fileupload.php');
	$upload = & new file_upload_class ();
	if ($opnConfig['egallery_maxSize']) {
		$upload->max_filesize ($opnConfig['egallery_maxSize']);
	} else {
		$upload->max_filesize ($userfile['size']);
	}
	if ($upload->upload ('userfile', '', '') ) {

		/* HIER */
		if ($upload->save_file ($rep . '/', 3) ) {
			$file = $upload->new_file;
			$filename = $upload->file['name'];
			$userfile['name'] = $filename;
		}
	}
	if (count ($upload->errors) ) {
		$problem = '';
		foreach ($upload->errors as $var) {
			$problem .= '<p>' . $var . '<br />';
		}
		return $problem;
	}
	return 'OK';

}

function copydir ($source, $destination) {

	global $opnTables, $opnConfig, $File;

	$fh = opendir ($source);
	if (!file_exists ($destination) ) {
		$File->make_dir ($destination, fileperms ($source) );
	}
	$total = 0;
	while ($file = readdir ($fh) ) {
		if ($file != '.' && $file != '..') {
			if (is_dir ($source . '/' . $file) ) {
				$total += copydir ("$source/$file", "$destination/$file");
				$newgalloc = substr ($destination, strlen ($opnConfig['datasave']['egallery']['path']) );
				$oldgalloc = substr ($source, strlen ($opnConfig['datasave']['egallery']['path']) );
				$galloc = $opnConfig['opnSQL']->qstr ($newgalloc . '/' . $file, 'galloc');
				$opnConfig['database']->Execute ('UPDATE ' . $opnTables['gallery_categories'] . " SET galloc=$galloc WHERE galloc='$oldgalloc/$file'");
				$opnConfig['opnSQL']->UpdateBlobs ($opnTables['gallery_categories'], "galloc='$oldgalloc/$file'");
			} else {
				$File->copy_file ("$source/$file", "$destination/$file");
				$total++;
			}
		}
	}
	return $total;

}

function rdel ($path, $gallid = '') {

	global $opnTables, $opnConfig, $File;
	if ($path[strlen ($path)-1] != '/') {
		$path .= '/';
	}
	if (is_dir ($path) ) {
		$d = opendir ($path);
		while ($f = readdir ($d) ) {
			if ($f != '.' && $f != '..') {
				$rf = $path . $f;
				if (is_dir ($rf) ) {
					if ($gallid == '') {
						$galloc = substr ($rf, strlen ($opnConfig['datasave']['egallery']['path']) );
						$_galloc = $opnConfig['opnSQL']->qstr ($galloc);
						$egrdelresult = &$opnConfig['database']->Execute ('SELECT gallid FROM ' . $opnTables['gallery_categories'] . " WHERE galloc=$_galloc");
						$gallid = $egrdelresult->fields['gallid'];
						$egrdelresult->Close ();
					}
					if ($gallid != '') {
						$result = &$opnConfig['database']->Execute ('SELECT pid FROM ' . $opnTables['gallery_pictures'] . ' WHERE gid=' . $gallid);
						if (!$result === false) {
							while (! $result->EOF) {
								$pid = $result->fields['pid'];
								$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['gallery_comments'] . ' WHERE pid=' . $pid);
								$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['gallery_rate_check'] . ' WHERE pid=' . $pid);
								$result->MoveNext ();
							}
							// while
							$result->Close ();
						}
						$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['gallery_pictures'] . ' WHERE gid=' . $gallid);
						$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['gallery_pictures_new'] . ' WHERE gid=' . $gallid);
						$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['gallery_categories'] . ' WHERE gallid=' . $gallid);
					}
					rdel ($rf);
				} else
				if (!$File->delete_file ($rf) ) {
					echo $rf . ' = ' . $File->ERROR;
				}
			}
		}
		closedir ($d);
		return $File->rm_dir ($path);
	}
	return '';

}

?>