<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function getPos (&$res, $pid) {

	$i = 0;
	while (! $res->EOF) {
		$row = $res->GetRowAssoc ('0');
		if ($row['pid'] == $pid) {
			return $i;
		}
		$i++;
		$res->MoveNext ();
	}
	return $i;

}

function navigationPic ($gid, $pid, $orderby) {

	global $opnTables, $opnConfig;

	$orderbyA = convertorderbyingally ($orderby);
	$egsql = 'SELECT pid, name FROM ' . $opnTables['gallery_pictures'] . ' WHERE gid=' . $gid . ' ORDER BY ' . $orderbyA;
	$egngpres = &$opnConfig['database']->Execute ($egsql);
	$max = $egngpres->RecordCount ();
	$ind = getPos ($egngpres, $pid);
	$egngpres = &$opnConfig['database']->Execute ($egsql);
	$r = $egngpres->GetArray ();
	$egngpres->Close ();
	$pname = '';
	$nname = '';
	if ($ind>0) {
		$prev = $r[$ind-1]['pid'];
		$pname = $r[$ind-1]['name'];
	}
	if ($ind<$max-1) {
		$next = $r[$ind+1]['pid'];
		$nname = $r[$ind+1]['name'];
	}
	$out = '<div align="center">';
	$out .= '<span class="smalltext">' . $pname . ' </span><span class="normaltext">&lt;&lt; </span>';
	if (isset ($prev) ) {
		$out .= '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
									'op' => 'showpic',
									'gid' => $gid,
									'pid' => $prev,
									'orderby' => $orderby) ) . '">' . _EGALLERY_GALPREV . '</a><span class="normaltext"> | </span>';
	} else {
		$out .= '<span class="normaltext">' . _EGALLERY_GALPREV . '  | </span>';
	}
	if (isset ($next) ) {
		$out .= '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
									'op' => 'showpic',
									'gid' => $gid,
									'pid' => $next,
									'orderby' => $orderby) ) . '">' . _EGALLERY_GALNEXT . '</a>';
	} else {
		$out .= '<span class="normaltext">' . _EGALLERY_GALNEXT . " </span>";
	}
	$out .= '<span class="normaltext"> &gt;&gt;</span><span class="smalltext"> ' . $nname . '</span>';
	$out .= '</div>';
	return $out;

}

function displayPicturePic ($row, $size) {

	global $opnConfig;

	$template = $row['displaytag'];
	$template = str_replace ('<:FILENAME:>', $opnConfig['datasave']['egallery']['url'] . '/' . $row['galloc'] . '/' . $row['img'], $template);
	$template = str_replace ('<:WIDTH:>', $size[0], $template);
	$template = str_replace ('<:HEIGHT:>', $size[1], $template);
	$template = str_replace ('<:DESCRIPTION:>', $row['description'], $template);
	return $template;

}

function displayDescriptionPic ($row) {
	if ($row['description'] != '') {
		$table = & new opn_TableClass ('default');
		$table->AddCols (array (strlen (_EGALLERY_GALDESCRIPTION) ) );
		$table->AddOpenRow ();
		$table->AddDataCol (_EGALLERY_GALDESCRIPTION, 'left', '', 'top');
		$table->AddDataCol ($row['description'], 'left', '', 'top');
		$table->AddCloseRow ();
		$hlp = '';
		$table->GetTable ($hlp);
		return $hlp;
	}
	return '';

}

function displaySizePic ($row, $size) {
	return '<span class="normaltextbold">' . underscoreTospace ($row['name']) . '</span><br /><span class="normaltext">[' . $size[0] . ' x ' . $size[1] . ' ' . substr ($row['img'], strrpos ($row['img'], '.')+1) . ']</span>';

}

function displayDateAddedPic ($row) {

	global $opnConfig;

	$opnConfig['opndate']->sqlToopnData ($row['unix_time']);
	$temp = '';
	$opnConfig['opndate']->formatTimestamp ($temp, _EGALLERY_GALDATEBRIEF);
	return '<div><span class="smalltext">' . _EGALLERY_GALADDED . ' ' . $temp . '</span></div>';

}

function displaySubmitterPic ($row) {

	global $opnTables, $opnConfig;

	$sql = 'SELECT COUNT(u.uid) AS counter FROM ' . $opnTables['users'] . ' u ' . ' LEFT JOIN ' . $opnTables['users_status'] . ' us ON u.uid=us.uid' . ' WHERE uname=' . $opnConfig['opnSQL']->qstr ($row['submitter']) . ' AND' . ' (us.level1<>' . _PERM_USER_STATUS_DELETE . ')';
	$egdspresult = &$opnConfig['database']->Execute ($sql);
	if ( (isset ($egdspresult->fields['counter']) ) && ($egdspresult->fields['counter']>0) ) {
		$row['submitter'] = '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
								'op' => 'userinfo',
								'uname' => $row['submitter']) ) . '" target="_blank">' . $row['submitter'] . '</a>';
	}
	return '<div><span class="smalltext">' . _EGALLERY_GALSUBMITTER . ' ' . $row['submitter'] . '</span></div>';

}

function displayHitsPic ($row) {
	return '<div><span class="smalltext">' . _EGALLERY_GALHITS . ' ' . $row['counter'] . '</span></div>';

}

function displayRatePic ($row) {

	global $opnConfig;
	if (!$opnConfig['permission']->HasRight ('modules/egallery', _EGALLERY_PERM_ALLOWRATING, true) ) {
		return '';
	}
	return '<div><span class="smalltext">' . _EGALLERY_GALVOTES . ' ' . $row['votes'] . '</span><br />' . '<span class="smalltext">' . _EGALLERY_GALRATING . ' ' . $row['rate'] . '</span>' . '</div>';

}

function displayRatingBarPic ($row, $orderby) {

	global $opnConfig;
	if (!$opnConfig['permission']->HasRight ('modules/egallery', _EGALLERY_PERM_ALLOWRATING, true) ) {
		return '';
	}
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_EGALLERY_440_', 'egallery');
	$form->Init (encodeurl ($opnConfig['opn_url'] . '/modules/egallery/index.php?op=Vote', false) );
	$form->AddHidden ('pid', $row['pid']);
	$form->AddHidden ('orderby', $orderby);
	$options = array ();
	for ($i = 1; $i<11; $i++) {
		$options[$i] = $i;
	}
	$form->AddSelect ('rate', $options, 10);
	$form->AddImage ('rateb', $opnConfig['opn_url'] . '/modules/egallery/images/rate.jpg');
	$form->AddFormEnd ();
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function displayCommentsPic ($pid, $orderby) {

	global $opnTables, $opnConfig;

	$out = '';
	if ($opnConfig['permission']->HasRight ('modules/egallery', _EGALLERY_PERM_ALLOWRATING, true) ) {
		$out .= '<br /><div align="center" class="normaltextbold">' . _EGALLERY_GALCOMMPOST . '</div><br />';
		$egdcpresult3 = &$opnConfig['database']->Execute ('SELECT cid, comment, wdate, name, member FROM ' . $opnTables['gallery_comments'] . ' WHERE pid=' . $pid . ' ORDER BY wdate ASC');
		if ($egdcpresult3->RecordCount () == 0) {
			$out .= '<div align="center" class="normaltext">' . _EGALLERY_GALNOCOMM . '</div><br />';
		} else {
			$table = & new opn_TableClass ('default');
			$table->AddCols (array ('140', '', '30') );
			$date = '';
			while (! $egdcpresult3->EOF) {
				$cid = $egdcpresult3->fields['cid'];
				$comment = $egdcpresult3->fields['comment'];
				$opnConfig['opndate']->sqlToopnData ($egdcpresult3->fields['wdate']);
				$opnConfig['opndate']->formatTimestamp ($date, _DATE_DATESTRING5);
				$name = $egdcpresult3->fields['name'];
				$member = $egdcpresult3->fields['member'];
				if ($member) {
					$poster = '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
												'op' => 'userinfo',
												'uname' => $name) ) . '">' . underscoreTospace ($name) . '</a>';
				} else {
					$poster = '<span class="normaltext">' . underscoreTospace ($name) . '</span>';
				}
				$table->AddOpenRow ();
				$table->AddDataCol ($poster . '<br /><span class="smalltext">' . $date . '</span>', 'center', '', 'top');
				$table->AddDataCol ($comment, 'left', '', 'top');
				$hlp = '';
				if ($opnConfig['permission']->HasRights ('modules/egallery', array (_PERM_ADMIN, _EGALLERY_PERM_ADMINEDITCOMMENT), true) ) {
					$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/egallery' . '/index.php',
												'op' => 'editcomment',
												'cid' => $cid,
												'pid' => $pid,
												'orderby' => $orderby), 'opncenterbox' );
				}
				if ($opnConfig['permission']->HasRights ('modules/egallery', array (_PERM_ADMIN, _EGALLERY_PERM_ADMINDELETECOMMENT), true) ) {
					$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery' . '/index.php',
												'op' => 'deletecomment',
												'cid' => $cid,
												'pid' => $pid,
												'orderby' => $orderby) ) . '" onclick="return confirm(\'' . _EGALLERY_GALSURE2DELETECOMMENT . '\')">' . '<img src="' . $opnConfig['opn_default_images'] . 'del.gif" class="imgtag" alt="' . _EGALLERY_GALDELETE . '" title="' . _EGALLERY_GALDELETE . '" /></a>';
				}
				if ($hlp == '') {
					$hlp = '&nbsp;';
				}
				$table->AddDataCol ($hlp, 'center');
				$table->AddCloseRow ();
				$egdcpresult3->MoveNext ();
			}
			// while
			$table->GetTable ($out);
		}
		$egdcpresult3->Close ();
		$out .= '<br /><br />';
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_EGALLERY_450_', 'egallery');
		$form->Init ($opnConfig['opn_url'] . '/modules/egallery/index.php');
		$form->AddText ('<div class="centertag">');
		$form->AddHidden ('op', 'Post');
		$form->AddText ('<span class="normaltextbold">' . _EGALLERY_GALNAME . '</span>');
		if ($opnConfig['permission']->IsUser () ) {
			$userdata = $opnConfig['permission']->GetUserinfo ();
			$form->AddText ('&nbsp;<span class="normaltext">' . $userdata['uname'] . '</span>');
			$form->AddHidden ('gname', $userdata['uname']);
			$form->AddHidden ('member', 1);
		} else {
			$form->AddTextfield ('gname', 20, 20);
			$form->AddHidden ('member', 0);
		}
		$form->AddNewline ();
		$form->AddText ('<br /><span class="normaltextbold">' . _EGALLERY_GALCOMMENT . '</span><br />');
		$form->AddTextfield ('comment', 70, 500);
		$form->AddHidden ('pid', $pid);
		$form->AddSubmit ('submity', _EGALLERY_GALSAVE);
		$form->AddText ('</div>');
		$form->AddNewline ();
		$form->AddFormEnd ();
		$form->GetFormular ($out);
		$out .= '<span class="smalltext">' . _EGALLERY_GALNOTE . '</span>';
	}
	// AllowComments
	return $out;

}

function rateCollector () {

	global $opnTables, $opnConfig, $cookiePrefix;

	$pid = 0;
	get_var ('pid', $pid, 'form', _OOBJ_DTYPE_INT);
	$rate = 0;
	get_var ('rate', $rate, 'form', _OOBJ_DTYPE_INT);
	// Fix for lamers that like to cheat on polls
	$ip1 = get_real_IP ();
	$opnConfig['opndate']->setTimestamp ('0000-00-00 00:30:00');
	$past = '';
	$opnConfig['opndate']->opnDataTosql ($past);
	$opnConfig['opndate']->now ();
	$temp = '';
	$opnConfig['opndate']->opnDataTosql ($temp);
	$past = $temp- $past;
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['gallery_rate_check'] . ' WHERE wtime<' . $past);
	$egrcresult = &$opnConfig['database']->Execute ('SELECT ip, pid FROM ' . $opnTables['gallery_rate_check'] . ' WHERE pid=' . $pid);
	$ips = $egrcresult->fields['ip'];
	$pids = $egrcresult->fields['pid'];
	$egrcresult->Close ();
	$opnConfig['opndate']->now ();
	$ctime = '';
	$opnConfig['opndate']->opnDataTosql ($ctime);
	if ( ($ip1 == $ips) && ($pid == $pids) ) {
		$voteValid = 0;
	} else {
		$_ip1 = $opnConfig['opnSQL']->qstr ($ip1);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['gallery_rate_check'] . " (ip, wtime, pid) VALUES ($_ip1, $ctime, $pid)");
		$voteValid = 1;
	}
	// Fix end
	if ($opnConfig['egallery_setRateCookies']>0) {
		// we have to check for cookies, so get timestamp of this rate
		$egrcresult = &$opnConfig['database']->Execute ('SELECT wdate FROM ' . $opnTables['gallery_pictures'] . ' WHERE pid=' . $pid);
		$opnConfig['opndate']->sqlToopnData ($egrcresult->fields['wdate']);
		$egrcresult->Close ();
		$timeStamp = '';
		$opnConfig['opndate']->formatTimestamp ($timeStamp, _DATE_DATESTRING5);
		$cookieName = $cookiePrefix . $timeStamp;
		// check if cookie exists
		$cookie = '';
		get_var ($cookieName, $cookie, 'cookie', _OOBJ_DTYPE_CLEAN);
		if ($cookie == '1') {
			// cookie exists, invalidate this vote
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_EGALLERY_460_';
			$_display_dat['module'] = 'modules/egallery';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (_EGALLERY_GAL, _EGALLERY_GALALREADYVOTED, _EGALLERY_GALFOOTER);
			// You already voted today!
			$voteValid = 0;
		} else {
			// cookie does not exist yet, set one now
			$cvalue = 1;
			$opnConfig['opnOption']['opnsession']->setopncookie ("$cookieName", $cvalue, time ()+86400);
		}
	}
	// update database if the vote is valid
	if ($voteValid>0) {
		$egsql = 'UPDATE ' . $opnTables['gallery_pictures'] . ' SET rate=((rate*votes) + ' . $rate . ')/(votes+1), votes=votes+1 WHERE pid=' . $pid;
		$opnConfig['database']->Execute ($egsql);
	}
	// a lot of browsers can't handle it if there's an empty page
	// $_display_dat = array();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_EGALLERY_470_';
	$_display_dat['module'] = 'modules/egallery';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_EGALLERY_GAL, _EGALLERY_GALNOTHING, _EGALLERY_GALFOOTER);

}

function showpic () {

	global $opnConfig, $opnTables;

	$pid = 0;
	get_var ('pid', $pid, 'both', _OOBJ_DTYPE_INT);
	$orderby = '';
	get_var ('orderby', $orderby, 'both', _OOBJ_DTYPE_CLEAN);
	if ($orderby == '') {
		$orderby = $opnConfig['egallery_defaultsortmedia'];
	}
	$egspresult = &$opnConfig['database']->Execute ('SELECT p.pid AS pid, p.gid AS gid, p.img AS img, p.counter AS counter, p.submitter AS submitter, p.wdate AS wdate, p.name AS name, p.description AS description, p.votes AS votes, p.rate AS rate, p.extension AS extension, p.width AS width, p.height AS height, p.wdate AS unix_time, c.galloc AS galloc, c.visible AS visible, t.templatepictures AS templatePictures, t.templatecss AS templateCSS, f.displaytag AS displaytag, f.filetype AS filetype, f.description AS description_media FROM ' . $opnTables['gallery_pictures'] . " p LEFT JOIN " . $opnTables['gallery_categories'] . " c ON c.gallid=p.gid LEFT JOIN " . $opnTables['gallery_template_types'] . " t ON t.id=c.template LEFT JOIN " . $opnTables['gallery_media_types'] . ' f ON f.extension=p.extension WHERE pid=' . $pid);
	$prow = $egspresult->GetRowAssoc ('0');
	$egspresult->Close ();
	$ok = 0;
	switch ($prow['visible']) {
		case 0:
			if ($opnConfig['permission']->HasRight ('modules/egallery', _PERM_ADMIN, true) ) {
				$ok = 1;
			}
			break;
		case 1:
			if ($opnConfig['permission']->IsUser () || $opnConfig['permission']->HasRight ('modules/egallery', _PERM_ADMIN, true) ) {
				$ok = 1;
			}
			break;
		default:
			$ok = 1;
			break;
	}
	if ($ok) {
		$boxtxt = '<br /><br />' . navigationGall () . '<br /><br />';
		if ($prow['filetype'] == 1) {
			$size = @getimagesize ($opnConfig['datasave']['egallery']['path'] . $prow['galloc'] . '/' . $prow['img']);
		} else {
			$size[0] = $prow['width'];
			$size[1] = $prow['height'];
			$size[2] = $prow['description_media'];
			$size[3] = 'width="' . $size[0] . '" height="' . $size[1] . '"';
		}
		$navtree = navigationTree ($prow['gid'], $prow['pid']);
		$navpic = navigationPic ($prow['gid'], $prow['pid'], $orderby);
		$iname = displaySizePic ($prow, $size);
		$img = displayPicturePic ($prow, $size);
		$date = displayDateAddedPic ($prow);
		$submitter = displaySubmitterPic ($prow);
		$hits = displayHitsPic ($prow);
		$rate = displayRatePic ($prow);
		$ratingbar = displayRatingBarPic ($prow, $orderby);
		$description = displayDescriptionPic ($prow);
		$comments = displayCommentsPic ($prow['pid'], $orderby);
		$postcard = '';
		if ($opnConfig['permission']->HasRight ('modules/egallery', _EGALLERY_PERM_ALLOWECARDS, true) ) {
			$temp = parse_url ($opnConfig['datasave']['egallery']['url']);
			$temp = $temp['path'] . '/';
			if ($prow['filetype'] == 1) {
				$postcard = '<a class="normaltext" href="' . $opnConfig['egallery_postscardpath'] . '?image=' . $temp . $prow['galloc'] . '/' . $prow['img'] . '" target="_blank">' . '<img src="' . $opnConfig['opn_url'] . '/modules/egallery/images/mailcard.gif" class="imgtag" align="middle" alt="' . _EGALLERY_GALPOSTCARD . '" /></a>' . '<a class="normaltext" href="' . $opnConfig['egallery_postscardpath'] . '?image=' . $temp . $prow['galloc'] . '/' . $prow['img'] . '" target="_blank">' . _EGALLERY_GALPOSTCARD . '</a>';
			}
		}
		if ($opnConfig['permission']->HasRight ('modules/egallery', _EGALLERY_PERM_PRINTPICTURE, true) ) {
			$target = 0;
			// No Margin Pop Up Window Version 1.0 : Credits to Dodo : http://www.regretless.com
			$dir = $opnConfig['datasave']['egallery']['url'] . '/' . $prow['galloc'] . '/';
			// the directory WHERE your image's at with "/" at the end, leave it 					 // blank if you are calling the image from the same directory
			$pic = $prow['img'];
			// your image file name
			$width = $prow['width'];
			// image width
			$height = $prow['height'];
			// image height
			$target++;
			// leave this alone
			$nmdir = $opnConfig['opn_url'] . '/modules/egallery/public/';
			// the directory WHERE your nmimage.php's at with "/" at the end
			// leave it blank if you are calling the image from the same directory
			$print = '<a href="#" onmouseover="window.status=\'pop up\';return true" onmouseout="window.status=\'\';return true" onclick="NewWindow(\'' . encodeurl ($nmdir . 'nmimage.php?', true, true, array ('z' => $dir . $pic,
																											'width' => $width,
																											'height' => $height,
																											false) ) . '\',\'brow' . $target . '\',' . $width . ',' . $height . ');return false">' . _OPN_HTML_NL;
			$print .= '<img src="' . $opnConfig['opn_default_images'] . 'print.gif" class="imgtag" align="middle" alt="' . _EGALLERY_GALPRINTMEDIA . '" /> ' . _OPN_HTML_NL . _EGALLERY_GALPRINTMEDIA . ' </a>' . _OPN_HTML_NL;
		} else {
			$print = '';
		}
		$download = '';
		if ( ($opnConfig['permission']->HasRight ('modules/egallery', _EGALLERY_PERM_DOWNLOADPICTURE, true) ) && ($opnConfig['egallery_downloadswitch'] != '0') ) {
			$thefile = substr ($prow['img'], 0, strrpos ($prow['img'], '.') );
			if ($opnConfig['egallery_downloadmode'] == 'zip') {
				$thefile .= '.zip';
			} elseif ($opnConfig['egallery_downloadmode'] == 'gz') {
				$thefile = $prow['img'] . '.gz';
			} elseif ($opnConfig['egallery_downloadmode'] == 'rar') {
				$thefile .= '.rar';
			}
			if ( ($opnConfig['egallery_downloadswitch'] == '1') || ($opnConfig['egallery_downloadswitch'] == '2') && file_exists ($opnConfig['datasave']['egallery']['path'] . $prow['galloc'] . '/' . $thefile) ) {
				$download = '<a class="normaltext" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/egallery/index.php?op=getit&url=' . $prow['galloc'] . '/' . $thefile . '&filename=' . $thefile) . '">' . '<img src="' . $opnConfig['opn_url'] . '/modules/egallery/images' . '/hit.gif" border="0" align="middle" alt="' . _EGALLERY_GALDOWNLOADMEDIA . '" /> ' . _EGALLERY_GALDOWNLOADMEDIA . '</a>';
			}
		}
		$template = $prow['templatepictures'];
		$template = str_replace ('<:IMAGE:>', $img, $template);
		$template = str_replace ('<:DESCRIPTION:>', $description, $template);
		$template = str_replace ('<:RATE:>', $rate, $template);
		$template = str_replace ('<:RATINGBAR:>', $ratingbar, $template);
		$template = str_replace ('<:SUBMITTER:>', $submitter, $template);
		$template = str_replace ('<:NAMESIZE:>', $iname, $template);
		$template = str_replace ('<:COMMENTS:>', $comments, $template);
		$template = str_replace ('<:HITS:>', $hits, $template);
		$template = str_replace ('<:DATE:>', $date, $template);
		// raw data
		$template = str_replace ('<:RAWIMAGE:>', $prow['img'], $template);
		$template = str_replace ('<:RAWIMAGESIZE:>', $size[3], $template);
		$template = str_replace ('<:RAWIMAGEWIDTH:>', $size[0], $template);
		$template = str_replace ('<:RAWIMAGEHEIGHT:>', $size[1], $template);
		$template = str_replace ('<:RAWDESCRIPTION:>', $prow['description'], $template);
		$template = str_replace ('<:RAWRATE:>', $prow['rate'], $template);
		$template = str_replace ('<:RAWVOTES:>', $prow['votes'], $template);
		$template = str_replace ('<:RAWSUBMITTER:>', $prow['submitter'], $template);
		$template = str_replace ('<:RAWNAME:>', $prow['name'], $template);
		$template = str_replace ('<:RAWHITS:>', $prow['counter'], $template);
		$template = str_replace ('<:RAWDATEBRIEF:>', strftime (_EGALLERY_GALBRIEFDATE, $prow['unix_time']), $template);
		$template = str_replace ('<:POSTCARD:>', $postcard, $template);
		$template = str_replace ('<:PRINT:>', $print, $template);
		$template = str_replace ('<:DOWNLOAD:>', $download, $template);
		$boxtxt .= $navtree;
		$boxtxt .= $navpic . ' ' . $template;
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_EGALLERY_480_';
		$_display_dat['module'] = 'modules/egallery';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_EGALLERY_GAL, $boxtxt, _EGALLERY_GALFOOTER);
	}

}

?>