<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

/*because there are several new settings, let's pre-initalize them, if the webmaster
* hasn't done yet
*/
if (!function_exists ('faq_repair_setting_plugin') ) {
	include_once (_OPN_ROOT_PATH . 'modules/faq/plugin/repair/setting.php');
}
$presetsettings = faq_repair_setting_plugin ();
global $opnConfig;

foreach ($presetsettings as $settingname => $settingvalue) {
	if (!isset ($opnConfig[$settingname]) ) {
		$opnConfig[$settingname] = $settingvalue;
	}
}

/* end of pre-initialize */

/**
*
* @return object
*/

function faq_initcat () {

	global $opnConfig;

	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorienav.php');
	$faqcat = & new opn_categorienav ('faq', 'faqanswer');
	$faqcat->SetModule ('modules/faq');
	$faqcat->SetImagePath ($opnConfig['datasave']['faq_cat']['url']);
	$faqcat->SetItemID ('id');
	$faqcat->SetItemLink ('id_cat');
	$faqcat->SetColsPerRow ($opnConfig['faq_cats_per_row']);
	$faqcat->SetSubCatLink ('index.php?op=showfaqcat&id_cat=%s');
	$faqcat->SetSubCatLinkVar ('id_cat');
	$faqcat->SetMainpageScript ('index.php');
	$faqcat->SetScriptname ('index.php');
	$faqcat->SetScriptnameVar (array ('op' => 'showfaqcat') );
	$faqcat->SetMainpageTitle (_FAQ_MAIN);
	// $faqcat->SetItemWhere('user_group IN ('.$checkerlist.')');
	return $faqcat;

}

function faq_initmf () {

	global $opnTables;

	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorie.functions.php');
	$mf = & new CatFunctions ('faq');
	$mf->itemtable = $opnTables['faqanswer'];
	$mf->itemid = 'id';
	$mf->itemlink = 'id_cat';
	return $mf;

}

function ShowCompactFaq () {

	global $opnConfig, $opnTables;

	$id_cat = 0;
	get_var ('id_cat', $id_cat, 'url', _OOBJ_DTYPE_INT);
	$categories = '';
	get_var ('categories', $categories, 'url', _OOBJ_DTYPE_CLEAN);
	$boxtxt = '<br />';
	$boxtxt .= '<a href="#FAQHEAD" name="FAQHEAD"></a>';
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$result = &$opnConfig['database']->Execute ('SELECT a.id AS id, a.id_cat AS id_cat, a.question AS question FROM ' . $opnTables['faqanswer'] . ' a, ' . $opnTables['faq_cats'] . ' b WHERE b.cat_id=a.id_cat AND b.cat_usergroup IN (' . $checkerlist . ') ORDER BY a.id_pos');
	if ($result !== false) {
		while (! $result->EOF) {
			$id = $result->fields['id'];
			$id_cat = $result->fields['id_cat'];
			$faqresults[$id_cat][$id]['question'] = $result->fields['question'];
			$result->MoveNext ();
		}
		$result->Close ();
	}
	$faqcat = faq_initcat ();
	$allcategories = $faqcat->GetAllCategories ();
	$levelnames = array ();
	$lastlevel = 0;
	foreach ($allcategories as $category) {
		for ($i = $category['level']; $i<= $lastlevel; $i++) {
			unset ($levelnames[$i]);
		}
		$levelnames[$category['level']]['name'] = $category['name'];
		$levelnames[$category['level']]['catid'] = $category['catid'];
		if (isset ($faqresults[$category['catid']]) ) {
			faq_drawnicecattree ($boxtxt, $levelnames);
			if ($opnConfig['faq_displayaslist'] == 1) {
				$boxtxt .= '<ul>';
			} else {
				$table = & new opn_TableClass ('alternator');
			}
			foreach ($faqresults[$category['catid']] as $faqid => $faqitem) {
				$hlp = '<img src="' . $opnConfig['opn_url'] . '/modules/faq/images/question.gif" class="imgtag" alt="" />';
				$hlp .= '&nbsp;<a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/faq/index.php?', true, true, array ('id_cat' => $category['catid'],
																				'op' => 'showfaqcat'),
																				'#FAQ' . $faqid) . '">' . $faqitem['question'] . '</a>';
				if ($opnConfig['faq_displayaslist'] == 1) {
					$boxtxt .= str_replace ('%alternate%', 'opncenterbox', '<li>' . $hlp . '</li>');
				} else {
					$table->AddDataRow (array ($hlp) );
				}
			}
			if ($opnConfig['faq_displayaslist'] == 1) {
				$boxtxt .= '</ul>';
			} else {
				$table->GetTable ($boxtxt);
			}
			$boxtxt .= '<br />';
			$lastlevel = $category['level'];
		}
	}
	$boxtxt .= '<br />';
	return $boxtxt;

}

function ShowFaqbyResult (&$result, $mark = '', &$boxtxt) {

	global $opnConfig;

	$_poll = & new opn_poll ('faq');
	$_poll->Init_url ('modules/faq/index.php');
	$faqcat = faq_initcat ();
	$mycss = '<style type="text/css">' . _OPN_HTML_NL . '	<!--' . _OPN_HTML_NL . '		.textmarker { background: #FFFFAA; }' . _OPN_HTML_NL . '	-->' . _OPN_HTML_NL . '</style>' . _OPN_HTML_NL;
	$opnConfig['put_to_head']['faqhighlight'] = $mycss;
	$allcategories = $faqcat->GetAllCategories ();
	$faqresults = array ();
	while (! $result->EOF) {
		$id = $result->fields['id'];
		$id_cat = $result->fields['id_cat'];
		$question = $result->fields['question'];
		$answer = $result->fields['answer'];
		if ($mark != '') {
			$opnConfig['cleantext']->hilight_text ($question, $mark, 'textmarker');
			$opnConfig['cleantext']->hilight_text ($answer, $mark, 'textmarker');
		}
		opn_nl2br ($answer);
		$faqresults[$id_cat][$id]['question'] = $question;
		$faqresults[$id_cat][$id]['answer'] = $answer;
		$_poll->Set_CustomId ($id);
		$faqresults[$id_cat][$id]['polltext'] = $_poll->menu_opn_poll ();
		$result->MoveNext ();
	}
	$levelnames = array ();
	$lastlevel = 0;
	foreach ($allcategories as $category) {
		for ($i = $category['level']; $i<= $lastlevel; $i++) {
			unset ($levelnames[$i]);
		}
		$levelnames[$category['level']]['name'] = $category['name'];
		$levelnames[$category['level']]['catid'] = $category['catid'];
		if (isset ($faqresults[$category['catid']]) ) {
			faq_drawnicecattree ($boxtxt, $levelnames);
			if ($opnConfig['faq_displayaslist'] == 1) {
				$boxtxt .= '<ul>';
			}
			foreach ($faqresults[$category['catid']] as $faqid => $faqitem) {
				if ($opnConfig['faq_displayaslist'] == 1) {
					$boxtxt .= '<li><a name="FAQ' . $faqid . '"></a><span class="normaltextbold">' . $faqitem['question'] . '</span><br />';
					$boxtxt .= $faqitem['answer'] . '<br /><a class="%alternate%" href="#FAQHEAD">(' . _FAQ_BACK_TOP . ')</a><br />';
					if ($faqitem['polltext'] != '') {
						$boxtxt .= '<br />' . $faqitem['polltext'];
					}
					$boxtxt .= '<br /></li>';
				} else {
					$table = & new opn_TableClass ('alternator');
					$table->AddHeaderRow (array (' <a name="FAQ' . $faqid . '"></a>' . $faqitem['question']), array ('left') );
					$table->AddDataRow (array ($faqitem['answer']) );
					$hlp = '';
					if ($opnConfig['permission']->HasRight ('modules/faq', _PERM_ADMIN, true) ) {
						$hlp .= '&nbsp;';
						$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/faq/admin/index.php',
													'op' => 'FaqCatGoEdit',
													'id' => $faqid,
													'ok' => '0') );
						$hlp .= '&nbsp;';
						$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/faq/admin/index.php',
													'op' => 'FaqCatGoDel',
													'id' => $faqid,
													'ok' => '0') );
					}
					$table->AddDataRow (array ('<a class="%alternate%" href="#FAQHEAD">(' . _FAQ_BACK_TOP . ')</a>' . $hlp) );
					if ($faqitem['polltext'] != '') {
						$table->AddDataRow (array ($faqitem['polltext']) );
					}
					$table->GetTable ($boxtxt);
				}
			}
			if ($opnConfig['faq_displayaslist'] == 1) {
				$boxtxt .= '</ul>';
			}
			$boxtxt .= '<br />';
			$lastlevel = $category['level'];
		}
	}

}

function display_nav_add_spaces ($counter, &$boxtxt) {

	for ($j = 0; $j< $counter; $j++) {
		$boxtxt .= '&nbsp;&nbsp;&nbsp;&nbsp;';
	}

}

function faq_drawnicecattree (&$boxtxt, $levelnames) {

	global $opnConfig;

	$boxtxt .= '<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/faq/index.php">' . _OPN_HTML_NL . '<img src="' . $opnConfig['opn_url'] . '/modules/faq/images/tree/tree_collapse.gif" width="10" alt="" class="imgtag" /></a> ' . _OPN_HTML_NL . '<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/faq/index.php">' . $opnConfig['sitename'] . '&nbsp;' . _FAQ_DESC . '</a><br />' . _OPN_HTML_NL;
	$counter = 0;
	foreach ($levelnames as $levelname) {
		display_nav_add_spaces ($counter, $boxtxt);
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/faq/index.php',
										'id_cat' => $levelname['catid']) ) . '">' . _OPN_HTML_NL . '<img src="' . $opnConfig['opn_url'] . '/modules/faq/images/tree/tree_endcolapse.gif" width="24" alt="" class="imgtag" /></a> ' . _OPN_HTML_NL . '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/faq/index.php?',
										true,
										true,
										array ('id_cat' => $levelname['catid'],
			'op' => 'showfaqcat') ) . '">' . $levelname['name'] . '</a><br />' . _OPN_HTML_NL;
		$counter++;
	}

}

function ShowFaqCategory () {

	global $opnTables, $opnConfig;

	$id_cat = 0;
	get_var ('id_cat', $id_cat, 'url', _OOBJ_DTYPE_INT);
	if (!$id_cat) {
		$id_cat = 0;
		get_var ('cat_id', $id_cat, 'url', _OOBJ_DTYPE_INT);
	}
	$boxtxt = '';
	if ($opnConfig['faq_displaysearchontop'] == 1) {
		$boxtxt .= faq_buildsearchform ();
	}
	$faqcat = faq_initcat ();
	$boxtxt .= $faqcat->SubNavigation ($id_cat);
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$result = &$opnConfig['database']->Execute ('SELECT a.id AS id, a.id_cat AS id_cat, a.question AS question, a.answer AS answer FROM ' . $opnTables['faqanswer'] . ' a, ' . $opnTables['faq_cats'] . ' b WHERE b.cat_id=a.id_cat AND b.cat_usergroup IN (' . $checkerlist . ') AND a.id_cat=' . $id_cat . ' ORDER BY a.id_pos');
	if ($result !== false) {
		ShowFaqbyResult ($result, '', $boxtxt);
		$result->Close ();
	}
	if ($opnConfig['faq_displaysearchontop'] == 0) {
		$boxtxt .= '<br /><br />';
		$boxtxt .= faq_buildsearchform ();
	}
	return $boxtxt;

}

function faq_buildsearchform ($extended = false) {

	global $opnConfig;

	$faqsearchterm = '';
	get_var ('faqsearchterm', $faqsearchterm, 'form');
	$faqsearchterm = $opnConfig['cleantext']->filter_searchtext ($faqsearchterm);
	set_var ('faqsearchterm', $faqsearchterm, 'form');
	$faqsearchtype = 'and';
	get_var ('faqsearchtype', $faqsearchtype, 'form', _OOBJ_DTYPE_CLEAN);
	$lookupin = $opnConfig['faq_defaultsearchfield'];
	get_var ('faqlookupin', $lookupin, 'form', _OOBJ_DTYPE_INT);
	set_var ('faqlookupin', $lookupin, 'form');
	$id_cat = 0;
	get_var ('id_cat', $id_cat, 'both', _OOBJ_DTYPE_INT);
	$mf = faq_initmf ();
	$form = & new opn_FormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_FAQ_60_', 'searchbox_faq');
	$form->Init ($opnConfig['opn_url'] . '/modules/faq/search.php');
	$form->AddTable ();
	$form->AddCols (array ('45%', '55%') );
	$form->AddOpenRow ();
	$form->SetSameCol ();
	$form->AddLabel ('faqsearchterm', _FAQ_SEARCHFOR . ' ');
	$form->AddTextfield ('faqsearchterm', 40, 0, $faqsearchterm);
	$form->SetEndCol ();
	$form->SetSameCol ();
	$form->AddSubmit ('faqsubmit', _FAQ_SEARCH);
	$form->AddText ('&nbsp;');
	$hascategories = $mf->makeMySelBox ($id_cat, $form, 2, 'id_cat');
	if (!$extended) {
		$form->AddHidden ('faqsearchtype', 'and');
		$form->AddHidden ('faqlookupin', $lookupin);
		$form->SetEndCol ();
		$form->AddCloseRow ();
	} else {
		$form->SetEndCol ();
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddText (_FAQ_MATCH . '&nbsp;');
		if ($faqsearchtype == 'and') {
			$checkand = 1;
			$checkor = 0;
		} else {
			$checkand = 0;
			$checkor = 1;
		}
		$form->AddRadio ('faqsearchtype', 'and', $checkand);
		$form->AddLabel ('faqsearchtype', _FAQ_AND . '&nbsp;', 1);
		$form->AddRadio ('faqsearchtype', 'or', $checkor);
		$form->AddLabel ('faqsearchtype', _FAQ_OR, 1);
		$form->SetEndCol ();
		$form->SetSameCol ();
		$form->AddLabel ('faqlookupin', _FAQ_LOOKUPIN.' ');
		$mylookupin = array (0=>_FAQ_QUESTION.' '._FAQ_AND2.' '._FAQ_ANSWER,
							1=>_FAQ_QUESTION,
							2=>_FAQ_ANSWER);
		$form->AddSelect('faqlookupin', $mylookupin, $lookupin);
		$form->SetEndCol ();
		$form->AddCloseRow ();
	}
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<br />';
	return $boxtxt;

}

function faq_search_result () {

	global $opnConfig, $opnTables;

	$faqsearchterm = '';
	get_var ('faqsearchterm', $faqsearchterm, 'form');
	$faqsearchterm = trim (urldecode ($faqsearchterm) );
	$faqsearchterm = $opnConfig['cleantext']->filter_searchtext ($faqsearchterm);
	set_var ('faqsearchterm', $faqsearchterm, 'form');
	$faqsearchtype = 'and';
	get_var ('faqsearchtype', $faqsearchtype, 'form', _OOBJ_DTYPE_CLEAN);
	$lookupin = $opnConfig['faq_defaultsearchfield'];
	get_var ('faqlookupin', $lookupin, 'form', _OOBJ_DTYPE_INT);
	set_var ('faqlookupin', $lookupin, 'form');
	$id_cat = 0;
	get_var ('id_cat', $id_cat, 'both', _OOBJ_DTYPE_INT);
	$boxtxt = '';
	$addquery = '';
	if ($id_cat>0) {
		$mf = faq_initmf ();
		$childcats = $mf->getChildTreeArray ($id_cat);
		if (count ($childcats)>0) {
			$childcatids = array ($id_cat);
			foreach ($childcats as $childkat) {
				$childcatids[] = intval ($childkat[2]);
			}
			$addquery .= '(a.id_cat IN (' . implode (', ', $childcatids) . ')) AND ';
		} else {
			$addquery .= '(a.id_cat=' . $id_cat . ') AND ';
		}
	}
	if ($opnConfig['faq_displaysearchontop'] == 1) {
		$boxtxt .= faq_buildsearchform (true);
	}
	$addquery .= '( ';
	if($lookupin == 0) {
		$addquery .= '( ';
	}
	$terms = explode (' ', $faqsearchterm);
/* TODO: just for testing right now - will get a setting for this somtimes... - Alex */
	$wordsonly = true;
	$wordsonly = false;
	if ($wordsonly) {
		$queryitems = array('RLIKE', '[[:<:]]', '[[:>:]]');
	} else {
		$queryitems = array('LIKE', '%', '%');
	}

	$size = sizeof ($terms);
	if ($faqsearchtype == 'or') {
		$andor = 'OR';
	} else {
		$andor = 'AND';
	}
	if($lookupin != 1) {
		$like_search = $opnConfig['opnSQL']->AddLike ($terms[0], $queryitems[1], $queryitems[2]);
		$addquery .= ' (a.answer '.$queryitems[0].' ' . $like_search . ' )';
		for ($i = 1; $i< $size; $i++) {
			$like_search = $opnConfig['opnSQL']->AddLike ($terms[$i], $queryitems[1], $queryitems[2]);
			$addquery .= ' ' . $andor . ' (a.answer '.$queryitems[0].' ' . $like_search . ')';
		}
	}
	if($lookupin == 0) {
		$addquery .= ') OR (';
	}
	if($lookupin != 2) {
		$like_search = $opnConfig['opnSQL']->AddLike ($terms[0], $queryitems[1], $queryitems[2]);
		$addquery .= ' (a.question '.$queryitems[0].' ' . $like_search . ' )';
		for ($i = 1; $i< $size; $i++) {
			$like_search = $opnConfig['opnSQL']->AddLike ($terms[$i], $queryitems[1], $queryitems[2]);
			$addquery .= ' ' . $andor . ' (a.question '.$queryitems[0].' ' . $like_search . ')';
		}
	}
	$addquery .= ')';
	if($lookupin == 0) {
		$addquery .= '  )';
	}
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$sql = 'SELECT a.id AS id, a.id_cat AS id_cat, a.question AS question, a.answer AS answer FROM ' . $opnTables['faqanswer'] . ' a, ' . $opnTables['faq_cats'] . ' b WHERE b.cat_id=a.id_cat AND b.cat_usergroup IN (' . $checkerlist . ') AND ';
	$sql .= $addquery . ' ';
	$sql .= ' GROUP BY a.id';
	$result = $opnConfig['database']->Execute ($sql);
	if (is_object ($result) ) {
		$result_count = $result->RecordCount ();
	} else {
		$result_count = 0;
	}
	if ($result_count == 0) {
		$boxtxt .= _FAQ_NOTHINGFOUND;
	} else {
		if ($result !== false) {
			ShowFaqbyResult ($result, $terms, $boxtxt);
			$result->Close ();
		}
	}
	if ($opnConfig['faq_displaysearchontop'] == 0) {
		$boxtxt .= '<br /><br />';
		$boxtxt .= faq_buildsearchform (true);
	}
	return $boxtxt;

}

?>