<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/* based on the e00 class, which generates maps based on arc-info files
* it uses the map class for the image handling
*
* http://jan.kneschke.de/projects/
*/

class e00 extends map {

	function e00 ($x, $y) {

		$this->map ($x, $y);

	}

	/**
	* draws a datafile into the image
	*
	* @param $img image-handler
	* @param $fn  filename of the datafile
	* @param $col color used for drawing
	*/

	function draw ($fn, $col) {
		if ( ($f = fopen ($fn, 'r') ) == false) {
			return false;
		}
		$num_records = 0;
		$ln = 0;
		$pl = array ();
		while (0 || $line = fgets ($f, 1024) ) {
			$ln++;

			# a node definition
			if ( ($num_records == 0) && preg_match ("#^\s+([0-9]+)\s+([-0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)#", $line, $a = '') ) {
				$num_records = $a[7];
				$pl['x'] = -1;
				$pl['y'] = -1;

				# 2 coordinates
			} elseif ($num_records && preg_match ("#^ *([-+]?[0-9]\.[0-9]{7}E[-+][0-9]{2}) *([-+]?[0-9]\.[0-9]{7}E[-+][0-9]{2}) *([-+]?[0-9]\.[0-9]{7}E[-+][0-9]{2}) *([-+]?[0-9]\.[0-9]{7}E[-+][0-9]{2})#", $line, $a = '') ) {
				if ( ($pl['x'] != -1) && ($pl['y'] != -1) ) {
					$this->draw_clipped ($pl['x'], $pl['y'], $a[1], $a[2], $col);
				}
				$num_records--;
				$this->draw_clipped ($a[1], $a[2], $a[3], $a[4], $col);
				$pl['x'] = $a[3];
				$pl['y'] = $a[4];
				$num_records--;

				# 1 coordinate
			} elseif ($num_records && preg_match ("#^ *([-+]?[0-9]\.[0-9]{7}E[-+][0-9]{2}) *([-+]?[0-9]\.[0-9]{7}E[-+][0-9]{2})#", $line, $a = '') ) {
				if ( ($pl['x'] != -1) && ($pl['y'] != -1) ) {
					$this->draw_clipped ($pl['x'], $pl['y'], $a[1], $a[2], $col);
					$pl['x'] = $a[1];
					$pl['y'] = $a[2];
				}
				$num_records--;
			} elseif ($ln>2) {
				break;
			}
		}
		fclose ($f);
		return true;

	}

}

?>