<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function replace_umlauts ($mystring) {

	$table = array ('' => 'ae',
			'' => 'oe',
			'' => 'ue',
			'' => 'ss',
			'' => 'Ae',
			'' => 'Oe',
			'' => 'Ue',
			'' => 'e',
			'' => 'c',
			'' => 'a',
			'' => 'e',
			'' => 'i',
			'' => 'o',
			'' => 'u',
			'' => 'u',
			'' => 'a',
			'' => 'E',
			'' => 'A',
			'' => 'E',
			'' => 'I',
			'' => 'O',
			'' => 'U',
			'' => 'U',
			'' => 'A',
			'' => 'A',
			'' => 'E',
			'' => 'O',
			'' => 'I',
			'' => 'U',
			);
	$string = strtr ($mystring, $table);
	return $string;

}

function build_alphabet () {
	return 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';

}

function build_orderchar ($myword) {

	$alphabet = build_alphabet ();
	$firstchar = strtoupper (substr (replace_umlauts ($myword), 0, 1) );
	$mypos = strpos ($alphabet, $firstchar);
	if ($mypos === false) {
		$myanswer = '-';
	} else {
		$myanswer = $firstchar;
	}
	return $myanswer;

}

function build_categorynames ($mf) {


	$mycats = $mf->composeCatArray ();
	$ret_catid = array ();
	foreach ($mycats as $value) {
		$ret_catid[$value['catid']] = $value['name'];
	}
	return $ret_catid;

}

function build_categoryselect ($options, $mf) {

	global $opnConfig, $opnTables;

	$mycats = $mf->composeCatArray ();
	foreach ($mycats as $v) {
		if ($v['level']>0) {
			$before = str_repeat ('&nbsp;&nbsp;', $v['level']) . '-&gt;&nbsp;';
		} else {
			$before = '';
		}
		$options[$v['catid']] = $before . $v['name'];
	}
	return $options;

}

function build_categorylist ($operation, $withlink = true) {

	global $opnConfig, $opnTables, $mf;

	$mycats = $mf->composeCatArray ();
	$mylist = '';
	foreach ($mycats as $v) {
		if ($v['level']>0) {
			$before = str_repeat ('&nbsp;&nbsp;', $v['level']) . '-&gt;&nbsp;';
		} else {
			$before = '';
		}
		if ($withlink) {
			$mylist .= $before . '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php' . $operation . $v['catid']) . '">' . $v['name'] . '</a><br />' . _OPN_HTML_NL;
		} else {
			$mylist .= $before . $v['name'] . '<br />' . _OPN_HTML_NL;
		}
	}
	return $mylist;

}

function buildMonthSelectGLO () {

	$options = array ();
	for ($i = 1; $i<=12; $i++) {
		$month = sprintf ('%02d', $i);
		$options[$month] = $month;
	}
	return $options;

}

function buildDaySelectGLO () {

	$options = array ();
	for ($i = 1; $i<=31; $i++) {
		$day = sprintf ('%02d', $i);
		$options[$day] = $day;
	}
	return $options;

}

function buildYearSelectGLO () {

	$options = array ();
	for ($i = 2001; $i<=2030; $i++) {
		$year = sprintf ('%04d', $i);
		$options[$year] = $year;
	}
	return $options;

}

function buildHourSelectGLO () {

	$options = array ();
	for ($i = 0; $i<=23; $i++) {
		$hour = sprintf ('%02d', $i);
		$options[$hour] = $hour;
	}
	return $options;

}

function buildMinSelectGLO () {

	$options = array ();
	for ($i = 0; $i<=45; ) {
		if ($i == 0) {
			$i1 = ':00';
		} else {
			$i1 = ':' . $i;
		}
		$options[sprintf ('%02d', $i)] = $i1;
		$i = $i+15;
	}
	return $options;

}

function build_keyphrasearr ($catid, $mf) {

	global $opnConfig;

	$keyphrases = $mf->GetItemResult (array ('keyphrase'),
						array (),
		'catid=' . $catid);
	if (is_object ($keyphrases) ) {
		$defcount = $keyphrases->RecordCount ();
	} else {
		$defcount = 0;
	}
	if ($defcount>0) {
		while (! $keyphrases->EOF) {
			$keyphrase = $keyphrases->fields['keyphrase'];
			$replacestring = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/glossar/index.php',
											'op' => 'listword',
											'word' => htmlentities ($keyphrase),
											'catid' => $catid) ) . '" target="_blank" ' . 'onclick="NewWindow(\'' . encodeurl (array ($opnConfig['opn_url'] . '/modules/glossar/index.php',
														'op' => 'listword',
														'word' => htmlentities ($keyphrase),
														'catid' => $catid) ) . '\',\'glossar\',400,200);return false">' . '&raquo;' . $keyphrase . '</a>';
			$keywords[] = ' ' . $keyphrase . ' ';
			$keyreplace[] = ' ' . $replacestring . ' ';
			$keywords[] = ' ' . $keyphrase . ',';
			$keyreplace[] = ' ' . $replacestring . ',';
			$keywords[] = ' ' . $keyphrase . '.';
			$keyreplace[] = ' ' . $replacestring . '.';
			$keywords[] = ' ' . $keyphrase . ';';
			$keyreplace[] = ' ' . $replacestring . ';';
			$keywords[] = ',' . $keyphrase . ' ';
			$keyreplace[] = ',' . $replacestring . ' ';
			$keywords[] = '.' . $keyphrase . ' ';
			$keyreplace[] = '.' . $replacestring . ' ';
			$keyphrases->MoveNext ();
		}
	}
	$myretarray['keywords'] = $keywords;
	$myretarray['keyreplace'] = $keyreplace;
	return $myretarray;

}
$_keyarr = array ();

function do_glossar ($text, $catid, $notreplace, $mf) {

	global $_keyarr;
	if (!isset ($_keyarr[$catid]) ) {
		$_keyarr[$catid] = build_keyphrasearr ($catid, $mf);
	}
	$keywords = $_keyarr[$catid]['keywords'];
	$keyreplace = $_keyarr[$catid]['keyreplace'];
	if ($notreplace != '') {
		$text = str_replace ($notreplace, '%--__--%', $text);
	}
	$text = str_replace ($keywords, $keyreplace, $text);
	if ($notreplace != '') {
		$text = str_replace ('%--__--%', $notreplace, $text);
	}
	return $text;

}

?>