<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');

function build_letterjump ($catid, $mf) {

	global $opnConfig, $opnTables;
	if ($catid) {
		$mywhere = 'catid=' . $catid;
	} else {
		$mywhere = '';
	}
	$result = $mf->GetItemResult (array ('orderchar'),
					array (),
		$mywhere,
		'i.orderchar');
	if (!$result === false) {
		$temp = '';
		while (! $result->EOF) {
			$temp .= $result->fields['orderchar'];
			$result->MoveNext ();
		}
		$alphabet = build_alphabet () . '-';
		$myletterjump = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/glossar/index.php',
										'op' => 'listletter',
										'letter' => '',
										'catid' => $catid) ) . '">' . _GLO_ALL . '</a>&nbsp;' . _GLO_ORSELECTCHAR . ':&nbsp;&nbsp;';
		$themax = strlen ($alphabet);
		for ($i = 0; $i<=$themax; $i++) {
			$currChar = substr ($alphabet, $i, 1);
			$mypos = strstr ($temp, $currChar);
			if ($currChar == '-') {
				$dispChar = _GLO_OTHER;
			} else {
				$dispChar = $currChar;
			}
			if ($mypos) {
				$myletterjump .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/glossar/index.php',
													'op' => 'listletter',
													'letter' => $currChar,
													'catid' => $catid) ) . '">' . $dispChar . '</a>&nbsp;';
			} else {
				$myletterjump .= $dispChar . '&nbsp;';
			}
		}
	} else {
		$myletterjump = '<span class="alerttext">' . _GLO_EMPTY . '</span>';
	}
	return $myletterjump;

}

function build_wordjump ($text, $catid, $usenewwindow = true) {

	global $opnConfig;
	if ($text) {
		$text = preg_replace ('/[;]+/i', ',', $text);
		$text = preg_replace ('/\s+/i', ' ', $text);
		$text = trim ($text);
		$array = split ('[,]+', $text);
		$mywordjump = '';
		$catjump = array ($opnConfig['opn_url'] . '/modules/glossar/index.php',
				'op' => 'listword');
		if ($catid <> 0) {
			$catjump['catid'] = $catid;
		}
		foreach ($array as $v) {
			if ($v) {
				$catjump['word'] = htmlentities ($v);
				if ($usenewwindow) {
					$mywordjump .= '<a class="%alternate%" href="' . encodeurl ($catjump) . '"' . ' target="_blank" ' . 'onclick="NewWindow(\'' . encodeurl ($catjump) . '\',\'test\',400, 200);return false">' . $v . '</a>, ';
				} else {
					$mywordjump .= '<a class="%alternate%" href="' . encodeurl ($catjump) . '">' . $v . '</a>, ';
				}
			}
		}
		$mywordjump = substr ($mywordjump, 0, strlen ($mywordjump)-2);
	}
	return $mywordjump;

}

function list_word () {

	global $opnConfig, $opnTables, $mf;

	$word = '';
	get_var ('word', $word, 'url', _OOBJ_DTYPE_CLEAN);
	$catid = 0;
	get_var ('catid', $catid, 'url', _OOBJ_DTYPE_INT);
	$_word = $opnConfig['opnSQL']->qstr ($word);
	$rdefinition = $mf->GetItemResult (array ('gloid',
						'catid',
						'keyphrase',
						'definition',
						'seealso',
						'linkto'),
						array (),
		'i.keyphrase=' . $_word . ' AND i.catid=' . $catid);
	$showadmin = $opnConfig['permission']->HasRight ('modules/glossar', _PERM_ADMIN, true);
	if (is_object ($rdefinition) ) {
		$defcount = $rdefinition->RecordCount ();
	} else {
		$defcount = 0;
	}
	$table = & new opn_TableClass ('alternator');
	if ($defcount == 0) {
		$table->AddDataRow (array ($word) );
		$table->AddDataRow (array (_GLO_NODEFINITIONFOUND) );
	} elseif ($defcount>1) {
		$table->AddDataRow (array ($word) );
		$table->AddDataRow (array (_GLO_TOOMANYDEFINITIONSFOUND) );
	} else {
		$gloid = $rdefinition->fields['gloid'];
		$catid = $rdefinition->fields['catid'];
		$keyphrase = $rdefinition->fields['keyphrase'];
		$definitiontext = $rdefinition->fields['definition'];
		$seealso = $rdefinition->fields['seealso'];
		$linkto = $rdefinition->fields['linkto'];
		$table->AddOpenHeadRow ();
		$hlp = $keyphrase;
		if ($showadmin) {
			$hlp .= '&nbsp;[&nbsp;<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php',
												'op' => 'modifydefinition',
												'gloid' => $gloid) ) . '">' . _GLO_EDIT . '</a>&nbsp;|&nbsp;' . '<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php',
																		'op' => 'deletedefinition',
																		'gloid' => $gloid) ) . '">' . _GLO_DELETE . '</a>&nbsp;]';
		}
		$table->AddHeaderCol ($hlp);
		$table->AddCloseRow ();
		if ($definitiontext) {
			$table->AddDataRow (array (do_glossar ($definitiontext, $catid, $word, $mf) ) );
		}
		if ($seealso) {
			$table->AddDataRow (array ('--&gt; <span class="normaltextitalic">' . _GLO_SEEALSO . ':</span> ' . build_wordjump ($seealso, $catid, false) ) );
		}
		if ($linkto) {
			$table->AddDataRow (array ('--&gt; <span class="normaltextitalic">' . _GLO_LINKTO . ':</span> <a class="%alternate%" href="' . $linkto . '" target="_blank">' . $linkto . '</a>') );
		}
	}
	$table->AddDataRow (array ('<a class="%alternate%" href="' . $opnConfig['opn_url'] . '/modules/glossar/index.php" onclick="window.close()">' . _GLO_CLOSEWINDOW . '</a>'), array ('right') );
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	define ('_OPN_DISPLAYCONTENT_DONE', 1);
	$opnConfig['opn_generateautomatictitle'] = 1;
	define ('_OPN_ADDTOTITLE', _GLO_GLOSSARY . ': ' . $word);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_GLOSSAR_110_';
	$_display_dat['module'] = 'modules/glossar';
	$_display_dat['emergency'] = true;
	$_display_dat['nothemehead'] = true;
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayHead ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_GLOSSAR_120_';
	$_display_dat['module'] = 'modules/glossar';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ('', $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function list_definitions ($mf) {

	global $opnConfig, $opnTables;

	$letter = '';
	get_var ('letter', $letter, 'both', _OOBJ_DTYPE_CLEAN);
	$catid = 0;
	get_var ('catid', $catid, 'both', _OOBJ_DTYPE_INT);
	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$search = '';
	get_var ('search', $search, 'both');
	$search = $opnConfig['cleantext']->filter_searchtext ($search);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$boxtitle = _GLO_GLOSSARY;
	if ($opnConfig['permission']->HasRight ('modules/glossar', _PERM_WRITE, true) ) {
		$boxtxt = '<a href="' . encodeurl ($opnConfig['opn_url'] . '/modules/glossar/index.php?op=newdefinition') . '">' . _GLO_ADDNEWDEFINITION . '</a>&nbsp;&nbsp;&nbsp;<a href="' . encodeurl ($opnConfig['opn_url'] . '/modules/glossar/index.php?op=requestdefinition') . '">' . _GLO_REQUESTADEFINITION . '</a>';
		$boxtxt .= '<br />';
	} else {
		$boxtxt = '';
	}
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_GLOSSAR_130_', 'glossar');
	$form->Init ($opnConfig['opn_url'] . '/modules/glossar/index.php');
	$form->AddText (_GLO_SEARCH . '&nbsp;');
	$form->AddTextfield ('search', 40, 40, $search);
	$form->AddText ('&nbsp;' . _GLO_CHOOSECATEGORIE . '&nbsp;');
	$options[''] = _GLO_ALL;
	$options = build_categoryselect ($options, $mf);
	$form->AddSelect ('catid', $options, '');
	$form->AddNewline (2);
	$form->AddSubmit ('submit', _GLO_SEARCH);
	$form->AddNewline (2);
	$form->AddFormEnd ();
	$myform = '';
	$form->GetFormular ($myform);
	$boxtxt .= '<br />' . $myform . '<br />';
	$help = build_letterjump ($catid, $mf);
	$boxtxt .= $help . '<br />';
	$where = '';
	if ($letter) {
		$where .= "orderchar='" . $letter . "'";
	}
	if ($catid>0) {
		if ($where != '') {
			$where .= ' AND ';
		}
		$where .= "catid='" . $catid . "'";
	}
	if ($search) {
		if ($where != '') {
			$where .= ' AND ';
		}
		$like_search = $opnConfig['opnSQL']->AddLike ($search);
		$where .= "((keyphrase LIKE $like_search ) OR (definition LIKE $like_search))";
	}
	if ($offset) {
		$limit = $offset;
	} else {
		$limit = 0;
	}
	$reccount = $mf->GetItemCount ($where);
	$rdefinition = $mf->GetItemLimit (array ('gloid',
						'catid',
						'orderchar',
						'keyphrase',
						'definition',
						'seealso',
						'linkto',
						'lastmod'),
						array ('orderchar,keyphrase'),
		$maxperpage,
		$where,
		$limit);
	if (is_object ($rdefinition) ) {
		$defcount = $rdefinition->RecordCount ();
	} else {
		$defcount = 0;
	}
	if ($defcount == 0) {
		$boxtxt .= _GLO_NODEFINITIONSFOUND;
	} else {
		$catnames = build_categorynames ($mf);
		$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/glossar/index.php',
						'op' => 'listletter',
						'letter' => $letter,
						'catid' => $catid,
						'search' => $search),
						$reccount,
						$maxperpage,
						$offset);
		$boxtxt .= $pagebar;
		$counter = 0;
		$showadmin = $opnConfig['permission']->HasRight ('modules/glossar', _PERM_ADMIN, true);
		$lastcatid = '';
		$lastorderchar = '';
		$table = & new opn_TableClass ('alternator');
		$table->AddCols (array ('50%', '50%') );
		while ( (! $rdefinition->EOF) && ($counter<= $maxperpage) ) {
			$gloid = $rdefinition->fields['gloid'];
			$catid = $rdefinition->fields['catid'];
			$orderchar = $rdefinition->fields['orderchar'];
			$keyphrase = $rdefinition->fields['keyphrase'];
			$definitiontext = $rdefinition->fields['definition'];
			opn_nl2br ($definitiontext);
			$seealso = $rdefinition->fields['seealso'];
			$linkto = $rdefinition->fields['linkto'];
			$lastmod = $rdefinition->fields['lastmod'];
			$opnConfig['opndate']->sqlToopnData ($lastmod);
			$lastmoddisplay = '';
			$opnConfig['opndate']->formatTimestamp ($lastmoddisplay, _DATE_DATESTRING4);
			if ($lastmoddisplay) {
				$lastmoddisplay = '&nbsp;&nbsp;&nbsp;' . _GLO_LASTMOD . '&nbsp;(' . $lastmoddisplay . ')' . _OPN_HTML_NL;
			}
			$newtag = buildnewtag ($lastmod);
			if ($newtag) {
				$newtag .= '&nbsp;&nbsp;';
			}
			if ($lastorderchar <> $orderchar) {
				$table->AddOpenHeadRow ();
				$table->AddHeaderCol ($orderchar, '', '2');
				$table->AddCloseRow ();
				$lastorderchar = $orderchar;
			}
			if ($lastcatid <> $catid) {
				$table->AddOpenHeadRow ();
				$table->AddHeaderCol ($catnames[$catid], '', '2');
				$table->AddCloseRow ();
				$lastcatid = $catid;
			}
			if ($search) {
				$opnConfig['cleantext']->hilight_text ($keyphrase, $search);
			}
			$table->AddOpenSubHeadRow ();
			$cols = 2;
			if ($showadmin) {
				$cols = 1;
			}
			$table->AddSubHeaderCol ('<strong>' . $keyphrase . '</strong>&nbsp;&nbsp;' . $newtag, '', $cols);
			if ($showadmin) {
				$hlp = $opnConfig['defimages']->get_edit_link(array ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php',
												'op' => 'modifydefinition',
												'gloid' => $gloid), 'alternatorhead');
				$hlp .= '&nbsp;&nbsp;' . _OPN_HTML_NL;
				$hlp .= $opnConfig['defimages']->get_delete_link(array ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php',
												'op' => 'deletedefinition',
												'gloid' => $gloid), 'alternatorhead');
				$table->AddSubHeaderCol ($hlp, 'center');
			}
			$table->AddCloseRow ();
			if ($definitiontext) {
				if ($search) {
					$opnConfig['cleantext']->hilight_text ($definitiontext, $search);
				}
				$table->AddOpenRow ();
				$table->AddDataCol (do_glossar ($definitiontext, $catid, $keyphrase, $mf), '', '2');
				$table->AddCloseRow ();
			}
			if ($seealso) {
				$table->AddOpenRow ();
				$table->AddDataCol ('--&gt; <span class="normaltextitalic">' . _GLO_SEEALSO . ':</span> ' . build_wordjump ($seealso, $catid), '', '2');
				$table->AddCloseRow ();
			}
			if ($linkto) {
				$table->AddOpenRow ();
				$table->AddCloseRow ('&rArr;--&gt; <span class="normaltextitalic">' . _GLO_LINKTO . ':</span> <a href="' . $linkto . '" target="_blank">' . $linkto . '</a>', '', '2');
				$tabke->AddDataCol ();
			}
			$counter++;
			$rdefinition->MoveNext ();
		}
		// while
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br />' . $pagebar;
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_GLOSSAR_140_';
	$_display_dat['module'] = 'modules/glossar';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtxt);

}

function doaddglossardefinition ($request, $mf) {

	global $opnConfig;
	if ($opnConfig['permission']->HasRight ('modules/glossar', _PERM_WRITE, true) ) {
		$boxtitle = '' . _GLO_GLOSSARY;
		$boxtxt = '';
		if ($request) {
			$title = _GLO_REQUESTDEFINITION;
		} else {
			$title = _GLO_ADDDEFINITION;
		}
		$boxtxt .= '<span class="extratextbold">' . $title . '</span><br /><br />';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_GLOSSAR_150_', 'glossar');
		$form->Init ($opnConfig['opn_url'] . '/modules/glossar/index.php');
		$form->AddCheckField ('keyphrase', 'e', _GLO_ERR_KEYPHRASE);
		if (!$request) {
			$form->AddCheckField ('definition', 'e', _GLO_ERR_DEFDEFINITION);
		}
		$form->AddTable ();
		$form->AddCols (array ('20%', '80%') );
		$form->AddOpenRow ();
		$form->AddLabel ('catid', _GLO_CHOOSECATEGORY);
		$options = array ();
		$options = build_categoryselect ($options, $mf);
		$form->AddSelect ('catid', $options);
		$form->AddChangeRow ();
		$form->AddLabel ('keyphrase', _GLO_DEFKEYPHRASE);
		$form->AddTextfield ('keyphrase', 80, 100);
		if (!$request) {
			$form->AddChangeRow ();
			$form->AddLabel ('definition', _GLO_DEFDEFINITION);
			$form->AddTextarea ('definition');
			$form->AddChangeRow ();
			$form->AddLabel ('seealso', _GLO_DEFSEEALSOWORDS);
			$form->AddTextfield ('seealso', 80, 255);
			$form->AddChangeRow ();
			$form->AddLabel ('linkto', _GLO_DEFLINKTO);
			$form->AddTextfield ('linkto', 80, 255);
		}
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddHidden ('status', '');
		$form->AddHidden ('op', 'glodefinitionmake');
		$form->AddHidden ('request', $request);
		$form->SetEndCol ();
		$form->AddSubmit ('submit', _GLO_SAVEDEFINITION);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_GLOSSAR_160_';
		$_display_dat['module'] = 'modules/glossar';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtxt);
	}

}

function makeaddglossardefinition () {

	global $opnTables, $opnConfig;

	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$keyphrase = '';
	get_var ('keyphrase', $keyphrase, 'form', _OOBJ_DTYPE_CLEAN);
	$definition = '';
	get_var ('definition', $definition, 'form', _OOBJ_DTYPE_CLEAN);
	$seealso = '';
	get_var ('seealso', $seealso, 'form', _OOBJ_DTYPE_CHECK);
	$linkto = '';
	get_var ('linkto', $linkto, 'form', _OOBJ_DTYPE_CHECK);
	$request = '';
	get_var ('request', $request, 'form', _OOBJ_DTYPE_CHECK);
	if ($opnConfig['permission']->HasRight ('modules/glossar', _PERM_WRITE, true) ) {
		if ($request) {
			$new = 'R';
		} else {
			if ($opnConfig['permission']->HasRight ('modules/glossar', _PERM_ADMIN, true) ) {
				$new = '';
			} else {
				$new = 'N';
			}
		}
		$gloid = $opnConfig['opnSQL']->get_new_number ('glossary', 'gloid');
		$keyphrase = trim ($keyphrase);
		$orderchar = build_orderchar ($keyphrase);
		$keyphrase = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($keyphrase, true, true, 'nohtml') );
		$definition = $opnConfig['opnSQL']->qstr (trim ($opnConfig['cleantext']->filter_text ($definition, true, true) ), 'definition');
		$seealso = $opnConfig['opnSQL']->qstr (trim ($opnConfig['cleantext']->filter_text ($seealso, true, true) ) );
		$linkto = $opnConfig['opnSQL']->qstr (trim ($opnConfig['cleantext']->filter_text ($linkto, true, true) ) );
		$opnConfig['opndate']->now ();
		$mydatestring = '';
		$opnConfig['opndate']->opnDataTosql ($mydatestring);
		$sql = 'INSERT INTO ' . $opnTables['glossary'] . ' VALUES ' . "(" . $gloid . ", " . $catid . ", '" . $orderchar . "', " . $keyphrase . ", " . $definition . ", " . $seealso . "," . " " . $linkto . ", '" . $new . "', " . $mydatestring . ")";
		$opnConfig['database']->Execute ($sql);
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['glossary'], 'gloid=' . $gloid);
		$boxtxt = '<br /><br />';
		$boxtxt .= _GLO_THANKYOU;
		$boxtxt .= '<br /><br />';
		$boxtxt .= '<a href="' . $opnConfig['opn_url'] . '/modules/glossar/index.php">' . _GLO_DESC . '</a><br />';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_GLOSSAR_170_';
		$_display_dat['module'] = 'modules/glossar';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_GLO_GLOSSARY, $boxtxt);
	}

}

?>