<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

getLanguageDef (_OPN_ROOT_PATH . 'modules/headlines/admin/language/');
include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');

/*********************************************************/

/* Headlines Grabber to put other sites news in our site */

/*********************************************************/

function headlinesConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_HEAD_HEADLINEADMIN);
	$menu->InsertEntry (_HEAD_HEADLINEMAIN, $opnConfig['opn_url'] . '/modules/headlines/admin/index.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function HeadlinesAdmin () {

	global $opnTables, $opnConfig;

	headlinesConfigHeader ();
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$sortby = 'asc_hid';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	$boxtitle = _HEAD_TITLE;
	$progurl = array ($opnConfig['opn_url'] . '/modules/headlines/admin/index.php');
	$newsortby = $sortby;
	$order = '';
	$table = & new opn_TableClass ('alternator');
	$table->get_sort_order ($order, array ('sitename',
						'theme_group',
						'status',
						'url',
						'hid'),
						$newsortby);
	$table->AddHeaderRow (array ($table->get_sort_feld ('hid', _HEAD_ID, $progurl), $table->get_sort_feld ('sitename', _HEAD_SITENAME, $progurl), $table->get_sort_feld ('url', _HEAD_URL, $progurl), $table->get_sort_feld ('status', _HEAD_STATUS, $progurl), $table->get_sort_feld ('theme_group', _HEAD_THEMEGROUP, $progurl), _HEAD_FUNCTIONS) );
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sql = 'SELECT COUNT(hid) AS counter FROM ' . $opnTables['headlines'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$result = &$opnConfig['database']->SelectLimit ('SELECT hid, sitename, url, status,theme_group FROM ' . $opnTables['headlines'] . ' WHERE hid>0 ' . $order, $maxperpage, $offset);
	if ($result !== false) {
		while (! $result->EOF) {
			$hid = $result->fields['hid'];
			$sitename = $result->fields['sitename'];
			$url = $result->fields['url'];
			$status = $result->fields['status'];
			if (isset ($opnConfig['theme_groups'][$result->fields['theme_group']]['theme_group_text']) ) {
				$themegroup = $opnConfig['theme_groups'][$result->fields['theme_group']]['theme_group_text'];
			} else {
				$themegroup = '&nbsp;';
			}
			$table->AddOpenRow ();
			$table->AddDataCol ($hid, 'center');
			$table->AddDataCol ('<a class="%alternate%" href="' . $url . '" target="_blank">' . $sitename . '</a>', 'center');
			$table->AddDataCol ($url, 'center');
			if ($status == 1) {
				$table->AddDataCol (_HEAD_ACTIVE, 'center');
			} else {
				$table->AddDataCol (_HEAD_INACTIVE, 'center');
			}
			$table->AddDataCol ($themegroup, 'center');
			$hlp = '';
			if ($opnConfig['permission']->HasRights ('modules/headlines', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/headlines/admin/index.php',
											'op' => 'HeadlinesEdit',
											'hid' => $hid) ) . ' | ';
			}
			if ($opnConfig['permission']->HasRights ('modules/headlines', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/headlines/admin/index.php',
											'op' => 'HeadlinesDel',
											'hid' => $hid,
											'ok' => '0') );
			}
			$table->AddDataCol ($hlp, 'center');
			$table->AddCloseRow ();
			$result->MoveNext ();
		}
	}
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />';
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/headlines/admin/index.php',
					'sortby' => $sortby),
					$reccount,
					$maxperpage,
					$offset);
	$boxtxt .= $pagebar . '<br /><br />';
	if ($opnConfig['permission']->HasRights ('modules/headlines', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$boxtxt .= '<span class="extratextbold">' . _HEAD_ADDHEADLINE . '</span><br /><br />';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_HEADLINES_70_', 'headlines');
		$form->Init ($opnConfig['opn_url'] . '/modules/headlines/admin/index.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90') );
		$form->AddOpenRow ();
		$form->AddLabel ('xsitename', _HEAD_SITENAME2 . ' ');
		$form->AddTextfield ('xsitename', 31, 30);
		$form->AddChangeRow ();
		$form->AddLabel ('url', _HEAD_URL2 . ' ');
		$form->AddTextfield ('url', 50, 100);
		$form->AddChangeRow ();
		$form->AddLabel ('headlinesurl', _HEAD_URLRDF . ' ');
		$form->AddTextfield ('headlinesurl', 50, 200);
		$form->AddChangeRow ();
		$form->AddLabel ('status', _HEAD_STATUS2 . ' ');
		$options[0] = _HEAD_INACTIVE;
		$options[1] = _HEAD_ACTIVE;
		$form->AddSelect ('status', $options, 0);
		$options = array ();
		$groups = $opnConfig['theme_groups'];
		foreach ($groups as $group) {
			$options[$group['theme_group_id']] = $group['theme_group_text'];
		}
		$form->AddChangeRow ();
		$form->AddLabel ('theme_group', _HEAD_THEMEGROUP);
		$form->AddSelect ('theme_group', $options);
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'HeadlinesAdd');
		$form->AddSubmit ('submit', _HEAD_ADD);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HEADLINES_80_';
	$_display_dat['module'] = 'modules/headlines';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function HeadlinesEdit () {

	global $opnTables, $opnConfig;

	$hid = 0;
	get_var ('hid', $hid, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/headlines', array (_PERM_EDIT, _PERM_ADMIN) );
	headlinesConfigHeader ();
	$result = &$opnConfig['database']->Execute ('SELECT sitename, url, headlinesurl, status, theme_group FROM ' . $opnTables['headlines'] . " WHERE hid=$hid");
	$xsitename = $result->fields['sitename'];
	$url = $result->fields['url'];
	$headlinesurl = $result->fields['headlinesurl'];
	$status = $result->fields['status'];
	$themegroup = $result->fields['theme_group'];
	$boxtitle = _HEAD_EDITHEADLINE;
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_HEADLINES_90_', 'headlines');
	$form->Init ($opnConfig['opn_url'] . '/modules/headlines/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90') );
	$form->AddOpenRow ();
	$form->AddLabel ('xsitename', _HEAD_SITENAME2 . ' ');
	$form->AddTextfield ('xsitename', 31, 30, $xsitename);
	$form->AddChangeRow ();
	$form->AddLabel ('url', _HEAD_URL2 . ' ');
	$form->AddTextfield ('url', 50, 100, $url);
	$form->AddChangeRow ();
	$form->AddLabel ('headlinesurl', _HEAD_URLRDF . ' ');
	$form->AddTextfield ('headlinesurl', 50, 200, $headlinesurl);
	$form->AddChangeRow ();
	$form->AddLabel ('status', _HEAD_STATUS2 . ' ');
	$options[0] = _HEAD_INACTIVE;
	$options[1] = _HEAD_ACTIVE;
	$form->AddSelect ('status', $options, $status);
	$options = array ();
	$groups = $opnConfig['theme_groups'];
	foreach ($groups as $group) {
		$options[$group['theme_group_id']] = $group['theme_group_text'];
	}
	$form->AddChangeRow ();
	$form->AddLabel ('theme_group', _HEAD_THEMEGROUP);
	$form->AddSelect ('theme_group', $options, $themegroup);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('hid', $hid);
	$form->AddHidden ('op', 'HeadlinesSave');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _HEAD_SAVECHANGE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HEADLINES_100_';
	$_display_dat['module'] = 'modules/headlines';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function HeadlinesSave () {

	global $opnTables, $opnConfig;

	$hid = 0;
	get_var ('hid', $hid, 'form', _OOBJ_DTYPE_INT);
	$xsitename = 'OPN';
	get_var ('xsitename', $xsitename, 'form', _OOBJ_DTYPE_CLEAN);
	$url = '';
	get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
	$headlinesurl = '';
	get_var ('headlinesurl', $headlinesurl, 'form', _OOBJ_DTYPE_URL);
	$status = 0;
	get_var ('status', $status, 'form', _OOBJ_DTYPE_INT);
	$theme_group = 0;
	get_var ('theme_group', $theme_group, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/headlines', array (_PERM_EDIT, _PERM_ADMIN) );
	$xsitename = $opnConfig['opnSQL']->qstr (str_replace (' ', '', $xsitename) );
	$headlinesurl = $opnConfig['opnSQL']->qstr ($headlinesurl);
	$url = $opnConfig['opnSQL']->qstr ($url);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['headlines'] . " SET sitename=$xsitename, url=$url, headlinesurl=$headlinesurl, status=$status, theme_group=$theme_group WHERE hid=$hid");

}

function HeadlinesAdd () {

	global $opnTables, $opnConfig;

	$xsitename = 'OPN';
	get_var ('xsitename', $xsitename, 'form', _OOBJ_DTYPE_CLEAN);
	$url = '';
	get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
	$headlinesurl = '';
	get_var ('headlinesurl', $headlinesurl, 'form', _OOBJ_DTYPE_URL);
	$status = 0;
	get_var ('status', $status, 'form', _OOBJ_DTYPE_INT);
	$theme_group = 0;
	get_var ('theme_group', $theme_group, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/headlines', array (_PERM_NEW, _PERM_ADMIN) );
	$xsitename = $opnConfig['opnSQL']->qstr (str_replace (' ', '', $xsitename) );
	$headlinesurl = $opnConfig['opnSQL']->qstr ($headlinesurl);
	$url = $opnConfig['opnSQL']->qstr ($url);
	$hid = $opnConfig['opnSQL']->get_new_number ('headlines', 'hid');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['headlines'] . " values ($hid, $xsitename, $url, $headlinesurl, $status,$theme_group)");

}

function HeadlinesDel () {

	global $opnTables, $opnConfig;

	$hid = 0;
	get_var ('hid', $hid, 'both', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/headlines', array (_PERM_DELETE, _PERM_ADMIN) );
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['headlines'] . ' WHERE hid=' . $hid);
		HeadlinesAdmin ();
	} else {
		headlinesConfigHeader ();
		$boxtitle = _HEAD_HEADLINES_DELETE;
		$boxtxt = '<div class="bigtextbold" align="center"><br />';
		$boxtxt .= '<span class="alerttextcolor">';
		$boxtxt .= '' . _HEAD_DELETEQUESTION . '</span><br /><br />';
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/headlines/admin/index.php',
										'op' => 'HeadlinesDel',
										'hid' => $hid,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/headlines/admin/index.php">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HEADLINES_110_';
		$_display_dat['module'] = 'modules/headlines';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'HeadlinesDel':
		HeadlinesDel ();
		break;
	case 'HeadlinesAdd':
		HeadlinesAdd ();
		HeadlinesAdmin ();
		break;
	case 'HeadlinesSave':
		HeadlinesSave ();
		HeadlinesAdmin ();
		break;
	case 'HeadlinesEdit':
		HeadlinesEdit ();
		break;
	default:
		HeadlinesAdmin ();
		break;
}

?>