<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/howto/plugin/tracking/language/');

function howto_get_title ($id) {

	global $opnConfig, $opnTables;

	$title = '';
	$result = &$opnConfig['database']->Execute ('SELECT title FROM ' . $opnTables['howto'] . ' WHERE id=' . $id);
	if ($result !== false) {
		while (! $result->EOF) {
			$title = $result->fields['title'];
			$result->MoveNext ();
		}
		$result->Close ();
	}
	return $title;

}

function howto_get_tracking ($url) {
	if ($url == '/modules/howto/index.php?op=preview_howto') {
		return _HWT_TRACKING_PHOWTO;
	}
	if (substr_count ($url, 'modules/howto/index.php?op=write_howto')>0) {
		return _HWT_TRACKING_WRITE;
	}
	if (substr_count ($url, 'modules/howto/index.php?op=howto')>0) {
		$letter = str_replace ('/modules/howto/index.php?op=howto', '', $url);
		$l = explode ('&', $letter);
		$letter = str_replace ('letter=', '', $l[1]);
		return _HWT_TRACKING_DISPLAYHOWTOLETTER . ' "' . $letter . '"';
	}
	if (substr_count ($url, 'modules/howto/index.php?op=showcontent&id=')>0) {
		$id = str_replace ('/modules/howto/index.php?op=showcontent&id=', '', $url);
		$title = howto_get_title ($id);
		return _HWT_TRACKING_DISPLAYHOWTO . ' "' . $title . '"';
	}
	if (substr_count ($url, 'modules/howto/index.php?op=postcomment')>0) {
		$id = str_replace ('/modules/howto/index.php?op=postcomment', '', $url);
		$l = explode ('&', $id);
		$title = str_replace ('title=', '', $l[2]);
		return _HWT_TRACKING_COMMENTHOWTO . ' "' . $title . '"';
	}
	if (substr_count ($url, 'modules/howto/index.php?op=SendHowto&id=')>0) {
		$id = str_replace ('/modules/howto/index.php?op=SendHowto&id=', '', $url);
		$title = howto_get_title ($id);
		return _HWT_TRACKING_SENDHOWTO . ' "' . $title . '"';
	}
	if (substr_count ($url, 'modules/howto/index.php?op=PrintHowto&id=')>0) {
		$id = str_replace ('/modules/howto/index.php?op=PrintHowto&id=', '', $url);
		$title = howto_get_title ($id);
		return _HWT_TRACKING_PRINTHOWTO . ' "' . $title . '"';
	}
	if (substr_count ($url, 'modules/howto/index.php?op=mod_howto&id=')>0) {
		$id = str_replace ('/modules/howto/index.php?op=mod_howto&id=', '', $url);
		$title = howto_get_title ($id);
		return _HWT_TRACKING_MODHOWTO . ' "' . $title . '"';
	}
	if (substr_count ($url, 'modules/howto/index.php?op=del_howto&id_del=')>0) {
		$id = str_replace ('/modules/howto/index.php?op=del_howto&id_del=', '', $url);
		return _HWT_TRACKING_DELHOWTO . ' "' . $id . '"';
	}
	if (substr_count ($url, 'modules/howto/index.php?op=del_comment')>0) {
		$cid = str_replace ('/modules/howto/index.php?op=del_comment', '', $url);
		$c = explode ('&', $cid);
		$cid = str_replace ('cid=', '', $c[0]);
		$id = str_replace ('id=', '', $c[1]);
		$title = howto_get_title ($id);
		return sprintf (_HWT_TRACKING_DELCOMMENT, $cid, $title);
	}
	if (substr_count ($url, 'modules/howto/admin/')>0) {
		return _HWT_TRACKING_ADMIN;
	}
	if (substr_count ($url, 'modules/howto/')>0) {
		return _HWT_TRACKING_INDEX;
	}
	return '';

}

?>