<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function moviez_nav ($letter, $name) {

	global $opnConfig, $opnTables;

	$boxtxt = '<div class="centertag"><span class="normaltextbold">';
	if ($letter == 'ALL') {
		$boxtxt .= _MOVIEZ_LIST_ALL;
	} elseif ($letter == '123') {
		$boxtxt .= _MOVIEZ_LIST_OTHER;
	} elseif ($letter != '') {
		$boxtxt .= sprintf (_MOVIEZ_LIST_BEGINN, $letter);
	} elseif ($name != '') {
		$boxtxt .= sprintf (_MOVIEZ_LIST_WRITTEN, $name);
	} else {
		$boxtxt .= sprintf (_MOVIEZ_LIST_WELCOME, $opnConfig['sitename']);
	}
	$boxtxt .= '</span><br />';
	if (isset ($opnConfig['moviez_lettersasnormallink']) && $opnConfig['moviez_lettersasnormallink'] == 1) {
		$classname = 'opncenterbox';
	} else {
		$classname = 'txtbutton';
	}
	if (isset ($opnConfig['moviez_showonlypossibleletters']) && $opnConfig['moviez_showonlypossibleletters'] == 1) {
		$sql = 'SELECT orderchar FROM ' . $opnTables['moviez'] . ' GROUP BY orderchar';
	} else {
		$sql = '';
	}
	$boxtxt .= build_letterpagebar (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
						'op' => 'moviez'),
						'letter',
						$letter,
						$sql);
	$boxtxt .= '<br />';
	if ($opnConfig['permission']->HasRights ('modules/moviez', array (_PERM_WRITE, _PERM_ADMIN), true) ) {
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/moviez/index.php?op=write_movie') . '"><span class="normaltextbold">' . _MOVIEZ_WRITE_MOVIEZ . '</span></a>';
	}
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/search') ) {
		$boxtxt .= '<br />';
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_MOVIEZ_90_', 'moviez');
		$form->Init ($opnConfig['opn_url'] . '/system/search/index.php');
		$form->AddTextfield ('query', 17);
		$form->AddText ('&nbsp;');
		$form->AddHidden ('types[]', 'moviez');
		$form->AddSubmit ('submit', _MOVIEZ_SEARCH);
		$form->AddText ('&nbsp;&nbsp;');
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$boxtxt .= '</div><br />';
	return $boxtxt;

}

function moviez_display_score ($score, $score2, $score3, $score4, $score5) {

	global $opnConfig;

	$image = '<img src="' . $opnConfig['opn_default_images'] . 'blue.gif" alt="" />';
	$halfimage = '<img src="' . $opnConfig['opn_default_images'] . 'bluehalf.gif" alt="" />';
	$full = '<img src="' . $opnConfig['opn_default_images'] . 'star.gif" alt="" />';
	$boxtxt = '';
	if ($score == 10) {
		for ($i = 0; $i<5; $i++) $boxtxt .= $full;
	} elseif ($score%2) {
		$score -= 1;
		$score /= 2;
		for ($i = 0; $i< $score; $i++) $boxtxt .= $image; $boxtxt .= $halfimage;
	} else {
		$score /= 2;
		for ($i = 0; $i< $score; $i++) $boxtxt .= $image;
	}
	$boxtxt .= '&nbsp;&nbsp;' . _MOVIEZ_SCORE2 . '&nbsp;';
	if ($score2 == 10) {
		for ($i = 0; $i<5; $i++) $boxtxt .= $full;
	} elseif ($score2%2) {
		$score2 -= 1;
		$score2 /= 2;
		for ($i = 0; $i< $score2; $i++) $boxtxt .= $image; $boxtxt .= $halfimage;
	} else {
		$score2 /= 2;
		for ($i = 0; $i< $score2; $i++) $boxtxt .= $image;
	}
	$boxtxt .= '&nbsp;&nbsp;' . _MOVIEZ_SCORE3 . '&nbsp;';
	if ($score3 == 10) {
		for ($i = 0; $i<5; $i++) $boxtxt .= $full;
	} elseif ($score3%2) {
		$score3 -= 1;
		$score3 /= 2;
		for ($i = 0; $i< $score3; $i++) $boxtxt .= $image; $boxtxt .= $halfimage;
	} else {
		$score3 /= 2;
		for ($i = 0; $i< $score3; $i++) $boxtxt .= $image;
	}
	$boxtxt .= '&nbsp;<br />&nbsp;' . _MOVIEZ_SCORE4 . '&nbsp;';
	if ($score4 == 10) {
		for ($i = 0; $i<5; $i++) $boxtxt .= $full;
	} elseif ($score%2) {
		$score4 -= 1;
		$score4 /= 2;
		for ($i = 0; $i< $score4; $i++) $boxtxt .= $image; $boxtxt .= $halfimage;
	} else {
		$score4 /= 2;
		for ($i = 0; $i< $score4; $i++) $boxtxt .= $image;
	}
	$boxtxt .= '&nbsp;&nbsp;' . _MOVIEZ_SCORE5 . '&nbsp;';
	if ($score5 == 10) {
		for ($i = 0; $i<5; $i++) $boxtxt .= $full;
	} elseif ($score5%2) {
		$score5 -= 1;
		$score5 /= 2;
		for ($i = 0; $i< $score5; $i++) $boxtxt .= $image; $boxtxt .= $halfimage;
	} else {
		$score5 /= 2;
		for ($i = 0; $i< $score5; $i++) $boxtxt .= $image;
	}
	return $boxtxt;

}

function write_movie ($mf) {

	global $opnConfig;

	$opnConfig['permission']->HasRights ('modules/moviez', array (_PERM_WRITE, _PERM_ADMIN) );
	$boxtxt = '<br />';
	$boxtxt .= '<span class="normaltextbold">' . _MOVIEZ_WRITE_MOVIEZ_FOR . ' ' . $opnConfig['sitename'] . '</span><br /><br /><span class="normaltextitalic">' . _MOVIEZ_SPECS_TEXT . '</span><br /><br /><div class="normaltext">';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_MOVIEZ_100_', 'moviez');
	$form->Init ($opnConfig['opn_url'] . '/modules/moviez/index.php', 'post', 'coolsus');
	$form->AddCheckField ('title', 'e', _MOVIEZ_ERR_TITLE);
	$form->AddCheckField ('text', 'e', _MOVIEZ_ERR_TITLE_TEXT);
	$form->AddCheckField ('score', '<', _MOVIEZ_ERR_SCORE,'',0);
	$form->AddCheckField ('score', '>', _MOVIEZ_ERR_SCORE,'',11);
	$form->AddCheckField ('movieer', 'e', _MOVIEZ_ERR_NAME_EMAIL);
	$form->AddCheckField ('email', 'e', _MOVIEZ_ERR_NAME_EMAIL);
	$form->AddCheckField ('email', 'm', _MOVIEZ_ERR_EMAIL);
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('title', _MOVIEZ_PRODUCT_TITLE);
	$form->AddTextfield ('title', 50, 150);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddLabel ('text', _MOVIEZ_PRODUCT_TITLE_NAME);
	$form->AddText ('<br /><span class="normaltextitalic">' . _MOVIEZ_WRITE_TEXT . '</span><br />');
	$form->SetEndCol ();
	$form->UseImages (true);
	$form->AddTextarea ('text');
	if ($opnConfig['permission']->IsUser () ) {
		$userinfo = $opnConfig['permission']->GetUserinfo ();
		$name = $userinfo['uname'];
		$email = '';
		if (isset ($userinfo['femail']) ) {
			$email = $userinfo['femail'];
		}
	}
	if (!isset ($name) ) {
		$name = '';
	}
	if (!isset ($email) ) {
		$email = '';
	}
	$form->AddChangeRow ();
	$form->AddLabel ('movieer', _MOVIEZ_YOUR_NAME);
	$form->SetSameCol ();
	$form->AddTextfield ('movieer', 40, 20, $name);
	$form->AddText ('<br /><span class="normaltextitalic">' . _MOVIEZ_YOUR_NAME_REQUIRED . '</span>');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('email', _MOVIEZ_YOUR_EMAIL);
	$form->SetSameCol ();
	$form->AddTextfield ('email', 40, 30, $email);
	$form->AddText ('<br /><span class="normaltextitalic">' . _MOVIEZ_YOUR_EMAIL_REQUIRED . '</span>');
	$form->SetEndCol ();
	$options = array ();
	for ($i = 10; $i>0; $i--) {
		$options[$i] = $i;
	}
	$form->AddChangeRow ();
	$form->AddText (_MOVIEZ_SCORE_ALL);
	$form->SetSameCol ();
	$form->AddLabel ('score', _MOVIEZ_SCORE . ' ');
	$form->AddSelect ('score', $options);
	$form->AddLabel ('score2', ' ' . _MOVIEZ_SCORE2 . ' ');
	$form->AddSelect ('score2', $options);
	$form->AddLabel ('score3', ' ' . _MOVIEZ_SCORE3 . ' ');
	$form->AddSelect ('score3', $options);
	$form->AddLabel ('score4', ' ' . _MOVIEZ_SCORE4 . ' ');
	$form->AddSelect ('score4', $options);
	$form->AddLabel ('score5', ' ' . _MOVIEZ_SCORE5 . ' ');
	$form->AddSelect ('score5', $options);
	$form->AddText ('<br /><span class="normaltextitalic">' . _MOVIEZ_SCORE_TEXT . '</span>');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('url', _MOVIEZ_RELAT_LINK);
	$form->SetSameCol ();
	$form->AddTextfield ('url', 40, 100, 'http://');
	$form->AddText ('<br /><span class="normaltextitalic">' . _MOVIEZ_RELAT_LINK_TEXT . ' "http://"</span>');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('url_title', _MOVIEZ_LINK_TITLE);
	$form->SetSameCol ();
	$form->AddTextfield ('url_title', 40, 50);
	$form->AddText ('<br /><span class="normaltextitalic">' . _MOVIEZ_LINK_TITLE_TEXT . '</span>');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('cid', _MOVIEZ_CATE);
	$mf->makeMySelBox (0, $form, 0, 'cid');
	if ($opnConfig['permission']->HasRight ('modules/moviez', _PERM_ADMIN, true) ) {
		$form->AddChangeRow ();
		$form->AddLabel ('cover', _MOVIEZ_IMAGE_NAME);
		$form->SetSameCol ();
		$form->AddTextfield ('cover', 40, 100);
		$form->AddText ('<br /><span class="normaltextitalic">' . sprintf (_MOVIEZ_IMAGE_NAME_TEXT, $opnConfig['datasave']['moviez_images']['url']) . '</span>');
		$form->SetEndCol ();
	}
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->AddText ('<span class="normaltextitalic">' . _MOVIEZ_WRITE_MOVIEZ_TEXT . '</span>');
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'pmovie_movie');
	$form->SetSameCol ();
	$form->AddSubmit ('submit', _MOVIEZ_WRITE_PMOVIEZ);
	$form->AddText (' ');
	$form->AddButton ('Cancel', _MOVIEZ_WRITE_CANCEL, '', '', 'javascript:history.go(-1)');
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '</div>';
	$opnConfig['opnOutput']->EnableJavaScript ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MOVIEZ_110_';
	$_display_dat['module'] = 'modules/moviez';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function pmovie_movie () {

	global $opnConfig;

	$date = '';
	get_var ('date', $date, 'form', _OOBJ_DTYPE_CLEAN);
	$title = '';
	get_var ('title', $title, 'form', _OOBJ_DTYPE_CLEAN);
	$text = '';
	get_var ('text', $text, 'form', _OOBJ_DTYPE_CHECK);
	$movieer = '';
	get_var ('movieer', $movieer, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$score = 0;
	get_var ('score', $score, 'form', _OOBJ_DTYPE_INT);
	$cover = '';
	get_var ('cover', $cover, 'form', _OOBJ_DTYPE_CLEAN);
	$url = '';
	get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
	$url_title = '';
	get_var ('url_title', $url_title, 'form', _OOBJ_DTYPE_CLEAN);
	$hits = 0;
	get_var ('hits', $hits, 'form', _OOBJ_DTYPE_INT);
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$score2 = 0;
	get_var ('score2', $score2, 'form', _OOBJ_DTYPE_INT);
	$score3 = 0;
	get_var ('score3', $score3, 'form', _OOBJ_DTYPE_INT);
	$score4 = 0;
	get_var ('score4', $score4, 'form', _OOBJ_DTYPE_INT);
	$score5 = 0;
	get_var ('score5', $score5, 'form', _OOBJ_DTYPE_INT);
	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/moviez', array (_PERM_WRITE, _PERM_ADMIN) );
	$title = stripslashes ($opnConfig['cleantext']->filter_text ($title, false, true, 'nohtml') );
	$text = stripslashes ($opnConfig['cleantext']->filter_text ($text, true, true) );
	$movieer = stripslashes ($opnConfig['cleantext']->filter_text ($movieer, false, true, 'nohtml') );
	$url_title = stripslashes ($opnConfig['cleantext']->filter_text ($url_title, false, true, 'nohtml') );
	$p_text = $text;
	opn_nl2br ($p_text);
	if ($url == 'http://') {
		$url = '';
	}
	$errormsg = '';
	$boxtxt = '<br />';
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_MOVIEZ_120_', 'moviez');
	$form->Init ($opnConfig['opn_url'] . '/modules/moviez/index.php', 'post', 'coolsus');
	if ( ($hits<0) && ($id != 0) ) {
		$errormsg .= '' . _MOVIEZ_ERR_HITS . '<br />';
	}
	if ( ($url_title != '' && $url == '') || ($url_title == '' && $url != '') ) {
		$errormsg .= '' . _MOVIEZ_ERR_LINK . '<br />';
	} elseif ( ($url != '') && (! (preg_match ('/(^http[s]*:[\/]+)(.*)/i', $url) ) ) ) {
		$url = 'http://' . $url;
	}
	if ($errormsg != '') {
		$form->AddText ($errormsg . '<br />');
		$form->AddButton ('Cancel', _MOVIEZ_GOBACK, '', '', 'history.go(-1)');
	} else {
		if ($date != '') {
			$opnConfig['opndate']->sqlToopnData ($date);
		}
		$fdate = '';
		$opnConfig['opndate']->formatTimestamp ($fdate, _DATE_FORUMDATESTRING2);
		if ($hits == '') {
			$hits = 1;
		}
		$form->AddText ('<div class="extratextbold" align="center">' . $title . '</div>');
		if ($cover != '') {
			$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/moviez/images/moviez/' . $cover . '" align="right" class="imgtag" vspace="2" alt="" />');
		}
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
			include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
			$p_text = make_user_images ($p_text);
		}
		$form->AddText ('<div align="left">' . $p_text . '</div>');
		$form->AddText ('<br />');
		$form->AddText (moviez_extrainfo ($id, $fdate, $title, $movieer, $email, $score, $url_title, $url, $hits, 1, $score2, $score3, $score4, $score5) );
		$text = urlencode ($text);
		$form->AddText ('<div class="centertag"><span class="normaltextitalic">' . _MOVIEZ_LOOK_RIGHT . ' </span></div>');
		$form->AddHidden ('id', $id);
		$form->AddHidden ('hits', $hits);
		$form->AddHidden ('op', 'send_movie');
		$form->AddHidden ('date', $date);
		$form->AddHidden ('title', $title);
		$form->AddHidden ('text', $text);
		$form->AddHidden ('movieer', $movieer);
		$form->AddHidden ('email', $email);
		$form->AddHidden ('score', $score);
		$form->AddHidden ('score2', $score2);
		$form->AddHidden ('score3', $score3);
		$form->AddHidden ('score4', $score4);
		$form->AddHidden ('score5', $score5);
		$form->AddHidden ('url', $url);
		$form->AddHidden ('url_title', $url_title);
		$form->AddHidden ('cover', $cover);
		$form->AddHidden ('cid', $cid);
		$form->AddText ('<div class="centertag">');
		$form->AddSubmit ('submit', _YES_SUBMIT);
		$form->AddText (' ');
		$form->AddButton ('Cancel', _NO_SUBMIT, '', '', 'history.go(-1)');
		$form->AddText ('</div>');
		if ($id != 0) {
			$word = '' . _MOVIEZ_MOD . '';
		} else {
			$word = '' . _MOVIEZ_ADD . '';
		}
		if ($opnConfig['permission']->HasRight ('modules/moviez', _PERM_ADMIN, true) ) {
			$form->AddText ('<br /><br /><span class="normaltextbold">' . _MOVIEZ_NOTE . '</span> ' . _MOVIEZ_LOG_ADMIN_TEXT . ' ' . $word . ' ' . _MOVIEZ_IMMED . '.');
		}
	}
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MOVIEZ_130_';
	$_display_dat['module'] = 'modules/moviez';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function send_movie () {

	global $opnTables, $opnConfig;

	$title = '';
	get_var ('title', $title, 'form', _OOBJ_DTYPE_CLEAN);
	$text = '';
	get_var ('text', $text, 'form', _OOBJ_DTYPE_CHECK);
	$movieer = '';
	get_var ('movieer', $movieer, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$score = 0;
	get_var ('score', $score, 'form', _OOBJ_DTYPE_INT);
	$cover = '';
	get_var ('cover', $cover, 'form', _OOBJ_DTYPE_CLEAN);
	$url = '';
	get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
	$url_title = '';
	get_var ('url_title', $url_title, 'form', _OOBJ_DTYPE_CLEAN);
	$hits = 0;
	get_var ('hits', $hits, 'form', _OOBJ_DTYPE_INT);
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$score2 = 0;
	get_var ('score2', $score2, 'form', _OOBJ_DTYPE_INT);
	$score3 = 0;
	get_var ('score3', $score3, 'form', _OOBJ_DTYPE_INT);
	$score4 = 0;
	get_var ('score4', $score4, 'form', _OOBJ_DTYPE_INT);
	$score5 = 0;
	get_var ('score5', $score5, 'form', _OOBJ_DTYPE_INT);
	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/moviez', array (_PERM_WRITE, _PERM_ADMIN) );
	$title = $opnConfig['cleantext']->filter_text ($title, false, true, 'nohtml');
	$orderchar = $opnConfig['opnSQL']->qstr (strtoupper ($title{0}) );
	$title = $opnConfig['opnSQL']->qstr ($title);
	$text = urldecode ($opnConfig['cleantext']->filter_text ($text, false, true) );
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
		$text = make_user_images ($text);
	}
	$url_title = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($url_title, false, true, 'nohtml') );
	$opnConfig['cleantext']->filter_text ($movieer, false, true, 'nohtml');
	$boxtxt = '<br />';
	$boxtxt .= '<br /><div class="centertag">' . _MOVIEZ_THANKS . '';
	if ($id != 0) {
		$boxtxt .= ' ' . _MOVIEZ_MODI . '';
	} else {
		$boxtxt .= ', ' . $movieer;
	}
	$boxtxt .= '!<br />';
	$opnConfig['opndate']->now ();
	$date = '';
	$opnConfig['opndate']->opnDataTosql ($date);
	$_email = $opnConfig['opnSQL']->qstr ($email);
	$_movieer = $opnConfig['opnSQL']->qstr ($movieer);
	$_cover = $opnConfig['opnSQL']->qstr ($cover);
	$_url = $opnConfig['opnSQL']->qstr ($url);
	$text = $opnConfig['opnSQL']->qstr ($text, 'text');
	if ( ($opnConfig['permission']->HasRight ('modules/moviez', _PERM_ADMIN, true) ) && ($id == 0) ) {
		$id = $opnConfig['opnSQL']->get_new_number ('moviez', 'id');
		$result = &$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['moviez'] . " VALUES ($id, $date, $title, $text, $_movieer, $_email, $score, $_cover, $_url, $url_title, 1, $score2, $score3, $score4, $score5,$cid,$orderchar)");
		if ($result === false) {
			die ('Unable to insert recordset');
		}
		$result->Close ();
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['moviez'], 'id=' . $id);
		$boxtxt .= '' . _MOVIEZ_AVAI_TEXT . '';
	} elseif ( ($opnConfig['permission']->HasRight ('modules/moviez', _PERM_ADMIN, true) ) && ($id != 0) ) {
		$result = &$opnConfig['database']->Execute ('UPDATE ' . $opnTables['moviez'] . " SET text=$text,wdate=$date, title=$title, movieer=$_movieer, email=$_email, score=$score, cover=$_cover, url=$_url, url_title=$url_title, hits=$hits, score2=$score2, score3=$score3, score4=$score4, score5=$score5, cid=$cid, orderchar=$orderchar WHERE id = $id");
		if ($result === false) {
			die ('Unable to update record');
		}
		$result->Close ();
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['moviez'], 'id=' . $id);
		$boxtxt .= '' . _MOVIEZ_AVAI_TEXT . '';
	} else {
		$id = $opnConfig['opnSQL']->get_new_number ('moviez_add', 'id');
		$result = &$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['moviez_add'] . " VALUES ($id, $date, $title, $text, $_movieer, $_email, $score, $_url, $url_title, $score2, $score3, $score4, $score5, $cid )");
		if ($result === false) {
			die ('Unable to insert record');
		}
		$result->Close ();
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['moviez_add'], 'id=' . $id);
		$boxtxt .= '' . _MOVIEZ_LOOK_SUBMISSION . '';
		if ($opnConfig['send_new_movie']) {
			$vars = array ();
			$mail = & new opn_mailer ();
			$mail->opn_mail_fill ($opnConfig['adminmail'], _MOVIEZ_MOV_SEND, 'modules/moviez', 'newmovie', $vars, $opnConfig['opn_webmaster_name'], $opnConfig['adminmail']);
			$mail->send ();
			$mail->init ();
		}
	}
	$boxtxt .= '<br /><br />[ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/moviez/index.php">' . _MOVIEZ_BACK_INDEX . '</a> ]<br /></div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MOVIEZ_140_';
	$_display_dat['module'] = 'modules/moviez';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function moviez_index ($moviezcat, $mf) {

	global $opnTables, $opnConfig;

	$cid = 0;
	get_var ('cid', $cid, 'url', _OOBJ_DTYPE_INT);
	if (!$cid) {
		$cid = 0;
		get_var ('cat_id', $cid, 'url', _OOBJ_DTYPE_INT);
	}
	$hlptxt = '';
	if ($cid == 0) {
		$hlptxt = $moviezcat->MainNavigation ();
	}
	$boxtxt = $hlptxt;
	if ($cid != 0) {
		$boxtxt .= $moviezcat->SubNavigation ($cid);
	}
	$boxtxt .= moviez_nav ('', '');
	$result = &$opnConfig['database']->Execute ('SELECT title, description FROM ' . $opnTables['moviez_main']);
	if ($result !== false) {
		$title = $result->fields['title'];
		$description = $result->fields['description'];
		$result->Close ();
	}
	if ($title != '') {
		OpenTable2 ($boxtxt);
		$boxtxt .= '<div align="center" class="normaltext"><span class="normaltextbold">' . $title . '</span><br /><br />' . $description . '</div>';
		CloseTable2 ($boxtxt);
		$boxtxt .= '<br />';
	}
	$table = & new opn_TableClass ('alternator');
	$table->AddCols (array ('50%', '50%') );
	$table->AddHeaderRow (array (_MOVIEZ_10_POP, _MOVIEZ_10_REC) );
	$where = '';
	if ($cid != 0) {
		$where = 'i.cid=' . $cid . ' ';
	}
	$result_pop = $mf->GetItemLimit (array ('id',
						'title'),
						array ('i.hits DESC'),
		10,
		$where);
	$result_rec = $mf->GetItemLimit (array ('id',
						'title'),
						array ('i.wdate DESC'),
		10,
		$where);
	$y = 1;
	if ( ($result_pop !== false) && ($result_rec !== false) ) {
		for ($x = 0; $x<10; $x++) {
			$row = $result_pop->GetRowAssoc ('0');
			if ($row['id'] != '') {
				$hlp = $y . ') <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
												'op' => 'showcontent',
												'id' => $row['id']) ) . '">' . $row['title'] . '</a>';
			} else {
				$hlp = '&nbsp;';
			}
			$row = $result_rec->GetRowAssoc ('0');
			if ($row['id'] != '') {
				$hlp1 = $y . ') <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
												'op' => 'showcontent',
												'id' => $row['id']) ) . '">' . $row['title'] . '</a>';
			} else {
				$hlp1 = '&nbsp;';
			}
			$table->AddDataRow (array ($hlp, $hlp1) );
			$y++;
			$result_pop->MoveNext ();
			$result_rec->MoveNext ();
		}
		$result_pop->Close ();
		$result_rec->Close ();
	}
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br />';
	$numresults = $mf->GetItemCount ($where);
	$boxtxt .= '<div align="center" class="normaltext">' . _MOVIEZ_THERE_ARE . ' ' . $numresults . ' ' . _MOVIEZ_IN_DB . '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MOVIEZ_150_';
	$_display_dat['module'] = 'modules/moviez';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function moviez () {

	global $opnConfig, $mf;

	$letter = '';
	get_var ('letter', $letter, 'url', _OOBJ_DTYPE_CLEAN);
	$field = 'title';
	get_var ('field', $field, 'url', _OOBJ_DTYPE_CLEAN);
	$order = 'ASC';
	get_var ('order', $order, 'url', _OOBJ_DTYPE_CLEAN);
	$name = '';
	get_var ('name', $name, 'both', _OOBJ_DTYPE_CLEAN);
	$name = $opnConfig['cleantext']->filter_searchtext ($name);
	if ( ($letter != '123') && ($letter != 'ALL') ) {
		$like_search = $opnConfig['opnSQL']->AddLike ($letter, '', '%');
		$where = "title LIKE $like_search ";
	} elseif ( ($letter == '123') && ($letter != 'ALL') ) {
		$where = $opnConfig['opnSQL']->CreateOpnRegexp ('title', '0-9');
	} elseif ($name != '') {
		$like_search = $opnConfig['opnSQL']->AddLike ($name);
		$where = "movieer LIKE $like_search ";
	} else {
		$where = '';
	}
	$numresults = 0;
	$err = $opnConfig['cleantext']->var_possible_check ($field, array ('id','title','hits','movieer','email','score','score2','score3','score4','score5','score'));
	$result = $mf->GetItemResult (array ('id',
					'title',
					'hits',
					'movieer',
					'email',
					'score',
					'score2',
					'score3',
					'score4',
					'score5'),
					array ($field . ' ' . $order),
		$where);
	$boxtxt = moviez_nav ($letter, $name);
	if ($result !== false) {
		$numresults = $result->RecordCount ();
	}
	$boxtxt .= '<br /><br />';
	if ($numresults == 0) {
		$boxtxt .= '<span class="normaltextbold">' . sprintf (_MOVIEZ_NO_MOV_FOR_LETTER, $letter) . '</span><br /><br />';
	} elseif ($numresults>0) {
		$i = 1;
		$table = & new opn_TableClass ('alternator');
		$table->AddCols (array ('40%', '21%', '21%', '18%') );
		$table->AddOpenHeadRow ();
		$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
											'op' => 'moviez',
											'letter' => $letter,
											'field' => 'title',
											'order' => 'ASC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/up_arrow.gif" class="imgtag" title="' . _MOVIEZ_SORT_ASC . '"></a> ' . _MOVIEZ_PRODUCT_TITLE . ' <a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
																															'op' => 'moviez',
																															'letter' => $letter,
																															'field' => 'title',
																															'order' => 'DESC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/down_arrow.gif" class="imgtag" title="' . _MOVIEZ_SORT_DESC . '"></a>',
																															'left');
		$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
											'op' => 'moviez',
											'letter' => $letter,
											'field' => 'movieer',
											'order' => 'ASC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/up_arrow.gif" class="imgtag" title="' . _MOVIEZ_SORT_ASC . '"></a> ' . _MOV_ER . ' <a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
																													'op' => 'moviez',
																													'letter' => $letter,
																													'field' => 'movieer',
																													'order' => 'desc') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/down_arrow.gif" class="imgtag" title="' . _MOVIEZ_SORT_DESC . '"></a>',
																													'center');
		$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
											'op' => 'moviez',
											'letter' => $letter,
											'field' => 'score',
											'order' => 'ASC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/up_arrow.gif" class="imgtag" title="' . _MOVIEZ_SORT_ASC . '"></a> ' . _MOVIEZ_SCORE_ALL . ' <a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
																														'op' => 'moviez',
																														'letter' => $letter,
																														'field' => 'score',
																														'order' => 'DESC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/down_arrow.gif" class="imgtag" title="' . _MOVIEZ_SORT_DESC . '"></a>',
																														'center');
		$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
											'op' => 'moviez',
											'letter' => $letter,
											'field' => 'hits',
											'order' => 'ASC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/up_arrow.gif" class="imgtag" title="' . _MOVIEZ_SORT_ASC . '"></a> ' . _MOVIEZ_HITS . ' <a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
																														'op' => 'moviez',
																														'letter' => $letter,
																														'field' => 'hits',
																														'order' => 'DESC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/down_arrow.gif" class="imgtag" title="' . _MOVIEZ_SORT_DESC . '"></a>',
																														'center');
		$table->AddCloseRow ();
		while (! $result->EOF) {
			$i++;
			$id = $result->fields['id'];
			$title = $result->fields['title'];
			$id = $result->fields['id'];
			$movieer = $result->fields['movieer'];
			$score = $result->fields['score'];
			$hits = $result->fields['hits'];
			$score2 = $result->fields['score2'];
			$score3 = $result->fields['score3'];
			$score4 = $result->fields['score4'];
			$score5 = $result->fields['score5'];
			// spter
			$table->AddOpenRow ();
			$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
												'op' => 'showcontent',
												'id' => $id) ) . '">' . $title . '</a>',
												'left');
			$table->AddDataCol ($movieer, 'center');
			$hlp = _MOVIEZ_SCORE . ' ';
			$hlp .= moviez_display_score ($score, $score2, $score3, $score4, $score5);
			$table->AddDataCol ($hlp, 'center');
			$table->AddDataCol ($hits, 'center');
			$table->AddCloseRow ();
			$result->MoveNext ();
		}
		$result->Close ();
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br /><div class="normaltext" align="center">' . $numresults . ' ' . _MOVIEZ_TOTAL . '</div><br /><br />';
	}
	$boxtxt .= '<div class="centertag">[ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/moviez/index.php">' . _MOVIEZ_RET_MAIN . '</a> ]</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MOVIEZ_160_';
	$_display_dat['module'] = 'modules/moviez';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function moviez_postcomment () {

	global $anonpost, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$title = '';
	get_var ('title', $title, 'url', _OOBJ_DTYPE_CLEAN);
	$opnConfig['permission']->HasRight ('modules/moviez', _PERM_WRITE);
	$title = urldecode ($title);
	$boxtxt = '<br />';
	$boxtxt .= '<div class="bigtextbold" align="center">' . _MOVIEZ_COM_MOV . ' ' . $title . '<br /><br /></div><div class="normaltext">';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_MOVIEZ_170_', 'moviez');
	$form->Init ($opnConfig['opn_url'] . '/modules/moviez/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	if ( ( (!$opnConfig['permission']->IsUser () ) && ($anonpost == 1) ) or ($opnConfig['permission']->IsUser () ) ) {
		$form->AddText (_MOVIEZ_YOUR_NICKNAME);
		$form->SetSameCol ();
		if (!$opnConfig['permission']->IsUser () ) {
			$form->AddText ('Anonymous [ <a class="%alternate%" href="' . $opnConfig['opn_url'] . '/modules/user/index.php">' . _MOVIEZ_CREATE_ACCOUNT . ' ]');
			$cookie['uname'] = 'Anonymous';
		} else {
			$cookie = $opnConfig['permission']->GetUserinfo ();
			$form->AddText ($cookie['uname']);
			if ($anonpost == 1) {
				$form->AddCheckbox ('xanon', 1);
				$form->AddLabel ('xanon', _MOVIEZ_POST_ANONYM, 1);
			}
		}
		$form->AddHidden ('uname', $cookie['uname']);
		$form->AddHidden ('id', $id);
		$form->SetEndCol ();
		$form->AddChangeRow ();
		$form->AddText (_MOVIEZ_PRODUCT_SCORE);
		for ($i = 10; $i>0; $i--) {
			$options[$i] = $i;
		}
		$form->SetSameCol ();
		$form->AddLabel ('score', _MOVIEZ_SCORE);
		$form->AddSelect ('score', $options);
		$form->AddLabel ('score2', _MOVIEZ_SCORE2);
		$form->AddSelect ('score2', $options);
		$form->AddLabel ('score3', _MOVIEZ_SCORE3);
		$form->AddSelect ('score3', $options);
		$form->AddLabel ('score4', _MOVIEZ_SCORE4);
		$form->AddSelect ('score4', $options);
		$form->AddLabel ('score5', _MOVIEZ_SCORE5);
		$form->AddSelect ('score5', $options);
		$form->SetEndCol ();
		$form->AddChangeRow ();
		$form->AddLabel ('comments', _MOVIEZ_YOU_COMM);
		$form->AddTextarea ('comments');
		$form->AddChangeRow ();
		$form->AddText ('&nbsp;');
		$form->SetSameCol ();
		$form->AddText (_MOVIEZ_HTML . '<br />');
		if (is_array ($opnConfig['AllowableHTML']) ) {
			$temp = array_keys ($opnConfig['AllowableHTML']);
			foreach ($temp as $key) {
				$form->AddText (htmlentities ($key) . ' ');
			}
		}
		$form->AddText ('&nbsp;');
		$form->SetEndCol ();
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'savecomment');
		$form->AddSubmit ('submit', _MOVIEZ_SUBMIT);
	} else {
		$form->AddText (sprintf (_MOVIEZ_PLEASE_REG, $opnConfig['opn_url']) );
	}
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MOVIEZ_180_';
	$_display_dat['module'] = 'modules/moviez';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function moviez_printComments ($id) {

	global $opnConfig, $opnTables;

	$boxtxt = '';
	$result = &$opnConfig['database']->Execute ('SELECT cid, userid, wdate, comments, score, score2, score3, score4, score5 FROM ' . $opnTables['moviez_comments'] . ' WHERE rid=' . $id . ' ORDER BY cid DESC');
	if ($result !== false) {
		$date = '';
		while (! $result->EOF) {
			$uname = $result->fields['userid'];
			$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
			$opnConfig['opndate']->formatTimestamp ($date, _DATE_DATESTRING5);
			$comments = $result->fields['comments'];
			$score = $result->fields['score'];
			$score2 = $result->fields['score2'];
			$score3 = $result->fields['score3'];
			$score4 = $result->fields['score4'];
			$score5 = $result->fields['score5'];
			if ($uname == 'Anonymous') {
				$boxtxt .= '' . _MOVIEZ_POST_BY . ' ' . $uname . ' ' . _MOVIEZ_ON . ' ' . $date . '<br />';
			} else {
				$boxtxt .= '' . _MOVIEZ_POST_BY . ' <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/user/index.php',
															'op' => 'userinfo',
															'uname' => $uname) ) . '">' . $uname . '</a> ' . _MOVIEZ_ON . ' ' . $date . '<br />';
			}
			$boxtxt .= '' . _MOVIEZ_MY_SCORE . ' ';
			$boxtxt .= moviez_display_score ($score, $score2, $score3, $score4, $score5);
			$boxtxt .= '<br />';
			$boxtxt .= '<br />';
			$comments = $opnConfig['cleantext']->filter_text ($comments, true, true);
			opn_nl2br ($comments);
			$boxtxt .= $comments;
			$boxtxt .= '<br />';
			$boxtxt .= '<br />';
			$result->MoveNext ();
		}
		$result->Close ();
	}
	return $boxtxt;

}

function moviez_savecomment () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRight ('modules/moviez', _PERM_WRITE);
	$xanon = 0;
	get_var ('xanon', $xanon, 'form', _OOBJ_DTYPE_INT);
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$uname = '';
	get_var ('uname', $uname, 'form', _OOBJ_DTYPE_CLEAN);
	$comments = '';
	get_var ('comments', $comments, 'form', _OOBJ_DTYPE_CHECK);
	$score = 0;
	get_var ('score', $score, 'form', _OOBJ_DTYPE_INT);
	$score2 = 0;
	get_var ('score2', $score2, 'form', _OOBJ_DTYPE_INT);
	$score3 = 0;
	get_var ('score3', $score3, 'form', _OOBJ_DTYPE_INT);
	$score4 = 0;
	get_var ('score4', $score4, 'form', _OOBJ_DTYPE_INT);
	$score5 = 0;
	get_var ('score5', $score5, 'form', _OOBJ_DTYPE_INT);
	if ($xanon) {
		$uname = $opnConfig['opn_anonymous_name'];
	}
	$comments = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($comments, true, true), 'comments');
	$opnConfig['cleantext']->filter_text ($uname, false, true, 'nohtml');
	$cid = $opnConfig['opnSQL']->get_new_number ('moviez_comments', 'cid');
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->opnDataTosql ($now);
	$_uname = $opnConfig['opnSQL']->qstr ($uname);
	$result = &$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['moviez_comments'] . " values ($cid, $id, $_uname, $now, $comments, $score, $score2, $score3, $score4, $score5)");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['moviez_comments'], 'cid=' . $cid);
	if ($result === false) {
		die ('Unable to insert recordset');
	}
	$result->Close ();
	$boxtxt = '';
	$boxtxt .= '' . _MOVIEZ_AVAI_TEXT . '';
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
							'op' => 'showcontent',
							'id' => $id),
							false) );

}

function moviez_r_comments ($id, $title) {

	global $opnConfig, $opnTables;

	$boxtxt = '';
	$result = &$opnConfig['database']->Execute ('SELECT cid, userid, wdate, comments, score, score2, score3, score4, score5 FROM ' . $opnTables['moviez_comments'] . ' WHERE rid=' . $id . ' ORDER BY cid DESC');
	if ($result !== false) {
		$date = '';
		while (! $result->EOF) {
			$cid = $result->fields['cid'];
			$uname = $result->fields['userid'];
			$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
			$opnConfig['opndate']->formatTimestamp ($date, _DATE_DATESTRING5);
			$comments = $result->fields['comments'];
			$score = $result->fields['score'];
			$score2 = $result->fields['score2'];
			$score3 = $result->fields['score3'];
			$score4 = $result->fields['score4'];
			$score5 = $result->fields['score5'];
			$title = urldecode ($title);
			$boxtxt .= '<span class="normaltextbold">' . $title . '</span><br />';
			if ($uname == 'Anonymous') {
				$boxtxt .= '' . _MOVIEZ_POST_BY . ' ' . $uname . ' ' . _MOVIEZ_ON . ' ' . $date . '<br />';
			} else {
				$boxtxt .= '' . _MOVIEZ_POST_BY . ' <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/user/index.php',
															'op' => 'userinfo',
															'uname' => $uname) ) . '">' . $uname . '</a> ' . _MOVIEZ_ON . ' ' . $date . '<br />';
			}
			$boxtxt .= '' . _MOVIEZ_SCORE . ' ';
			$boxtxt .= moviez_display_score ($score, $score2, $score3, $score4, $score5);
			if ($opnConfig['permission']->HasRight ('modules/moviez', _PERM_ADMIN, true) ) {
				$boxtxt .= '<br /><span class="normaltextbold">' . _MOVIEZ_ADMIN . '</span> [ <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
																				'op' => 'del_comment',
																				'cid' => $cid,
																				'id' => $id) ) . '">' . _MOVIEZ_DEL . '</a> ]<hr noshade="noshade" size="1" /><br /><br />';
			} else {
				$boxtxt .= '<hr noshade="noshade" size="1" /><br /><br />';
			}
			$comments = $opnConfig['cleantext']->filter_text ($comments, true, true);
			opn_nl2br ($comments);
			$boxtxt .= $comments;
			$boxtxt .= '<br />';
			$result->MoveNext ();
		}
		$result->Close ();
	}
	return $boxtxt;

}

function moviez_showcontent () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = '';
	$boxtxt .= '<table class="opncenterbox" border="0" cellspacing="0" cellpadding="0"><tr class="opncenterbox"><td class="opncenterbox" width="100%">';
	$result = &$opnConfig['database']->Execute ('UPDATE ' . $opnTables['moviez'] . ' SET hits=hits+1 WHERE id=' . $id);
	$result->Close ();
	$myrow = &$opnConfig['database']->Execute ('SELECT id, wdate, title, text, cover, movieer, email, hits, url, url_title, score, score2, score3, score4, score5 FROM ' . $opnTables['moviez'] . ' WHERE id=' . $id);
	$id = $myrow->fields['id'];
	$opnConfig['opndate']->sqlToopnData ($myrow->fields['wdate']);
	$fdate = '';
	$opnConfig['opndate']->formatTimestamp ($fdate, _DATE_FORUMDATESTRING2);
	$title = $myrow->fields['title'];
	$text = $myrow->fields['text'];
	$cover = $myrow->fields['cover'];
	$movieer = $myrow->fields['movieer'];
	$email = $myrow->fields['email'];
	$hits = $myrow->fields['hits'];
	$url = $myrow->fields['url'];
	$url_title = $myrow->fields['url_title'];
	$score = $myrow->fields['score'];
	$score2 = $myrow->fields['score2'];
	$score3 = $myrow->fields['score3'];
	$score4 = $myrow->fields['score4'];
	$score5 = $myrow->fields['score5'];
	opn_nl2br ($text);
	$boxtxt .= '<div class="extratextbold" align="center">' . $title . '<br /><br /></div>';
	$boxtxt .= '<div class="normaltext" align="left">';
	if ($cover != '') {
		$boxtxt .= '<img src="' . $opnConfig['opn_url'] . '/modules/moviez/images/moviez/' . $cover . '" align="right" class="imgtag" vspace="2" alt="" />';
	}
	$boxtxt .= $text . '</div>';
	$boxtxt .= '</td></tr></table>';
	$boxtxt .= moviez_extrainfo ($id, $fdate, $title, $movieer, $email, $score, $url_title, $url, $hits, 0, $score2, $score3, $score4, $score5);
	$title = urlencode ($title);
	$boxtxt .= '<br /><br /><span class="normaltextbold">[ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/moviez/index.php">' . _MOVIEZ_BACK_INDEX . '</a> ]</span>';
	$boxtxt .= '<br />';
	$boxtxt .= moviez_r_comments ($id, $title);
	$myrow->Close ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MOVIEZ_190_';
	$_display_dat['module'] = 'modules/moviez';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function mod_movie ($mf) {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRight ('modules/moviez', _PERM_ADMIN);
	$boxtxt = '<br />';
	if ( ($id == 0) ) {
		$boxtxt .= 'This function must be passed argument id, or you are not admin.';
	} else {
		$result = &$opnConfig['database']->Execute ('SELECT id, wdate, title, text, cover, movieer, email, hits, url, url_title, score, score2, score3, score4, score5, cid FROM ' . $opnTables['moviez'] . ' WHERE id=' . $id);
		if ($result !== false) {
			$date = '';
			while (! $result->EOF) {
				$id = $result->fields['id'];
				$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
				$opnConfig['opndate']->formatTimestamp ($date);
				$title = $result->fields['title'];
				$text = $result->fields['text'];
				$cover = $result->fields['cover'];
				$movieer = $result->fields['movieer'];
				$email = $result->fields['email'];
				$hits = $result->fields['hits'];
				$url = $result->fields['url'];
				$url_title = $result->fields['url_title'];
				$score = $result->fields['score'];
				$score2 = $result->fields['score2'];
				$score3 = $result->fields['score3'];
				$score4 = $result->fields['score4'];
				$score5 = $result->fields['score5'];
				$cid = $result->fields['cid'];
				$result->MoveNext ();
			}
			$result->Close ();
		}
		if ($opnConfig['installedPlugins']->isplugininstalled ('modules/user_images') ) {
			include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
			$text = de_make_user_images ($text);
		}
		$text = opn_br2nl ($text);
		$boxtxt .= '<div class="centertag"><span class="normaltextbold">' . _MOVIEZ_MODIFIC . '</span></div><br /><br />';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_MOVIEZ_200_', 'moviez');
		$form->Init ($opnConfig['opn_url'] . '/modules/moviez/index.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('date', _MOVIEZ_DAT);
		$form->AddTextfield ('date', 18, 18, $date);
		$form->AddChangeRow ();
		$form->AddLabel ('title', _MOVIEZ_TITEL);
		$form->AddTextfield ('title', 50, 150, $title);
		$form->AddChangeRow ();
		$form->AddLabel ('text', _MOVIEZ_TEXT);
		$form->UseImages (true);
		$text = str_replace ('&amp;', '&amp;amp;', $text);
		$text = str_replace ('&lt;', '&amp;lt;', $text);
		$text = str_replace ('&gt;', '&amp;gt;', $text);
		$form->AddTextarea ('text', 0, 0, '', $text);
		$form->AddChangeRow ();
		$form->AddLabel ('movieer', _MOV_ER);
		$form->AddTextfield ('movieer', 30, 20, $movieer);
		$form->AddChangeRow ();
		$form->AddLabel ('email', _MOVIEZ_EMAIL);
		$form->AddTextfield ('email', 30, 60, $email);
		$form->AddChangeRow ();
		$form->AddText (_MOVIEZ_SCORE_ALL);
		for ($i = 10; $i>0; $i--) {
			$options[$i] = $i;
		}
		$form->SetSameCol ();
		$form->AddLabel ('score', _MOVIEZ_SCORE);
		$form->AddSelect ('score', $options, $score);
		$form->AddText ('&nbsp;');
		$form->AddLabel ('score2', _MOVIEZ_SCORE2);
		$form->AddSelect ('score2', $options, $score2);
		$form->AddText ('&nbsp;');
		$form->AddLabel ('score3', _MOVIEZ_SCORE3);
		$form->AddSelect ('score3', $options, $score3);
		$form->AddText ('&nbsp;');
		$form->AddLabel ('score4', _MOVIEZ_SCORE4);
		$form->AddSelect ('score4', $options, $score4);
		$form->AddText ('&nbsp;');
		$form->AddLabel ('score5', _MOVIEZ_SCORE5);
		$form->AddSelect ('score5', $options, $score5);
		$form->SetEndCol ();
		$form->AddChangeRow ();
		$form->AddLabel ('url', _MOVIEZ_LINK);
		$form->AddTextfield ('url', 30, 100, $url);
		$form->AddChangeRow ();
		$form->AddLabel ('url_title', _MOVIEZ_LINK_TITLE);
		$form->AddTextfield ('url_title', 30, 50, $url_title);
		$form->AddChangeRow ();
		$form->AddLabel ('cid', _MOVIEZ_CATE);
		$mf->makeMySelBox ($cid, $form, 0, 'cid');
		$form->AddChangeRow ();
		$form->AddLabel ('cover', _MOVIEZ_COVER_IMG);
		$form->AddTextfield ('cover', 30, 100, $cover);
		$form->AddChangeRow ();
		$form->AddLabel ('hits', _MOVIEZ_HITS);
		$form->AddTextfield ('hits', 5, 5, $hits);
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddHidden ('op', 'pmovie_movie');
		$form->AddHidden ('id', $id);
		$form->SetEndCol ();
		$form->SetSameCol ();
		$form->AddSubmit ('submit', _MOVIEZ_PMOVIEZ_MOD);
		$form->AddText ('&nbsp;&nbsp;');
		$form->AddButton ('Cancel', _MOVIEZ_WRITE_CANCEL, '', '', 'javascript:history.go(-1)');
		$form->SetEndCol ();
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MOVIEZ_210_';
	$_display_dat['module'] = 'modules/moviez';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function del_movie () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRight ('modules/moviez', _PERM_ADMIN);
	$id_del = 0;
	get_var ('id_del', $id_del, 'url', _OOBJ_DTYPE_INT);
	$yes = 0;
	get_var ('yes', $yes, 'url', _OOBJ_DTYPE_INT);
	if ( ($yes) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$result = &$opnConfig['database']->Execute ('delete FROM ' . $opnTables['moviez_comments'] . ' WHERE rid=' . $id_del);
		$result->Close ();
		$result = &$opnConfig['database']->Execute ('delete FROM ' . $opnTables['moviez'] . ' WHERE id=' . $id_del);
		$result->Close ();
		$opnConfig['opnOutput']->Redirect ('/modules/moviez/index.php');
	} else {
		$boxtxt = '';
		$boxtxt .= '<h3>' . sprintf (_MOVIEZ_DEL_MOV, $id_del) . '</h3>';
		$boxtxt .= '' . sprintf (_MOVIEZ_DEL_MOV_TXT, $id_del) . ' ';
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
										'op' => 'del_movie',
										'id_del' => $id_del,
										'yes' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
															'op' => 'showcontent',
															'id' => $id_del) ) . '">' . _NO . '</a><br />';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MOVIEZ_220_';
		$_display_dat['module'] = 'modules/moviez';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);
	}

}

function moviez_del_comment () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRight ('modules/moviez', _PERM_ADMIN);
	$cid = 0;
	get_var ('cid', $cid, 'url', _OOBJ_DTYPE_INT);
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$result = &$opnConfig['database']->Execute ('delete FROM ' . $opnTables['moviez_comments'] . ' WHERE cid=' . $cid);
	$result->Close ();
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
							'op' => 'showcontent',
							'id' => $id),
							false) );

}

function PrintMovie () {

	global $opnTables, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$printcomment = 0;
	get_var ('printcomment', $printcomment, 'url', _OOBJ_DTYPE_INT);
	if (!$id) {
		$opnConfig['opnOutput']->Redirect ('/modules/moviez/index.php');
	}
	$themecss = $opnConfig['opnOutput']->css;
	$result = &$opnConfig['database']->Execute ('SELECT wdate, title, text, movieer, email, score, cover, url, url_title, score2, score3, score4, score5 FROM ' . $opnTables['moviez'] . ' WHERE id=' . $id);
	if ($result !== false) {
		$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
		$date = '';
		$opnConfig['opndate']->formatTimestamp ($date, _DATE_FORUMDATESTRING2);
		$title = $result->fields['title'];
		$text = $result->fields['text'];
		$movieer = $result->fields['movieer'];
		$email = $result->fields['email'];
		$score = $result->fields['score'];
		$cover = $result->fields['cover'];
		$url = $result->fields['url'];
		$url_title = $result->fields['url_title'];
		$score2 = $result->fields['score2'];
		$score3 = $result->fields['score3'];
		$score4 = $result->fields['score4'];
		$score5 = $result->fields['score5'];
		$result->Close ();
	}
	echo '<html><head><title>' . $opnConfig['sitename'] . ' - ' . $title . '</title>';
	if ($themecss != '') {
		echo '<link href="' . $themecss . '" rel="stylesheet">' . _OPN_HTML_NL;
	}
	echo '</head>' . '<body bgcolor="#FFFFFF" text="#000000"><table class="opncenterbox" border="0" cellspacing="0" cellpadding="0"><tr class="opncenterbox"><td class="opncenterbox"><table border="0" width="640" cellpadding="0" cellspacing="1" class="bgcolor2"><tr class="opncenterbox"><td class="opncenterbox"><table border="0" width="640" cellpadding="20" cellspacing="1" class="bgcolor3"><tr class="opncenterbox"><td class="opncenterbox"><div class="bigtextbold" align="center">' . $title . '</span><br /><br /></div>';
	if ($cover != '') {
		echo '<img src="' . $opnConfig['opn_url'] . '/modules/moviez/images/moviez/' . $cover . '" align="right" class="imgtag" vspace="2" alt="" />' . _OPN_HTML_NL;
	}
	echo $text . '<br /><br />' . _OPN_HTML_NL . '<span class="normaltextbold">' . _MOV_ER . '</span> ' . $movieer . ' (' . $opnConfig['crypttext']->CodeEmail ($email) . ')<br />' . '<span class="normaltextbold">' . _MOVIEZ_ADD . '</span> ' . $date . '<br />' . '<span class="normaltextbold"></span> ';
	echo _MOVIEZ_SCORE;
	echo moviez_display_score ($score, $score2, $score3, $score4, $score5);
	echo '<br /><span class="normaltextbold">' . _MOVIEZ_RELAT_LINK . ' </span> ' . $url_title . '<br />' . '<span class="normaltextbold">' . _MOVIEZ_RELAT_URL . '</span> ' . $url . '<br /><br />';
	if ($printcomment == 1) {
		echo '<br />';
		echo '<br />' . _MOVIEZ_COMMENT . '<br />';
		echo '<br />';
		echo moviez_printcomments ($id);
	}
	echo '</td></tr></table></td></tr></table><br /><br /><div class="centertag">' . _MOVIEZ_THIS_MOV . ' ' . $opnConfig['sitename'] . '<br />' . '<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '">' . $opnConfig['opn_url'] . '</a><br /><br />' . _MOVIEZ_URL_MOV . '<br />' . '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
																																											'op' => 'showcontent',
																																											'id' => $id) ) . '">' . encodeurl ($opnConfig['opn_url'] . '/index.php?op=showcontent&id=' . $id) . '</a>' . '</td></tr></table></body></html>';

}

function moviez_extrainfo ($id, $fdate, $title, $movieer, $email, $score, $url_title, $url, $hits, $pmovie, $score2, $score3, $score4, $score5) {

	global $anonpost, $opnTables, $opnConfig;

	$_movieer = $opnConfig['opnSQL']->qstr ($movieer);
	$result = &$opnConfig['database']->Execute ('SELECT uname FROM ' . $opnTables['users'] . " WHERE uname=$_movieer");
	if ($result !== false) {
		$name = $result->fields['uname'];
		$result->Close ();
	} else {
		$name = '';
	}
	if ($name != '') {
		$name = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
									'op' => 'userinfo',
									'uname' => $name) ) . '" target="_blank">' . $movieer . '</a>';
	} else {
		$name = $movieer;
	}
	$boxtxt = '<br /><br />';
	$table = & new opn_TableClass ('listalternator');
	$table->AddOpenHeadRow ();
	$table->AddHeaderCol ($opnConfig['defimages']->get_info_image (_MOVIEZ_EX_INFO), 'left', '2');
	$table->AddCloseRow ();
	$table->AddDataRow (array (_MOVIEZ_DATE_ADD, $fdate) );
	$table->AddOpenRow ();
	$table->AddDataCol (_MOV_ER);
	$name .= ' (' . $opnConfig['crypttext']->CodeEmail ($email, '', $table->currentclass) . ')';
	$table->AddDataCol ($name);
	$table->AddCloseRow ();
	if ($score != '') {
		$hlp = moviez_display_score ($score, $score2, $score3, $score4, $score5) . _OPN_HTML_NL;
		$hlp .= '  (' . sprintf (_MOVIEZ_READ_TIMES, $hits) . ')';
		$table->AddDataRow (array (_MOVIEZ_SCORE_ALL, _MOVIEZ_SCORE . $hlp) );
	}
	if ($url != '') {
		$table->AddDataRow (array (_MOVIEZ_RELAT_LINK, '<a class="%alternate%" href="' . $url . '" target="_blank">' . $url_title . '</a>') );
	}
	if (!$pmovie) {
		$hlp = '';
		if ( ($opnConfig['permission']->IsUser () ) or ($anonpost == 1) ) {
			$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
										'op' => 'postcomment',
										'id' => $id,
										'title' => urlencode ($title) ), '', _MOVIEZ_COMMENT, _MOVIEZ_COMMENT ) . ' |&nbsp;';
		}
		$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
									'op' => 'PrintMovie',
									'id' => $id) ) . '" target="_blank"><img src="' . $opnConfig['opn_default_images'] . 'print.gif" class="imgtag" alt="" /> ' . _MOVIEZ_PRINT . '</a> |&nbsp;';
		$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
									'op' => 'PrintMovie',
									'id' => $id) ) . '&amp;printcomment=1" target="_blank"><img src="' . $opnConfig['opn_default_images'] . 'print.gif" class="imgtag" alt="" /> ' . _MOVIEZ_PRINTCOMMENT . '</a> |&nbsp;';
		if ($opnConfig['permission']->HasRights ('modules/moviez', array (_MOVIEZ_PERM_FRIENDSEND, _PERM_ADMIN), true) ) {
			$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
										'op' => 'SendMovie',
										'id' => $id) ) . '"><img src="' . $opnConfig['opn_default_images'] . 'friend.gif" class="imgtag" alt="" /> ' . _MOVIEZ_SEND . '</a> )';
		}
		$table->AddDataRow (array (_MOVIEZ_OPTION, $hlp) );
		if ($opnConfig['permission']->HasRight ('modules/moviez', _PERM_ADMIN, true) ) {
			$table->AddOpenFootRow ();
			$table->AddFooterCol ('Admin (ID ' . $id . '): [ <a class="listalternatorfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
																'op' => 'mod_movie',
																'id' => $id) ) . '">' . _MOVIEZ_MODIFY . '</a> ] - [ <a class="listalternatorfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/moviez/index.php',
																	'op' => 'del_movie',
																	'id_del' => $id,
																	'yes' => '0') ) . '">' . _MOVIEZ_DEL . '</a> ]',
																	'',
																	'2');
			$table->AddCloseRow ();
		}
		if ( (!$opnConfig['permission']->IsUser () ) && ($anonpost == 0) ) {
			$table->AddOpenFootRow ();
			$table->AddFooterCol (sprintf (_MOVIEZ_PLEASE_REG, $opnConfig['opn_url']), '', '2');
			$table->AddCloseRow ();
		}
	}
	$table->GetTable ($boxtxt);
	return $boxtxt;

}

function SendMovie () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/moviez', array (_MOVIEZ_PERM_FRIENDSEND, _PERM_ADMIN) );
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	if (!$id) {
		exit ();
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MOVIEZ_230_';
	$_display_dat['module'] = 'modules/moviez';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayHead ();
	$boxtxt = '<script type="text/javascript">' . _OPN_HTML_NL;
	$boxtxt . '<!--' . _OPN_HTML_NL;
	// Function for Validating Forms
	$boxtxt .= 'function CheckForm(form)' . _OPN_HTML_NL . '{' . _OPN_HTML_NL . 'if ( form.yname.value == "" ) {' . _OPN_HTML_NL . 'alert( "' . _MOVIEZ_PLEASE_NAME . '" )' . _OPN_HTML_NL . 'form.yname.focus()' . _OPN_HTML_NL . 'return false' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'else if (form.ymail.value == "") {' . _OPN_HTML_NL . 'alert( "' . _MOVIEZ_PLEASE_EMAIL . '" )' . _OPN_HTML_NL . 'form.ymail.focus()' . _OPN_HTML_NL . 'return false' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'else if ( form.fname.value == "") {' . _OPN_HTML_NL . 'alert( "' . _MOVIEZ_PLEASE_FRIEND_NAME . '" )' . _OPN_HTML_NL . 'form.fname.focus()' . _OPN_HTML_NL . 'return false' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'else if ( form.fmail.value == "") {' . _OPN_HTML_NL . 'alert( "' . _MOVIEZ_PLEASE_FRIEND_EMAIL . '" )' . _OPN_HTML_NL . 'form.fmail.focus()' . _OPN_HTML_NL . 'return false' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'else {' . _OPN_HTML_NL . 'document.friend.submit()' . _OPN_HTML_NL . 'return true' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . '//--->' . _OPN_HTML_NL . '</script>' . _OPN_HTML_NL;
	$result = &$opnConfig['database']->Execute ('SELECT title FROM ' . $opnTables['moviez'] . " WHERE id=$id");
	if ($result !== false) {
		$title = $result->fields['title'];
		$result->Close ();
	}
	$boxtxt .= '<br />';
	$boxtxt .= '<span class="extratextbold">' . _MOVIEZ_SEND_FRIEND . '</span><br /><br />' . '' . sprintf (_MOVIEZ_SEND_SPEC_FRIEND, $title) . '<br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_MOVIEZ_240_', 'moviez');
	$form->Init ($opnConfig['opn_url'] . '/modules/moviez/index.php', 'post', 'friend');
	if ($opnConfig['permission']->IsUser () ) {
		$cookie = $opnConfig['permission']->GetUserinfo ();
		$result = &$opnConfig['database']->Execute ('SELECT uname, email FROM ' . $opnTables['users'] . " WHERE uname='" . $cookie['uname'] . "'");
		if ($result !== false) {
			$yn = $result->fields['uname'];
			$ye = $result->fields['email'];
			$result->Close ();
		}
	}
	if (!isset ($yn) ) {
		$yn = '';
	}
	if (!isset ($ye) ) {
		$ye = '';
	}
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('yname', _MOVIEZ_YOUR_NAME);
	$form->AddTextfield ('yname', 30, 50, $yn);
	$form->AddChangeRow ();
	$form->AddLabel ('ymail', _MOVIEZ_YOUR_EMAIL);
	$form->AddTextfield ('ymail', 30, 60, $ye);
	$form->AddChangeRow ();
	$form->AddLabel ('fname', _MOVIEZ_FRIEND_NAME);
	$form->AddTextfield ('fname', 30, 50);
	$form->AddChangeRow ();
	$form->AddLabel ('fmail', _MOVIEZ_FRIEND_EMAIL);
	$form->AddTextfield ('fmail', 30, 60);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('id', $id);
	$form->AddHidden ('op', 'EmailMovie');
	$form->SetEndCol ();
	$form->AddButton ('Send', _MOVIEZ_SEND, '', '', 'CheckForm(this.form)');
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MOVIEZ_250_';
	$_display_dat['module'] = 'modules/moviez';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ('', $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function EmailMovie () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/moviez', array (_MOVIEZ_PERM_FRIENDSEND, _PERM_ADMIN) );
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$yname = '';
	get_var ('yname', $yname, 'form', _OOBJ_DTYPE_CLEAN);
	$ymail = '';
	get_var ('ymail', $ymail, 'form', _OOBJ_DTYPE_EMAIL);
	$fname = '';
	get_var ('fname', $fname, 'form', _OOBJ_DTYPE_CLEAN);
	$fmail = '';
	get_var ('fmail', $fmail, 'form', _OOBJ_DTYPE_EMAIL);
	$result = &$opnConfig['database']->SelectLimit ('SELECT title, text, movieer, score, score2, score3, score4, score5 FROM ' . $opnTables['moviez'] . ' WHERE id=' . $id, 1);
	if ($result !== false) {
		$title = $result->fields['title'];
		$text = $result->fields['text'];
		$movieer = $result->fields['movieer'];
		$score = $result->fields['score'];
		$score2 = $result->fields['score2'];
		$score3 = $result->fields['score3'];
		$score4 = $result->fields['score4'];
		$score5 = $result->fields['score5'];
		$result->Close ();
	}
	$subject = sprintf (_MOVIEZ_MAIL_SUBJECT, $opnConfig['sitename']);
	$text = $opnConfig['cleantext']->filter_text ($text, false, true, 'nohtml');
	$vars['{FNAME}'] = $fname;
	$vars['{YNAME}'] = $yname;
	$vars['{TITLE}'] = $title;
	$vars['{TEXT}'] = $text;
	$vars['{MOVIEZER}'] = $movieer;
	$vars['{SCORE}'] = $score;
	$vars['{SCORE2}'] = $score2;
	$vars['{SCORE3}'] = $score3;
	$vars['{SCORE4}'] = $score4;
	$vars['{SCORE5}'] = $score5;
	$mail = & new opn_mailer ();
	$mail->opn_mail_fill ($fmail, $subject, 'modules/moviez', 'movie', $vars, $yname, $ymail);
	$mail->send ();
	$mail->init ();
	$boxtxt = '<br />';
	$boxtxt .= '<h3>' . _MOVIEZ_MOV_SEND . '</h3><blockquote>' . sprintf (_MOVIEZ_THX_SUPP, $opnConfig['sitename'], $yname) . '' . '<br />' . sprintf (_MOVIEZ_SEND_TO, $fname, $fmail) . '</blockquote>';
	$boxtxt .= '<p align="center"><span class="normaltextbold">[ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/moviez/index.php">' . _MOVIEZ_RET_MAIN . '</a> ]</span></p>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MOVIEZ_260_';
	$_display_dat['module'] = 'modules/moviez';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);
	unset ($boxtxt);

}

?>