<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;
if ($opnConfig['permission']->HasRights ('modules/pagespeed', array (_PERM_READ, _PERM_BOT) ) ) {
	$opnConfig['module']->InitModule ('modules/pagespeed');
	$opnConfig['opnOutput']->setMetaPageName ('modules/pagespeed');
	getLanguageDef (_OPN_ROOT_PATH . 'modules/pagespeed/language/');
	include_once (_OPN_ROOT_PATH . 'api/user_name.php');
	$AnalyseSite = '';
	get_var ('AnalyseSite', $AnalyseSite, 'form', _OOBJ_DTYPE_URL);
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_PAGESPEED_10_', 'pagespeed');
	$form->Init ($opnConfig['opn_url'] . '/modules/pagespeed/index.php');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('AnalyseSite', _PAGESP_SITETEST);
	if ($AnalyseSite != '') {
		$form->AddTextfield ('AnalyseSite', 40, 0, $AnalyseSite);
	} else {
		$form->AddTextfield ('AnalyseSite', 40, 0, $opnConfig['opn_url']);
		$AnalyseSite = '';
	}
	$NumLoops = 5;
	get_var ('NumLoops', $NumLoops, 'form', _OOBJ_DTYPE_INT);
	$form->AddChangeRow ();
	$form->AddLabel ('NumLoops', _PAGESP_COUNT);
	$options[1] = 1;
	$options[5] = 5;
	$options[10] = 10;
	$options[25] = 25;
	$options[50] = 50;
	$options[100] = 100;
	$form->AddSelect ('NumLoops', $options, 5);
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->AddSubmit ('submit', _PAGESP_ANALYZING);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	$output = '';
	if ($AnalyseSite != '') {
		include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_http.php');
		$http = & new http ();
		$status = $http->get ($AnalyseSite);
		if ($status == HTTP_STATUS_OK) {
			$time1 = microtime ();
			for ($i = 0; $i< $NumLoops; $i++);  {
				$output = '';
				$http1 = & new http ();
				$status = $http1->get ($AnalyseSite);
				$output .= $http1->get_response_body ();
				$http1->disconnect ();
			}
			$time2 = microtime ();
			$time_1 = explode (' ', $time1);
			$time_2 = explode (' ', $time2);
			$t1 = '';
			ereg ('0\.([0-9]+)', '' . $time_1[0], $t1);
			$t2 = '';
			ereg ('0\.([0-9]+)', '' . $time_2[0], $t2);
			$Start = $time_1[1] . '.' . $t1[1];
			$Stop = $time_2[1] . '.' . $t2[1];
			$boxtxt .= _PAGESP_ANALYZINGSITE . $AnalyseSite . '<br />';
			$FileSize = strlen ($output);
			$elapsed = $Stop- $Start;
			$timePrPage = $elapsed/ $NumLoops;
			$boxtxt .= _PAGESP_TIMEELAPSED . number_format ($elapsed, 2) . ' ' . _PAGESP_SECONDS . '<br />';
			$boxtxt .= _PAGESP_AVERAGETIME . number_format ($timePrPage, 2) . ' ' . _PAGESP_SECONDS . '<br />';
			$boxtxt .= _PAGESP_FILESIZE . number_format ($FileSize/1024, 2) . 'KB (' . number_format ($FileSize, 2) . ' ' . _PAGESP_BYTES . ') <br /><br />';
			$boxtxt .= _PAGESP_THROUGHPUT . number_format ( ($FileSize/ (1048576) )/ ($timePrPage), 2) . ' ' . _PAGESP_MB . '<br />';
			$boxtxt .= _PAGESP_THROUGHPUT . number_format ( ($FileSize/1024)/ ($timePrPage), 2) . ' ' . _PAGESP_KB . '<br />';
			$boxtxt .= _PAGESP_THROUGHPUT . number_format ( ( ($FileSize*8)/ (1048576) )/ ($timePrPage), 2) . ' ' . _PAGESP_MB . '<br />';
			$boxtxt .= _PAGESP_THROUGHPUT . number_format ( ( ($FileSize*8)/1024)/ ($timePrPage), 2) . ' ' . _PAGESP_KB . '<br /><br />';
			$boxtxt .= _PAGESP_MAXPAGESMIN . number_format ( ( (60)/ $timePrPage), 2) . ' ' . _PAGESP_PAGES . '.<br />';
			$boxtxt .= _PAGESP_MAXPAGESHOUR . number_format ( ( (3600)/ $timePrPage), 2) . ' ' . _PAGESP_PAGES . '.<br />';
			$boxtxt .= _PAGESP_MAXPAGESDAY . number_format ( ( (86400)/ $timePrPage), 2) . '&nbsp;' . _PAGESP_PAGES . '.<br />';
			$boxtxt .= _PAGESP_MAXPAGESMONTH . number_format ( ( (2592000)/ $timePrPage), 2) . ' ' . _PAGESP_PAGES . '.<br />';
			$boxtxt .= '<br />';
			$table = & new opn_TableClass ('default');
			$table->AddHeaderRow (array (_PAGESP_PAGEOUTPUT) );
			$table->AddDataRow (array (nl2br (htmlspecialchars ($output) ) ) );
			$table->GetTable ($boxtxt);
		}
		$http->disconnect ();
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_PAGESPEED_20_';
	$_display_dat['module'] = 'modules/pagespeed';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_PAGESP_ANALYZING, $boxtxt);
}

?>