<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

global $opnConfig, $opnTables;

function pollCollector ($pollid, $voteID, $forwarder) {

	global $opnConfig, $opnTables;

	$voteValid = '1';
	if ($opnConfig['setCookies'] == 0) {
		// we have to check for cookies, so get timestamp of this poll
		$result = &$opnConfig['database']->SelectLimit ('SELECT wtimestamp FROM ' . $opnTables['poll_desc'] . " WHERE pollid=$pollid", 1);
		$timeStamp = $result->fields['wtimestamp'];
		$cookieName = $opnConfig['cookiePrefix'] . $timeStamp;
		$cookieName = str_replace ('.', '_', $cookieName);
		$cookie = '';
		get_var ($cookieName, $cookie, 'cookie', _OOBJ_DTYPE_CLEAN);
		// check if cookie exists
		if ($cookie == '1') {
			// cookie exists, invalidate this vote
			$voteValid = '0';
		} else {
			// cookie does not exist yet, set one now
			$cvalue = '1';
			$opnConfig['opnOption']['opnsession']->setopncookie ($cookieName, $cvalue, time ()+86400);
		}
	}
	// update database if the vote is valid
	if ( ($voteValid>0) && ($voteID <> '') ) {
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['poll_data'] . " SET optioncount=optioncount+1 WHERE (pollid=$pollid) AND (voteid=$voteID)");
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['poll_desc'] . " SET voters=voters+1 WHERE pollid=$pollid");
		$opnConfig['opnOutput']->Redirect ($forwarder);
		CloseTheOpnDB ($opnConfig);
	} else {
		$opnConfig['opnOutput']->Redirect ($forwarder);
		CloseTheOpnDB ($opnConfig);
	}
	// a lot of browsers can't handle it if there's an empty page
	echo '<html><head></head><body></body></html>';

}

function pollList () {

	global $opnTables, $opnConfig;

	$result = &$opnConfig['database']->Execute ('SELECT pollid, polltitle, wtimestamp, voters FROM ' . $opnTables['poll_desc'] . " ORDER BY wtimestamp");
	$counter = 0;
	$boxtxt = '';
	if ($result !== false) {
		while (! $result->EOF) {
			$resultArray[$counter] = array ($result->fields['pollid'],
							$result->fields['polltitle'],
							$result->fields['wtimestamp'],
							$result->fields['voters']);
			$counter++;
			$result->MoveNext ();
		}
	}
	if (!isset ($resultArray) ) {
		$resultArray = array ();
		$boxtxt .= _POLL_NOACTIVEPOLL;
	} else {
		$table = & new opn_TableClass ('default');
		$themax = count ($resultArray);
		for ($count = 0; $count<$themax; $count++) {
			$id = $resultArray[$count][0];
			$pollTitle = $resultArray[$count][1];
			$result2 = &$opnConfig['database']->Execute ('SELECT SUM(optioncount) AS summe FROM ' . $opnTables['poll_data'] . " WHERE pollid=$id");
			$sum = $result2->fields['summe'];
			$hlp = '<ul><li>';
			$hlp .= ' <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/poll/pollbooth.php',
											'pollid' => $id) ) . '">' . $pollTitle . '</a> ';
			$hlp .= '</li></ul>';
			$hlp1 = '(<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/poll/pollbooth.php',
											'op' => _POLL_RESULT,
											'pollid' => $id) ) . '">' . _POLL_POLLBOOTHRESULTS . '</a> - ' . $sum . '&nbsp;' . _POLL_MAINVOTES . ')';
			$table->AddDataRow (array ($hlp, $hlp1) );
		}
		$table->GetTable ($boxtxt);
	}
	return $boxtxt;

}

function poll_mk_percbar ($myperc, $mycolor, $tbheight = 10, $tbwidth = '100%') {

	$rmyperc = round ($myperc, 0);
	$boxtxt = '<table  width="' . $tbwidth . '" height="' . $tbheight . '" border="0" cellspacing="0" cellpadding="0">';
	if ($myperc >= 100) {
		$boxtxt .= '<tr class="' . $mycolor . '"><td width="100%" class="' . $mycolor . 'bg">';
	} elseif ($myperc<=0) {
		$boxtxt .= '<tr><td width="100%"><span class="sideboxsmalltext">&nbsp;</span>';
	} else {
		$boxtxt .= '<tr class="' . $mycolor . '">' . '<td width="' . $rmyperc . '%" class="' . $mycolor . 'bg">' . '</td><td width="' . (100- $rmyperc) . '%">';
	}
	$boxtxt .= '</td></tr></table>';
	return $boxtxt;

}

function pollResults ($pollid, $sidebox = false) {

	global $opnConfig, $opnTables;

	$boxtxt = '';
	if (!isset ($pollid) ) {
		$pollid = 1;
	}
	if ($sidebox) {
		$css1 = 'sidebox';
		$css2 = 'opnsidebox';
	} else {
		$css1 = '';
		$css2 = 'opncenterbox';
	}
	$result = &$opnConfig['database']->Execute ('SELECT polltitle, wtimestamp FROM ' . $opnTables['poll_desc'] . " WHERE pollid=$pollid");
	$holdtitle = $result->fields['polltitle'];
	$result->Close ();
	$boxtxt .= '<br /><span class="normaltextbold">' . $holdtitle . '</span><br /><br />';
	$result = &$opnConfig['database']->Execute ('SELECT SUM(optioncount) AS summe FROM ' . $opnTables['poll_data'] . " WHERE pollid=$pollid");
	$sum = $result->fields['summe'];
	$result->Close ();
	$table = & new opn_TableClass ('alternator');
	$table->AddCols (array ('20%', '60%', '20%') );
	// select next vote option
	$result = &$opnConfig['database']->Execute ('SELECT pollid, optiontext, optioncount, voteid FROM ' . $opnTables['poll_data'] . " WHERE (pollid=$pollid) AND (optiontext <> '')");
	$i = 0;
	while (! $result->EOF) {
		$optionText = $result->fields['optiontext'];
		$optionCount = $result->fields['optioncount'];
		if ($optionText != '') {
			$mycolor = ($i == 0?'alternator2' : 'alternator1');
			if ($sum) {
				$percent = 100* $optionCount/ $sum;
			} else {
				$percent = 0;
			}
			$table->AddOpenRow ();
			if (!$sidebox) {
				$hlp = $optionText;
			} else {
				$hlp = '<span class="sideboxsmalltext">' . $optionText . '</span>';
			}
			$table->AddDataCol ($hlp);
			$table->AddDataCol (poll_mk_percbar ($percent, $mycolor) );
			$table->AddDataCol (' ' . round ($percent, 2) . ' % (' . $optionCount . ')', 'right');
			$table->AddCloseRow ();
			$i = ($mycolor == 'alternator2'?1 : 0);
		}
		$result->MoveNext ();
	}
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br />';
	$boxtxt .= '<div align="center"><span class="' . $css1 . 'normaltext">' . _POLL_POLLBOOTHTOTALVOTES . ': ' . $sum . '</span><br />';
	if ($opnConfig['setCookies'] == 0) {
		$boxtxt .= '<span class="' . $css1 . 'smalltext">' . _POLL_POLLBOOTHWEALLOWJUST . '</span><br /><br />';
	} else {
		$boxtxt .= '<br /><br />';
	}
	$booth = $pollid;
	$boxtxt .= '<span class="' . $css1 . 'smalltext">[ <a class="' . $css2 . '" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/poll/pollbooth.php',
														'pollid' => $booth) ) . '">' . _POLL_POLLBOOTHVOTINGBOOTH . '</a> | ';
	$boxtxt .= '<a class="' . $css2 . '" href="' . $opnConfig['opn_url'] . '/modules/poll/pollbooth.php">' . _POLL_POLLBOTHOTHERPOLLS . '</a> ]</span></div>';
	return $boxtxt;

}

function pollShow ($pollid) {

	global $opnConfig, $opnTables;

	$query = 'SELECT polltitle, voters FROM ' . $opnTables['poll_desc'] . ' WHERE pollid=' . $pollid;
	$result = &$opnConfig['database']->Execute ($query);
	$pollTitle = $result->fields['polltitle'];
	$voters = $result->fields['voters'];
	$url[0] = $opnConfig['opn_url'] . '/modules/poll/pollbooth.php';
	$url['op'] = _POLL_RESULT;
	$url['pollid'] = $pollid;
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_POLL_140_', 'poll');
	$form->Init ($opnConfig['opn_url'] . '/modules/poll/pollbooth.php');
	$form->AddHidden ('pollid', $pollid);
	$form->AddHidden ('forwarder', encodeurl ($url) );
	$form->AddText ('<span class="normaltextbold">' . $pollTitle . '</span><br /><br />');
	$result = &$opnConfig['database']->Execute ('SELECT pollid, optiontext, optioncount, voteid FROM ' . $opnTables['poll_data'] . " WHERE (pollid=$pollid) AND (optiontext <> '')");
	$i = 0;
	while (! $result->EOF) {
		$myrow = $result->GetRowAssoc ('0');
		if ($myrow['optiontext'] != '') {
			$i++;
			$form->AddRadio ('voteID', $myrow['voteid'], 0, '', 'voteID' . $i);
			$form->AddText ($myrow['optiontext'] . '<br />');
		}
		$result->MoveNext ();
	}
	$form->AddText ('<br /><div class="centertag"><table  cellspacing="0" cellpadding="5" border="0" width="111"><tr class="opncenterbox"><td class="opncenterbox">');
	$form->AddSubmit ('voteone', _POLL_VOTE);
	$form->AddText ('</td>');
	if ($opnConfig['opn_poll_seperate_rows'] == 1) {
		$form->AddText ('</tr><tr class="opncenterbox">');
	}
	$form->AddText ('<td class="opncenterbox">');
	$form->AddSubmit ('op', _POLL_RESULT);
	$form->AddText ('</td></tr></table></div>');
	$form->AddFormEnd ();
	$boxContent = '';
	$form->GetFormular ($boxContent);
	$boxContent .= '<span class="sideboxsmalltextbold"><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/poll/pollbooth.php">' . _POLL_MAINLASTSURVEYS . '</a></span><br />';
	if ($opnConfig['pollcomm']) {
		$r = &$opnConfig['database']->Execute ('SELECT COUNT(sid) AS counter FROM ' . $opnTables['poll_comments'] . " WHERE sid=$pollid");
		if ( ($r !== false) && (isset ($r->fields['counter']) ) ) {
			$numcom = $r->fields['counter'];
		} else {
			$numcom = 0;
		}
		$boxContent .= '<br /><div class="centertag">' . _POLL_MAINVOTES . ' <strong>' . $voters . '</strong><br />' . _POLL_MAINCOMMENTS . '  <strong>' . $numcom . '</strong></div>';
	} else {
		$boxContent .= '<br /><div class="centertag">' . _POLL_MAINVOTES . ' <strong>' . $voters . '</strong></div>';
	}
	$boxContent .= '</div>';
	return ($boxContent);

}

?>