<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/quizz', true);
getLanguageDef (_OPN_ROOT_PATH . 'modules/quizz/admin/language/');
define ('_QUIADM_QUIVERSION', '1.6');
define ('_QUIADM_QUIFOOTER', _QUIADM_TITLE . '&nbsp;' . _QUIADM_QUIVERSION . ' - Credits');

function QuizConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_QUIADM_ADMIN);
	$menu->InsertEntry (_QUIADM_MAIN, $opnConfig['opn_url'] . '/modules/quizz/admin/index.php');
	$menu->InsertEntry (_QUIADM_NEW, array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
						'act' => 'QuizAdd') );
	$menu->InsertEntry (_QUIADM_SETTINGS, $opnConfig['opn_url'] . '/modules/quizz/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function quimk_percbar ($myperc, $dcol, $tbheight = 10, $tbwidth = '100%') {

	$rmyperc = round ($myperc, 0);
	$d = ($dcol == 1?'alternator2' : 'alternator1');
	$boxtxt = '<table width="' . $tbwidth . '" style="height:' . $tbheight . 'px" border="0" cellspacing="0" cellpadding="0">';
	if ($myperc >= 100) {
		$boxtxt .= '<tr><td width="100%" class="' . $d . '">';
	} elseif ($myperc<=0) {
		$boxtxt .= '<tr><td width="100%"><span class="smalltext">&nbsp;</span>';
	} else {
		$boxtxt .= '<tr><td width="' . $rmyperc . '%" class="' . $d . '">' . '</td><td width="' . (100- $rmyperc) . '%">';
	}
	$boxtxt .= '</td></tr></table>';
	return $boxtxt;

}

/****************************************************/

/* Quiz Functions				   */

/**************************************************/

function QuizAdmin () {

	global $opnConfig, $opnTables;

	QuizConfigHeader ();
	$table = & new opn_TableClass ('alternator');
	$table->AddOpenHeadRow ();
	$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php?act=QuizAdd') . '"> [ ' . _QUIADM_NEW . ' ]</a>', '', '2');
	$table->AddCloseRow ();
	$sql = 'SELECT qa.quizzid AS quizzid, qa.quizztitle AS quizztitle, qa.wactive AS wactive, qc.name AS name FROM ' . $opnTables['quizz_admin'] . ' qa , ' . $opnTables['quizz_categories'] . ' qc' . ' WHERE qa.cid = qc.cid' . ' ORDER BY qa.wtimestamp DESC';
	$result = &$opnConfig['database']->Execute ($sql);
	while (! $result->EOF) {
		$qid = $result->fields['quizzid'];
		$quizzTitle = $result->fields['quizztitle'];
		$active = $result->fields['wactive'];
		$category = $result->fields['name'];
		if ($active == 1) {
			$hlp = _QUIADM_ACTIVE;
		} else {
			$hlp = _QUIADM_INACTIVE;
		}
		$hlp1 = '<span class="%alternateextra%">' . _QUIADM_TITLE . ' ' . $qid . ' : ';
		$hlp1 .= '"' . $quizzTitle . '" ';
		$hlp1 .= '(' . $category . ')</span><br />';
		$hlp1 .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/index.php',
									'qid' => $qid) ) . '" target="_blank"> [ ' . _QUIADM_SEE . ' ]</a> | ';
		$hlp1 .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
									'act' => 'QuizViewScore',
									'qid' => $qid) ) . '"> [ ' . _QUIADM_VIEWSCORE . ' ]</a> | ';
		$hlp1 .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
									'act' => 'QuizRemoveScore',
									'qid' => $qid) ) . '"> [ ' . _QUIADM_DELSCORE . ' ]</a> | ';
		$hlp1 .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
									'act' => 'QuizViewStats',
									'qid' => $qid) ) . '"> [ ' . _QUIADM_VIEWSTAT . ' ]</a><br />';
		$hlp1 .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
									'act' => 'QuizModify',
									'qid' => $qid) ) . ' ';
		$hlp1 .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
									'act' => 'QuizRemove',
									'qid' => $qid) );
		$table->AddDataRow (array ($hlp, $hlp1) );
		$result->MoveNext ();
	}
	$boxtxt = '';
	$table->GetTable ($boxtxt);

	#-----------------------------------------------------------------------------------------------

	# display if available the contributor questions

	$sql = 'SELECT pollid, polltitle, qid FROM ' . $opnTables['quizz_descontrib'] . ' ORDER BY qid';
	$result = &$opnConfig['database']->Execute ($sql);
	if (!$result->EOF) {
		$boxtxt2 = '<br />';
		$boxtxt2 .= '<div align="center" class="bigtextbold">' . _QUIADM_ADDCONTRIB . '</div>';
		$table = & new opn_TableClass ('alternator');
		while (! $result->EOF) {
			$pollID = $result->fields['pollid'];
			$pollTitle = $result->fields['polltitle'];
			$qid = $result->fields['qid'];
			$table->AddDataRow (array (_QUIADM_TITLE . ' ' . $qid . ' : ' . '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php', 'act' => 'QuizAddContrib', 'pid' => $pollID, 'qid' => $qid) ) . '">' . $pollTitle . '</a>') );
			$result->MoveNext ();
		}
		$table->GetTable ($boxtxt2);
	} else {
		$boxtxt2 = '';
	}
	$boxtxt .= $boxtxt2 . '<br />';

	#-----------------------------------------------------------------------------------------------

	$boxtxt .= '<div align="center" class="bigtextbold">' . _QUIADM_ADDCAT . '</div>';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QUIZZ_10_', 'quizz');
	$form->Init ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('CatName', _QUIADM_CAT);
	$form->AddTextfield ('CatName', 30, 50);
	$form->AddChangeRow ();
	$form->AddLabel ('CatComment', _QUIADM_COMMENT);
	$form->SetSameCol ();
	$form->AddTextfield ('CatComment', 30, 255);
	$form->AddText (' (*)');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('CatImage', _QUIADM_CATIMAGE);
	$form->SetSameCol ();
	$form->AddTextfield ('CatImage', 30, 50);
	$form->AddText (' (*)');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddHidden ('act', 'createPostedQuizCategory');
	$form->AddSubmit ('submity', _QUIADM_ADD);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<span class="normaltext">* : ' . _QUIADM_HELPOPTION . '</span>';

	#-----------------------------------------------------------------------------------------------

	$boxtxt .= '<br />';
	$boxtxt .= '<div align="center" class="bigtextbold">' . _QUIADM_DELCAT . '</div>';
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QUIZZ_20_', 'quizz');
	$form->Init ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('cid', _QUIADM_CAT);
	$sql = 'SELECT cid, name FROM ' . $opnTables['quizz_categories'];
	$result = &$opnConfig['database']->Execute ($sql);
	$form->AddSelectDB ('cid', $result);
	$form->AddChangeRow ();
	$form->AddHidden ('act', 'QuizDelCategory');
	$form->AddSubmit ('submity', _QUIADM_DELETE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);

	#-----------------------------------------------------------------------------------------------

	$boxtxt .= '<br />';
	$boxtxt .= '<br /><div align="center" class="bigtextbold">' . _QUIADM_MODIFYCAT . '</div>';
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QUIZZ_30_', 'quizz');
	$form->Init ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('cid', _QUIADM_CAT);
	$sql = 'SELECT cid, name FROM ' . $opnTables['quizz_categories'];
	$result = &$opnConfig['database']->Execute ($sql);
	$form->AddSelectDB ('cid', $result);
	$form->AddChangeRow ();
	$form->AddHidden ('act', 'QuizModifyCategory');
	$form->AddSubmit ('submity', _QUIADM_MODIFY);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_40_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function QuizRemoveScore () {

	global $opnConfig;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	QuizConfigHeader ();
	$boxtxt = '<div class="centertag"><span class="extratextbold">' . _QUIADM_ADMIN . '</span></div>';
	$boxtxt .= '<br />';
	$boxtxt .= '<div class="centertag"><span class="normaltext">' . _QUIADM_SURE2DELETESCORE . ' ' . $qid . '?<br /><br />' . '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
																				'act' => 'deletePostedScoreQuiz',
																				'qid' => $qid) ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a href="' . encodeurl ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php?act=QuizAdmin') . '">' . _NO . '</a></span></div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_50_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function QuizViewScore () {

	global $opnConfig, $opnTables;

	QuizConfigHeader ();
	$qid = 0;
	get_var ('qid', $qid, 'both', _OOBJ_DTYPE_INT);
	$nblots = 0;
	get_var ('nblots', $nblots, 'both', _OOBJ_DTYPE_INT);
	if ($nblots<=0) {
		$nblots = 10;
	}
	$sql = 'SELECT quizztitle, voters FROM ' . $opnTables['quizz_admin'] . ' WHERE quizzid=' . $qid;
	$result = &$opnConfig['database']->Execute ($sql);

	#	$quizzTitle = $result->fields['quizztitle'];

	$nbscore = $result->fields['voters'];
	$boxtxt = '<div align="center" class="bigtextbold">' . _QUIADM_LISTSCORE . '</div>';
	$boxtxt .= '<br />';

	# display the best scores

	$sql = 'SELECT username, score FROM ' . $opnTables['quizz_check'] . ' WHERE qid=' . $qid . ' ORDER BY score DESC,wtime DESC';
	$result = &$opnConfig['database']->SelectLimit ($sql, $nbscore);
	if ($result->RecordCount ()>0) {
		$table = & new opn_TableClass ('alternator');
		$table->AddHeaderRow (array (_QUIADM_LOGNAME, _QUIADM_LISTSCORE, _QUIADM_MODIFY) );
		while (! $result->EOF) {
			$username = $result->fields['username'];
			$res = $result->fields['score'];
			$table->AddDataRow (array ($username, $res, '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php', 'act' => 'QuizViewScoreDelete', 'qid' => $qid, 'username' => $username, 'score' => $res) ) . '">' . _QUIADM_DELETE . '</a>'), array ('left', 'center', 'center') );
			$result->MoveNext ();
		}
		$table->GetTable ($boxtxt);
	}
	$boxtxt .= '<br /><br />';

	# display the drawings lots

	$form = & new opn_FormularClass ('alternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QUIZZ_60_', 'quizz');
	$form->Init ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php');
	$form->AddTable ();
	$form->AddOpenHeadRow ();
	$form->AddHeaderCol (_QUIADM_LOTS, '', '3');
	$form->AddCloseRow ();

	# perform the drawings lots if needed
	if ($nblots) {
		$form->AddOpenHeadRow ();
		$form->AddHeaderCol (_QUIADM_ANDTHEWINNERSARE . ' :', 'left', '3');
		$form->AddCloseRow ();
		$sql = 'SELECT username, score, email FROM ' . $opnTables['quizz_check'] . ' WHERE qid=' . $qid . ' ORDER BY score DESC';
		$result = &$opnConfig['database']->SelectLimit ($sql, $nblots);
		while (! $result->EOF) {
			$form->AddOpenRow ();
			$username = $result->fields['username'];
			$score = $result->fields['score'];
			$email = $result->fields['email'];
			$form->AddText ($username);
			$form->AddText ('(' . $score . ')');
			$form->AddText ($email);
			$form->AddCloseRow ();
			$result->MoveNext ();
		}
	} else {
		$nblots = 10;
	}
	$form->AddOpenRow ();
	$form->SetColspan ('3');
	$form->SetSameCol ();
	$form->AddText (_QUIADM_NBWINNERS . ' ');
	$form->AddTextfield ('nblots', $nblots, 3);
	$form->AddHidden ('act', 'QuizViewScore');
	$form->AddHidden ('qid', $qid);
	$form->AddSubmit ('submity', _QUIADM_LAUNCH);
	$form->SetEndCol ();
	$form->SetColspan ('');
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<div class="centertag"><a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php?act=QuizAdmin') . '"> [ ' . _QUIADM_ADMIN . ' ]</a></div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_70_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function QuizViewStats () {

	global $opnConfig, $opnTables;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	QuizConfigHeader ();
	$boxtxt = '<div align="center" class="bigtextbold">' . _QUIADM_LISTSTATS . '</div>';
	$boxtxt .= '<br />';
	$sql = 'SELECT quizztitle, voters FROM ' . $opnTables['quizz_admin'] . ' WHERE quizzid=' . $qid;
	$result = &$opnConfig['database']->Execute ($sql);

	#	$quizzTitle = $result->fields['quizztitle'];

	$voters = $result->fields['voters'];
	$sql = 'SELECT MAX(score) as maxscore, MIN(score) as minscore, AVG(score) as avgscore FROM ' . $opnTables['quizz_check'] . ' WHERE qid=' . $qid;
	$result = &$opnConfig['database']->Execute ($sql);
	$max = $result->fields['maxscore'];
	$min = $result->fields['minscore'];
	$mean = $result->fields['avgscore'];
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php?act=QuizAdmin') . '"> [ ' . _QUIADM_ADMIN . ' ]</a><br /><br />';
	$table = & new opn_TableClass ('default');
	$table->AddCols (array ('15%', '10%', '75%') );
	$table->AddDataRow (array ('<span class="normaltextbold">' . _QUIADM_NBVOTE . ' : </span>', '<span class="normaltextbold">' . $voters . '</span>') );
	$table->AddDataRow (array ('&nbsp;', '&nbsp;') );
	$table->AddDataRow (array (_QUIADM_MEANSCORE . ' : ', '<span class="normaltextbold">' . number_format ($mean, 2, _QUIADM_DEC_POINT, _QUIADM_THOUSANDS_SEP) . '</span>'), array ('left', 'right') );
	$table->AddDataRow (array (_QUIADM_MINSCORE . ' : ', '<span class="normaltextbold">' . number_format ($min, 2, _QUIADM_DEC_POINT, _QUIADM_THOUSANDS_SEP) . '</span>'), array ('left', 'right') );
	$table->AddDataRow (array (_QUIADM_MAXSCORE . ' : ', '<span class="normaltextbold">' . number_format ($max, 2, _QUIADM_DEC_POINT, _QUIADM_THOUSANDS_SEP) . '</span>'), array ('left', 'right') );
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddCols (array ('20%', '10%', '10%', '60%') );
	$sql = 'SELECT pollid, polltitle FROM ' . $opnTables['quizz_desc'] . ' WHERE qid=' . $qid;
	$result1 = &$opnConfig['database']->Execute ($sql);
	$count = 0;
	while (! $result1->EOF) {
		$pollID = $result1->fields['pollid'];
		$question = $result1->fields['polltitle'];
		$count++;
		$table->AddOpenHeadRow ();
		$table->AddHeaderCol (wordwrap (_QUIADM_QUESTION . ' ' . $count . ' : "' . $question, 90, '<br />', 1), 'left', '4');
		$table->AddCloseRow ();
		$sql = 'SELECT SUM(optioncount) AS summ FROM ' . $opnTables['quizz_data'] . ' WHERE pollid=' . $pollID;
		$result = &$opnConfig['database']->Execute ($sql);
		$sum = (int) $result->fields['summ'];
		$dcol1 = '1';
		$dcol2 = '2';
		$a = 0;

		/* cycle through all options */

		for ($i = 1; $i<=12; $i++) {
			$dcolor = ($a == 0? $dcol1 : $dcol2);

			/* select next vote option */

			$_pollID = $opnConfig['opnSQL']->qstr ($pollID);
			$_i = $opnConfig['opnSQL']->qstr ($i);
			$sql = 'SELECT optiontext, optioncount FROM ' . $opnTables['quizz_data'] . " WHERE (pollid=$_pollID) AND (voteid=$_i)";
			$result = &$opnConfig['database']->Execute ($sql);
			if (is_object ($result) ) {
				$optionText = $result->fields['optiontext'];
				$optionCount = $result->fields['optioncount'];
				if ($optionText != '') {
					$table->AddOpenRow ();
					$table->AddDataCol ($optionText, 'left');
					if ($sum) {
						$percent = 100* $optionCount/ $sum;
					} else {
						$percent = 0;
					}
					$table->AddDataCol ('( ' . number_format ($optionCount, 0, _QUIADM_DEC_POINT, _QUIADM_THOUSANDS_SEP) . ' )', 'right');
					$table->AddDataCol (number_format ($percent, 2, _QUIADM_DEC_POINT, _QUIADM_THOUSANDS_SEP) . ' %', 'right');
					$table->AddDataCol (quimk_percbar ($percent, $dcolor), 'left');
					$table->AddCloseRow ();
				}
			}
			$a = ($dcolor == $dcol1?1 : 0);
		}
		$result1->MoveNext ();
	}
	$table->GetTable ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_80_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function QuizModify () {

	global $opnConfig, $opnTables;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	QuizConfigHeader ();
	$sql = 'SELECT quizztitle, nbscore, displayscore, displayresults, emailadmin, comment, image, restrict_user, log_user, wactive, cid, contrib, expire, admemail, administrator, conditions, showafterquizz FROM ' . $opnTables['quizz_admin'] . ' WHERE quizzid=' . $qid;
	$result = &$opnConfig['database']->Execute ($sql);
	$quizzTitle = $result->fields['quizztitle'];
	$nbscore = $result->fields['nbscore'];
	$displayscore = $result->fields['displayscore'];
	$displayresults = $result->fields['displayresults'];
	$emailadmin = $result->fields['emailadmin'];
	$comment = $result->fields['comment'];
	$image = $result->fields['image'];
	$restrict_user = $result->fields['restrict_user'];
	$log_user = $result->fields['log_user'];
	$active = $result->fields['wactive'];
	$cid = $result->fields['cid'];
	$contrib = $result->fields['contrib'];
	$expire = $result->fields['expire'];
	$admemail = $result->fields['admemail'];
	$administrator = $result->fields['administrator'];
	$conditions = $result->fields['conditions'];
	$showafterquizz = $result->fields['showafterquizz'];
	$boxtxt = '<div align="center" class="bigtextbold">' . _QUIADM_MODIFY . '</div>';
	$boxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QUIZZ_90_', 'quizz');
	$form->Init ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenHeadRow ();
	$form->AddHeaderCol (_QUIADM_GENINFOS, 'left', '2');
	$form->AddCloseRow ();
	$form->AddOpenRow ();
	$form->AddText ('quizztitle', _QUIADM_TITLE);
	$form->AddTextfield ('quizztitle', 30, 0, $quizzTitle);
	$form->AddChangeRow ();
	$form->AddLabel ('active', _QUIADM_ACTIVE);
	$form->SetSameCol ();
	$form->AddCheckbox ('active', 1, ($active == 1?1 : 0) );
	$form->AddText (' ' . _QUIADM_HELPACTIVE);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('displayscore', _QUIADM_VIEWSCORE);
	$form->SetSameCol ();
	$form->AddCheckbox ('displayscore', 1, ($displayscore == 1?1 : 0) );
	$form->AddText (' ' . _QUIADM_HELPVIEWSCORE);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('displayresults', _QUIADM_VIEWANSWER);
	$form->SetSameCol ();
	$form->AddCheckbox ('displayresults', 1, ($displayresults == 1?1 : 0) );
	$form->AddText (' ' . _QUIADM_HELPANSWER);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('emailadmin', _QUIADM_SENDEMAIL);
	$form->SetSameCol ();
	$form->AddCheckbox ('emailadmin', 1, ($emailadmin == 1?1 : 0) );
	$form->AddText (' ' . _QUIADM_HELPEMAIL);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('contrib', _QUIADM_CONTRIB);
	$form->SetSameCol ();
	$form->AddCheckbox ('contrib', 1, ($contrib == 1?1 : 0) );
	$form->AddText (' ' . _QUIADM_HELPCONTRIB);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('restrict', _QUIADM_ONLYREGISTERED);
	$form->SetSameCol ();
	$form->AddCheckbox ('restrict', 1, ($restrict_user == 1?1 : 0) );
	$form->AddText (' ' . _QUIADM_HELPONLYREGISTERED);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('log', _QUIADM_LIMITVOTE);
	$form->SetSameCol ();
	$form->AddCheckbox ('log', 1, ($log_user == 1?1 : 0) );
	$form->AddText (' ' . _QUIADM_HELPLIMITVOTE);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('nbscore', _QUIADM_NBSCORE);
	$form->SetSameCol ();
	$form->AddTextfield ('nbscore', 3, 0, $nbscore);
	$form->AddText (' ' . _QUIADM_HELPNBSCORE);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('admemail', _QUIADM_ADMEMAIL);
	$form->SetSameCol ();
	$form->AddTextfield ('admemail', 30, 0, $admemail);
	$form->AddText (' (*) ' . _QUIADM_HELPADMEMAIL);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('administrator', _QUIADM_ADMINISTRATOR);
	$form->SetSameCol ();
	$form->AddTextfield ('administrator', 30, 0, $administrator);
	$form->AddText (' (*) ' . _QUIADM_HELPADMINISTRATOR);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('image', _QUIADM_IMAGE);
	$form->SetSameCol ();
	$form->AddTextfield ('image', 30, 0, $image);
	$form->AddText (' (*) ' . _QUIADM_HELPIMAGE);
	$form->SetEndCol ();
	$sql = 'SELECT cid, name FROM ' . $opnTables['quizz_categories'];
	$result = &$opnConfig['database']->Execute ($sql);
	$form->AddChangeRow ();
	$form->AddLabel ('cid', _QUIADM_CAT);
	$form->AddSelectDB ('cid', $result, $cid);

	# expiration date (a lot of code for so few things)

	$opnConfig['opndate']->sqlToopnData ($expire);
	$day = '';
	$opnConfig['opndate']->getDay ($day);
	$month = '';
	$opnConfig['opndate']->getMonth ($month);
	$year = '';
	$opnConfig['opndate']->getYear ($year);
	$hour = '';
	$opnConfig['opndate']->getHour ($hour);
	$minute = '';
	$opnConfig['opndate']->getMinute ($minute);
	$form->AddChangeRow ();
	$form->AddText (_QUIADM_EXPIRATION . ' (*)');
	$form->SetSameCol ();
	$form->AddLabel ('day', _QUIADM_DAY . ': ');
	$options = builddayquiad ();
	$form->AddSelectnokey ('day', $options, $day);
	$form->AddLabel ('month', ' ' . _QUIADM_UMONTH . ': ');
	$options = buildmonthquiad ();
	$form->AddSelectnokey ('month', $options, $month);
	$form->AddLabel ('year', ' ' . _QUIADM_YEAR . ': ');
	$form->AddTextfield ('year', 5, 4, $year);
	$form->AddLabel ('hour', ' ' . _QUIADM_HOUR . ': ');
	$options = buildhourquiad ();
	$form->AddSelectnokey ('hour', $options, $hour);
	$form->AddLabel ('min', ': ');
	$options = buildminutequiad ();
	$form->AddSelectnokey ('min', $options, $minute);
	$now = getnow ();
	$form->AddText ('<br /> (' . _QUIADM_NOWIS . ' : ' . $now . ')');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('comment', _QUIADM_COMMENT . ' (*)');
	$form->AddTextarea ('comment', 0, 0, '', $comment);
	$form->AddChangeRow ();
	$form->AddLabel ('conditions', _QUIADM_CONDITIONS . ' (*)');
	$form->AddTextarea ('conditions', 0, 0, '', $conditions);
	$form->AddChangeRow ();
	$form->AddLabel ('showafterquizz', _QUIADM_SHOWAFTERQUIZZ . ' (*)');
	$form->AddTextarea ('showafterquizz', 0, 0, '', $showafterquizz);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('act', 'modifyPostedQuiz');
	$form->AddHidden ('qid', $qid);
	$form->SetEndCol ();
	$form->AddSubmit ('submity', _QUIADM_MODIFY);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<span class="normaltext">* : ' . _QUIADM_HELPOPTION . '</span><br />';
	$boxtxt .= '<br /><span class="opncenterbox">' . _QUIADM_QUESTIONS . '</span><br />';
	$boxtxt .= '<div class="centertag"><a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
												'act' => 'QuizAddQuestion',
												'qid' => $qid) ) . '"> [ ' . _QUIADM_ADDQUESTION . ' ]</a></div><br />';
	$sql = 'SELECT pollid, polltitle FROM ' . $opnTables['quizz_desc'] . ' WHERE qid=' . $qid;
	$result = &$opnConfig['database']->Execute ($sql);
	$count = 0;
	while (! $result->EOF) {
		$pollID = $result->fields['pollid'];
		$question = $result->fields['polltitle'];
		$count++;
		$boxtxt .= '<div class="opncenterbox">' . _QUIADM_QUESTION . ' ' . $count . ' : ';
		$boxtxt .= '"' . $question . '" ' . $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
												'act' => 'QuizModifyQuestion',
												'pid' => $pollID,
												'qid' => $qid) ) . ' ';
		$boxtxt .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
										'act' => 'QuizDelQuestion',
										'pid' => $pollID,
										'qid' => $qid) ) . '</div>';
		$result->MoveNext ();
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_100_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

function builddayquiad () {

	$xday = 1;
	$options = array ();
	$options['00'] = '00';
	while ($xday<=31) {
		$day = sprintf ("%02d", $xday);
		$options[$day] = $day;
		$xday++;
	}
	return $options;

}

function buildmonthquiad () {

	$xmonth = 1;
	$options = array ();
	$options['00'] = '00';
	while ($xmonth<=12) {
		$month = sprintf ("%02d", $xmonth);
		$options[$month] = $month;
		$xmonth++;
	}
	return $options;

}

function buildhourquiad () {

	$xhour = 0;
	$options = array ();
	while ($xhour<=23) {
		$hour = sprintf ("%02d", $xhour);
		$options[$hour] = $hour;
		$xhour++;
	}
	return $options;

}

function buildminutequiad () {

	$xmin = 0;
	$options = array ();
	while ($xmin<=59) {
		$min = sprintf ("%02d", $xmin);
		$options[$min] = $min;
		$xmin = $xmin+5;
	}
	return $options;

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function getnow () {

	global $opnConfig;

	$opnConfig['opndate']->now ();
	$temp = '';
	$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
	return $temp;

}

function QuizAddContrib () {

	global $opnConfig, $opnTables;

	QuizConfigHeader ();
	$pid = 0;
	get_var ('pid', $pid, 'url', _OOBJ_DTYPE_INT);
	$qid = '';
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_CLEAN);
	$boxtxt = '<div align="center" class="bigtextbold">' . _QUIADM_ADDCONTRIB . '</div>';
	$boxtxt .= '<br />';
	$sql = 'SELECT polltitle, answer, coef, good, bad, comment,image FROM ' . $opnTables['quizz_descontrib'] . ' WHERE pollid=' . $pid;
	$result = &$opnConfig['database']->Execute ($sql);
	$pollTitle = $result->fields['polltitle'];
	$answer = $result->fields['answer'];
	$coef = $result->fields['coef'];
	$good = $result->fields['good'];
	$bad = $result->fields['bad'];
	$comment = $result->fields['comment'];
	$image = $result->fields['image'];
	$pollTitle = preg_replace ("/'/", "&quot;", $pollTitle);

	# check if the answer was ordered
	if (preg_match ('/,/', $answer) ) {
		$array_answer = split (',', $answer);
	}
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QUIZZ_110_', 'quizz');
	$form->Init ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('question', _QUIADM_QUESTIONTITLE . ': ');
	$form->AddTextfield ('question', 50, 250, $pollTitle);
	$form->AddChangeRow ();
	$form->AddLabel ('coef', _QUIADM_COEF);
	$form->AddTextfield ('coef', 3, 0, $coef);
	$form->AddChangeRow ();
	$form->AddLabel ('image', _QUIADM_IMAGE . ' (*)');
	$form->SetSameCol ();
	$form->AddTextfield ('image', 50, 0, $image);
	if ($image <> '') {
		$form->AddText ('&nbsp;<img src="' . $opnConfig['opn_url'] . '/modules/quizz/images/' . $image . '" class="imgtag" alt="' . $image . '" title="' . $image . '">');
	} else {
		$form->AddText ('&nbsp;');
	}
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddTable ('alternator', '2');
	$form->AddCols (array ('20%', '50%', '10%', '20%') );
	$form->AddHeaderRow (array (_QUIADM_QUESTION, '&nbsp;', _QUIADM_ANSWER, '&nbsp;') );
	$sql = 'SELECT optiontext, voteid FROM ' . $opnTables['quizz_datacontrib'] . ' WHERE pollid=' . $pid . ' ORDER BY voteid';
	$result = &$opnConfig['database']->Execute ($sql);

	#	$count=0;

	#	if(!isset($optionText)) {$optionText = '';}

	#	if(!isset($sel)) {$sel = "";}

	$i = 1;
	$sel = '--';
	while (! $result->EOF) {
		$Text = $result->fields['optiontext'];

		#		$voteID = $result->fields['voteid'];

		$form->AddOpenRow ();
		$form->AddLabel ('optionText[' . $i . ']', _QUIADM_OPTION . ' ' . $i . ':');
		$form->AddTextfield ('optionText[' . $i . ']', 50, 200, $Text);
		$form->SetAlign ('center');
		$form->AddRadio ('answer', $i, ($i == 1?1 : 0) );
		$options = array ();
		$options[] = '--';
		for ($j = 1; $j<=12; $j++) {
			if (isset ($array_answer[$i-1]) ) {
				if ($array_answer[$i-1] == $j) {
					$sel = $j;
				}
			}
			$options[] = $j;
		}
		$form->AddSelectnokey ('optionSort[' . $i . ']', $options, $sel);
		$form->SetAlign ('');
		$form->AddCloseRow ();
		$i++;
		$result->MoveNext ();
	}
	$form->AddTableClose ();
	$form->AddChangeRow ();
	$form->AddLabel ('comment', _QUIADM_COMMENT . ' (*)');
	$form->AddTextarea ('comment', 0, 0, '', $comment);
	$form->AddChangeRow ();
	$form->AddLabel ('bad', _QUIADM_IFBADANSWER . ' (*)');
	$form->AddTextarea ('bad', 0, 0, '', $bad);
	$form->AddChangeRow ();
	$form->AddLabel ('good', _QUIADM_IFGOODANSWER . ' (*)');
	$form->AddTextarea ('good', 0, 0, '', $good);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('act', 'createPostedQuizQuestion');
	$form->AddHidden ('qid', $qid);
	$form->AddHidden ('pid', $pid);
	$form->AddHidden ('mode', 'contrib');
	$form->SetEndCol ();
	$form->AddSubmit ('submity', _QUIADM_ADD);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QUIZZ_120_', 'quizz');
	$form->Init ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->SetSameCol ();
	$form->AddHidden ('act', 'deleteContributorQuizQuestion');
	$form->AddHidden ('qid', $qid);
	$form->AddHidden ('pid', $pid);
	$form->SetEndCol ();
	$form->AddSubmit ('submity', _QUIADM_DELCONTRIB);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<span class="normaltext">* : ' . _QUIADM_HELPOPTION . '</span>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_130_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function QuizModifyCategory () {

	global $opnConfig, $opnTables;

	QuizConfigHeader ();
	$cid = 0;
	get_var ('cid', $cid, 'both', _OOBJ_DTYPE_INT);
	$boxtxt = '<div align="center" class="bigtextbold">' . _QUIADM_MODIFYCAT . '</div>';
	$boxtxt .= '<br />';
	$sql = 'SELECT name, comment, image FROM ' . $opnTables['quizz_categories'] . ' WHERE cid=' . $cid;
	$result = &$opnConfig['database']->Execute ($sql);
	$name = $result->fields['name'];
	$comment = $result->fields['comment'];
	$image = $result->fields['image'];
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QUIZZ_140_', 'quizz');
	$form->Init ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('CatName', _QUIADM_CAT);
	$form->AddTextfield ('CatName', 30, 0, $name);
	$form->AddChangeRow ();
	$form->AddLabel ('CatComments', _QUIADM_COMMENT);
	$form->SetSameCol ();
	$form->AddTextfield ('CatComment', 30, 0, $comment);
	$form->AddText (' (*)');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText ('CatImage', _QUIADM_CATIMAGE);
	$form->SetSameCol ();
	$form->AddTextfield ('CatImage', 30, 0, $image);
	$form->AddText (' (*)<img src="' . $opnConfig['opn_url'] . '/modules/quizz/images/' . $image . '" class="imgtag" alt="">');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('act', 'modifyPostedQuizCategory');
	$form->AddHidden ('cid', $cid);
	$form->SetEndCol ();
	$form->AddSubmit ('submity', _QUIADM_MODIFY);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<span class="normaltext">* : ' . _QUIADM_HELPOPTION . '</span>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_150_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function QuizModifyQuestion () {

	global $opnConfig, $opnTables;

	QuizConfigHeader ();
	$pid = 0;
	get_var ('pid', $pid, 'url', _OOBJ_DTYPE_INT);
	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = '<div align="center" class="bigtextbold">' . _QUIADM_MODIFYQUESTION . '</div>';
	$boxtxt .= '<br />';
	$sql = 'SELECT polltitle, answer, coef, good, bad, comment, image FROM ' . $opnTables['quizz_desc'] . ' WHERE pollid=' . $pid;
	$result = &$opnConfig['database']->Execute ($sql);
	$pollTitle = $result->fields['polltitle'];
	$answer = $result->fields['answer'];
	$coef = $result->fields['coef'];
	$good = $result->fields['good'];
	$bad = $result->fields['bad'];
	$comment = $result->fields['comment'];
	$image = $result->fields['image'];
	$pollTitle = preg_replace ("/'/", '&quot;', $pollTitle);

	# check if the answer was ordered
	if (preg_match ('/,/', $answer) ) {
		$array_answer = split (',', $answer);
	} else {
		$array_answer = '';
	}
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QUIZZ_160_', 'quizz');
	$form->Init ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('question', _QUIADM_QUESTIONTITLE . ': ');
	$form->AddTextfield ('question', 50, 250, $pollTitle);
	$form->AddChangeRow ();
	$form->AddLabel ('coef', _QUIADM_COEF);
	$form->AddTextfield ('coef', 3, 0, $coef);
	$form->AddChangeRow ();
	$form->AddLabel ('image', _QUIADM_IMAGE . ' (*)');
	$form->AddTextfield ('image', 50, 0, $image);
	$i = 1;
	$form->AddChangeRow ();
	$form->AddTable ('alternator', '2');
	$form->AddCols (array ('20%', '50%', '10%', '20%') );
	$form->AddHeaderRow (array (_QUIADM_QUESTION, '&nbsp;', _QUIADM_ANSWER, _QUIADM_RANK) );

	#	if(!isset($optionText)) {$optionText = '';}

	#	if(!isset($sel)) {$sel = '';}

	$sql = 'SELECT optiontext, voteid FROM ' . $opnTables['quizz_data'] . ' WHERE pollid=' . $pid . ' ORDER BY voteid';
	$result = &$opnConfig['database']->Execute ($sql);
	while (! $result->EOF) {
		$Text = $result->fields['optiontext'];

		#		$voteID = $result->fields['voteid'];

		$Text = $opnConfig['cleantext']->filter_text ($Text, true, true, 'nohtml');
		$form->AddOpenRow ();
		$form->AddLabel ('optionText[' . $i . ']', _QUIADM_OPTION . ' ' . $i . ':');
		$form->AddTextfield ('optionText[' . $i . ']', 50, 200, $Text);
		$form->SetAlign ('center');
		$form->AddRadio ('answer', $i, ($answer == $i?1 : 0) );
		$options = array ();
		$options[] = '--';
		$sel = '--';
		for ($j = 1; $j<=12; $j++) {
			if (is_array ($array_answer) ) {
				if (isset ($array_answer[$i-1]) ) {
					if ($array_answer[$i-1] == $j) {
						$sel = $j;
					}
				}
			}
			$options[] = $j;
		}
		$form->AddSelectnokey ('optionSort[' . $i . ']', $options, $sel);
		$form->SetAlign ('');
		$form->AddCloseRow ();
		$i++;
		$result->MoveNext ();
	}
	$form->AddTableClose ();
	$form->AddChangeRow ();
	$form->AddLabel ('comment', _QUIADM_COMMENT . ' (*)');
	$form->AddTextarea ('comment', 0, 0, '', $comment);
	$form->AddChangeRow ();
	$form->AddLabel ('bad', _QUIADM_IFBADANSWER . ' (*)');
	$form->AddTextarea ('bad', 0, 0, '', $bad);
	$form->AddChangeRow ();
	$form->AddLabel ('good', _QUIADM_IFGOODANSWER . ' (*)');
	$form->AddTextarea ('good', 0, 0, '', $good);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('act', 'modifyPostedQuizQuestion');
	$form->AddHidden ('qid', $qid);
	$form->AddHidden ('pid', $pid);
	$form->SetEndCol ();
	$form->AddSubmit ('submity', _QUIADM_MODIFYQUESTION);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<span class="normaltext">* : ' . _QUIADM_HELPOPTION . '</span>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_170_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

/****************************************************/

/* Quiz Functions				   */

/**************************************************/

function modifyPostedQuizQuestion () {

	global $opnConfig, $opnTables;

	$question = '';
	get_var ('question', $question, 'form', _OOBJ_DTYPE_CHECK);
	$optionText = '';
	get_var ('optionText', $optionText, 'form', _OOBJ_DTYPE_CHECK);
	$qid = 0;
	get_var ('qid', $qid, 'form', _OOBJ_DTYPE_INT);
	$answer = '';
	get_var ('answer', $answer, 'form', _OOBJ_DTYPE_CLEAN);
	$coef = 0;
	get_var ('coef', $coef, 'form', _OOBJ_DTYPE_INT);
	$good = '';
	get_var ('good', $good, 'form', _OOBJ_DTYPE_CLEAN);
	$bad = '';
	get_var ('bad', $bad, 'form', _OOBJ_DTYPE_CLEAN);
	$pid = 0;
	get_var ('pid', $pid, 'form', _OOBJ_DTYPE_INT);
	$comment = '';
	get_var ('comment', $comment, 'form', _OOBJ_DTYPE_CHECK);
	$optionSort = '';
	get_var ('optionSort', $optionSort, 'form', _OOBJ_DTYPE_CLEAN);
	$image = '';
	get_var ('image', $image, 'form', _OOBJ_DTYPE_CLEAN);
	$question = $opnConfig['cleantext']->filter_text ($question, true, true, 'nohtml');
	$good = $opnConfig['cleantext']->filter_text ($good, true, true);
	$bad = $opnConfig['cleantext']->filter_text ($bad, true, true);
	$comment = $opnConfig['cleantext']->filter_text ($comment, true, true);
	opn_nl2br ($question);
	opn_nl2br ($good);
	opn_nl2br ($bad);
	opn_nl2br ($comment);
	$question = $opnConfig['opnSQL']->qstr ($question);
	$good = $opnConfig['opnSQL']->qstr ($good, 'good');
	$bad = $opnConfig['opnSQL']->qstr ($bad, 'bad');
	$comment = $opnConfig['opnSQL']->qstr ($comment, 'comment');
	$ordered_answer = implode (',', $optionSort);
	$ordered_answer = preg_replace ("/,--|--,|--/", '', $ordered_answer);

	# check if sorted answer is needed
	if (!empty ($ordered_answer) ) {

		# check if all availaible answers are sorted
		$themax = sizeof ($optionText);
		for ($i = 1; $i<=$themax; $i++) {
			if ( (!empty ($optionText[$i]) and $optionSort[$i] == '--') or (empty ($optionText[$i]) and $optionSort[$i] != '--') ) {
				QuizConfigHeader ();
				$boxtxt = Quizheader ();
				$boxtxt = '<div class="centertag"><span class="normaltext">' . _QUIADM_INCORRECTORDER . '</span></div>';
				$_display_dat = array ();
				$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_180_';
				$_display_dat['module'] = 'modules/quizz';
				$opnConfig['opnOutput']->SetDisplay ($_display_dat);
				unset ($_display_dat);
				$opnConfig['opnOutput']->DisplayCenterbox (_QUI_DESC, '<br />' . $boxtxt, _QUI_QUIFOOTER);
				exit;
			}
		}

		# change the answer the the ordered answer

		$answer = $ordered_answer;
	}
	$answer = $opnConfig['opnSQL']->qstr ($answer);

	# update general information about current question ...

	$_image = $opnConfig['opnSQL']->qstr ($image);
	$sql = 'UPDATE ' . $opnTables['quizz_desc'] . " SET polltitle=$question, answer=$answer, coef=$coef, good=$good, bad=$bad, comment=$comment, image=$_image WHERE pollid=$pid";
	$opnConfig['database']->Execute ($sql);
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['quizz_desc'], 'pollid=' . $pid);
	$themax = sizeof ($optionText);
	for ($i = 1; $i<=$themax; $i++) {
		if ($optionText[$i] != '') {
			$optionText[$i] = $opnConfig['opnSQL']->qstr ($optionText[$i]);
		} else {
			$optionText[$i] = "''";
		}
		$sql = 'UPDATE ' . $opnTables['quizz_data'] . " SET optiontext=$optionText[$i] WHERE (voteid=$i) AND (pollid=$pid)";
		$opnConfig['database']->Execute ($sql);
	}
	set_var ('qid', $qid, 'url');
	QuizModify ();

}

/*********************************************************/

/* Quiz Functions										*/

/*********************************************************/

function QuizAddQuestion () {

	global $opnConfig;

	QuizConfigHeader ();
	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = '<div align="center" class="bigtextbold">' . _QUIADM_ADDQUESTION . '</div>';
	$boxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QUIZZ_190_', 'quizz');
	$form->Init ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('question', _QUIADM_QUESTIONTITLE . ': ');
	$form->AddTextfield ('question', 50, 250, '???');
	$form->AddChangeRow ();
	$form->AddLabel ('coef', _QUIADM_COEF);
	$form->AddTextfield ('coef', 3, 0, '1');
	$form->AddChangeRow ();
	$form->AddLabel ('image', _QUIADM_IMAGE . ' (*)');
	$form->AddTextfield ('image', 50);
	$form->AddChangeRow ();
	$form->AddTable ('alternator', '2');
	$form->AddCols (array ('20%', '50%', '10%', '20%') );
	$form->AddHeaderRow (array (_QUIADM_QUESTION, '&nbsp;', _QUIADM_ANSWER, _QUIADM_RANK) );

	#	if(!isset($optionText)) {$optionText = '';}

	#	if(!isset( $sel)) { $sel = '';}

	$options[] = '--';
	for ($j = 1; $j<=12; $j++) {
		$options[] = $j;
	}
	for ($i = 1; $i<=12; $i++) {
		$form->AddOpenRow ();
		$form->AddLabel ('optionText[' . $i . ']', _QUIADM_OPTION . ' ' . $i . ':');
		$form->AddTextfield ('optionText[' . $i . ']', 50, 200);
		$form->SetAlign ('center');
		$form->AddRadio ('answer', $i, ($i == 1?1 : 0) );
		$form->AddSelectnokey ('optionSort[' . $i . ']', $options);
		$form->SetAlign ('');
		$form->AddCloseRow ();
	}
	$form->AddTableClose ();
	$form->AddChangeRow ();
	$form->AddLabel ('comment', _QUIADM_COMMENT . ' (*)');
	$form->AddTextarea ('comment');
	$form->AddChangeRow ();
	$form->AddLabel ('bad', _QUIADM_IFBADANSWER . ' (*)');
	$form->AddTextarea ('bad');
	$form->AddChangeRow ();
	$form->AddLabel ('good', _QUIADM_IFGOODANSWER . ' (*)');
	$form->AddTextarea ('good');
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('act', 'createPostedQuizQuestion');
	$form->AddHidden ('qid', $qid);
	$form->SetEndCol ();
	$form->AddSubmit ('submity', _QUIADM_ADDQUESTION);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<span class="normaltext">* : ' . _QUIADM_HELPOPTION . '</span>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_200_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function QuizAdd () {

	global $opnConfig, $opnTables;

	QuizConfigHeader ();
	$boxtxt = '<div align="center" class="bigtextbold">' . _QUIADM_NEW . '</div>';
	$boxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QUIZZ_210_', "quizz");
	$form->Init ($opnConfig['opn_url'] . "/modules/quizz/admin/index.php");
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('quizztitle', _QUIADM_TITLE);
	$form->AddTextfield ('quizztitle', 30);
	$form->AddChangeRow ();
	$form->AddLabel ('displayresults', _QUIADM_VIEWANSWER);
	$form->SetSameCol ();
	$form->AddCheckbox ('displayresults', 1, 1);
	$form->AddText (' ' . _QUIADM_HELPANSWER);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('displayscore', _QUIADM_VIEWSCORE);
	$form->SetSameCol ();
	$form->AddCheckbox ('displayscore', 1, 1);
	$form->AddText (' ' . _QUIADM_HELPVIEWSCORE);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('emailadmin', _QUIADM_SENDEMAIL);
	$form->SetSameCol ();
	$form->AddCheckbox ('emailadmin', 1, 1);
	$form->AddText (' ' . _QUIADM_HELPEMAIL);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('restrict', _QUIADM_ONLYREGISTERED);
	$form->SetSameCol ();
	$form->AddCheckbox ('restrict', 1, 1);
	$form->AddText (' ' . _QUIADM_HELPONLYREGISTERED);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('log', _QUIADM_LIMITVOTE);
	$form->SetSameCol ();
	$form->AddCheckbox ('log', 1, 1);
	$form->AddText (' ' . _QUIADM_HELPLIMITVOTE);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('contrib', _QUIADM_CONTRIB);
	$form->SetSameCol ();
	$form->AddCheckbox ('contrib', 1, 1);
	$form->AddText (' ' . _QUIADM_HELPCONTRIB);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('nbscore', _QUIADM_NBSCORE);
	$form->SetSameCol ();
	$form->AddTextfield ('nbscore', 3, 0, '10');
	$form->AddText (' ' . _QUIADM_HELPNBSCORE);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('admemail', _QUIADM_ADMEMAIL);
	$form->SetSameCol ();
	$form->AddTextfield ('admemail', 30);
	$form->AddText (' (*) ' . _QUIADM_HELPADMEMAIL);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('administrator', _QUIADM_ADMINISTRATOR);
	$form->SetSameCol ();
	$form->AddTextfield ('administrator', 30);
	$form->AddText (' (*) ' . _QUIADM_HELPADMINISTRATOR);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('image', _QUIADM_IMAGE);
	$form->SetSameCol ();
	$form->AddTextfield ('image', 30);
	$form->AddText (' (*) ' . _QUIADM_HELPIMAGE);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('cid', _QUIADM_CAT);
	$sql = 'SELECT cid, name from ' . $opnTables['quizz_categories'] . "";
	$result = &$opnConfig['database']->Execute ($sql);
	$form->AddSelectDB ('cid', $result);
	$form->AddChangeRow ();
	$form->AddText (_QUIADM_EXPIRATION . ' (*)');
	$form->SetSameCol ();
	$form->AddLabel ('day', ' ' . _QUIADM_DAY . ': ');
	$options = builddayquiad ();
	$form->AddSelectnokey ('day', $options);
	$form->AddLabel ('month', ' ' . _QUIADM_UMONTH . ': ');
	$options = buildmonthquiad ();
	$form->AddSelectnokey ('month', $options);
	$form->AddLabel ('year', ' ' . _QUIADM_YEAR . ': ');
	$form->AddTextfield ('year', 5, 4, '0000');
	$form->AddLabel ('hour', ' ' . _QUIADM_HOUR . ': ');
	$options = buildhourquiad ();
	$form->AddSelectnokey ('hour', $options);
	$form->AddLabel ('min', ' : ');
	$options = buildminutequiad ();
	$form->AddSelectnokey ('min', $options);
	$now = getnow ();
	$form->AddText ('<br /> (' . _QUIADM_NOWIS . ' : ' . $now . ')');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('comment', _QUIADM_COMMENT);
	$form->AddTextarea ('comment');
	$form->AddChangeRow ();
	$form->AddLabel ('conditions', _QUIADM_CONDITIONS . ' (*)');
	$form->AddTextarea ('conditions');
	$form->AddChangeRow ();
	$form->AddLabel ('showafterquizz', _QUIADM_SHOWAFTERQUIZZ . ' (*)');
	$form->AddTextarea ('showafterquizz');
	$form->AddChangeRow ();
	$form->AddHidden ('act', 'createPostedQuiz');
	$form->AddSubmit ('submity', _QUIADM_CREATE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<span class="normaltext">* : ' . _QUIADM_HELPOPTION . '</span>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_220_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function modifyPostedQuiz () {

	global $opnConfig, $opnTables;

	$qid = 0;
	get_var ('qid', $qid, 'form', _OOBJ_DTYPE_INT);
	$quizztitle = '';
	get_var ('quizztitle', $quizztitle, 'form', _OOBJ_DTYPE_CLEAN);
	$displayresults = 0;
	get_var ('displayresults', $displayresults, 'form', _OOBJ_DTYPE_INT);
	$displayscore = 0;
	get_var ('displayscore', $displayscore, 'form', _OOBJ_DTYPE_CLEAN);
	$emailadmin = '';
	get_var ('emailadmin', $emailadmin, 'form', _OOBJ_DTYPE_EMAIL);
	$nbscore = '';
	get_var ('nbscore', $nbscore, 'form', _OOBJ_DTYPE_CLEAN);
	$comment = '';
	get_var ('comment', $comment, 'form', _OOBJ_DTYPE_CHECK);
	$image = '';
	get_var ('image', $image, 'form', _OOBJ_DTYPE_CLEAN);
	$log = 0;
	get_var ('log', $log, 'form', _OOBJ_DTYPE_INT);
	$restrict = 0;
	get_var ('restrict', $restrict, 'form', _OOBJ_DTYPE_CLEAN);
	$active = 0;
	get_var ('active', $active, 'form', _OOBJ_DTYPE_CLEAN);
	$cid = '';
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_CLEAN);
	$contrib = 0;
	get_var ('contrib', $contrib, 'form', _OOBJ_DTYPE_INT);
	$year = '';
	get_var ('year', $year, 'form', _OOBJ_DTYPE_CLEAN);
	$month = '';
	get_var ('month', $month, 'form', _OOBJ_DTYPE_CLEAN);
	$day = '';
	get_var ('day', $day, 'form', _OOBJ_DTYPE_CLEAN);
	$hour = '';
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_CLEAN);
	$min = '';
	get_var ('min', $min, 'form', _OOBJ_DTYPE_CLEAN);
	$admemail = '';
	get_var ('admemail', $admemail, 'form', _OOBJ_DTYPE_CLEAN);
	$administrator = '';
	get_var ('administrator', $administrator, 'form', _OOBJ_DTYPE_CLEAN);
	$conditions = '';
	get_var ('conditions', $conditions, 'form', _OOBJ_DTYPE_CLEAN);
	$showafterquizz = '';
	get_var ('showafterquizz', $showafterquizz, 'form', _OOBJ_DTYPE_CLEAN);
	$quizztitle = $opnConfig['opnSQL']->qstr ($quizztitle);
	$comment = $opnConfig['opnSQL']->qstr ($comment);
	$conditions = $opnConfig['opnSQL']->qstr ($conditions, 'conditions');
	$nbscore = $opnConfig['opnSQL']->qstr ($nbscore);
	$showafterquizz = $opnConfig['opnSQL']->qstr ($showafterquizz, 'showafterquizz');
	$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . $day . ' ' . $hour . ':' . $min . ':00');
	$expire = '';
	$opnConfig['opndate']->opnDataTosql ($expire);
	$_emailadmin = $opnConfig['opnSQL']->qstr ($emailadmin);
	$_administrator = $opnConfig['opnSQL']->qstr ($administrator);
	$_admemail = $opnConfig['opnSQL']->qstr ($admemail);
	$_image = $opnConfig['opnSQL']->qstr ($image);
	$sql = 'UPDATE ' . $opnTables['quizz_admin'] . " SET quizztitle=$quizztitle, nbscore=$nbscore, displayscore=$displayscore, displayresults=$displayresults, emailadmin=$_emailadmin, comment=$comment, image=$_image, restrict_user=$restrict, log_user=$log, wactive=$active, cid=$cid, contrib=$contrib, expire=$expire, admemail=$_admemail, administrator=$_administrator, conditions=$conditions, showafterquizz=$showafterquizz WHERE quizzid=$qid";
	$opnConfig['database']->Execute ($sql);
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['quizz_admin'], 'quizzid=' . $qid);
	QuizAdmin ();

}

/*********************************************************/

/* Quiz Functions					*/

/*******************************************************/

function createPostedQuiz () {

	global $opnConfig, $opnTables;

	$quizztitle = 'empty';
	get_var ('quizztitle', $quizztitle, 'form', _OOBJ_DTYPE_CLEAN);
	$displayresults = 0;
	get_var ('displayresults', $displayresults, 'form', _OOBJ_DTYPE_INT);
	$displayscore = 0;
	get_var ('displayscore', $displayscore, 'form', _OOBJ_DTYPE_CLEAN);
	$emailadmin = '';
	get_var ('emailadmin', $emailadmin, 'form', _OOBJ_DTYPE_EMAIL);
	$nbscore = '';
	get_var ('nbscore', $nbscore, 'form', _OOBJ_DTYPE_CLEAN);
	$comment = '';
	get_var ('comment', $comment, 'form', _OOBJ_DTYPE_CHECK);
	$image = '';
	get_var ('image', $image, 'form', _OOBJ_DTYPE_CLEAN);
	$log = 0;
	get_var ('log', $log, 'form', _OOBJ_DTYPE_INT);
	$restrict = 0;
	get_var ('restrict', $restrict, 'form', _OOBJ_DTYPE_CLEAN);
	$cid = '';
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_CLEAN);
	$contrib = 0;
	get_var ('contrib', $contrib, 'form', _OOBJ_DTYPE_INT);
	$year = '';
	get_var ('year', $year, 'form', _OOBJ_DTYPE_CLEAN);
	$month = '';
	get_var ('month', $month, 'form', _OOBJ_DTYPE_CLEAN);
	$day = '';
	get_var ('day', $day, 'form', _OOBJ_DTYPE_CLEAN);
	$hour = '';
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_CLEAN);
	$min = '';
	get_var ('min', $min, 'form', _OOBJ_DTYPE_CLEAN);
	$admemail = '';
	get_var ('admemail', $admemail, 'form', _OOBJ_DTYPE_CLEAN);
	$administrator = '';
	get_var ('administrator', $administrator, 'form', _OOBJ_DTYPE_CLEAN);
	$conditions = '';
	get_var ('conditions', $conditions, 'form', _OOBJ_DTYPE_CLEAN);
	$showafterquizz = '';
	get_var ('showafterquizz', $showafterquizz, 'form', _OOBJ_DTYPE_CLEAN);
	$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . $day . ' ' . $hour . ':' . $min . ':00');
	$expire = '';
	$opnConfig['opndate']->opnDataTosql ($expire);
	$opnConfig['opndate']->now ();
	$timeStamp = '';
	$opnConfig['opndate']->opnDataTosql ($timeStamp);
	$quizztitle = $opnConfig['opnSQL']->qstr ($quizztitle);
	$comment = $opnConfig['opnSQL']->qstr ($comment);
	$conditions = $opnConfig['opnSQL']->qstr ($conditions, 'conditions');
	$quizzID = $opnConfig['opnSQL']->get_new_number ('quizz_admin', 'quizzid');
	$emailadmin = $opnConfig['opnSQL']->qstr ($emailadmin);
	$nbscore = $opnConfig['opnSQL']->qstr ($nbscore);
	$showafterquizz = $opnConfig['opnSQL']->qstr ($showafterquizz, 'showafterquizz');
	$_image = $opnConfig['opnSQL']->qstr ($image);
	$_administrator = $opnConfig['opnSQL']->qstr ($administrator);
	$_admemail = $opnConfig['opnSQL']->qstr ($admemail);
	$sql = 'INSERT INTO ' . $opnTables['quizz_admin'] . " VALUES ($quizzID, $quizztitle, $timeStamp, 0, $nbscore,$displayscore,$displayresults,$emailadmin,$comment,0,$restrict,$log,$_image,$cid,$contrib,$expire,$_admemail,$_administrator,$conditions, $showafterquizz)";
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['quizz_admin'], 'quizzid=' . $quizzID);
	$opnConfig['database']->Execute ($sql);
	QuizAdmin ();

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function createPostedQuizQuestion () {

	global $opnConfig, $opnTables;

	$question = '';
	get_var ('question', $question, 'form', _OOBJ_DTYPE_CLEAN);
	$optionText = '';
	get_var ('optionText', $optionText, 'form', _OOBJ_DTYPE_CLEAN);
	$qid = 0;
	get_var ('qid', $qid, 'form', _OOBJ_DTYPE_INT);
	$answer = '';
	get_var ('answer', $answer, 'form', _OOBJ_DTYPE_CLEAN);
	$coef = 0;
	get_var ('coef', $coef, 'form', _OOBJ_DTYPE_INT);
	$good = '';
	get_var ('good', $good, 'form', _OOBJ_DTYPE_CLEAN);
	$bad = '';
	get_var ('bad', $bad, 'form', _OOBJ_DTYPE_CLEAN);
	$mode = '';
	get_var ('mode', $mode, 'form', _OOBJ_DTYPE_CLEAN);
	$pid = 0;
	get_var ('pid', $pid, 'form', _OOBJ_DTYPE_INT);
	$comment = '';
	get_var ('comment', $comment, 'form', _OOBJ_DTYPE_CLEAN);
	$optionSort = '';
	get_var ('optionSort', $optionSort, 'form', _OOBJ_DTYPE_CLEAN);
	$image = '';
	get_var ('image', $image, 'form', _OOBJ_DTYPE_CLEAN);
	$question = $opnConfig['cleantext']->filter_text ($question, true, true, 'nohtml');
	$good = $opnConfig['cleantext']->filter_text ($good, true, true);
	$bad = $opnConfig['cleantext']->filter_text ($bad, true, true);
	$comment = $opnConfig['cleantext']->filter_text ($comment, true, true);
	opn_nl2br ($question);
	opn_nl2br ($good);
	opn_nl2br ($bad);
	opn_nl2br ($comment);
	$good = $opnConfig['opnSQL']->qstr ($good, 'good');
	$bad = $opnConfig['opnSQL']->qstr ($bad, 'bad');
	$comment = $opnConfig['opnSQL']->qstr ($comment, 'comment');
	$question = $opnConfig['opnSQL']->qstr ($question);
	$opnConfig['opndate']->now ();
	$timeStamp = '';
	$opnConfig['opndate']->opnDataTosql ($timeStamp);
	$ordered_answer = implode (",", $optionSort);
	$ordered_answer = preg_replace ("/,--|--,|--/", "", $ordered_answer);

	# check if sorted answer is needed
	if (!empty ($ordered_answer) ) {

		# check if all availaible answers are sorted
		$max = count($optionText);
		for ($i = 1; $i<$max; $i++) {
			if ( (!empty ($optionText[$i]) and $optionSort[$i] == "--") or (empty ($optionText[$i]) and $optionSort[$i] != "--") ) {
				QuizConfigHeader ();
				$boxtxt = Quizheader ();
				$boxtxt = '<div class="centertag"><span class="normaltext">' . _QUIADM_INCORRECTORDER . '</span></div>';
				$_display_dat = array ();
				$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_230_';
				$_display_dat['module'] = 'modules/quizz';
				$opnConfig['opnOutput']->SetDisplay ($_display_dat);
				unset ($_display_dat);
				$opnConfig['opnOutput']->DisplayCenterbox (_QUI_DESC, '<br />' . $boxtxt, _QUI_QUIFOOTER);
				exit;
			}
		}

		# change the answer the the ordered answer

		$answer = $opnConfig['opnSQL']->qstr ($ordered_answer);
	}
	$pollid = $opnConfig['opnSQL']->get_new_number ('quizz_desc', 'pollid');
	$_image = $opnConfig['opnSQL']->qstr ($image);
	$sql = 'INSERT INTO ' . $opnTables['quizz_desc'] . " VALUES ($pollid, $question, $timeStamp, 0, $qid, $answer,$coef,$good,$bad,$comment,$_image)";
	$opnConfig['database']->Execute ($sql);
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['quizz_desc'], 'pollid=' . $pollid);
	$id = $pollid;
	$max = count($optionText);
	for ($i = 1; $i<$max; $i++) {
		if ($optionText[$i] != "") {
			$optionText[$i] = $opnConfig['opnSQL']->qstr ($optionText[$i]);
			$sql = 'INSERT INTO ' . $opnTables['quizz_data'] . " (pollid, optiontext, optioncount, voteid)" . " VALUES ($id, $optionText[$i], 0, $i)";
			$opnConfig['database']->Execute ($sql);
		}
	}

	# delete contributor question if needed
	if ($mode == 'contrib') {
		$sql = 'delete FROM ' . $opnTables['quizz_datacontrib'] . " WHERE pollid=$pid";
		$opnConfig['database']->Execute ($sql);
		$sql = 'delete FROM ' . $opnTables['quizz_descontrib'] . " WHERE pollid=$pid";
		$opnConfig['database']->Execute ($sql);
	}
	set_var ('qid', $qid, 'url');
	QuizModify ();

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function deletePostedScoreQuiz () {

	global $opnConfig, $opnTables;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);

	# delete all the score and stats for the selected Quiz

	$sql = 'UPDATE ' . $opnTables['quizz_admin'] . " SET voters=0 WHERE quizzid=$qid";
	$opnConfig['database']->Execute ($sql);
	$sql = 'SELECT pollid FROM ' . $opnTables['quizz_desc'] . " WHERE qid=$qid";
	$result = &$opnConfig['database']->Execute ($sql);
	while (! $result->EOF) {
		$pollID = $result->fields['pollid'];
		$sql = 'UPDATE ' . $opnTables['quizz_data'] . " SET optioncount=0 WHERE pollid=$pollID";
		$opnConfig['database']->Execute ($sql);
		$result->MoveNext ();
	}
	$sql = 'delete FROM ' . $opnTables['quizz_check'] . " WHERE qid=$qid";
	$opnConfig['database']->Execute ($sql);
	QuizAdmin ();

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function deletePostedContributorQuizQuestion () {

	global $opnConfig, $opnTables;

	$pid = 0;
	get_var ('pid', $pid, 'url', _OOBJ_DTYPE_INT);

	# delete contributor question

	$sql = 'delete FROM ' . $opnTables['quizz_datacontrib'] . " WHERE pollid=$pid";
	$opnConfig['database']->Execute ($sql);
	$sql = 'delete FROM ' . $opnTables['quizz_descontrib'] . " WHERE pollid=$pid";
	$opnConfig['database']->Execute ($sql);
	QuizAdmin ();

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function QuizDelCategory () {

	global $opnConfig;

	$cid = 0;
	get_var ('cid', $cid, 'both', _OOBJ_DTYPE_INT);
	QuizConfigHeader ();
	$boxtxt = "<div align='center'><span class='extratextbold'>" . _QUIADM_ADMIN . '</span></div>';
	$boxtxt .= '<br />';
	$boxtxt .= '<div class="centertag"><span class="bigtextbold">' . _QUIADM_DELCAT . '</span><br /><br />' . '<span class="normaltext">' . _QUIADM_SURE2DELETECAT . '<br /><br />' . '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
																											'act' => 'removePostedQuizCategory',
																											'cid' => $cid) ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a href="' . encodeurl ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php?act=QuizAdmin') . '">' . _NO . '</a></span></div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_240_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function createPostedQuizCategory () {

	global $opnConfig, $opnTables;

	$CatName = '';
	get_var ('CatName', $CatName, 'form', _OOBJ_DTYPE_CLEAN);
	$CatComment = '';
	get_var ('CatComment', $CatComment, 'form', _OOBJ_DTYPE_CLEAN);
	$CatImage = '';
	get_var ('CatImage', $CatImage, 'form', _OOBJ_DTYPE_CLEAN);
	$cid = $opnConfig['opnSQL']->get_new_number ('quizz_categories', 'cid');
	$CatName = $opnConfig['opnSQL']->qstr ($CatName);
	$CatComment = $opnConfig['opnSQL']->qstr ($CatComment);
	$_CatImage = $opnConfig['opnSQL']->qstr ($CatImage);
	$sql = 'INSERT INTO ' . $opnTables['quizz_categories'] . " VALUES ($cid, $CatName,$CatComment,$_CatImage)";
	$opnConfig['database']->Execute ($sql);
	QuizAdmin ();

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function modifyPostedQuizCategory () {

	global $opnConfig, $opnTables;

	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$CatName = '';
	get_var ('CatName', $CatName, 'form', _OOBJ_DTYPE_CLEAN);
	$CatComment = '';
	get_var ('CatComment', $CatComment, 'form', _OOBJ_DTYPE_CLEAN);
	$CatImage = '';
	get_var ('CatImage', $CatImage, 'form', _OOBJ_DTYPE_CLEAN);
	$CatName = $opnConfig['opnSQL']->qstr ($CatName);
	$CatComment = $opnConfig['opnSQL']->qstr ($CatComment);
	$_CatImage = $opnConfig['opnSQL']->qstr ($CatImage);
	$sql = 'UPDATE ' . $opnTables['quizz_categories'] . " SET name=$CatName,comment=$CatComment,image=$_CatImage WHERE cid=$cid";
	$opnConfig['database']->Execute ($sql);
	QuizAdmin ();

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function deleteContributorQuizQuestion () {

	global $opnConfig;

	$qid = 0;
	get_var ('qid', $qid, 'form', _OOBJ_DTYPE_INT);
	$pid = 0;
	get_var ('pid', $pid, 'form', _OOBJ_DTYPE_INT);
	QuizConfigHeader ();
	$boxtxt = '<div class="centertag"><span class="extratextbold">' . _QUIADM_ADMIN . '</span></div>';
	$boxtxt .= '<br />';
	$boxtxt .= '<div class="centertag"><span class="bigtextbold">' . _QUIADM_DELCONTRIB . ' ' . $pid . '?<br /><br />' . '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
																			'act' => 'deletePostedContributorQuizQuestion',
																			'qid' => $qid,
																			'pid' => $pid) ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a href="' . encodeurl ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php?act=QuizAdmin') . '">' . _NO . '</a></span></div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_250_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function QuizDelQuestion () {

	global $opnConfig;

	QuizConfigHeader ();
	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$pid = 0;
	get_var ('pid', $pid, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = '<div class="centertag"><span class="extratextbold">' . _QUIADM_ADMIN . '</span></div>';
	$boxtxt .= '<br />';
	$boxtxt .= '<div class="centertag"><span class="bigtextbold">' . _QUIADM_DELQUESTION . '</span><br /><br />' . '<span class="normaltext">' . _QUIADM_SURE2DELQUESTION . ' ' . $pid . '?<br /><br />' . '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
																														'act' => 'removePostedQuizQuestion',
																														'qid' => $qid,
																														'pid' => $pid) ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
												'act' => 'QuizModify',
												'qid' => $qid) ) . '">' . _NO . '</a></span></div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_260_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function QuizRemove () {

	global $opnConfig;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	QuizConfigHeader ();
	$boxtxt = '<div class="centertag"><span class="extratextbold">' . _QUIADM_ADMIN . '</span></div>';
	$boxtxt .= '<br />';
	$boxtxt .= '<div class="centertag"><span class="bigtextbold">' . _QUIADM_DELETE . '</span><br /><br />' . '<span class="normaltext">' . _QUIADM_SURE2DELETE . ' ' . $qid . '?<br /><br />' . '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
																												'act' => 'removePostedQuiz',
																												'qid' => $qid) ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a href="' . encodeurl ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php?act=QuizAdmin') . '">' . _NO . '</a></span></div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_270_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUIADM_DESC, '<br />' . $boxtxt, _QUIADM_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function removePostedQuizCategory () {

	global $opnConfig, $opnTables;

	$cid = 0;
	get_var ('cid', $cid, 'url', _OOBJ_DTYPE_INT);
	$sql = 'delete FROM ' . $opnTables['quizz_categories'] . " WHERE cid=$cid";
	$opnConfig['database']->Execute ($sql);
	QuizAdmin ();

}

/*********************************************************/

/* Quiz Functions									   */

/*********************************************************/

function removePostedQuiz () {

	global $opnConfig, $opnTables;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$sql = 'SELECT pollid FROM ' . $opnTables['quizz_desc'] . " WHERE qid=$qid";
	$result = &$opnConfig['database']->Execute ($sql);
	while (! $result->EOF) {
		$pollID = $result->fields['pollid'];
		$sql = 'delete FROM ' . $opnTables['quizz_desc'] . " WHERE pollid=$pollID";
		$opnConfig['database']->Execute ($sql);
		$_pollID = $opnConfig['opnSQL']->qstr ($pollID);
		$sql = 'delete FROM ' . $opnTables['quizz_data'] . " WHERE pollid=$_pollID";
		$opnConfig['database']->Execute ($sql);
		$sql = 'delete FROM ' . $opnTables['quizz_descontrib'] . " WHERE pollid=$pollID";
		$opnConfig['database']->Execute ($sql);
		$_pollID = $opnConfig['opnSQL']->qstr ($pollID);
		$sql = 'delete FROM ' . $opnTables['quizz_datacontrib'] . " WHERE pollid=$_pollID";
		$opnConfig['database']->Execute ($sql);
		$result->MoveNext ();
	}
	$sql = 'delete FROM ' . $opnTables['quizz_admin'] . ' WHERE quizzid=' . $qid;
	$opnConfig['database']->Execute ($sql);
	$sql = 'delete FROM ' . $opnTables['quizz_check'] . " WHERE qid=$qid";
	$opnConfig['database']->Execute ($sql);
	QuizAdmin ();

}

/*********************************************************/

/* Quiz Functions										*/

/*********************************************************/

function removePostedQuizQuestion () {

	global $opnConfig, $opnTables;

		$qid=0;
	#	get_var ('qid',$qid,'url',_OOBJ_DTYPE_INT);

	$pid = 0;
	get_var ('pid', $pid, 'url', _OOBJ_DTYPE_INT);
	$sql = 'delete FROM ' . $opnTables['quizz_desc'] . " WHERE pollid=$pid";
	$opnConfig['database']->Execute ($sql);
	$sql = 'delete FROM ' . $opnTables['quizz_data'] . " WHERE pollid=$pid";
	$opnConfig['database']->Execute ($sql);
	QuizModify ();

}

/*********************************************************/

$act = '';
get_var ('act', $act, 'both', _OOBJ_DTYPE_CLEAN);
if ($act == '') {
	QuizAdmin ();
} else {
	switch ($act) {
		case 'createPostedQuizQuestion':
			createPostedQuizQuestion ();
			break;
		case 'modifyPostedQuiz':
			modifyPostedQuiz ();
			break;
		case 'modifyPostedQuizCategory':
			modifyPostedQuizCategory ();
			break;
		case 'modifyPostedQuizQuestion':
			modifyPostedQuizQuestion ();
			break;
		case 'deletePostedScoreQuiz':
			deletePostedScoreQuiz ();
			break;
		case 'removePostedQuizCategory':
			removePostedQuizCategory ();
			break;
		case 'removePostedQuiz':
			removePostedQuiz ();
			break;
		case 'removePostedQuizQuestion':
			removePostedQuizQuestion ();
			break;
		case 'QuizAddQuestion':
			QuizAddQuestion ();
			break;
		case 'QuizDelQuestion':
			QuizDelQuestion ();
			break;
		case 'QuizViewStats':
			QuizViewStats ();
			break;
		case 'QuizRemoveScore':
			QuizRemoveScore ();
			break;
		case 'QuizViewScore':
			QuizViewScore ();
			break;
		case 'QuizViewScoreDelete':
			$qid = 0;
			get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
			$username = '';
			get_var ('username', $username, 'url', _OOBJ_DTYPE_CLEAN);
			$score = 0;
			get_var ('score', $score, 'url', _OOBJ_DTYPE_INT);
			$_username = $opnConfig['opnSQL']->qstr ($username);
			global $opnTables;

			$sql = 'DELETE FROM ' . $opnTables['quizz_check'] . " WHERE (qid=$qid) and (username=$_username) and (score=$score)";
			$opnConfig['database']->Execute ($sql);
			QuizViewScore ();
			break;
		// qid='.$qid.'&username='.$username.'&score='.$res.'">';
		case 'QuizRemove':
			QuizRemove ();
			break;
		case 'createPostedQuiz':
			createPostedQuiz ();
			break;
		case 'QuizModifyCategory':
			QuizModifyCategory ();
			break;
		case 'QuizModifyQuestion':
			QuizModifyQuestion ();
			break;
		case 'QuizAddContrib':
			QuizAddContrib ();
			break;
		case 'QuizModify':
			QuizModify ();
			break;
		case 'QuizDelCategory':
			QuizDelCategory ();
			break;
		case 'createPostedQuizCategory':
			createPostedQuizCategory ();
			break;
		case 'deletePostedContributorQuizQuestion':
			deletePostedContributorQuizQuestion ();
			break;
		case 'deleteContributorQuizQuestion':
			deleteContributorQuizQuestion ();
			break;
		case 'QuizAdd':
			QuizAdd ();
			break;
		case 'QuizAdmin':
			QuizAdmin ();
			break;
	}
}
$opnConfig['opnOutput']->DisplayFoot ();

?>