<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/*********************************************************/

/* Quiz Functions					*/

/*******************************************************/

function Quizheader () {

	global $opnConfig;

	$help = '<div class="centertag">[ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/quizz/index.php">' . _QUI_TITLE . '</a> ]</div>';
	return $help . '<br />';

}

function addContributeQuizQuestion () {

	global $opnConfig, $opnTables;

	$qid = 0;
	get_var ('qid', $qid, 'form', _OOBJ_DTYPE_INT);
	$question = '';
	get_var ('question', $question, 'form', _OOBJ_DTYPE_CLEAN);
	$optionText = array();
	get_var ('optionText', $optionText, 'form', _OOBJ_DTYPE_CLEAN);
	$answer = '';
	get_var ('answer', $answer, 'form', _OOBJ_DTYPE_CLEAN);
	$coef = 0;
	get_var ('coef', $coef, 'form', _OOBJ_DTYPE_INT);
	$good = '';
	get_var ('good', $good, 'form', _OOBJ_DTYPE_CLEAN);
	$bad = '';
	get_var ('bad', $bad, 'form', _OOBJ_DTYPE_CLEAN);
	$comment = '';
	get_var ('comment', $comment, 'form', _OOBJ_DTYPE_CHECK);
	$optionSort = array();
	get_var ('optionSort', $optionSort, 'form', _OOBJ_DTYPE_CLEAN);
	$image = '';
	get_var ('image', $image, 'form', _OOBJ_DTYPE_URL);
	$good = $opnConfig['cleantext']->FixQuotes ($good);
	$bad = $opnConfig['cleantext']->FixQuotes ($bad);
	$comment = $opnConfig['cleantext']->FixQuotes ($comment);
	$question = $opnConfig['cleantext']->FixQuotes ($question);
	$good = $opnConfig['cleantext']->filter_text ($good, true, true);
	$bad = $opnConfig['cleantext']->filter_text ($bad, true, true);
	$comment = $opnConfig['cleantext']->filter_text ($comment, true, true);
	$question = $opnConfig['cleantext']->filter_text ($question, true, true);
	opn_nl2br ($good);
	opn_nl2br ($bad);
	opn_nl2br ($comment);
	opn_nl2br ($question);
	$boxtxt = '';
	$opnConfig['opndate']->now ();
	$timeStamp = '';
	$opnConfig['opndate']->opnDataTosql ($timeStamp);
	$ordered_answer = implode (',', $optionSort);
	$ordered_answer = preg_replace ("/,--|--,|--/", '', $ordered_answer);
	// check if sorted answer is needed
	if (!empty ($ordered_answer) ) {
		// check if all availaible answers are sorted
		$max = count($optionText);
		for ($i = 1; $i<$max; $i++) {
			if ( (!empty ($optionText[$i]) and $optionSort[$i] == '--') or (empty ($optionText[$i]) and $optionSort[$i] != '--') ) {
				$boxtxt = Quizheader ();
				$boxtxt .= '<div class="centertag"><span class="normaltext">' . _QUI_INCORRECTORDER . '</span></div>';
				$_display_dat = array ();
				$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_290_';
				$_display_dat['module'] = 'modules/quizz';
				$opnConfig['opnOutput']->SetDisplay ($_display_dat);
				unset ($_display_dat);
				$opnConfig['opnOutput']->DisplayCenterbox (_QUI_DESC, '<br />' . $boxtxt, _QUI_QUIFOOTER);
				exit;
			}
		}
		// change the answer the the ordered answer
		$answer = $ordered_answer;
	}
	if ($question != '???') {
		$question = $opnConfig['opnSQL']->qstr ($question);
		$comment = $opnConfig['opnSQL']->qstr ($comment);
		$good = $opnConfig['opnSQL']->qstr ($good);
		$bad = $opnConfig['opnSQL']->qstr ($bad);
		$answer = $opnConfig['opnSQL']->qstr ($answer);
		$pollid = $opnConfig['opnSQL']->get_new_number ('quizz_descontrib', 'pollid');
		$sql = 'INSERT INTO ' . $opnTables['quizz_descontrib'] . " VALUES ($pollid, $question, $timeStamp, 0, $qid,$answer,$coef,$good,$bad,$comment,'')";
		$opnConfig['database']->Execute ($sql);
		$max = count($optionText);
		for ($i = 1; $i<$max; $i++) {
			if ($optionText[$i] != '') {
				$optionText[$i] = $opnConfig['opnSQL']->qstr ($optionText[$i]);
				$sql = 'INSERT INTO ' . $opnTables['quizz_datacontrib'] . " (pollid, optiontext, optioncount, voteid) VALUES ($pollid, $optionText[$i], 0, $i)";
				$opnConfig['database']->Execute ($sql);
			}
		}

		# update the image name
		if ( (isset ($image) ) && (is_array ($image) ) && (isset ($image['name']) ) ) {
			if ($image['name'] != '') {
				require (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.fileupload.php');
				$userfile_size = $opnConfig['opn_upload_size_limit'];
				$upload = & new file_upload_class;
				$upload->max_filesize ($userfile_size);
				if ($upload->upload ('image', 'image', '') ) {
					if ($opnConfig['opn_dirmanage'] >= 2) {
						if ($upload->ftp_upload (_OPN_ROOT_PATH . 'modules/quizz/images/', 3) ) {
							$file = $upload->new_file;
							$filename = $upload->file['name'];
						}
					} else {
						if ($upload->save_file (_OPN_ROOT_PATH . 'modules/quizz/images/', 3) ) {
							$file = $upload->new_file;
							$filename = $upload->file['name'];
						}
					}
				}
				if (isset ($upload->errors) ) {
					$problem = '';
					foreach ($upload->errors as $var) {
						$problem .= '<p>' . $var . '<br />';
					}
				} else {
					$problem = '';
				}
				if (! (isset ($filename) ) ) {
					$filename = '';
				}
				if ($problem == '') {
					$_filename = $opnConfig['opnSQL']->qstr ($filename);
					$_pollid = $opnConfig['opnSQL']->qstr ($pollid);
					$sql = 'UPDATE ' . $opnTables['quizz_descontrib'] . " SET image=$_filename WHERE pollid=$_pollid";
					$opnConfig['database']->Execute ($sql);
				} else {
					$boxtxt .= 'Error ! Can not copy image ' . $filename . ' <br />' . $problem;
				}
			}
		}
		$boxtxt .= Quizheader () . '<span class="normaltext"><br /><br />' . _QUI_CONTRIBTHANKS . '</span>';
	} else {
		$boxtxt .= Quizheader () . '<span class="normaltext"><br /><br />' . _QUI_TOBEDONE . '</span>';
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_300_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUI_DESC, $boxtxt, _QUI_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions					*/

/*******************************************************/

function QuizContribute () {

	global $opnConfig;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = Quizheader ();
	$boxtxt .= '<div align="center" class="bigtextbold">' . _QUI_ADDQUESTION . '</div>';
	$boxtxt .= '<br />';

	# get the login infos for the registered user

	$impossible = FALSE;
	if (!$opnConfig['permission']->IsUser () ) {
		$boxtxt .= '<div align="center" class="bigtextbold">' . _QUI_ADDQUESTIONSORRY . '</div>';
		$impossible = TRUE;

		# return;
	}

	# the current user

	#	$userinfo = $opnConfig['permission']->GetUserinfo();

	#	$logname = $userinfo['uname'];

	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QUIZZ_310_', 'quizz');
	$form->Init ($opnConfig['opn_url'] . '/modules/quizz/index.php', 'post', '', 'multipart/form-data');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('question', _QUI_QUESTIONTITLE . ':');
	$form->AddTextfield ('question', 50, 250, '???');
	$form->AddChangeRow ();
	$form->AddLabel ('coef', _QUI_COEF);
	$form->AddTextfield ('coef', 3, 0, '1');
	$form->AddChangeRow ();
	$form->AddLabel ('image', _QUI_IMAGE . ' (*)');
	$form->AddFile ('image');
	$form->AddChangeRow ();
	$form->AddTable ('alternator', '2');
	$form->AddCols (array ('20%', '50%', '10%', '20%') );
	$form->AddHeaderRow (array (_QUI_QUESTION, '&nbsp;', _QUI_ANSWER, _QUI_RANK) );

	#	if(!isset($optionText)) {$optionText = '';}

	#	if(!isset($sel)) {$sel = '';}

	$options[] = '--';
	for ($j = 1; $j<=12; $j++) {
		$options[] = $j;
	}
	for ($i = 1; $i<=12; $i++) {
		$form->AddOpenRow ();
		$form->AddLabel ('optionText[' . $i . ']', _OPTION . ' ' . $i . ':');
		$form->AddTextfield ('optionText[' . $i . ']', 50, 200);
		$form->SetAlign ('center');
		$form->AddRadio ('answer', $i, ($i == 1?1 : 0) );
		$form->AddSelectnokey ('optionSort[' . $i . ']', $options);
		$form->SetAlign ('');
		$form->AddCloseRow ();
	}
	$form->AddTableClose ();
	$form->AddChangeRow ();
	$form->AddLabel ('comment', _QUI_COMMENT . ' (*)');
	$form->AddTextarea ('comment');
	$form->AddChangeRow ();
	$form->AddLabel ('bad', _QUI_IFBADANSWER . ' (*)');
	$form->AddTextarea ('bad');
	$form->AddChangeRow ();
	$form->AddLabel ('good', _QUI_IFGOODANSWER . ' (*)');
	$form->AddTextarea ('good');
	if ($impossible == FALSE) {
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddHidden ('do', 'addContributeQuizQuestion');
		$form->AddHidden ('qid', $qid);
		$form->SetEndCol ();
		$form->AddSubmit ('submit', _QUI_ADDQUESTION);
	}
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<span class="normaltext">* : ' . _QUI_HELPOPTION . '</span>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_320_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUI_DESC, $boxtxt, _QUI_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions					*/

/*******************************************************/

function QuizShow () {

	global $opnConfig, $opnTables;

	# check for  authorization

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$sql = 'SELECT quizztitle, comment , wactive, restrict_user, log_user, image, contrib, expire , displayscore, nbscore, conditions, showafterquizz  FROM ' . $opnTables['quizz_admin'] . ' WHERE quizzid=' . $qid;
	$result = &$opnConfig['database']->Execute ($sql);
	$quizzTitle = $result->fields['quizztitle'];
	$comment = $result->fields['comment'];
	$active = $result->fields['wactive'];
	$restrict_user = $result->fields['restrict_user'];
	$log_user = $result->fields['log_user'];
	$image = $result->fields['image'];
	$contrib = $result->fields['contrib'];
	$expire = $result->fields['expire'];
	$displayscore = $result->fields['displayscore'];
	$nbscore = $result->fields['nbscore'];
	$conditions = $result->fields['conditions'];
	$showafterquizz = $result->fields['showafterquizz'];
	if ($showafterquizz == '') {
		$showafterquizz = _QUI_THANKS;
	}
	opn_nl2br ($showafterquizz);
	$boxtxt = Quizheader ();

	# check if quizz is active

	$activated = 1;
	$expired = 0;
	$restricted = 0;
	$logged = 0;
	if ($active == 0 and !$opnConfig['permission']->HasRight ('modules/quizz', _PERM_ADMIN, true) ) {
		$activated = 0;
		$boxtxt .= '<div class="centertag"><span class="normaltext">' . _QUI_MUSTBEACTIVE . '</span></div>';
	}

	# check if the quizz is restrict to registered user
	if ( ( ($restrict_user == 1) and (!$opnConfig['permission']->IsUser () ) ) and !$opnConfig['permission']->HasRight ('modules/quizz', _PERM_ADMIN . true) ) {
		$restricted = 1;
		$boxtxt .= '<div align="center" class="normaltext">' . _QUI_MUSTBEUSER . ' - <a href="' . $opnConfig['opn_url'] . '/system/user/register.php">' . _QUI_ACCOUNCREATE . '</a>.' . '</div>';
	}

	# first check if it exists an expiration date (no xx)
	if ($expire != 0.00000) {

		# expiration date of the quiz

		$opnConfig['opndate']->now ();
		$today = '';
		$opnConfig['opndate']->opnDataTosql ($today);
		if ($expire<=$today) {
			$expired = 1;
			$boxtxt .= '<span class="normaltext">' . $quizzTitle . ': ' . _QUI_HASEXPIRED . '</span><br />';
		}

		# show the score if needed
		if ( ($displayscore == 1) && ($expired == 1) ) {
			$table = & new opn_TableClass ('alternator');
			$table->AddOpenRow ();
			$table->AddDataCol (_QUI_LISTSCORE, 'center');
			$sql = 'SELECT username, score FROM ' . $opnTables['quizz_check'] . " WHERE qid=$qid ORDER BY score DESC,wtime DESC";
			$result = &$opnConfig['database']->SelectLimit ($sql, $nbscore);
			if ($result->RecordCount ()>0) {
				while (! $result->EOF) {
					$username = $result->fields['username'];
					$res = $result->fields['score'];
					$table->AddChangeRow ();
					$table->AddDataCol ($username . ' : ' . $res);
					$result->MoveNext ();
				}
				$boxtxt .= '<br />';
			}
			$table->AddChangeRow ();
			$table->AddDataCol ($showafterquizz);
			$table->AddCloseRow ();
			$table->GetTable ($boxtxt);
		}
	}

	# get the login infos  for the registered user
	if ($opnConfig['permission']->IsUser () ) {
		$userinfo = $opnConfig['permission']->GetUserinfo ();
		$logname = $userinfo['uname'];
		$adrs = $userinfo['email'];
	} else {
		$logname = '';
		$adrs = '';
	}

	# check if the user is logged (only one vote for the quizz)
	if ( ($restrict_user == 1) && ($log_user == 1) ) {

		# search in the database for a previous vote

		$_adrs = $opnConfig['opnSQL']->qstr ($adrs);
		$_logname = $opnConfig['opnSQL']->qstr ($logname);
		$sql = 'SELECT username FROM ' . $opnTables['quizz_check'] . " WHERE (qid=$qid AND username=$_logname) OR (qid=$qid AND email=$_adrs)";
		$result = &$opnConfig['database']->Execute ($sql);
		if ($result->RecordCount ()>0) {
			$logged = 1;
			$boxtxt .= '<div class="centertag"><span class="normaltext">' . _QUI_ALREADYVOTED . '</span></div>';
		}
	}
	if ($opnConfig['permission']->HasRight ('modules/quizz', _PERM_ADMIN, true) ) {
		$menu = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
									'act' => 'QuizViewScore',
									'qid' => $qid) ) . '">[ ' . _QUI_VIEWSCORE . ' ]</a> | ';
		$menu .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
										'act' => 'QuizRemoveScore',
										'qid' => $qid) ) . '"> [ ' . _QUI_DELSCORE . ' ]</a> | ';
		$menu .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
										'act' => 'QuizViewStats',
										'qid' => $qid) ) . '"> [ ' . _QUI_VIEWSTAT . ' ]</a> | ';
		$menu .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
										'act' => 'QuizModify',
										'qid' => $qid) ) . '"> [ ' . _QUI_MODIFY . ' ]</a> | ';
		$menu .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
										'act' => 'QuizRemove',
										'qid' => $qid) ) . '"> [ ' . _QUI_DELETE . ' ]</a>';
	} else {
		$menu = '';
	}
	$table = & new opn_TableClass ('default');
	$table->AddOpenRow ();
	if (!empty ($image) ) {
		$table->AddDataCol ('<span class="normaltextbold">' . $quizzTitle . '</span>' . $menu, 'center');
		$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/modules/quizz/images/' . $image . '" class="imgtag" alt="">', 'center', '', 'middle', '2');
	} else {
		$table->AddDataCol ('<span class="normaltextbold">' . $quizzTitle . '</span>' . $menu, 'center');
	}
	$table->AddChangeRow ();
	$table->AddDataCol ($comment);
	$table->AddCloseRow ();
	$table->GetTable ($boxtxt);
	if (!empty ($conditions) ) {
		$boxtxt .= '<span class="normaltext">' . sprintf (_QUI_READCONDITIONS, '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/index.php',
																	'do' => 'viewConditions',
																	'qid' => $qid) ) . '">') . '</span><br />';
	}
	if ( ($activated == 1) && ($expired == 0) && ($restricted == 0) && ($logged == 0) ) {

		# print the quizz form

		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QUIZZ_330_', 'quizz');
		$form->Init ($opnConfig['opn_url'] . '/modules/quizz/index.php');
		$form->AddHidden ('qid', $qid);
		$form->AddHidden ('do', 'vote');
		if ($opnConfig['permission']->IsUser () ) {
			$form->AddHidden ('logname', $logname);
			$form->AddHidden ('adrs', $adrs);
		} else {
			$form->AddTable ();
			$form->AddOpenRow ();
			$form->SetSameCol ();
			$form->AddLabel ('logname', _QUI_LOGNAME . ' : ');
			$form->AddTextfield ('logname');
			$form->AddLabel ('adrs', _QUI_EMAIL . ' : ');
			$form->AddTextfield ('adrs');
			$form->SetEndCol ();
			$form->AddCloseRow ();
			$form->AddTableClose ();
		}
		$num = 1;
		$sql = 'SELECT pollid, polltitle, voters, comment, answer, image FROM ' . $opnTables['quizz_desc'] . " WHERE qid=$qid";
		$result = &$opnConfig['database']->Execute ($sql);
		while (! $result->EOF) {
			$pollID = $result->fields['pollid'];
			$pollTitle = $result->fields['polltitle'];

			#			$voters = $result->fields['voters'];

			$comment = $result->fields['comment'];
			$answer = $result->fields['answer'];
			$image = $result->fields['image'];
			if (!empty ($comment) ) {
				$form->AddText ('<span class="normaltextbold">' . $comment . ' <br /></span><br />');
			}
			$form->AddTable ();
			$form->AddCols (array ('50%', '50%') );
			if (!empty ($image) ) {
				$hlp = '<img src="' . $opnConfig['opn_url'] . '/modules/quizz/images/' . $image . '" class="imgtag" align="absmiddle">&nbsp;';
			} else {
				$hlp = '';
			}
			$hlp .= wordwrap (_QUI_QUESTIONTITLE . ' ' . $num . ' : ' . $pollTitle, 90, '<br />', 1) . ' ';
			if ($opnConfig['permission']->HasRight ('modules/quizz', _PERM_ADMIN, true) ) {
				$hlp .= '<a class="listalternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
												'act' => 'QuizModifyQuestion',
												'pid' => $pollID,
												'qid' => $qid) ) . '">[ ' . _QUI_MODIFY . ' ]</a> | ';
				$hlp .= '<a class="listalternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
												'act' => 'QuizDelQuestion',
												'pid' => $pollID,
												'qid' => $qid) ) . '">[ ' . _QUI_DELETE . ' ]</a>';
			}
			$form->AddOpenHeadRow ();
			$form->AddHeaderCol ($hlp, 'left', '2');
			$form->AddCloseRow ();

			# ordered answer needed ?
			if (preg_match ('/,/', $answer) ) {
				$sql = 'SELECT optiontext, voteid FROM ' . $opnTables['quizz_data'] . " WHERE pollid=$pollID ORDER BY voteid";
				$result1 = &$opnConfig['database']->Execute ($sql);
				while (! $result1->EOF) {

					# compute the list of answer for the combo box

					$optionText = $result1->fields['optiontext'];
					$voteID = $result1->fields['voteid'];
					$array_text[$voteID] = trim ($optionText);
					$result1->MoveNext ();
				}
				$thesize = sizeof ($array_text);
				for ($i = 1; $i<=$thesize; $i++) {
					if (!empty ($array_text[$i]) ) {
						$form->AddOpenRow ();
						$form->AddText ('&nbsp;');
						$options = array ();
						$size2 = sizeof ($array_text);
						for ($j = 1; $j<=$size2; $j++) {
							if (!empty ($array_text[$j]) ) {
								$options[$j] = $array_text[$j];
							}
						}
						// $form->AddSelect('voteQuiz['.$pollID.']['.$i.']',$options);
						$form->AddSelect ("voteQuiz[$pollID][$i]", $options);
						// $form->AddText('<span class="normaltext"> '.$array_text[$i].'</span>');
						$form->AddCloseRow ();
					}
				}
			} else {
				for ($i = 1; $i<=12; $i++) {
					$sql = 'SELECT optiontext FROM ' . $opnTables['quizz_data'] . " WHERE (pollid=$pollID) AND (voteid=$i)";
					$result1 = &$opnConfig['database']->Execute ($sql);
					$optionText = $result1->fields['optiontext'];
					if (trim ($optionText) != '') {
						$form->AddOpenRow ();
						$form->AddLabel ("voteQuiz[$pollID]", $optionText);
						$form->AddRadio ("voteQuiz[$pollID]", $i);
						$form->AddCloseRow ();
					}
				}

				# end poll question
			}
			$num++;
			$form->AddOpenRow ();
			$form->AddHidden ('pollID', $pollID);
			$form->AddText ('&nbsp;');
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$result->MoveNext ();
		}

		# end poll loop

		$form->AddText ('<div class="centertag">');
		$form->AddSubmit ('submity', _QUI_SUBMIT);
		$form->AddText ('</div>');

		# display the possibility for contributor to add question if needed
		if ($contrib == 1) {
			$form->AddText ('<br />');
			$form->AddText ('<div class="centertag">');
			$form->AddText ('<span class="normaltext">');
			$form->AddText ('<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/index.php',
									'qid' => $qid,
									'do' => 'contrib') ) . '"> [ ' . _QUI_CONTRIBUTE . ' ]</a>');
			$form->AddText ('</span>');
			$form->AddText ('</div>');
		}
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_340_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUI_DESC, $boxtxt, _QUI_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions					*/

/*******************************************************/

function QuizVote () {

	global $opnConfig, $opnTables;

	$qid = 0;
	get_var ('qid', $qid, 'form', _OOBJ_DTYPE_INT);
	$voteQuiz = '';
	get_var ('voteQuiz', $voteQuiz, 'form', _OOBJ_DTYPE_CLEAN);
	$logname = '';
	get_var ('logname', $logname, 'form', _OOBJ_DTYPE_CLEAN);
	$adrs = '';
	get_var ('adrs', $adrs, 'form', _OOBJ_DTYPE_CLEAN);
	$boxtxt = Quizheader ();
	if (empty ($logname) or empty ($adrs) ) {
		$boxtxt .= '<div class="centertag"><span class="normaltext">' . _QUI_MISSINGINFOS . '</span></div>';
		return;
	}
	$sql = 'SELECT quizztitle, nbscore, displayscore, displayresults, emailadmin, wactive, restrict_user, log_user, image, contrib, admemail, comment, showafterquizz FROM ' . $opnTables['quizz_admin'] . " WHERE quizzid=$qid";
	$result = &$opnConfig['database']->Execute ($sql);
	$quizzTitle = $result->fields['quizztitle'];
	$nbscore = $result->fields['nbscore'];
	$displayscore = $result->fields['displayscore'];
	$displayresults = $result->fields['displayresults'];
	$emailadmin = $result->fields['emailadmin'];
	$active = $result->fields['wactive'];
	$restrict_user = $result->fields['restrict_user'];
	$log_user = $result->fields['log_user'];
	$image = $result->fields['image'];

	#	$contrib = $result->fields['contrib'];

	$admemail = $result->fields['admemail'];
	$comment = $result->fields['comment'];
	$showafterquizz = $result->fields['showafterquizz'];
	if ($showafterquizz == '') {
		$showafterquizz = _QUI_THANKS;
	}
	opn_nl2br ($showafterquizz);
	$report = '';
	$answers = '';

	# check if quizz is active
	if ($active == 0) {
		$boxtxt .= '<div class="centertag"><span class="normaltext">' . _QUI_MUSTBEACTIVE . '</span></div>';
		return;
	}

	# check if the quizz is restrict to registered user
	if ( ($restrict_user == 1) and (!$opnConfig['permission']->IsUser () ) ) {
		$boxtxt .= '<div class="centertag"><span class="normaltext">' . _QUI_MUSTBEUSER . '</span></div>';
		return;
	}

	# check if the user is logged (only one vote for the quizz)
	if ($log_user == 1) {

		# search in the database for a previous vote

		$_logname = $opnConfig['opnSQL']->qstr ($logname);
		$_adrs = $opnConfig['opnSQL']->qstr ($adrs);
		$sql = 'SELECT username,email FROM ' . $opnTables['quizz_check'] . " WHERE (qid=$qid AND username=$_logname) OR (qid=$qid AND email=$_adrs)";
		$result = &$opnConfig['database']->Execute ($sql);
		$username = $result->fields['username'];
		$email = $result->fields['email'];

		# already recorded ?
		if ($username == $logname or $email == $adrs) {
			$boxtxt .= '<div class="centertag"><span class="normaltext">' . _QUI_ALREADYVOTED . '</span></div>';
			return;
		}
	}

	# display a header if you have choose to show the score
	if ($displayscore == 1) {
		$table = & new opn_TableClass ('default');
		$table->AddOpenRow ();
		$table->AddDataCol ('<span class="bigtextbold">' . _QUI_RESULT . ' "' . $quizzTitle . '"</span>', 'center');
		if (!empty ($image) ) {
			$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/modules/quizz/images/' . $image . '" class="imgtag" alt="">', 'center', '', 'midle', '2');
		}
		$table->AddChangeRow ();
		$table->AddDataCol ($comment);
		$table->AddCloseRow ();
		$table->GetTable ($boxtxt);
	}

	# update nb voter for current quizz

	$sql = 'UPDATE ' . $opnTables['quizz_admin'] . " SET voters=voters+1 WHERE quizzid=$qid";
	$opnConfig['database']->Execute ($sql);
	$sql = 'SELECT pollid, polltitle, voters, answer, coef, good, bad, comment, image FROM ' . $opnTables['quizz_desc'] . " WHERE qid=$qid";
	$result = &$opnConfig['database']->Execute ($sql);
	$score = 0;
	$num = 1;
	while (! $result->EOF) {

		# check if ordered answer needed

		$pollID = $result->fields['pollid'];
		$pollTitle = $result->fields['polltitle'];

		#		$voters = $result->fields['voters'];

		$answer = $result->fields['answer'];
		$coef = $result->fields['coef'];
		$good = $result->fields['good'];
		$bad = $result->fields['bad'];
		$comment = $result->fields['comment'];
		$image = $result->fields['image'];
		if (preg_match ('/,/', $answer) ) {

			#			$array_answer = split(',',$answer);

			$ordered_answer = implode (',', $voteQuiz[$pollID]);
			$ordered_answer = preg_replace ("/,--|--,|--/", '', $ordered_answer);
			foreach (explode (',', $answer) as $val) {
				$sql = 'UPDATE ' . $opnTables['quizz_data'] . " SET optioncount=optioncount+1 WHERE (pollid=$pollID) AND (voteid=$val)";
				$opnConfig['database']->Execute ($sql);
			}

			# update nb result for current answer (stat purpose)
		} else {
			$ordered_answer = '';

			# update nb result for current answer (stat purpose)
			if (isset ($voteQuiz[$pollID]) ) {
				$sql = 'UPDATE ' . $opnTables['quizz_data'] . " SET optioncount=optioncount+1 WHERE (pollid=$pollID) AND (voteid=$voteQuiz[$pollID])";
				$opnConfig['database']->Execute ($sql);
			}
		}

		# update nb result for current question (stat purpose)

		$sql = 'UPDATE ' . $opnTables['quizz_desc'] . " SET voters=voters+1 WHERE pollid=$pollID";
		$opnConfig['database']->Execute ($sql);

		# display results ?
		if ($displayresults == 1) {

			# check if ordered answers to display results
			if (!empty ($ordered_answer) ) {
				$sql = 'SELECT optiontext, voteid FROM ' . $opnTables['quizz_data'] . " WHERE pollid=$pollID ORDER BY voteid";
				$result1 = &$opnConfig['database']->Execute ($sql);
				while (! $result1->EOF) {
					$optionText = $result1->fields['optiontext'];
					$voteID = $result1->fields['voteid'];
					$array_text[$voteID] = $optionText;
					$result1->MoveNext ();
				}

				# sort of the user answer

				$optionText = '';
				foreach ($voteQuiz[$pollID] as $val) {
					$optionText .= "$array_text[$val] ";
				}
				$answerText = '';
				foreach (explode (',', $answer) as $val) {
					$answerText .= "$array_text[$val] ";
				}
			} else {
				if (isset ($voteQuiz[$pollID]) ) {
					$sql = 'SELECT optiontext FROM ' . $opnTables['quizz_data'] . " WHERE (pollid=$pollID) AND (voteid=$voteQuiz[$pollID])";
					$result1 = &$opnConfig['database']->Execute ($sql);
					$optionText = $result1->fields['optiontext'];
				}
				$sql = 'SELECT optiontext FROM ' . $opnTables['quizz_data'] . " WHERE (pollid=$pollID) AND (voteid=$answer)";
				$result1 = &$opnConfig['database']->Execute ($sql);
				$answerText = $result1->fields['optiontext'];
			}
			if (!isset ($optionText) ) {
				$optionText = '';
			}
			$table = & new opn_TableClass ('default');
			$table->AddOpenRow ();
			$table->AddDataCol ($num . ' - ' . _QUI_FORTHEQUESTION . ' "' . $pollTitle . '"', '', '4');
			$table->AddChangeRow ();
			$table->AddDataCol ('&nbsp;');
			$table->AddDataCol (_QUI_YOUHAVECHOOSE);
			$table->AddDataCol ($optionText);
			$table->AddDataCol ('&nbsp;');
			$table->AddChangeRow ();
			$table->AddDataCol ('&nbsp;');
			$table->AddDataCol (_QUI_CORRECTANSWER);
			$table->AddDataCol ($answerText);
			$table->AddDataCol ('&nbsp;');
			$report .= $num . ' - ' . _QUI_FORTHEQUESTION . ' "' . $pollTitle . '", ';
			$report .= _QUI_YOUHAVECHOOSE . ' "' . $optionText . '" ' . _QUI_CORRECTANSWER . ' "' . $answerText . '" ' . "\n";
			$table->AddChangeRow ();
			$table->AddDataCol ('&nbsp;');
			$hlp = '';
			if (!isset ($voteQuiz[$pollID]) ) {
				$voteQuiz[$pollID] = '';
			}
			if ( (empty ($ordered_answer) and $voteQuiz[$pollID] == $answer) or (!empty ($ordered_answer) and $ordered_answer == $answer) ) {
				if (!empty ($good) ) {
					$hlp .= '<br />' . $good;
				}
			} else {
				if (!empty ($bad) ) {
					$hlp .= '<br />' . $bad;
				}
			}
			$table->AddDataCol ($hlp, '', '2');
			$table->AddCloseRow ();
			$table->GetTable ($boxtxt);
		}

		# check for the correct answer ?
		if ( (empty ($ordered_answer) and $voteQuiz[$pollID] == $answer) or (!empty ($ordered_answer) and $ordered_answer == $answer) ) {
			$score = $score+ $coef;
		}
		if (empty ($ordered_answer) ) {
			$answers .= "$voteQuiz[$pollID]|";
		} else {
			$answers .= "$ordered_answer|";
		}
		$num++;
		$result->MoveNext ();
	}

	# display the final score ?
	if ($displayscore == 1) {
		$boxtxt .= '<span class="normaltext">' . _QUI_YOURSCORE . " : $score</span>";
	}

	# store the available infos if needed

	$opnConfig['opndate']->now ();
	$ctime = '';
	$opnConfig['opndate']->opnDataTosql ($ctime);
	$ip = $opnConfig['opnOption']['client']->property ('ip');
	$_logname = $opnConfig['opnSQL']->qstr ($logname);
	$_adrs = $opnConfig['opnSQL']->qstr ($adrs);
	$_answers = $opnConfig['opnSQL']->qstr ($answers);
	$_ip = $opnConfig['opnSQL']->qstr ($ip);
	$sql = 'INSERT INTO ' . $opnTables['quizz_check'] . " VALUES ($_ip,$ctime,$_logname,$_adrs,$qid,$score,$_answers)";
	$opnConfig['database']->Execute ($sql);

	# show the score if needed
	if ($displayscore == 1) {
		$sql = 'SELECT username, score FROM ' . $opnTables['quizz_check'] . " WHERE qid=$qid ORDER BY score DESC,wtime DESC";
		$result = &$opnConfig['database']->SelectLimit ($sql, $nbscore);
		$table = & new opn_TableClass ('default');
		$table->AddCols (array ('20%', '80%') );
		if ($result->RecordCount ()>0) {
			$table->AddOpenRow ();
			$table->AddDataCol (_QUI_LISTSCORE, '', '2');
			while (! $result->EOF) {
				$username = $result->fields['username'];
				$res = $result->fields['score'];
				$table->AddChangeRow ();
				$table->AddDataCol ($username . ':');
				$table->AddDataCol ($res);
				$result->MoveNext ();
			}
			$table->AddCloseRow ();
		} else {
			$table->AddDataRow (array ('&nbsp;') );
		}
		$table->GetTable ($boxtxt);
	}

	# bye bye !! :)

	$boxtxt .= '<span class="normaltext">' . $showafterquizz . '</span>';

	# send an email if needed
	if ($emailadmin) {
		if (empty ($admemail) ) {
			$admemail = $opnConfig['adminmail'];
		}
		$subject = "$logname " . _QUI_YOUHASVOTED . " $quizzTitle";
		$vars['{NAME}'] = $logname;
		$vars['{TITLE}'] = $quizzTitle;
		$vars['{NICKNAME}'] = $logname;
		$vars['{EMAIL}'] = $adrs;
		$vars['{SCORE}'] = $score;
		$vars['{ANSWERS}'] = $answers;
		$opnConfig['cleantext']->un_htmlentities ($report);
		$vars['{REPORT}'] = str_replace (_OPN_HTML_NL, _OPN_HTML_CRLF, $report);
		if (!defined ('_OPN_MAILER_INCLUDED') ) {
			include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
		}
		$mail = & new opn_mailer ();
		$mail->opn_mail_fill ($admemail, $subject, 'modules/quizz', 'voting', $vars, $opnConfig['opn_webmaster_name'], $admemail);
		$mail->send ();
		$mail->init ();
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_350_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUI_DESC, $boxtxt, _QUI_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions					*/

/*******************************************************/

function QuizList () {

	global $opnConfig, $opnTables;
	$boxtxt = '';
	$cid = 0;
	get_var ('cid', $cid, 'url', _OOBJ_DTYPE_INT);
	if (!$cid) {
		$table = & new opn_TableClass ('default');
		$sql = "select cid, name, comment, image from " . $opnTables['quizz_categories'] . "";
		$result = &$opnConfig['database']->Execute ($sql);
		while (! $result->EOF) {
			$cid = $result->fields['cid'];
			$name = $result->fields['name'];
			$comment = $result->fields['comment'];
			$image = $result->fields['image'];

			# compute the number of Quiz by Category

			$sql = 'SELECT COUNT(cid) AS counter from ' . $opnTables['quizz_admin'] . ' WHERE cid=' . $cid;
			$res = &$opnConfig['database']->Execute ($sql);
			if ( ($res !== false) && (isset ($res->fields['counter']) ) ) {
				$nb = $res->fields['counter'];
			} else {
				$nb = 0;
			}
			$table->AddOpenRow ();
			if ($nb>0) {
				$hlp = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/index.php',
											'cid' => $cid) ) . '"> ' . $name . ' </a>';
			} else {
				$hlp = ' ' . $name . ' ';
			}
			$table->AddDataCol ($hlp);
			if (!empty ($comment) ) {
				$table->AddDataCol (' : ' . $comment);
			}
			$table->AddDataCol (" ($nb " . _QUI_QUIZZ . ") ");
			if ($opnConfig['permission']->HasRight ('modules/quizz', _PERM_ADMIN, true) ) {
				$hlp = '<a clss="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
											'act' => 'QuizModifyCategory',
											'cid' => $cid) ) . '"> [ ' . _QUI_MODIFY . ' ]</a> | ';
				$hlp .= '<a opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
											'act' => 'QuizDelCategory',
											'cid' => $cid) ) . '"> [ ' . _QUI_DELETE . ' ]</a>';
				$table->AddDataCol ($hlp);
			}
			if (!empty ($image) ) {
				$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/modules/quizz/images/' . $image . '" class="imgtag" alt="' . $comment . '" />');
			}
			$table->AddCloseRow ();
			$result->MoveNext ();
		}
		$table->GetTable ($boxtxt);
	} else {
		$table = & new opn_TableClass ('default');
		$userinfo = $opnConfig['permission']->GetUserinfo ();
		$sql = 'SELECT quizzid, quizztitle, wactive, restrict_user, administrator,displayscore,nbscore from ' . $opnTables['quizz_admin'] . " WHERE cid=$cid ORDER BY wtimestamp desc";
		$result = &$opnConfig['database']->Execute ($sql);
		while (! $result->EOF) {
			$qid = $result->fields['quizzid'];
			$quizzTitle = $result->fields['quizztitle'];
			$active = $result->fields['wactive'];
			$restrict_user = $result->fields['restrict_user'];
			$administrator = $result->fields['administrator'];
			$displayscore = $result->fields['displayscore'];
			$nbscore = $result->fields['nbscore'];

			# display the inactive quizz if admin
			if ( ($opnConfig['permission']->HasRight ('modules/quizz', _PERM_ADMIN, true) ) or ($administrator != "" and $userinfo['uname'] == $administrator) ) {
				if ($active == 1) {
					$img = 'green_dot.gif';
					$alt = _QUI_ACTIVE;
				} else {
					$img = 'red_dot.gif';
					$alt = _QUI_INACTIVE;
				}
				$table->AddOpenRow ();
				$table->AddDataCol ('<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/index.php',
													'qid' => $qid) ) . '">' . $quizzTitle . '</a><img src="' . $opnConfig['opn_url'] . '/modules/quizz/images/' . $img . '" alt="' . $alt . '" title="' . $alt . '">');
				$hlp = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
											'act' => 'QuizViewScore',
											'qid' => $qid) ) . '"> [ ' . _QUI_VIEWSCORE . ' ]</a> | ';
				$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
											'act' => 'QuizRemoveScore',
											'qid' => $qid) ) . '"> [ ' . _QUI_DELSCORE . ' ]</a> <br /> ';
				$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
											'act' => 'QuizViewStats',
											'qid' => $qid) ) . '"> [ ' . _QUI_VIEWSTAT . ' ]</a> | ';
				$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
											'act' => 'QuizModify',
											'qid' => $qid) ) . '"> [ ' . _QUI_MODIFY . ' ]</a> | ';
				$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/admin/index.php',
											'act' => 'QuizRemove',
											'qid' => $qid) ) . '"> [ ' . _QUI_DELETE . ' ]</a>';
				$table->AddDataCol ($hlp);

				# compute the number of Question in the Quiz

				$sql = 'SELECT COUNT(qid) AS counter from ' . $opnTables['quizz_desc'] . ' WHERE qid=' . $qid;
				$res = &$opnConfig['database']->Execute ($sql);
				if ( ($res !== false) && (isset ($res->fields['counter']) ) ) {
					$nb = $res->fields['counter'];
				} else {
					$nb = 0;
				}
				$table->AddDataCol (' (' . $nb . '&nbsp;' . _QUI_QUESTIONSNB . ')');
				if ($displayscore) {
					$table->AddChangeRow ();
					$sql = 'SELECT username, score FROM ' . $opnTables['quizz_check'] . " WHERE qid=$qid ORDER BY score DESC,wtime DESC";
					$ress = &$opnConfig['database']->SelectLimit ($sql, $nbscore);
					$hlp = '<br /><br />';
					$table1 = & new opn_TableClass ('default');
					$table1->AddCols (array ('20%', '80%') );
					if ($ress->RecordCount ()>0) {
						$table1->AddDataCol (_QUI_LISTSCORE, '', '2');
						$table1->AddCloseRow ();
						while (! $ress->EOF) {
							$username = $ress->fields['username'];
							$res = $ress->fields['score'];
							$table1->AddOpenRow ();
							$table1->AddDataCol ($username);
							$table1->AddDataCol ($res);
							$table1->AddCloseRow ();
							$ress->MoveNext ();
						}
					} else {
						$table1->AddDataCol ('&nbsp;', '', '2');
						$table1->AddCloseRow ();
					}
					$hlp = '';
					$table1->GetTable ($hlp);
					$table->AddDataCol ($hlp, '', '3');
				}
				$table->AddCloseRow ();
			} else
			if ($active == 1) {
				$table->AddOpenRow ();
				if ($restrict_user == 1 and !$opnConfig['permission']->IsUser () ) {
					$rimg = '<img src="' . $opnConfig['opn_url'] . '/modules/quizz/images/red_dot.gif" alt="' . _QUI_ONLYREGISTERED . '" title="' . _QUI_ONLYREGISTERED . '" />';
					$hlp = "$quizzTitle $rimg";
				} else {
					$hlp = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/quizz/index.php',
												'qid' => $qid) ) . '">  ' . $quizzTitle . ' </a>';
				}
				$table->AddDataCol ($hlp);

				# compute the number of Question in the Quiz

				$sql = 'SELECT COUNT(qid) AS counter from ' . $opnTables['quizz_desc'] . ' WHERE qid=' . $qid;
				$res = &$opnConfig['database']->Execute ($sql);
				if ( ($res !== false) && (isset ($res->fields['counter']) ) ) {
					$nb = $res->fields['counter'];
				} else {
					$nb = 0;
				}
				$table->AddDataCol (" ($nb " . _QUI_QUESTIONSNB . ")");
				if ($displayscore) {
					$table->AddChangeRow ();
					$sql = 'SELECT username, score FROM ' . $opnTables['quizz_check'] . " WHERE qid=$qid ORDER BY score DESC,wtime DESC";
					$ress = &$opnConfig['database']->SelectLimit ($sql, $nbscore);
					$hlp = '<br /><br />';
					$table1 = & new opn_TableClass ('default');
					$table1->AddCols (array ('20%', '80%') );
					if ($ress->RecordCount ()>0) {
						$table1->AddDataCol (_QUI_LISTSCORE, '', '2');
						$table1->AddCloseRow ();
						while (! $ress->EOF) {
							$username = $ress->fields['username'];
							$res = $ress->fields['score'];
							$table1->AddOpenRow ();
							$table1->AddDataCol ($username);
							$table1->AddDataCol ($res);
							$table1->AddCloseRow ();
							$ress->MoveNext ();
						}
					} else {
						$table1->AddDataCol ('&nbsp;', '', '2');
						$table1->AddCloseRow ();
					}
					$hlp = '';
					$table1->GetTable ($hlp);
					$table->AddDataCol ($hlp, '', '2');
				}
				$table->AddCloseRow ();
			}
			$result->MoveNext ();
		}
		$table->GetTable ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_360_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUI_LIST, $boxtxt, _QUI_QUIFOOTER);

}

/*********************************************************/

/* Quiz Functions					*/

/*******************************************************/

function ViewConditions () {

	global $opnTables, $opnConfig;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$result = $opnConfig['database']->Execute ('SELECT quizztitle, conditions FROM ' . $opnTables['quizz_admin'] . ' WHERE quizzid=' . $qid);
	$quizzTitle = $result->fields['quizztitle'];
	$conditions = $result->fields['conditions'];
	opn_nl2br ($conditions);
	$boxtxt = '<div class="centertag"><span class="bigtextbold">' . $quizzTitle . '</span></div>';
	$boxtxt .= '<br />';
	$boxtxt .= '<br />';
	$boxtxt .= $conditions;
	$boxtxt .= '<br />';
	$boxtxt .= '<div class="centertag"><a class="opncenterbox" href="javascript:history.go(-1)">' . _QUI_GOBKACK . '</a></div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_370_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUI_CONDITIONS, $boxtxt);

}

function QuizVoteRegister () {

	global $opnConfig, $opnTables;

	$boxtxt = '';
	$qid = 0;
	get_var ('qid', $qid, 'form', _OOBJ_DTYPE_INT);
	$voteQuiz = '';
	get_var ('voteQuiz', $voteQuiz, 'form', _OOBJ_DTYPE_CLEAN);
	$sql = 'SELECT quizztitle, nbscore, displayscore, displayresults, emailadmin, wactive, restrict_user, log_user, image, contrib, admemail, comment, showafterquizz FROM ' . $opnTables['quizz_admin'] . ' WHERE quizzid=' . $qid;
	$result = &$opnConfig['database']->Execute ($sql);
	$quizzTitle = $result->fields['quizztitle'];
	$displayscore = $result->fields['displayscore'];
	$displayresults = $result->fields['displayresults'];
	$image = $result->fields['image'];
	$comment = $result->fields['comment'];
	$showafterquizz = $result->fields['showafterquizz'];
	if ($showafterquizz == '') {
		$showafterquizz = _QUI_THANKS;
	}
	opn_nl2br ($showafterquizz);
	$report = '';
	$answers = '';

	# display a header if you have choose to show the score
	if ($displayscore == 1) {
		$table = & new opn_TableClass ('default');
		$table->AddOpenRow ();
		$table->AddDataCol ('<span class="bigtextbold">' . _QUI_RESULT . ' "' . $quizzTitle . '"</span>', 'center');
		if (!empty ($image) ) {
			$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/modules/quizz/images/' . $image . '" class="imgtag" alt="">', 'center', '', 'midle', '2');
		}
		$table->AddChangeRow ();
		$table->AddDataCol ($comment);
		$table->AddCloseRow ();
		$table->GetTable ($boxtxt);
	}

	# update nb voter for current quizz

	$sql = 'UPDATE ' . $opnTables['quizz_admin'] . ' SET voters=voters+1 WHERE quizzid=' . $qid;
	$opnConfig['database']->Execute ($sql);
	$sql = 'SELECT pollid, polltitle, voters, answer, coef, good, bad, comment, image FROM ' . $opnTables['quizz_desc'] . ' WHERE qid=' . $qid;
	$result = &$opnConfig['database']->Execute ($sql);
	$score = 0;
	$rightcounter = 0;
	$wrongcounter = 0;
	$num = 1;
	while (! $result->EOF) {
		$wrongcounter++;

		# check if ordered answer needed

		$pollID = $result->fields['pollid'];
		$pollTitle = $result->fields['polltitle'];

		#		$voters = $result->fields['voters'];

		$answer = $result->fields['answer'];
		$coef = $result->fields['coef'];
		$good = $result->fields['good'];
		$bad = $result->fields['bad'];
		$comment = $result->fields['comment'];
		$image = $result->fields['image'];
		if (preg_match ('/,/', $answer) ) {

			#			$array_answer = split(',',$answer);

			$ordered_answer = implode (',', $voteQuiz[$pollID]);
			$ordered_answer = preg_replace ("/,--|--,|--/", '', $ordered_answer);
			foreach (explode (',', $answer) as $val) {
				$sql = 'UPDATE ' . $opnTables['quizz_data'] . " SET optioncount=optioncount+1 WHERE (pollid=$pollID) AND (voteid=$val)";
				$opnConfig['database']->Execute ($sql);
			}

			# update nb result for current answer (stat purpose)
		} else {
			$ordered_answer = '';

			# update nb result for current answer (stat purpose)
			if (isset ($voteQuiz[$pollID]) ) {
				$sql = 'UPDATE ' . $opnTables['quizz_data'] . " SET optioncount=optioncount+1 WHERE (pollid=$pollID) AND (voteid=$voteQuiz[$pollID])";
				$opnConfig['database']->Execute ($sql);
			}
		}

		# update nb result for current question (stat purpose)

		$sql = 'UPDATE ' . $opnTables['quizz_desc'] . " SET voters=voters+1 WHERE pollid=$pollID";
		$opnConfig['database']->Execute ($sql);

		# display results ?
		if ($displayresults == 1) {

			# check if ordered answers to display results
			if (!empty ($ordered_answer) ) {
				$sql = 'SELECT optiontext, voteid FROM ' . $opnTables['quizz_data'] . " WHERE pollid=$pollID ORDER BY voteid";
				$result1 = &$opnConfig['database']->Execute ($sql);
				while (! $result1->EOF) {
					$optionText = $result1->fields['optiontext'];
					$voteID = $result1->fields['voteid'];
					$array_text[$voteID] = $optionText;
					$result1->MoveNext ();
				}

				# sort of the user answer

				$optionText = '';
				foreach ($voteQuiz[$pollID] as $val) {
					$optionText .= "$array_text[$val] ";
				}
				$answerText = '';
				foreach (explode (',', $answer) as $val) {
					$answerText .= "$array_text[$val] ";
				}
			} else {
				if (isset ($voteQuiz[$pollID]) ) {
					$sql = 'SELECT optiontext FROM ' . $opnTables['quizz_data'] . " WHERE (pollid=$pollID) AND (voteid=$voteQuiz[$pollID])";
					$result1 = &$opnConfig['database']->Execute ($sql);
					$optionText = $result1->fields['optiontext'];
				}
				$sql = 'SELECT optiontext FROM ' . $opnTables['quizz_data'] . " WHERE (pollid=$pollID) AND (voteid=$answer)";
				$result1 = &$opnConfig['database']->Execute ($sql);
				$answerText = $result1->fields['optiontext'];
			}
			if (!isset ($optionText) ) {
				$optionText = '';
			}
			$table = & new opn_TableClass ('default');
			$table->AddOpenRow ();
			$table->AddDataCol ($num . ' - ' . _QUI_FORTHEQUESTION . ' "' . $pollTitle . '"', '', '4');
			$table->AddChangeRow ();
			$table->AddDataCol ('&nbsp;');
			$table->AddDataCol (_QUI_YOUHAVECHOOSE);
			$table->AddDataCol ($optionText);
			$table->AddDataCol ('&nbsp;');
			$table->AddChangeRow ();
			$table->AddDataCol ('&nbsp;');
			$table->AddDataCol (_QUI_CORRECTANSWER);
			$table->AddDataCol ($answerText);
			$table->AddDataCol ('&nbsp;');
			$report .= $num . ' - ' . _QUI_FORTHEQUESTION . ' "' . $pollTitle . '", ';
			$report .= _QUI_YOUHAVECHOOSE . ' "' . $optionText . '" ' . _QUI_CORRECTANSWER . ' "' . $answerText . '" ' . "\n";
			$table->AddChangeRow ();
			$table->AddDataCol ('&nbsp;');
			$hlp = '';
			if (!isset ($voteQuiz[$pollID]) ) {
				$voteQuiz[$pollID] = '';
			}
			if ( (empty ($ordered_answer) and $voteQuiz[$pollID] == $answer) or (!empty ($ordered_answer) and $ordered_answer == $answer) ) {
				if (!empty ($good) ) {
					$hlp .= '<br />' . $good;
				}
			} else {
				if (!empty ($bad) ) {
					$hlp .= '<br />' . $bad;
				}
			}
			$table->AddDataCol ($hlp, '', '2');
			$table->AddCloseRow ();
			$table->GetTable ($boxtxt);
		}

		# check for the correct answer ?
		if ( (empty ($ordered_answer) and $voteQuiz[$pollID] == $answer) or (!empty ($ordered_answer) and $ordered_answer == $answer) ) {
			$score = $score+ $coef;
			$rightcounter++;
		}
		if (empty ($ordered_answer) ) {
			$answers .= "$voteQuiz[$pollID]|";
		} else {
			$answers .= "$ordered_answer|";
		}
		$num++;
		$result->MoveNext ();
	}

	# display the final score ?
	if ($displayscore == 1) {
		$boxtxt .= '<span class="normaltext">' . _QUI_YOURSCORE . " : $score</span>";
		$boxtxt .= '<br />';
		$boxtxt .= '<br />';
	}

	# store the available infos if needed

	$opnConfig['opndate']->now ();
	$ctime = '';
	$opnConfig['opndate']->opnDataTosql ($ctime);
	$ip = $opnConfig['opnOption']['client']->property ('ip');
	$_answers = $opnConfig['opnSQL']->qstr ($answers);
	$_ip = $opnConfig['opnSQL']->qstr ($ip);
	$sql = 'INSERT INTO ' . $opnTables['quizz_check'] . " VALUES ($_ip,$ctime,'NeuUser','',$qid,$score,$_answers)";
	$opnConfig['database']->Execute ($sql);
	if ($rightcounter == $wrongcounter) {
		include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_activation.php');
		$opnConfig['activation'] = & new OPNActivation ();
		$opnConfig['activation']->InitActivation ();
		$opnConfig['activation']->BuildActivationKey ();
		$opnConfig['activation']->SetActdata ('quizz');
		$opnConfig['activation']->SetExtraData ('dummy');
		$opnConfig['activation']->SaveActivation ();
		$url = array ($opnConfig['opn_url'] . '/system/user/register.php',
				'op' => 'activation',
				'modul' => 'quizz',
				'code' => $opnConfig['activation']->GetActivationKey () );
		$boxtxt .= '<br />';
		$boxtxt .= '<br />';
		$boxtxt .= '<br />';
		$boxtxt .= _QUI_REG_QUALLI . '<a class="opncenterbox" href="' . encodeurl ($url) . '">' . _QUI_NOTREGIS1 . '</a>' . _OPN_HTML_NL;
	}
	$boxtxt .= '<br />';
	$boxtxt .= '<br />';
	$boxtxt .= '<span class="normaltext">' . $showafterquizz . '</span>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QUIZZ_380_';
	$_display_dat['module'] = 'modules/quizz';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_QUI_DESC, $boxtxt);

}

?>