<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;

$opnConfig['permission']->InitPermissions ('modules/tutorial');
$opnConfig['permission']->HasRight ('modules/tutorial', _PERM_WRITE);
$opnConfig['module']->InitModule ('modules/tutorial');
$opnConfig['opnOutput']->setMetaPageName ('modules/tutorial');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.myfunctions.php');
include_once (_OPN_ROOT_PATH . 'modules/tutorial/include/tutorialfunctions.php');
include_once (_OPN_ROOT_PATH . 'modules/tutorial/include/submiter.php');
getLanguageDef (_OPN_ROOT_PATH . 'modules/tutorial/language/');
require (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.fileupload.php');
$opnConfig['opnOption']['tutorial_uploadfilename'] = 'userfile';

function denyAnonymous () {

	global $opnConfig;

	$boxtitle = _TUT_SUBMITNEWS;
	$boxtext = sprintf (_OPNMESSAGE_NO_USER, '<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/user/register.php">', '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user/index.php?op=login') . '">');
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TUTORIAL_390_';
	$_display_dat['module'] = 'modules/tutorial';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtext);

}

function defaultDisplay () {

	global $opnConfig, $opnTables;
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
	}
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$mf = & new MyFunctions;
	$form = & new opn_FormularClass ('listalternator');
	$mf->table = $opnTables['tutorial_topics'];
	$mf->id = 'topicid';
	$mf->title = 'topictext';
	$mf->where = '(user_group IN (' . $checkerlist . '))';
	$boxtitle = _TUT_SUBMITNEWS;
	$boxtext = '';
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_400_', 'tutorial');
	if ($opnConfig['permission']->HasRight ('modules/tutorial', _TUT_PERM_UPLOAD, true) ) {
		$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/submit.php', 'post', 'coolsus', 'multipart/form-data');
	} else {
		$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/submit.php', 'post', 'coolsus');
	}
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText (_TUT_YOURNAME);
	if ($opnConfig['permission']->IsUser () ) {
		$cookie = $opnConfig['permission']->GetUserinfo ();
		$form->SetSameCol ();
		$form->AddText (' <a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . $cookie['uname'] . '</a>');
		$form->AddText (' [ <a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user/index.php?op=logout') . '">' . _TUT_LOGOUT . '</a> ]');
		$form->SetEndCol ();
	} else {
		$form->AddText (' ' . $opnConfig['opn_anonymous_name'] . ' [ <a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . _TUT_NEWUSER . '</a> ]');
	}
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddLabel ('subject', _TUT_TITLE);
	$form->AddText ('(' . _TUT_TITLEHINT . ')');
	$form->SetEndCol ();
	$form->SetSameCol ();
	$form->AddTextfield ('subject', 70, 80);
	$form->AddText ('<br />(' . _TUT_BADTITLE . ')');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('topicid', _TUT_TOPIC);
	$mf->makeMySelBox (0, $form);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddLabel ('tutorial', _TUT_SCOOP);
	$form->AddText ('<br />(' . _TUT_SCOOPHINT . ')');
	$form->SetEndCol ();
	if ($opnConfig['permission']->HasRight ('modules/tutorial', _TUT_PERM_USERIMAGES, true) ) {
		$form->UseImages (true);
	}
	$form->AddTextarea ('tutorial', 0, 0, '', '', 'storeCaret(this)', 'storeCaret(this)', 'storeCaret(this)');
	$form->AddChangeRow ();
	if ($opnConfig['permission']->HasRight ('modules/tutorial', _TUT_PERM_UPLOAD, true) ) {
		$form->AddText ('&nbsp;');
		$form->SetSameCol ();
		$form->AddHidden ('MAX_FILE_SIZE', $opnConfig['opn_upload_size_limit']);
		$form->AddFile ('userfile');
		$form->SetEndCol ();
	} else {
		$form->AddText ('&nbsp;');
		$form->AddHidden ('userfile', 'none');
	}
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$options = array ();
	$options['exttrans'] = _TUT_SCOOPTYPE1;
	$options['html'] = _TUT_SCOOPTYPE2;
	$options['plaintext'] = _TUT_SCOOPTYPE3;
	$form->SetSameCol ();
	$form->AddSelect ('posttype', $options, 'html');
	$form->AddNewline ();
	$form->AddText ('(' . _TUT_HINT . ')');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->AddSubmit ('op', _TUT_PREVIEW);
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->AddText ('(' . _TUT_PREVIEW2SUBMIT . ')');
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtext);
	$opnConfig['opnOutput']->EnableJavaScript ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TUTORIAL_410_';
	$_display_dat['module'] = 'modules/tutorial';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtext);

}

function PreviewTutorial () {

	global $opnConfig, $opnTables;
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
	}
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$mf = & new MyFunctions;
	$mf->table = $opnTables['tutorial_topics'];
	$mf->id = 'topicid';
	$mf->title = 'topictext';
	$mf->where = '(user_group IN (' . $checkerlist . '))';
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$tutorial = '';
	get_var ('tutorial', $tutorial, 'form', _OOBJ_DTYPE_CHECK);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$posttype = '';
	get_var ('posttype', $posttype, 'form', _OOBJ_DTYPE_CHECK);
	$userfile = '';
	get_var ('userfile', $userfile, 'file');
	$year = 9999;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_CLEAN);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$hour = 0;
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_INT);
	$min = 0;
	get_var ('min', $min, 'form', _OOBJ_DTYPE_INT);
	$file = '';
	get_var ('file', $file, 'form', _OOBJ_DTYPE_CLEAN);

	$boxtitle = _TUT_SUBMITNEWS;
	if (($subject != '') && ($tutorial != '')) {
		if ($userfile == '') {
			$userfile = 'none';
		}
		$userfile = check_upload ($userfile);
		if ($userfile <> 'none') {
			$upload = & new file_upload_class;
			$upload->max_filesize ($opnConfig['opn_upload_size_limit']);
			if ($upload->upload ('userfile', 'image', '') ) {
				if ($upload->save_file ($opnConfig['datasave']['tut_bild_upload']['path'], 3) ) {
					$file = $upload->new_file;
				}
			}
			if ( (isset ($upload->errors) ) && ($upload->errors) ) {
				$file = '';
			}
		} else {
			$file = $userfile;
		}
		$tutorial = $opnConfig['cleantext']->FixQuotes ($tutorial);
		$subject = $opnConfig['cleantext']->FixQuotes ($subject);
		$boxtext = '';
		$p_subject = $opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml');
		if ($posttype == 'exttrans') {
			$p_tutorial = $opnConfig['cleantext']->filter_text (htmlspecialchars ($tutorial), true);
		} elseif ($posttype == 'plaintext') {
			$p_tutorial = $opnConfig['cleantext']->filter_text ($tutorial, true, true, 'nohtml');
		} else {
			$p_tutorial = $opnConfig['cleantext']->filter_text ($tutorial, true, true);
		}
		$f_subject = $p_subject;
		$f_tutorial = $p_tutorial;
		opn_nl2br ($p_tutorial);
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_420_', 'tutorial');
		$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/submit.php', 'post', 'coolsus');
		$form->AddTable ();
		$form->AddCols (array ('20%', '80%') );
		$form->AddOpenRow ();
		$form->AddText (_TUT_YOURNAME);
		if ($opnConfig['permission']->IsUser () ) {
			$cookie = $opnConfig['permission']->GetUserinfo ();
			$form->SetSameCol ();
			$form->AddText (' <a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . $cookie['uname'] . '</a>');
			$form->AddText (' [ <a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user/index.php?op=logout') . '">' . _TUT_LOGOUT . '</a> ]');
			$form->SetEndCol ();
		} else {
			$form->AddText (' ' . $opnConfig['opn_anonymous_name'] . ' [ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . _TUT_NEWUSER . '</a> ]');
		}
		$form->AddChangeRow ();
		$form->AddText (_TUT_PREVIEWWINDOW);
		if ($topicid == '') {
			$warning = '<div align="center" class="normaltextbold"><br />' . _TUT_SELTOPIC . '</div>';
		} else {
			$warning = '';
		}
		if ($file != 'none') {
			$file = str_ireplace (_OPN_ROOT_PATH, $opnConfig['opn_url'] . '/', $file);
			// $form->AddText('<img src="'.$file.'" class="imgtag" alt="" />');
		}
		TutorialPreviewPart ($form, $topicid, $file, $p_subject, $p_tutorial);
		if ($warning != '') {
			$form->AddChangeRow ();
			$form->AddText ('&nbsp;');
			$form->AddText ($warning);
		}
		$form->AddChangeRow ();
		$form->AddLabel ('subject', _TUT_TITLE);
		$form->AddTextfield ('subject', 70, 80, $f_subject);
		$form->AddChangeRow ();
		$form->AddLabel ('topicid', _TUT_TOPIC);
		$mf->makeMySelBox ($topicid, $form);
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddLabel ('tutorial', _TUT_SCOOP);
		$form->AddText ('<br />' . _TUT_SCOOPHINT . ')');
		$form->SetEndCol ();
		if ($opnConfig['permission']->HasRight ('modules/tutorial', _TUT_PERM_USERIMAGES, true) ) {
			$form->UseImages (true);
		}
		$form->AddTextarea ('tutorial', 0, 0, '', $f_tutorial, 'storeCaret(this)', 'storeCaret(this)', 'storeCaret(this)');

		/*
		if ($opnConfig['tut_use_upload'] == 1) {
		$form->AddText('<br /><br />');
		$form->AddHidden('MAX_FILE_SIZE',30000);
		$form->AddFile('userfile');
		$form->AddText('');
		} else {
		$form->AddHidden('userfile',$file);
		}
		*/

		$form->AddChangeRow ();
		$options['exttrans'] = _TUT_SCOOPTYPE1;
		$options['html'] = _TUT_SCOOPTYPE2;
		$options['plaintext'] = _TUT_SCOOPTYPE3;
		$form->AddText ('&nbsp;');
		$form->SetSameCol ();
		$form->AddSelect ('posttype', $options, $posttype);
		$form->AddText ('<br />(' . _TUT_HINT . ')');
		$form->SetEndCol ();
		if ($opnConfig['permission']->HasRight ('modules/tutorial', _TUT_PERM_DELTIME, true) ) {
			// hier start the AutoDel Part
			$opnConfig['opndate']->now ();
			$ttmon = '';
			$opnConfig['opndate']->getMonth ($ttmon);
			$ttday = '';
			$opnConfig['opndate']->getDay ($ttday);
			$tthour = '';
			$opnConfig['opndate']->getHour ($tthour);
			$ttmin = '';
			$opnConfig['opndate']->getMinute ($ttmin);
			if ($year == '') {
				$year = 9999;
			}
			if ($month == '') {
				$month = $ttmon;
			}
			if ($day == '') {
				$day = $ttday;
			}
			if ($hour == '') {
				$hour = $tthour;
			}
			if ($min == '') {
				$min = $ttmin;
			}
			$form->AddChangeRow ();
			$form->AddText (_TUT_SUBMITWHENDOYOUDELTUTORIAL);
			$temp = '';
			$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
			$form->SetSameCol ();
			$form->AddText (_TUT_SUBMITNOWIS . ' ' . $temp);
			$form->AddNewline (2);
			$options = array ();
			$xday = 1;
			while ($xday<=31) {
				$options[$xday] = $xday;
				$xday++;
			}
			$form->AddLabel ('day', _TUT_SUBMITDAY . ' ');
			$form->AddSelect ('day', $options, $day);
			$xmonth = 1;
			$cero = '0';
			$options = array ();
			while ($xmonth<=12) {
				$dummy = $xmonth;
				if ($xmonth<10) {
					$xmonth = "$cero$xmonth";
				}
				$options[$xmonth] = $xmonth;
				$xmonth = $dummy;
				$xmonth++;
			}
			$form->AddLabel ('month', ' ' . _TUT_SUBMITMONTH . ' ');
			$form->AddSelect ('month', $options, $month);
			$form->AddLabel ('year', ' ' . _TUT_SUBMITYEAR . ' ');
			$form->AddTextfield ('year', 5, 4, $year);
			$xhour = 0;
			$options = array ();
			while ($xhour<=23) {
				$dummy = $xhour;
				if ($xhour<10) {
					$xhour = "$cero$xhour";
				}
				$options[$xhour] = $xhour;
				$xhour = $dummy;
				$xhour++;
			}
			$form->AddLabel ('hour', _TUT_SUBMITHOUR . ' ');
			$form->AddSelect ('hour', $options, $hour);
			$xmin = 0;
			$options = array ();
			while ($xmin<=59) {
				if ( ($xmin == 0) OR ($xmin == 5) ) {
					$xmin = "0$xmin";
				}
				$options[$xmin] = $xmin;
				$xmin = $xmin+5;
			}
			$form->AddLabel ('min', ' : ');
			$form->AddSelect ('min', $options, $min);
			$form->AddText (' : 00');
			$form->SetEndCol ();
		}
		// hier stop the AutoDel Part
		$form->AddChangeRow ();
		$form->AddHidden ('userfile', $file);
		$form->SetSameCol ();
		$form->AddSubmit ('op', _TUT_PREVIEW);
		$form->AddSubmit ('op', _TUT_SUBMIT);
		$form->SetEndCol ();
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtext);
		$opnConfig['opnOutput']->EnableJavaScript ();
	} else {
		$boxtext = '<div class="centertag">' . _TUT_SUBJECTSTORY . '<br />';
		$boxtext .= '[ <a class="opncenterbox" href="javascript:history.go(-1)">' . _TUT_GOBACK . '</a> ]</div>';
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TUTORIAL_430_';
	$_display_dat['module'] = 'modules/tutorial';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtext);

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case _TUT_PREVIEW:
		PreviewTutorial ();
		break;
	case _TUT_SUBMIT:
		SubmitTutorial ();
		break;
	default:
		defaultDisplay ();
		break;
}

?>