<?php
/**
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function weblogs_set_edit_link ($lid) {

	global $opnConfig;

	$boxtxt = '';
	if ($opnConfig['permission']->HasRight ('modules/weblogs', _PERM_ADMIN, true) ) {
		$boxtxt .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/weblogs/admin/index.php',
										'op' => 'weblogsModLink',
										'lid' => $lid), 'opncenterbox' );
		$boxtxt .= '&nbsp;';
	}
	return $boxtxt;

}

function weblogs_menu () {

	global $opnConfig;
	if ($opnConfig['weblogs_nav'] != 1) {
		$boxtxt = '<div class="centertag">';
		$boxtxt .= theme_boxi ($opnConfig['opn_url'] . '/modules/weblogs/index.php?op=NewLinks', '' . _WEB_NEWLOGS . '', '', '');
		$boxtxt .= '</div>';
		$boxtxt .= '<br />';
		return $boxtxt;
	}
	return '';

}

function weblogs_SearchForm () {

	global $opnConfig;

	$query = '';
	get_var ('query', $query, 'both');
	$query = $opnConfig['cleantext']->filter_searchtext ($query);
	if ($opnConfig['weblogs_search']) {
		$help = '<div class="centertag">';
		$form = & new opn_FormularClass ('default');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WEBLOGS_110_', 'weblogs');
		$form->Init (encodeurl ($opnConfig['opn_url'] . '/modules/weblogs/index.php') );
		$form->AddTable ();
		$form->AddOpenRow ();
		$form->SetSameCol ();
		$form->AddTextfield ('query', 30, 0, $query);
		$form->AddText (' ');
		$form->AddHidden ('op', 'search');
		$form->AddSubmit ('submit', _WEB_SEARCH);
		$form->SetEndCol ();
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($help);
		$help .= '</div>';
	} else {
		$help = '';
	}
	return $help;

}

function weblogs_index ($webcat) {

	global $opnConfig;

	$boxtxt = '';
	$boxtxt .= weblogs_menu ();
	if ($opnConfig['weblogs_search']) {
		$boxtxt .= weblogs_SearchForm ();
		$boxtxt .= '<br /><br /><br />';
	}
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$hlptxt = $webcat->MainNavigation ();
	if ($hlptxt != '') {
		$boxtxt .= $hlptxt;
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WEBLOGS_120_';
	$_display_dat['module'] = 'modules/weblogs';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_WEB_DESC, $boxtxt);

}

function weblogs_newlinks ($mf) {

	global $opnConfig;

	$newlinkshowdays = 7;
	get_var ('newlinkshowdays', $newlinkshowdays, 'url', _OOBJ_DTYPE_CLEAN);
	$boxtxt = '<br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_WEB_NEWWEBLOGS) );
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br />';
	$counter = 0;
	$allweeklinks = 0;
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->formatTimestamp ($now, '%Y-%m-%d');
	$opnConfig['opndate']->setTimestamp ($now);
	$opnConfig['opndate']->opnDataTosql ($now);
	$newlinkDB = '';
	while ($counter<=6) {
		$opnConfig['opndate']->sqlToopnData ($now);
		$opnConfig['opndate']->subInterval ($counter . ' DAYS');
		$opnConfig['opndate']->opnDataTosql ($newlinkDB);
		$totallinks = $mf->GetItemCount ("wdate LIKE '%$newlinkDB%'");
		$counter++;
		$allweeklinks = $allweeklinks+ $totallinks;
	}
	$counter = 0;
	$allmonthlinks = 0;
	$newlinkDB = '';
	while ($counter<=29) {
		$opnConfig['opndate']->sqlToopnData ($now);
		$opnConfig['opndate']->subInterval ($counter . ' DAYS');
		$opnConfig['opndate']->opnDataTosql ($newlinkDB);
		$totallinks = $mf->GetItemCount ("wdate LIKE '%$newlinkDB%'");
		$allmonthlinks = $allmonthlinks+ $totallinks;
		$counter++;
	}
	$boxtxt .= '<div align="center" class="normaltext">' . _WEB_TOTALNEWLOGS . ' - ' . $allweeklinks . ' \ ' . _WEB_LAST30DAYS . ' - ' . $allmonthlinks . '<br />' . _WEB_SHOW . ' (<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
																													'op' => 'NewLinks',
																													'newlinkshowdays' => '7') ) . '">' . _WEB_WEEK . '</a>, ' . '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
															'op' => 'NewLinks',
															'newlinkshowdays' => '14') ) . '">2 ' . _WEB_WEEKS . '</a>, ' . '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
															'op' => 'NewLinks',
															'newlinkshowdays' => '30') ) . '">30 ' . _WEB_DAYS . '</a>)' . '</div><br />';
	// List Last VARIABLE Days of Links
	if (!isset ($newlinkshowdays) ) {
		$newlinkshowdays = 7;
	}
	$boxtxt .= '<div class="centertag"><br /><span class="normaltextbold">' . _WEB_TOTALNEWLOGSFOR . ' ' . $newlinkshowdays . ' ' . _WEB_DAYS . ':</span><br /><br />';
	$counter = 0;
	$allweeklinks = 0;
	$boxtxt .= '<ul>';
	$newlinkView = '';
	$newlinkdayRaw = '';
	while ($counter<= $newlinkshowdays-1) {
		$opnConfig['opndate']->sqlToopnData ($now);
		$opnConfig['opndate']->subInterval ($counter . ' DAYS');
		$opnConfig['opndate']->opnDataTosql ($newlinkdayRaw);
		$opnConfig['opndate']->formatTimestamp ($newlinkView, _DATE_DATESTRING4);
		$totallinks = $mf->GetItemCount ("wdate LIKE '%$newlinkDB%'");
		$counter++;
		$allweeklinks = $allweeklinks+ $totallinks;
		$boxtxt .= '<li><a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
										'op' => 'NewLinksDate',
										'selectdate' => $newlinkdayRaw) ) . '">' . $newlinkView . '</a>&nbsp;(' . $totallinks . ')</li>';
	}
	$boxtxt .= '</ul></div>';
	$counter = 0;
	$allmonthlinks = 0;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WEBLOGS_130_';
	$_display_dat['module'] = 'modules/weblogs';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_WEB_DESC, $boxtxt);

}

function weblogs_newlinksdate ($mf) {

	global $opnConfig;

	$selectdate = 0;
	get_var ('selectdate', $selectdate, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['opndate']->sqlToopnData ($selectdate);
	$dateView = '';
	$opnConfig['opndate']->formatTimestamp ($dateView, _DATE_DATESTRING4);
	$boxtxt = '<br />';
	$boxtxt .= weblogs_menu () . '<br />';
	$newlinkDB = $selectdate;
	$totallinks = $mf->GetItemCount ("wdate LIKE '%$newlinkDB%'");
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array ($dateView . ' - ' . $totallinks . ' ' . _WEB_NEWWEBLOGS) );
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br />';
	$result = $mf->GetItemResult (array ('cid',
					'lid',
					'title',
					'text',
					'homepage',
					'downloadurl',
					'link1',
					'link2',
					'link3',
					'link4',
					'link5',
					'link6',
					'submitter',
					'wdate',
					'user_group'),
					array ('title ASC'),
		"wdate LIKE '%$newlinkDB%'");
	if ($result !== false) {

		#		$datetime = '';

		while (! $result->EOF) {
			$lid = $result->fields['lid'];

			#			$cid = $result->fields['cid'];

			$title = $result->fields['title'];
			$text = $result->fields['text'];
			$homepage = $result->fields['homepage'];
			$downloadurl = $result->fields['downloadurl'];
			$link1 = $result->fields['link1'];
			$link2 = $result->fields['link2'];
			$link3 = $result->fields['link3'];
			$link4 = $result->fields['link4'];
			$link5 = $result->fields['link5'];
			$link6 = $result->fields['link6'];
			$table = & new opn_TableClass ('default');
			$table->AddCols (array ('20%', '80%') );
			$table->AddOpenRow ();
			$table->AddDataCol ('<a class="opncenterbox" href="javascript:self.scrollTo(0,0)"><img src="' . $opnConfig['opn_url'] . '/modules/weblogs/images/top.gif" class="imgtag" title="' . _WEB_TOP . '" alt="' . _WEB_TOP . '" /></a> <span class="normaltextbold">' . $dateView . '</span><br />' . weblogs_set_edit_link ($lid), '', '', 'top', '3');
			$table->AddDataCol ('<span class="normaltextbold">' . $title . '</span><br /><br />' . $text . '<br /><br />');
			$table->AddChangeRow ();

			#			$transfertitle = str_replace (' ', '_', $title);

			$hlp = '';
			if ($homepage != '') {
				$hlp .= '' . _WEB_HOMEPAGE . '&nbsp;<a class="opncenterbox" href="' . $homepage . '" target="_blank">' . $homepage . '</a>&nbsp;<br />';
			}
			if ($link1 != '') {
				$hlp .= '' . _WEB_LINK . '&nbsp;<a class="opncenterbox" href="' . $link1 . '" target="_blank">' . $link1 . '</a>&nbsp;<br />';
			}
			if ($link2 != '') {
				$hlp .= '' . _WEB_LINK . '&nbsp;<a class="opncenterbox" href="' . $link2 . '" target="_blank">' . $link2 . '</a>&nbsp;<br />';
			}
			if ($link3 != '') {
				$hlp .= '' . _WEB_LINK . '&nbsp;<a class="opncenterbox" href="' . $link3 . '" target="_blank">' . $link3 . '</a>&nbsp;<br />';
			}
			if ($link4 != '') {
				$hlp .= '' . _WEB_LINK . '&nbsp;<a class="opncenterbox" href="' . $link4 . '" target="_blank">' . $link4 . '</a>&nbsp;<br />';
			}
			if ($link5 != '') {
				$hlp .= '' . _WEB_LINK . '&nbsp;<a class="opncenterbox" href="' . $link5 . '" target="_blank">' . $link5 . '</a>&nbsp;<br />';
			}
			if ($link6 != '') {
				$hlp .= '' . _WEB_LINK . '&nbsp;<a class="opncenterbox" href="' . $link6 . '" target="_blank">' . $link6 . '</a>&nbsp;<br />';
			}
			if ($downloadurl != '') {
				$hlp .= '' . _WEB_DOWNLOAD . '&nbsp;<a class="opncenterbox" href="' . $downloadurl . '" target="_blank">' . $downloadurl . '</a>&nbsp;<br />';
			}
			if ($hlp == '') {
				$hlp = '&nbsp;';
			}
			$table->AddDataCol ($hlp);
			$table->AddCloseRow ();
			$table->GetTable ($boxtxt);
			$boxtxt .= '<br /><br />';
			$result->MoveNext ();
		}
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WEBLOGS_140_';
	$_display_dat['module'] = 'modules/weblogs';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_WEB_DESC, $boxtxt);

}

function weblogs_showitem (&$result) {

	global $opnConfig, $opnTables;

	$cid = $result->fields['cid'];
	$lid = $result->fields['lid'];
	$title = $result->fields['title'];
	$text = $result->fields['text'];
	$text = $opnConfig['cleantext']->makeClickable ($text);
	opn_nl2br ($text);
	$homepage = $result->fields['homepage'];
	$downloadurl = $result->fields['downloadurl'];
	$link1 = $result->fields['link1'];
	$link2 = $result->fields['link2'];
	$link3 = $result->fields['link3'];
	$link4 = $result->fields['link4'];
	$link5 = $result->fields['link5'];
	$link6 = $result->fields['link6'];
	// $submitter = $result->fields['submitter'];
	$wdate = $result->fields['wdate'];
	$opnConfig['opndate']->sqlToopnData ($wdate);
	$datetime = '';
	$opnConfig['opndate']->formatTimestamp ($datetime, _DATE_LINKSDATESTRING);
	$table = & new opn_TableClass ('default');
	$table->AddCols (array ('20%', '80%') );
	$table->AddOpenRow ();
	$table->AddDataCol ('<a class="opncenterbox" href="javascript:self.scrollTo(0,0)"><img src="' . $opnConfig['opn_url'] . '/modules/weblogs/images/top.gif" class="imgtag" title="' . _WEB_TOP . '" alt="' . _WEB_TOP . '" /></a> <span class="normaltextbold">' . $datetime . '</span><br />' . weblogs_set_edit_link ($lid), '', '', 'top', '3');
	$table->AddDataCol ('<span class="normaltextbold">' . $title . '</span><br /><br />' . $text . '<br /><br />');
	$table->AddChangeRow ();
	$hlp = '';
	if ($homepage != '') {
		$hlp .= '' . _WEB_HOMEPAGE . '&nbsp;<a class="opncenterbox" href="' . $homepage . '" target="_blank">' . $homepage . '</a>&nbsp;<br />';
	}
	if ($link1 != '') {
		$hlp .= '' . _WEB_LINK . '&nbsp;<a class="opncenterbox" href="' . $link1 . '" target="_blank">' . $link1 . '</a>&nbsp;<br />';
	}
	if ($link2 != '') {
		$hlp .= '' . _WEB_LINK . '&nbsp;<a class="opncenterbox" href="' . $link2 . '" target="_blank">' . $link2 . '</a>&nbsp;<br />';
	}
	if ($link3 != '') {
		$hlp .= '' . _WEB_LINK . '&nbsp;<a class="opncenterbox" href="' . $link3 . '" target="_blank">' . $link3 . '</a>&nbsp;<br />';
	}
	if ($link4 != '') {
		$hlp .= '' . _WEB_LINK . '&nbsp;<a class="opncenterbox" href="' . $link4 . '" target="_blank">' . $link4 . '</a>&nbsp;<br />';
	}
	if ($link5 != '') {
		$hlp .= '' . _WEB_LINK . '&nbsp;<a class="opncenterbox" href="' . $link5 . '" target="_blank">' . $link5 . '</a>&nbsp;<br />';
	}
	if ($link6 != '') {
		$hlp .= '' . _WEB_LINK . '&nbsp;<a class="opncenterbox" href="' . $link6 . '" target="_blank">' . $link6 . '</a>&nbsp;<br />';
	}
	if ($downloadurl != '') {
		$hlp .= '' . _WEB_DOWNLOAD . '&nbsp;<a class="opncenterbox" href="' . $downloadurl . '" target="_blank">' . $downloadurl . '</a>&nbsp;<br />';
	}
	$result3 = &$opnConfig['database']->Execute ('SELECT cat_name FROM ' . $opnTables['weblogs_cats'] . ' WHERE cat_id=' . $cid);
	$ctitle = $result3->fields['cat_name'];
	$hlp .= '<br />' . _WEB_CATE . ': ' . $ctitle;
	if ($hlp == '') {
		$hlp = '&nbsp;';
	}
	$table->AddDataCol ($hlp);
	$table->AddCloseRow ();
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />';
	return $boxtxt;

}

function weblogs_viewlink ($webcat, $mf) {

	global $opnConfig, $opnTables;

	$cid = 0;
	get_var ('cid', $cid, 'both', _OOBJ_DTYPE_INT);
	if (!$cid) {
		$cid = 0;
		get_var ('cat_id', $cid, 'both', _OOBJ_DTYPE_INT);
	}
	$min = 0;
	get_var ('min', $min, 'url', _OOBJ_DTYPE_INT);
	$orderby = '';
	get_var ('orderby', $orderby, 'url', _OOBJ_DTYPE_CLEAN);
	$show = 0;
	get_var ('show', $show, 'url', _OOBJ_DTYPE_INT);
	$max = $min+ $opnConfig['weblogs_perpage'];
	if ($orderby <> '') {
		$orderby = weblogs_convertorderbyin ($orderby);
	} else {
		$orderby = 'wdate DESC';
	}
	if ($show) {
		$opnConfig['weblogs_perpage'] = $show;
	} else {
		$show = $opnConfig['weblogs_perpage'];
	}
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$boxtxt = '';
	if ($opnConfig['weblogs_search']) {
		$boxtxt .= weblogs_SearchForm ();
		$boxtxt .= '<br /><br /><br />';
	}
	$boxtxt .= $webcat->SubNavigation ($cid);
	if ($opnConfig['weblogs_sort'] != 0) {
		$orderbyTrans = weblogs_convertorderbytrans ($orderby);
		$boxtxt .= '<div class="centertag"><span class="smalltext">' . _WEB_SORTLOGBY . ':&nbsp;&nbsp;';
		$boxtxt .= ' ' . _WEB_SORTTITLE . ' (<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
													'op' => 'viewlink',
													'cid' => $cid,
													'orderby' => 'titleA') ) . '">A</a>\<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
												'op' => 'viewlink',
												'cid' => $cid,
												'orderby' => 'titleD') ) . '">D</a>)';
		$boxtxt .= ' ' . _WEB_SORTDATE . ' (<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
												'op' => 'viewlink',
												'cid' => $cid,
												'orderby' => 'dateA') ) . '">A</a>\<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
												'op' => 'viewlink',
												'cid' => $cid,
												'orderby' => 'dateD') ) . '">D</a>)';
		$boxtxt .= '</span><br /><span class="normaltextbold">' . _WEB_SORTCURRBY . ': ' . $orderbyTrans . '</span>';
		$boxtxt .= '</div>';
	}
	$totalselectedlinks = $mf->GetItemCount ('cid=' . $cid);
	$boxtxt .= '<hr /><br />';
	$x = 0;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WEBLOGS_150_';
	$_display_dat['module'] = 'modules/weblogs';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayHead ();
	$opnConfig['opnOutput']->SetDoHeader (false);
	$opnConfig['opnOutput']->SetDoFooter (false);
	$opnConfig['opnOutput']->DisplayCenterbox (_WEB_DESC, $boxtxt);
	$result = $mf->GetItemLimit (array ('cid',
					'lid',
					'title',
					'text',
					'homepage',
					'downloadurl',
					'link1',
					'link2',
					'link3',
					'link4',
					'link5',
					'link6',
					'submitter',
					'wdate',
					'user_group'),
					array ($orderby),
		$opnConfig['weblogs_perpage'],
		'cid=' . $cid,
		$min);
	if ($result !== false) {
		$datetime = '';
		while (! $result->EOF) {
			$opnConfig['opnOutput']->DisplayCenterbox ('', weblogs_showitem ($result) );
			if ($opnConfig['permission']->HasRight ('modules/weblogs', _WEBLOGS_PERM_COMMENTWRITE, true) ) {
				set_var ('lid', $result->fields['lid'], 'both');
				$cid = $result->fields['cid'];
				include (_OPN_ROOT_PATH . 'modules/weblogs/comments.php');
			}
			$x++;
			$result->MoveNext ();
		}
	}
	$orderby = weblogs_convertorderbyout ($orderby);
	// Calculates how many pages exist.  Which page one should be on, etc...
	// echo "Count Result:  $totalselectedlinks<br />"; // testing lines
	$linkpagesint = ($totalselectedlinks/ $opnConfig['weblogs_perpage']);
	$linkpageremainder = ($totalselectedlinks% $opnConfig['weblogs_perpage']);
	if ($linkpageremainder != 0) {
		$linkpages = ceil ($linkpagesint);
		if ($totalselectedlinks<$opnConfig['weblogs_perpage']) {
			$linkpageremainder = 0;
		}
	} else {
		$linkpages = $linkpagesint;
	}
	// Page Numbering
	$boxtxt = '';
	if ($linkpages != 1 && $linkpages != 0) {
		$boxtxt .= '<br /><br /><span class="normaltext">';
		$boxtxt .= '' . _WEB_SELECTPAGE . ':&nbsp;&nbsp;';
		$prev = $min- $opnConfig['weblogs_perpage'];
		if ($prev >= 0) {
			$boxtxt .= '&nbsp;<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
											'op' => 'viewlink',
											'cid' => $cid,
											'min' => $prev,
											'orderby' => $orderby,
											'show' => $show) ) . '">';
			$boxtxt .= '&lt;&lt; ' . _WEB_PREVIOUS . '</a>&nbsp;';
		}
		$counter = 1;
		$currentpage = ($max/ $opnConfig['weblogs_perpage']);
		while ($counter<= $linkpages) {
			$mintemp = ($opnConfig['weblogs_perpage']* $counter)- $opnConfig['weblogs_perpage'];
			if ($counter == $currentpage) {
				$boxtxt .= $counter . '&nbsp;';
			} else {
				$boxtxt .= '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
												'op' => 'viewlink',
												'cid' => $cid,
												'min' => $mintemp,
												'orderby' => $orderby,
												'show' => $show) ) . '">' . $counter . '</a>&nbsp;';
			}
			$counter++;
		}
		if ($x >= $opnConfig['weblogs_perpage']) {
			$boxtxt .= '&nbsp;<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
											'op' => 'viewlink',
											'cid' => $cid,
											'min' => $max,
											'orderby' => $orderby,
											'show' => $show) ) . '">';
			$boxtxt .= '' . _WEB_NEXT . ' &gt;&gt;</a>';
		}
		$boxtxt .= '</span>';
	}
	$opnConfig['opnOutput']->DisplayCenterbox ('', $boxtxt);
	$opnConfig['opnOutput']->SetDoFooter (true);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function categoryweblogs_newlinkgraphic ($cat) {

	global $opnConfig, $opnTables;

	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$newresult = &$opnConfig['database']->SelectLimit ('SELECT wdate FROM ' . $opnTables['weblogs_links'] . ' WHERE cid=' . $cat . ' and user_group IN (' . $checkerlist . ') ORDER BY wdate desc', 1);
	$time = $newresult->fields['wdate'];
	$boxtxt = '&nbsp;';
	$boxtxt .= buildnewtag ($time);
	return $boxtxt;

}
// Reusable Link Sorting Functions

function weblogs_convertorderbyin ($orderby) {
	if ($orderby == 'titleA') {
		$orderby = 'title ASC';
	}
	if ($orderby == 'dateA') {
		$orderby = 'wdate ASC';
	}
	if ($orderby == 'titleD') {
		$orderby = 'title DESC';
	}
	if ($orderby == 'dateD') {
		$orderby = 'wdate DESC';
	}
	return $orderby;

}

function weblogs_convertorderbytrans ($orderby) {
	if ($orderby == 'title ASC') {
		$orderbyTrans = '' . _WEB_TITLEATOZ . '';
	}
	if ($orderby == 'title DESC') {
		$orderbyTrans = '' . _WEB_TITLEZTOA . '';
	}
	if ($orderby == 'wdate ASC') {
		$orderbyTrans = '' . _WEB_DATEOLDFIRST . '';
	}
	if ($orderby == 'wdate DESC') {
		$orderbyTrans = '' . _WEB_DATENEWFIRST . '';
	}
	return $orderbyTrans;

}

function weblogs_convertorderbyout ($orderby) {
	if ($orderby == 'title ASC') {
		$orderby = 'titleA';
	}
	if ($orderby == 'date ASC') {
		$orderby = 'dateA';
	}
	if ($orderby == 'title DESC') {
		$orderby = 'titleD';
	}
	if ($orderby == 'date DESC') {
		$orderby = 'dateD';
	}
	return $orderby;

}

function weblogs_search () {

	global $opnConfig, $opnTables;

	$query = '';
	get_var ('query', $query, 'both');
	$min = 0;
	get_var ('min', $min, 'both', _OOBJ_DTYPE_INT);
	$orderby = '';
	get_var ('orderby', $orderby, 'both', _OOBJ_DTYPE_CLEAN);
	$show = '';
	get_var ('show', $show, 'both', _OOBJ_DTYPE_CLEAN);
	$linksresults = 15;
	get_var ('linksresults', $linksresults, 'both', _OOBJ_DTYPE_CLEAN);
	$max = $min+ $linksresults;
	if ($orderby <> '') {
		$orderby = weblogs_convertorderbyin ($orderby);
	} else {
		$orderby = 'title ASC';
	}
	if ($show) {
		$linksresults = $show;
	} else {
		$show = $linksresults;
	}
	$query = $opnConfig['cleantext']->filter_searchtext ($query);
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$like_search = $opnConfig['opnSQL']->AddLike ($query);
	$fullcountresult = &$opnConfig['database']->Execute ('SELECT COUNT(lid) AS counter FROM ' . $opnTables['weblogs_links'] . " WHERE (title LIKE $like_search OR text LIKE $like_search) and user_group IN (" . $checkerlist . ")");
	if ( ($fullcountresult !== false) && (isset ($fullcountresult->fields['counter']) ) ) {
		$totalselectedlinks = $fullcountresult->fields['counter'];
	} else {
		$totalselectedlinks = 0;
	}
	$fullcountresult->Close ();
	$x = 0;
	$boxtxt = '<br />';
	$boxtxt .= weblogs_menu () . '<br />';
	$boxtxt .= weblogs_SearchForm () . '<br />';
	$boxtxt .= '<div class="centertag">';
	if ($query != '') {
		if ($totalselectedlinks>0) {
			$table = & new opn_TableClass ('alternator');
			$table->AddHeaderRow (array (_WEB_DESC) );
			$table->GetTable ($boxtxt);
			$orderbyTrans = weblogs_convertorderbytrans ($orderby);
			$boxtxt .= '<div align="center" class="smalltext"><br />' . _WEB_SORTLOGBY . ':&nbsp;&nbsp;' . _WEB_SORTTITLE . ' (<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
																							'op' => 'search',
																							'query' => $query,
																							'orderby' => 'titleA') ) . '">A</a>\<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
													'op' => 'search',
													'query' => $query,
													'orderby' => 'titleD') ) . '">D</a>)  ' . _WEB_SORTDATE . ' (<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
																	'op' => 'search',
																	'query' => $query,
																	'orderby' => 'dateA') ) . '">A</a>\<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
													'op' => 'search',
													'query' => $query,
													'orderby' => 'dateD') ) . '">D</a>)  ';
			$boxtxt .= '<br /><span class="normaltextbold">' . _WEB_SORTCURRBY . ': ' . $orderbyTrans . '</span></div><br />';
			$like_search = $opnConfig['opnSQL']->AddLike ($query);
			$result = &$opnConfig['database']->SelectLimit ('SELECT lid, cid, title, text, homepage, downloadurl, link1, link2, link3, link4, link5, link6, submitter, wdate FROM ' . $opnTables['weblogs_links'] . " WHERE (title LIKE $like_search OR text LIKE $like_search) AND user_group IN (" . $checkerlist . ") ORDER BY $orderby", $linksresults, $min);
			if ($result !== false) {
				$datetime = '';
				while (! $result->EOF) {
					$boxtxt .= weblogs_showitem ($result);
					$x++;
					$result->MoveNext ();
				}
			}
			$orderby = weblogs_convertorderbyout ($orderby);
		} else {
			$boxtxt .= '<span class="alerttext" align="center">' . _WEB_NOMATCHESFOUND . '</span><br /><br />';
		}
		// Calculates how many pages exist.  Which page one should be on, etc...
		// echo "Count Result:  $totalselectedlinks<br />";# testing lines
		if ($linksresults <> 0) {
			$linkpagesint = ($totalselectedlinks/ $linksresults);
			$linkpageremainder = ($totalselectedlinks% $linksresults);
		} else {
			$linkpagesint = 0;
			$linkpageremainder = 0;
		}
		if ($linkpageremainder != 0) {
			$linkpages = ceil ($linkpagesint);
			if ($totalselectedlinks<$linksresults) {
				$linkpageremainder = 0;
			}
		} else {
			$linkpages = $linkpagesint;
		}
		// Page Numbering
		if ($linkpages != 1 && $linkpages != 0) {
			$boxtxt .= '<br /><br /><span class="normaltext" align="center">';
			$boxtxt .= '' . _WEB_SELECTPAGE . ':&nbsp;&nbsp;';
			$prev = $min- $linksresults;
			if ($prev >= 0) {
				$boxtxt .= '&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
													'op' => 'search',
													'query' => $query,
													'min' => $prev,
													'orderby' => $orderby,
													'show' => $show) ) . '">';
				$boxtxt .= '[&lt;&lt; ' . _WEB_PREVIOUS . ' ]</a>&nbsp;';
			}
			$counter = 1;
			$currentpage = ($max/ $linksresults);
			while ($counter<= $linkpages) {
				$mintemp = ($opnConfig['weblogs_perpage']* $counter)- $linksresults;
				if ($counter == $currentpage) {
					$boxtxt .= $counter . '&nbsp;';
				} else {
					$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
													'op' => 'search',
													'query' => $query,
													'min' => $mintemp,
													'orderby' => $orderby,
													'show' => $show) ) . '">' . $counter . '</a>&nbsp;';
				}
				$counter++;
			}
			if ($x >= $opnConfig['weblogs_perpage']) {
				$boxtxt .= '&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/index.php',
													'op' => 'search',
													'query' => $query,
													'min' => $max,
													'orderby' => $orderby,
													'show' => $show) ) . '">';
				$boxtxt .= '[ ' . _WEB_NEXT . ' &gt;&gt;]</a>';
			}
			$boxtxt .= '</span>';
		}
		$boxtxt .= '<br /><br /><div align="center" class="normaltext">' . _WEB_TRYTOSEARCH . ' "' . $query . '" ' . _WEB_INOTHERENGINE . '<br />' . '<a class="opncenterbox" href="http://www.google.com/search?q=' . $query . '" target="_blank">Google</a> -' . ' <a class="opncenterbox" href="http://www.altavista.com/cgi-bin/query?pg=q&amp;sc=on&amp;hl=on&amp;act=2006&amp;par=0&amp;q=' . $query . '&amp;kl=XX&amp;stype=stext" target="_blank">Alta Vista</a> -' . ' <a class="opncenterbox" href="http://www.lycos.com/cgi-bin/pursuit?query=' . $query . '&amp;maxhits=20" target="_blank">Lycos</a> -' . ' <a class="opncenterbox" href="http://search.yahoo.com/bin/search?p=' . $query . '" target="_blank">Yahoo</a> -' . ' <a class="opncenterbox" href="http://srch.overture.com/d/search/p/go/?Partner=go_home&amp;Keywords=' . $query . '&amp;Go=Search" target="_blank">Infoseek</a> -' . ' <a class="opncenterbox" href="http://www.dejanews.com/dnquery.xp?QRY=' . $query . '" target="_blank">Deja News</a> -' . ' <a class="opncenterbox" href="http://www.hotbot.com/?MT=' . $query . '&amp;DU=days&amp;SW=web" target="_blank">HotBot</a>' . '<br />' . '<a class="opncenterbox" href="http://www.linuxapps.com/?page=search&amp;search=' . $query . '" target="_blank">LinuxStart</a> -' . ' <a class="opncenterbox" href="http://search.1stlinuxsearch.com/compass?scope=' . $query . '&amp;ui=sr" target="_blank">1stLinuxSearch</a> -' . ' <a class="opncenterbox" href="http://www.linuxlinks.com/cgi-bin/search.cgi?query=' . $query . '&amp;engine=Links" target="_blank">LinuxLinks</a> -' . ' <a class="opncenterbox" href="http://www.freshmeat.net/search/?q=' . $query . '" target="_blank">Freshmeat</a> -' . ' <a class="opncenterbox" href="http://linuxtoday.com/search.php3?query=' . $query . '" target="_blank">Linux Today</a>' . '</div>';
	} else {
		$boxtxt .= '<span class="alerttext" align="center">' . _WEB_NOMATCHESFOUND . '</span><br /><br />';
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WEBLOGS_160_';
	$_display_dat['module'] = 'modules/weblogs';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_WEB_DESC, $boxtxt);

}

?>