<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;

$opnConfig['permission']->HasRights ('modules/wish_tickets', array (_PERM_READ, _PERM_WRITE) );
$opnConfig['module']->InitModule ('modules/wish_tickets');
$opnConfig['opnOutput']->setMetaPageName ('modules/wish_tickets');
if (!defined ('_OPN_MAILER_INCLUDED') ) {
	include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
}
getLanguageDef (_OPN_ROOT_PATH . 'modules/wish_tickets/language/');
include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.multichecker.php');

/* --------------------- Functions ------------------------- */

function nothing () {

	global $opnConfig, $getDatenSubject, $getDatenProblem;
	if ($opnConfig['permission']->IsUser () ) {
		$ui = $opnConfig['permission']->GetUserinfo ();
	}
	if (!isset ($ui['name']) ) {
		$ui['name'] = '';
	}
	if (!isset ($ui['email']) ) {
		$ui['email'] = '';
	}
	if (!isset ($ui['uname']) ) {
		$ui['uname'] = '';
	}
	$boxtitle = _WISUBLE_TICKET_TITLE;
	$boxtxt = '<div class="normaltext">' . _WISUBLE_TICKET_SUBMIT . '</div>';
	if ($opnConfig['permission']->HasRight ('modules/wish_tickets', _PERM_WRITE, true) ) {
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WISH_TICKETS_140_', 'wish_tickets');
		$form->Init (encodeurl ($opnConfig['opn_url'] . '/modules/wish_tickets/index.php?op=new') );
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('requester_name', _WISUBLE_TICKET_NAME);
		$form->Addtextfield ('requester_name', 20, 256, $ui['uname']);
		$form->AddChangeRow ();
		$form->AddLabel ('email', _WISUBLE_TICKET_EMAIL);
		$form->AddTextfield ('email', 20, 256, $ui['email']);
		$form->AddChangeRow ();
		$form->AddLabel ('user_name', _WISUBLE_TICKET_USER);
		$form->AddTextfield ('user_name', 20, 256, $ui['uname']);
		if ($opnConfig['wishticket_usedomain'] == 1) {
			$form->AddChangeRow ('listalternator', '10%');
			$form->AddLabel ('domain', _WISUBLE_TICKET_DOMAIN);
			$form->AddTextfield ('domain', 20, 256);
		}
		$form->AddChangeRow ();
		$form->AddLabel ('subject', _WISUBLE_TICKET_SUBJECT);
		$form->AddTextfield ('subject', 45, 60, $getDatenSubject);
		$form->AddChangeRow ();
		$form->AddLabel ('problem', _WISUBLE_TICKET_PROB);
		$form->UseEditor (false);
		$form->UseWysiwyg (false);
		$form->AddTextarea ('problem', 0, 0, '', $getDatenProblem);
		$options[_WISUBLE_TICKET_PRIHIGHT] = _WISUBLE_TICKET_PRIHIGHT;
		$options[_WISUBLE_TICKET_PRIHIGH] = _WISUBLE_TICKET_PRIHIGH;
		$options[_WISUBLE_TICKET_PRIMED] = _WISUBLE_TICKET_PRIMED;
		$options[_WISUBLE_TICKET_PRILOW] = _WISUBLE_TICKET_PRILOW;
		$form->AddChangeRow ();
		$form->AddLabel ('priority', _WISUBLE_TICKET_PRI);
		$form->AddSelect ('priority', $options, _WISUBLE_TICKET_PRILOW);
		$form->AddChangeRow ();
		$form->AddText ('&nbsp;');
		$form->AddSubmit ('submity', _WISUBLE_TICKET_SUBMIT2);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$boxtxt .= '<br /><div class="normaltext">' . sprintf (_WISUBLE_TICKET_STATUS, encodeurl ($opnConfig['opn_url'] . '/modules/wish_tickets/index.php?op=view') ) . '<br />';
	if ($opnConfig['wishticket_useviewall']) {
		$boxtxt .= '<br />' . sprintf (_WISUBLE_TICKET_LIST, encodeurl ($opnConfig['opn_url'] . '/modules/wish_tickets/index.php?op=showall') ) . '<br />';
	}
	if ($opnConfig['wishticket_useviewallfinished']) {
		$boxtxt .= '<br />' . sprintf (_WISUBLE_TICKET_LISTSOLVED, encodeurl ($opnConfig['opn_url'] . '/modules/wish_tickets/index.php?op=showallsolved') ) . '<br />';
	}
	$boxtxt .= '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WISH_TICKETS_150_';
	$_display_dat['module'] = 'modules/wish_tickets';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtxt);

}

function build_mail_adress ($name, $email) {
	if ($name != '') {
		return $name . ' <' . $email . '>';
	}
	return $email;

}

function new_ticket () {

	global $opnConfig, $opnTables;

	$opnConfig['permission']->HasRight ('modules/wish_tickets', _PERM_WRITE);
	$requester_name = '';
	get_var ('requester_name', $requester_name, 'form', _OOBJ_DTYPE_CLEAN);
	$user_name = '';
	get_var ('user_name', $user_name, 'form', _OOBJ_DTYPE_CLEAN);
	$domain = '';
	get_var ('domain', $domain, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$problem = '';
	get_var ('problem', $problem, 'form', _OOBJ_DTYPE_CHECK);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CLEAN);
	$ticket = '';
	get_var ('ticket', $ticket, 'form', _OOBJ_DTYPE_CLEAN);
	$priority = '';
	get_var ('priority', $priority, 'form', _OOBJ_DTYPE_CLEAN);
	$dr = 0;
	$opnConfig['opndate']->now ();
	$date = '';
	$opnConfig['opndate']->opnDataTosql ($date);
	$_email = $opnConfig['opnSQL']->qstr ($email);
	$_problem = $opnConfig['opnSQL']->qstr ($problem);
	$_user_name = $opnConfig['opnSQL']->qstr ($user_name);
	$check = &$opnConfig['database']->Execute ('SELECT ticket FROM ' . $opnTables['wishticket'] . " WHERE  email=$_email AND problem=$_problem AND username=$_user_name");
	if (isset ($check) ) {
		if ($check->RecordCount ()>0) {
			error_page (_WISUBLE_TICKET_DUPE);
			$dr = 1;
		}
	}
	if ( ($dr == 0) && (check_fields ($requester_name, $user_name, $domain, $email, $problem, $subject) ) ) {
		$subject = $opnConfig['opnSQL']->qstr ($subject);
		$ticket1 = $opnConfig['opnSQL']->get_new_number ('wishticket', 'ticket');
		$ip = get_real_IP ();
		$problem = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($problem, true), 'problem');
		$opnConfig['cleantext']->filter_text ($subject, true);
		$opnConfig['cleantext']->filter_text ($requester_name);
		$opnConfig['cleantext']->filter_text ($user_name);
		$opnConfig['cleantext']->filter_text ($domain);
		$opnConfig['cleantext']->filter_text ($email);
		$_email = $opnConfig['opnSQL']->qstr ($email);
		$_requester_name = $opnConfig['opnSQL']->qstr ($requester_name);
		$_user_name = $opnConfig['opnSQL']->qstr ($user_name);
		$_priority = $opnConfig['opnSQL']->qstr ($priority);
		$_domain = $opnConfig['opnSQL']->qstr ($domain);
		$_ip = $opnConfig['opnSQL']->qstr ($ip);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['wishticket'] . " VALUES($ticket1, $date, $_requester_name,  $_user_name, $_domain, $_email, $problem, $_priority, '', 0,  $_ip, $subject, 0)");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['wishticket'], 'ticket=' . $ticket);
		$_user_name = $opnConfig['opnSQL']->qstr ($user_name);
		$_date = $opnConfig['opnSQL']->qstr ($date);
		$results = &$opnConfig['database']->Execute ('SELECT ticket, wishdate, name, username, wdomain, email, problem, priority, solution, status, ip, subject FROM ' . $opnTables['wishticket'] . " WHERE  email=$_email AND wishdate=$_date AND username=$_user_name");
		$ticket = $results->fields['ticket'];
		$vars = array ();
		$vars['{NAME}'] = $requester_name;
		$vars['{TICKET}'] = $ticket;
		$vars['{USER}'] = $user_name;
		$vars['{TICKETTITEL}'] = $opnConfig['wishticket_title'];
		$vars['{URL}'] = encodeurl ($opnConfig['opn_url'] . '/modules/wish_tickets/index.php?op=view', false);
		$mail = & new opn_mailer ();
		$mail->opn_mail_fill ($email, _WISUBLE_TICKET_ESUP . ' ' . $ticket, 'modules/wish_tickets', 'sendticket', $vars, $opnConfig['opn_webmaster_name'], $opnConfig['adminmail']);
		$mail->send ();
		$mail->init ();
		$data = _WISUBLE_TICKET_ENEW . _OPN_HTML_NL;
		$data .= _WISUBLE_TICKET_TICKET . ": $ticket\n";
		$data .= _WISUBLE_TICKET_NAME . ": $requester_name\n";
		$data .= _WISUBLE_TICKET_EMAIL . ": $email\n";
		$data .= _WISUBLE_TICKET_SUBJECT . ": $subject\n";
		$data .= _WISUBLE_TICKET_PRI . ": $priority\n\n\n";
		$data .= _WISUBLE_TICKET_ELINK . ': ' . encodeurl ($opnConfig['opn_url'] . '/modules/wish_tickets/admin/index.php?op=ticketsmanager', false) . "\n";
		if ($opnConfig['wishticket_notify_icq']) {
			for ($i = 0; $i<count ($opnConfig['wishticket_notifywho']); $i++) {
				$ui = $opnConfig['permission']->GetUser ($opnConfig['wishticket_notifywho'][$i], '', '');
				if ($ui['user_icq'] != '') {
					$toicq = $ui['user_icq'] . '@pager.icq.com';
					$mail->setBody ($data);
					$mail->setHeader ('X-Mailer', 'OPN WishTicket');
					$mail->setHeader ('User-Agent', 'OPN WishTicket');
					$mail->opn_mail_fill ($toicq, _WISUBLE_TICKET_ESUP . ' ' . $ticket, '', '', '', $requester_name, $email);
					$mail->send ();
					$mail->init ();
				}
			}
		}
		if ($opnConfig['wishticket_notify']) {
			if (!is_array ($opnConfig['wishticket_notifywho']) ) {
				$ui = $opnConfig['permission']->GetUserinfo ();
			} elseif (!isset ($opnConfig['wishticket_notifywho'][0]) ) {
				$ui = $opnConfig['permission']->GetUserinfo ();
			} else {
				$ui = $opnConfig['permission']->GetUser ($opnConfig['wishticket_notifywho'][0], '', '');
			}
			if (!isset ($ui['email']) ) {
				$ui['email'] = $opnConfig['adminmail'];
			}
			$toWish = build_mail_adress ($ui['uname'], $ui['email']);
			if (count ($opnConfig['wishticket_notifywho'])>1) {
				for ($i = 1; $i<count ($opnConfig['wishticket_notifywho']); $i++) {
					$ui = $opnConfig['permission']->GetUser ($opnConfig['wishticket_notifywho'][$i], '', '');
					if ($toWish != "") {
						$toWish .= ", ";
					}
					$toWish .= build_mail_adress ($ui['uname'], $ui['email']);
				}
			}
			$mail->setBody ($data);
			$mail->setHeader ('X-Mailer', 'OPN WishTicket');
			$mail->setHeader ('User-Agent', 'OPN WishTicket');
			$mail->opn_mail_fill ($toWish, _WISUBLE_TICKET_ESUP . ' ' . $ticket, '', '', '', $requester_name, $email);
			$mail->send ();
			$mail->init ();
		}
		$boxtitle = _WISUBLE_TICKET_TITLESUBMITED;
		$boxtxt = '<span class="normaltext">' . _WISUBLE_TICKET_SUB1 . '<span class="normaltextbold"> ' . $email . '</span>.<br />';
		$boxtxt .= _WISUBLE_TICKET_SUB2 . '<br /><br /><br />';
		$boxtxt .= _WISUBLE_TICKET_TICKET . ': <span class="normaltextbold">' . $ticket . '</span><br />';
		$boxtxt .= _WISUBLE_TICKET_NAME . ': <span class="normaltextbold">' . $requester_name . '</span><br />';
		$boxtxt .= _WISUBLE_TICKET_USER . ': <span class="normaltextbold">' . $user_name . '</span><br />';
		if ($opnConfig['wishticket_usedomain'] == 1) {
			$boxtxt .= _WISUBLE_TICKET_DOMAIN . ': <span class="normaltextbold">' . $domain . '</span><br />';
		}
		$boxtxt .= _WISUBLE_TICKET_PRI . ': <span class="normaltextbold">' . $priority . '</span><br />';
		$boxtxt .= _WISUBLE_TICKET_SUBJECT . ': <span class="normaltextbold">' . $subject . '</span><br />';
		opn_nl2br ($problem);
		$boxtxt .= _WISUBLE_TICKET_PROB . ': <span class="normaltextitalic">' . $problem . '</span><br /><br />';
		$boxtxt .= _WISUBLE_TICKET_THK . '</span>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WISH_TICKETS_160_';
		$_display_dat['module'] = 'modules/wish_tickets';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtxt);
	}

}

function view () {

	global $opnConfig;

	$boxtitle = _WISUBLE_TICKET_TITLEVIEW;
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WISH_TICKETS_170_', 'wish_tickets_view');
	$form->Init ($opnConfig['opn_url'] . '/modules/wish_tickets/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('ticket', _WISUBLE_TICKET_TICKET);
	$form->AddTextfield ('ticket', 20, 256);
	$form->AddChangeRow ();
	$form->AddLabel ('user_name', _WISUBLE_TICKET_USER);
	$form->AddTextfield ('user_name', 20, 256);
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'show');
	$form->AddSubmit ('submity', _WISUBLE_TICKET_VIEW);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WISH_TICKETS_180_';
	$_display_dat['module'] = 'modules/wish_tickets';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtxt);
	unset ($boxtxt);

}

function show () {

	global $opnTables, $opnConfig;

	$boxtitle = _WISUBLE_TICKET_TITLESHOW;
	$ticket = 0;
	get_var ('ticket', $ticket, 'both', _OOBJ_DTYPE_INT);
	$user_name = '';
	get_var ('user_name', $user_name, 'form', _OOBJ_DTYPE_CLEAN);
	$result = &$opnConfig['database']->Execute ('SELECT ticket, wishdate, name, username, wdomain, email, problem, priority, solution, status, ip, subject, supporter FROM ' . $opnTables['wishticket'] . " WHERE ticket=$ticket");
	$sta[0] = _WISUBLE_TICKET_STATUSOPEN;
	$sta[1] = _WISUBLE_TICKET_STATUSASSIGNED;
	$sta[2] = _WISUBLE_TICKET_STATUSRESELOVED;
	if ( ($result !== false) && (!$result->EOF) ) {
		$progr = $result->fields['solution'];
		$prob = $result->fields['problem'];
		opn_nl2br ($prob);
		if ($result->fields['ticket'] == $ticket && $result->fields['username'] == $user_name) {
			$opnConfig['opndate']->sqlToopnData ($result->fields['wishdate']);
			$temp = '';
			$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
			opn_nl2br ($prob);
			$table = & new opn_TableClass ('listalternator');
			$table->AddCols (array ('20%', '80%') );
			$table->AddDataRow (array (_WISUBLE_TICKET_DATESUB, $temp) );
			$table->AddDataRow (array (_WISUBLE_TICKET_STAT, $sta[$result->fields['status']]) );
			if ($result->fields['supporter'] >= 2) {
				$ui = $opnConfig['permission']->GetUser ($result->fields['supporter'], '', 'uid');
			} else {
				$ui['uname'] = '';
			}
			$table->AddDataRow (array (_WISUBLE_TICKET_SUPPORTER, $ui['uname']) );
			$table->AddDataRow (array (_WISUBLE_TICKET_PRI, $result->fields['priority']) );
			$table->AddDataRow (array (_WISUBLE_TICKET_NAME, $result->fields['name']) );
			$table->AddDataRow (array (_WISUBLE_TICKET_EMAIL, $result->fields['email']) );
			$table->AddDataRow (array (_WISUBLE_TICKET_USER, $result->fields['username']) );
			if ($opnConfig['wishticket_usedomain'] == 1) {
				$table->AddDataRow (array (_WISUBLE_TICKET_DOMAIN, $result->fields['wdomain']) );
			}
			$table->AddDataRow (array (_WISUBLE_TICKET_SUBJECT, $result->fields['subject']) );
			$table->AddDataRow (array (_WISUBLE_TICKET_PROB, $prob) );
			$boxtxt = '';
			$table->GetTable ($boxtxt);
			$boxtxt .= '<br /><br />';
			$form = & new opn_FormularClass ('listalternator');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WISH_TICKETS_190_', 'wish_tickets');
			$form->Init (encodeurl ($opnConfig['opn_url'] . '/modules/wish_tickets/index.php?op=update') );
			$form->AddTable ();
			$form->AddCols (array ('10%', '90%') );
			$form->AddOpenRow ();
			$form->AddText ('&nbsp;');
			$form->UseEditor (false);
			$form->UseWysiwyg (false);
			$form->AddTextarea ('problem');
			$form->AddChangeRow ();
			$form->AddHidden ('ticket', $ticket);
			$form->AddSubmit ('submity', _WISUBLE_TICKET_APPENDTOTICKET);
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$form->GetFormular ($boxtxt);
			$boxtxt .= '<br /><span class="normaltextbold">' . _WISUBLE_TICKET_TAKEN . '</span>:<br />';
			if (strlen ($progr)<2) {
				$boxtxt .= _WISUBLE_TICKET_PROGRESS;
			} else {
				$boxtxt .= $progr;
			}
			$boxtxt .= '</span>';
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WISH_TICKETS_200_';
			$_display_dat['module'] = 'modules/wish_tickets';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtxt);
		}
		if ($result->fields['ticket'] == $ticket && $result->fields['username'] != $user_name) {
			error_page ('<li>' . _WISUBLE_TICKET_COMB . '</li>');
		}
	} else {
		error_page ('<li>' . _WISUBLE_TICKET_NOEXIST . '</li>');
	}

}

function showall () {

	global $opnTables, $opnConfig;

	$boxtitle = _WISUBLE_TICKET_TITLESHOW;
	$get_query = 'SELECT ticket, wishdate, name, username, wdomain, email, problem, priority, solution, status, ip, subject FROM ' . $opnTables['wishticket'] . ' WHERE (status<>2) ORDER BY status, ticket DESC';
	$status[0] = _WISUBLE_TICKET_STATUSOPEN;
	$status[1] = _WISUBLE_TICKET_STATUSASSIGNED;
	$status[2] = _WISUBLE_TICKET_STATUSRESELOVED;
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_WISUBLE_TICKET_TICKET, _WISUBLE_TICKET_STAT . ' / ' . _WISUBLE_TICKET_PRI, _WISUBLE_TICKET_DATETIME, _WISUBLE_TICKET_DET, _WISUBLE_TICKET_PROBLEM) );
	$mysql_result = &$opnConfig['database']->Execute ($get_query);
	$lastStatus = 0;
	if ($mysql_result !== false) {
		$temp = '';
		while (! $mysql_result->EOF) {
			$subj = $mysql_result->fields['subject'];
			if ($lastStatus <> $mysql_result->fields['status']) {
				$table->AddOpenRow ();
				$table->AddDataCol ('&nbsp;', '', '5');
				$table->AddCloseRow ();
			}
			// if
			$opnConfig['opndate']->sqlToopnData ($mysql_result->fields['wishdate']);
			$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
			$problem = $mysql_result->fields['problem'];
			opn_nl2br ($problem);
			$table->AddDataRow (array ($mysql_result->fields['ticket'], $status[$mysql_result->fields['status']] . ' / ' . $mysql_result->fields['priority'], $temp, _WISUBLE_TICKET_SUBJECT . ': ' . $subj . '<br />' . _WISUBLE_TICKET_SUBBY . ' ' . $mysql_result->fields['name'], $problem), array ('center', 'center', 'center', 'center', 'center') );
			$lastStatus = $mysql_result->fields['status'];
			$mysql_result->MoveNext ();
		}
	}
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br /><a href="' . $opnConfig['opn_url'] . '/modules/wish_tickets/">' . _WISUBLE_TICKET_WISHHOME . '</a><br />';
	$boxtxt .= '<br />' . sprintf (_WISUBLE_TICKET_LISTSOLVED, encodeurl ($opnConfig['opn_url'] . '/modules/wish_tickets/index.php?op=showallsolved') ) . '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WISH_TICKETS_210_';
	$_display_dat['module'] = 'modules/wish_tickets';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtxt);

}

function showallsolved () {

	global $opnTables, $opnConfig;

	$boxtitle = _WISUBLE_TICKET_TITLESHOW;
	$get_query = 'SELECT ticket, wishdate, name, username, wdomain, email, problem, priority, solution, status, ip, subject FROM ' . $opnTables['wishticket'] . " WHERE status ='2' ORDER BY ticket DESC";
	$status[0] = _WISUBLE_TICKET_STATUSOPEN;
	$status[1] = _WISUBLE_TICKET_STATUSASSIGNED;
	$status[2] = _WISUBLE_TICKET_STATUSRESELOVED;
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_WISUBLE_TICKET_TICKET, _WISUBLE_TICKET_DET, _WISUBLE_TICKET_PROBLEM, _WISUBLE_TICKET_SOLUTION) );
	$mysql_result = &$opnConfig['database']->Execute ($get_query);
	if ($mysql_result !== false) {
		while (! $mysql_result->EOF) {
			$subj = stripslashes ($mysql_result->fields['subject']);
			$problem = $mysql_result->fields['problem'];
			$solution = $mysql_result->fields['solution'];
			opn_nl2br ($solution);
			opn_nl2br ($problem);
			$table->AddDataRow (array ($mysql_result->fields['ticket'], _WISUBLE_TICKET_SUBJECT . ': ' . $subj . '<br />' . _WISUBLE_TICKET_SUBBY . ' ' . $mysql_result->fields['name'], $problem, $solution), array ('center', 'center', 'center', 'center') );
			$mysql_result->MoveNext ();
		}
	}
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br /><a href="' . $opnConfig['opn_url'] . '/modules/wish_tickets/">' . _WISUBLE_TICKET_WISHHOME . '</a><br />';
	$boxtxt .= '<br />' . sprintf (_WISUBLE_TICKET_LIST, encodeurl ($opnConfig['opn_url'] . '/modules/wish_tickets/index.php?op=showall') ) . '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WISH_TICKETS_220_';
	$_display_dat['module'] = 'modules/wish_tickets';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtxt);

}

function update () {

	global $opnConfig, $opnTables;

	$problem = '';
	get_var ('problem', $problem, 'form', _OOBJ_DTYPE_CHECK);
	$ticket = 0;
	get_var ('ticket', $ticket, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRight ('modules/wish_tickets', _PERM_WRITE);
	$result = &$opnConfig['database']->Execute ('SELECT ticket, wishdate, name, username, wdomain, email, problem, priority, solution, status, ip, subject FROM ' . $opnTables['wishticket'] . ' WHERE ticket=' . $ticket);
	$problem = $opnConfig['cleantext']->FixQuotes ($problem);
	$problem = htmlspecialchars ($problem);
	$prop = $result->fields['problem'];
	$opnConfig['opndate']->now ();
	$date1='';
	// $opnConfig['opndate']->opnDataTosql($date1);
	$temp = '';
	$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
	$help = sprintf (_WISUBLE_TICKET_PRBADDED, $temp);
	$problem = $opnConfig['opnSQL']->qstr ($prop . '<br />' . $help . ':<br />' . $problem, 'problem');
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['wishticket'] . " SET problem=$problem WHERE ticket=$ticket");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['wishticket'], 'ticket=' . $ticket);
	$boxtitle = _WISUBLE_TICKET_TITLEUPDATE;
	$boxtxt = '<div align="center" class="normaltext"><br />' . sprintf (_WISUBLE_TICKET_UPDCOMPLET, $ticket) . '.<br /><br />';
	$boxtxt .= '<a href="' . $opnConfig['opn_url'] . '/modules/wish_tickets/index.php">' . _WISUBLE_TICKET_WISHHOME . '</a></div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WISH_TICKETS_230_';
	$_display_dat['module'] = 'modules/wish_tickets';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtxt);

}

function check_fields ($requester_name, $user_name, $domain, $email, $problem, $subject) {

	global $opnConfig;

	$check = & new multichecker ();
	$message = '<br />';
	$errmsg = '<li>' . _WISUBLE_TICKET_INVALEMAIL . '</li>';
	if (!$check->is_email ($email) ) {
		$message = $message . $errmsg;
		$found_err = 1;
	}
	if (empty ($requester_name) ) {
		$errmsg = '<li>' . _WISUBLE_TICKET_INVALNAME . '</li>';
		$message = $message . $errmsg;
		$found_err = 1;
	}
	if (empty ($user_name) ) {
		$errmsg = '<li>' . _WISUBLE_TICKET_INVALUSER . '</li>';
		$message = $message . $errmsg;
		$found_err = 1;
	}
	if ($opnConfig['wishticket_usedomain'] == 1) {
		if (empty ($domain) ) {
			$errmsg = '<li>' . _WISUBLE_TICKET_INVALDOM . '</li>';
			$message = $message . $errmsg;
			$found_err = 1;
		}
	}
	if (empty ($subject) ) {
		$errmsg = '<li>' . _WISUBLE_TICKET_INVALSUB . '</li>';
		$message = $message . $errmsg;
		$found_err = 1;
	}
	if (empty ($problem) ) {
		$errmsg = '<li>' . _WISUBLE_TICKET_INVALPROB . '</li>';
		$message = $message . $errmsg;
		$found_err = 1;
	}
	if (isset ($found_err) ) {
		error_page ($message);
		return false;
	}
	return true;

}

function error_page ($message) {

	global $opnConfig;

	$boxtitle = _WISUBLE_TICKET_ERROR;
	$boxtxt = '<span class="normaltext">' . _WISUBLE_TICKET_CORRECT . '<br /><br />';
	if (substr_count ($message, '<li>')>0) {
		$boxtxt .= '<ul>' . $message . '</ul>';
	} else {
		$boxtxt .= $message . '<br /><br />';
	}
	$boxtxt .= '</span>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WISH_TICKETS_240_';
	$_display_dat['module'] = 'modules/wish_tickets';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtxt);

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'new':
		new_ticket ();
		break;
	case 'view':
		view ();
		break;
	case 'show':
		show ();
		break;
	case 'showall':
		showall ();
		break;
	case 'showallsolved':
		showallsolved ();
		break;
	case 'update':
		update ();
		break;
	default:
		nothing ();
		break;
}

?>