<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'system/admin/plugin/tracking/language/');

function admin_get_tracking ($url) {

	global $opnTables, $opnConfig;
	if ($url == '/admin.php') {
		return _ADMIN_TRACKING_ADMINMENU;
	}
	if (substr_count ($url, '/admin.php?fct=plugins')>0) {
		return _ADMIN_TRACKING_PLUGINMENU;
	}
	if (substr_count ($url, 'admin.php?fct=openphpnuke')>0) {
		return _ADMIN_TRACKING_OPENPHPNUKE;
	}
	if (substr_count ($url, 'admin.php?fct=diagnostic')>0) {
		return _ADMIN_TRACKIN_DIAGNOSTIC;
	}
	if (substr_count ($url, 'admin/user_group/index.php')>0) {
		return _ADMIN_TRACKIN_USERGROUP;
	}
	if (substr_count ($url, 'admin/useradmin/index.php')>0) {
		return _ADMIN_TRACKIN_USER;
	}
	if (substr_count ($url, 'admin.php?fct=errorlog')>0) {
		return _ADMIN_TRACKING_ERRORLOG;
	}
	if ($url == '/admin.php?fct=honeypot') {
		return _ADMIN_TRACKING_HONEYPOT;
	}
	if ($url == '/admin.php?fct=moduleinfos') {
		return _ADMIN_TRACKING_MODULEINFOS;
	}
	if ($url == '/admin.php?fct=sidebox') {
		return _ADMIN_TRACKING_SIDEBOXMENU;
	}
	if (substr_count ($url, 'admin.php?fct=sidebox&filterside=0')>0) {
		return _ADMIN_TRACKING_SIDEBOXLEFT;
	}
	if (substr_count ($url, 'admin.php?fct=sidebox&filterside=1')>0) {
		return _ADMIN_TRACKING_SIDEBOXRIGHT;
	}
	if (substr_count ($url, 'admin.php?fct=sidebox&filterside=-1')>0) {
		return _ADMIN_TRACKING_SIDEBOXALL;
	}
	if ($url == '/admin.php?fct=middlebox') {
		return _ADMIN_TRACKING_MIDDLEBOXMENU;
	}
	if (substr_count ($url, 'admin.php?fct=middlebox&filterside=0')>0) {
		return _ADMIN_TRACKING_MIDDLEBOXLEFT;
	}
	if (substr_count ($url, 'admin.php?fct=middlebox&filterside=1')>0) {
		return _ADMIN_TRACKING_MIDDLEBOXRIGHT;
	}
	if (substr_count ($url, 'admin.php?fct=middlebox&filterside=-1')>0) {
		return _ADMIN_TRACKING_MIDDLEBOXALL;
	}
	if ($url == '/admin.php?fct=sidebox') {
		return _ADMIN_TRACKING_OPNBOXMENU;
	}
	if (substr_count ($url, 'admin.php?fct=opnbox&filterside=0')>0) {
		return _ADMIN_TRACKING_OPNBOXLEFT;
	}
	if (substr_count ($url, 'admin.php?fct=opnbox&filterside=1')>0) {
		return _ADMIN_TRACKING_OPNBOXRIGHT;
	}
	if (substr_count ($url, 'admin.php?fct=opnbox&filterside=-1')>0) {
		return _ADMIN_TRACKING_OPNBOXALL;
	}
	if ( ($url == '/admin.php?fct=metatags') or ($url == '/admin.php?fct=metatags&op=settings') ) {
		return _ADMIN_TRACKING_METATAGSSETTINGS;
	}
	if ($url == '/admin.php?fct=metatags&op=pages') {
		return _ADMIN_TRACKING_METATAGSPAGES;
	}
	if (substr_count ($url, 'admin.php?fct=metatags&op=editpage')>0) {
		$page = str_replace ('/admin.php?fct=metatags&op=editpage', '', $url);
		$p = explode ('&', $page);
		$page = str_replace ('page=', '', $p[1]);
		return _ADMIN_TRACKING_METATAGSPAGEEDIT . ' "' . $page . '"';
	}
	if (substr_count ($url, 'admin.php?fct=sidebox&op=sideboxDelete&sbid=')>0) {
		$sbid = str_replace ('/admin.php?fct=sidebox&op=sideboxDelete', '', $url);
		$s = explode ('&', $sbid);
		$sbid = str_replace ('sbid=', '', $s[1]);
		return _ADMIN_TRACKING_SIDEBOXDELETE . ' "' . $sbid . '"';
	}
	if (substr_count ($url, 'admin.php?fct=sidebox&op=sideboxEdit&sbid=')>0) {
		$sbid = str_replace ('/admin.php?fct=sidebox&op=sideboxEdit&sbid=', '', $url);
		if (is_integer ($sbid) ) {
			$result = &$opnConfig['database']->Execute ('SELECT options FROM ' . $opnTables['opn_sidebox'] . " WHERE sbid=$sbid");
		} else {
			$_sbid = $opnConfig['opnSQL']->qstr ($sbid);
			$result = &$opnConfig['database']->Execute ('SELECT options FROM ' . $opnTables['opn_sidebox'] . " WHERE sbid=$_sbid");
		}
		if (is_object ($result) ) {
			if ($result->RecordCount ()>0) {
				$row = $result->GetRowAssoc ('0');
				$options = unserialize ($row['options']);
			} else {
				$options['title'] = $sbid;
			}
			$result->Close ();
		} else {
			$options['title'] = $sbid;
		}
		return _ADMIN_TRACKING_SIDEBOXEDIT . ' "' . $options['title'] . '"';
	}
	if (substr_count ($url, 'admin.php?fct=middlebox&op=middleboxDelete&sbid=')>0) {
		$sbid = str_replace ('/admin.php?fct=middlebox&op=middleboxDelete', '', $url);
		$s = explode ('&', $sbid);
		$sbid = str_replace ('sbid=', '', $s[1]);
		return _ADMIN_TRACKING_MIDDLEBOXDELETE . ' "' . $sbid . '"';
	}
	if (substr_count ($url, 'admin.php?fct=middlebox&op=middleboxEdit&sbid=')>0) {
		$sbid = str_replace ('/admin.php?fct=middlebox&op=middleboxEdit&sbid=', '', $url);
		if (is_integer ($sbid) ) {
			$result = &$opnConfig['database']->Execute ('SELECT options FROM ' . $opnTables['opn_middlebox'] . " WHERE sbid=$sbid");
		} else {
			$_sbid = $opnConfig['opnSQL']->qstr ($sbid);
			$result = &$opnConfig['database']->Execute ('SELECT options FROM ' . $opnTables['opn_middlebox'] . " WHERE sbid=$_sbid");
		}
		if (is_object ($result) ) {
			if ($result->RecordCount ()>0) {
				$row = $result->GetRowAssoc ('0');
				$options = unserialize ($row['options']);
			} else {
				$options['title'] = $sbid;
			}
			$result->Close ();
		} else {
			$options['title'] = $sbid;
		}
		return _ADMIN_TRACKING_MIDDLEBOXEDIT . ' "' . $options['title'] . '"';
	}
	if (substr_count ($url, 'admin.php?fct=opnbox&op=opnboxDelete&sbid=')>0) {
		$sbid = str_replace ('/admin.php?fct=opnbox&op=opnboxDelete', '', $url);
		$s = explode ('&', $sbid);
		$sbid = str_replace ('sbid=', '', $s[1]);
		return _ADMIN_TRACKING_OPNBOXDELETE . ' "' . $sbid . '"';
	}
	if (substr_count ($url, 'admin.php?fct=opnbox&op=opnboxEdit&sbid=')>0) {
		$sbid = str_replace ('/admin.php?fct=opnbox&op=opnboxEdit&sbid=', '', $url);
		if (is_integer ($sbid) ) {
			$result = &$opnConfig['database']->Execute ('SELECT options FROM ' . $opnTables['opn_opnbox'] . " WHERE sbid=$sbid");
		} else {
			$_sbid = $opnConfig['opnSQL']->qstr ($sbid);
			$result = &$opnConfig['database']->Execute ('SELECT options FROM ' . $opnTables['opn_opnbox'] . " WHERE sbid=$_sbid");
		}
		if (is_object ($result) ) {
			if ($result->RecordCount ()>0) {
				$row = $result->GetRowAssoc ('0');
				$options = unserialize ($row['options']);
			} else {
				$options['title'] = $sbid;
			}
			$result->Close ();
		} else {
			$options['title'] = $sbid;
		}
		return _ADMIN_TRACKING_OPNBOXEDIT . ' "' . $options['title'] . '"';
	}
	if (substr_count ($url, 'admin.php?fct=modultheme&op=delpage')>0) {
		$template = str_replace ('/admin.php?fct=modultheme&op=delpage', '', $url);
		$s = explode ('&', $template);
		$template = str_replace (' ', '', str_replace ('module=', '', $s[1]) );
		return sprintf (_ADMIN_TRACKING_MODULETHEMEDELETE, $template);
	}
	if (substr_count ($url, 'admin.php?fct=modultheme&module=')>0) {
		$template = str_replace ('/admin.php?fct=modultheme', '', $url);
		$s = explode ('&', $template);
		$template = str_replace (' ', '', str_replace ('module=', '', $s[1]) );
		return sprintf (_ADMIN_TRACKING_MODULETHEMEEDIT, $template);
	}
	if (substr_count ($url, 'admin.php?fct=modultheme')>0) {
		return _ADMIN_TRACKING_MODULETHEME;
	}
	if (substr_count ($url, '/plugin/index.php?op=install')>0) {
		$p = explode ('?', $url);
		$p = explode ('&', $p[1]);
		$plugin = str_replace ('module=', '', $p[1]);
		return _ADMIN_TRACKING_INSTALLPLUGIN . ' "' . $plugin . '"';
	}
	if (substr_count ($url, '/plugin/index.php?op=remove')>0) {
		$p = explode ('?', $url);
		$p = explode ('&', $p[1]);
		$plugin = str_replace ('module=', '', $p[1]);
		return _ADMIN_TRACKING_REMOVEPLUGIN . ' "' . $plugin . '"';
	}
	return '';

}

?>