<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'system/anypage/plugin/search/language/');

function anypage_retrieve_searchbuttons (&$buttons) {

	$button['name'] = 'anypage';
	$button['sel'] = 0;
	$button['label'] = _ANYPAGE_SEARCH_ANYPAGE;
	$buttons[] = $button;
	unset ($button);

}

function anypage_retrieve_search ($type, $query, &$data, &$sap) {
	switch ($type) {
		case 'anypage':
			anypage_retrieve_anypage ($query, $data, $sap);
			break;
	}

}

function anypage_retrieve_all ($query, &$data, &$sap) {

	anypage_retrieve_anypage ($query, $data, $sap);

}

function anypage_retrieve_anypage ($query, &$data, &$sap) {

	global $opnConfig;

	$q = anypage_get_query ($query);
	$q .= anypage_get_orderby ();
	$result = &$opnConfig['database']->Execute ($q);
	$hlp1 = array ();
	if ($result !== false) {
		$nrows = $result->RecordCount ();
		if ($nrows>0) {
			$hlp1['data'] = _ANYPAGE_SEARCH_ANYPAGE;
			$hlp1['ishead'] = true;
			$data[] = $hlp1;
			while (! $result->EOF) {
				$sid = $result->fields['id'];
				$title = $result->fields['pagename'];
				$hlp1['data'] = anypage_build_link ($sid, $title);
				$hlp1['ishead'] = false;
				$data[] = $hlp1;
				$result->MoveNext ();
			}
			unset ($hlp1);
			$sap++;
		}
		$result->Close ();
	}

}

function anypage_get_query ($query) {

	global $opnTables, $opnConfig;

	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$opnConfig['opn_searching_class']->init ();
	$opnConfig['opn_searching_class']->SetFields (array ('id',
							'pagename') );
	$opnConfig['opn_searching_class']->SetTable ($opnTables['anypage_page']);
	$showadmin = $opnConfig['permission']->HasRights ('system/anypage', array (_PERM_EDIT, _PERM_ADMIN), true);
	if (!$showadmin) {
		$opnConfig['opn_searching_class']->SetWhere ("status='V' AND (user_group IN (" . $checkerlist . ')) AND');
	} else {
		$opnConfig['opn_searching_class']->SetWhere ('id>0 AND (user_group IN (' . $checkerlist . ')) AND');
	}
	$opnConfig['opn_searching_class']->SetQuery ($query);
	$opnConfig['opn_searching_class']->SetSearchfields (array ('pagename',
								'title',
								'wpage',
								'shortdesc') );
	return $opnConfig['opn_searching_class']->GetSQL ();

}

function anypage_get_orderby () {
	return ' ORDER BY lastmod DESC';

}

function anypage_build_link ($sid, $title) {

	global $opnConfig;

	$furl = encodeurl (array ($opnConfig['opn_url'] . '/system/anypage/index.php',
				'id' => $sid) );
	if ($title == '') {
		$title = '-';
	}
	$hlp = '<a class="%linkclass%" href="' . $furl . '">' . $title . '</a> ';
	return $hlp;

}

?>