<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

global $opnConfig;

$opnConfig['module']->InitModule ('system/article');
$opnConfig['permission']->InitPermissions ('system/article');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.myfunctions.php');
include_once (_OPN_ROOT_PATH . 'api/user_name.php');
getLanguageDef (_OPN_ROOT_PATH . 'system/article/language/');

function _article_set_options () {

	global $opnConfig;

	$storycat = 0;
	$storytopic = 0;
	get_var ('storycat', $storycat, 'url', _OOBJ_DTYPE_INT);
	get_var ('storytopic', $storytopic, 'url', _OOBJ_DTYPE_INT);
	if ( ($storycat) && (preg_match ('/^[0-9]{1,}$/', $storycat) ) ) {
		$opnConfig['opnOption']['storycat'] = $storycat;
	} else {
		$opnConfig['opnOption']['storycat'] = '';
	}
	if ( ($storytopic) && (preg_match ('/^[0-9]{1,}$/', $storytopic) ) ) {
		$opnConfig['opnOption']['storytopic'] = $storytopic;
	} else {
		$opnConfig['opnOption']['storytopic'] = '';
	}

}

function _article_get_cats (&$cats) {

	global $opnConfig, $opnTables;

	$cats = array ();
	$resultm = &$opnConfig['database']->Execute ('SELECT catid,title FROM ' . $opnTables['article_stories_cat'] . ' WHERE catid>0');
	while (! $resultm->EOF) {
		$cats[$resultm->fields['catid']] = $resultm->fields['title'];
		$resultm->MoveNext ();
	}
	$resultm->Close ();

}

function _article_get_topics (&$topics, &$topicchecker) {

	global $opnConfig, $opnTables;

	$topics = array ();
	$checker = array ();
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$t_result = &$opnConfig['database']->Execute ('SELECT topicid, topicimage, topictext, pid FROM ' . $opnTables['article_topics'] . ' WHERE user_group IN (' . $checkerlist . ')');
	while (! $t_result->EOF) {
		$checker[] = $t_result->fields['topicid'];
		$topics[$t_result->fields['topicid']][0] = $t_result->fields['topicimage'];
		$topics[$t_result->fields['topicid']][1] = $t_result->fields['topictext'];
		$topics[$t_result->fields['topicid']][2] = $t_result->fields['pid'];
		$t_result->MoveNext ();
	}
	$topicchecker = implode (',', $checker);
	$t_result->Close ();

}

function _article_get_path ($topics, $topic, $path = '') {
	if (!isset ($topics[$topic][1]) ) {
		return $path;
	}
	$parentid = $topics[$topic][2];
	$name = $topics[$topic][1];
	opn_nl2br ($name);
	$path = '/' . $name . $path;
	if ($parentid == 0) {
		return $path;
	}
	$path = _article_get_path ($topics, $parentid, $path);
	return $path;

}

function _build_article ($articlenumber, &$result, &$myreturntext, $art_options = false, $backto = "", $isindex = false) {

	global $opnTheme, $opnConfig, $opnTables, $storynum;
	if ( ($art_options === false) OR (!is_array ($art_options) ) ) {
		$art_options = array ();
		$art_options['docenterbox'] = 0;
		$art_options['dothetitle'] = 1;
		$art_options['dothetitle_max'] = 0;
		$art_options['dothebody'] = 0;
		$art_options['dothebody_max'] = 0;
		$art_options['dothefooter'] = 1;
		$art_options['dothefooter_max'] = 0;
		$art_options['showtopic'] = 1;
		$art_options['showfulllink'] = 0;
		$art_options['showcatlink'] = 0;
	} else {
		if (!isset ($art_options['docenterbox']) ) {
			$art_options['docenterbox'] = 0;
		}
		if (!isset ($art_options['dothetitle']) ) {
			$art_options['dothetitle'] = 1;
		}
		if (!isset ($art_options['dothetitle_max']) ) {
			$art_options['dothetitle_max'] = 0;
		}
		if (!isset ($art_options['dothebody']) ) {
			$art_options['dothebody'] = 0;
		}
		if (!isset ($art_options['dothebody_max']) ) {
			$art_options['dothebody_max'] = 0;
		}
		if (!isset ($art_options['dothefooter']) ) {
			$art_options['dothefooter'] = 1;
		}
		if (!isset ($art_options['dothefooter_max']) ) {
			$art_options['dothefooter_max'] = 0;
		}
		if (!isset ($art_options['showtopic']) ) {
			$art_options['showtopic'] = 1;
		}
		if (!isset ($art_options['showfulllink']) ) {
			$art_options['showfulllink'] = 0;
		}
		if (!isset ($art_options['showcatlink']) ) {
			$art_options['showcatlink'] = 0;
		}
	}
	$sidcount = 0;
	$firstsid = 0;
	$cats = '';
	_article_get_cats ($cats);
	_article_set_options ();
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	if (preg_match ('/^[0-3][0-5]$/', $storynum) ) {
		$opnConfig['opnOption']['storynum'] = $storynum;
	} elseif ($opnConfig['permission']->IsUser () ) {
		$userinfo = $opnConfig['permission']->GetUserinfo ();
		$opnConfig['opnOption']['storynum'] = $userinfo['storynum'];
	} else {
		$opnConfig['opnOption']['storynum'] = $opnConfig['storyhome'];
	}
	$query = 'SELECT sid, catid, aid, title, wtime, hometext, bodytext, comments, counter, topic, informant, notes, userfile, options, acomm FROM ' . $opnTables['article_stories'];
	$query1 = 'SELECT COUNT(sid) AS counter FROM ' . $opnTables['article_stories'];
	$query .= "  WHERE (art_lang='0' OR art_lang='" . $opnConfig['language'] . "')";
	$query1 .= "  WHERE (art_lang='0' OR art_lang='" . $opnConfig['language'] . "')";
	$topics = '';
	$checker = '';
	_article_get_topics ($topics, $checker);
	if ($checker != '') {
		$topics1 = ' AND (topic IN (' . $checker . ')) ';
	} else {
		$topics1 = ' ';
	}
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$query .= ' AND (art_user_group IN (' . $checkerlist . '))';
	$query1 .= ' AND (art_user_group IN (' . $checkerlist . '))';
	if ( (isset ($opnConfig['opnOption']['themegroup']) ) && ($opnConfig['opnOption']['themegroup'] >= 1) ) {
		$query .= " AND ((art_theme_group='" . $opnConfig['opnOption']['themegroup'] . "') OR (art_theme_group=0))";
		$query1 .= " AND ((art_theme_group='" . $opnConfig['opnOption']['themegroup'] . "') OR (art_theme_group=0))";
	}
	if ($opnConfig['opnOption']['storytopic'] != '') {
		$query .= ' AND topic=' . $opnConfig['opnOption']['storytopic'];
		$query1 .= ' AND topic=' . $opnConfig['opnOption']['storytopic'];
	}
	if ($opnConfig['opnOption']['storycat'] != '') {
		$query .= ' AND catid=' . $opnConfig['opnOption']['storycat'];
		$query1 .= ' AND catid=' . $opnConfig['opnOption']['storycat'];
	} else {
		if ($backto == '') {
			$query .= ' AND ihome=0';
			$query1 .= ' AND ihome=0';
		}
	}
	if ($checker != '') {
		$query .= $topics1;
		$query1 .= $topics1;
	}
	if (! ($opnConfig['opnOption']['storynum']) ) {
		$opnConfig['opnOption']['storynum'] = $opnConfig['storyhome'];
	}
	if ($articlenumber != 0) {
		$query .= ' AND (sid=' . $articlenumber . ')';
	}
	$query .= ' ORDER BY wtime DESC';
	if ($result == '') {
		$result = &$opnConfig['database']->SelectLimit ($query, $opnConfig['opnOption']['storynum'], $offset);
		$art_options['docenterbox'] = 1;
	}
	if ($opnConfig['database']->ErrorNo ()>0) {
		echo $opnConfig['database']->ErrorNo () . ': ' . $opnConfig['database']->ErrorMsg () . '<br />SQL : ' . $query;
		exit ();
	}
	$foundsomearticles = false;
	$datetime = '';
	$temp = '';
	while (! $result->EOF) {
		$s_sid = $result->fields['sid'];
		$s_catid = $result->fields['catid'];
		$title = $result->fields['title'];
		$opnConfig['opndate']->sqlToopnData ($result->fields['wtime']);
		$time = $result->fields['wtime'];
		$opnConfig['opndate']->formatTimestamp ($datetime, _DATE_DATESTRING5);
		$hometext = $result->fields['hometext'];
		$bodytext = $result->fields['bodytext'];
		$comments = $result->fields['comments'];
		$counter = $result->fields['counter'];
		$topic = $result->fields['topic'];
		$informant = $result->fields['informant'];
		$notes = $result->fields['notes'];
		$userfile = $result->fields['userfile'];
		$myoptions = unserialize ($result->fields['options']);
		$acomm = $result->fields['acomm'];
		if ($isindex) {
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['article_stories'] . " SET counter=counter+1 WHERE sid=$s_sid");
		}
		$sql1 = 'SELECT wdate FROM ' . $opnTables['article_comments'] . ' WHERE sid=' . $s_sid . ' ORDER BY wdate DESC';
		$result1 = &$opnConfig['database']->SelectLimit ($sql1, 1);
		if (isset ($result1->fields['wdate']) ) {
			$newest_comment = $result1->fields['wdate'];
		} else {
			$newest_comment = 0;
		}
		if (isset ($myoptions['_art_op_use_theme_id']) ) {
			$opnConfig['current_mb_themeid'] = $myoptions['_art_op_use_theme_id'];
		} else {
			$opnConfig['current_mb_themeid'] = '';
		}
		if ($informant == '') {
			$informant = $opnConfig['opn_anonymous_name'];
		}
		if ($firstsid == 0) {
			$firstsid = $s_sid;
		}
		if ( (!isset ($myoptions['_art_op_use_foot']) ) OR ($myoptions['_art_op_use_foot'] == '') ) {
			$myoptions['_art_op_use_foot'] = '';
			$tplzu = '&nbsp;|&nbsp;';
		} else {
			$tplzu = '';
		}
		$sidcount++;
		$myicons = '';
		if ($isindex) {
			if ($opnConfig['permission']->HasRights ('system/article', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
				$myicons .= '&nbsp;&nbsp; [ <a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/admin/index.php',
														'op' => 'EditStory',
														'sid' => $s_sid) ) . '">' . _THEME_EDIT . '</a>';
			}
			if ($opnConfig['permission']->HasRights ('system/article', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
				$myicons .= ' | <a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/admin/index.php',
													'op' => 'RemoveStory',
													'sid' => $s_sid) ) . '">' . _THEME_DELETE . '</a> ]&nbsp;&nbsp;';
			}
			if ($opnConfig['installedPlugins']->isplugininstalled ('pro/article_pro') ) {
				if ($opnConfig['permission']->HasRights ('system/article', array (_ART_PERM_SENDARTICLE, _PERM_ADMIN), true) ) {
					$myicons .= '&nbsp;<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/include/sendarticle.php',
														'sid' => $s_sid) ) . '" title="' . _ART_OPNSENDPAGE . '" target="_blank"><img src="images/opnsend.gif" class="imgtag" title="' . _ART_OPNSENDPAGE . '" alt="' . _ART_OPNSENDPAGE . '" /></a>&nbsp;&nbsp;';
				}
			}
		}
		if ($backto != '') {
			$myicons .= '&nbsp;&nbsp;' . $backto;
		}
		if (!$opnConfig['art_hideicons']) {
			if ($opnConfig['permission']->HasRight ('system/article', _ART_PERM_PRINT, true) ) {
				$myicons .= ' | <a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/printarticle.php',
													'sid' => $s_sid) ) . '" title="' . _ARTAUTO_ALLTOPICSPRINTERFRIENDLYPAGE . '" target="_blank"><img src="' . $opnConfig['opn_default_images'] . 'print.gif" class="imgtag" alt="' . _ARTAUTO_ALLTOPICSPRINTERFRIENDLYPAGE . '" /></a>&nbsp;';
			}
			if (!$acomm) {
				if ( ($opnConfig['permission']->HasRight ('system/article', _ART_PERM_PRINT, true) ) && ($opnConfig['permission']->HasRight ('system/article', _ART_PERM_COMMENTREAD, true) ) ) {
					$myicons .= '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/printarticle.php',
													'sid' => $s_sid,
													'printcomment' => '1') ) . '" title="' . _ARTAUTO_ALLTOPICSPRINTERFRIENDLYPAGEWITHCOMMENTS . '" target="_blank"><img src="' . $opnConfig['opn_default_images'] . 'print_comments.gif" class="imgtag" alt="' . _ARTAUTO_ALLTOPICSPRINTERFRIENDLYPAGEWITHCOMMENTS . '" /></a>&nbsp;';
				}
			}
			if ($opnConfig['installedPlugins']->isplugininstalled ('modules/fpdf') ) {
				if ($opnConfig['permission']->HasRight ('system/article', _ART_PERM_PRINTASPDF, true) ) {
					$myicons .= '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/printpdf.php',
													'sid' => $s_sid) ) . '" title="' . _ART_ALLTOPICSPRINTERPDF . '" target="_blank"><img src="' . $opnConfig['opn_default_images'] . 'files/pdf.gif" class="imgtag" title="' . _ART_ALLTOPICSPRINTERPDF . '" alt="' . _ART_ALLTOPICSPRINTERPDF . '" /></a>&nbsp;&nbsp;';
				}
			}
			if ($opnConfig['installedPlugins']->isplugininstalled ('system/friend') ) {
				if ($opnConfig['permission']->HasRight ('system/article', _ART_PERM_SENDARTICLE, true) ) {
					$myicons .= '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/friend/index.php',
													'op' => 'FriendSend',
													'sid' => $s_sid) ) . '" title="' . _ARTAUTO_ALLTOPICSSENDTOAFRIEND . '"><img src="' . $opnConfig['opn_default_images'] . 'friend.gif" class="imgtag" alt="' . _ARTAUTO_ALLTOPICSSENDTOAFRIEND . '" /></a>';
				}
			}
		}
		if ($isindex) {
			if ( (!isset ($opnConfig['art_useshortheaderindetailedview']) ) || ($opnConfig['art_useshortheaderindetailedview'] == 0) ) {
				$title = $title . '&nbsp;' . $myicons . '<br />' . _OPN_HTML_NL;
			}
		}
		if (isset ($topics[$topic][0]) ) {
			$topicimage = $topics[$topic][0];
		} else {
			$topicimage = '';
		}
		if (isset ($topics[$topic][1]) ) {
			$topictext = _article_get_path ($topics, $topic);
			$topictext = substr ($topictext, 1);
		} else {
			$topictext = '';
		}
		$hometext = $opnConfig['cleantext']->makeClickable ($hometext);
		opn_nl2br ($hometext);
		$notes = $opnConfig['cleantext']->makeClickable ($notes);
		opn_nl2br ($notes);
		$introcount = strlen ($hometext);
		$fullcount = strlen ($bodytext);
		opn_nl2br ($bodytext);
		$totalcount = $introcount+ $fullcount;
		$morelink = '';
		$morebytes = '';
		$mycomments = '';
		$com_date = '';
		if (!$isindex) {
			if ( ($fullcount >= 1) OR ( ($userfile != '') && ($userfile != 'none') ) ) {
				if ($opnConfig['opnOption']['storycat'] == '') {
					$morelink .= '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/index.php',
																					'sid' => $s_sid) ) . '">';
				} else {
					$morelink .= '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/index.php',
																					'sid' => $s_sid,
																					'backto' => 'storycat',
																					'storycat' => $opnConfig['opnOption']['storycat']) ) . '">';
				}
				$morelink .= '<span class="normaltextbold">' . _ART_AUTOSTARTREADMORE . '</span></a>';
				$morebytes .= $tplzu . $totalcount . '&nbsp;' . _ART_ALLTOPICSBYTESMORE . $tplzu;
			}
			if (!$acomm) {
				if ($comments == 0) {
					$mycomments = '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/index.php',
														'sid' => $s_sid) ) . '">' . _ART_ALLTOPICSCOMMENTS . '</a>';
				} else {
					if ( ( (isset ($opnConfig['art_showcommentdate']) ) && ($opnConfig['art_showcommentdate']) ) && ($newest_comment) ) {
						$opnConfig['opndate']->sqlToopnData ($newest_comment);
						$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
						$com_date = $tplzu . _ART_LASTCOMMENT . ': ' . $temp;
					}
					if ($comments == 1) {
						$mycomments = '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/index.php',
															'sid' => $s_sid) ) . '">' . $comments . '&nbsp;' . _ART_ALLTOPICSCOMMENT . '</a>';
					} else {
						$mycomments = '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/index.php',
															'sid' => $s_sid) ) . '">' . $comments . '&nbsp;' . _ART_ALLTOPICSCOMMENTA . '</a>';
					}
					$mycomments .= '&nbsp;' . buildnewtag ($newest_comment);
				}
				if (!$opnConfig['permission']->HasRight ('system/article', _ART_PERM_COMMENTREAD, true) ) {
					$mycomments = '';
					$com_date = '';
				}
			} else {
				$mycomments = '';
				$com_date = '';
				if ($morelink == '') {
					$morelink .= '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/index.php',
														'sid' => $s_sid) ) . '">' . _ART_AUTOSTARTREADMORE . '</a>';
				}
			}
		}
		$thetext = '';
		$imagetext = '';
		if ( ($userfile != '') && ($userfile != 'none') && (!is_array ($userfile) ) ) {
			if ( (isset ($opnConfig['art_showarticleimagebeforetext']) ) && ($opnConfig['art_showarticleimagebeforetext'] == 1) ) {
				$thetext .= '<img src="' . $userfile . '" class="articleimg" alt="" /><br style="clear:left" />';
			} else {
				$imagetext = '<br /><img src="' . $userfile . '" class="imgtag" alt="" />';
			}
		}
		// add notes
		$thetext .= $hometext;
		if ( ($art_options['dothebody'] == 1) && ($bodytext != '') ) {
			if ( (!isset($myoptions['_art_op_use_user_group_shorttxt'])) OR ($opnConfig['permission']->CheckUserGroup ($myoptions['_art_op_use_user_group_shorttxt'])) ) {
				if ($opnConfig['permission']->HasRight ('system/article', _ART_PERM_READMORE, true) ) {
					$thetext = $thetext . '<br /><br />' . $bodytext;
				}
			}
		}
		if ($notes != '') {
			$thetext .= '<br /><span class="normaltextbold">' . _ART_ADMINNOTE . '</span> <span class="normaltextitalic">' . $notes . '</span>';
		}
		if ( ($topicimage != '') && ($art_options['showtopic'] == 1) ) {
			$thetext = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/topicindex.php',
											'storytopic' => $topic) ) . '" title="' . $topictext . '">' . '<img src="' . $opnConfig['datasave']['art_topic_path']['url'] . '/' . $topicimage . '" class="imgarticlecenter" alt="" title="" />' . '</a>' . $thetext;
		}
		$thetext .= $imagetext;
		if (!isset ($myoptions['_art_op_use_head']) ) {
			$myoptions['_art_op_use_head'] = '';
		}
		if (!isset ($myoptions['_art_op_use_foot']) ) {
			$myoptions['_art_op_use_foot'] = '';
		}
		if ( ($myoptions['_art_op_use_head'] == '') && ($opnConfig['_op_use_head_org'] != '') ) {
			$myoptions['_art_op_use_head'] = $opnConfig['_op_use_head_org'];
		}
		if ( ($myoptions['_art_op_use_foot'] == '') && ($opnConfig['_op_use_foot_org'] != '') ) {
			$myoptions['_art_op_use_foot'] = $opnConfig['_op_use_foot_org'];
		}
		if ( ($myoptions['_art_op_use_head'] != '') || ($myoptions['_art_op_use_foot'] != '') ) {
			if ($s_catid != '0') {
				$mycat = $cats[$s_catid];
				$mycaturl = encodeurl (array ($opnConfig['opn_url'] . '/system/article/topicindex.php',
								'storycat' => $s_catid) );
			} else {
				$mycat = '';
				$mycaturl = '';
			}
			$_article_dat_ = array ('[MORELINK]' => $morelink,
						'[MOREBYTES]' => $morebytes,
						'[COMMENTS]' => $mycomments,
						'[COMMENTS_LAST]' => $com_date,
						'[ICONS]' => $myicons,
						'[POSTER]' => api_user_name ($informant),
						'[HREFPOSTER]' => encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
							'op' => 'userinfo',
							'uname' => $informant) ),
							'[TITLE]' => $title,
							'[POSTEDON]' => $datetime . '&nbsp;' . buildnewtag ($time),
							'[READS]' => $counter,
							'[_THEME_POSTEDBY]' => _THEME_POSTEDBY,
							'[_THEME_ON]' => _THEME_ON,
							'[_THEME_READS]' => _THEME_READS,
							'[CAT]' => $mycat,
							'[SID]' => $s_sid,
							'[HREFCAT]' => $mycaturl,
							'[URL]' => $opnConfig['opn_url'] . '/',
							'[art_options]' => $art_options);
			$opnConfig['_article_dat_'] = $_article_dat_;
			$headtypedetected = substr ($myoptions['_art_op_use_head'], strrpos ($myoptions['_art_op_use_head'], '.')+1);
			$foottypedetected = substr ($myoptions['_art_op_use_foot'], strrpos ($myoptions['_art_op_use_foot'], '.')+1);
			if ( ($headtypedetected != 'php') || ($foottypedetected != 'php') ) {
				if (!defined ('_OPN_TEMPLATE_CLASS_INCLUDED') ) {
					include (_OPN_ROOT_PATH . "class/class.opn_theme_template.php");
				}
				$tpl = & new opn_template (_OPN_ROOT_PATH);
				$tpl->set ('[MORELINK]', $morelink);
				$tpl->set ('[MOREBYTES]', $morebytes);
				$tpl->set ('[COMMENTS]', $mycomments);
				$tpl->set ('[COMMENTS_LAST]', $com_date);
				$tpl->set ('[ICONS]', $myicons);
				$tpl->set ('[POSTER]', api_user_name ($informant) );
				$tpl->set ('[HREFPOSTER]', encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
									'op' => 'userinfo',
									'uname' => $informant) ) );
				$tpl->set ('[TITLE]', $title);
				$tpl->set ('[POSTEDON]', $datetime . '&nbsp;' . buildnewtag ($time) );
				$tpl->set ('[READS]', $counter);
				$tpl->set ('[_THEME_POSTEDBY]', _THEME_POSTEDBY);
				$tpl->set ('[_THEME_ON]', _THEME_ON);
				$tpl->set ('[_THEME_READS]', _THEME_READS);
				$tpl->set ('[CAT]', $mycat);
				$tpl->set ('[SID]', $s_sid);
				$tpl->set ('[HREFCAT]', $mycaturl);
				$tpl->set ('[URL]', $opnConfig['opn_url'] . '/');
			}
		}
		$foot = '';
		$myoptions['_art_op_use_foot'] = trim ($myoptions['_art_op_use_foot']);
		if ($myoptions['_art_op_use_foot'] != '') {
			if ($foottypedetected != 'php') {
				$foot = $tpl->fetch ('themes/' . $opnTheme['thename'] . '/tpl/article/' . $myoptions['_art_op_use_foot']);
			} else {
				include (_OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/tpl/article/' . $myoptions['_art_op_use_foot']);
			}
		} else {
			if (!$isindex) {
				$foot .= '<a href="javascript:self.scrollTo(0,0)">';
				$foot .= '<img src="' . $opnConfig['opn_url'] . '/system/article/plugin/autostart/images/point_nach_oben.gif" class="imgtag" alt="" />';
				$foot .= '</a>';
				$foot .= '<img src="' . $opnConfig['opn_url'] . '/system/article/plugin/autostart/images/point.gif" width="8" height="8" border="0" alt="" /> ';
			} else {
				$foot .= '<br />';
			}
			$foot .= $morelink . $morebytes . $mycomments . $com_date . $myicons;
		}
		$myoptions['_art_op_use_head'] = trim ($myoptions['_art_op_use_head']);
		if ($myoptions['_art_op_use_head'] != '') {
			if ($headtypedetected != 'php') {
				$title = $tpl->fetch ('themes/' . $opnTheme['thename'] . '/tpl/article/' . $myoptions['_art_op_use_head']);
			} else {
				include (_OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/tpl/article/' . $myoptions['_art_op_use_head']);
			}
		} else {
			if ($art_options['showfulllink'] == 1) {
				$titlecat = '';
				if ( ($s_catid != '0') && ($art_options['showcatlink'] == 1) ) {
					$titlecat = '<a class="opncenterboxhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/topicindex.php',
													'storycat' => $s_catid) ) . '">' . $cats[$s_catid] . '</a>: ';
				}
				$title = $titlecat . '<a class="opncenterboxhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/index.php',
														'sid' => $s_sid) ) . '">' . $title . '</a>';
			} else {
				if ($s_catid != '0') {
					$title = '<a class="opncenterboxhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/topicindex.php',
													'storycat' => $s_catid) ) . '">' . $cats[$s_catid] . '</a>: ' . $title;
				}
				$poster = '<a class="opncenterboxhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
												'op' => 'userinfo',
												'uname' => $informant) ) . '">' . api_user_name ($informant) . '</a>';
				$title = $title . '<br />';
				$title .= _THEME_POSTEDBY . ' ' . $poster . '&nbsp;' . _THEME_ON . ' ' . $datetime . '&nbsp;' . buildnewtag ($time) . ' (' . $counter . ' * ' . _THEME_READS . ")";
			}
		}
		if ($art_options['dothetitle'] == 0) {
			$title = '';
		}
		if ($art_options['dothefooter'] == 0) {
			$foot = '';
		}
		if ($art_options['dothetitle_max'] != 0) {
			$opnConfig['cleantext']->opn_shortentext ($title, $art_options['dothetitle_max']);
		}
		if ($art_options['dothebody_max'] != 0) {
			$opnConfig['cleantext']->opn_shortentext ($thetext, $art_options['dothebody_max']);
		}
		if ($art_options['dothefooter_max'] != 0) {
			$opnConfig['cleantext']->opn_shortentext ($foot, $art_options['dothefooter_max']);
		}
		if ($art_options['docenterbox'] == 1) {
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_ARTICLE_380_';
			$_display_dat['module'] = 'system/article';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox ($title, $thetext, $foot);
		} else {
			themebox_centerincenter ($myreturntext, $title, $thetext, $foot);
		}
		$foundsomearticles = true;
		$result->MoveNext ();
	}
	$result->Close ();
	if ($foundsomearticles == true) {
		if ($articlenumber == 0) {
			$txt = '';
			$offsetafter = $offset+ $opnConfig['opnOption']['storynum'];
			$offsetbefore = $offset- $opnConfig['opnOption']['storynum'];
			$result = $opnConfig['database']->Execute ($query1);
			if ( (is_object ($result) ) && (isset ($result->fields['counter']) ) ) {
				$reccount = $result->fields['counter'];
				$result->Close ();
			} else {
				$reccount = 0;
			}
			unset ($result);
			$url = array ($opnConfig['opn_url'] . '/system/article/topicindex.php');
			if ($opnConfig['opnOption']['storytopic'] != '') {
				$url['storytopic'] = $opnConfig['opnOption']['storytopic'];
			}
			if ($opnConfig['opnOption']['storycat'] != '') {
				$url['storycat'] = $opnConfig['opnOption']['storycat'];
			}
			if ($offsetbefore >= 0) {
				$txt .= '<td align="left">';
				$url['offset'] = $offsetbefore;
				$txt .= '<a href="' . encodeurl ($url) . '"><span class="normaltextbold">' . _ART_PREVIOUS_PAGE . '</span></a>';
				$txt .= '</td>';
			}
			if ($offsetafter<=$reccount) {
				$txt .= '<td align="right">';
				$url['offset'] = $offsetafter;
				$txt .= '<a href="' . encodeurl ($url) . '"><span class="normaltextbold">' . _ART_NEXT_PAGE . '</span></a>';
				$txt .= '</td>';
			}
			if ($txt != '') {
				$txt = '<table class="opncenterbox" border="0" cellspacing="0" cellpadding="0"><tr>' . $txt . '</tr></table>';
				$_display_dat = array ();
				$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_ARTICLE_390_';
				$_display_dat['module'] = 'system/article';
				$opnConfig['opnOutput']->SetDisplay ($_display_dat);
				unset ($_display_dat);
				$opnConfig['opnOutput']->DisplayCenterbox (_ART_BROWSEINARTICLE, $txt, '');
			}
		}
	}
	return $foundsomearticles;

}

?>