<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig, $opnTables;

$opnConfig['permission']->InitPermissions ('system/forum');
$opnConfig['permission']->HasRights ('system/forum', array (_PERM_READ, _PERM_BOT) );
$opnConfig['module']->InitModule ('system/forum');
$opnConfig['opnOutput']->setMetaPageName ('system/forum');
getLanguageDef (_OPN_ROOT_PATH . 'system/forum/language/');
include_once (_OPN_ROOT_PATH . 'system/forum/functions.php');
include_once (_OPN_ROOT_PATH . 'system/forum/class.forum.php');
include_once (_OPN_ROOT_PATH . 'system/forum/class.forum_input.php');
include_once (_OPN_ROOT_PATH . 'api/user_name.php');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
$cancel = '';
get_var ('cancel', $cancel, 'form', _OOBJ_DTYPE_CLEAN);
$forum = 0;
get_var ('forum', $forum, 'both', _OOBJ_DTYPE_INT);
$topic = 0;
get_var ('topic', $topic, 'both', _OOBJ_DTYPE_INT);
if ( ($cancel) OR (trim ($opnConfig['opnOption']['client']->_browser_info['browser']) == 'bot') ) {
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php',
							'topic' => $topic,
							'forum' => $forum),
							false) );
} else {
	$message = '';
	get_var ('message', $message, 'form', _OOBJ_DTYPE_CHECK);
	if ($message != '') {
		$opnConfig['cleantext']->filter_text ($message, true, true);
	}
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
		include_once (_OPN_ROOT_PATH . 'system/smilies/smilies.php');
	}
	$boxtxt = '';
	$eh = & new opn_errorhandler;
	// opn_errorhandler object
	forum_setErrorCodes ($eh);
	$opnforum = & new ForumHandler_input;
	$forumconfig = loadForumConfig ($forum);
	if ($forumconfig['readonly']) {
		$eh->show ('FORUM_0026');
	}
	$sql = 'SELECT forum_name, forum_access,forum_type FROM ' . $opnTables['forum'] . ' WHERE (forum_id = ' . $forum . ')';
	$result = &$opnConfig['database']->Execute ($sql);
	if ($result === false) {
		$eh->show ('FORUM_0001');
	}
	$myrow = $result->GetRowAssoc ('0');
	$forum_name = $myrow['forum_name'];
	$forum_access = $myrow['forum_access'];
	$forum_type = $myrow['forum_type'];
	$forum_id = $forum;
	if (is_locked ($topic) ) {
		$eh->show ('FORUM_0016');
	}
	if (!does_exists ($forum, 'forum') || !does_exists ($topic, 'topic') ) {
		if ( ($forum == 0) AND ($topic == 0) ) {
			include_once (_OPN_ROOT_PATH . 'system/forum/index.php');
			die ();
		} else {
			$eh->show ('FORUM_0017');
		}
	}
	$submit = '';
	get_var ('submit', $submit, 'form', _OOBJ_DTYPE_CLEAN);
	if ($submit) {
		if (!$opnConfig['permission']->IsUser () ) {
			$username = '';
			get_var ('username', $username, 'form', _OOBJ_DTYPE_CLEAN);
			$password = '';
			get_var ('password', $password, 'form', _OOBJ_DTYPE_CLEAN);
			if ($username == '' && $password == '' && $forum_access == 0) {
				// Not logged in, and username and password are empty and forum_access is 0 (anon posting allowed)
				$userdata = $opnConfig['permission']->GetUser ($opnConfig['opn_anonymous_id'], '', '');
			} else {
				// no valid session, need to check user/pass.
				if ($username == '' || $password == '') {
					$eh->show ('FORUM_0018');
				}
				$userdata = $opnConfig['permission']->GetUser ($username, 'useruname', '');
				$md_pass = md5 ($password);
				if ($md_pass != $userdata['pass']) {
					$eh->show ('FORUM_0019');
				}
			}
		} else {
			$userdata = $opnConfig['permission']->GetUserinfo ();
		}
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_FORUM_620_';
		$_display_dat['module'] = 'system/forum';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		$opnConfig['opnOutput']->EnableJavaScript ();
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayHead ();
		// Either valid user/pass, or valid session. continue with post.
		if ($message != '') {
			$uname = '';
			get_var ('uname', $uname, 'form', _OOBJ_DTYPE_CLEAN);
			if ( (!$opnConfig['permission']->IsUser () ) && ($opnConfig['forum_check_anon_nick']) && ($username != '(Anonymous)') ) {
				$ui = array ();
				$ui = $opnConfig['permission']->GetUser ($uname, 'useruname', '');
				if (isset ($ui['uname']) ) {
					$eh->show ('FORUM_0027');
				}
			}
			$poster_ip = get_real_IP ();
			$subject = '';
			get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
			if ($subject != '') {
				$opnConfig['cleantext']->filter_text ($subject, true, true);
			}
			$message = $opnConfig['cleantext']->FixQuotes ($message);
			$subject = $opnConfig['cleantext']->FixQuotes ($subject);
			$result = &$opnConfig['database']->Execute ('SELECT topic_title FROM ' . $opnTables['forum_topics'] . ' WHERE topic_id=' . $topic);
			$topic_title = $result->fields['topic_title'];
			$html = 0;
			get_var ('html', $html, 'form', _OOBJ_DTYPE_INT);
			$bbcode = 0;
			get_var ('bbcode', $bbcode, 'form', _OOBJ_DTYPE_INT);
			$smile = 0;
			get_var ('smile', $smile, 'form', _OOBJ_DTYPE_INT);
			$user_images = 0;
			get_var ('user_images', $user_images, 'form', _OOBJ_DTYPE_INT);
			$sig = 0;
			get_var ('sig', $sig, 'form', _OOBJ_DTYPE_INT);
			if ($forumconfig['allow_html'] == 0 || $html) {
				$message = htmlspecialchars ($message);
			}
			if ($forumconfig['allow_bbcode'] == 1 && !$bbcode) {
				include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ubbcode.php');
				$ubb = & new UBBCode;
				$ubb->ubbencode ($message);
			}
			if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
				if (!$smile) {
					$message = smilies_smile ($message);
				}
			}
			if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
				if (!$user_images) {
					include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
					$message = make_user_images ($message);
				}
			}
			if ( ($sig) && ($userdata['uid'] != $opnConfig['opn_anonymous_id']) ) {
				$message .= '[addsig]';
			}
			opn_nl2br ($message);
			$message = $opnConfig['cleantext']->makeClickable ($message);
			$message = $opnConfig['opnSQL']->qstr ($message, 'post_text');
			$subject = $opnConfig['opnSQL']->qstr ($subject);
			$opnConfig['opndate']->now ();
			$time = '';
			$opnConfig['opndate']->opnDataTosql ($time);
			$opnConfig['opndate']->setTimestamp ('00:' . sprintf ('%02d', $forumconfig['spamtime']) . ':00');
			$time1 = '';
			$opnConfig['opndate']->opnDataTosql ($time1);
			$time2 = $time- $time1;
			$ip = get_real_IP ();
			$_ip = $opnConfig['opnSQL']->qstr ($ip);
			$sql = 'SELECT COUNT(post_id) AS total FROM ' . $opnTables['forum_posts'] . " WHERE poster_ip=$_ip and post_time > $time2";
			$result = &$opnConfig['database']->Execute ($sql);
			if ( ($result !== false) && (isset ($result->fields['total']) ) ) {
				$postime = $result->fields['total'];
			} else {
				$postime = 0;
			}
			if ($postime<$forumconfig['spampost']) {
				$attach = array ();
				if (!isset ($forumconfig['attachmentenable']) ) {
					$forumconfig['attachmentenable'] = 0;
				}
				forum_check_upload ($forumconfig, $forum, $attach);
				$newpost_id = $opnConfig['opnSQL']->get_new_number ('forum_posts', 'post_id');
				$image_subject = '';
				get_var ('image_subject', $image_subject, 'form', _OOBJ_DTYPE_CLEAN);
				$email = '';
				get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
				if (!$opnConfig['permission']->IsUser () ) {
					if ($uname == '(Anonymous)') {
						$email = '';
						$uname = '';
					}
				} else {
					$email = '';
					$uname = '';
				}
				$email = $opnConfig['opnSQL']->qstr ($email);
				$uname = $opnConfig['opnSQL']->qstr ($uname);
				$_image_subject = $opnConfig['opnSQL']->qstr ($image_subject);
				$_poster_ip = $opnConfig['opnSQL']->qstr ($poster_ip);
				$sql = 'INSERT INTO ' . $opnTables['forum_posts'] . " (post_id, topic_id, image, forum_id, poster_id, post_text, post_time, poster_ip,poster_name, poster_email, post_subject) VALUES ($newpost_id, $topic, $_image_subject, $forum, " . $userdata['uid'] . ", $message, $time, $_poster_ip, $uname, $email, $subject)";
				$opnConfig['database']->Execute ($sql) or $eh->show ('FORUM_0014');
				$opnConfig['opnSQL']->UpdateBlobs ($opnTables['forum_posts'], 'post_id=' . $newpost_id);
				$sql = 'UPDATE ' . $opnTables['forum_topics'] . ' SET topic_time = ' . $time . ' WHERE topic_id = ' . $topic;
				$opnConfig['database']->Execute ($sql) or $eh->show ('FORUM_0014');
				$notify2 = 0;
				get_var ('notify2', $notify2, 'form', _OOBJ_DTYPE_INT);
				set_watch ($forumconfig['allow_watch'], 'topic', $notify2, $topic, $userdata['uid']);
				forum_do_upload ($forumconfig, $attach, $forum, $topic, $newpost_id);
				if ($userdata['uid'] != $opnConfig['opn_anonymous_id']) {
					$sql = 'UPDATE ' . $opnTables['users_status'] . ' SET posts=posts+1 WHERE (uid = ' . $userdata['uid'] . ')';
					$result = &$opnConfig['database']->Execute ($sql);
					if ($result === false) {
						$eh->show ('FORUM_0020');
					}
				}
				$helptxt = '<div class="centertag">' . _FORUM_REPLYPOSTED . '<br /><a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php',
																			'topic' => $topic,
																			'forum' => $forum,
																			'viewlastpost' => '1') ) . '">' . _FORUM_CLICKTOVIEW . '</a></div>';
				$helptxt .= '<meta http-equiv="refresh" content="3;URL=' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php',
													'topic' => $topic,
													'forum' => $forum,
													'viewlastpost' => '1') ) . '" />';
				send_notify ($forumconfig['allow_watch'], 'topic', $userdata['uid'], $topic);
				$boxtxt .= $helptxt;
			} else {
				$helptxt = '<div class="centertag">' . sprintf (_FORUM_NOTMORETHEN, $forumconfig['spampost'], $forumconfig['spamtime']) . '</div>';
				$boxtxt .= $helptxt;
			}
		} else {
			$helptxt = '<div class="centertag">' . _FORUM_TYPEMSG . '<br /><br />';
			$helptxt .= '[ <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php',
											'topic' => $topic,
											'forum' => $forum,
											'viewlastpost' => '1') ) . '">' . _FORUM_GOBACK . '</a> ]</div>';
			$boxtxt .= $helptxt;
		}
		$boxtxt .= '<br />';
	} else {
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_FORUM_630_';
		$_display_dat['module'] = 'system/forum';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		$opnConfig['opnOutput']->EnableJavaScript ();
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayHead ();
		$userdata = $opnConfig['permission']->GetUserinfo ();
		$result = &$opnConfig['database']->Execute ('SELECT topic_title FROM ' . $opnTables['forum_topics'] . ' WHERE topic_id=' . $topic);
		$topic_title = $result->fields['topic_title'];
		$table = & new opn_TableClass ('alternator');
		$table->AddCols (array ('30%', '70%') );
		$table->AddOpenRow ();
		$table->AddDataCol ($opnforum->help_show_mods ($forum), '', '2');
		$table->AddCloseRow ();
		$table->AddDataRow (array (_FORUM_FORUM . ':', '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewforum.php', 'forum' => $forum) ) . '">' . $forum_name . '</a>') );
		$table->AddDataRow (array ('<span class="smalltextbold">' . _FORUM_POSTREPLY . ':</span>', '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php', 'forum' => $forum, 'topic' => $topic) ) . '">' . $topic_title . '</a>') );
		$table->AddDataRow (array ('<span class="smalltextbold">' . _FORUM_GOON . ':</span>', '<a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/forum/index.php">' . $opnConfig['sitename'] . '&nbsp;' . _FORUM_INDEX . '</a>') );
		$helptxt = '';
		$table->GetTable ($helptxt);
		$boxtxt .= $helptxt . '<br /><br />';
		$dat['donefile'] = 'reply.php';
		$dat['forum_access'] = $forum_access;
		$dat['forumconfig'] = $forumconfig;
		$dat['topic_title'] = $topic_title;
		$dat['forum_type'] = $forum_type;
		$fast_post = '';
		get_var ('fast_post', $fast_post, 'both', _OOBJ_DTYPE_CLEAN);
		if ($fast_post == 'fast_post') {
			$dat['mode'] = 'fast_post';
		} else {
			$dat['mode'] = 'post';
		}
		$opnforum->_insert ('userdata', $userdata);
		$opnforum->_insert ('forum', $forum);
		$boxtxt .= $opnforum->reply_form ($dat);
		$boxtxt .= '<br />';
		$forumlist = get_forumlist_user_can_see ();
		$forumlist = explode (',', $forumlist);
		if (! ( (!in_array ($forum, $forumlist) ) && ($forum_type == 1) ) ) {
			$sorting = 0;
			get_var ('sorting', $sorting, 'both', _OOBJ_DTYPE_CLEAN);
			$start = 0;
			get_var ('start', $start, 'both', _OOBJ_DTYPE_INT);
			$total = get_total_posts ($topic, 'topic');
			$pagezeile = '';
			if ($total>$forumconfig['posts_per_page']) {
				$help = '';
				$times = 0;
				for ($x = 0; $x< $total; $x += $forumconfig['posts_per_page']) {
					if ($times != 0) {
						$help .= ' - ';
					}
					if ($start != $x) {
						$help .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/reply.php',
														'sorting' => $sorting,
														'topic' => $topic,
														'forum' => $forum,
														'start' => $x) ) . '">' . ($times+1) . '</a>';
					} else {
						$help .= ($times+1);
					}
					$times++;
				}
				$table = & new opn_TableClass ('default');
				$table->AddHeaderRow (array ($times . '&nbsp;' . _FORUM_PAGES . ' ( ' . $help . ' )'), array ('right') );
				$table->GetTable ($pagezeile);
			}
			$helptext = '<div class="centertag">' . _FORUM_TOPICREVIEW . '</div>';
			$boxtxt .= $helptext;
			$boxtxt .= '<br />';
			if ($sorting == '1') {
				$sorttxt = 'post_time ASC';
			} else {
				$sorttxt = 'post_time DESC';
			}
			$thetopic = &$opnConfig['database']->SelectLimit ('SELECT post_id, image, topic_id, forum_id, poster_id, post_text, post_time, poster_ip, poster_name, poster_email, post_subject FROM ' . $opnTables['forum_posts'] . ' WHERE topic_id = ' . $topic . ' AND forum_id = ' . $forum . ' ORDER BY ' . $sorttxt, $forumconfig['posts_per_page'], $start);
			if ($thetopic !== false) {
				$table = & new opn_TableClass ('alternator');
				$table->AddCols (array ('20%', '80%') );
				if ($opnConfig['permission']->HasRight ('system/forum', _FORUM_PERM_SENDTOPIC, true) ) {
					$send_help = '<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/emailtopic.php',
													'topic' => $topic,
													'forum' => $forum,
													'post_id' => '-1',
													'usernummer' => $userdata['uid']) ) . '"><img src="images/friendheadmail.gif" class="imgtag" style="float: right" align="right" alt="' . _FORUM_EMAILTOPIC . '" /></a>';
				} else {
					$send_help = '';
				}
				$table->AddHeaderRow (array (_FORUM_AUTHOR, $send_help) );
				$opnforum->_insert ('forum', $forum);
				$opnforum->_insert ('topic', $topic);
				$opnforum->_insert ('userdata', $userdata);
				$opnforum->_insert ('topic_subject', '');
				$opnforum->_insert ('topic_post_total', $total);
				$opnforum->_insert ('forumconfig', $forumconfig);
				$boxtxt .= $opnforum->show_topics ($thetopic, $table);
				$thetopic->Close ();
				$table->GetTable ($boxtxt);
//				$result = &$opnConfig['database']->Execute ('UPDATE ' . $opnTables['forum_topics'] . " SET topic_views = topic_views + 1 WHERE topic_id = $topic");
				$boxtxt .= $pagezeile;
			}
		}
		unset ($forumlist);
	}
	$opnConfig['opnOutput']->DisplayCenterbox (_FORUM_FORUM, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();
}

?>