<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

define ('_FORUM_SEARCH_TYPE_NEW', 0);
define ('_FORUM_SEARCH_TYPE_LAST', 1);

/**
* Perform a normal search
* @param $eh
* @param $pagesize
* @param $offset
* @param $sortbysel
* @param $sortorder
* @param $sortby
* @param $term
* @param $addterms
* @param $username
* @param $forum
* @param $boxtxt
* @param $maxrows
* @return object
*/

function &normal_search ($eh, $pagesize, $offset, $sortbysel, $sortorder, $sortby, $term, $addterms, $username, $forum, &$boxtxt, &$maxrows) {

	global $opnConfig, $opnTables;
	if ($forum == 0) {
		$forum = -1;
	}
	$addquery = '';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_FORUM_650_', 'forum');
	$form->Init ($opnConfig['opn_url'] . '/system/forum/searchbb.php', 'post', 'Search');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('term', _FORUM_KEYWORD);
	$form->AddTextfield ('term', 25, 50, $term);
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->SetSameCol ();
	$form->AddRadio ('addterms', 'any', ($addterms == 'any'?1 : 0) );
	$form->AddLabel ('addterms', _FORUM_SEARCHANY, 1);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->SetSameCol ();
	$form->AddRadio ('addterms', 'all', ($addterms == 'all'?1 : 0) );
	$form->AddLabel ('addterms', _FORUM_SEARCHALL, 1);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('forum', _FORUM_FORUM);
	$options[-1] = _FORUM_SEARCHFORUMS;
	$forumlist = get_forumlist_user_can_see ();
	if ($forumlist != '') {
		$query = 'SELECT forum_name,forum_id FROM ' . $opnTables['forum'] . ' WHERE forum_id IN (' . $forumlist . ')';
		$result = &$opnConfig['database']->Execute ($query);
		if ($result !== false) {
			while (! $result->EOF) {
				$row = $result->GetRowAssoc ('0');
				$options[$row['forum_id']] = $row['forum_name'];
				if ($forum == -1) {
					if ($addquery != '') {
						$addquery .= ' OR ';
					}
					$addquery .= ' ( (p.forum_id=' . $row['forum_id'] . ') AND (f.forum_id=' . $row['forum_id'] . ') ) ';
				}
				$result->MoveNext ();
			}
		}
		if ($addquery != '') {
			$addquery = '(' . $addquery . ')';
		}
		$query = '';
		$form->AddSelect ('forum', $options, $forum);
		$form->AddChangeRow ();
		$form->AddLabel ('username', _FORUM_AUTHOR);
		$form->AddTextfield ('username', 25, 50, $username);
		$form->AddChangeRow ();
		$form->AddLabel ('sortbysel', _FORUM_SORTBY);
		$options = array ();
		$options['date'] = _FORUM_DATE;
		$options['post'] = _FORUM_BYPOST;
		$options['topic'] = _FORUM_BYTOPIC;
		$options['forum'] = _FORUM_FORUM;
		$options['user'] = _FORUM_AUTHOR;
		$form->SetSameCol ();
		$form->AddSelect ('sortbysel', $options, $sortbysel);
		$form->AddNewline ();
		$form->AddRadio ('sortorder', 'asc', ($sortorder == 'asc'?1 : 0) );
		$form->AddLabel ('sortorder', _FORUM_SORT_ASC, 1);
		$form->AddNewline ();
		$form->AddRadio ('sortorder', 'desc', ($sortorder == 'desc'?1 : 0) );
		$form->AddLabel ('sortorder', _FORUM_SORT_DESC, 1);
		$form->SetEndCol ();
		$form->AddChangeRow ();
		$form->AddText ('&nbsp;');
		$form->SetSameCol ();
		$form->AddSubmit ('submit', _FORUM_SEARCH);
		$form->AddReset ('reset', _FORUM_CLEAR);
		$form->SetEndCol ();
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		if ($term != '') {
			$terms = split (' ', $term);
			// Get all the words into an array
			if ($addquery != '') {
				$addquery .= ' AND ';
			}
			$like_search = $opnConfig['opnSQL']->AddLike ($terms[0]);
			$addquery .= "(p.post_text LIKE $like_search";
			if ($addterms == 'any') {
				$andor = 'OR';
			} else {
				$andor = 'AND';
			}
			$size = sizeof ($terms);
			for ($i = 1; $i< $size; $i++) {
				$like_search = $opnConfig['opnSQL']->AddLike ($terms[$i]);
				$addquery .= " $andor p.post_text LIKE $like_search";
			}
			$addquery .= ')';
		}
		if ($forum != -1) {
			if ($addquery != '') {
				$addquery .= ' AND ';
			}
			$addquery .= 'p.forum_id=' . $forum . ' AND f.forum_id=' . $forum;
		}
		if ($username != '') {
			$_username = $opnConfig['opnSQL']->qstr ($username);
			$result = &$opnConfig['database']->Execute ('SELECT uid FROM ' . $opnTables['users'] . " WHERE uname=$_username");
			if ($result === false) {
				$eh->show ('FORUM_0001');
			}
			$userid = $result->fields['uid'];
			if (!$userid) {
				$eh->show ('FORUM_0011');
			}
			if ($addquery != '') {
				$addquery .= " AND p.poster_id=$userid AND u.uname=$_username";
			} else {
				$addquery = " p.poster_id=$userid AND u.uname=$_username";
			}
		} else {
			$username = '';
		}
		if ($addquery != '') {
			$query .= ' WHERE ' . $addquery . ' AND ';
		} else {
			$query .= ' WHERE ';
		}
		$query .= ' p.topic_id = t.topic_id AND p.forum_id = f.forum_id AND p.poster_id = u.uid';
		$query .= ' AND f.forum_id IN (' . $forumlist . ')';
		$query1 = 'SELECT COUNT(t.topic_title) AS counter FROM ' . $opnTables['forum_posts'] . ' p, ' . $opnTables['users'] . ' u, ' . $opnTables['forum'] . ' f,' . $opnTables['forum_topics'] . ' t' . $query;
		$query .= ' ORDER BY ' . $sortby;
		$result = &$opnConfig['database']->Execute ($query1);
		if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
			$maxrows = $result->fields['counter'];
		} else {
			$eh->show ('FORUM_0001');
			$maxrows = 0;
		}
		$result->Close ();
		$query1 = 'SELECT u.uid AS uid, f.forum_id AS forum_id, p.topic_id AS topic_id, u.uname AS uname, p.post_time AS post_time, t.topic_title AS topic_title, f.forum_name AS forum_name FROM ' . $opnTables['forum_posts'] . ' p, ' . $opnTables['users'] . ' u, ' . $opnTables['forum'] . ' f,' . $opnTables['forum_topics'] . ' t' . $query;
		$result = &$opnConfig['database']->SelectLimit ($query1, $pagesize, $offset);
	} else {
		$result = false;
	}
	return $result;

}

/**
* Peform a ego search
* @param $eh
* @param $pagesize
* @param $offset
* @param $username
* @param $maxrows
* @return object
*/

function &ego_search ($eh, $pagesize, $offset, $username, &$maxrows) {

	global $opnConfig, $opnTables;

	$addquery = '';
	$query = '';
	if ($username != '') {
		$_username = $opnConfig['opnSQL']->qstr ($username);
		$result = &$opnConfig['database']->Execute ('SELECT uid FROM ' . $opnTables['users'] . " WHERE uname=$_username");
		if ($result === false) {
			$eh->show ('FORUM_0001');
		}
		$userid = $result->fields['uid'];
		if (!$userid) {
			$eh->show ('FORUM_0011');
		}
		if ($addquery != '') {
			$addquery .= " AND p.poster_id=$userid AND u.uname=$_username";
		} else {
			$addquery = " p.poster_id=$userid AND u.uname=$_username";
		}
	} else {
		$username = '';
	}
	if ($addquery != '') {
		$query .= ' WHERE ' . $addquery . ' AND ';
	} else {
		$query .= ' WHERE ';
	}
	$forumlist = get_forumlist_user_can_see ();
	if ($forumlist != '') {
		$query .= ' p.topic_id = t.topic_id AND p.forum_id = f.forum_id AND p.poster_id = u.uid';
		$query .= ' AND f.forum_id IN (' . $forumlist . ')';
		$query1 = 'SELECT COUNT(t.topic_title) AS counter FROM ' . $opnTables['forum_posts'] . ' p, ' . $opnTables['users'] . ' u, ' . $opnTables['forum'] . ' f,' . $opnTables['forum_topics'] . ' t' . $query;
		$query .= ' ORDER BY p.post_time DESC';
		$result = &$opnConfig['database']->Execute ($query1);
		if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
			$maxrows = $result->fields['counter'];
		} else {
			$eh->show ('FORUM_0001');
			$maxrows = 0;
		}
		$result->Close ();
		$query1 = 'SELECT u.uid AS uid, f.forum_id AS forum_id, p.topic_id AS topic_id, u.uname AS uname, p.post_time AS post_time, t.topic_title AS topic_title, f.forum_name AS forum_name FROM ' . $opnTables['forum_posts'] . ' p, ' . $opnTables['users'] . ' u, ' . $opnTables['forum'] . ' f,' . $opnTables['forum_topics'] . ' t' . $query;
		$result = &$opnConfig['database']->SelectLimit ($query1, $pagesize, $offset);
	} else {
		$result = false;
	}
	return $result;

}

/**
* Get the post since last visit or the post in the last 24 hours
*
* @param $searchtype
* @param $ui
* @param $eh
* @param $pagesize
* @param $offset
* @param $maxrows
* @return array
*/

function &lastnewpostpost_search ($searchtype, $ui, $eh, $pagesize, $offset, &$maxrows) {

	global $opnConfig, $opnTables;

	switch ($searchtype) {
		case _FORUM_SEARCH_TYPE_NEW:
			$result = $opnConfig['database']->Execute ('SELECT lastvisit FROM ' . $opnTables['forum_user_visit'] . ' WHERE uid=' . $ui['uid']);
			$lastvisit = $result->fields['lastvisit'];
			break;
		case _FORUM_SEARCH_TYPE_LAST:
			$opnConfig['opndate']->now ();
			$opnConfig['opndate']->subInterval ('1 DAY');
			$lastvisit = '';
			$opnConfig['opndate']->opnDataTosql ($lastvisit);
			break;
	}
	if (!$lastvisit) {
		$eh->show ('FORUM_0011');
	}
	$forumlist = get_forumlist_user_can_see ();
	if ($forumlist != '') {
		if (!$opnConfig['database']->isInterbase) {
			$query = 'SELECT p.topic_id AS topic_id, MAX( p.post_time ) AS maximum FROM ';
		} else {
			$query = 'SELECT p.topic_id AS topic_id FROM ';
		}
		$query .= $opnTables['forum_posts'] . ' p, ' . $opnTables['forum'] . ' f';
		$query .= ' WHERE  p.forum_id = f.forum_id AND f.forum_id IN (' . $forumlist . ')';
		$query .= ' GROUP BY p.topic_id';
		$query .= ' HAVING MAX(p.post_time) >=' . $lastvisit;
		if (!$opnConfig['database']->isInterbase) {
			$query .= ' ORDER BY maximum DESC';
		} else {
			$query .= ' ORDER BY MAX(p.post_time) DESC';
		}
		$result = &$opnConfig['database']->Execute ($query);
		$topics = array ();
		if ( ($result !== false)) {
			$maxrows = $result->RecordCount ();
			$result->Close ();
			$result = &$opnConfig['database']->SelectLimit ($query, $pagesize, $offset);
			while (!$result->EOF) {
				$topics[$result->fields['topic_id']] = $result->fields['topic_id'];
				$result->MoveNext ();
			}
			$result->Close ();
			$result = $topics;
		} else {
			$eh->show ('FORUM_0001');
			$maxrows = 0;
		}
	} else {
		$result = false;
	}
	return $result;

}

/**
* Get the unanswered posts
* @param $eh
* @param $pagesize
* @param $offset
* @param $maxrows
* @return object
*/

function &unansweredpost_search ($eh, $pagesize, $offset, &$maxrows) {

	global $opnConfig, $opnTables;

	$forumlist = get_forumlist_user_can_see ();
	if ($forumlist != '') {
		$query = 'SELECT t.topic_id AS topic_id FROM ' . $opnTables['forum'] . ' f,' . $opnTables['forum_topics'] . ' t,' . $opnTables['forum_posts'] . ' p';
		$query .= ' WHERE t.forum_id = f.forum_id';
		$query .= ' AND f.forum_id IN (' . $forumlist . ') AND p.topic_id=t.topic_id';
		$query .= ' GROUP BY t.topic_id, t.topic_time HAVING count(p.topic_id) = 1';
		$query .= ' ORDER BY t.topic_time DESC';
		$result = &$opnConfig['database']->Execute ($query);
		$topics = array ();
		if ( ($result !== false)) {
			$maxrows = $result->RecordCount ();
			$result = &$opnConfig['database']->SelectLimit ($query, $pagesize, $offset);
			while (!$result->EOF) {
				$topicid = $result->fields['topic_id'];
				$topics[$topicid] = $topicid;
				$result->MoveNext ();
			}
			$result->Close ();
			$result = $topics;
		} else {
			$eh->show ('FORUM_0001');
			$maxrows = 0;
		}
	} else {
		$result = false;
	}
	return $result;

}

function display_thread ($result, $maxrows, $pagesize, $page, $sortbysel, $sortorder, $term, $addterms, $forum, $username, $searchmode, &$boxtxt) {

	global $opnConfig, $opnTables;

	$table = & new opn_TableClass ('alternator');
	$table->AddCols (array ('25%', '35%', '20%', '15%', '5%') );
	$table->AddHeaderRow (array (_FORUM_FORUM, _FORUM_TOPIC, _FORUM_AUTHOR, _FORUM_POSTEDON, '&nbsp;') );

	foreach ($result as $value) {
		$last_posts = forum_get_last_post ($value, 'topic');
		$result1 = $opnConfig['database']->Execute ('SELECT forum_name FROM ' . $opnTables['forum'] . ' WHERE forum_id='. $last_posts[7]);
		$forum_name = $result1->fields['forum_name'];
		$result1 = $opnConfig['database']->Execute ('SELECT topic_title FROM ' . $opnTables['forum_topics'] . ' WHERE topic_id=' . $last_posts[3]);
		$topic_title = $result1->fields['topic_title'];
		if ($topic_title == '') {
			$topic_title = _FORUM_NO_TITLE;
		}
		$table->AddOpenRow ();
		$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewforum.php',
											'forum' => $last_posts[7]) ) . '">' . stripslashes ($forum_name) . '</a>',
											'center');
		$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php',
											'topic' => $last_posts[3],
											'forum' => $last_posts[7]) ) . '">' . stripslashes ($topic_title) . '</a>',
											'center');
		$table->AddDataCol ($last_posts[2], 'center');
		$table->AddDataCol ($last_posts[1], 'center');
		$topiclink = $opnConfig['opn_url'] . '/system/forum/viewtopic.php?topic=' . $last_posts[3] . '&forum=' . $last_posts[7] . '&viewlastpost=1#post_id' . $last_posts[8];
		$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl ($topiclink) . '"><img src="' . $opnConfig['opn_url'] . '/system/forum/images/last.gif" alt="' . _FORUM_LASTPOSTING_JUMP . '" title="' . _FORUM_LASTPOSTING_JUMP . '" width="15" height="15" class="imgtag" /></a>', 'center', '', 'middle');
		$table->AddCloseRow ();

	}
	$table->GetTable ($boxtxt);
	if (count ($result)>0) {
		include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
		$boxtxt .= build_pagebar (array ($opnConfig['opn_url'] . '/system/forum/searchbb.php',
						'sortbysel' => $sortbysel,
						'sortorder' => $sortorder,
						'term' => $term,
						'addterms' => $addterms,
						'forum' => $forum,
						'username' => $username,
						'searchmode' => $searchmode),
						$maxrows,
						$pagesize,
						$page);
	}
}
?>