<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig, $opnTables;

$opnConfig['permission']->HasRights ('system/forum', array (_PERM_READ, _PERM_BOT) );
$opnConfig['module']->InitModule ('system/forum');
$opnConfig['opnOutput']->setMetaPageName ('system/forum');
getLanguageDef (_OPN_ROOT_PATH . 'system/forum/language/');
include_once (_OPN_ROOT_PATH . 'api/user_name.php');
include (_OPN_ROOT_PATH . 'system/forum/functions.php');
$opnConfig['forumlist'] = get_forumlist_user_can_see ();

function mk_percbar_stats ($myperc, $tbheight = 10, $tbwidth = '100%') {

	$rmyperc = round ($myperc, 0);
	$boxtxt = '<table  width="' . $tbwidth . '" style="height:' . $tbheight . 'px" border="0" cellspacing="0" cellpadding="0">' . _OPN_HTML_NL;
	if ($myperc >= 100) {
		$boxtxt .= '<tr class="%alternate%"><td width="100%" class="%alternate%bg">';
	} elseif ($myperc<=0) {
		$boxtxt .= '<tr><td width="100%" class="bigtextbold">&nbsp;';
	} else {
		$boxtxt .= '<tr class="%alternate"><td width="' . $rmyperc . '%" class="%alternate%bg">' . '</td><td width="' . (100- $rmyperc) . '%">';
	}
	$boxtxt .= '</td></tr></table>';
	return $boxtxt;

}

function get_order_by (&$sql, $field, $function = 'count') {

	global $opnConfig;
	switch ($opnConfig['dbdriver']) {
		case 'ibase':
		case 'firebird':
		case 'borland_ibase':
			$sql .= ' ORDER BY ' . $function . '(' . $field . ') DESC';
			break;
		default:
			$sql .= ' ORDER BY counter DESC';
			break;
	}
	// switch

}

function get_top_poster (&$stats) {

	global $opnConfig, $opnTables;
	if ($opnConfig['forumlist'] != '') {
		$sql = 'SELECT poster_id, count(poster_id) AS counter FROM ' . $opnTables['forum_posts'] . ' WHERE forum_id IN (' . $opnConfig['forumlist'] . ') AND poster_id<>' . $opnConfig['opn_anonymous_id'] . ' GROUP BY poster_id';
		get_order_by ($sql, 'poster_id');
		$result = &$opnConfig['database']->SelectLimit ($sql, $opnConfig['top']);
		$fields = array ();
		$stats['top_posters'] = array ();
		if ($result !== false) {
			while (! $result->EOF) {
				if (!isset ($result->fields['counter']) ) {
					$result->fields['counter'] = 0;
				}
				$fields[] = $result->GetRowAssoc ('0');
				$result->MoveNext ();
			}
			$result->Close ();
		}
		$max_posts = 0;
		foreach ($fields as $field) {
			$result2 = &$opnConfig['database']->SelectLimit ('SELECT uname FROM ' . $opnTables['users'] . ' WHERE uid = ' . $field['poster_id'], 1);
			$myrow2 = $result2->GetRowAssoc ('0');
			$stats['top_posters'][] = array ('counter' => $field['counter'],
							'link' => '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
											'op' => 'userinfo',
											'uname' => $myrow2['uname']) ) . '">' . api_user_name ($myrow2['uname']) . '</a>');
			$result2->Close ();
			$max_posts += $field['counter'];
		}
		foreach ($stats['top_posters'] as $i => $poster) {
			$stats['top_posters'][$i]['post_percent'] = round ( ($poster['counter']*100)/ $max_posts);
		}
	}

}

function SortCatArray ($a, $b) {
	if ($a['counter'] == $b['counter']) {
		return 0;
	}
	return ($a['counter']> $b['counter'])?-1 : 1;

}

function get_top_cat (&$stats) {

	global $opnConfig, $opnTables;
	if ($opnConfig['forumlist'] != '') {
		$sql = 'SELECT forum_id, cat_id FROM ' . $opnTables['forum'] . ' WHERE forum_id IN (' . $opnConfig['forumlist'] . ') ORDER BY forum_id';
		$result = &$opnConfig['database']->Execute ($sql);
		$fields = array ();
		$stats['top_cat'] = array ();
		if ($result !== false) {
			while (! $result->EOF) {
				$fields[] = $result->GetRowAssoc ('0');
				$result->MoveNext ();
			}
			$result->Close ();
		}
		$fields1 = array ();
		foreach ($fields as $field) {
			$sql = 'SELECT count(topic_id) as counter FROM ' . $opnTables['forum_topics'] . ' WHERE forum_id=' . $field['forum_id'];
			$result = $opnConfig['database']->Execute ($sql);
			$total = 0;
			if ($result !== false) {
				while (! $result->EOF) {
					if (!isset ($result->fields['counter']) ) {
						$result->fields['counter'] = 0;
					}
					$total = $result->fields['counter'];
					$result->MoveNext ();
				}
				$result->Close ();
			}
			if (isset ($fields1[$field['cat_id']]['counter']) ) {
				$fields1[$field['cat_id']]['counter'] += $total;
			} else {
				$field1 = array ();
				$field1['cat_id'] = $field['cat_id'];
				$field1['counter'] = $total;
				$fields1[$field['cat_id']] = $field1;
			}
		}
		usort ($fields1, 'SortCatArray');
		$fields = $fields1;
		$fields1 = array ();
		$i = 0;
		foreach ($fields as $field) {
			if ($i<$opnConfig['top']) {
				$fields1[] = $field;
				$i++;
			}
		}
		$max_posts = 0;
		foreach ($fields as $field) {
			$result2 = &$opnConfig['database']->SelectLimit ('SELECT cat_title FROM ' . $opnTables['forum_cat'] . ' WHERE cat_id = ' . $field['cat_id'], 1);
			$myrow2 = $result2->GetRowAssoc ('0');
			$title = $myrow2['cat_title'];
			$opnConfig['cleantext']->opn_shortentext ($title, 40);
			$stats['top_cat'][] = array ('counter' => $field['counter'],
						'link' => '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/index.php',
											'cat' => $field['cat_id']) ) . '">' . $title . '</a>');
			$result2->Close ();
			$max_posts += $field['counter'];
		}
		foreach ($stats['top_cat'] as $i => $poster) {
			if ($max_posts>0) {
				$stats['top_cat'][$i]['post_percent'] = round ( ($poster['counter']*100)/ $max_posts);
			} else {
				$stats['top_cat'][$i]['post_percent'] = 0;
			}
		}
	}

}

function get_top_forum (&$stats) {

	global $opnConfig, $opnTables;
	if ($opnConfig['forumlist'] != '') {
		$sql = 'SELECT forum_id, count(forum_id) AS counter FROM ' . $opnTables['forum_posts'] . ' WHERE forum_id IN (' . $opnConfig['forumlist'] . ') GROUP BY forum_id';
		get_order_by ($sql, 'forum_id');
		$result = &$opnConfig['database']->SelectLimit ($sql, $opnConfig['top']);
		$fields = array ();
		$stats['top_forum'] = array ();
		if ($result !== false) {
			while (! $result->EOF) {
				if (!isset ($result->fields['counter']) ) {
					$result->fields['counter'] = 0;
				}
				$fields[] = $result->GetRowAssoc ('0');
				$result->MoveNext ();
			}
			$result->Close ();
		}
		$max_posts = 0;
		foreach ($fields as $field) {
			$result2 = &$opnConfig['database']->SelectLimit ('SELECT forum_name FROM ' . $opnTables['forum'] . ' WHERE forum_id = ' . $field['forum_id'], 1);
			$myrow2 = $result2->GetRowAssoc ('0');
			$title = $myrow2['forum_name'];
			$opnConfig['cleantext']->opn_shortentext ($title, 40);
			$stats['top_forum'][] = array ('counter' => $field['counter'],
							'link' => '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewforum.php',
											'forum' => $field['forum_id']) ) . '">' . $title . '</a>');
			$result2->Close ();
			$max_posts += $field['counter'];
		}
		foreach ($stats['top_forum'] as $i => $poster) {
			$stats['top_forum'][$i]['post_percent'] = round ( ($poster['counter']*100)/ $max_posts);
		}
	}

}

function get_top_topic_starter (&$stats) {

	global $opnConfig, $opnTables;
	if ($opnConfig['forumlist'] != '') {
		$sql = 'SELECT topic_poster, count(topic_poster) AS counter FROM ' . $opnTables['forum_topics'] . ' WHERE forum_id IN (' . $opnConfig['forumlist'] . ') AND topic_poster<>' . $opnConfig['opn_anonymous_id'] . ' GROUP BY topic_poster';
		get_order_by ($sql, 'topic_poster');
		$result = &$opnConfig['database']->SelectLimit ($sql, $opnConfig['top']);
		$fields = array ();
		$stats['top_starter'] = array ();
		if ($result !== false) {
			while (! $result->EOF) {
				if (!isset ($result->fields['counter']) ) {
					$result->fields['counter'] = 0;
				}
				$fields[] = $result->GetRowAssoc ('0');
				$result->MoveNext ();
			}
			$result->Close ();
		}
		$max_posts = 0;
		foreach ($fields as $field) {
			$result2 = &$opnConfig['database']->SelectLimit ('SELECT uname FROM ' . $opnTables['users'] . ' WHERE uid = ' . $field['topic_poster'], 1);
			$myrow2 = $result2->GetRowAssoc ('0');
			$stats['top_starter'][] = array ('counter' => $field['counter'],
							'link' => '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
											'op' => 'userinfo',
											'uname' => $myrow2['uname']) ) . '">' . api_user_name ($myrow2['uname']) . '</a>');
			$result2->Close ();
			$max_posts += $field['counter'];
		}
		foreach ($stats['top_starter'] as $i => $poster) {
			$stats['top_starter'][$i]['post_percent'] = round ( ($poster['counter']*100)/ $max_posts);
		}
	}

}

function get_top_topic_by_replies (&$stats) {

	global $opnConfig, $opnTables;
	if ($opnConfig['forumlist'] != '') {
		$sql = 'SELECT topic_id, count(topic_id) AS counter FROM ' . $opnTables['forum_posts'] . ' WHERE forum_id IN (' . $opnConfig['forumlist'] . ') GROUP BY topic_id';
		get_order_by ($sql, 'topic_id');
		$result = &$opnConfig['database']->SelectLimit ($sql, $opnConfig['top']);
		$fields = array ();
		$stats['top_topics_replies'] = array ();
		if ($result !== false) {
			while (! $result->EOF) {
				if (!isset ($result->fields['counter']) ) {
					$result->fields['counter'] = 0;
				}
				$fields[] = $result->GetRowAssoc ('0');
				$result->MoveNext ();
			}
			$result->Close ();
		}
		$max_posts = 0;
		foreach ($fields as $field) {
			$counter = $field['counter']-1;
			$result2 = &$opnConfig['database']->SelectLimit ('SELECT topic_title, forum_id FROM ' . $opnTables['forum_topics'] . ' WHERE topic_id = ' . $field['topic_id'], 1);
			$myrow2 = $result2->GetRowAssoc ('0');
			$title = $myrow2['topic_title'];
			$opnConfig['cleantext']->opn_shortentext ($title, 40);
			$stats['top_topics_replies'][] = array ('counter' => $counter,
								'link' => '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php',
											'topic' => $field['topic_id'],
											'forum' => $myrow2['forum_id']) ) . '">' . $title . '</a>');
			$result2->Close ();
			$max_posts += $field['counter'];
		}
		foreach ($stats['top_topics_replies'] as $i => $poster) {
			$stats['top_topics_replies'][$i]['post_percent'] = round ( ($poster['counter']*100)/ $max_posts);
		}
	}

}

function get_top_topic_by_views (&$stats) {

	global $opnConfig, $opnTables;
	if ($opnConfig['forumlist'] != '') {
		$sql = 'SELECT topic_id, sum(topic_views) AS counter FROM ' . $opnTables['forum_topics'] . ' WHERE forum_id IN (' . $opnConfig['forumlist'] . ') GROUP BY topic_id';
		get_order_by ($sql, 'topic_views', 'sum');
		$result = &$opnConfig['database']->SelectLimit ($sql, $opnConfig['top']);
		$fields = array ();
		$stats['top_topics_views'] = array ();
		if ($result !== false) {
			while (! $result->EOF) {
				if (!isset ($result->fields['counter']) ) {
					$result->fields['counter'] = 0;
				}
				$fields[] = $result->GetRowAssoc ('0');
				$result->MoveNext ();
			}
			$result->Close ();
		}
		$max_posts = 0;
		foreach ($fields as $field) {
			$result2 = &$opnConfig['database']->SelectLimit ('SELECT topic_title, forum_id FROM ' . $opnTables['forum_topics'] . ' WHERE topic_id = ' . $field['topic_id'], 1);
			$myrow2 = $result2->GetRowAssoc ('0');
			$title = $myrow2['topic_title'];
			$opnConfig['cleantext']->opn_shortentext ($title, 40);
			$stats['top_topics_views'][] = array ('counter' => $field['counter'],
								'link' => '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php',
											'topic' => $field['topic_id'],
											'forum' => $myrow2['forum_id']) ) . '">' . $title . '</a>');
			$result2->Close ();
			$max_posts += $field['counter'];
		}
		foreach ($stats['top_topics_views'] as $i => $poster) {
			$stats['top_topics_views'][$i]['post_percent'] = round ( ($poster['counter']*100)/ $max_posts);
		}
	}

}

function get_averages (&$stats) {

	global $opnConfig, $opnTables;

	$total = 0;
	if ($opnConfig['forumlist'] != '') {
		$sql = 'SELECT MIN(post_time) as counter FROM ' . $opnTables['forum_posts'] . ' WHERE forum_id IN (' . $opnConfig['forumlist'] . ')';
		$result = $opnConfig['database']->Execute ($sql);
		if ($result !== false) {
			if (!isset ($result->fields['counter']) ) {
				$result->fields['counter'] = 0;
			}
			$total = $result->fields['counter'];
			$result->Close ();
		}
	}
	$opnConfig['opndate']->sqlToopnData ($total);
	$ret = '';
	$opnConfig['opndate']->formatTimestamp ($ret, '%Y-%m-%d');
	$total_days_up = ceil ( (time ()-strtotime ($ret) )/ (86400) );
	$total = 0;
	if ($opnConfig['forumlist'] != '') {
		$sql = 'SELECT count(post_id) as counter FROM ' . $opnTables['forum_posts'] . ' WHERE forum_id IN (' . $opnConfig['forumlist'] . ')';
		$result = $opnConfig['database']->Execute ($sql);
		if ($result !== false) {
			if (!isset ($result->fields['counter']) ) {
				$result->fields['counter'] = 0;
			}
			$total = $result->fields['counter'];
			$result->Close ();
		}
	}
	$stats['num_posts'] = $total;
	$stats['average_posts'] = round ($total/ $total_days_up, 2);
	$total = 0;
	if ($opnConfig['forumlist'] != '') {
		$sql = 'SELECT count(topic_id) as counter FROM ' . $opnTables['forum_topics'] . ' WHERE forum_id IN (' . $opnConfig['forumlist'] . ')';
		$result = $opnConfig['database']->Execute ($sql);
		if ($result !== false) {
			if (!isset ($result->fields['counter']) ) {
				$result->fields['counter'] = 0;
			}
			$total = $result->fields['counter'];
			$result->Close ();
		}
	}
	$stats['num_topics'] = $total;
	$stats['average_topics'] = round ($total/ $total_days_up, 2);
	$total = 0;
	if ($opnConfig['forumlist'] != '') {
		$sql = 'SELECT count(forum_id) as counter FROM ' . $opnTables['forum'] . ' WHERE forum_id IN (' . $opnConfig['forumlist'] . ')';
		$result = $opnConfig['database']->Execute ($sql);
		if ($result !== false) {
			if (!isset ($result->fields['counter']) ) {
				$result->fields['counter'] = 0;
			}
			$total = $result->fields['counter'];
			$result->Close ();
		}
	}
	$stats['num_forum'] = $total;
	$sql = 'SELECT count(cat_id) as counter FROM ' . $opnTables['forum_cat'];
	$result = $opnConfig['database']->Execute ($sql);
	if ($result !== false) {
		if (!isset ($result->fields['counter']) ) {
			$result->fields['counter'] = 0;
		}
		$total = $result->fields['counter'];
		$result->Close ();
	} else {
		$total = 0;
	}
	$stats['num_cat'] = $total;

}
$stats = array ();
get_averages ($stats);
get_top_forum ($stats);
get_top_cat ($stats);
get_top_poster ($stats);
get_top_topic_by_replies ($stats);
get_top_topic_by_views ($stats);
get_top_topic_starter ($stats);
$table = & new opn_TableClass ('default');
$table->AddCols (array ('50%', '50%') );
// Build the avarage stats
$table1 = & new opn_TableClass ('alternator');
$table1->AddCols (array ('50%', '50%') );
$table1->AddOpenHeadRow ();
$table1->AddHeaderCol (_FORUM_STATS_ALLG, '', '2');
$table1->AddCloseRow ();
$table2 = & new opn_TableClass ('alternator');
$table2->AddCols (array ('80%', '20%') );
$table2->AddDataRow (array (_FORUM_STATS_POSTS, $stats['num_posts']), array ('left', 'right') );
$table2->AddDataRow (array (_FORUM_STATS_TOPICS, $stats['num_topics']), array ('left', 'right') );
$table2->AddDataRow (array (_FORUM_STATS_CATS, $stats['num_cat']), array ('left', 'right') );
$hlp = '';
$table2->GetTable ($hlp);
$table2 = & new opn_TableClass ('alternator');
$table2->AddCols (array ('80%', '20%') );
$table2->AddDataRow (array (_FORUM_STATS_AVA_POSTS, $stats['average_posts']), array ('left', 'right') );
$table2->AddDataRow (array (_FORUM_STATS_AVA_TOPICS, $stats['average_topics']), array ('left', 'right') );
$table2->AddDataRow (array (_FORUM_STATS_FORUM, $stats['num_forum']), array ('left', 'right') );
$hlp1 = '';
$table2->GetTable ($hlp1);
$table1->AddDataRow (array ($hlp, $hlp1) );
$hlp = '';
$table1->GetTable ($hlp);
$table->AddOpenRow ();
$table->AddDataCol ($hlp, '', '2');
$table->AddCloseRow ();
// build the top poster
$table1 = & new opn_TableClass ('alternator');
$table1->AddCols (array ('60%', '20%', '20%') );
$table1->AddOpenHeadRow ();
$table1->AddHeaderCol (sprintf (_FORUM_STATS_TOP_POSTER, $opnConfig['top']), '', '3');
$table1->AddCloseRow ();
$counter = 0;
foreach ($stats['top_posters'] as $value) {
	$table1->AddDataRow (array ($value['link'], mk_percbar_stats ($value['post_percent']), $value['counter']), array ('left', 'left', 'right') );
	$counter++;
}
// for ($i=0; $i < $opnConfig['top']; $i++) {
// $table1->AddDataRow(array('&nbsp;','&nbsp;'));
// }
$hlp = '';
$table1->GetTable ($hlp);
// build the top topic starter
$table1 = & new opn_TableClass ('alternator');
$table1->AddCols (array ('60%', '20%', '20%') );
$table1->AddOpenHeadRow ();
$table1->AddHeaderCol (sprintf (_FORUM_STATS_TOP_STARTER, $opnConfig['top']), '', '3');
$table1->AddCloseRow ();
$counter = 0;
foreach ($stats['top_starter'] as $value) {
	$table1->AddDataRow (array ($value['link'], mk_percbar_stats ($value['post_percent']), $value['counter']), array ('left', 'left', 'right') );
	$counter++;
}
// for ($i=0; $i < $opnConfig['top']; $i++) {
// $table1->AddDataRow(array('&nbsp;','&nbsp;'));
// }
$hlp1 = '';
$table1->GetTable ($hlp1);
$table->AddOpenRow ();
$table->AddDataCol ('&nbsp;', '', '2');
$table->AddChangeRow ();
$table->AddDataCol ($hlp, '', '', 'top');
$table->AddDataCol ($hlp1, '', '', 'top');
$table->AddCloseRow ();
// build the top topic by replies
$table1 = & new opn_TableClass ('alternator');
$table1->AddCols (array ('60%', '20%', '20%') );
$table1->AddOpenHeadRow ();
$table1->AddHeaderCol (sprintf (_FORUM_STATS_TOP_TOPICS_REPLIES, $opnConfig['top']), '', '3');
$table1->AddCloseRow ();
$counter = 0;
foreach ($stats['top_topics_replies'] as $value) {
	$table1->AddDataRow (array ($value['link'], mk_percbar_stats ($value['post_percent']), $value['counter']), array ('left', 'left', 'right') );
	$counter++;
}
// for ($i=0; $i < $opnConfig['top']; $i++) {
// $table1->AddDataRow(array('&nbsp;','&nbsp;'));
// }
$hlp = '';
$table1->GetTable ($hlp);
// build the top topic by views
$table1 = & new opn_TableClass ('alternator');
$table1->AddCols (array ('60%', '20%', '20%') );
$table1->AddOpenHeadRow ();
$table1->AddHeaderCol (sprintf (_FORUM_STATS_TOP_TOPIC_VIEWS, $opnConfig['top']), '', '3');
$table1->AddCloseRow ();
$counter = 0;
foreach ($stats['top_topics_views'] as $value) {
	$table1->AddDataRow (array ($value['link'], mk_percbar_stats ($value['post_percent']), $value['counter']), array ('left', 'left', 'right') );
	$counter++;
}
$hlp1 = '';
$table1->GetTable ($hlp1);
$table->AddOpenRow ();
$table->AddDataCol ('&nbsp;', '', '2');
$table->AddChangeRow ();
$table->AddDataCol ($hlp, '', '', 'top');
$table->AddDataCol ($hlp1, '', '', 'top');
$table->AddCloseRow ();
// build top forum
$table1 = & new opn_TableClass ('alternator');
$table1->AddCols (array ('60%', '20%', '20%') );
$table1->AddOpenHeadRow ();
$table1->AddHeaderCol (sprintf (_FORUM_STATS_TOP_FORUM, $opnConfig['top']), '', '3');
$table1->AddCloseRow ();
$counter = 0;
if (is_array ($stats['top_forum']) ) {
	foreach ($stats['top_forum'] as $value) {
		$table1->AddDataRow (array ($value['link'], mk_percbar_stats ($value['post_percent']), $value['counter']), array ('left', 'left', 'right') );
		$counter++;
	}
}
$hlp = '';
$table1->GetTable ($hlp);
// build top cats
$table1 = & new opn_TableClass ('alternator');
$table1->AddCols (array ('60%', '20%', '20%') );
$table1->AddOpenHeadRow ();
$table1->AddHeaderCol (sprintf (_FORUM_STATS_TOP_CAT, $opnConfig['top']), '', '3');
$table1->AddCloseRow ();
$counter = 0;
if (is_array ($stats['top_cat']) ) {
	foreach ($stats['top_cat'] as $value) {
		$table1->AddDataRow (array ($value['link'], mk_percbar_stats ($value['post_percent']), $value['counter']), array ('left', 'left', 'right') );
		$counter++;
	}
}
$hlp1 = '';
$table1->GetTable ($hlp1);
$table->AddOpenRow ();
$table->AddDataCol ('&nbsp;', '', '2');
$table->AddChangeRow ();
$table->AddDataCol ($hlp, '', '', 'top');
$table->AddDataCol ($hlp1, '', '', 'top');
$table->AddCloseRow ();
$boxtxt = '';
$table->GetTable ($boxtxt);
$boxtxt .= '<br />' . _FORUM_BACKTOFORUM;
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_FORUM_680_';
$_display_dat['module'] = 'system/forum';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayContent (_FORUM_STATS, $boxtxt);

?>