<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
getLanguageDef (_OPN_ROOT_PATH . 'system/mailingclient/admin/language/');

function MailingClientConfigHeader () {

	global $opnTables, $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_MACLI_ADMIN_TITLE);
	$menu->InsertEntry (_MACLI_ADMIN_MAIN, $opnConfig['opn_url'] . '/system/mailingclient/admin/index.php');
	$menu->InsertEntry (_MACLI_ADMIN_MAIN_BOT, array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
							'op' => 'listBotClient') );
	$result = $opnConfig['database']->Execute ('SELECT COUNT(id) AS counter FROM ' . $opnTables['mailingclient_new']);
	if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
		$num = $result->fields['counter'];
		$result->Close ();
		if ($num>0) {
			$menu->InsertEntry (sprintf (_MACLI_ADMIN_NEWINFOS, $num), array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
											'op' => 'newmailingclient') );
		}
	}
	unset ($result);
	$menu->InsertEntry (_MACLI_ADMIN_MAIN_SETTINGS, $opnConfig['opn_url'] . '/system/mailingclient/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function listMailingClient () {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$sortby = 'asc_id';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	$url = array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php');
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sql = 'SELECT COUNT(id) AS counter FROM ' . $opnTables['mailingclient'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( ($justforcounting !== false) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	MailingClientConfigHeader ();
	$table = & new opn_TableClass ('alternator');
	$newsortby = $sortby;
	$order = '';
	$table->get_sort_order ($order, array ('subject',
						'body',
						'bot_id',
						'id'),
						$newsortby);
	$table->AddHeaderRow (array ($table->get_sort_feld ('id', _MACLI_ADMIN_ID, $url), $table->get_sort_feld ('subject', _MACLI_ADMIN_SUBJECT, $url), $table->get_sort_feld ('body', _MACLI_ADMIN_BODY, $url), $table->get_sort_feld ('bot_id', _MACLI_ADMIN_BOT_ID, $url), _MACLI_ADMIN_FUNCTIONS) );
	$info = &$opnConfig['database']->SelectLimit ('SELECT id, subject, body, bot_id FROM ' . $opnTables['mailingclient'] . ' ' . $order, $maxperpage, $offset);
	while (! $info->EOF) {
		$id = $info->fields['id'];
		$subject = $info->fields['subject'];
		$body = $info->fields['body'];
		$bot_id = $info->fields['bot_id'];
		$table->AddOpenRow ();
		$table->AddDataCol ($id);
		$table->AddDataCol ($subject);
		$table->AddDataCol ($body);
		$table->AddDataCol ($bot_id);
		$table->AddDataCol ($opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
											'op' => 'editinfo',
											'id' => $id) ) . ' ' . $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
																											'op' => 'deleteinfo',
																											'id' => $id,
																											'ok' => '0') ));
		$table->AddCloseRow ();
		$info->MoveNext ();
	}
	// while
	$text = '';
	$table->GetTable ($text);
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
					'sortby' => $sortby),
					$reccount,
					$maxperpage,
					$offset);
	$text .= '<br /><br />' . $pagebar . '<br /><br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_MAILINGCLIENT_10_';
	$_display_dat['module'] = 'system/mailingclient';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_MACLI_ADMIN_TITLE, $text);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function listNewMailingClient () {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$sortby = 'asc_bot_id';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	$url = 'system/mailingclient/admin/index.php?';
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sql = 'SELECT COUNT(id) AS counter FROM ' . $opnTables['mailingclient_new'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( ($justforcounting !== false) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	MailingClientConfigHeader ();
	$menu = & new OPN_Adminmenu (_MACLI_ADMIN_NEWTITLE);
	$menu->InsertEntry (_MACLI_ADMIN_ADDALLNEW, $opnConfig['opn_url'] . '/system/mailingclient/admin/index.php?op=addallnew');
	$menu->InsertEntry (_MACLI_ADMIN_IGNOREALLNEW, $opnConfig['opn_url'] . '/system/mailingclient/admin/index.php?op=ignoreallnew');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);
	$table = & new opn_TableClass ('alternator');
	$newsortby = $sortby;
	$order = '';
	$table->get_sort_order ($order, array ('subject',
						'body',
						'bot_id'),
						$newsortby);
	$table->AddHeaderRow (array ($table->get_sort_feld ('subject', _MACLI_ADMIN_SUBJECT, $url), $table->get_sort_feld ('body', _MACLI_ADMIN_BODY, $url), $table->get_sort_feld ('bot_id', _MACLI_ADMIN_BOT_ID, $url), _MACLI_ADMIN_FUNCTIONS) );
	$info = &$opnConfig['database']->SelectLimit ('SELECT id, subject, body, bot_id FROM ' . $opnTables['mailingclient_new'] . ' ' . $order, $maxperpage, $offset);
	while (! $info->EOF) {
		$id = $info->fields['id'];
		$subject = $info->fields['subject'];
		$body = $info->fields['body'];
		$bot_id = $info->fields['bot_id'];
		$table->AddOpenRow ();
		$table->AddDataCol ($subject);
		$table->AddDataCol ($body);
		$table->AddDataCol ($bot_id);
		$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
											'op' => 'editinfo',
											'dbnew' => '1',
											'id' => $id) ) . '">' . _MACLI_ADMIN_ADDNEW . '</a> | ' . '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
																'op' => 'ignoresinglenew',
																'id' => $id,
																'ok' => '0') ) . '">' . _MACLI_ADMIN_IGNORENEW . '</a>');
		$table->AddCloseRow ();
		$info->MoveNext ();
	}
	// while
	$text = '';
	$table->GetTable ($text);
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
					'op' => 'newmailingclient',
					'sortby' => $sortby),
					$reccount,
					$maxperpage,
					$offset);
	$text .= '<br /><br />' . $pagebar;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_MAILINGCLIENT_20_';
	$_display_dat['module'] = 'system/mailingclient';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_MACLI_ADMIN_NEWTITLE, $text);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function listBotClient () {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sql = 'SELECT COUNT(id) AS counter FROM ' . $opnTables['mailingclient_bot'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( ($justforcounting !== false) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$info = &$opnConfig['database']->SelectLimit ('SELECT id, botname, botsearch FROM ' . $opnTables['mailingclient_bot'] . ' ORDER BY id', $maxperpage, $offset);
	if (!isset ($offset) ) {
		$offset = 0;
	}
	MailingClientConfigHeader ();
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_MACLI_ADMIN_BOT_ID, _MACLI_ADMIN_BOT_NAME, _MACLI_ADMIN_BOT_SEARCH, _MACLI_ADMIN_FUNCTIONS) );
	while (! $info->EOF) {
		$id = $info->fields['id'];
		$botname = $info->fields['botname'];
		$botsearch = $info->fields['botsearch'];
		$table->AddOpenRow ();
		$table->AddDataCol ($id);
		$table->AddDataCol ($botname);
		$table->AddDataCol ($botsearch);
		$table->AddDataCol ($opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
											'op' => 'editbot',
											'id' => $id) ) . ' ' . $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
																											'op' => 'deletebot',
																											'id' => $id,
																											'ok' => '0') ));
		$table->AddCloseRow ();
		$info->MoveNext ();
	}
	// while
	$text = '';
	$table->GetTable ($text);
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php'),
					$reccount,
					$maxperpage,
					$offset);
	$text .= '<br /><br />' . $pagebar . '<br /><br />';
	$text .= '<span class="normaltextbold">' . _MACLI_ADMIN_ADDBOT . '</span><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_MAILINGCLIENT_30_', 'system/mailingclient');
	$form->UseEditor (false);
	$form->UseWysiwyg (false);
	$form->Init ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('botname', _MACLI_ADMIN_BOT_NAME);
	$form->AddTextfield ('botname', 20, 20);
	$form->AddChangeRow ();
	$form->AddLabel ('botsearch', _MACLI_ADMIN_BOT_SEARCH);
	$form->AddTextfield ('botsearch', 60, 60);
	$form->AddChangeRow ();
	$form->AddLabel ('delinsubject', _MACLI_ADMIN_DELTHISPLEASE_IN_SUBJECT . ':');
	$form->AddTextarea ('delinsubject');
	$form->AddChangeRow ();
	$form->AddLabel ('delinsubjecta', _MACLI_ADMIN_DELTHISPLEASE_IN_SUBJECT_A . ':');
	$form->AddTextarea ('delinsubjecta');
	$form->AddChangeRow ();
	$form->AddLabel ('delinsubjectb', _MACLI_ADMIN_DELTHISPLEASE_IN_SUBJECT_B . ':');
	$form->AddTextarea ('delinsubjectb');
	$form->AddChangeRow ();
	$form->AddLabel ('delinbody', _MACLI_ADMIN_DELTHISPLEASE_IN_BODY . ':');
	$form->AddTextarea ('delinbody');
	$form->AddChangeRow ();
	$form->AddLabel ('delinbodya', _MACLI_ADMIN_DELTHISPLEASE_IN_BODY_A . ':');
	$form->AddTextarea ('delinbodya');
	$form->AddChangeRow ();
	$form->AddLabel ('delinbodyb', _MACLI_ADMIN_DELTHISPLEASE_IN_BODY_B . ':');
	$form->AddTextarea ('delinbodyb');
	$form->AddChangeRow ();
	$form->AddLabel ('searchin', _MACLI_ADMIN_SEARCH_IN);
	$form->SetSameCol ();
	$form->AddRadio ('searchin', 1, true);
	$form->AddText (' ' . _MACLI_ADMIN_SEARCH_IN_SUBJECT . ' ');
	$form->AddRadio ('searchin', 0);
	$form->AddText (' ' . _MACLI_ADMIN_SEARCH_IN_BODY);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('delbotsearch', _MACLI_ADMIN_DELBOTSEARCH);
	$form->SetSameCol ();
	$form->AddRadio ('delbotsearch', 1, true);
	$form->AddText (' ' . _YES . ' ');
	$form->AddRadio ('delbotsearch', 0);
	$form->AddText (' ' . _NO);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'addbot');
	$form->AddSubmit ('submit', _MACLI_ADMIN_ADD);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($text);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_MAILINGCLIENT_40_';
	$_display_dat['module'] = 'system/mailingclient';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_MACLI_ADMIN_TITLE, $text);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function mailingclient_addallnew () {

	global $opnConfig, $opnTables;

	$result = $opnConfig['database']->Execute ('SELECT subject,body,maildate,bot_id FROM ' . $opnTables['mailingclient_new']);
	while (! $result->EOF) {
		$subject = $opnConfig['opnSQL']->qstr ($result->fields['subject'], 'subject');
		$body = $opnConfig['opnSQL']->qstr ($result->fields['body'], 'body');
		$maildate = $opnConfig['opnSQL']->qstr ($result->fields['maildate'], 'maildate');
		$bot_id = $result->fields['bot_id'];
		$id = $opnConfig['opnSQL']->get_new_number ('mailingclient', 'id');
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['mailingclient'] . " VALUES ($id,$subject,$body,$maildate,$bot_id)");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['mailingclient'], 'id=' . $id);
		$result->MoveNext ();
	}
	// while
	$result->Close ();
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mailingclient_new']);
	$opnConfig['opnOutput']->Redirect ('/system/mailingclient/admin/index.php');

}

function addsinglenewtodb () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$subject = '';
	get_var ('subject', $subject, 'url', _OOBJ_DTYPE_CLEAN);
	$body = '';
	get_var ('body', $body, 'url', _OOBJ_DTYPE_CLEAN);
	$maildate = '';
	get_var ('maildate', $maildate, 'url', _OOBJ_DTYPE_CLEAN);
	$bot_id = 0;
	get_var ('bot_id', $bot_id, 'url', _OOBJ_DTYPE_INT);
	opn_nl2br ($subject);
	opn_nl2br ($body);
	opn_nl2br ($maildate);
	$subject = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($subject, true, true, 'nothml'), 'subject');
	$body = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($body, true, true, 'recodehtml'), 'body');
	$maildate = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($maildate, true, true, 'nothml'), 'maildate');
	$id1 = $opnConfig['opnSQL']->get_new_number ('mailingclient', 'id');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['mailingclient'] . " VALUES ($id1,$subject,$body,$maildate,$bot_id)");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['mailingclient'], 'id=' . $id);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mailingclient_new'] . ' WHERE id=' . $id);
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php?op=newmailingclient', false) );

}

function mailingclient_ignoreallnew () {

	global $opnConfig, $opnTables;

	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mailingclient_new']);
		$opnConfig['opnOutput']->Redirect ('/system/mailingclient/admin/index.php');
	} else {
		MailingClientConfigHeader ();
		$text = '<div class="bigtextbold" align="center">';
		$text .= '<span class="alerttextcolor">' . _MACLI_ADMIN_IGNOREALL . '</span><br />';
		$text .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
										'op' => 'ignoreallnew',
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php?op=newmailingclient') . '">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_MAILINGCLIENT_50_';
		$_display_dat['module'] = 'system/mailingclient';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_MACLI_ADMIN_TITLE, $text);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function mailingclient_ignoresinglenew () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mailingclient_new'] . ' WHERE id=' . $id);
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php?op=newmailingclient', false) );
	} else {
		MailingClientConfigHeader ();
		$text = '<div class="bigtextbold" align="center">';
		$text .= '<span class="alerttextcolor">' . _MACLI_ADMIN_IGNORESINGLE . '</span><br />';
		$text .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
										'op' => 'ignoresinglenew',
										'id' => $id,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php?op=newmailingclient') . '">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_MAILINGCLIENT_60_';
		$_display_dat['module'] = 'system/mailingclient';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_MACLI_ADMIN_TITLE, $text);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function deleteinfo () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mailingclient'] . ' WHERE id=' . $id);
		$opnConfig['opnOutput']->Redirect ('/system/mailingclient/admin/index.php');
	} else {
		MailingClientConfigHeader ();
		$text = '<div class="bigtextbold" align="center">';
		$text .= '<span class="alerttextcolor">' . _MACLI_ADMIN_DELETEINFO . '</span><br />';
		$text .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
										'op' => 'deleteinfo',
										'id' => $id,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/mailingclient/admin/index.php">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_MAILINGCLIENT_70_';
		$_display_dat['module'] = 'system/mailingclient';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_MACLI_ADMIN_TITLE, $text);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function deletebot () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mailingclient_bot'] . ' WHERE id=' . $id);
		$opnConfig['opnOutput']->Redirect ('/system/mailingclient/admin/index.php');
	} else {
		MailingClientConfigHeader ();
		$text = '<div class="bigtextbold" align="center">';
		$text .= '<span class="alerttextcolor">' . _MACLI_ADMIN_DELETEINFO . '</span><br />';
		$text .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php',
										'op' => 'deletebot',
										'id' => $id,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/mailingclient/admin/index.php">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_MAILINGCLIENT_80_';
		$_display_dat['module'] = 'system/mailingclient';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_MACLI_ADMIN_TITLE, $text);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function editinfo () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$dbnew = 0;
	get_var ('dbnew', $dbnew, 'url', _OOBJ_DTYPE_INT);
	if ($dbnew == 1) {
		$result = $opnConfig['database']->Execute ('SELECT subject,body,maildate,bot_id FROM ' . $opnTables['mailingclient_new'] . ' WHERE id=' . $id);
		$subject = $result->fields['subject'];
		$body = $result->fields['body'];
		$maildate = $result->fields['maildate'];
		$bot_id = $result->fields['bot_id'];
	} else {
		$result = $opnConfig['database']->Execute ('SELECT subject,body,maildate,bot_id FROM ' . $opnTables['mailingclient'] . ' WHERE id=' . $id);
		$subject = $result->fields['subject'];
		$body = $result->fields['body'];
		$maildate = $result->fields['maildate'];
		$bot_id = $result->fields['bot_id'];
	}
	$subject = opn_br2nl ($subject);
	$body = opn_br2nl ($body);
	$maildate = opn_br2nl ($maildate);
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_MAILINGCLIENT_90_', 'system/mailingclient');
	$form->UseEditor (false);
	$form->UseWysiwyg (false);
	$form->Init ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('subject', _MACLI_ADMIN_SUBJECT . ':');
	$form->AddTextarea ('subject', 0, 0, '', $subject);
	$form->AddChangeRow ();
	$form->AddLabel ('body', _MACLI_ADMIN_BODY . ':');
	$form->AddTextarea ('body', 0, 0, '', $body);
	$form->AddChangeRow ();
	$form->AddLabel ('maildate', _MACLI_ADMIN_MAILDATE . ':');
	$form->AddTextarea ('maildate', 0, 0, '', $maildate);
	$form->AddChangeRow ();
	$form->AddLabel ('bot_id', _MACLI_ADMIN_BOT_ID . ':');
	$form->AddTextfield ('bot_id', 60, 60, $bot_id);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('id', $id);
	if ($dbnew == true) {
		$form->AddHidden ('op', 'addsinglenewtodb');
	} else {
		$form->AddHidden ('op', 'saveinfo');
	}
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _MACLI_ADMIN_SAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$text = '';
	$form->GetFormular ($text);
	MailingClientConfigHeader ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_MAILINGCLIENT_100_';
	$_display_dat['module'] = 'system/mailingclient';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_MACLI_ADMIN_EDITINFO, $text);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function editbot () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$result = $opnConfig['database']->Execute ('SELECT botname,botsearch,searchin,delbotsearch,delinsubject,delinbody,delinsubjecta,delinsubjectb,delinbodya,delinbodyb  FROM ' . $opnTables['mailingclient_bot'] . ' WHERE id=' . $id);
	$botname = $result->fields['botname'];
	$botsearch = $result->fields['botsearch'];
	$searchin = $result->fields['searchin'];
	$delbotsearch = $result->fields['delbotsearch'];
	$delinsubject = $result->fields['delinsubject'];
	$delinbody = $result->fields['delinbody'];
	$delinsubjecta = $result->fields['delinsubjecta'];
	$delinsubjectb = $result->fields['delinsubjectb'];
	$delinbodya = $result->fields['delinbodya'];
	$delinbodyb = $result->fields['delinbodyb'];
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_MAILINGCLIENT_110_', 'system/mailingclient');
	$form->UseEditor (false);
	$form->UseWysiwyg (false);
	$form->Init ($opnConfig['opn_url'] . '/system/mailingclient/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('botname', _MACLI_ADMIN_BOT_NAME . ':');
	$form->AddTextarea ('botname', 0, 0, '', $botname);
	$form->AddChangeRow ();
	$form->AddLabel ('botsearch', _MACLI_ADMIN_BOT_SEARCH . ':');
	$form->AddTextarea ('botsearch', 0, 0, '', $botsearch);
	$form->AddChangeRow ();
	$form->AddLabel ('delinsubject', _MACLI_ADMIN_DELTHISPLEASE_IN_SUBJECT . ':');
	$form->AddTextarea ('delinsubject', 0, 0, '', $delinsubject);
	$form->AddChangeRow ();
	$form->AddLabel ('delinsubjecta', _MACLI_ADMIN_DELTHISPLEASE_IN_SUBJECT_A . ':');
	$form->AddTextarea ('delinsubjecta', 0, 0, '', $delinsubjecta);
	$form->AddChangeRow ();
	$form->AddLabel ('delinsubjectb', _MACLI_ADMIN_DELTHISPLEASE_IN_SUBJECT_B . ':');
	$form->AddTextarea ('delinsubjectb', 0, 0, '', $delinsubjectb);
	$form->AddChangeRow ();
	$form->AddLabel ('delinbody', _MACLI_ADMIN_DELTHISPLEASE_IN_BODY . ':');
	$form->AddTextarea ('delinbody', 0, 0, '', $delinbody);
	$form->AddChangeRow ();
	$form->AddLabel ('delinbodya', _MACLI_ADMIN_DELTHISPLEASE_IN_BODY_A . ':');
	$form->AddTextarea ('delinbodya', 0, 0, '', $delinbodya);
	$form->AddChangeRow ();
	$form->AddLabel ('delinbodyb', _MACLI_ADMIN_DELTHISPLEASE_IN_BODY_B . ':');
	$form->AddTextarea ('delinbodyb', 0, 0, '', $delinbodyb);
	$form->AddChangeRow ();
	$form->AddLabel ('searchin', _MACLI_ADMIN_SEARCH_IN);
	$form->SetSameCol ();
	$form->AddRadio ('searchin', 1, ($searchin?true : false) );
	$form->AddText (' ' . _MACLI_ADMIN_SEARCH_IN_SUBJECT . ' ');
	$form->AddRadio ('searchin', 0, (! $searchin?true : false) );
	$form->AddText (' ' . _MACLI_ADMIN_SEARCH_IN_BODY);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('delbotsearch', _MACLI_ADMIN_DELBOTSEARCH);
	$form->SetSameCol ();
	$form->AddRadio ('delbotsearch', 1, ($delbotsearch?true : false) );
	$form->AddText (' ' . _YES . ' ');
	$form->AddRadio ('delbotsearch', 0, (! $delbotsearch?true : false) );
	$form->AddText (' ' . _NO);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('id', $id);
	$form->AddHidden ('op', 'savebot');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _MACLI_ADMIN_SAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$text = '';
	$form->GetFormular ($text);
	MailingClientConfigHeader ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_MAILINGCLIENT_120_';
	$_display_dat['module'] = 'system/mailingclient';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_MACLI_ADMIN_EDITINFO, $text);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function saveinfo () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$body = '';
	get_var ('body', $body, 'form', _OOBJ_DTYPE_CHECK);
	$maildate = '';
	get_var ('maildate', $maildate, 'form', _OOBJ_DTYPE_CLEAN);
	$bot_id = 0;
	get_var ('bot_id', $bot_id, 'form', _OOBJ_DTYPE_INT);
	opn_nl2br ($subject);
	opn_nl2br ($body);
	opn_nl2br ($maildate);
	$subject = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($subject, true, true, 'nothml'), 'subject');
	$body = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($body, true, true, 'recodehtml'), 'body');
	$maildate = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($maildate, true, true, 'nothml'), 'maildate');
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['mailingclient'] . " SET subject=$subject, body=$body, maildate=$maildate, bot_id=$bot_id WHERE id=$id");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['mailingclient'], 'id=' . $id);
	$opnConfig['opnOutput']->Redirect ('/system/mailingclient/admin/index.php');

}

function savebot () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$botname = '';
	get_var ('botname', $botname, 'form', _OOBJ_DTYPE_CLEAN);
	$botsearch = '';
	get_var ('botsearch', $botsearch, 'form');
	$searchin = '';
	get_var ('searchin', $searchin, 'form', _OOBJ_DTYPE_INT);
	$delbotsearch = '';
	get_var ('delbotsearch', $delbotsearch, 'form', _OOBJ_DTYPE_INT);
	$delinsubject = '';
	get_var ('delinsubject', $delinsubject, 'form');
	$delinbody = '';
	get_var ('delinbody', $delinbody, 'form');
	$delinsubjecta = '';
	get_var ('delinsubjecta', $delinsubjecta, 'form');
	$delinsubjectb = '';
	get_var ('delinsubjectb', $delinsubjectb, 'form');
	$delinbodya = '';
	get_var ('delinbodya', $delinbodya, 'form');
	$delinbodyb = '';
	get_var ('delinbodyb', $delinbodyb, 'form');
	$botname = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($botname, true, true, 'nothml'), 'botname');
	$botsearch = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($botsearch, true, false, ''), 'botsearch');
	$delinsubject = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($delinsubject, false, false, ''), 'delinsubject');
	$delinbody = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($delinbody, true, false, ''), 'delinbody');
	$delinsubjecta = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($delinsubjecta, false, false, ''), 'delinsubjecta');
	$delinsubjectb = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($delinsubjectb, false, false, ''), 'delinsubjectb');
	$delinbodya = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($delinbodya, false, false, ''), 'delinbodya');
	$delinbodyb = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($delinbodyb, false, false, ''), 'delinbodyb');
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['mailingclient_bot'] . " SET delinbodyb=$delinbodyb,delinbodya=$delinbodya,delinsubjectb=$delinsubjectb,delinsubjecta=$delinsubjecta,delinbody=$delinbody,delinsubject=$delinsubject,botsearch=$botsearch,botname=$botname, searchin=$searchin,delbotsearch=$delbotsearch WHERE id=$id");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['mailingclient_bot'], 'id=' . $id);
	$opnConfig['opnOutput']->Redirect ('/system/mailingclient/admin/index.php');

}

function addbot () {

	global $opnConfig, $opnTables;

	$botname = '';
	get_var ('botname', $botname, 'form', _OOBJ_DTYPE_CLEAN);
	$botsearch = '';
	get_var ('botsearch', $botsearch, 'form', _OOBJ_DTYPE_CLEAN);
	$searchin = '';
	get_var ('searchin', $searchin, 'form', _OOBJ_DTYPE_INT);
	$delbotsearch = '';
	get_var ('delbotsearch', $delbotsearch, 'form', _OOBJ_DTYPE_INT);
	$delinsubject = '';
	get_var ('delinsubject', $delinsubject, 'form', _OOBJ_DTYPE_CLEAN);
	$delinbody = '';
	get_var ('delinbody', $delinbody, 'form', _OOBJ_DTYPE_CLEAN);
	$delinsubjecta = '';
	get_var ('delinsubjecta', $delinsubjecta, 'form', _OOBJ_DTYPE_CLEAN);
	$delinsubjectb = '';
	get_var ('delinsubjectb', $delinsubjectb, 'form', _OOBJ_DTYPE_CLEAN);
	$delinbodya = '';
	get_var ('delinbodya', $delinbodya, 'form', _OOBJ_DTYPE_CLEAN);
	$delinbodyb = '';
	get_var ('delinbodyb', $delinbodyb, 'form', _OOBJ_DTYPE_CLEAN);
	$botname = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($botname, true, true, 'nothml'), 'botname');
	$botsearch = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($botsearch, true, false, ''), 'botsearch');
	$delinsubject = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($delinsubject, false, false, ''), 'delinsubject');
	$delinbody = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($delinbody, true, false, ''), 'delinbody');
	$delinsubjecta = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($delinsubjecta, false, false, ''), 'delinsubjecta');
	$delinsubjectb = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($delinsubjectb, false, false, ''), 'delinsubjectb');
	$delinbodya = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($delinbodya, false, false, ''), 'delinbodya');
	$delinbodyb = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($delinbodyb, false, false, ''), 'delinbodyb');
	$id = $opnConfig['opnSQL']->get_new_number ('mailingclient_bot', 'id');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['mailingclient_bot'] . " VALUES ($id,$botname,$botsearch,$searchin,$delbotsearch,$delinsubject,$delinbody,$delinsubjecta,$delinsubjectb,$delinbodya,$delinbodyb)");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['mailingclient_bot'], 'id=' . $id);
	$opnConfig['opnOutput']->Redirect ('/system/mailingclient/admin/index.php');

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'editinfo':
		editinfo ();
		break;
	case 'saveinfo':
		saveinfo ();
		break;
	case 'deleteinfo':
		deleteinfo ();
		break;
	case 'newmailingclient':
		listNewMailingClient ();
		break;
	case 'addallnew':
		mailingclient_addallnew ();
		break;
	case 'addsinglenewtodb':
		addsinglenewtodb ();
		break;
	case 'ignoreallnew':
		mailingclient_ignoreallnew ();
		break;
	case 'ignoresinglenew':
		mailingclient_ignoresinglenew ();
		break;
	case 'listBotClient':
		listBotClient ();
		break;
	case 'editbot':
		editbot ();
		break;
	case 'savebot':
		savebot ();
		break;
	case 'addbot':
		addbot ();
		break;
	case 'deletebot':
		deletebot ();
		break;
	default:
		listMailingClient ();
		break;
}

?>