<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

include_once (_OPN_ROOT_PATH . 'include/opn_ini_options_get.php');
getLanguageDef (_OPN_ROOT_PATH . 'system/mymsg2/admin/language/');

function MyMsg2ConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->EnableJavaScript ();
	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_MYMADM_CONF);
	$menu->InsertEntry (_MYMADM_MAIN, $opnConfig['opn_url'] . '/system/mymsg2/admin/index.php');
	if ($opnConfig['permission']->HasRight ('system/mymsg2', _PERM_ADMIN, true) ) {
		$menu->InsertEntry (_MYMADMIN_SETTINGS, $opnConfig['opn_url'] . '/system/mymsg2/admin/settings.php');
	}
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function InputPart ($myoptions, &$form) {

	global $opnConfig;

	$form->AddChangeRow ();
	$form->AddText (_MYMSG_USELANG);
	if ( (!isset ($myoptions['_mymsg_op_use_lang']) ) OR ($myoptions['_mymsg_op_use_lang'] == '') ) {
		$myoptions['_mymsg_op_use_lang'] = '0';
	}
	$options = get_language_options ();
	$form->AddSelect ('_mymsg_op_use_lang', $options, $myoptions['_mymsg_op_use_lang']);
	$form->AddChangeRow ();
	$form->AddText (_MYMSG_USEGROUP);
	if ( (!isset ($myoptions['_mymsg_op_use_group']) ) OR ($myoptions['_mymsg_op_use_group'] == '') ) {
		$myoptions['_mymsg_op_use_group'] = '0';
	}
	$options = array ();
	$groups = $opnConfig['permission']->UserGroups;
	foreach ($groups as $group) {
		$options[$group['id']] = $group['name'];
	}
	$form->AddSelect ('_mymsg_op_use_group', $options, $myoptions['_mymsg_op_use_group']);

}

function list_mymsg2 () {

	global $opnTables, $opnConfig;

	$boxtxt = '';
	$boxtxt .= '<div align="center" class="bigtextbold">' . _MYMADM_CONF2 . '</div>' . _OPN_HTML_NL;
	$boxtxt .= '<span class="bigtextbold">' . _MYMADM_HOME . '</span><br />' . _OPN_HTML_NL;
	$boxtxt .= '<br />' . _OPN_HTML_NL;
	$table = & new opn_TableClass ('alternator');
	$table->AddCols (array ('20%', '30%', '10%', '10%', '10%', '10%', '30%') );
	$table->AddHeaderRow (array (_MYMADM_TYPE, _MYMADM_TITLE, _MYMADM_ACTION, _MYMADM_POS, _MYMSG_USELANG, _MYMADM_PLAY, _MYMADM_LAST) );
	$message_name = 'Home';
	$result = &$opnConfig['database']->Execute ('SELECT message_id,title,message_time,display,message_pos,lang FROM ' . $opnTables['mymsg2'] . ' WHERE catid=0 and topicid=0 ORDER BY message_pos, message_time DESC');
	if ($result !== false) {
		$numrows = $result->RecordCount ();
	} else {
		$numrows = 0;
	}
	if ($numrows == 0) {
		$table->AddOpenRow ();
		$table->AddDataCol ('<a class="%alternate%" href="' . $opnConfig['opn_url'] . '/index.php">' . $message_name . '</a>');
		$table->AddDataCol ('&nbsp;');
		$table->AddDataCol ('&nbsp;');
		$table->AddDataCol ('&nbsp;');
		$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
											'op' => 'add',
											'catid' => '0',
											'topicid' => '0',
											'message_name' => $message_name) ) . '">' . _MYMADM_ADD . '</a>',
											'center');
		$table->AddCloseRow ();
	} else {
		$i = 1;
		while (! $result->EOF) {
			$i++;
			$message_id = $result->fields['message_id'];
			$title = $result->fields['title'];
			$time = $result->fields['message_time'];
			$display = $result->fields['display'];
			$pos = $result->fields['message_pos'];
			$lang = $result->fields['lang'];
			$opnConfig['opndate']->sqlToopnData ($time);
			$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
			$table->AddOpenRow ();
			$table->AddDataCol ('<a class="%alternate%" href="' . $opnConfig['opn_url'] . '/index.php">' . $message_name . '</a>');
			// sollte abstellbar sein
			$table->AddDataCol ($title);
			$hlp = '';
			if ($opnConfig['permission']->HasRights ('system/mymysg2', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
											'op' => 'edit',
											'message_id' => $message_id,
											'message_name' => $message_name) );
				$hlp .= ' ' . _OPN_HTML_NL;
			}
			if ($opnConfig['permission']->HasRights ('system/mymysg2', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
											'op' => 'delete',
											'message_id' => $message_id,
											'message_name' => $message_name) );
			}
			if ($hlp == '') {
				$hlp = '&nbsp;';
			}
			$table->AddDataCol ($hlp, 'center');
			$hlp = '';
			if ($opnConfig['permission']->HasRights ('system/mymysg2', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_up_link (array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
											'op' => 'moving',
											'message_id' => $message_id,
											'newpos' => ($pos-1.5) ) );
				$hlp .= ' ' . _OPN_HTML_NL;
				$hlp .= $opnConfig['defimages']->get_down_link (array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
											'op' => 'moving',
											'message_id' => $message_id,
											'newpos' => ($pos+1.5) ) );
			}
			if ($hlp == '') {
				$hlp = '&nbsp;';
			}
			$table->AddDataCol ($hlp, 'center');
			if ($lang == '0') {
				$lang = _MYMSG_ALL;
			}
			$table->AddDataCol ($lang, 'center');
			if ($opnConfig['permission']->HasRights ('system/mymysg2', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
				$link = array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
												'op' => 'update_visible',
												'message_id' => $message_id,
												'display' => '0');
				if ($display == 1) {
					$link['display'] = 0;
				} else {
					$link['display'] = 1;
				}
				$hlp = $opnConfig['defimages']->get_activate_deactivate_link ($link, $display, '', _YES_SUBMIT, _NO_SUBMIT );
			} else {
				$hlp = $opnConfig['defimages']->get_activate_deactivate_image ($display, _YES_SUBMIT,  _NO_SUBMIT);
			}
			$table->AddDataCol ($hlp, 'center');
			$table->AddDataCol ($time, 'center');
			$table->AddCloseRow ();
			$result->MoveNext ();
		}
		$table->AddOpenRow ();
		$table->AddDataCol ('<a class="%alternate%" href="' . $opnConfig['opn_url'] . '/index.php">' . $message_name . '</a>');
		$table->AddDataCol ('&nbsp;');
		$table->AddDataCol ('&nbsp;');
		$table->AddDataCol ('&nbsp;');
		if ($opnConfig['permission']->HasRights ('system/mymysg2', array (_PERM_NEW, _PERM_ADMIN), true) ) {
			$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
												'op' => 'add',
												'catid' => '0',
												'topicid' => '0',
												'message_name' => $message_name) ) . '">' . _MYMADM_ADD . '</a>',
												'center');
		} else {
			$table->AddDataCol ('&nbsp;');
		}
		$table->AddDataCol ('&nbsp;');
		$table->AddDataCol ('&nbsp;');
		$table->AddCloseRow ();
	}
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />';
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		$boxtxt .= '<span class="bigtextbold">' . _MYMADM_CATE . '</span>&nbsp;[<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/article/admin/categoryadmin.php?op=categorymanager') . '">' . _MYMADM_CREATECAT . '</a>]<br /><br />' . _OPN_HTML_NL;
		$table = & new opn_TableClass ('alternator');
		$table->AddCols (array ('20%', '30%', '10%', '30%', '10%') );
		$table->AddHeaderRow (array (_MYMADM_CAT, _MYMADM_TITLE, _MYMADM_PLAY, _MYMADM_LAST, _MYMADM_ACTION) );
		$result = &$opnConfig['database']->Execute ('SELECT catid,title FROM ' . $opnTables['article_stories_cat']);
		if ($result !== false) {
			if ($result->RecordCount ()>0) {
				$i = 1;
				while (! $result->EOF) {
					$i++;
					$catid = $result->fields['catid'];
					$message_name = $result->fields['title'];
					$table->AddOpenRow ();
					$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/index.php',
														'storycat' => $catid) ) . '">' . $message_name . '</a>');
					$result2 = &$opnConfig['database']->Execute ('SELECT message_id,title,display,message_time FROM ' . $opnTables['mymsg2'] . " WHERE catid=$catid");
					if ($result2 !== false) {
						$numrows = $result2->RecordCount ();
					} else {
						$numrows = 0;
					}
					if ($numrows == 0) {
						$table->AddDataCol ('&nbsp;');
						$table->AddDataCol ('&nbsp;');
						$table->AddDataCol ('&nbsp;');
						if ($opnConfig['permission']->HasRights ('system/mymysg2', array (_PERM_NEW, _PERM_ADMIN), true) ) {
							$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
																'op' => 'add',
																'catid' => $catid,
																'topicid' => '0',
																'message_name' => $message_name) ) . '">' . _MYMADM_ADD . '</a>',
																'center');
						}
						$table->AddCloseRow ();
					} else {
						$message_id = $result2->fields['message_id'];
						$title = $result2->fields['title'];
						$display = $result2->fields['display'];
						$time = $result2->fields['message_time'];
						$opnConfig['opndate']->sqlToopnData ($time);
						$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
						// sollte abstellbar sein
						$table->AddDataCol ($title);
						$table->AddDataCol ($opnConfig['defimages']->get_activate_deactivate_image ($display, _YES_SUBMIT, _NO_SUBMIT), 'center');
						$table->AddDataCol ($time, 'center');
						$hlp = '';
						if ($opnConfig['permission']->HasRights ('system/mymysg2', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
							$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
														'op' => 'edit',
														'message_id' => $message_id,
														'message_name' => $message_name) ) . ' ';
						}
						if ($opnConfig['permission']->HasRights ('system/mymysg2', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
							$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
														'op' => 'delete',
														'message_id' => $message_id,
														'message_name' => $message_name) );
						}
						if ($hlp == '') {
							$hlp = '&nbsp;';
						}
						$table->AddDataCol ($hlp, 'center');
						$table->AddCloseRow ();
					}
					$result->MoveNext ();
				}
			} else {
				$table->AddOpenRow ();
				$table->AddDataCol (_MYMADM_NOCAT, '', '5');
				$table->AddCloseRow ();
			}
		}
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br /><br />';
		$boxtxt .= '<hr />';
		$boxtxt .= '<br />';
		$boxtxt .= '<span class="bigtextbold">' . _MYMADM_TOPIC . '</span>&nbsp;[<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/article/admin/topicadmin.php?op=topicsmanager') . '">' . _MYMADM_CREATETOPIC . '</a>]<br /><br />' . _OPN_HTML_NL;
		$table = & new opn_TableClass ('alternator');
		$table->AddCols (array ('20%', '30%', '10%', '30%', '10%') );
		$table->AddHeaderRow (array (_MYMADM_TOPIC1, _MYMADM_TITLE, _MYMADM_PLAY, _MYMADM_LAST, _MYMADM_ACTION) );
		$result = &$opnConfig['database']->Execute ('SELECT topicid,topictext FROM ' . $opnTables['article_topics']);
		if ($result !== false) {
			if ($result->RecordCount ()>0) {
				$i = 1;
				while (! $result->EOF) {
					$i++;
					$topicid = $result->fields['topicid'];
					$message_name = $result->fields['topictext'];
					$table->AddOpenRow ();
					$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/index.php',
														'storytopic' => $topicid) ) . '">' . $message_name . '</a>');
					$result2 = &$opnConfig['database']->Execute ('SELECT message_id,title,display,message_time FROM ' . $opnTables['mymsg2'] . " WHERE topicid=$topicid");
					if ($result !== false) {
						$numrows = $result2->RecordCount ();
					} else {
						$numrows = 0;
					}
					if ($numrows == 0) {
						$table->AddDataCol ('&nbsp;');
						$table->AddDataCol ('&nbsp;');
						$table->AddDataCol ('&nbsp;');
						if ($opnConfig['permission']->HasRights ('system/mymysg2', array (_PERM_NEW, _PERM_ADMIN), true) ) {
							$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
																'op' => 'add',
																'catid' => '0',
																'topicid' => $topicid,
																'message_name' => $message_name) ) . '">' . _MYMADM_ADD . '</a>',
																'center');
						} else {
							$table->AddDataCol ('&nbsp;');
						}
					} else {
						$message_id = $result2->fields['message_id'];
						$title = $result2->fields['title'];
						$display = $result2->fields['display'];
						$time = $result2->fields['message_time'];
						$opnConfig['opndate']->sqlToopnData ($time);
						$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
						// sollte abstellbar sein
						$table->AddDataCol ($title);
						$table->AddDataCol ($opnConfig['defimages']->get_activate_deactivate_image ($display, _YES_SUBMIT, _NO_SUBMIT), 'center');
						$table->AddDataCol ($time, 'center');
						$hlp = '';
						if ($opnConfig['permission']->HasRights ('system/mymysg2', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
							$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
														'op' => 'edit',
														'message_id' => $message_id,
														'message_name' => $message_name) ) . ' ';
						}
						if ($opnConfig['permission']->HasRights ('system/mymysg2', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
							$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
														'op' => 'delete',
														'message_id' => $message_id,
														'message_name' => $message_name) );
						}
						if ($hlp == '') {
							$hlp = '&nbsp;';
						}
						$table->AddDataCol ($hlp, 'center');
					}
					$table->AddCloseRow ();
					$result->MoveNext ();
				}
			} else {
				$table->AddOpenRow ();
				$table->AddDataCol (_MYMADM_NOTOPIC, '', '5');
				$table->AddCloseRow ();
			}
		}
		$table->GetTable ($boxtxt);
	}
	$boxtxt .= '<br />';
	return $boxtxt;

}

function edit_mymsg2 () {

	global $opnTables, $opnConfig;

	$message_id = 0;
	get_var ('message_id', $message_id, 'url', _OOBJ_DTYPE_INT);
	$message_name = '';
	get_var ('message_name', $message_name, 'url', _OOBJ_DTYPE_CLEAN);
	$opnConfig['permission']->HasRights ('system/mymsg2', array (_PERM_EDIT, _PERM_ADMIN) );
	$boxtxt = '';
	$result = &$opnConfig['database']->Execute ('SELECT message_id,title,message_text,display,message_pos,usergroup,lang FROM ' . $opnTables['mymsg2'] . ' WHERE message_id=' . $message_id);
	if ($result === false) {
		$boxtxt .= $opnConfig['database']->ErrorNo () . ': ' . $opnConfig['database']->ErroMsg () . '<br />';
		exit ();
	}
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_MYMSG2_10_', 'mymsg2');
	while (! $result->EOF) {
		$message_id = $result->fields['message_id'];
		$title = $result->fields['title'];
		$text = $result->fields['message_text'];
		$display = $result->fields['display'];
		$usergroup = $result->fields['usergroup'];
		$lang = $result->fields['lang'];
		$pos = $result->fields['message_pos'];
		$myoptions = array ();
		$myoptions['_mymsg_op_use_lang'] = $lang;
		$myoptions['_mymsg_op_use_group'] = $usergroup;
		// sollte abstellbar sein
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
			include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
			$text = de_make_user_images ($text);
		}
		$form = & new opn_FormularClass ('listalternator');
		getForumMyMsg ($form, $message_name, $title, $text, $display, $pos, $myoptions);
		$form->SetSameCol ();
		$form->AddHidden ('op', 'update');
		$form->AddHidden ('message_id', $message_id);
		$form->SetEndCol ();
		$form->SetSameCol ();
		$form->AddSubmit ('submit');
		$form->AddText ('&nbsp;');
		$form->AddButton ('Back', _MYMADM_CANCEL, '', '', "javascript:history.go(-1)");
		$form->SetEndCol ();
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$result->MoveNext ();
	}
	return $boxtxt;

}

function update_mymsg2 () {

	global $opnConfig, $opnTables;

	$opnConfig['permission']->HasRights ('system/mymsg2', array (_PERM_EDIT, _PERM_ADMIN) );
	$boxtxt = '';
	$error = 0;
	$message_id = 0;
	get_var ('message_id', $message_id, 'form', _OOBJ_DTYPE_INT);
	$title = '';
	get_var ('title', $title, 'form', _OOBJ_DTYPE_CLEAN);
	$position = 0;
	get_var ('position', $position, 'form', _OOBJ_DTYPE_CLEAN);
	$text = '';
	get_var ('text', $text, 'form', _OOBJ_DTYPE_CHECK);
	$display = 0;
	get_var ('display', $display, 'form', _OOBJ_DTYPE_INT);
	if ($title == '') {
		$error = 1;
		$boxtxt .= _MYMADM_TITLE2 . '.<br />';
	}
	if ($text == '') {
		$error = 1;
		$boxtxt .= _MYMADM_UPD_NOTEXT . '.<br />';
	}
	if ($error == 1) {
		$boxtxt .= '<br /><input type="button" onclick="history.go(-1)" value="' . _MYMADM_BACK . '">';
	} else {
		// sollte abstellbar sein
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
			include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
			$text = make_user_images ($text);
		}
		$result = $opnConfig['database']->Execute ('SELECT message_pos FROM ' . $opnTables['mymsg2'] . ' WHERE message_id=' . $message_id);
		$pos = $result->fields['message_pos'];
		$result->Close ();
		$title = $opnConfig['opnSQL']->qstr ($title);
		$text = $opnConfig['opnSQL']->qstr ($text, 'message_text');
		$opnConfig['opndate']->now ();
		$now = '';
		$opnConfig['opndate']->opnDataTosql ($now);
		$myoptions = array ();
		get_var ('_mymsg_op_', $myoptions,'form','',true);
		if (!isset ($myoptions['_mymsg_op_use_lang']) ) {
			$mymsg_lang = '0';
		} else {
			$mymsg_lang = $myoptions['_mymsg_op_use_lang'];
		}
		if (!isset ($myoptions['_mymsg_op_use_group']) ) {
			$mymsg_group = 0;
		} else {
			$mymsg_group = $myoptions['_mymsg_op_use_group'];
		}
		$_mymsg_lang = $opnConfig['opnSQL']->qstr ($mymsg_lang);
		$query = 'UPDATE ' . $opnTables['mymsg2'] . " SET title=$title, message_text=$text, message_time=$now, display=$display , options=" . $opnConfig['opnSQL']->qstr (serialize ($myoptions) ) . ", lang=$_mymsg_lang, usergroup=$mymsg_group WHERE message_id=$message_id";
		$opnConfig['database']->Execute ($query);
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['mymsg2'], 'message_id=' . $message_id);
		if ($pos != $position) {
			set_var ('newpos', $position, 'url');
			set_var ('message_id', $message_id, 'url');
			move_mymsg2 ();
			unset_var ('newpos', 'url');
			unset_var ('message_id', 'url');
		}
		$boxtxt .= _MYMADM_UPD_SUCCUPD . '!';
		$boxtxt .= '<br /><br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/mymsg2/admin/index.php">' . _MYMADM_UPD_BACK . '</a>';
	}
	return $boxtxt;

}

function update_mymsg2_visible () {

	global $opnConfig, $opnTables;

	$message_id = 0;
	get_var ('message_id', $message_id, 'url', _OOBJ_DTYPE_INT);
	$display = 0;
	get_var ('display', $display, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('system/mymsg2', array (_PERM_EDIT, _PERM_ADMIN) );
	$query = 'UPDATE ' . $opnTables['mymsg2'] . " SET display=$display  WHERE message_id=$message_id";
	$opnConfig['database']->Execute ($query);

}

function getForumMyMsg (&$form, $message_name, $title, $text, $display, $pos = false, $myoptions = false) {

	global $opnConfig;

	$form->UseImages (true);
	$form->Init ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php', 'post', 'coolsus');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText (_MYMADM_FOR);
	$form->AddText ($message_name);
	$form->AddChangeRow ();
	$form->AddLabel ('title', _MYMADM_TITLE);
	$form->AddTextfield ('title', 50, 100, $title);
	$form->AddChangeRow ();
	$form->AddLabel ('text', _MYMADM_TEXT . ':');
	$form->AddTextarea ('text', 0, 0, '', $text, 'storeCaret(this)', 'storeCaret(this)', 'storeCaret(this)');
	if ($pos !== false) {
		$form->AddChangeRow ();
		$form->AddLabel ('position', _MYMADM_POS);
		$form->AddTextfield ('position', 0, 0, $pos);
	}
	$form->AddChangeRow ();
	$form->AddLabel ('display', _MYMADM_PLAY2);
	$form->AddCheckbox ('display', 1, $display);
	if ($myoptions === false) {
		$myoptions = array ();
		get_var ('_mymsg_op_', $myoptions,'form','',true);
	}
	InputPart ($myoptions, $form);
	$form->AddChangeRow ();

}

function add_mymsg2 () {

	global $opnConfig;

	$catid = 0;
	get_var ('catid', $catid, 'url', _OOBJ_DTYPE_INT);
	$topicid = 0;
	get_var ('topicid', $topicid, 'url', _OOBJ_DTYPE_INT);
	$message_name = '';
	get_var ('message_name', $message_name, 'url', _OOBJ_DTYPE_CLEAN);
	$opnConfig['permission']->HasRights ('system/mymsg2', array (_PERM_NEW, _PERM_ADMIN) );
	$boxtxt = '';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_MYMSG2_20_', 'mymsg2');
	getForumMyMsg ($form, $message_name, '', '', 1);
	$form->SetSameCol ();
	$form->AddHidden ('op', 'insert');
	$form->AddHidden ('catid', $catid);
	$form->AddHidden ('topicid', $topicid);
	$form->SetEndCol ();
	$form->SetSameCol ();
	$form->AddSubmit ('submit', _MYMADM_ADD);
	$form->AddText ('&nbsp;');
	$form->AddButton ('Back', _MYMADM_CANCEL, '', '', "javascript:history.go(-1)");
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function insert_mymsg2 () {

	global $opnConfig, $opnTables;

	$opnConfig['permission']->HasRights ('system/mymsg2', array (_PERM_NEW, _PERM_ADMIN) );
	$boxtxt = '';
	$error = 0;
	$title = '';
	get_var ('title', $title, 'form', _OOBJ_DTYPE_CLEAN);
	$text = '';
	get_var ('text', $text, 'form', _OOBJ_DTYPE_CHECK);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$display = 0;
	get_var ('display', $display, 'form', _OOBJ_DTYPE_INT);
	if ($title == '') {
		$error = 1;
		$boxtxt .= _MYMADM_TITLE2 . '.<br />';
	}
	if ($text == '') {
		$error = 1;
		$boxtxt .= _MYMADM_ENTERTEXT . '.<br />';
	}
	if ($error == 1) {
		$boxtxt .= '<br /><input type="button" onclick="history.go(-1)" value="' . _MYMADM_BACK . '">';
	} else {
		// sollte abstellbar sein
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
			include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
			$text = make_user_images ($text);
		}
		$title = $opnConfig['opnSQL']->qstr ($title);
		$text = $opnConfig['opnSQL']->qstr ($text, 'message_text');
		$opnConfig['opndate']->now ();
		$now = '';
		$opnConfig['opndate']->opnDataTosql ($now);
		$message_id = $opnConfig['opnSQL']->get_new_number ('mymsg2', 'message_id');
		$myoptions = array ();
		get_var ('_mymsg_op_', $myoptions,'form','',true);
		if (!isset ($myoptions['_mymsg_op_use_lang']) ) {
			$mymsg_lang = '0';
		} else {
			$mymsg_lang = $myoptions['_mymsg_op_use_lang'];
		}
		if (!isset ($myoptions['_mymsg_op_use_group']) ) {
			$mymsg_group = 0;
		} else {
			$mymsg_group = $myoptions['_mymsg_op_use_group'];
		}
		$_mymsg_lang = $opnConfig['opnSQL']->qstr ($mymsg_lang);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['mymsg2'] . " VALUES ($message_id, $title, $text, $catid, $topicid, $now, $display, $message_id, " . $opnConfig['opnSQL']->qstr (serialize ($myoptions) ) . ", $_mymsg_lang, $mymsg_group)");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['mymsg2'], 'message_id=' . $message_id);
		$boxtxt .= _MYMADM_MSG_ADDED . ' !';
		$boxtxt .= '<br /><br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/mymsg2/admin/index.php">' . _MYMADM_BACK_TO_LIST . '</a>';
	}
	return $boxtxt;

}

function delete_mymsg2 () {

	global $opnTables, $opnConfig;

	$message_id = 0;
	get_var ('message_id', $message_id, 'url', _OOBJ_DTYPE_INT);
	$message_name = '';
	get_var ('message_name', $message_name, 'url', _OOBJ_DTYPE_CLEAN);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('system/mymsg2', array (_PERM_DELETE, _PERM_ADMIN) );
	$boxtxt = '';
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mymsg2'] . " WHERE message_id=$message_id");
		$boxtxt .= _MYMADM_MSG_DEL;
		$boxtxt .= '<br /><br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/mymsg2/admin/index.php">' . _MYMADM_BACK_TO_LIST . '</a>';
	} else {
		$result = &$opnConfig['database']->Execute ('SELECT title,message_text,display FROM ' . $opnTables['mymsg2'] . " WHERE message_id=$message_id");
		$title = $result->fields['title'];
		$text = $result->fields['message_text'];
		$display = $result->fields['display'];
		// sollte abstellbar sein
		$boxtxt .= '<span class="normaltextbold">' . _MYMADM_TITLE . ':</span><br />' . $title . '<br /><br />';
		$boxtxt .= '<span class="normaltextbold">' . _MYMADM_TEXT . ':</span><br />';
		$boxtxt .= $text . '<br /><br />';
		$boxtxt .= '<span class="normaltextbold">' . _MYMADM_STATUS . ':</span><br />';
		if ($display) {
			$boxtxt .= _MYMADM_PLAY3;
		} else {
			$boxtxt .= _MYMADM_NOTPLAY3;
		}
		$boxtxt .= '<br /><br />';
		$boxtxt .= '<div class="centertag">' . _MYMADM_SHURE . ' <span class="normaltextbold">' . $message_name . '</span>' . _MYMADM_SHURE2 . '<br /><br />';
		$boxtxt .= '<a class="opncenterbox" href="javascript:history.go(-1)">' . _NO . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/mymsg2/admin/index.php',
																					'op' => 'delete',
																					'message_name' => $message_name,
																					'message_id' => $message_id,
																					'ok' => '1') ) . '">' . _YES . '</a></div>';
	}
	return $boxtxt;

}

function move_mymsg2 () {

	global $opnConfig, $opnTables;

	$newpos = 0;
	get_var ('newpos', $newpos, 'url', _OOBJ_DTYPE_CLEAN);
	$message_id = 0;
	get_var ('message_id', $message_id, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['mymsg2'] . " SET message_pos=$newpos WHERE message_id=$message_id");
	$result = &$opnConfig['database']->Execute ('SELECT message_id FROM ' . $opnTables['mymsg2'] . ' ORDER BY message_pos, message_time DESC');
	$mypos = 0;
	while (! $result->EOF) {
		$row = $result->GetRowAssoc ('0');
		$mypos++;
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['mymsg2'] . " SET message_pos=$mypos WHERE message_id=" . $row['message_id']);
		$result->MoveNext ();
	}

}
$boxtxt = '';
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
MyMsg2ConfigHeader ();
switch ($op) {
	case 'edit':
		$boxtxt = edit_mymsg2 ();
		break;
	case 'update':
		$boxtxt = update_mymsg2 ();
		break;
	case 'update_visible':
		update_mymsg2_visible ();
		$boxtxt = list_mymsg2 ();
		break;
	case 'add':
		$boxtxt = add_mymsg2 ();
		break;
	case 'insert':
		$btxt = insert_mymsg2 ();
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_MYMSG2_30_';
		$_display_dat['module'] = 'system/mymsg2';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_MYMADM_CONF2, $btxt);
		$boxtxt = list_mymsg2 ();
		break;
	case 'delete':
		$boxtxt = delete_mymsg2 ();
		break;
	case 'moving':
		move_mymsg2 ();
		$opnConfig['opnOutput']->Redirect ('/system/mymsg2/admin/index.php');
		break;
	default:
		$boxtxt = list_mymsg2 ();
		break;
}
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_MYMSG2_40_';
$_display_dat['module'] = 'system/mymsg2';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayCenterbox (_MYMADM_CONF2, $boxtxt);
$opnConfig['opnOutput']->DisplayFoot ();

?>