<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_MODULE_CLASS_PM_MSG_INCLUDED') ) {
	define ('_MODULE_CLASS_PM_MSG_INCLUDED', 1);
	getLanguageDef (_OPN_ROOT_PATH . 'system/pm_msg/class/language/');

	class pm_msg_handle {
		var $_ui = false;
		var $_eh = false;
		var $_admin = false;
		var $_script_url = '';

		function pm_msg_handle ($admin = false) {

			global $opnConfig;

			$this->_ui = $opnConfig['permission']->GetUserinfo ();
			$this->_admin = $admin;
			$this->_eh = & new opn_errorhandler;
			// opn_errorhandler object
			$this->_eh->SetErrorMsg ('PMMSG_0001', _PMMSG_CLASS_ERROR_PMMSG_0001);
			$this->_eh->SetErrorMsg ('PMMSG_0002', _PMMSG_CLASS_ERROR_PMMSG_0002);
			$this->_eh->SetErrorMsg ('PMMSG_0003', _PMMSG_CLASS_ERROR_PMMSG_0003);
			$this->_eh->SetErrorMsg ('PMMSG_0004', _PMMSG_CLASS_ERROR_PMMSG_0004);
			$this->_eh->SetErrorMsg ('PMMSG_0005', _PMMSG_CLASS_ERROR_PMMSG_0005);
			$this->_eh->SetErrorMsg ('PMMSG_0006', _PMMSG_CLASS_ERROR_PMMSG_0006);
			$this->_eh->SetErrorMsg ('PMMSG_0007', _PMMSG_CLASS_ERROR_PMMSG_0007);
			$this->_eh->SetErrorMsg ('PMMSG_0008', _PMMSG_CLASS_ERROR_PMMSG_0008);
			$this->_eh->SetErrorMsg ('PMMSG_0009', _PMMSG_CLASS_ERROR_PMMSG_0009);
			$this->_eh->SetErrorMsg ('PMMSG_0010', _PMMSG_CLASS_ERROR_PMMSG_0010);
			if (!isset ($opnConfig['pm_max_folder_size']) ) {
				$opnConfig['pm_max_folder_size'] = 33;
			}

		}

		function _get_user_pm_setting (&$dat) {

			global $opnConfig, $opnTables;

			$dat['allowedemail'] = 0;
			$dat['allowedpmmail'] = 0;
			$dat['secret'] = 0;
			$dat['copysend'] = 0;
			$ui = $opnConfig['permission']->GetUser ($dat['uid'], 'useruid', '');
			$query = &$opnConfig['database']->Execute ('SELECT allowedemail, allowedpmmail, secret, copysend FROM ' . $opnTables['priv_msgs_userdatas'] . ' WHERE uid=' . $dat['uid']);
			if ($query !== false) {
				if ($query->RecordCount () == 1) {
					$dat['allowedemail'] = $query->fields['allowedemail'];
					$dat['allowedpmmail'] = $query->fields['allowedpmmail'];
					$dat['secret'] = $query->fields['secret'];
					$dat['copysend'] = $query->fields['copysend'];
				}
				$query->Close ();
			}
			$dat['email'] = $ui['email'];
			$dat['uname'] = $ui['uname'];
			$dat['code'] = $ui['pass'];

		}

		function _poster_line ($posterdata, &$hlp) {

			global $opnConfig;

			$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
										'op' => 'userinfo',
										'uname' => $posterdata['uname']) ) . '"><img src="' . $opnConfig['opn_url'] . '/system/pm_msg/images/icons/profile.gif" class="imgtag" alt="" />' . _PMMSG_CLASS_PROFILE . '</a>';
			if ( (isset ($posterdata['femail']) ) && ($posterdata['femail'] != '') ) {
				$hlp .= '&nbsp;&nbsp;<a class="%alternate%" href="mailto:' . $posterdata['femail'] . '"><img src="' . $opnConfig['opn_default_images'] . 'friend.gif" class="imgtag" alt="" />' . _PMMSG_CLASS_EMAIL . '</a>';
			}
			if ( (isset ($posterdata['url']) ) && ($posterdata['url'] != '') && ($posterdata['url'] != 'http://') ) {
				if (strstr ('http://', $posterdata['url']) ) {
					$posterdata['url'] = 'http://' . $posterdata['url'];
				}
				$hlp .= '&nbsp;&nbsp;<a class="%alternate%" href="' . $posterdata['url'] . '" target="_blank"><img src="' . $opnConfig['opn_url'] . '/system/pm_msg/images/icons/www_icon.gif" class="imgtag" alt="" /></a>' . _OPN_HTML_NL;
			}
			if ( (isset ($posterdata['user_icq']) ) && ($posterdata['user_icq'] != '') ) {
				$hlp .= '&nbsp;&nbsp;<a class="%alternate%" href="http://wwp.mirabilis.com/' . $posterdata['user_icq'] . '" target="_blank"><img src="http://wwp.icq.com/scripts/online.dll?icq=' . $posterdata['user_icq'] . '&amp;img=5" class="imgtag" alt="" /></a>';
			}
			if ( (isset ($posterdata['user_aim']) ) && ($posterdata['user_aim'] != '') ) {
				$hlp .= '&nbsp;&nbsp;<a class="%alternate%" href="aim:goim?screenname=' . $posterdata['user_aim'] . '&amp;message=Hi+' . $posterdata['user_aim'] . '.+Are+you+there?"><img src="' . $opnConfig['opn_url'] . '/system/pm_msg/images/icons/aim.gif" class="imgtag" alt="" /></a>';
			}
			if ( (isset ($posterdata['user_yim']) ) && ($posterdata['user_yim'] != '') ) {
				$hlp .= '&nbsp;&nbsp;<a class="%alternate%" href="http://edit.yahoo.com/config/send_webmesg?.target=' . $posterdata['user_yim'] . '&amp;.src=pg"><img src="' . $opnConfig['opn_url'] . '/system/pm_msg/images/icons/yim.gif" class="imgtag" alt="" /></a>';
			}
			if ( (isset ($posterdata['user_msnm']) ) && ($posterdata['user_msnm'] != '') ) {
				$hlp .= '&nbsp;&nbsp;<a class="%alternate%" href="bb_profile.php?userid=' . $posterdata['uid'] . '"><img src="' . $opnConfig['opn_url'] . '/system/pm_msg/images/icons/msnm.gif" class="imgtag" alt="" /></a>';
			}

		}

		function preview_pm ($to_userid, $subject, $message, $msg_image) {

			global $opnConfig;

			$html = 0;
			get_var ('html', $html, 'form', _OOBJ_DTYPE_INT);
			$bbcode = 0;
			get_var ('bbcode', $bbcode, 'form', _OOBJ_DTYPE_INT);
			$sig = 0;
			get_var ('sig', $sig, 'form', _OOBJ_DTYPE_INT);
			$smile = 0;
			get_var ('smile', $smile, 'form', _OOBJ_DTYPE_INT);
			$t = $to_userid;
			$boxtxt = '';
			$table = & new opn_TableClass ('alternator');
			$opnConfig['opndate']->now ();
			$time = '';
			$opnConfig['opndate']->formatTimestamp ($time, _DATE_FORUMDATESTRING2);
			$message = stripslashes ($message);
			if ($opnConfig['allow_html_pm'] == 0 && $html) {
				$message = htmlspecialchars ($message);
			}
			if (!$bbcode) {
				$ubb = & new UBBCode;
				$ubb->ubbencode ($message);
			}
			if ( ($opnConfig['installedPlugins']->isplugininstalled ('system/user_sig') ) && ($sig) ) {
				$message .= '<br /><hr /><br />' . $this->_ui['user_sig'];
			}
			opn_nl2br ($message);
			if ( ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) && (!$smile) ) {
				$message = smilies_smile ($message);
			}
			$message = $opnConfig['cleantext']->makeClickable ($message);
			$table->AddCols (array ('20%', '80%') );
			$table->AddOpenRow ();
			$hlp = _PMMSG_CLASS_FROM;
			$hlp .= ' <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
										'op' => 'userinfo',
										'uname' => $this->_ui['uname']) ) . '">' . api_user_name ($this->_ui['uname']) . '</a>';
			$hlp .= '<br />';
			$hlp .= _PMMSG_CLASS_SENT . ': ' . $time;
			$table->AddDataCol ($hlp, 'left');
			$hlp = '';
			if ($msg_image != '') {
				$hlp = '<img src="' . $opnConfig['opn_url'] . '/system/pm_msg/images/subject/' . $msg_image . '" alt="" />&nbsp;';
			}
			$hlp .= '<span class="normaltextbold">' . $subject . '</span>';
			$table->AddDataCol ($hlp, 'left');
			$table->AddChangeRow ();
			$table->AddDataCol ($message . '<br /><br />', 'left', '2');
			$table->AddChangeRow ();
			$hlp = '';
			$this->_poster_line ($this->_ui, $hlp);
			$table->AddDataCol ($hlp, 'left', '2');
			$table->AddCloseRow ();
			$table->GetTable ($boxtxt);
			return $boxtxt;

		}

		function view_pm ($msg_id, $msg_cat = 1) {

			global $opnConfig, $opnTables;

			$boxtxt = '';
			$sql = 'SELECT msg_id, msg_image, subject, from_userid, to_userid, msg_time, msg_text';
			if ($msg_cat == 1) {
				$sql .= ', read_msg FROM ' . $opnTables['priv_msgs'] . ' WHERE (msg_id=' . $msg_id . ')';
			} else {
				$sql .= ' FROM ' . $opnTables['priv_msgs_save'] . ' WHERE (msg_id=' . $msg_id . ') AND (msg_cat=' . $msg_cat . ')';
			}
			if (!$this->_admin) {
				if ($msg_cat == 1) {
					$sql .= ' AND (to_userid=' . $this->_ui['uid'] . ')';
				} else {
					$sql .= ' AND (uid_id=' . $this->_ui['uid'] . ') ';
				}
			}
			$result = &$opnConfig['database']->SelectLimit ($sql, 1);
			if ( ($result !== false) && (!$result->EOF) ) {
				$myrow = $result->GetRowAssoc ('0');
				if ( ($msg_cat == 1) && (!$this->_admin) ) {
					$sql = 'UPDATE ' . $opnTables['priv_msgs'] . ' SET read_msg=1 WHERE msg_id=' . $myrow['msg_id'];
					$opnConfig['database']->Execute ($sql);
					$sql = 'SELECT options FROM ' . $opnTables['priv_msgs_pm_option'] . ' WHERE (msg_id=' . $msg_id . ') ';
					$result_options = &$opnConfig['database']->SelectLimit ($sql, 1);
					if ( ($result_options !== false) && (!$result_options->EOF) ) {
						while (! $result_options->EOF) {
							$msg_options = unserialize ($result_options->fields['options']);
							$result_options->MoveNext ();
						}
						$sql_del = 'DELETE FROM ' . $opnTables['priv_msgs_pm_option'] . ' WHERE msg_id=' . $msg_id;
						$opnConfig['database']->Execute ($sql_del);
						if ($msg_options['read_receipt'] == 1) {
							$opnConfig['opndate']->now ();
							$readtime = '';
							$opnConfig['opndate']->formatTimestamp ($readtime, _DATE_FORUMDATESTRING2);
							$to_uid_dat = array ();
							$to_uid_dat['uid'] = $myrow['from_userid'];
							$this->_get_user_pm_setting ($to_uid_dat);
							$dat = array ();
							$dat['subject'] = _PMMSG_CLASS_READ_RECEIPT_MESSAGES_HAVEREAD . $myrow['subject'];
							$dat['msgiconselect'] = '';
							$dat['message'] = _PMMSG_CLASS_READ_RECEIPT_MESSAGES . '<br />';
							$dat['message'] .= _PMMSG_CLASS_READ_RECEIPT_MESSAGES_READ . $myrow['subject'] . '<br />';
							$dat['message'] .= _PMMSG_CLASS_READ_RECEIPT_MESSAGES_READON . ' ' . $readtime . '<br />';
							$dat['html'] = 0;
							$dat['read_receipt'] = 0;
							$dat['bbcode'] = 0;
							$dat['sig'] = 0;
							$dat['smile'] = 0;
							$dat['to_userid'] = $myrow['from_userid'];
							$this->_save_pm ($dat, $to_uid_dat);
						}
					}
				}
				$boxtxt .= '<span class="normaltextbold">' . _PMMSG_CLASS_PRIVATE_MESSAGE . '</span>';
				$boxtxt .= '<br /><br />';
				if (!$this->_admin) {
					$boxtxt .= '<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/pm_msg/index.php">' . _PMMSG_CLASS_INDEX . '</a>';
					$boxtxt .= '&nbsp;';
					$boxtxt .= '<span class="normaltextbold"> &gt; </span>&nbsp;' . $myrow['subject'];
				}
				$table = & new opn_TableClass ('alternator');
				$posterdata = $opnConfig['permission']->GetUser ($myrow['from_userid'], 'userid', '');
				$opnConfig['opndate']->sqlToopnData ($myrow['msg_time']);
				$time = '';
				$opnConfig['opndate']->formatTimestamp ($time, _DATE_FORUMDATESTRING2);
				$to_uid_dat = array ();
				$to_uid_dat['uid'] = $myrow['to_userid'];
				$this->_get_user_pm_setting ($to_uid_dat);
				if ($to_uid_dat['secret'] == 1) {
					$message = open_the_secret ($to_uid_dat['code'], $myrow['msg_text']);
				} else {
					$message = stripslashes ($myrow['msg_text']);
				}
				opn_nl2br ($message) . 'test';
				$ubb = & new UBBCode;
				$ubb->ubbencode ($message);
				if ( ($opnConfig['installedPlugins']->isplugininstalled ('system/user_sig') ) && (isset ($posterdata['user_sig']) ) ) {
					$usersig = $posterdata['user_sig'];
					$ubb->ubbencode ($usersig);
				}
				$table->AddCols (array ('20%', '80%') );
				$table->AddOpenRow ();
				$hlp = _PMMSG_CLASS_FROM . ' <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
														'op' => 'userinfo',
														'uname' => $posterdata['uname']) ) . '">' . api_user_name ($posterdata['uname']) . '</a>';
				$hlp .= '<br />';
				$hlp .= _PMMSG_CLASS_TO . ' <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
														'op' => 'userinfo',
														'uname' => $to_uid_dat['uname']) ) . '">' . api_user_name ($to_uid_dat['uname']) . '</a>';
				$hlp .= '<br />';
				$hlp .= _PMMSG_CLASS_SENT . ': ' . $time;
				$table->AddDataCol ($hlp, 'left');
				if ($myrow['msg_image'] == '') {
					$myrow['msg_image'] = 'blank.gif';
				}
				$hlp = '<img src="' . $opnConfig['opn_url'] . '/system/pm_msg/images/subject/' . $myrow['msg_image'] . '" alt="" />&nbsp;';
				$hlp .= '<span class="normaltextbold">' . $myrow['subject'] . '</span>';
				$table->AddDataCol ($hlp, 'left');
				$table->AddChangeRow ();
				$table->AddDataCol ($message . '<br /><br />', 'left', '2');
				$table->AddChangeRow ();
				$hlp = '';
				$this->_poster_line ($posterdata, $hlp);
				$table->AddDataCol ($hlp, 'left', '2');
				if (!$this->_admin) {
					$table->AddChangeRow ();
					$start = 0;
					get_var ('start', $start, 'url', _OOBJ_DTYPE_INT);
					$total_messages = 0;
					get_var ('total_messages', $total_messages, 'url', _OOBJ_DTYPE_INT);
					$sortby = '';
					get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
					$previous = $start-1;
					$next = $start+1;
					$zusatz = '';
					$hlp = '';
					if ($previous >= 0) {
						$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/pm_msg/readpmsg.php',
													'start' => $previous,
													'total_messages' => $total_messages,
													_OPN_VAR_TABLE_SORT_VAR => $sortby) ) . '">' . _PMMSG_CLASS_PREVIOUS_MESSAGES . '</a>';
						$zusatz .= ' | ';
					}
					if ($next<$total_messages) {
						$hlp .= $zusatz . '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/pm_msg/readpmsg.php',
															'start' => $next,
															'total_messages' => $total_messages,
															_OPN_VAR_TABLE_SORT_VAR => $sortby) ) . '">' . _PMMSG_CLASS_NEXT_MESSAGES . '</a>';
						$zusatz .= ' | ';
					}
					$table->AddDataCol ($hlp, 'right', '2');
					$table->AddCloseRow ();
					$table->AddOpenRow ();
					$form = & new opn_FormularClass ('default');
					$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_PM_MSG_90_', 'pm_msg');
					$form->Init ($opnConfig['opn_url'] . '/system/pm_msg/replypmsg.php', 'post');
					$form->AddTable ();
					$form->AddCols (array ('10%', '10%') );
					$form->AddOpenRow ();
					$form->AddSubmit ('reply', _PMMSG_CLASS_REPLY_PM);
					$form->AddHidden ('msg_id', $myrow['msg_id']);
					$form->AddHidden ('msg_cat', $msg_cat);
					$form->AddCloseRow ();
					$form->AddTableClose ();
					$form->AddFormEnd ();
					$hlp = '';
					$form->GetFormular ($hlp);
					$form = & new opn_FormularClass ('default');
					$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_PM_MSG_100_', 'pm_msg');
					$form->Init ($opnConfig['opn_url'] . '/system/pm_msg/pm_action.php', 'post');
					$form->AddTable ();
					$form->AddCols (array ('10%', '10%') );
					$form->AddOpenRow ();
					$form->AddSubmit ('delete', _PMMSG_CLASS_DELETE_PM);
					$form->AddHidden ('msg_id', $myrow['msg_id']);
					$form->AddHidden ('msg_cat', $msg_cat);
					$form->AddHidden ('op', 'delete');
					$form->AddCloseRow ();
					$form->AddTableClose ();
					$form->AddFormEnd ();
					$form->GetFormular ($hlp);
					$table->AddDataCol ($hlp, 'left', '2');
					$form->AddCloseRow ();
				}
				$table->GetTable ($boxtxt);
			} else {
				$boxtxt .= _PMMSG_CLASS_THERE_ISNT_ANY_REVIEW_FOR_LETTER;
			}
			return $boxtxt;

		}

		function _save_pm (&$dat, $u) {

			global $opnConfig, $opnTables;
			if (get_magic_quotes_gpc () ) {
				$dat['message'] = stripslashes ($dat['message']);
			}
			if ($opnConfig['allow_html_pm'] == 0 && $dat['html']) {
				$dat['message'] = htmlspecialchars ($dat['message']);
			}
			if (!$dat['bbcode']) {
				$ubb = & new UBBCode;
				$ubb->ubbencode ($dat['message']);
			}
			if ( ($opnConfig['installedPlugins']->isplugininstalled ('system/user_sig') ) && ($dat['sig']) ) {
				$dat['message'] .= '<br /><hr /><br />' . $this->_ui['user_sig'];
			}
			opn_nl2br ($dat['$message']);
			if ( ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) && (!$dat['smile']) ) {
				$dat['message'] = smilies_smile ($dat['message']);
			}
			$dat['$message'] = $opnConfig['cleantext']->makeClickable ($dat['message']);
			$opnConfig['opndate']->now ();
			$time = '';
			$opnConfig['opndate']->opnDataTosql ($time);
			if ($u['copysend'] == 1) {
				$vars = array ();
				$file = 'notification';
				$subject1 = sprintf (_PMMSG_CLASS_NEW_PM_EMAIL, $opnConfig['sitename']);
				$mail = & new opn_mailer ();
				if ($opnConfig['pm_send_complete']) {
					if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
						$message1 = smilies_desmile ($dat['message']);
					} else {
						$message1 = $dat['message'];
					}
					$message1 = opn_br2nl ($message1);
					$message1 = strip_tags ($message1, '<a>');
					$opnConfig['cleantext']->un_htmlentities ($message1);
					$ssubject = $dat['subject'];
					$opnConfig['cleantext']->un_htmlentities ($ssubject);
					$vars['{UNAME}'] = $u['uname'];
					$vars['{SUBJECT}'] = $ssubject;
					$vars['{MESSAGE}'] = $message1;
					$file = 'completepm';
				}
				$mail->opn_mail_fill ($u['email'], $subject1, 'system/pm_msg', $file, $vars, $opnConfig['opn_webmaster_name'], $opnConfig['adminmail']);
				$mail->send ();
				$mail->init ();
			}
			if ($u['secret'] == 1) {
				$dat['message'] = make_the_secret ($u['code'], $dat['message']);
			}
			$message = $opnConfig['opnSQL']->qstr ($dat['message'], 'msg_text');
			$subject = $opnConfig['opnSQL']->qstr ($dat['subject']);
			$msgiconselect = $opnConfig['opnSQL']->qstr ($dat['msgiconselect']);
			$msg_id = $opnConfig['opnSQL']->get_new_number ('priv_msgs', 'msg_id');
			$sql = 'INSERT INTO ' . $opnTables['priv_msgs'] . " VALUES ($msg_id, $msgiconselect, $subject, " . $this->_ui['uid'] . ", " . $dat['to_userid'] . ", $time, $message, 0)";
			$opnConfig['database']->Execute ($sql);
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables['priv_msgs'], 'msg_id=' . $msg_id);
			if ($dat['read_receipt'] == 1) {
				$options = array ();
				$options['read_receipt'] = 1;
				$options = $opnConfig['opnSQL']->qstr (serialize (addslashesinarray ($options) ), 'options');
				$sql = 'INSERT INTO ' . $opnTables['priv_msgs_pm_option'] . " VALUES ($msg_id, $options)";
				$opnConfig['database']->Execute ($sql);
				$opnConfig['opnSQL']->UpdateBlobs ($opnTables['priv_msgs_pm_option'], 'msg_id=' . $msg_id);
			}
			$msg_id = $opnConfig['opnSQL']->get_new_number ('priv_msgs_save', 'msg_id');
			$sql = 'INSERT INTO ' . $opnTables['priv_msgs_save'] . " VALUES (" . $this->_ui['uid'] . ", $msg_id, $msgiconselect, $subject, " . $this->_ui['uid'] . ", " . $dat['to_userid'] . ", $time, $message, 4)";
			$opnConfig['database']->Execute ($sql);
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables['priv_msgs_save'], 'msg_id=' . $msg_id);

		}

		function save_pm () {

			global $opnConfig, $opnTables;

			$boxtxt = '';
			$subject = '';
			get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
			$msgiconselect = '';
			get_var ('msgiconselect', $msgiconselect, 'form', _OOBJ_DTYPE_CLEAN);
			$message = '';
			get_var ('message', $message, 'form', _OOBJ_DTYPE_CHECK);
			$html = 0;
			get_var ('html', $html, 'form', _OOBJ_DTYPE_INT);
			$read_receipt = 0;
			get_var ('read_receipt', $read_receipt, 'form', _OOBJ_DTYPE_INT);
			$bbcode = 0;
			get_var ('bbcode', $bbcode, 'form', _OOBJ_DTYPE_INT);
			$sig = 0;
			get_var ('sig', $sig, 'form', _OOBJ_DTYPE_INT);
			$smile = 0;
			get_var ('smile', $smile, 'form', _OOBJ_DTYPE_INT);
			$to_userid = '';
			get_var ('to_userid', $to_userid, 'form', _OOBJ_DTYPE_CLEAN);
			if ($to_userid == '') {
				OpenTable ($boxtxt);
				$boxtxt .= '<div class="centertag">The selected user doesn\'t exist in the database.<br />';
				$boxtxt .= 'Please check the name and try again.<br /><br />';
				$boxtxt .= '[ <a class="opncenterbox" href="javascript:history.go(-1)">' . _PMMSG_CLASS_GO_BACK . '</a> ]</div>';
				CloseTable ($boxtxt);
			} else {
				$num = 0;
				$num_folder = 0;
				$result = $opnConfig['database']->Execute ('SELECT COUNT(msg_id) AS counter FROM ' . $opnTables['priv_msgs'] . ' WHERE to_userid=' . $to_userid . ' ');
				if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
					while (! $result->EOF) {
						$num = $result->fields['counter'];
						$result->MoveNext ();
					}
					// while
					$result->Close ();
					unset ($result);
				}
				$result = $opnConfig['database']->Execute ('SELECT COUNT(msg_id) AS counter FROM ' . $opnTables['priv_msgs_save'] . ' WHERE uid_id=' . $to_userid);
				if ($result !== false) {
					while (! $result->EOF) {
						if (isset ($result->fields['counter']) ) {
							$num_folder = $result->fields['counter'];
						}
						$result->MoveNext ();
					}
					// while
				}
				$total_messages = $num+ $num_folder;
				if ($total_messages >= $opnConfig['pm_max_folder_size']) {
					OpenTable ($boxtxt);
					$boxtxt .= '<div align="center" class="normaltext">';
					$boxtxt .= '<br />';
					$boxtxt .= _PMMSG_CLASS_MESSAGE_CAN_NOT_SEND_LIMIT;
					$boxtxt .= '<br />';
					$boxtxt .= '<br />';
					$boxtxt .= '[ <a class="opncenterbox" href="javascript:history.go(-1)">' . _PMMSG_CLASS_GO_BACK . '</a> ]</div>';
					CloseTable ($boxtxt);
				} else {
					$to_uid_dat = array ();
					$to_uid_dat['uid'] = $to_userid;
					$this->_get_user_pm_setting ($to_uid_dat);
					if ($subject == '') {
						$this->_eh->show ('PMMSG_0002');
					}
					if ($msgiconselect == '') {
						$this->_eh->show ('PMMSG_0003');
					}
					if ($message == '') {
						$this->_eh->show ('PMMSG_0004');
					}
					$dat = array ();
					$dat['subject'] = $subject;
					$dat['msgiconselect'] = $msgiconselect;
					$dat['message'] = $message;
					$dat['html'] = $html;
					$dat['read_receipt'] = $read_receipt;
					$dat['bbcode'] = $bbcode;
					$dat['sig'] = $sig;
					$dat['smile'] = $smile;
					$dat['to_userid'] = $to_userid;
					$this->_save_pm ($dat, $to_uid_dat);
					OpenTable ($boxtxt);
					$boxtxt .= '<div align="center" class="normaltext">' . _PMMSG_CLASS_YOUR_MESSAGE_HAS_BEEN_POSTED . '<br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/pm_msg/index.php">' . _PMMSG_CLASS_YOU_CAN_CLICK_HERE_TO_VIEW_YOUR_PRIVATE_MESSAGES . '</a></div>';
					CloseTable ($boxtxt);
				}
			}
			return $boxtxt;

		}

		function write_pm () {

			global $opnConfig, $opnTables;

			$boxtxt = '';
			$preview = '';
			get_var ('preview', $preview, 'both', _OOBJ_DTYPE_CLEAN);
			$reply = '';
			get_var ('reply', $reply, 'both', _OOBJ_DTYPE_CLEAN);
			$send = '';
			get_var ('send', $send, 'both', _OOBJ_DTYPE_CLEAN);
			$send2 = '';
			get_var ('send2', $send2, 'both', _OOBJ_DTYPE_CLEAN);
			$msg_cat = '';
			get_var ('msg_cat', $msg_cat, 'both', _OOBJ_DTYPE_INT);
			if ( ($preview != '') || ($reply != '') || ($send != '') || ($send2 != '') ) {
				$subject = '';
				$msgiconselect = 'blank.gif';
				$message = '';
				$html = 0;
				$read_receipt = 0;
				$bbcode = 0;
				$sig = 0;
				$smile = 0;
				if ($preview != '') {
					$subject = '';
					get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CLEAN);
					$msgiconselect = '';
					get_var ('msgiconselect', $msgiconselect, 'form', _OOBJ_DTYPE_CLEAN);
					$message = '';
					get_var ('message', $message, 'form', _OOBJ_DTYPE_CHECK);
					$html = 0;
					get_var ('html', $html, 'form', _OOBJ_DTYPE_INT);
					$read_receipt = 0;
					get_var ('read_receipt', $read_receipt, 'form', _OOBJ_DTYPE_INT);
					$bbcode = 0;
					get_var ('bbcode', $bbcode, 'form', _OOBJ_DTYPE_INT);
					$sig = 0;
					get_var ('sig', $sig, 'form', _OOBJ_DTYPE_INT);
					$smile = 0;
					get_var ('smile', $smile, 'form', _OOBJ_DTYPE_INT);
					$to_userid = 0;
					get_var ('to_userid', $to_userid, 'form', _OOBJ_DTYPE_INT);
					$boxtxt .= $this->preview_pm ($to_userid, $subject, $message, $msgiconselect);
					if (get_magic_quotes_gpc () ) {
						$message = stripslashes ($message);
					}
				} elseif ($reply != '') {
					$msg_id = 0;
					get_var ('msg_id', $msg_id, 'form', _OOBJ_DTYPE_INT);
					if ($msg_cat == 1) {
						$sql = 'SELECT msg_image, subject, from_userid, to_userid FROM ' . $opnTables['priv_msgs'] . ' WHERE msg_id=' . $msg_id;
					} else {
						$sql = 'SELECT msg_id, msg_image, subject, from_userid, to_userid, msg_time, msg_text FROM ' . $opnTables['priv_msgs_save'] . ' WHERE (msg_id=' . $msg_id . ') AND (msg_cat=' . $msg_cat . ') AND (uid_id = ' . $this->_ui['uid'] . ') ';
					}
					$result = &$opnConfig['database']->Execute ($sql);
					if ($result === false) {
						$this->_eh->show ('PMMSG_0007');
					}
					$row = $result->GetRowAssoc ('0');
					if (!$row) {
						$this->_eh->show ('PMMSG_0008');
					}
					$fromuserdata = $opnConfig['permission']->GetUser ($row['from_userid'], 'userid', '');
					$touserdata = $opnConfig['permission']->GetUser ($row['to_userid'], 'userid', '');
					if ( ($opnConfig['permission']->IsUser () ) && ($this->_ui['uid'] != $touserdata['uid']) ) {
						$this->_eh->show ('PMMSG_0009');
					}
				}
				if ($send2 == '') {
					$send2 = false;
				}
				if ($reply == '') {
					$reply = false;
				}
				$myformname = 'coolsus';
				$mytextareaname = 'message';
				$boxtxt .= '<script type="text/javascript">' . _OPN_HTML_NL;
				$boxtxt .= '<!--' . _OPN_HTML_NL;
				$boxtxt .= 'function showimage() {' . _OPN_HTML_NL;
				$boxtxt .= '  if (!document.images)' . _OPN_HTML_NL;
				$boxtxt .= '	return' . _OPN_HTML_NL;
				$boxtxt .= '	document.' . $myformname . '.msgicon.src="' . $opnConfig['opn_url'] . '/system/pm_msg/images/subject/" + document.' . $myformname . '.msgiconselect.options[document.' . $myformname . '.msgiconselect.selectedIndex].value' . _OPN_HTML_NL;
				$boxtxt .= '}' . _OPN_HTML_NL;
				$boxtxt .= '//-->' . _OPN_HTML_NL . '</script>' . _OPN_HTML_NL;
				$form = & new opn_FormularClass ('listalternator');
				$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_PM_MSG_110_', 'pm_msg');
				$form->Init ($opnConfig['opn_url'] . '/system/pm_msg/replypmsg.php', 'post', $myformname);
				$form->AddCheckField('subject', 'e', _PPMSG_CLASS_NO_SUBJECT);
				$form->AddCheckField($mytextareaname, 'e', _PPMSG_CLASS_NO_MESSAGE);
				$form->AddTable ();
				$form->SetIsHeader (true);
				$form->AddOpenHeadRow ();
				$form->SetColspan ('2');
				$form->AddText (_PMMSG_CLASS_ABOUT_POSTING . '&nbsp;' . _PMMSG_CLASS_ALL_REGISTERED_USERS_CAN_POST_PM);
				$form->SetColspan ('');
				$form->AddCloseRow ();
				$form->SetIsHeader (false);
				$form->AddOpenRow ();
				$form->AddText (_PMMSG_CLASS_TO);
				if ($reply) {
					$form->SetSameCol ();
					$form->AddHidden ('to_user', $fromuserdata['uname']);
					$form->AddHidden ('to_userid', $fromuserdata['uid']);
					$form->AddText (api_user_name ($fromuserdata['uname']) );
					$form->SetEndCol ();
				} elseif ( ($send2) || ($preview != '') ) {
					$to_userid = 0;
					get_var ('to_userid', $to_userid, 'both', _OOBJ_DTYPE_INT);
					$form->SetSameCol ();
					$tuid = $opnConfig['permission']->GetUser ($to_userid, 'useruid', '');
					$form->AddHidden ('to_user', $to_userid);
					$form->AddHidden ('to_userid', $to_userid);
					$form->AddText (api_user_name ($tuid['uname']) );
					$form->SetEndCol ();
				} else {
					$result = &$opnConfig['database']->Execute ('SELECT u.uid AS uid, u.uname AS uname FROM ' . $opnTables['users'] . ' u, ' . $opnTables['users_status'] . ' us WHERE ((us.uid=u.uid) AND (us.level1<>' . _PERM_USER_STATUS_DELETE . ') AND (u.uid <> ' . $opnConfig['opn_anonymous_id'] . ')) ORDER BY uname');
					$form->AddCheckField('to_userid', 's', _PMMSG_CLASS_NO_RECIPIENT);
					$form->AddSelectDB ('to_userid', $result, '', '', 0, 0, 0, 'select', '', 1);
				}
				$form->AddChangeRow ();
				$form->AddLabel ('msgiconselect', _PMMSG_CLASS_MESSAGE_ICON);
				$filelist = get_file_list (_OPN_ROOT_PATH . 'system/pm_msg/images/subject');
				natcasesort ($filelist);
				reset ($filelist);
				$form->SetSameCol ();
				$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/system/pm_msg/images/subject/blank.gif" name="msgicon" alt="" />');
				$form->AddText ('&nbsp;&nbsp;');
				$options = array ();
				foreach ($filelist as $file) {
					if (preg_match ('/.gif|.jpg|.png/', $file) ) {
						$options[$file] = $file;
					}
				}
				$form->AddSelect ('msgiconselect', $options, $msgiconselect, 'showimage()', 3);
				$form->SetEndCol ();
				unset ($filelist);
				$form->AddChangeRow ();
				$form->AddLabel ('subject', _PMMSG_CLASS_SUBJECT);
				if ($reply) {
					$form->AddTextfield ('subject', 50, 100, 'Re: ' . $row['subject']);
				} else {
					$form->AddTextfield ('subject', 50, 100, $subject);
				}
				$form->AddChangeRow ();
				$form->SetSameCol ();
				$form->AddLabel ($mytextareaname, _PMMSG_CLASS_MESSAGE);
				$form->AddText ('<br /><br />HTML : ');
				if ($opnConfig['allow_html_pm'] == 1) {
					$form->AddText ('On<br />');
				} else {
					$form->AddText ('Off<br />');
				}
				$form->SetEndCol ();
				if ($reply) {
					if ($msg_cat == 1) {
						$sql = 'SELECT p.msg_text AS msg_text, p.msg_time AS msg_time, u.uname AS uname FROM ' . $opnTables['priv_msgs'] . ' p, ' . $opnTables['users'] . ' u ';
						$sql .= 'WHERE (p.msg_id = ' . $msg_id . ') AND (p.from_userid = u.uid)';
					} else {
						$sql = 'SELECT p.msg_text AS msg_text, p.msg_time AS msg_time, u.uname AS uname FROM ' . $opnTables['priv_msgs_save'] . ' p, ' . $opnTables['users'] . ' u ';
						$sql .= 'WHERE (p.msg_cat=' . $msg_cat . ') AND (p.uid_id = ' . $this->_ui['uid'] . ') AND (p.msg_id = ' . $msg_id . ') AND (p.from_userid = u.uid)';
					}
					if ($result = &$opnConfig['database']->Execute ($sql) ) {
						$row = $result->GetRowAssoc ('0');
						$ui = $opnConfig['permission']->GetUserinfo ();
						$query = &$opnConfig['database']->Execute ('SELECT allowedemail, allowedpmmail, secret FROM ' . $opnTables['priv_msgs_userdatas'] . ' WHERE uid=' . $ui['uid']);
						if ($query !== false) {
							if ($query->RecordCount () == 1) {
								$allowedemail = $query->fields['allowedemail'];
								$allowedpmmail = $query->fields['allowedpmmail'];
								$secret = $query->fields['secret'];
							}
							$query->Close ();
						}
						if ( (isset ($secret) ) && ($secret == 1) ) {
							$row['msg_text'] = open_the_secret ($ui['pass'], $row['msg_text']);
						}
						if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
							$text = smilies_desmile ($row['msg_text']);
						} else {
							$text = $row['msg_text'];
						}
						$text = opn_br2nl ($text);
						$ubb = & new UBBCode;
						$ubb->ubbdecode ($text);
						$opnConfig['opndate']->sqlToopnData ($row['msg_time']);
						$temp = '';
						$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
						$reply = '<blockquote><em>' . _OPN_HTML_NL . $row['uname'] . ' (' . $temp . '):' . _OPN_HTML_NL . $text . _OPN_HTML_NL . '</em></blockquote>';
					} else {
						$reply = 'Error Contacting database. Please try again.' . _OPN_HTML_NL;
					}
				} else {
					$reply = '';
				}
				$form->UseSmilies (true);
				$form->AddTextarea ($mytextareaname, 0, 0, '', $reply . $message);
				$form->AddChangeRow ();
				$form->AddText (_PMMSG_CLASS_OPTIONS);
				$form->SetSameCol ();
				$form->AddCheckbox ('read_receipt', 1, $read_receipt);
				$form->AddLabel ('read_receipt', _PMMSG_CLASS_ENABLE_READ_RECEIPT_FOR_THIS_POST, 1);
				$form->AddNewline ();
				if ($opnConfig['allow_html_pm'] == 1) {
					$form->AddCheckbox ('html', 1, $html);
					$form->AddLabel ('html', _PMMSG_CLASS_DISABLE_HTML_ON_THIS_POST, 1);
					$form->AddNewline ();
				}
				if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
					$form->AddCheckbox ('smile', 1, $smile);
					$form->AddLabel ('smile', _PMMSG_CLASS_DISABLE . ' <a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/smilies/" target="_blank">Smilies</a> ' . _PMMSG_CLASS_ON_THIS_POST, 1);
					$form->AddNewline ();
				}
				// if
				if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_sig') ) {
					if ( ($opnConfig['allow_sig'] == 1) && (isset ($this->_ui['attachsig']) ) ) {
						$form->AddCheckbox ('sig', 1, $this->_ui['attachsig']);
						$form->AddLabel ('sig', _PMMSG_CLASS_SHOWSIG, 1);
						$form->AddNewline ();
					}
				}
				if (!isset ($msg_id) ) {
					$msg_id = '';
				}
				$form->AddText ('&nbsp;');
				$form->SetEndCol ();
				$form->AddChangeRow ();
				$form->AddHidden ('msg_id', $msg_id);
				$form->SetSameCol ();
				$form->AddSubmit ('preview', _PMMSG_CLASS_PREVIEW);
				$form->AddText ('&nbsp;');
				$form->AddSubmit ('submit', _PMMSG_CLASS_SUBMIT);
				$form->AddText ('&nbsp;');
				$form->AddReset ('Reset', _PMMSG_CLASS_CLEAR);
				if ($reply) {
					$form->AddText ('&nbsp;');
					$form->AddButton ('Cancel', _PMMSG_CLASS_CANCEL_REPLY, '', '', 'javascript:history.go(-1)');
				} else {
					$form->AddText ('&nbsp;');
					$form->AddButton ('Cancel', _PMMSG_CLASS_CANCEL_SEND, '', '', 'javascript:history.go(-1)');
				}
				$form->AddText ('&nbsp;');
				$form->SetEndCol ();
				$form->AddCloseRow ();
				$form->AddTableClose ();
				$form->AddFormEnd ();
				$form->GetFormular ($boxtxt);
				$boxtxt .= '<br />';
			}
			return $boxtxt;

		}

	}
}

?>