<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('system/robotstxt', true);
getLanguageDef (_OPN_ROOT_PATH . 'system/robotstxt/admin/language/');

function ROBConfigHeader () {

	global $opnConfig;

	$menu = & new OPN_Adminmenu (_ROBTXT_ADMIN);
	$menu->InsertEntry (_ROBTXT_ADMIN, $opnConfig['opn_url'] . '/system/robotstxt/admin/index.php');
	$menu->InsertEntry (_ROBTXT_DELROBOT, array ($opnConfig['opn_url'] . '/system/robotstxt/admin/index.php',
						'op' => 'delrobotstxt') );
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}
// sometime in future
$dir = '';
get_var ('dir', $dir, 'form', _OOBJ_DTYPE_CLEAN);
if ($dir == '') {
	$dir = '.';
	chdir (_OPN_ROOT_PATH);
}
if (is_dir ($dir) ) {
	chdir ($dir);
	$dir = getcwd ();
}
if ($dir[strlen ($dir)-1] != '/') {
	$dir .= '/';
}

function GetDirArrayRobot ($sPath) {

	$retVal = array ();
	$handle = opendir ($sPath);
	while ($file = readdir ($handle) ) {
		$retVal[count ($retVal)] = $file;
	}
	closedir ($handle);
	natcasesort ($retVal);
	return $retVal;

}
$secured = '';
if (!file_exists ('index.html') && !file_exists ('index.php') && !file_exists ('.htaccess') && !file_exists ('.htpasswd') ) {
	$secured .= _ROBTXT_INSECURE . '<br />';
} else {
	$secured .= _ROBTXT_SECURE;
	if (file_exists ('index.html') ) {
		$secured .= 'index.html, ';
	}
	if (file_exists ('index.php') ) {
		$secured .= 'index.php, ';
	}
	if (file_exists ('.htaccess') ) {
		$secured .= '.htaccess, ';
	}
	if (file_exists ('index.html') ) {
		$secured .= '.htpasswd, ';
	}
	$secured .= '<br />';
}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'delrobotstxt':
		$opnConfig['opnOutput']->DisplayHead ();
		ROBConfigHeader ();
		if (unlink ('robots.txt') ) {
			$boxtxt = _ROBTXT_DELROBOTOK . '<br />';
		} else {
			$boxtxt = _ROBTXT_DELROBOTFAULT . '<br />';
		}
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_ROBOTSTXT_10_';
		$_display_dat['module'] = 'system/robotstxt';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_ROBTXT_ADMIN, $boxtxt);
		$opnConfig['opnOutput']->DisplayFoot ();
		break;
	case 'update':
		$opnConfig['opnOutput']->DisplayHead ();
		ROBConfigHeader ();
		$dir = '';
		get_var ('dir', $dir, 'form', _OOBJ_DTYPE_CLEAN);
		$comment = '';
		get_var ('comment', $comment, 'form', _OOBJ_DTYPE_CLEAN);
		if ($dir == '.') {
			$file = _OPN_ROOT_PATH . 'robots.txt';
		} else {
			$file = $dir . 'robots.txt';
		}
		if (substr_count ($comment, '#') > 0) {
			$content = $comment . _OPN_HTML_NL . _OPN_HTML_NL;
		} else {
			$content = '# ' . $comment . _OPN_HTML_NL . _OPN_HTML_NL;
		}
		$content .= 'User-agent: *' . _OPN_HTML_NL;
		$d = GetDirArrayRobot ($dir);
		foreach ($d as $key=>$entry) {
			if (is_dir ($dir . $entry) && ($entry != '.') && ($entry != '..') ) {
				$my = '';
				get_var ('id_' . $key, $my, 'form', _OOBJ_DTYPE_CLEAN);
				if ($my != 'on') {
					$content .= 'Disallow: /' . $entry . '/' . _OPN_HTML_NL;
				}
			}
		}
		include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.file.php');
		$File = & new opnFile;
		$File->overwrite_file ($file, $content);
		if ($File->ERROR != '') {
			$boxtxt = $File->ERROR;
		} else {
			$boxtxt = _ROBTXT_CHANGESSAVED . '<br />';
		}
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_ROBOTSTXT_20_';
		$_display_dat['module'] = 'system/robotstxt';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_ROBTXT_ADMIN, $boxtxt);
		$opnConfig['opnOutput']->DisplayFoot ();
		break;
	default:
		$txt = '';
		$opnConfig['opnOutput']->DisplayHead ();
		ROBConfigHeader ();
		if (!file_exists ('robots.txt') ) {
			$comment = '';
			$secured .= '<br />' . _ROBTXT_NOFOUNDROBOT . '<br />';
		} else {
			$file = fopen ('robots.txt', 'r');
			$secured .= '<br />' . _ROBTXT_FOUNDROBOT . '<br />';
			$comment = fgets ($file, 1024);
			$dummy = fgets ($file, 1024);
			$dummy = fgets ($file, 1024);
			while (!feof ($file) ) {
				$line = fgets ($file, 1024);
				$line = substr ($line, 11, strlen ($line)-13);
				$disallowed[$line] = true;
			}
			fclose ($file);
		}
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_ROBOTSTXT_30_', 'robotstxt');
		$form->Init ($opnConfig['opn_url'] . '/system/robotstxt/admin/index.php');
		$d = GetDirArrayRobot ($dir);
		$PHP_SELF = '';
		get_var ('PHP_SELF', $PHP_SELF, 'server');
		foreach ($d as $key => $entry) {
			if (is_dir ($dir . $entry) && ($entry != '.') && ($entry != '..') ) {
				if ( (isset ($disallowed[$entry]) ) && ($disallowed[$entry]) ) {
					$form->AddCheckbox ('id_' . $key, 'on');
				} else {
					$form->AddCheckbox ('id_' . $key, 'on', 1);
				}
				$form->AddLabel ('id_' . $key, '&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($PHP_SELF,
												'changedir' => '1',
												'dir' => $dir . $entry) ) . '">' . $entry . '</a>',
												1);
				$form->AddText ('<br />');
			}
		}
		$form->Addnewline ();
		$form->AddLabel ('comment', 'comment:');
		$form->AddNewline ();
		$form->AddTextfield ('comment', 70, 0, $comment);
		$form->AddNewline (2);
		$form->AddHidden ('dir', $dir);
		$form->AddHidden ('op', 'update');
		$form->AddSubmit ('submity', _ROBTXT_SAVE_CHANGES);
		$form->AddFormEnd ();
		$form->GetFormular ($txt);
		$foot = _ROBTXT_USAGE;
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_ROBOTSTXT_40_';
		$_display_dat['module'] = 'system/robotstxt';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_ROBTXT_ADMIN, $secured);
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_ROBOTSTXT_50_';
		$_display_dat['module'] = 'system/robotstxt';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_ROBTXT_ADMIN, $txt, $foot);
		$opnConfig['opnOutput']->DisplayFoot ();
		break;
}

?>