<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

getLanguageDef (_OPN_ROOT_PATH . 'system/search/admin/language/');
$opnConfig['module']->InitModule ('system/search', true);
include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');

function search_ConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_SEARCH_ADMIN_ADMIN);
	$menu->InsertEntry (_SEARCH_ADMIN_MAIN, $opnConfig['opn_url'] . '/system/search/admin/index.php');
	$menu->InsertEntry (_SEARCH_ADMIN_DELETE, array ($opnConfig['opn_url'] . '/system/search/admin/index.php',
							'op' => 'delentries') );
	$menu->InsertEntry (_SEARCH_ADMIN_SETTINGS, $opnConfig['opn_url'] . '/system/search/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function search_show () {

	global $opnTables, $opnConfig;

	$sortby = 'asc_sid';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sql = 'SELECT COUNT(sid) AS counter FROM ' . $opnTables['search'] . ' WHERE sid <>0';
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( ($justforcounting !== false) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$sql = 'SELECT sid, searchtext, suser FROM ' . $opnTables['search'] . ' WHERE sid<>0';
	$sortby1 = _SEARCH_ORDERBY . ' ';
	$search = array ('asc_',
			'desc_');
	$replace = array ('',
			'');
	$s = str_replace ($search, $replace, $sortby);
	switch ($s) {
		case 'sid':
			$sortby1 .= _SEARCH_ID . '&nbsp;';
			break;
		case 'searchtext':
			$sortby1 .= _SEARCH_SEARCHTEXT . '&nbsp;';
			break;
		case 'suser':
			$sortby1 .= _SEARCH_USERNAME . '&nbsp;';
			break;
	}
	if (substr_count ($sortby, 'desc_')>0) {
		$sortby1 .= _SEARCH_ORDERDESC;
	} else {
		$sortby1 .= _SEARCH_ORDERASC;
	}
	$order = '';
	$oldsortby = $sortby;
	$progurl = array ($opnConfig['opn_url'] . '/system/search/admin/index.php');
	$boxtxt = '<div align="center" class="normaltext"><span class="normaltextbold">(' . _SEARCH_SEARCH . ')</span><br /><br />';
	$boxtxt .= $sortby1 . '</div><br /><br />' . _OPN_HTML_NL;
	$table = & new opn_TableClass ('alternator');
	$table->get_sort_order ($order, array ('sid',
						'searchtext',
						'suser'),
						$sortby);
	$table->AddHeaderRow (array ($table->get_sort_feld ('sid', _SEARCH_ID, $progurl), $table->get_sort_feld ('searchtext', _SEARCH_SEARCHTEXT, $progurl), $table->get_sort_feld ('suser', _SEARCH_USERNAME, $progurl) ) );
	$hresult = $opnConfig['database']->SelectLimit ($sql . $order, $maxperpage, $offset);
	if ($hresult !== false) {
		while (! $hresult->EOF) {
			$id = $hresult->fields['sid'];
			$searchtext = $hresult->fields['searchtext'];
			$user1 = $hresult->fields['suser'];
			if ($user1<1) {
				$user1 = 1;
			}
			$ui = $opnConfig['permission']->GetUser ($user1, 'userid', '');
			$table->AddDataRow (array ($id, $searchtext, $ui['uname']) );
			$hresult->MoveNext ();
		}
	}
	$table->GetTable ($boxtxt);
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/system/search/admin/index.php',
					'sortby' => $oldsortby),
					$reccount,
					$maxperpage,
					$offset);
	$boxtxt .= '<br /><br />' . $pagebar;
	return $boxtxt;

}

function search_delete () {

	global $opnConfig, $opnTables;

	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('delete from ' . $opnTables['search']);
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/system/search/admin/index.php', false) );
		CloseTheOpnDB ($opnConfig);
		return '';
	}
	$txt = '<div class="bigtextbold" align="center"><span class="alerttextcolor">';
	$txt .= _SEARCH_ADMIN_DELETEALL . '</span>';
	$txt .= '<br /><br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/search/admin/index.php">' . _NO . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/search/admin/index.php',
																									'op' => 'delentries',
																									'ok' => '1') ) . '">' . _YES . '</a></div>';
	return $txt;

}
$boxtxt = '';
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'delentries':
		$boxtxt = search_delete ();
		break;
	default:
		$boxtxt = search_show ();
		break;
}
search_ConfigHeader ();
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_SEARCH_10_';
$_display_dat['module'] = 'system/search';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayCenterbox (_SEARCH_TITEL, $boxtxt);
$opnConfig['opnOutput']->DisplayFoot ();

?>