<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'system/sections/plugin/search/language/');

function sections_retrieve_searchbuttons (&$buttons) {

	$button['name'] = 'sections';
	$button['sel'] = 0;
	$button['label'] = _SECSEARCH_SECTIONS;
	$buttons[] = $button;
	unset ($button);
	$button['name'] = 'stcomments';
	$button['sel'] = 0;
	$button['label'] = _SECSEARCH_SEARCH_COMMENTS;
	$buttons[] = $button;
	unset ($button);

}

function sections_retrieve_search ($type, $query, &$data, &$sap) {
	switch ($type) {
		case 'sections':
			sections_retrieve_all ($query, $data, $sap);
			break;
		case 'stcomments':
			sections_retrieve_comments ($query, $data, $sap);
			break;
	}

}

function sections_retrieve_all ($query, &$data, &$sap) {

	sections_retrieve_sections ($query, $data, $sap);
	sections_retrieve_comments ($query, $data, $sap);

}

function sections_retrieve_sections ($query, &$data, &$sap) {

	global $opnConfig;

	$q = sections_get_query ($query);
	$q .= sections_get_orderby ();
	$result = &$opnConfig['database']->Execute ($q);
	$hlp1 = array ();
	if ($result !== false) {
		$nrows = $result->RecordCount ();
		if ($nrows>0) {
			$hlp1['data'] = _SECSEARCH_SECTIONS;
			$hlp1['ishead'] = true;
			$data[] = $hlp1;
			while (! $result->EOF) {
				$artid = $result->fields['artid'];
				$secid = $result->fields['secid'];
				$title = $result->fields['title'];
				$content = $result->fields['content'];
				$hlp1['data'] = sections_build_link ($artid, $secid, $title, $content);
				$hlp1['ishead'] = false;
				$data[] = $hlp1;
				$result->MoveNext ();
			}
			unset ($hlp1);
			$sap++;
		}
		$result->Close ();
	}

}

function sections_get_query ($query) {

	global $opnTables, $opnConfig;

	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$opnConfig['opn_searching_class']->init ();
	$opnConfig['opn_searching_class']->SetFields (array ('s.artid',
							's.secid',
							's.title',
							's.content') );
	$opnConfig['opn_searching_class']->SetTable ($opnTables['seccont'] . ' s, ' . $opnTables['sections_cats'] . ' c');
	$opnConfig['opn_searching_class']->SetWhere (' s.secid=c.cat_id AND s.seccont_usergroup IN (' . $checkerlist . ') AND c.cat_usergroup IN (' . $checkerlist . ') AND');
	$opnConfig['opn_searching_class']->SetQuery ($query);
	$opnConfig['opn_searching_class']->SetSearchfields (array ('title',
								'content') );
	return $opnConfig['opn_searching_class']->GetSQL ();

}

function sections_get_orderby () {
	return ' ORDER BY artid DESC';

}

function sections_build_link ($artid, $secid, $title, $content) {

	global $opnConfig, $opnTables;

	$t = $content;
	$result2 = &$opnConfig['database']->Execute ('SELECT cat_name FROM ' . $opnTables['sections_cats'] . ' WHERE cat_id=' . $secid);
	$sectitle = $result2->fields['cat_name'];
	$result2->Close ();
	$surl = '' . encodeurl (array ($opnConfig['opn_url'] . '/system/sections/index.php',
					'secid' => $secid) );
	$furl = '' . encodeurl (array ($opnConfig['opn_url'] . '/system/sections/index.php',
					'op' => 'viewarticle',
					'artid' => $artid) );
	$hlp = '<a class="%linkclass%" href="' . $furl . '">' . $title . '</a> ';
	$hlp .= _SECSEARCH_BY . ' ';
	$hlp .= '<a class="%linkclass%" href="' . $surl . '">' . $sectitle . '</a>';
	return $hlp;

}

function sections_retrieve_comments ($query, &$data, &$sap) {

	global $opnConfig;

	$hlp1 = array ();
	$q = sections_comments_get_query ($query);
	$q .= sections_comments_get_orderby ();
	$result = &$opnConfig['database']->Execute ($q);
	if ($result !== false) {
		$nrows = $result->RecordCount ();
		if ($nrows>0) {
			$hlp1['data'] = _SECSEARCH_SEARCH_COMMENTS;
			$hlp1['ishead'] = true;
			$data[] = $hlp1;
			while (! $result->EOF) {
				$tid = $result->fields['tid'];
				$sid = $result->fields['sid'];
				$subject = $result->fields['subject'];
				$date = $result->fields['wdate'];
				$name = $result->fields['name'];
				$hlp1['data'] = sections_comments_build_link ($tid, $sid, $subject, $date, $name);
				$hlp1['ishead'] = false;
				$data[] = $hlp1;
				$result->MoveNext ();
			}
			unset ($hlp1);
			$sap++;
		}
		$result->Close ();
	}

}

function sections_comments_get_query ($query) {

	global $opnTables, $opnConfig;

	$opnConfig['opn_searching_class']->init ();
	$opnConfig['opn_searching_class']->SetFields (array ('tid',
							'sid',
							'subject',
							'wdate',
							'name') );
	$opnConfig['opn_searching_class']->SetTable ($opnTables['sections_comments']);
	$opnConfig['opn_searching_class']->SetQuery ($query);
	$opnConfig['opn_searching_class']->SetSearchfields (array ('subject',
								'comment',
								'name',
								'email',
								'url') );
	return $opnConfig['opn_searching_class']->GetSQL ();

}

function sections_comments_get_orderby () {
	return ' ORDER BY wdate DESC';

}

function sections_comments_build_link ($tid, $sid, $subject, $date, $name) {

	global $opnConfig;

	$furl = encodeurl (array ($opnConfig['opn_url'] . '/system/sections/index.php',
				'op' => 'viewarticle',
				'thold' => '-1',
				'mode' => 'flat',
				'order' => '1',
				'artid' => $sid),
				true,
				true,
				false,
				'#' . $tid);
	if (!$name) {
		$name = $opnConfig['opn_anonymous_name'];
	}
	$opnConfig['opndate']->sqlToopnData ($date);
	$datetime = '';
	$opnConfig['opndate']->formatTimestamp ($datetime, _DATE_DATESTRING5);
	$hlp = '<a class="%linkclass%" href="' . $furl . '">' . $subject . '</a> ';
	$hlp .= _SECSEARCH_SEARCH_BY1 . ' ' . $name . '&nbsp;' . _SECSEARCH_SEARCH_ON . ' ' . $datetime;
	$hlp .= _SECSEARCH_SEARCH_BY1 . ' <a class="%linkclass%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
											'op' => 'userinfo',
											'uname' => $name) ) . '">' . api_user_name ($name) . '</a> ';
	$hlp .= ' ' . _SECSEARCH_SEARCH_ON . ' ' . $datetime;
	return $hlp;

}

?>