<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('system/smilies', true);
getLanguageDef (_OPN_ROOT_PATH . 'system/smilies/admin/language/');
include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');

function smiliesConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_SMIADMIN_CONFIG);
	$menu->InsertEntry (_SMIADMIN_MAIN, $opnConfig['opn_url'] . '/system/smilies/admin/index.php');
	if ($opnConfig['permission']->HasRights ('system/smilies', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$menu->InsertEntry (_SMIADMIN_IMPORT,
										array ($opnConfig['opn_url'] . '/system/smilies/admin/index.php',
			'op' => 'import') );
	}
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function SmilesAdmin () {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sql = 'SELECT COUNT(id) AS counter FROM ' . $opnTables['smilies'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( ($justforcounting !== false) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	if ($getsmiles = &$opnConfig['database']->SelectLimit ('SELECT id, code, smile_url, emotion, smile_pos FROM ' . $opnTables['smilies'] . ' ORDER BY smile_pos', $maxperpage, $offset) ) {
		$numsmiles = $getsmiles->RecordCount ();
		if ($numsmiles == 0) {
			$boxtxt = '<span class="normaltext">' . sprintf (_SMIADMIN_NOSMILIES, encodeurl ($opnConfig['opn_url'] . '/system/smilies/admin/index.php?mode=add') ) . '</span>';
		} else {
			$table = & new opn_TableClass ('alternator');
			$table->AddHeaderRow (array ('&nbsp;', _SMIADMIN_CODE, _SMIADMIN_SMILE, _SMIADMIN_FUNCTIONS) );
			while (! $getsmiles->EOF) {
				$smiles = $getsmiles->GetRowAssoc ('0');
				$id = $smiles['id'];
				$pos = $smiles['smile_pos'];
				$hlp = '';
				if ($opnConfig['permission']->HasRights ('system/smilies', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/system/smilies/admin/index.php',
												'op' => 'SmilesEdit',
												'offset' => $offset,
												'id' => $smiles['id']) ) . ' ';
				}
				if ($opnConfig['permission']->HasRights ('system/smilies', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/system/smilies/admin/index.php',
												'op' => 'SmilesDel',
												'offset' => $offset,
												'id' => $smiles['id']) );
				}
				if ($hlp == '') {
					$hlp = '&nbsp;';
				}
				$hlp2 = '';
				if ($opnConfig['permission']->HasRights ('system/smilies', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
					$hlp2 .= $opnConfig['defimages']->get_up_link (array ($opnConfig['opn_url'] . '/system/smilies/admin/index.php',
												'op' => 'moving',
												'offset' => $offset,
												'id' => $id,
												'newpos' => ($pos-1.5) ) );
					$hlp2 .= '&nbsp;' . _OPN_HTML_NL;
					$hlp2 .= $opnConfig['defimages']->get_down_link (array ($opnConfig['opn_url'] . '/system/smilies/admin/index.php',
												'op' => 'moving',
												'offset' => $offset,
												'id' => $id,
												'newpos' => ($pos+1.5) ) );
				}
				if ($hlp2 == '') {
					$hlp2 = '&nbsp;';
				}
				$table->AddDataRow (array ($hlp2, $smiles['code'], '<img src="' . $smiles['smile_url'] . '" alt="" />', $hlp), array ('center', 'left', 'center', 'left') );
				$getsmiles->MoveNext ();
			}
			$boxtxt = '';
			$table->GetTable ($boxtxt);
			$boxtxt .= '<br /><br />' . _OPN_HTML_NL;
			$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/system/smilies/admin/index.php'),
							$reccount,
							$maxperpage,
							$offset);
			$boxtxt .= $pagebar . '<br /><br />';
		}
	} else {
		$boxtxt .= _SMIADMIN_ERRORDB;
	}
	if ($opnConfig['permission']->HasRights ('system/smilies', array (_PERM_NEW, _PERM_ADMIN, _SMILIES_PERM_UPLOAD), true) ) {
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_SMILIES_10_', 'smilies');
		if ($opnConfig['permission']->HasRights ('system/smilies', array (_PERM_ADMIN, _SMILIES_PERM_UPLOAD), true) ) {
			$form->Init ($opnConfig['opn_url'] . '/system/smilies/admin/index.php',
											'post',
											'',
											'multipart/form-data');
		} else {
			$form->Init ($opnConfig['opn_url'] . '/system/smilies/admin/index.php');
		}
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('code', _SMIADMIN_SMILECODE);
		$form->AddTextfield ('code');
		$form->AddChangeRow ();
		$form->AddLabel ('smile_url', _SMIADMIN_SMILEURL);
		$form->AddTextfield ('smile_url');
		$form->AddChangeRow ();
		$form->AddLabel ('emotion', _SMIADMIN_SMILEEMOTION);
		$form->AddTextfield ('emotion');
		if ($opnConfig['permission']->HasRights ('system/smilies', array (_PERM_ADMIN, _SMILIES_PERM_UPLOAD), true) ) {
			$form->AddChangeRow ();
			$form->AddLabel ('userupload', _SMIADMIN_SMILEUPLOAD);
			$form->AddFile ('userupload');
		}
		$form->AddChangeRow ();
		$form->SetSameCol ();
		if ($opnConfig['permission']->HasRights ('system/smilies', array (_PERM_ADMIN, _SMILIES_PERM_UPLOAD), true) ) {
		} else {
			$form->AddHidden ('userupload',
											'none');
		}
		$form->AddHidden ('op', 'SmilesAdd');
		$form->AddHidden ('offset', $offset);
		$form->SetEndCol ();
		$form->AddSubmit ('submit', _SMIADMIN_ADD);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	return $boxtxt;

}

function SmilesEdit () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('system/smilies', array (_PERM_EDIT, _PERM_ADMIN) );
	$boxtxt = '<div class="normaltext">';
	if ($getsmiles = &$opnConfig['database']->SelectLimit ('SELECT id, code, smile_url, emotion, smile_pos FROM ' . $opnTables['smilies'] . " WHERE id = $id", 1) ) {
		$numsmiles = $getsmiles->RecordCount ();
		if ($numsmiles == 0) {
			$boxtxt = '<span class="normaltext">' . sprintf (_SMIADMIN_NOSMILIES, encodeurl ($opnConfig['opn_url'] . '/system/smilies/admin/index.php?mode=add') ) . '</span>';
		} else {
			$smiles = $getsmiles->GetRowAssoc ('0');
			if ($smiles) {
				$form = & new opn_FormularClass ('listalternator');
				$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_SMILIES_20_', 'smilies');
				$form->Init ($opnConfig['opn_url'] . '/system/smilies/admin/index.php');
				$form->AddTable ();
				$form->AddCols (array ('10%', '90%') );
				$form->AddOpenRow ();
				$form->AddLabel ('code', _SMIADMIN_SMILECODE);
				$form->AddTextfield ('code', 0, 0, $smiles['code']);
				$form->AddChangeRow ();
				$form->AddLabel ('smile_url', _SMIADMIN_SMILEURL);
				$form->AddTextfield ('smile_url', 0, 0, $smiles['smile_url']);
				$form->AddChangeRow ();
				$form->AddLabel ('emotion', _SMIADMIN_SMILEEMOTION);
				$form->AddTextfield ('emotion', 0, 0, $smiles['emotion']);
				$form->AddChangeRow ();
				$form->AddLabel ('position', _SMIADMIN_POSITION);
				$form->AddTextfield ('position', 0, 0, $smiles['smile_pos']);
				$form->AddChangeRow ();
				$form->SetSameCol ();
				$form->AddHidden ('id', $smiles['id']);
				$form->AddHidden ('op', 'SmilesSave');
				$form->AddHidden ('offset', $offset);
				$form->SetEndCol ();
				$form->AddSubmit ('submit', _SMIADMIN_SAVE);
				$form->AddCloseRow ();
				$form->AddTableClose ();
				$form->AddFormEnd ();
				$form->GetFormular ($boxtxt);
			}
		}
	} else {
		$boxtxt .= _SMIADMIN_ERRORDB;
	}
	$boxtxt .= '</div>';
	return $boxtxt;

}

function SmilesDel () {

	global $opnTables, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('system/smilies', array (_PERM_DELETE, _PERM_ADMIN) );
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['smilies'] . ' WHERE id=' . $id);
		return '';
	}
	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$boxtxt = '<div class="bigtextbold" align="center"><br />';
	$boxtxt .= '<span class="alerttextcolor">';
	$boxtxt .= _SMIADMIN_WARNING . '<br /><br /></span>';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/smilies/admin/index.php',
									'op' => 'SmilesDel',
									'offset' => $offset,
									'id' => $id,
									'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/smilies/admin/index.php?op=SmileAdmin') . '">' . _NO . '</a><br /><br /></div>' . _OPN_HTML_NL;
	return $boxtxt;

}

function SmilesAdd () {

	global $opnTables, $opnConfig;

	$code = '';
	get_var ('code', $code, 'form', _OOBJ_DTYPE_CLEAN);
	$smile_url = '';
	get_var ('smile_url', $smile_url, 'form', _OOBJ_DTYPE_URL);
	$emotion = '';
	get_var ('emotion', $emotion, 'form', _OOBJ_DTYPE_CLEAN);
	$userupload = '';
	get_var ('userupload', $userupload, 'file');
	$auto = 0;
	get_var ('auto', $auto, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('system/smilies', array (_PERM_NEW, _PERM_ADMIN, _SMILIES_PERM_UPLOAD) );
	if ($code) {
		$skipsave = false;
		if ($auto == 0) {
			if ($userupload == '') {
				$userupload = 'none';
			}
			$userupload = check_upload ($userupload);
			if ( ($userupload <> 'none') && ($smile_url == '') ) {
				require (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.fileupload.php');
				$upload = & new file_upload_class;
				$upload->max_filesize ($opnConfig['opn_upload_size_limit']);
				if ($upload->upload ('userupload', 'image', '') ) {
					if ($upload->save_file ($opnConfig['datasave']['mysmilies']['path'], 3) ) {
						$filename = $upload->file['name'];
					}
				}
				if (isset ($upload->errors) ) {
					foreach ($upload->errors as $var) {
						echo '<br /><br />' . $var . '<br />';
						$skipsave = true;
					}
				}
			}
			if (isset ($filename) ) {
				$smile_url = $filename;
				$smile_url = $opnConfig['opnSQL']->qstr ($opnConfig['datasave']['mysmilies']['url'] . '/' . $smile_url);
			} else {
				$smile_url = $opnConfig['opnSQL']->qstr ($smile_url);
			}
		} else {
			$smile_url = $opnConfig['opnSQL']->qstr ($smile_url);
			$result = $opnConfig['database']->Execute ('SELECT COUNT(id) AS counter FROM ' . $opnTables['smilies'] . " WHERE smile_url=$smile_url");
			$counter = $result->fields['counter'];
			$result->Close ();
			unset ($result);
			if ($counter >= 1) {
				$skipsave = true;
			}
		}
		$code = $opnConfig['opnSQL']->qstr ($code);
		$emotion = $opnConfig['opnSQL']->qstr ($emotion);
		if ($skipsave == false) {
			$id = $opnConfig['opnSQL']->get_new_number ('smilies', 'id');
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['smilies'] . " (id, code, smile_url, emotion, smile_pos) VALUES ($id, $code,$smile_url,$emotion, $id)");
			if ($opnConfig['database']->ErrorNo ()>0) {
				$boxtxt = $opnConfig['database']->ErrorNo () . ' --- ' . $opnConfig['database']->ErrorMsg () . '<br />';
				return $boxtxt;
			}
		}
	}
	return '';

}

function SmilesSave () {

	global $opnTables, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$code = '';
	get_var ('code', $code, 'form', _OOBJ_DTYPE_CLEAN);
	$smile_url = '';
	get_var ('smile_url', $smile_url, 'form', _OOBJ_DTYPE_URL);
	$emotion = '';
	get_var ('emotion', $emotion, 'form', _OOBJ_DTYPE_CLEAN);
	$position = 0;
	get_var ('position', $position, 'form', _OOBJ_DTYPE_CLEAN);
	$opnConfig['permission']->HasRights ('system/smilies', array (_PERM_EDIT, _PERM_ADMIN) );
	$result = $opnConfig['database']->Execute ('SELECT smile_pos FROM ' . $opnTables['smilies'] . ' WHERE id=' . $id);
	$pos = $result->fields['smile_pos'];
	$result->Close ();
	$code = $opnConfig['opnSQL']->qstr ($code);
	$smile_url = $opnConfig['opnSQL']->qstr ($smile_url);
	$emotion = $opnConfig['opnSQL']->qstr ($emotion);
	// smile_pos
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['smilies'] . " SET code = $code, smile_url = $smile_url, emotion = $emotion WHERE id = $id");
	if ($opnConfig['database']->ErrorNo ()>0) {
		$boxtxt = $opnConfig['database']->ErrorNo () . ' --- ' . $opnConfig['database']->ErrorMsg () . '<br />';
		return $boxtxt;
	}
	if ($pos != $position) {
		set_var ('id', $id, 'url');
		set_var ('newpos', $position, 'url');
		SmilesMove ();
		unset_var ('id', 'url');
		unset_var ('newpos', 'url');
	}
	return '';

}

function SmilesImport () {

	global $opnConfig;

	$opnConfig['permission']->HasRights ('system/smilies', array (_PERM_NEW, _PERM_ADMIN, _SMILIES_PERM_UPLOAD) );
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_SMILIES_30_', 'smilies');
	$form->Init ($opnConfig['opn_url'] . '/system/smilies/admin/index.php');
	$form->AddText (sprintf (_SMIADMIN_IMPORT_PATH, '<strong>' . $opnConfig['datasave']['mysmilies']['path'] . '</strong>', '<strong>' . _OPN_ROOT_PATH . 'system/smilies/images/</strong>') );
	$form->AddNewLine (2);
	$form->AddHidden ('op', 'doimport');
	$form->AddSubmit ('submit', _SMIADMIN_IMPORT);
	$form->AddFormEnd ();
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function SmilesMove () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$newpos = 0;
	get_var ('newpos', $newpos, 'url', _OOBJ_DTYPE_CLEAN);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['smilies'] . " SET smile_pos=$newpos WHERE id=$id");
	$result = &$opnConfig['database']->Execute ('SELECT id FROM ' . $opnTables['smilies'] . ' ORDER BY smile_pos');
	$mypos = 0;
	while (! $result->EOF) {
		$row = $result->GetRowAssoc ('0');
		$mypos++;
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['smilies'] . " SET smile_pos=$mypos WHERE id=" . $row['id']);
		$result->MoveNext ();
	}

}

function SmilesDoImport ($path, $url) {

	$filelist = get_file_list ($path);
	natcasesort ($filelist);
	reset ($filelist);
	$boxtxt = '';
	foreach ($filelist as $file) {
		if (!preg_match ('/.gif|.jpg|.png/', $file) ) {
		} else {
			$code = explode ('.', $file);
			$code = ':' . $code[0] . ':';
			set_var ('smile_url', $url . '/' . $file, 'form');
			set_var ('emotion', '', 'form');
			set_var ('code', $code, 'form');
			set_var ('auto', 1, 'form');
			$txt = SmilesAdd ();
			if ($txt != '') {
				$boxtxt .= $txt;
			}
			unset_var ('smile_url', 'form');
			unset_var ('emotion', 'form');
			unset_var ('code', 'form');
			unset_var ('auto', 'form');
		}
	}
	unset ($filelist);
	return $boxtxt;

}
$boxtxt = '';
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	default:
		$boxtxt .= SmilesAdmin ();
		break;
	case 'SmilesAdmin':
		$boxtxt .= SmilesAdmin ();
		break;
	case 'SmilesEdit':
		$boxtxt .= SmilesEdit ();
		break;
	case 'SmilesDel':
		$txt = SmilesDel ();
		if ($txt == '') {
			$boxtxt .= SmilesAdmin ();
		} else {
			$boxtxt .= $txt;
		}
		break;
	case 'SmilesAdd':
		$txt = SmilesAdd ();
		if ($txt == '') {
			$boxtxt .= SmilesAdmin ();
		} else {
			$boxtxt .= $txt;
		}
		break;
	case 'SmilesSave':
		$txt = SmilesSave ();
		if ($txt == '') {
			$boxtxt .= SmilesAdmin ();
		} else {
			$boxtxt .= $txt;
		}
		break;
	case 'moving':
		SmilesMove ();
		$boxtxt .= SmilesAdmin ();
		break;
	case 'import':
		$boxtxt .= SmilesImport ();
		break;
	case 'doimport':
		$opnConfig['permission']->HasRights ('system/smilies', array (_PERM_NEW, _PERM_ADMIN) );
		$boxtxt .= SmilesDoImport ($opnConfig['datasave']['mysmilies']['path'], $opnConfig['datasave']['mysmilies']['url']);
		$boxtxt .= SmilesDoImport (_OPN_ROOT_PATH . 'system/smilies/images/', $opnConfig['opn_url'] . '/system/smilies/images');
		$boxtxt .= SmilesAdmin ();
		break;
}
smiliesConfigHeader ();
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_SMILIES_40_';
$_display_dat['module'] = 'system/smilies';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayCenterbox (_SMIADMIN_SMILIES, $boxtxt);
$opnConfig['opnOutput']->DisplayFoot ();

?>