<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('system/statistics', true);
$privsettings = $opnConfig['module']->GetPrivateSettings ();
$pubsettings = $opnConfig['module']->GetPublicSettings ();
getLanguageDef (_OPN_ROOT_PATH . 'system/statistics/admin/language/');

function statistics_allhiddens ($wichSave) {

	$values[] = array ('type' => _INPUT_BLANKLINE,
			'noautotable' => 1);
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => urlencode ($wichSave) );
	$nav[_STAT_NAVGENERAL] = _STAT_NAVGENERAL;
	$nav[_STAT_NAVIPEXCLUDE] = _STAT_NAVIPEXCLUDE;
	$nav[_STAT_NAVUSEREXCLUDE] = _STAT_NAVUSEREXCLUDE;
	$nav[_STAT_NAVURLEXCLUDE] = _STAT_NAVURLEXCLUDE;
	$nav[_INPUT_BLANKLINE] = _INPUT_BLANKLINE;
	$nav[_STAT_SAVE] = _STAT_SAVE;
	$nav[_STAT_ADMIN] = _STAT_ADMIN;
	$nav[$wichSave] = '';
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav,
			'rt' => 5);
	return $values;

}

function statisticsettings () {

	global $opnConfig, $pubsettings, $privsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _STAT_GENERAL);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _STAT_ADVSTAT,
			'name' => 'advancedstats',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['advancedstats'] == 1?true : false),
			 ($privsettings['advancedstats'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _STAT_DATESTAT,
			'name' => 'stats_datestats',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['stats_datestats'] == 1?true : false),
			 ($pubsettings['stats_datestats'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _STAT_MODULSTAT,
			'name' => 'stats_modulstats',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['stats_modulstats'] == 1?true : false),
			 ($pubsettings['stats_modulstats'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _STAT_HFEXCLUDE,
			'name' => 'stats_stop',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['stats_stop'] == 1?true : false),
			 ($pubsettings['stats_stop'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _STAT_DISPLAY_USER,
			'name' => 'stats_view_user',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['stats_view_user'] == 1?true : false),
			 ($privsettings['stats_view_user'] == 0?true : false) ) );
	$values = array_merge ($values, statistics_allhiddens (_STAT_NAVGENERAL) );
	$set->GetTheForm (_STAT_SETTINGS, $opnConfig['opn_url'] . '/system/statistics/admin/settings.php', $values);

}

function ipsettings () {

	global $opnConfig, $pubsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _STAT_IPEXCLUDE);
	for ($i = 0; $i<count ($pubsettings['stats_ip']); $i++) {
		$values[] = array ('type' => _INPUT_TEXT,
				'display' => _STAT_IPEX,
				'name' => "exclude_ip_$i",
				'value' => $pubsettings['stats_ip'][$i],
				'size' => 15,
				'maxlength' => 15);
	}
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _STAT_ADDIP);
	$values = array_merge ($values, statistics_allhiddens (_STAT_NAVIPEXCLUDE) );
	$set->GetTheForm (_STAT_SETTINGS, $opnConfig['opn_url'] . '/system/statistics/admin/settings.php', $values);

}

function usersettings () {

	global $opnConfig, $pubsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _STAT_USEREXCLUDE);
	for ($i = 0; $i<count ($pubsettings['stats_user']); $i++) {
		$values[] = array ('type' => _INPUT_TEXT,
				'display' => _STAT_USEREX,
				'name' => "exclude_user_$i",
				'value' => $pubsettings['stats_user'][$i],
				'size' => 25,
				'maxlength' => 25);
	}
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _STAT_ADDUSER);
	$values = array_merge ($values, statistics_allhiddens (_STAT_NAVUSEREXCLUDE) );
	$set->GetTheForm (_STAT_SETTINGS, $opnConfig['opn_url'] . '/system/statistics/admin/settings.php', $values);

}

function urlsettings () {

	global $opnConfig, $pubsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _STAT_URLEXCLUDE);
	for ($i = 0; $i<count ($pubsettings['stats_url']); $i++) {
		$values[] = array ('type' => _INPUT_TEXT,
				'display' => _STAT_URLEX,
				'name' => "exclude_url_$i",
				'value' => $pubsettings['stats_url'][$i],
				'size' => 50,
				'maxlength' => 100);
	}
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _STAT_ADDURL);
	$values = array_merge ($values, statistics_allhiddens (_STAT_NAVURLEXCLUDE) );
	$set->GetTheForm (_STAT_SETTINGS, $opnConfig['opn_url'] . '/system/statistics/admin/settings.php', $values);

}

function statistics_dosavesettings () {

	global $opnConfig, $privsettings, $pubsettings;

	$opnConfig['module']->SetPrivateSettings ($privsettings);
	$opnConfig['module']->SavePrivateSettings ();
	$opnConfig['module']->SetPublicSettings ($pubsettings);
	$opnConfig['module']->SavePublicSettings ();

}

function statistics_dosavestatistic ($vars) {

	global $privsettings, $pubsettings;

	$privsettings['advancedstats'] = $vars['advancedstats'];
	$pubsettings['stats_datestats'] = $vars['stats_datestats'];
	$pubsettings['stats_modulstats'] = $vars['stats_modulstats'];
	$pubsettings['stats_stop'] = $vars['stats_stop'];
	$privsettings['stats_view_user'] = $vars['stats_view_user'];
	statistics_dosavesettings ();

}

function statistics_dosaveip ($vars) {

	global $pubsettings;

	$pubsettings['stats_ip'] = array ();
	$i = 0;
	foreach ($vars as $key => $value) {
		if (substr_count ($key, 'exclude_ip')>0) {
			if ($value != '') {
				$pubsettings['stats_ip'][$i] = $value;
				$i++;
			}
		}
	}
	statistics_dosavesettings ();

}

function statistics_dosaveuser ($vars) {

	global $pubsettings;

	$pubsettings['stats_user'] = array ();
	$i = 0;
	foreach ($vars as $key => $value) {
		if (substr_count ($key, 'exclude_user')>0) {
			if ($value != '') {
				$pubsettings['stats_user'][$i] = $value;
				$i++;
			}
		}
	}
	statistics_dosavesettings ();

}

function statistics_dosaveurl ($vars) {

	global $pubsettings;

	$pubsettings['stats_url'] = array ();
	$i = 0;
	foreach ($vars as $key => $value) {
		if (substr_count ($key, 'exclude_url')>0) {
			if ($value != '') {
				$pubsettings['stats_url'][$i] = $value;
				$i++;
			}
		}
	}
	statistics_dosavesettings ();

}

function statistics_dosave ($returns) {

	$op = urldecode ($returns['save']);
	switch ($op) {
		case _STAT_NAVGENERAL:
			statistics_dosavestatistic ($returns);
			break;
		case _STAT_NAVIPEXCLUDE:
			statistics_dosaveip ($returns);
			break;
		case _STAT_NAVUSEREXCLUDE:
			statistics_dosaveuser ($returns);
			break;
		case _STAT_NAVURLEXCLUDE:
			statistics_dosaveurl ($returns);
			break;
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		statistics_dosave ($result);
	} else {
		$result = '';
	}
}
$op = urldecode ($op);
switch ($op) {
	case _STAT_SAVE:
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/system/statistics/admin/settings.php',
								'op' => $result['save']),
								false) );
		CloseTheOpnDB ($opnConfig);
		break;
	case _STAT_ADMIN:
		$opnConfig['opnOutput']->Redirect ('/system/statistics/admin/index.php');
		CloseTheOpnDB ($opnConfig);
		break;
	case _STAT_ADDIP:
		$pubsettings['stats_ip'][count ($pubsettings['stats_ip'])] = '0.0.0.0';
		statistics_dosavesettings ();
		ipsettings ();
		break;
	case _STAT_ADDUSER:
		$pubsettings['stats_user'][count ($pubsettings['stats_user'])] = '??????????';
		statistics_dosavesettings ();
		usersettings ();
		break;
	case _STAT_ADDURL:
		$pubsettings['stats_url'][count ($pubsettings['stats_url'])] = '/';
		statistics_dosavesettings ();
		urlsettings ();
		break;
	case _STAT_NAVIPEXCLUDE:
		ipsettings ();
		break;
	case _STAT_NAVUSEREXCLUDE:
		usersettings ();
		break;
	case _STAT_NAVURLEXCLUDE:
		urlsettings ();
		break;
	default:
		statisticsettings ();
		break;
}

?>