<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig, $opnTables;
if ($opnConfig['permission']->HasRights ('system/statistics', array (_PERM_READ, _PERM_BOT) ) ) {
	$opnConfig['module']->InitModule ('system/statistics');
	$opnConfig['opnOutput']->setMetaPageName ('system/statistics');
	getLanguageDef (_OPN_ROOT_PATH . 'system/statistics/language/');
	include_once (_OPN_ROOT_PATH . 'system/statistics/stats.php');
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_STATISTICS_30_';
	$_display_dat['module'] = 'system/statistics';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayHead ();
	$op = '';
	get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
	$year = '';
	get_var ('year', $year, 'url', _OOBJ_DTYPE_CLEAN);
	if ($year == '') {
		$year = date ('Y');
	}
	$month = '';
	get_var ('month', $month, 'url', _OOBJ_DTYPE_CLEAN);
	if ($month == '') {
		$month = date ('n');
	}
	$day = '';
	get_var ('day', $day, 'url', _OOBJ_DTYPE_CLEAN);
	if ($day == '') {
		$day = date ('j');
	}
	$weekday = '';
	get_var ('weekday', $weekday, 'url', _OOBJ_DTYPE_CLEAN);
	if ($weekday == '') {
		$weekday = date ('w');
	}
	$mon = sprintf ('%02d', $month);
	$d = sprintf ('%02d', $day);
	$today = $year . '-' . $mon . '-' . $d . ' 00:00:00';
	$opnConfig['opndate']->setTimestamp ($today);
	$weekno = '';
	get_var ('weekno', $weekno, 'url', _OOBJ_DTYPE_CLEAN);
	if ($weekno == '') {
		$opnConfig['opndate']->formatTimestamp ($weekno, '%U');
	}
	$monthn = '';
	$opnConfig['opndate']->formatTimestamp ($monthn, '%B');
	$date['year'] = $year;
	$date['month'] = $month;
	$date['day'] = $day;
	$date['monthname'] = $monthn;
	$date['date'] = $today;
	$date['formdate'] = '';
	$opnConfig['opndate']->formatTimestamp ($date['formdate'], _DATE_DATESTRING4);
	$date['weekno'] = $weekno;
	$date['weekday'] = $weekday;
	$backlinks = '<div class="centertag">[ <a class="normaltext" href="' . $opnConfig['opn_url'] . '/system/statistics/index.php">' . _STATS_RETURNBASICSTATS . '</a> | ';
	$backlinks .= '<a class="normaltext" href="' . encodeurl ($opnConfig['opn_url'] . '/system/statistics/index.php?op=detail') . '">' . _STATS_BACKDETAIL . '</a> ]</div>';
	$backlinks = '<br />' . $backlinks;
	switch ($op) {
		default:
			stats ();
			break;
		case 'osview':
			statsosview ();
			break;
		case 'browserview':
			statsbrowserview ();
			break;
		case 'detail':
			statsdetails ();
			break;
		case 'year':
			count_total ();
			$boxtxt = $backlinks;
			$boxtxt .= '<br />' . showYear ();
			$boxtxt .= $backlinks;
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_STATISTICS_40_';
			$_display_dat['module'] = 'system/statistics';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (_STATS_YEARLY . ' ' . $year, $boxtxt);
			break;
		case 'month':
			count_total ();
			$boxtxt = $backlinks;
			$boxtxt .= '<br />' . showMonth ();
			$boxtxt .= $backlinks;
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_STATISTICS_50_';
			$_display_dat['module'] = 'system/statistics';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (sprintf (_STATS_DAILY, $date['monthname'] . ' ' . $date['year']), $boxtxt);
			break;
		case 'day':
			count_total ();
			$boxtxt = $backlinks;
			$boxtxt .= '<br />' . showDay ();
			$boxtxt .= $backlinks;
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_STATISTICS_60_';
			$_display_dat['module'] = 'system/statistics';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (sprintf (_STATS_HOOURLY, $date['formdate']), $boxtxt);
			break;
		case 'week':
			count_total ();
			$boxtxt = $backlinks;
			$boxtxt .= '<br />' . showWeek ();
			$boxtxt .= $backlinks;
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_STATISTICS_70_';
			$_display_dat['module'] = 'system/statistics';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (sprintf (_STATS_WEEKLY, _STATS_WEEKNONAME . ' ' . $date['weekno'] . ' ' . $date['year']), $boxtxt);
			break;
		case 'weekdaymonth':
			count_total ();
			$boxtxt = $backlinks;
			$boxtxt .= '<br />' . showWeekdayMonth ();
			$boxtxt .= $backlinks;
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_STATISTICS_80_';
			$_display_dat['module'] = 'system/statistics';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (sprintf (_STATS_DAILY, $date['monthname'] . ' ' . $date['year']), $boxtxt);
			break;
	}
	$opnConfig['opnOutput']->DisplayFoot ();
}

?>