<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

getLanguageDef (_OPN_ROOT_PATH . 'system/theme_group/admin/language/');
include_once (_OPN_ROOT_PATH . 'include/opn_ini_options_get.php');

function ThemeGroupConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_THEMEGR_THEMECONFIG);
	$menu->InsertEntry (_THEMEGR_MAIN, $opnConfig['opn_url'] . '/system/theme_group/admin/index.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function ThemeGroupAdmin () {

	global $opnTables, $opnConfig;

	$boxtxt = '';
	$sql = 'SELECT COUNT(theme_group_id) AS counter FROM ' . $opnTables['opn_theme_group'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	if ($reccount >= 1) {
		$table = & new opn_TableClass ('alternator');
		$table->AddHeaderRow (array ('&nbsp;', _THEMEGR_THEMEID, _THEMEGR_THEMETITLE, _THEMEGR_THEMELANG, _THEMEGR_THEMEUSERGROUP, '&nbsp;', _THEMEGR_POS) );
		$result = &$opnConfig['database']->Execute ('SELECT theme_group_id, theme_group_text, theme_group_visible, theme_group_pos, theme_group_usergroup, theme_group_lang FROM ' . $opnTables['opn_theme_group'] . ' ORDER BY theme_group_pos');
		while (! $result->EOF) {
			$theme_group_id = $result->fields['theme_group_id'];
			$theme_group_text = $result->fields['theme_group_text'];
			$theme_group_visible = $result->fields['theme_group_visible'];
			$theme_group_pos = $result->fields['theme_group_pos'];
			$theme_group_usergroup = $result->fields['theme_group_usergroup'];
			$theme_group_lang = $result->fields['theme_group_lang'];
			$table->AddOpenRow ();
			$hlp = '';
			$url = array ();
			$url[0] = $opnConfig['opn_url'] . '/system/theme_group/admin/index.php?';
			$url['op'] = 'change_visible';
			$url['id'] = $theme_group_id;
			if ($theme_group_visible == 0) {
				$url['visible'] = 1;
			} else {
				$url['visible'] = 0;
			}
			$table->AddDataCol ($opnConfig['defimages']->get_activate_deactivate_link ($url, $theme_group_visible, '', _OFF, _ON), 'center');
			$table->AddDataCol ($theme_group_id, 'center');
			$table->AddDataCol ($theme_group_text, 'center');
			$table->AddDataCol ($theme_group_lang, 'center');
			$table->AddDataCol ($theme_group_usergroup, 'center');
			$hlp = '';
			if ($opnConfig['permission']->HasRights ('system/theme_group', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/system/theme_group/admin/index.php?',
											'op' => 'ThemeGroupEdit',
											'theme_group_id' => $theme_group_id) );
			}
			$hlp .= ' ';
			if ($opnConfig['permission']->HasRights ('system/theme_group', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/system/theme_group/admin/index.php?',
											'op' => 'ThemeGroupDel',
											'theme_group_id' => $theme_group_id,
											'ok' => '0') );
			}
			$table->AddDataCol ($hlp, 'center');
			$move_up = $opnConfig['defimages']->get_up_link (array ($opnConfig['opn_url'] . '/system/theme_group/admin/index.php',
											'op' => 'ThemeOrder',
											'id' => $theme_group_id,
											'new_pos' => ($theme_group_pos-1.5) ) );
			$move_down = $opnConfig['defimages']->get_down_link (array ($opnConfig['opn_url'] . '/system/theme_group/admin/index.php',
											'op' => 'ThemeOrder',
											'id' => $theme_group_id,
											'new_pos' => ($theme_group_pos+1.5) ) );
			$move_space = '&nbsp;';
			$table->AddDataCol ($move_up . $move_space . $move_down, 'center');
			$table->AddCloseRow ();
			$result->MoveNext ();
		}
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br /><br />';
	}
	if ($opnConfig['permission']->HasRights ('system/theme_group', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$boxtxt .= '<span class="extratextbold">' . _THEMEGR_ADDGROUP . '<br /><br /></span>';
		$boxtxt .= '<div class="normaltext">';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_THEME_GROUP_10_', 'theme_group');
		$form->Init ($opnConfig['opn_url'] . '/system/theme_group/admin/index.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('theme_group_text', _THEMEGR_THEMETITLE . ' ');
		$form->AddTextfield ('theme_group_text', 31);
		$form->AddChangeRow ();
		$form->AddLabel ('theme_group_imgurl', _THEMEGR_THEMEIMGURL . ' ');
		$form->AddTextfield ('theme_group_imgurl', 31);
		$form->AddChangeRow ();
		$form->AddLabel ('theme_group_css', _THEMEGR_THEMECSS . ' ');
		$form->AddTextfield ('theme_group_css', 31);
		$form->AddChangeRow ();
		$form->AddLabel ('theme_group_visible', _THEMEGR_THEMEVISIBLE . ' ');
		$options = array ();
		$options['0'] = _NO_SUBMIT;
		$options['1'] = _YES_SUBMIT;
		$form->AddSelect ('theme_group_visible', $options, 1);
		$options = get_language_options ();
		$form->AddChangeRow ();
		$form->AddLabel ('theme_group_lang', _THEMEGR_THEMELANG);
		$theme_group_lang = '';
		$form->AddSelect ('theme_group_lang', $options, $theme_group_lang);
		$groups = $opnConfig['permission']->UserGroups;
		$options = array ();
		foreach ($groups as $group) {
			$options[$group['id']] = $group['name'];
		}
		$form->AddChangeRow ();
		$form->AddLabel ('theme_group_usergroup', _THEMEGR_THEMEUSERGROUP);
		$theme_group_usergroup = 0;
		$form->AddSelect ('theme_group_usergroup', $options, $theme_group_usergroup);
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'ThemeGroupAdd');
		$form->AddSubmit ('submit', _THEMEGR_ADD);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$boxtxt .= '</div>';
	}
	return $boxtxt;

}

function ThemeGroupAdd () {

	global $opnTables, $opnConfig;

	$theme_group_text = '';
	get_var ('theme_group_text', $theme_group_text, 'form', _OOBJ_DTYPE_CLEAN);
	$theme_group_imgurl = '';
	get_var ('theme_group_imgurl', $theme_group_imgurl, 'form', _OOBJ_DTYPE_URL);
	$theme_group_visible = 0;
	get_var ('theme_group_visible', $theme_group_visible, 'form', _OOBJ_DTYPE_INT);
	$theme_group_css = '';
	get_var ('theme_group_css', $theme_group_css, 'form', _OOBJ_DTYPE_CLEAN);
	$theme_group_usergroup = 0;
	get_var ('theme_group_usergroup', $theme_group_usergroup, 'form', _OOBJ_DTYPE_INT);
	$theme_group_lang = '';
	get_var ('theme_group_lang', $theme_group_lang, 'form', _OOBJ_DTYPE_CLEAN);
	$opnConfig['permission']->HasRights ('system/theme_group', array (_PERM_NEW, _PERM_ADMIN) );
	$theme_group_id = $opnConfig['opnSQL']->get_new_number ('opn_theme_group', 'theme_group_id');
	$theme_group_text = $opnConfig['opnSQL']->qstr ($theme_group_text);
	$theme_group_imgurl = $opnConfig['opnSQL']->qstr ($theme_group_imgurl);
	$theme_group_css = $opnConfig['opnSQL']->qstr ($theme_group_css);
	$theme_group_lang = $opnConfig['opnSQL']->qstr ($theme_group_lang);
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['opn_theme_group'] . " VALUES ($theme_group_id, $theme_group_text, $theme_group_imgurl, $theme_group_visible, $theme_group_id, $theme_group_css, $theme_group_usergroup, $theme_group_lang)");

}

function change_visible () {

	global $opnConfig, $opnTables;

	$opnConfig['permission']->HasRights ('system/theme_group', array (_PERM_EDIT, _PERM_ADMIN), true);
	$visible = 0;
	get_var ('visible', $visible, 'url', _OOBJ_DTYPE_INT);
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['opn_theme_group'] . ' SET theme_group_visible=' . $visible . ' WHERE theme_group_id=' . $id);

}

function ThemeGroupEdit () {

	global $opnTables, $opnConfig;

	$theme_group_id = 0;
	get_var ('theme_group_id', $theme_group_id, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('system/theme_group', array (_PERM_EDIT, _PERM_ADMIN), true);
	$result = $opnConfig['database']->Execute ('SELECT theme_group_text, theme_group_imgurl, theme_group_visible, theme_group_pos, theme_group_usergroup, theme_group_css, theme_group_lang FROM ' . $opnTables['opn_theme_group'] . ' WHERE theme_group_id=' . $theme_group_id);
	$theme_group_text = $result->fields['theme_group_text'];
	$theme_group_imgurl = $result->fields['theme_group_imgurl'];
	$theme_group_visible = $result->fields['theme_group_visible'];
	$theme_group_css = $result->fields['theme_group_css'];
	$theme_group_usergroup = $result->fields['theme_group_usergroup'];
	$theme_group_lang = $result->fields['theme_group_lang'];
	$theme_group_pos = $result->fields['theme_group_pos'];
	$boxtxt = '<div align="center" class="extratextbold">' . _THEMEGR_EDITGROUP . '</div>';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_THEME_GROUP_20_', 'theme_group');
	$form->Init ($opnConfig['opn_url'] . '/system/theme_group/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('theme_group_text', _THEMEGR_THEMETITLE . ' ');
	$form->AddTextfield ('theme_group_text', 31, 0, $theme_group_text);
	$form->AddChangeRow ();
	$form->AddLabel ('theme_group_imgurl', _THEMEGR_THEMEIMGURL . ' ');
	$form->AddTextfield ('theme_group_imgurl', 31, 0, $theme_group_imgurl);
	$form->AddChangeRow ();
	$form->AddLabel ('theme_group_css', _THEMEGR_THEMECSS . ' ');
	$form->AddTextfield ('theme_group_css', 31, 0, $theme_group_css);
	$form->AddChangeRow ();
	$form->AddLabel ('position', _THEMEGR_POSITION . ' ');
	$form->AddTextfield ('position', 0, 0, $theme_group_pos);
	$form->AddChangeRow ();
	$form->AddLabel ('theme_group_visible', _THEMEGR_THEMEVISIBLE . ' ');
	$options = array ();
	$options['0'] = _NO_SUBMIT;
	$options['1'] = _YES_SUBMIT;
	$form->AddSelect ('theme_group_visible', $options, $theme_group_visible);
	$options = get_language_options ();
	$form->AddChangeRow ();
	$form->AddLabel ('theme_group_lang', _THEMEGR_THEMELANG);
	$form->AddSelect ('theme_group_lang', $options, $theme_group_lang);
	$groups = $opnConfig['permission']->UserGroups;
	$options = array ();
	foreach ($groups as $group) {
		$options[$group['id']] = $group['name'];
	}
	$form->AddChangeRow ();
	$form->AddLabel ('theme_group_usergroup', _THEMEGR_THEMEUSERGROUP);
	$form->AddSelect ('theme_group_usergroup', $options, $theme_group_usergroup);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('theme_group_id', $theme_group_id);
	$form->AddHidden ('op', 'ThemeGroupSave');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _THEMEGR_SAVECHANGES);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function ThemeGroupSave () {

	global $opnTables, $opnConfig;

	$theme_group_id = 0;
	get_var ('theme_group_id', $theme_group_id, 'form', _OOBJ_DTYPE_INT);
	$theme_group_text = '';
	get_var ('theme_group_text', $theme_group_text, 'form', _OOBJ_DTYPE_CLEAN);
	$theme_group_imgurl = '';
	get_var ('theme_group_imgurl', $theme_group_imgurl, 'form', _OOBJ_DTYPE_URL);
	$theme_group_visible = 0;
	get_var ('theme_group_visible', $theme_group_visible, 'form', _OOBJ_DTYPE_INT);
	$theme_group_css = '';
	get_var ('theme_group_css', $theme_group_css, 'form', _OOBJ_DTYPE_CLEAN);
	$position = 0;
	get_var ('position', $position, 'form', _OOBJ_DTYPE_CLEAN);
	$theme_group_usergroup = 0;
	get_var ('theme_group_usergroup', $theme_group_usergroup, 'form', _OOBJ_DTYPE_INT);
	$theme_group_lang = '';
	get_var ('theme_group_lang', $theme_group_lang, 'form', _OOBJ_DTYPE_CLEAN);
	$opnConfig['permission']->HasRights ('system/theme_group', array (_PERM_EDIT, _PERM_ADMIN), true);
	$result = $opnConfig['database']->Execute ('SELECT theme_group_pos FROM ' . $opnTables['opn_theme_group'] . ' WHERE theme_group_id=' . $theme_group_id);
	$pos = $result->fields['theme_group_pos'];
	$result->Close ();
	$theme_group_text = $opnConfig['opnSQL']->qstr ($theme_group_text);
	$theme_group_imgurl = $opnConfig['opnSQL']->qstr ($theme_group_imgurl);
	$theme_group_css = $opnConfig['opnSQL']->qstr ($theme_group_css);
	$theme_group_lang = $opnConfig['opnSQL']->qstr ($theme_group_lang);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['opn_theme_group'] . " SET theme_group_text=$theme_group_text, theme_group_imgurl=$theme_group_imgurl, theme_group_visible=$theme_group_visible, theme_group_css=$theme_group_css, theme_group_usergroup=$theme_group_usergroup, theme_group_lang=$theme_group_lang WHERE theme_group_id=$theme_group_id");
	if ($pos != $position) {
		set_var ('id', $theme_group_id, 'url');
		set_var ('new_pos', $position, 'url');
		ThemeOrder ();
		unset_var ('id', 'url');
		unset_var ('new_pos', 'url');
	}

}

function ThemeOrder () {

	global $opnTables, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$new_pos = 0;
	get_var ('new_pos', $new_pos, 'url', _OOBJ_DTYPE_CLEAN);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['opn_theme_group'] . " SET theme_group_pos=$new_pos WHERE theme_group_id=$id");
	$result = &$opnConfig['database']->Execute ('SELECT theme_group_id FROM ' . $opnTables['opn_theme_group'] . ' ORDER BY theme_group_pos');
	$c = 0;
	while (! $result->EOF) {
		$row = $result->GetRowAssoc ('0');
		$c++;
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['opn_theme_group'] . ' SET theme_group_pos=' . $c . ' WHERE theme_group_id=' . $row['theme_group_id']);
		$result->MoveNext ();
	}

}

function ThemeGroupDel () {

	global $opnTables, $opnConfig;

	$theme_group_id = 0;
	get_var ('theme_group_id', $theme_group_id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('system/theme_group', array (_PERM_DELETE, _PERM_ADMIN), true);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_theme_group'] . ' WHERE theme_group_id=' . $theme_group_id);
		return '';
	}
	$boxtxt = '<div class="bigtextbold" align="center"><br />';
	$boxtxt .= '<span class="alerttextcolor">';
	$boxtxt .= _THEMEGR_WARNING . '<br /><br /></span>';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/theme_group/admin/index.php?',
									'op' => 'ThemeGroupDel',
									'theme_group_id' => $theme_group_id,
									'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/theme_group/admin/index.php?op=ThemeGroupAdmin') . '">' . _NO . '</a><br /><br /></div>';
	return $boxtxt;

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	default:
		$boxtxt = ThemeGroupAdmin ();
		break;
	case 'ThemeGroupAdmin':
		$boxtxt = ThemeGroupAdmin ();
		break;
	case 'ThemeOrder':
		ThemeOrder ();
		$boxtxt = ThemeGroupAdmin ();
		break;
	case 'ThemeGroupEdit':
		$boxtxt = ThemeGroupEdit ();
		break;
	case 'ThemeGroupDel':
		$boxtxt = ThemeGroupDel ();
		if ($boxtxt == '') {
			$boxtxt = ThemeGroupAdmin ();
		}
		break;
	case 'ThemeGroupAdd':
		ThemeGroupAdd ();
		$boxtxt = ThemeGroupAdmin ();
		break;
	case 'ThemeGroupSave':
		ThemeGroupSave ();
		$boxtxt = ThemeGroupAdmin ();
		break;
	case 'change_visible':
		change_visible ();
		$boxtxt = ThemeGroupAdmin ();
		break;
}
ThemeGroupConfigHeader ();
if (isset ($boxtxt) ) {
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_THEME_GROUP_30_';
	$_display_dat['module'] = 'system/theme_group';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_THEMEGR_THEMECONFIG, $boxtxt);
}
$opnConfig['opnOutput']->DisplayFoot ();

?>