<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('system/tracking', true);
getLanguageDef (_OPN_ROOT_PATH . 'system/tracking/admin/language/');

$menu = array(
	1 => array(
		'text'   => _TRACKADMIN_LAST.' 1 '._TRACKADMIN_HOURS,
		'timef'  => date('Y-m-d H:i:s', time()-3600), // now - 1 hours
		'timet'  => date('Y-m-d H:i:s', time())	    // now
	),
	2 => array(
		'text'   => _TRACKADMIN_LAST.' 4 '._TRACKADMIN_HOURS,
		'timef'  => date('Y-m-d H:i:s', time()-14400), // now - 4 hours
		'timet'  => date('Y-m-d H:i:s', time())	    // now
	),
	3 => array(
		'text'   => _TRACKADMIN_TODAY,
		'timef'  => date('Y-m-d H:i:s', mktime(0,0,0,date('m'),date('d'),date('Y'))), // now
		'timet'  => date('Y-m-d H:i:s', mktime(23,59,59,date('m'),date('d'),date('Y')))	// today
	),
	4 => array(
		'text'   => _TRACKADMIN_YESTERDAY,
		'timef'  => date('Y-m-d H:i:s', mktime(0,0,0,date('m'),date('d')-1,date('Y'))),    // today - 1 day
		'timet'  => date('Y-m-d H:i:s', mktime(23,59,59,date('m'),date('d')-1,date('Y')))    // today - 1 day
	),
	5 => array(
		'text'   => _TRACKADMIN_LAST.' 3',
		'timef'  => date('Y-m-d H:i:s', mktime(0,0,0,date('m'),date('d')-3,date('Y'))),   // today - 3 days
		'timet'  => date('Y-m-d H:i:s', time())	    // now
	),
	6 => array(
		'text'   => _TRACKADMIN_LAST.' 7',
		'timef'  => date('Y-m-d H:i:s', mktime(0,0,0,date('m'),date('d')-7,date('Y'))),   // today - 7 days
		'timet'  => date('Y-m-d H:i:s', time())	    // now
	),
	7 => array(
		'text'   => _TRACKADMIN_LAST.' 14',
		'timef'  => date('Y-m-d H:i:s', mktime(0,0,0,date('m'),date('d')-14,date('Y'))),   // today - 14 days
		'timet'  => date('Y-m-d H:i:s', time())	    // now
	),
	8 => array(
		'text'   => _TRACKADMIN_LAST.' 30',
		'timef'  => date('Y-m-d H:i:s', mktime(0,0,0,date('m'),date('d')-30,date('Y'))),   // today - 30 days
		'timet'  => date('Y-m-d H:i:s', time())	    // now
	),
	9 => array(
		'text'   => _TRACKADMIN_ALL,
		'timef'  => '1990-01-01 00:00:01',
		'timet'  => date('Y-m-d H:i:s', time())	    // now
	)
);	// End of Menu Definition

// only default if first start without parameters
//  Default Menu: 1 / 2 / 3 / ...
//  $default_timef = $menu[1]["timef"];
//  $default_timet = $menu[1]["timet"];
//  $default_text  = $menu[1]["text"];

$menu_optr = 'start';			 // Default mode for period menu

/**
 * build param string e.g. for URL from an array
 *
 * @access public
 * @param array $params
 * @return string
 **/
function tracking_query_str ($params) {
	$str = '';
	foreach ($params as $key => $value) {
		$str .= (strlen($str) < 1) ? '' : '&';
		$str .= $key . '=' . $value;
	}
	return ($str);
}


function decodeurl1($url) {
	global $opnConfig;

	$url1 = $url;
	if ($opnConfig['encodeurl'] == 1) {
		if (substr_count ($url, '?')>0) {
			if (substr_count ($url, 'opnparams')>0) {
				$url1 = explode ('?', $url);
				$url1[1] = str_replace ('opnparams=', '', $url1[1]);
				$decode_url = open_the_secret (md5 ($opnConfig['encoder']), $url1[1]);
				$tbl = array ();
				parse_str ($decode_url, $tbl);
				$url1[1] = $decode_url;
				$url1 = implode ('?', $url1);
			}
		}
	} elseif ($opnConfig['encodeurl'] == 2) {
		if (substr_count ($url, '?')>0) {
			if (substr_count ($url, 'opnparams')>0) {
				$url1 = explode ('?', $url);
				$url1[1] = str_replace ('opnparams=', '', $url1[1]);
				$decode_url = open_the_secret (md5 ($opnConfig['encoder']), $url1[1]);
				$decode_url = open_the_secret (md5 ($opnConfig['encoder']), $opnConfig['opnOption']['opnsession']->get_var ('_OPNLINKNR_' . $decode_url) );
				$url1[1] = $decode_url;
				$url1 = implode ('?', $url1);
			}
		}
	}
	if (substr_count ($url1, '?')>0) {
		$url2 = explode ('?', $url1);
		foreach ($url2 as $key => $val) {
			$url2[$key] = rawurldecode ($url2[$key]);
		}
		parse_str ($url2[1], $tbl);
		if (isset ($tbl[session_name ()]) ) {
			unset ($tbl[session_name ()]);
		}
		if (isset ($tbl[strtolower (session_name () )]) ) {
			unset ($tbl[strtolower (session_name () )]);
		}
		if (count ($tbl)>0) {
			$url2[1] = tracking_query_str ($tbl);
			$url1 = implode ('?', $url2);
		} else {
			$url1 = $url2[0];
		}
	}
	return $url1;

}

function trackingConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_TRACKADMIN_ADMINTRACKINGCONFIGURATION);
	$menu->InsertEntry (_TRACKADMIN_ADMINMAIN, $opnConfig['opn_url'] . '/system/tracking/admin/index.php');
	$menu->InsertEntry (_TRACKADMIN_ADMINSETTINGS, $opnConfig['opn_url'] . '/system/tracking/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}
// ************************************************************************
// Diese Funktion formatiert das Datum entsprechend der Maske im
// Language File
// _LINKSDATESTRING
// ************************************************************************

function track_fc_format_date ($f1_date, $f1_datestring) {

	global $opnConfig;

	$opnConfig['opndate']->setTimestamp ($f1_date);
	$datetime = '';
	$opnConfig['opndate']->formatTimestamp ($datetime, $f1_datestring);
	$datetime = ucfirst ($datetime);
	return ($datetime);

}
// ******************************************************************************
// Display group of visits for selected range
// ******************************************************************************

function fc_sort ($a, $b) {

	global $FELD;
	return strnatcasecmp ($a[$FELD], $b[$FELD]);

}
// ************************************************************************
// Line break for words longer then $f1_lenght. It will ab a space after
// $f1_lenghtletters. So in a table can be an automatic line break
// for long words.
// ************************************************************************

function track_umbruch ($f1_string, $f1_lenght) {

	$hf_neu = array ();
	$hf_words = explode (' ', $f1_string);
	foreach ($hf_words as $val) {
		$hf_neu[] = chunk_split ($val, $f1_lenght, ' ');
	}
	$f1_string = trim (implode (' ', $hf_neu) );
	return $f1_string;

}
// ************************************************************************
// print an array						# WM018029
// ************************************************************************

function track_print_array_table (&$table, $f1_array, $f1_double, $hf_printkey) {

	$hf_count = 0;
	foreach ($f1_array as $key1 => $subarray) {
		$hf_count++;
		if ( ($hf_count != 2) && ($f1_double == '2') ) {
			continue;
		}
		$hf_count = 0;
		$table->AddOPenRow ();
		if ($hf_printkey) {
			$table->AddDataCol ($key1 . ':');
		}
		if (!is_array ($subarray) ) {
			$table->AddDataCol ($subarray);
		} else {
			$hlp = '<ul>';
			foreach ($subarray as $key2 => $val) {
				$hlp .= '<li>' . $key2 . ' : ' . $val . _OPN_HTML_NL;
			}
			$hlp .= '</ul>';
			$table->AddDataCol ($hlp);
		}
		$table->AddCloseRow ();
	}

}
// ******************************************************************************
// Cut a stringpart
// $string  = complet string with the part to find
// $hf_suchend = cut from start including that string
// $hf_suchend = cut that until the end
// ******************************************************************************

function fc_cutpart ($string, $hf_suchstart, $hf_suchend) {

	$string = substr ($string, strpos ($string, $hf_suchstart)+strlen ($hf_suchstart), strlen ($string) );
	// Cut first part
	$hf_lenght = strpos ($string, $hf_suchend);
	// Lenght of searched part
	if ($hf_lenght == 0) {
		$hf_lenght = strlen ($string);
	}
	// nothing after part, no suchend found
	$part = substr ($string, 0, $hf_lenght);
	// Cut it
	return $part;

}

function db_error_check ($disp_errno, $filename, $function, $where) {

	global $opnConfig;
	if ( ($opnConfig['database']->ErrorNo () != 0) or ($disp_errno != '') ) {
		$boxtxt = '*** A Database Problem Occured ***<br />';
		$boxtxt .= 'Script  : /system/tracking/admin/index.php<br />';
		$boxtxt .= 'Filename: ' . $filename . '<br />';
		$boxtxt .= 'Function: ' . $function . '<br />';
		$boxtxt .= 'Place   : ' . $where . '<br />';
		// $boxtxt.= 'Aff rows: '.$opnConfig['database']->Affected_Rows().'<br />';
		$boxtxt .= 'Errno   : ' . $opnConfig['database']->ErrorNo () . '<br />';
		$boxtxt .= 'Error   : ' . $opnConfig['database']->ErrorMsg () . '<br />';
		$boxtxt .= '**********************************<br />';
	} else {
		$boxtxt = '';
	}
	return $boxtxt;

}
// ******************************************************************************
// Display group of visits for selected range
// ******************************************************************************

function start ($sort, $timef, $timet, $text) {

	global $opnConfig, $opnTables;
	if ($timef == '') {
		$timef = date ('Y-m-d H:i:s', mktime (0, 0, 0, date ('m'), date ('d'), date ('Y') ) );
	}
	if ($timet == '') {
		$timet = date ('Y-m-d H:i:s', time () );
	}
	// count pageviews							     # WM010829
	$result = &$opnConfig['database']->Execute ('SELECT COUNT(tracktime) AS counter FROM ' . $opnTables['tracking'] . ' WHERE ' . $opnConfig['opnSQL']->CreateBetween ('tracktime', $timef, $timet, true, 19) );
	$boxtxt = db_error_check ('', 'tracking.php', 'start', 'case user count(*) / SELECT');
	if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
		$hf_pageviews = $result->fields['counter'];
	} else {
		$hf_pageviews = 0;
	}
	// get the grouped result from SQL: per visit / per pages
	switch ($sort) {
		case 'visit':
			// by visits
			$result = &$opnConfig['database']->Execute ("SELECT substring(tracktime,1,10) as hf_date, ip, uid, count(ip) as hf_count FROM " . $opnTables['tracking'] . " " . ' WHERE ' . $opnConfig['opnSQL']->CreateBetween ('tracktime', $timef, $timet, true, 19) . 'GROUP BY hf_date DESC, ip, uid ');
			db_error_check ('', 'tracking.php', 'start', 'case visit / SELECT');
			if (is_object ($result) ) {
				$result_count = $result->RecordCount ();
			} else {
				$result_count = 0;
			}
			$hf_headcount = $result_count;
			$hf_sorttext = _TRACKADMIN_VISITS;
			$hf_textend = ' ' . _TRACKADMIN_AND . ' ' . $hf_pageviews . '&nbsp;' . _TRACKADMIN_PAGES;
			break;
		case 'page':
			// by pages
			$result = &$opnConfig['database']->Execute ("SELECT requrl, count(ip) as hf_count FROM " . $opnTables['tracking'] . " " . ' WHERE ' . $opnConfig['opnSQL']->CreateBetween ('tracktime', $timef, $timet, true, 19) . 'GROUP BY requrl DESC ' . 'ORDER BY hf_count DESC ');
			db_error_check ('', 'tracking.php', 'start', 'case page / SELECT');
			if (is_object ($result) ) {
				$result_count = $result->RecordCount ();
			} else {
				$result_count = 0;
			}
			$hf_headcount = $result_count;
			$hf_sorttext = _TRACKADMIN_DIFFPAGES;
			$hf_textend = ' ' . _TRACKADMIN_AND . ' ' . $hf_pageviews . '&nbsp;' . _TRACKADMIN_PAGES;
			break;
		case 'time':
			// by time
			$result = &$opnConfig['database']->Execute ("SELECT tracktime, ip, uid, requrl FROM " . $opnTables['tracking'] . " " . ' WHERE ' . $opnConfig['opnSQL']->CreateBetween ('tracktime', $timef, $timet, true, 19) . 'ORDER BY tracktime DESC ');
			db_error_check ('', 'tracking.php', 'start', 'case time / SELECT');
			if (is_object ($result) ) {
				$result_count = $result->RecordCount ();
			} else {
				$result_count = 0;
			}
			$hf_headcount = $result_count;
			$hf_sorttext = _TRACKADMIN_PAGES;
			$hf_textend = '';
			break;
		case 'date':
			// by date			      # WM010809
			// get pageviews by date
			$result = &$opnConfig['database']->Execute ("SELECT substring(tracktime,1,10) as hf_date, count(ip) as hf_count FROM " . $opnTables['tracking'] . " " . ' WHERE ' . $opnConfig['opnSQL']->CreateBetween ('tracktime', $timef, $timet, true, 19) . 'GROUP BY hf_date DESC ');
			db_error_check ('', 'tracking.php', 'start', 'case date / SELECT');
			if (is_object ($result) ) {
				$result_count = $result->RecordCount ();
			} else {
				$result_count = 0;
			}
			$hf_headcount = $result_count;
			$hf_sorttext = _TRACKADMIN_DAYS;
			$hf_textend = ' ' . _TRACKADMIN_AND . ' ' . $hf_pageviews . '&nbsp;' . _TRACKADMIN_PAGES;
			break;
		case 'user':
			// by users
			// get pageviews by user
			$result = &$opnConfig['database']->Execute ("SELECT uid, count(ip) as hf_count FROM " . $opnTables['tracking'] . " " . ' WHERE ' . $opnConfig['opnSQL']->CreateBetween ('tracktime', $timef, $timet, true, 19) . 'GROUP BY uid ' . 'ORDER BY hf_count DESC');
			db_error_check ('', 'tracking.php', 'start', 'case user / SELECT');
			if (is_object ($result) ) {
				$result_count = $result->RecordCount ();
			} else {
				$result_count = 0;
			}
			$hf_headcount = $result_count;
			$hf_sorttext = _TRACKADMIN_USERS;
			$hf_textend = ' ' . _TRACKADMIN_AND . ' ' . $hf_pageviews . '&nbsp;' . _TRACKADMIN_PAGES;
			break;
		case 'trackid':
			// by trackid			  # WM010810

			# get pageviews by trackid

			$result = &$opnConfig['database']->Execute ("SELECT trackid, uid, count(ip) as hf_count FROM " . $opnTables['tracking'] . " " . ' WHERE ' . $opnConfig['opnSQL']->CreateBetween ('tracktime', $timef, $timet, true, 19) . 'GROUP BY trackid ' . 'ORDER BY hf_count DESC');
			db_error_check ('', 'tracking.php', 'start', 'case trackid / SELECT');
			if (is_object ($result) ) {
				$result_count = $result->RecordCount ();
			} else {
				$result_count = 0;
			}
			$hf_headcount = $result_count;
			$hf_sorttext = _TRACKADMIN_TRACKID;
			$hf_textend = ' ' . _TRACKADMIN_AND . ' ' . $hf_pageviews . '&nbsp;' . _TRACKADMIN_PAGES;
			break;
	}
	// display header line
	$boxtxt.= '<br /><br />'._OPN_HTML_NL;

	if ($text!='') {
		$hf_text = ' '._TRACKADMIN_AT." '".$text."'";
	} else {
		$hf_text = '';
	}// if a menutext is set
	$boxtxt.= '<span class="normaltextbold">'.$hf_headcount." ".$hf_sorttext.$hf_text.$hf_textend.
				'</span>'.
				' ('._TRACKADMIN_FROM.' '.track_fc_format_date($timef, _DATE_DATESTRING5).'  '._TRACKADMIN_TO.' '.track_fc_format_date($timet, _DATE_DATESTRING5).')';
	$boxtxt.= '<br /><br />'._OPN_HTML_NL;
	$table = & new opn_TableClass('alternator');

	switch ($sort) {
		case 'visit':
			$table->AddHeaderRow (array (_TRACKADMIN_DATE, _TRACKADMIN_IP, _TRACKADMIN_UID, _TRACKADMIN_COUNT) );
			break;
		case 'page':
			$table->AddHeaderRow (array (_TRACKADMIN_COUNT, _TRACKADMIN_TITLE, _TRACKADMIN_URL) );
			break;
		case 'time':
			$table->AddHeaderRow (array (_TRACKADMIN_DATE, _TRACKADMIN_IP, _TRACKADMIN_UID, _TRACKADMIN_TITLE, _TRACKADMIN_URL) );
			break;
		case 'date':
			$table->AddHeaderRow (array (_TRACKADMIN_DATE, _TRACKADMIN_COUNT) );
			break;
		case 'user':
			$table->AddHeaderRow (array (_TRACKADMIN_USER, _TRACKADMIN_COUNT) );
			break;
		case 'trackid':
			$table->AddHeaderRow (array (_TRACKADMIN_TRACKID, _TRACKADMIN_USER, _TRACKADMIN_COUNT) );
			break;
	}

	$userinfo = $opnConfig['permission']->GetUserinfo();

	// display grouped results: by visit / py pages / by time
	$uid = '';
	while (!$result->EOF) {
		$array=$result->GetRowAssoc ('0');
		if(!isset($array['uid'])) {
			$array['uid'] = '';
		}
		if(!isset($array['tracktime'])) {
			$array['tracktime'] = '';
		}
		if(!isset($array['ip'])) {
			$array['ip'] = '';
		}
		if(isset($array['requrl'])) {
			$array['requrl'] = decodeurl1($array['requrl']);
		}
		if ( $array['uid']!=$uid) {
			$uname = '';
			$uid = '';
		}
		// build link to view one tracking line
		$href = '<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','optr'=>'show_line', 'timef'=>$array['tracktime'], 'ip'=>$array['ip'], 'text'=>'')).'">';
		if (isset($array['requrl'])) {
			$href1 = '<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','optr'=>'show_page','sort'=>$sort,
					'timef'=>$timef,
					'timet'=>$timet,
					'url'=>str_replace('&','@@',$array['requrl']))).
					'">';
		}
		$hf_date = track_fc_format_date($array['tracktime'], _DATE_DATESTRING5);  // Datum lokal formatieren  # WM010904

		$table->AddOpenRow();
		if ( ($array['uid']>0) && ($array['uid']!=$uid)) {		// read uname for uid
			$userinfo = $opnConfig['permission']->GetUser($array['uid'],'','');
			$uid=$userinfo['uid'];
			$uname=$userinfo['uname'];
		}
		switch ($sort) {
			// overview by grouped visits
			case "visit":
				$table->AddDataCol(track_fc_format_date($array['hf_date'], _DATE_DATESTRING4));       // date
				$table->AddDataCol($array['ip']);       // ip
				if ($array['uid']>0) {		   // uid not 0
					$table->AddDataCol('<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/user/index.php?','op' => 'userinfo' , 'uname' => $uname) ).'">'.$uname.'</a>'); }  // user id
				else {
					$table->AddDataCol($uname); }  # user id
					$table->AddDataCol('<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','optr'=>'show_visit','sort'=>$sort,'timef'=>$timef,'timet'=>$timet,'ip'=>$array['ip'],'truid'=>$array['uid'])).'">'
					.$array['hf_count'].'</a> ');       // count
				break;
			// overview by grouped pages
			case "page":
				$table->AddDataCol('<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','optr'=>'show_visit','sort'=>$sort,'timef'=>$timef,'timet'=>$timet,
					'text'=>$text,'url'=>str_replace('&','@@',$array['requrl']))).'">'.$array['hf_count'].'</a>');
				$table->AddDataCol(track_umbruch(read_object($array['requrl']),51));
				$table->AddDataCol($href1.htmlspecialchars(track_umbruch($array['requrl'],51)).'</a>');
				break;
			// overview by time and single pages
			case "time":
				$table->AddDataCol($href.$hf_date.'</a>');       // time  # WM010829  # WM010904
				$table->AddDataCol($array['ip']);       // ip
				if ($array['uid']>0) {		   # uid not 0
					$table->AddDataCol('<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/user/index.php','op' => 'userinfo' , 'uname' => $uname) ).'">'.$uname.'</a>'); }  // user id
				else {
					$table->AddDataCol($uname);
				}  // user id
				$table->AddDataCol(track_umbruch(read_object($array['requrl']),51));
				$table->AddDataCol($href1.htmlspecialchars(track_umbruch($array['requrl'],51)).'</a>');
				break;
			// overview pageviews grouped by date
			case "date":
				$table->AddDataCol(track_fc_format_date($array['hf_date'], _DATE_DATESTRING4));       // date
				$table->AddDataCol('<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','optr'=>'show_visit','sort'=>$sort,'timef'=>$array['hf_date'].' 00:00:00',
					'timet=>'.$array['hf_date'].' 23:59:59')).'">'.$array['hf_count'].'</a> ');       // count
				break;
			// overview pageviews grouped by user
			case "user":
				if ($array['uid']>0) {		   // uid not 0
					$table->AddDataCol('<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/user/index.php','op' => 'userinfo' , 'uname' => $uname) ).'">'.$uname.'</a>');
				} else {
					$table->AddDataCol('Anonymous');
				}  // user id
				$table->AddDataCol('<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','optr'=>'show_visit','sort'=>$sort,'timef'=>$timef,
					'timet'=>$timet,'truid'=>$array['uid'])).'">'.$array['hf_count'].'</a> ');       // count
				break;
			case "trackid":
				$table->AddDataCol($array['trackid']);
				if ($array['uid']>0) {		   // uid not 0
					$table->AddDataCol('<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/user/index.php','op' => 'userinfo' , 'uname' => $uname) ).'">'.$uname.'</a>');
				} else {
					$table->AddDataCol('Anonymous');
				}  // user id
				$table->AddDataCol('<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','optr'=>'show_visit','timef'=>$timef,'timet'=>$timet,
					'trid'=>$array['trackid'],'text'=>$text)).'">'.$array['hf_count'].'</a> ');       // count
				break;
		} // END SWITCH
		$table->AddCloseRow();
		$result->MoveNext();
	} // END WHILE

	$table->GetTable($boxtxt);

	if ( !($result === false) ) {
		$result->Close();
	} // free SQL memory  # WM010904
	return $boxtxt;
}

function retrieve_tracking_infos() {
	global $opnConfig;

	$plug=array();
	$opnConfig['installedPlugins']->getplugin($plug,'tracking');
	foreach ($plug as $var) {
		include_once (_OPN_ROOT_PATH.$var['plugin'].'/plugin/tracking/index.php');
	}
}

// ******************************************************************************
// Objekt dazulesen
// ******************************************************************************
function read_object($f1_url) {
	global $opnConfig, $opnTables;

	if ($opnConfig['opn_installdir'] != '') {
		$f1_url=str_replace('/'.$opnConfig['opn_installdir'].'/','',$f1_url);
		$f1_url='/'.$f1_url;
	}
	$opnConfig['cleantext']->un_htmlentities($f1_url);
	// get desciption for each URL
	if (( '/'==$f1_url ) || ('/index.php'==$f1_url ) ){
		$back  = _TRACKADMIN_STARTPAGE;
	} elseif  (substr_count($f1_url,'index.php?storynum=')>0) {
		$storynum=str_replace('/index.php?storynum=','',$f1_url);
		$back=_TRACKADMIN_STORYNUME." '".$storynum."'";
	} elseif (substr_count($f1_url,'index.php?storycat=')>0) {
		$catid=str_replace('/index.php?storycat=','',$f1_url);
		$_catid = $opnConfig['opnSQL']->qstr($catid);
		$result=&$opnConfig['database']->Execute('SELECT title FROM '.$opnTables['article_stories_cat']." WHERE catid=$_catid");
		$title=$result->fields['title'];
		$result->Close();
		$back=_TRACKADMIN_CAT." '".$title."'";
	} elseif (substr_count($f1_url,'/index.php?storytopic=')>0) {
		$topicid=str_replace('/index.php?storytopic=','',$f1_url);
		$_topicid = $opnConfig['opnSQL']->qstr($topicid);
		$result=&$opnConfig['database']->Execute('SELECT topictext FROM '.$opnTables['article_topics']." WHERE topicid=$_topicid");
		$topictext=$result->fields['topictext'];
		$result->Close();
		$back=_TRACKADMIN_TOPIC." '".$topictext."'";
	} elseif (substr_count($f1_url,'index.php?aftersid=')>0) {
		$back=_TRACKINGADMIN_NEXTPAGE;
	} elseif ('/submit.php'==$f1_url ) {
		$back = _TRACKADMIN_SUBMITNEWS;
	}
	if(!isset($back)) {
		$back = '';
	}
	if ($back == '') {
		retrieve_tracking_infos();
		if (substr_count($f1_url,'.') > 0) {
			$url=dirname($f1_url);
		} else {
			$url=dirname($f1_url.'1.1');
		}
		$u=explode('/',$url);
		if(isset($u[2])){
			$url=$u[2];
		}
		$myfunc=$url.'_get_tracking';
		if (function_exists($myfunc)) {
			$back=$myfunc($f1_url);
		}
	}
	if ($back == '') {
		$back=admin_get_tracking($f1_url);
	}
	if ($back == '') {
		$back=user_get_tracking($f1_url);
	}
	if ($back == '') {
		$back  = _TRACKADMIN_CASENOT.$f1_url;
	}
	return $back;
}

// ******************************************************************************
// Display pagesviews for one page
// ******************************************************************************
function show_page ($sort, $timef, $timet, $url) {
	global $opnTables,$opnConfig;

	switch ($sort) {
		case 'tracktime':
			$hf_order  = ' ORDER BY tracktime';
			break;
		case 'requrl':
			$hf_order  = ' ORDER BY requrl';
			break;
		case 'ip':
			$hf_order  = ' ORDER BY ip';
			break;
		case 'uid':
			$hf_order  = ' ORDER BY uid';
			break;
		case 'trackid':
			$hf_order  = ' ORDER BY trackid';
			break;
		default:
			$hf_order  = ' ORDER BY tracktime DESC';
			break;
	}

	$url = str_replace("@@","&",$url);		// give & back

	// read visit from database
	$_url = $opnConfig['opnSQL']->qstr($url);
	$result=&$opnConfig['database']->Execute('SELECT tracktime, ip, uid, server, referer, requrl, trackid FROM '.$opnTables['tracking']." "
					.' WHERE '.$opnConfig['opnSQL']->CreateBetween('tracktime', $timef, $timet,true,19)
					."AND requrl = $_url ".$hf_order);
	$boxtxt=db_error_check ('','tracking.php', 'show_page', 'SELECT * FROM');
	$table = & new opn_TableClass('alternator');
	$table->AddCols(array('170','130','40'));
	$table->AddHeaderRow(array(_TRACKADMIN_DATE,_TRACKADMIN_IP,_TRACKADMIN_UID,_TRACKADMIN_TITLE,_TRACKADMIN_URL));
	// display every pageview from selected visit
	while (!$result->EOF) {
		$array=$result->GetRowAssoc ('0');
		$array['requrl'] = decodeurl1($array['requrl']);
		// read username for uid
		$uname = '';
		if  ($array['uid']>0) {		// read uname for uid
			$userinfo = $opnConfig['permission']->GetUser($array['uid'],'','');
			$uname=$userinfo['uname'];
		}
		$hf_date = track_fc_format_date($array['tracktime'], _DATE_DATESTRING5);  // Datum lokal formatieren  # WM010904
		$table->AddOpenRow();
		$table->AddDataCol($hf_date);
		$table->AddDataCol($array['ip']);
		if ($array['uid']>0) {		# uid not 0
			$table->AddDataCol('<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/user/index.php','op' => 'userinfo' , 'uname' => $uname) ).'">'.$uname.'</a>'); }  # user id
		else {
			$table->AddDataCol($uname);      // user id
		}
		$table->AddDataCol(read_object($array['requrl']));  // object title
		$table->AddDataCol($array['requrl']).   // requrl
		$table->AddCloseRow();
		$result->MoveNext();
	} # END WHILE
	$table->GetTable($boxtxt);
	$result->Close();	 // free SQL memory	# WM010830
	return $boxtxt;
} // END FUNCTION

// ******************************************************************************
// Display pagesviews for one page				 # WM010829 NEW
// ******************************************************************************
function show_line ($timef, $f1_ip) {
	global $opnTables,$opnConfig;

	# read visit from database
	$_timef = $opnConfig['opnSQL']->qstr($timef);
	$_f1_ip = $opnConfig['opnSQL']->qstr($f1_ip);
	$result=&$opnConfig['database']->Execute('SELECT tracktime, ip, uid, server, referer, requrl, trackid FROM '.$opnTables['tracking']." WHERE tracktime = $_timef AND ip = $_f1_ip");
	$boxtxt=db_error_check ('',"tracking.php", "show_line", "SELECT * FROM" );
	$table = & new opn_TableClass('listalternator');
	while (!$result->EOF) {
		$array=$result->GetRowAssoc ('0');
		$array['requrl'] = decodeurl1($array['requrl']);
		track_print_array_table ($table,$array, "2", "x");
		$result->MoveNext();
	}
	$table->GetTable($boxtxt);
	return $boxtxt;
} // END FUNCTION

// ******************************************************************************
// Display pagesviews for one visit
// ******************************************************************************
function show_visit ($sort, $timef, $timet, $f1_ip, $f1_uid, $f1_trid, $f1_url, $f1_text) {
	global $opnTables,$opnConfig;

	$f1_url = str_replace("@@","&",$f1_url);		// give & back

	$sel_uid='';
	$sel_ip='';
	$sel_trid='';
	$sel_url='';

	// select for uip and ip only if not NULL
	if ($f1_uid !='')   {
		$_f1_uid = $opnConfig['opnSQL']->qstr($f1_uid);
		$sel_uid  = " AND uid = $_f1_uid";
	}

	if ($f1_ip !='') {
		$_f1_ip = $opnConfig['opnSQL']->qstr($f1_ip);
		$sel_ip = " AND ip = $_f1_ip";
	}

	if ($f1_trid !='')   {
		$_f1_trid = $opnConfig['opnSQL']->qstr($f1_trid);
		$sel_trid = " AND trackid = $_f1_trid";
	}

	if ($f1_url  !='')   {
		$_f1_url = $opnConfig['opnSQL']->qstr($f1_url);
		$sel_url  = " AND requrl = $_f1_url";
	}

	// sort the listing
	switch ($sort) {
		case 'tracktime':
			$hf_order = ' ORDER BY tracktime';
			break;
		case 'requrl':
			$hf_order = ' ORDER BY requrl';
			break;
		case 'ip':
			$hf_order = ' ORDER BY ip';
			break;
		case 'uid':
			$hf_order = ' ORDER BY uid';
			break;
		case 'trackid':
			$hf_order = ' ORDER BY trackid';
			break;
		default:
			$hf_order = ' ORDER BY tracktime DESC';
			break;
	}
	// read visit from database
	$result=&$opnConfig['database']->Execute('SELECT tracktime, ip, uid, server, referer, requrl, trackid FROM '.$opnTables['tracking']." "
				.' WHERE '.$opnConfig['opnSQL']->CreateBetween('tracktime', $timef, $timet,true,19).
				 $sel_uid.
				 $sel_ip.
				 $sel_trid.
				 $sel_url.
				 $hf_order
				 );
	$boxtxt=db_error_check ('','tracking.php', 'show_visit', 'SELECT * FROM '.$opnTables['tracking']);
	if (is_object($result)) {
		$result_count=$result->RecordCount();
	} else {
		$result_count=0;
	}
	$hf_headcount = $result_count;
	$hf_sorttext = _TRACKADMIN_PAGES;
	$hf_text = _TRACKADMIN_WITH;
	$hf_textend='';
	if ($f1_trid !='') { $hf_textend = ' '._TRACKADMIN_TRACKID.' '.$f1_trid; }
	if ($f1_uid !='')  { $hf_textend = ' '._TRACKADMIN_UID.' '.$f1_uid; }
	if ($f1_ip !='')   { $hf_textend = ' '._TRACKADMIN_IP.' '.$f1_ip; }
	if ($f1_url !='')  { $hf_textend = ' '._TRACKADMIN_URL.' '.$f1_url; }

	// display header

	$boxtxt.= '<br /><br />'._OPN_HTML_NL;

	$boxtxt.= '<span class="extratextbold">'.$hf_headcount." ".$hf_sorttext.$hf_text.$hf_textend.
			'</span>'.
			' ('._TRACKADMIN_FROM." ".track_fc_format_date($timef, _DATE_DATESTRING5)."  "._TRACKADMIN_TO." ".track_fc_format_date($timet, _DATE_DATESTRING5).")";
	$boxtxt.= '<br /><br />'._OPN_HTML_NL;

	// build link for sorting colums
	$href = $opnConfig['opn_url'].'/system/tracking/admin/index.php?op=trackingshow&optr=show_visit'.'&timef='.$timef.'&timet='.$timet
		.'&trid='.$f1_trid.'&uid='.$f1_uid.'&url='.str_replace('&','@@',$f1_url).'&ip='.$f1_ip.'&text='.$f1_text.'&sort=';
	$table = & new opn_TableClass('alternator');
	$table->AddCols(array('180','130','130','40','320','320'));
	$table->AddHeaderRow(array('<a class="alternatorhead" href="'.encodeurl($href.'tracktime').'">'._TRACKADMIN_DATE.'</a>',
		'<a class="alternatorhead" href="'.encodeurl($href.'ip').'">'._TRACKADMIN_IP.'</a>',
		'<a class="alternatorhead" href="'.encodeurl($href.'trackid').'">'._TRACKADMIN_TRACKID.'</a>',
		'<a class="alternatorhead" href="'.encodeurl($href.'uid').'">'._TRACKADMIN_UID.'</a>',
		_TRACKADMIN_TITLE,
		'<a class="alternatorhead" href="'.encodeurl($href.'requrl').'">'._TRACKADMIN_URL.'</a>'));
	$uid=0;
	// display every pageview from selected visit
	while (!$result->EOF) {
		$array=$result->GetRowAssoc ('0');
		if (isset($array['requrl'])) {
			$array['requrl'] = decodeurl($array['requrl']);
			$href1 = '<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','optr'=>'show_page','sort'=>$sort,
					'timef'=>$timef,'timet'=>$timet,
					'url'=>str_replace('&','@@',$array['requrl']))).
					'">';
		}
		$array['requrl'] = decodeurl1($array['requrl']);
		# build link to view one tracking line
		$href = '<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','op'=>'trackingshow','optr'=>'show_line','timef'=>$array['tracktime'],
			'ip'=>$array['ip'],'text'=>$f1_text)).'">';
		$hf_date = track_fc_format_date($array['tracktime'], _DATE_DATESTRING5);  // Datum lokal formatieren  # WM010904
   		if ( $array['uid']!=$uid) { $uname = ''; }  // new uid  # wm010830
		if ( ($array['uid']>0) && ($array['uid']!=$uid)) {
			$userinfo = $opnConfig['permission']->GetUser($array['uid'],'','');
			$uid=$userinfo['uid'];
			$uname=$userinfo['uname'];
		} else {
			$uname='';
		}
		$table->AddOpenRow();
		$table->AddDataCol($href.$hf_date.'</a>');
		$table->AddDataCol($array['ip']);
		$table->AddDataCol($array['trackid']);
		if ($array['uid']>0) {
			$table->AddDataCol('<a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/system/user/index.php','op' => 'userinfo' , 'uname' => $uname) ).'">'.$uname.'</a>');
		}
		 else {
			$table->AddDataCol($uname);      # user id
		}
		$table->AddDataCol(track_umbruch(read_object($array['requrl']),51));
		$table->AddDataCol($href1.track_umbruch($array['requrl'],51).'</a>');
		$table->AddCloseRow();
		$result->MoveNext();
	} // END WHILE
	$table->GetTable($boxtxt);
	if ( !($result === false) )  { $result->Close();   }    // free SQL memory  # WM010904
	return $boxtxt;
} // END FUNCTION

# ******************************************************************************
# Pls select the period for deleting
# ******************************************************************************
function go_to_delete_mode() {

	global $opnConfig;

	$boxtxt= '<br /><br /><br /><br /><br /><br /><br />';
	$boxtxt.= _TRACKADMIN_GODELSELECT1.'<br /><br />';
	$boxtxt.= _TRACKADMIN_GODELSELECT2.'<br /><br />';
	$boxtxt.= '<a href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','op'=>'trackingshow','optr'=>'start')).'">';
	$boxtxt.= _TRACKADMIN_LEAVEDELMODE.'</a>';
	return $boxtxt;
}

# ******************************************************************************
# There will be x lines to deletion
# ******************************************************************************
function go_to_delete_select($timef, $timet) {
	global $opnTables,$opnConfig;

	if ($timet=='') { $timet = date('Y-m-d H:i:s', time()); }

	$result = $opnConfig['database']->Execute('SELECT COUNT(tracktime) AS counter FROM '.$opnTables['tracking'].' WHERE '.$opnConfig['opnSQL']->CreateBetween('tracktime', $timef, $timet,true,19));
	$boxtxt=db_error_check ('','tracking.php', 'go_to_delete_select', 'SELECT' );
	if (($result !== false) && (isset($result->fields['counter']))) {
		$result_count=$result->fields['counter'];
	} else {
		$result_count=0;
	}
	$hf_count = $result_count;
	if ($hf_count=='-1') { $hf_count = 0; }
	$boxtxt.= '<br /><br /><br /><br /><br /><br /><br />'.
		_TRACKADMIN_GODELWARN1.' '.$hf_count.' '.
		_TRACKADMIN_GODELWARN2.'<br /><br />'.
		_TRACKADMIN_TIMEFROM.': '.$timef.'<br />'.
		_TRACKADMIN_TIMETO.': '.$timet.'<br /><br />'.
		_TRACKADMIN_GODELWARN3.'<br /><br />'.
		'<a href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','op'=>'trackingshow','optr'=>'delnow',
		'timef'=>$timef,
		'timet'=>$timet)).
		'">'.
		_TRACKADMIN_YESDELETE.'</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.
		'<a href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','op'=>'trackingshow','optr'=>'start')).'">'.
		_TRACKADMIN_NODONTDELETE.'</a>';
	return $boxtxt;
}

// ******************************************************************************
// Delete tracking lines
// ******************************************************************************
function delete_tracking($timef, $timet) {
	global $opnTables,$opnConfig;

	$myselect = "SELECT COUNT(tracktime) AS counter FROM ".$opnTables['tracking'].' WHERE '.$opnConfig['opnSQL']->CreateBetween('tracktime', $timef, $timet,true,19);
	$result = $opnConfig['database']->Execute($myselect);
	if (($result !== false) && (isset($result->fields['counter']))) {
		$result_count_before=$result->fields['counter'];
	} else {
		$result_count_before=0;
	}
	$opnConfig['database']->Execute('DELETE FROM '.$opnTables['tracking'].' WHERE '.$opnConfig['opnSQL']->CreateBetween('tracktime', $timef, $timet,true,19));
	$boxtxt=db_error_check ('','tracking.php', 'delete_tracking', 'DELETE' );
	$result = $opnConfig['database']->Execute($myselect);
	if (($result !== false) && (isset($result->fields['counter']))) {
		$result_count_after=$result->fields['counter'];
	} else {
		$result_count_after=0;
	}
	$hf_count = $result_count_before-$result_count_after;
	if ($hf_count=='-1') {
		$hf_count = 0;
	}
	$boxtxt.= '<br /><br /><br /><br /><br /><br />';
	$boxtxt.= _TRACKADMIN_ITHAVEBEEN." ".$hf_count.'&nbsp;'._TRACKADMIN_TRACKDELETED.'<br /><br />';
	$boxtxt.= '<a href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','op'=>'trackingshow','optr'=>'start')).'">';
	$boxtxt.= _TRACKADMIN_BACKTOSTART.'</a>';
	return $boxtxt;
}

// ******************************************************************************
//
// Start of program
//
// ******************************************************************************

function TrackingStart ($f1_optr, $f1_sort, $f1_datef, $f1_datet, $f1_timef, $f1_timet, $f1_text, $f1_url, $f1_ip, $f1_uid, $f1_trackid) {

	global $opnConfig, $menu;
	// Menaufbau
	switch ($f1_optr) {
		// option for the period menu
		case 'start':
			$menu_optr = 'start';
			break;
		// if delete mode, next is select delete date
		case "godel":
			$menu_optr = 'delsel';
			break;
		// if delete mode, next is select delete date
		case "delsel":
			$menu_optr = "delsel";
			break;
		// if delete mode, next is select delete date
		case "fdelsel":
			$menu_optr = "delsel";
			break;
		// if delete mode, next is select delete date
		default:
			$menu_optr = "start";
			break;
	}
	// change time fields for formula data
	if ( ($f1_optr == 'fstart') or ($f1_optr == 'fdelsel') ) {
		if ($f1_timef == '') {
			$f1_timef = '00:00:00';
		}
		if ( ($f1_timet == '') and ($f1_datet != '') ) {
			$f1_timet = '23:59:59';
		}
		if ($f1_datef != '') {
			$opnConfig['opndate']->ConvertDateToDBDate ($f1_timef, $f1_datef, $f1_timef);
		}
		if ($f1_datet != '') {
			$opnConfig['opndate']->ConvertDateToDBDate ($f1_timet, $f1_datet, $f1_timet);
		}
	}
	// Default period if no time selected
	if ( ($f1_timef == '') && ($f1_timet == '') ) {
		$f1_timef = $menu[1]['timef'];
		$f1_timet = $menu[1]['timet'];
		$f1_text = $menu[1]['text'];
	}
	$hf_count = 0;
	// display menu period
	$boxtxt= '<span class="normaltext">';
	foreach ($menu as $sub) {
		if ($hf_count++ > 0) { $boxtxt.= ' - ';}
		if ($f1_text!=$sub['text']) {	   # link not activ if current menu
			$boxtxt.= '<a href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','op'=>'trackingshow','optr'=>$menu_optr,
						'sort'=>$f1_sort, 		       # page / visit
						'timef'=>$sub['timef'],
						'timet'=>$sub['timet'],
						'text'=>$sub['text']))
						.'">';
			$boxtxt.= $sub['text'].'</a>';	  // menu text
		} else {
			$boxtxt.= $sub['text'];	  // menu text
		}
	}
	// menu point change to delete mode
	// $boxtxt.= "<img src='".$opnConfig['opn_url']."/system/tracking/images/pix.gif' width='50' height='1'>";
	$boxtxt .= '&nbsp;&nbsp;&nbsp;';
	$boxtxt.= '(<a href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','op'=>'trackingshow','optr'=>'godel')).'">'	 // change to delete mode
				._TRACKADMIN_GODEL.'</a>)';
	$boxtxt.= '<br /><br />'._OPN_HTML_NL;
	// display menu by pages / visits
	if ($f1_optr!='godel') {	      // only if not in the delete mode
		$boxtxt.= '';
		if ($f1_sort!='page') {	     // only link if not active
			$boxtxt.= '<a href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','op'=>'trackingshow','optr'=>$menu_optr,
				'sort'=>'page',        # page / visit
				'timef'=>$f1_timef,
				'timet'=>$f1_timet,
				'text'=>$f1_text)).
				'">';
			$boxtxt.= _TRACKADMIN_BYPAGES.'</a> - ';
		} else {
			$boxtxt.= _TRACKADMIN_BYPAGES.' - ';
		}

		if ($f1_sort!='visit') {	     // only link if not active
			$boxtxt.= '<a href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','op'=>'trackingshow','optr'=>$menu_optr,
				'sort'=>'visit',        // page / visit
				'timef'=>$f1_timef,
				'timet'=>$f1_timet,
				'text'=>$f1_text)).
				'">';
			$boxtxt.= _TRACKADMIN_BYVISITS.'</a> - ';
		} else {
			$boxtxt.= _TRACKADMIN_BYVISITS.' - ';
		}

		if ($f1_sort!='time') {	     // only link if not active
			$boxtxt.= '<a href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','op'=>'trackingshow','optr'=>$menu_optr,
				'sort'=>'time',
				'timef'=>$f1_timef,
				'timet'=>$f1_timet,
				'text'=>$f1_text)).
				'">';
			$boxtxt.= _TRACKADMIN_BYTIME.'</a> - ';
		} else {
			$boxtxt.= _TRACKADMIN_BYTIME.' - ';
		}

		if ($f1_sort!='date') {	     // only link if not active
			$boxtxt.= '<a href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','op'=>'trackingshow','optr'=>$menu_optr,
				'sort'=>'date',
				'timef'=>$f1_timef,
				'timet'=>$f1_timet,
				'text'=>$f1_text)).
				'">';
			$boxtxt.= _TRACKADMIN_BYDATE.'</a> - ';
		} else {
			$boxtxt.= _TRACKADMIN_BYDATE.' - ';
		}

		if ($f1_sort!='user') {	     // only link if not active	    # WM010809
			$boxtxt.= '<a href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','op'=>'trackingshow','optr'=>$menu_optr,
				'sort'=>'user',
				'timef'=>$f1_timef,
				'timet'=>$f1_timet,
				'text'=>$f1_text)).
				'">';
			$boxtxt.= _TRACKADMIN_BYUSER.'</a> - ';
		} else {
			$boxtxt.= _TRACKADMIN_BYUSER.' - ';
		}

		if ($f1_sort!='trackid') {	  // only link if not active	    # WM010810
			$boxtxt.= '<a href="'.encodeurl(array($opnConfig['opn_url'].'/system/tracking/admin/index.php','op'=>'trackingshow','optr'=>$menu_optr,
				'sort'=>'trackid',
				'timef'=>$f1_timef,
				'timet'=>$f1_timet,
				'text'=>$f1_text)).
				'">';
			$boxtxt.= _TRACKADMIN_BYTRACKID.'</a>';
		} else {
			$boxtxt.= _TRACKADMIN_BYTRACKID;
		}
	} // IF $optr != godel
	$boxtxt.= '</span><br />'._OPN_HTML_NL;

	// display selection form for period
	$form = & new opn_FormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_TRACKING_10_', 'tracking');
	$form->Init ($opnConfig['opn_url'] . "/system/tracking/admin/index.php", 'post', 'range');
	$form->AddTable ();
	$form->AddOpenRow ();
	$form->AddLabel ('datef', _TRACKADMIN_DATEFROM);
	$form->AddTextfield ('datef', 10, 10);
	$form->AddLabel ('datet', _TRACKADMIN_DATETO);
	$form->AddTextfield ('datet', 10, 10);
	$form->AddChangeRow ();
	$form->AddLabel ('timef', _TRACKADMIN_TIMEFROM);
	$form->AddTextfield ('timef', 10, 8);
	$form->AddLabel ('timet', _TRACKADMIN_TIMETO);
	$form->AddTextfield ('timet', 10, 8);
	$form->SetSameCol ();
	$form->AddHidden ('op', 'trackingshow');
	$form->AddHidden ('optr', 'f' . $menu_optr);
	$form->AddSubmit ('submit', 'Submit');
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	// processing of links and submits
	switch ($f1_optr) {
		case 'delnow':
			$boxtxt.=delete_tracking($f1_timef, $f1_timet);
			break;
		case 'delsel':
			$boxtxt.=go_to_delete_select($f1_timef, $f1_timet);
			break;
		case 'fdelsel':			   // from Form
			$boxtxt.=go_to_delete_select($f1_timef, $f1_timet);
			break;
		case 'godel':
			$boxtxt.=go_to_delete_mode();
			break;
		case 'fstart':			     // Start from Form
			$boxtxt.=start ($f1_sort, $f1_timef, $f1_timet, $f1_text);
			break;
		case 'start':
			$boxtxt.=start ($f1_sort, $f1_timef, $f1_timet, $f1_text);
			break;
		case 'show_visit':	      // Show a single visit
			$boxtxt.=show_visit ($f1_sort, $f1_timef, $f1_timet, $f1_ip, $f1_uid, $f1_trackid, $f1_url, $f1_text);
			break;
		case 'show_page':	      // Show a single page
			$boxtxt.=show_page ($f1_sort, $f1_timef, $f1_timet, $f1_url);
			break;
		case 'show_line':	      // Show a single line		 # WM010829
			$boxtxt.=show_line ($f1_timef, $f1_ip);
			break;
		default:			// show at first call
			$boxtxt.=start ($f1_sort,
			$menu[1]['timef'], $menu[1]['timet'],
			$menu[1]['text']);
			break;
	}
	trackingConfigHeader ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_TRACKING_20_';
	$_display_dat['module'] = 'system/tracking';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_TRACKADMIN_TITLE1, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}
// END function TrackingStart
$optr = '';
get_var ('optr', $optr, 'both', _OOBJ_DTYPE_CLEAN);
$sort = 'time';
get_var ('sort', $sort, 'both', _OOBJ_DTYPE_CLEAN);
$datef = '';
get_var ('datef', $datef, 'both', _OOBJ_DTYPE_CLEAN);
$datet = '';
get_var ('datet', $datet, 'both', _OOBJ_DTYPE_CLEAN);
$timef = '';
get_var ('timef', $timef, 'both', _OOBJ_DTYPE_CLEAN);
$timet = '';
get_var ('timet', $timet, 'both', _OOBJ_DTYPE_CLEAN);
$text = '';
get_var ('text', $text, 'both', _OOBJ_DTYPE_CLEAN);
$url = '';
get_var ('url', $url, 'both', _OOBJ_DTYPE_CLEAN);
$ip = '';
get_var ('ip', $ip, 'both', _OOBJ_DTYPE_CLEAN);
$truid = '';
get_var ('truid', $truid, 'both', _OOBJ_DTYPE_CLEAN);
$trid = '';
get_var ('trid', $trid, 'both', _OOBJ_DTYPE_CLEAN);
TrackingStart ($optr, $sort, $datef, $datet, $timef, $timet, $text, $url, $ip, $truid, $trid);

?>