<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('system/user_points', true);
include_once (_OPN_ROOT_PATH . 'system/user_points/functions.php');
include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
getLanguageDef (_OPN_ROOT_PATH . 'system/user_points/admin/language/');

function user_pointsConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_UPADMIN_ADMINUPCONFIGURATION);
	$menu->InsertEntry (_UPADMIN_ADMINUPMAIN, $opnConfig['opn_url'] . '/system/user_points/admin/index.php');
	$menu->InsertEntry (_UPADMIN_ADMINCALC, array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
							'op' => 'calcpoints') );
	$menu->InsertEntry (_UPADMIN_ADMINEDIT, array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
							'op' => 'editpoints') );
	$menu->InsertEntry (_UPADMIN_ADMINDELETE, array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
							'op' => 'deletepoints'),
							'',
							true);
	$menu->InsertEntry (_UPADMIN_ADMINUSER, array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
							'op' => 'user') );
	$menu->InsertEntry (_UPADMIN_ADMINPOINTS, array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
							'op' => 'points') );
	$menu->InsertEntry (_UPADMIN_ADMINNEWMODULE, array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
							'op' => 'newmodule') );
	$menu->InsertEntry (_UPADMIN_ADMINSETTINGS, $opnConfig['opn_url'] . '/system/user_points/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);
	unset ($menu);

}

function display_text () {

	global $opnConfig;

	user_pointsConfigHeader ();
	$boxtitle = _UPADMIN_ADMINUPCONFIGURATION;
	$boxtxt = _UPADMIN_MAINTEXT1 . '<br /><br />';
	$boxtxt .= '<span class="normaltextbold">' . _UPADMIN_ADMINCALC . '</span><br />';
	$boxtxt .= _UPADMIN_MAINTEXT2 . '<br /><br />';
	$boxtxt .= '<span class="normaltextbold">' . _UPADMIN_ADMINEDIT . '</span><br />';
	$boxtxt .= _UPADMIN_MAINTEXT3 . '<br /><br />';
	$boxtxt .= '<span class="normaltextbold">' . _UPADMIN_ADMINDELETE . '</span><br />';
	$boxtxt .= _UPADMIN_MAINTEXT4 . '<br /><br />';
	$boxtxt .= '<span class="normaltextbold">' . _UPADMIN_ADMINUSER . '</span><br />';
	$boxtxt .= _UPADMIN_MAINTEXT5 . '<br /><br />';
	$boxtxt .= '<span class="normaltextbold">' . _UPADMIN_ADMINPOINTS . '</span><br />';
	$boxtxt .= _UPADMIN_MAINTEXT6 . '<br /><br />';
	$boxtxt .= '<span class="normaltextbold">' . _UPADMIN_ADMINNEWMODULE . '</span><br />';
	$boxtxt .= _UPADMIN_MAINTEXT7;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_USER_POINTS_10_';
	$_display_dat['module'] = 'system/user_points';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function GetUserSQL ($search = '') {

	global $opnConfig, $opnTables;

	$sql = 'SELECT u.uid AS uid, u.uname AS uname';
	$sql .= ' FROM ' . $opnTables['users'] . ' u, ';
	$sql .= $opnTables['users_status'] . ' us';
	$sql .= ' WHERE u.uid=us.uid AND us.level1<>' . _PERM_USER_STATUS_DELETE . ' AND u.uid<>' . $opnConfig['opn_anonymous_id'];
	if ($search != '') {
		$like_search = $opnConfig['opnSQL']->AddLike ($search);
		$sql .= " AND (u.uname LIKE $like_search OR u.email LIKE $like_search)";
	}
	$sql .= ' ORDER BY u.uid';
	return $sql;

}

function GetCountSQL ($search = '') {

	global $opnConfig, $opnTables;

	$sql = 'SELECT COUNT(u.uid) AS counter';
	$sql .= ' FROM ' . $opnTables['users'] . ' u, ';
	$sql .= $opnTables['users_status'] . ' us';
	$sql .= ' WHERE u.uid=us.uid AND us.level1<>' . _PERM_USER_STATUS_DELETE . ' AND u.uid<>' . $opnConfig['opn_anonymous_id'];
	if ($search != '') {
		$like_search = $opnConfig['opnSQL']->AddLike ($search);
		$sql .= " AND (u.uname LIKE $like_search OR u.email LIKE $like_search)";
	}
	return $sql;

}

function calcpoints () {

	global $opnConfig;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$output = '';
	get_var ('output', $output, 'url', _OOBJ_DTYPE_CLEAN);
	$sql = GetUserSQL ();
	$sql1 = GetCountSQL ();
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$justforcounting = &$opnConfig['database']->Execute ($sql1);
	if ( ($justforcounting !== false) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$result = &$opnConfig['database']->SelectLimit ($sql, $maxperpage, $offset);
	while (! $result->EOF) {
		$uid = $result->fields['uid'];
		Count_Points ($uid);
		$result->MoveNext ();
	}
	// while
	$numberofPages = ceil ($reccount/ $maxperpage);
	$actualPage = ceil ( ($offset+1)/ $maxperpage);
	if ($actualPage<=$numberofPages) {
		$offset = ($actualPage* $maxperpage);
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
								'op' => 'calcpoints',
								'offset' => $offset,
								'output' => $output),
								false) );
	} else {
		if ($output == '') {
			user_pointsConfigHeader ();
			$boxtxt = _UPADMIN_CALCPOINTSDONE;
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_USER_POINTS_20_';
			$_display_dat['module'] = 'system/user_points';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (_UPADMIN_ADMINCALC, $boxtxt);
			$opnConfig['opnOutput']->DisplayFoot ();
		} else {
			$opnConfig['opnOutput']->Redirect (encodeurl ($output, false) );
		}
	}

}

function editpoints () {

	global $opnConfig;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$search = '';
	get_var ('search', $search, 'form');
	$sql = GetUserSQL ($search);
	$sql1 = GetCountSQL ($search);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$justforcounting = &$opnConfig['database']->Execute ($sql1);
	if ( ($justforcounting !== false) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$result = &$opnConfig['database']->SelectLimit ($sql, $maxperpage, $offset);
	user_pointsConfigHeader ();
	$boxtxt = '';
	$form = & new opn_FormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_USER_POINTS_30_', 'useradmin');
	$form->Init (encodeurl ($opnConfig['opn_url'] . '/system/user_points/admin/index.php'), 'post');
	$form->AddTable ();
	$form->AddOpenRow ();
	$form->AddLabel ('search', _UPADMIN_SEARCH);
	$form->AddTextfield ('search', 50, 50, $search);
	$form->SetSameCol ();
	$form->AddHidden ('op', 'editpoints');
	$form->AddSubmit ('submit', _UPADMIN_SEARCH1);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddCols (array ('10%', '90%') );
	if ($result !== false) {
		if ($result->fields !== false) {
			while (! $result->EOF) {
				$uid = $result->fields['uid'];
				$uname = $result->fields['uname'];
				$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
											'op' => 'doedit',
											'uid' => $uid,
											'uname' => $uname) ) . '">' . $uname . '</a>';
				$table->AddDataRow (array ($uid, $hlp), array ('right', 'left') );
				$result->MoveNext ();
			}
		}
	}
	$table->GetTable ($boxtxt);
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
					'op' => 'editpoints'),
					$reccount,
					$maxperpage,
					$offset);
	$boxtxt .= '<br /><br />' . $pagebar;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_USER_POINTS_40_';
	$_display_dat['module'] = 'system/user_points';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_UPADMIN_ADMINEDIT, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function doedit () {

	global $opnConfig;

	$uid = 0;
	get_var ('uid', $uid, 'url', _OOBJ_DTYPE_INT);
	$uname = '';
	get_var ('uname', $uname, 'url', _OOBJ_DTYPE_CLEAN);
	$points = Count_Points ($uid);
	user_pointsConfigHeader ();
	$boxtxt = sprintf (_UPADMIN_HASPOINTS, $uname, $points) . '<br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_USER_POINTS_50_', 'user_points');
	$form->Init ($opnConfig['opn_url'] . '/system/user_points/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('15%', '85%') );
	$form->AddOpenRow ();
	$form->AddLabel ('username', _UPADMIN_USERNAME);
	$form->AddTextfield ('username', 0, 0, $uname, true);
	$form->AddChangeRow ();
	$form->AddLabel ('userpoints', _UPADMIN_USERPOINTS);
	$form->AddTextfield ('userpoints');
	$form->AddChangeRow ();
	$form->AddLabel ('dowhat', _UPADMIN_DOWHAT);
	$options['plus'] = _UPADMIN_PLUS;
	$options['minus'] = _UPADMIN_MINUS;
	$form->AddSelect ('dowhat', $options);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('uid', $uid);
	$form->AddHidden ('op', 'saveedit');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _UPADMIN_SAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_USER_POINTS_60_';
	$_display_dat['module'] = 'system/user_points';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_UPADMIN_ADMINEDIT, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function saveedit () {

	global $opnConfig, $opnTables;

	$uid = 0;
	get_var ('uid', $uid, 'form', _OOBJ_DTYPE_INT);
	$userpoints = 0;
	get_var ('userpoints', $userpoints, 'form', _OOBJ_DTYPE_INT);
	$dowhat = '';
	get_var ('dowhat', $dowhat, 'form', _OOBJ_DTYPE_CHECK);
	$result = $opnConfig['database']->Execute ('SELECT specialpoints FROM ' . $opnTables['user_points'] . ' WHERE uid=' . $uid);
	if ($result->RecordCount () == 1) {
		$points = $result->fields['specialpoints'];
		if ($dowhat == 'plus') {
			$points += $userpoints;
		} elseif ($dowhat == 'minus') {
			$points -= $userpoints;
		}
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_points'] . " SET specialpoints=$points WHERE uid=" . $uid);
	}
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/system/user_points/admin/index.php?op=editpoints', false) );
	CloseTheOpnDB ($opnConfig);

}

function deletepoints () {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$docount = 0;
	get_var ('docount', $docount, 'url', _OOBJ_DTYPE_INT);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sql = 'SELECT uid, points FROM ' . $opnTables['user_points'] . ' WHERE wactive=0';
	$sql1 = 'SELECT COUNT(uid) AS counter FROM ' . $opnTables['user_points'] . ' WHERE wactive=0';
	if ( ($offset == 0) && ($docount == 0) ) {
		set_var ('offset', 0, 'url');
		set_var ('output', array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
					'op' => 'deletepoints',
					'offset' => '0',
					'docount' => '1'),
					'url');
		calcpoints ();
	}
	$justforcounting = &$opnConfig['database']->Execute ($sql1);
	if ( ($justforcounting !== false) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$result = &$opnConfig['database']->SelectLimit ($sql, $maxperpage, $offset);
	$opnConfig['opndate']->now ();
	$now = 0;
	$opnConfig['opndate']->opnDataTosql ($now);
	while (! $result->EOF) {
		$uid = $result->fields['uid'];
		$points = $result->fields['points'];
		$id = $opnConfig['opnSQL']->get_new_number ('user_points_backup', 'id');
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['user_points_backup'] . " VALUES ($id,$uid,$points,$now)");
		$result->MoveNext ();
	}
	// while
	$numberofPages = ceil ($reccount/ $maxperpage);
	$actualPage = ceil ( ($offset+1)/ $maxperpage);
	if ($actualPage<=$numberofPages) {
		$offset = ($actualPage* $maxperpage);
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
								'op' => 'deletepoints',
								'offset' => $offset,
								'docount' => $docount),
								false) );
	} else {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_points'] . ' WHERE wactive=0');
		$opnConfig['module']->LoadPublicSettings ();
		$pubsettings['user_points_date'] = $now;
		$opnConfig['module']->SetPublicSettings ($pubsettings);
		$opnConfig['module']->SavePublicSettings ();
		user_pointsConfigHeader ();
		$boxtxt = _UPADMIN_DEELETEYES . '<br /></br >';
		$boxtxt .= '<a href="' . encodeurl ($opnConfig['opn_url'] . '/system/user_points/admin/index.php?op=calcpoints') . '">' . _UPDAMIN_NEXT . '</a>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_USER_POINTS_70_';
		$_display_dat['module'] = 'system/user_points';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_UPADMIN_ADMINDELETE, $boxtxt);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function DisplayUser () {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$sql = 'SELECT u.uid AS uid, u.uname AS uname, up.wactive AS wactive FROM ' . $opnTables['users'] . ' u,';
	$sql .= ' ' . $opnTables['user_points'] . ' up';
	$sql .= ' WHERE u.uid=up.uid ORDER BY u.uid';
	$sql1 = 'SELECT COUNT(u.uid) AS counter FROM ' . $opnTables['users'] . ' u,';
	$sql1 .= ' ' . $opnTables['user_points'] . ' up';
	$sql1 .= ' WHERE u.uid=up.uid';
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$justforcounting = &$opnConfig['database']->Execute ($sql1);
	if ( ($justforcounting !== false) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$result = &$opnConfig['database']->SelectLimit ($sql, $maxperpage, $offset);
	user_pointsConfigHeader ();
	$table = & new opn_TableClass ('alternator');
	if ($result !== false) {
		if ($result->fields !== false) {
			while (! $result->EOF) {
				$uid = $result->fields['uid'];
				$uname = $result->fields['uname'];
				$active = $result->fields['wactive'];
				$url = array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
												'op' => 'douser',
												'uid' => $uid,
												'offset' => $offset);
				if ($active == 0) {
					$url['active'] = 1;
					$active = 1;
				} else {
					$url['active'] = 0;
					$active = 0;
				}
				$url = $opnConfig['defimages']->get_activate_deactivate_link ($url, $active);
				$table->AddDataRow (array ($uname, $url) );
				$result->MoveNext ();
			}
		}
	}
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
					'op' => 'user'),
					$reccount,
					$maxperpage,
					$offset);
	$boxtxt .= '<br /><br />' . $pagebar;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_USER_POINTS_80_';
	$_display_dat['module'] = 'system/user_points';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_UPADMIN_ADMINUSER, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function DoUser () {

	global $opnConfig, $opnTables;

	$uid = 0;
	get_var ('uid', $uid, 'url', _OOBJ_DTYPE_INT);
	$active = 0;
	get_var ('active', $active, 'url', _OOBJ_DTYPE_INT);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_points'] . " SET wactive=$active WHERE uid=$uid");
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
							'op' => 'user',
							'offset' => $offset),
							false) );

}

function EditPointsdb () {

	global $opnConfig, $opnTables;

	$result = &$opnConfig['database']->ExeCute ('SELECT id, description, points FROM ' . $opnTables['user_points_tables']);
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_USER_POINTS_90_', 'user_points');
	$form->Init ($opnConfig['opn_url'] . '/system/user_points/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	while (! $result->EOF) {
		$id = $result->fields['id'];
		$description = $result->fields['description'];
		$points = $result->fields['points'];
		$form->AddOpenRow ();
		$form->AddLabel ('points[' . $id . ']', $description . ': ');
		$form->AddTextfield ('points[' . $id . ']', 0, 0, $points);
		$form->AddCloseRow ();
		$result->MoveNext ();
	}
	// while
	$form->AddOpenRow ();
	$form->AddHidden ('op', 'dopoints');
	$form->AddSubmit ('submit', _UPADMIN_SAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	user_pointsConfigHeader ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_USER_POINTS_100_';
	$_display_dat['module'] = 'system/user_points';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_UPADMIN_ADMINPOINTS, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function savepoints () {

	global $opnConfig, $opnTables;

	$points = array ();
	get_var ('points', $points,'form',_OOBJ_DTYPE_CHECK);
	$result = &$opnConfig['database']->Execute ('SELECT id FROM ' . $opnTables['user_points_tables']);
	while (! $result->EOF) {
		$id = $result->fields['id'];
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_points_tables'] . ' SET points=' . $points[$id] . ' WHERE id=' . $id);
		$result->MoveNext ();
	}
	// while
	$opnConfig['opnOutput']->Redirect ($opnConfig['opn_url'] . '/system/user_points/admin/index.php');

}

function newmodule () {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$sql = 'SELECT id, description, tablename, userfield, datefield, uidoruname FROM ' . $opnTables['user_points_tables'];
	$sql1 = 'SELECT COUNT(id) AS counter FROM ' . $opnTables['user_points_tables'];
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$justforcounting = &$opnConfig['database']->Execute ($sql1);
	if ( ($justforcounting !== false) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$result = &$opnConfig['database']->SelectLimit ($sql, $maxperpage, $offset);
	user_pointsConfigHeader ();
	$boxtxt = '';
	$boxtxt .= _UPADMIN_DECLARE . '<br /><br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_UPADMIN_DESCRIPTION, _UPADMIN_TABLENAME, _UPADMIN_UFIELD, _UPADMIN_DFIELD, _UPADMIN_NAMEORID, _UPADMIN_FUNCTIONS) );
	if ($result !== false) {
		if ($result->fields !== false) {
			while (! $result->EOF) {
				$id = $result->fields['id'];
				$description = $result->fields['description'];
				$tablename = $result->fields['tablename'];
				$userfield = $result->fields['userfield'];
				$datefield = $result->fields['datefield'];
				$uidoruname = $result->fields['uidoruname'];
				$hlp = $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
											'op' => 'editdb',
											'id' => $id) );
				$hlp .= '&nbsp;' . $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
												'op' => 'deletedb',
												'id' => $id) );
				$table->AddDataRow (array ($description, $tablename, $userfield, $datefield, $uidoruname, $hlp) );
				$result->MoveNext ();
			}
		}
	}
	$table->GetTable ($boxtxt);
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
					'op' => 'newmodule'),
					$reccount,
					$maxperpage,
					$offset);
	$boxtxt .= '<br /><br />' . $pagebar;
	$help = '';
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_USER_POINTS_110_', 'user_points');
	$form = & new opn_FormularClass ('listalternator');
	$form->Init ($opnConfig['opn_url'] . '/system/user_points/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('description', _UPADMIN_DESCRIPTION . ': ');
	$form->AddTextfield ('description');
	$form->AddChangeRow ();
	$form->AddLabel ('tablename', _UPADMIN_TABLENAME . ': ');
	$form->AddTextfield ('tablename');
	$form->AddChangeRow ();
	$form->AddLabel ('ufield', _UPADMIN_UFIELD . ': ');
	$form->AddTextfield ('ufield');
	$form->AddChangeRow ();
	$form->AddLabel ('dfield', _UPADMIN_DFIELD . ': ');
	$form->AddTextfield ('dfield');
	$form->AddChangeRow ();
	$form->AddLabel ('uioruname', _UPADMIN_NAMEORID . ': ');
	$form->AddTextfield ('uioruname');
	$form->AddChangeRow ();
	$form->AddLabel ('points', _UPADMIN_USERPOINTS);
	$form->AddTextfield ('points');
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'newdb');
	$form->AddSubmit ('submit', _UPADMIN_SAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($help);
	$boxtxt .= '<br /><br />' . $help;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_USER_POINTS_120_';
	$_display_dat['module'] = 'system/user_points';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_UPADMIN_ADMINNEWMODULE, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function newdb () {

	global $opnConfig, $opnTables;

	$description = '';
	get_var ('description', $description, 'form', _OOBJ_DTYPE_CHECK);
	$tablename = '';
	get_var ('tablename', $tablename, 'form', _OOBJ_DTYPE_CHECK);
	$ufield = '';
	get_var ('ufield', $ufield, 'form', _OOBJ_DTYPE_CHECK);
	$dfield = '';
	get_var ('dfield', $dfield, 'form', _OOBJ_DTYPE_CHECK);
	$uioruname = 0;
	get_var ('uioruname', $uioruname, 'form', _OOBJ_DTYPE_INT);
	$points = 0;
	get_var ('points', $points, 'form', _OOBJ_DTYPE_INT);
	$description = $opnConfig['opnSQL']->qstr ($description, 'description');
	$tablename = $opnConfig['opnSQL']->qstr ($tablename, 'tablename');
	$ufield = $opnConfig['opnSQL']->qstr ($ufield, 'userfield');
	$dfield = $opnConfig['opnSQL']->qstr ($dfield, 'datefield');
	$id = $opnConfig['opnSQL']->get_new_number ('user_points_tables', 'id');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['user_points_tables'] . " VALUES ($id,$description,$tablename,$ufield,$dfield,$uioruname,$points)");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['user_points_tables'], 'id=' . $id);
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/system/user_points/admin/index.php?op=newmodule', false) );

}

function deletedb () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_points_tables'] . " WHERE sid=$id");
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/system/user_points/admin/index.php?op=newmodule', false) );
	} else {
		$txt = '<div align="center" class="bigtextbold">';
		$txt .= '<span class="alerttextcolor">' . _UPADMIN_SUREDELETE . '</span>';
		$txt .= '<br /><br /><a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user_points/admin/index.php?op=newmodule') . '">' . _NO . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user_points/admin/index.php',
																															'op' => 'deletedb',
																															'id' => $id,
																															'ok' => '1') ) . '">' . _YES . '</a></div>';
		user_pointsConfigHeader ();
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_USER_POINTS_130_';
		$_display_dat['module'] = 'system/user_points';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_UPADMIN_ADMINNEWMODULE, $txt);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function editdb () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$sql = 'SELECT id, description, tablename, userfield, datefield, uidoruname FROM ' . $opnTables['user_points_tables'] . ' WHERE id=' . $id;
	$result = &$opnConfig['database']->Execute ($sql);
	$boxtxt = _UPADMIN_DECLARE . '<br /><br />';
	$id = $result->fields['id'];
	$description = $result->fields['description'];
	$tablename = $result->fields['tablename'];
	$userfield = $result->fields['userfield'];
	$datefield = $result->fields['datefield'];
	$uidoruname = $result->fields['uidoruname'];
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_USER_POINTS_140_', 'user_points');
	$form = & new opn_FormularClass ('listalternator');
	$form->Init ($opnConfig['opn_url'] . '/system/user_points/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('35%', '65%') );
	$form->AddOpenRow ();
	$form->AddLabel ('description', _UPADMIN_DESCRIPTION . ': ');
	$form->AddTextfield ('description', 0, 0, $description);
	$form->AddChangeRow ();
	$form->AddLabel ('tablename', _UPADMIN_TABLENAME . ': ');
	$form->AddTextfield ('tabelname', 0, 0, $tablename);
	$form->AddChangeRow ();
	$form->AddLabel ('ufield', _UPADMIN_UFIELD . ': ');
	$form->AddTextfield ('ufield', 0, 0, $userfield);
	$form->AddChangeRow ();
	$form->AddLabel ('dfield', _UPADMIN_DFIELD . ': ');
	$form->AddTextfield ('dfield', 0, 0, $datefield);
	$form->AddChangeRow ();
	$form->AddLabel ('uioruname', _UPADMIN_NAMEORID . ': ');
	$form->AddTextfield ('uioruname', 0, 0, $uidoruname);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('id', $id);
	$form->AddHidden ('op', 'savedb');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _UPADMIN_SAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	user_pointsConfigHeader ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_USER_POINTS_150_';
	$_display_dat['module'] = 'system/user_points';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_UPADMIN_ADMINNEWMODULE, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function savedb () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$description = '';
	get_var ('description', $description, 'form', _OOBJ_DTYPE_CHECK);
	$tablename = '';
	get_var ('tablename', $tablename, 'form', _OOBJ_DTYPE_CHECK);
	$ufield = '';
	get_var ('ufield', $ufield, 'form', _OOBJ_DTYPE_CHECK);
	$dfield = '';
	get_var ('dfield', $dfield, 'form', _OOBJ_DTYPE_CHECK);
	$uioruname = 0;
	get_var ('uioruname', $uioruname, 'form', _OOBJ_DTYPE_INT);
	$description = $opnConfig['opnSQL']->qstr ($description, 'description');
	$tablename = $opnConfig['opnSQL']->qstr ($tablename, 'tablename');
	$ufield = $opnConfig['opnSQL']->qstr ($ufield, 'userfield');
	$dfield = $opnConfig['opnSQL']->qstr ($dfield, 'datefield');
	$uioruname = $opnConfig['opnSQL']->qstr ($uioruname);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_points_tables'] . " SET  description=$description, tablename=$tablename,
								userfield=$ufield, datefield=$dfield, uidoruname=$uioruname
								 WHERE id=$id");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['user_points_tables'], 'id=' . $id);
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/system/user_points/admin/index.php?op=newmodule', false) );

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'calcpoints':
		calcpoints ();
		break;
	case 'editpoints':
		editpoints ();
		break;
	case 'doedit':
		doedit ();
		break;
	case 'saveedit':
		saveedit ();
		break;
	case 'deletepoints':
		deletepoints ();
		break;
	case 'user':
		DisplayUser ();
		break;
	case 'douser':
		douser ();
		break;
	case 'points':
		editpointsdb ();
		break;
	case 'dopoints':
		savepoints ();
		break;
	case 'newmodule':
		newmodule ();
		break;
	case 'newdb':
		newdb ();
		break;
	case 'deletedb':
		deletedb ();
		break;
	case 'editdb':
		editdb ();
		break;
	case 'savedb':
		savedb ();
		break;
	default:
		display_text ();
		break;
}
// switch

?>