<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

$opnTheme['privat_at']['center'] = '';
$opnTheme['privat_at']['left'] = '';
$opnTheme['privat_at']['right'] = '';
$opnTheme['privat_at']['page'] = false;
$opnTheme['themeinit'] = 'autotheme_theme_init';
$opnTheme['themeinit_css'] = 'autotheme_theme_init_css';
$opnTheme['privat_at']['page'] = '';

function autotheme_theme_init () {

	global $opnConfig, $opnTheme;

	$opncss = $opnConfig['opnOutput']->getcss ('opn_themes_include');
	if ($opncss != '') {
		echo '<link href="' . $opncss . '" rel="stylesheet" type="text/css" />' . _OPN_HTML_NL;
	}
	$css = $opnConfig['opn_url'] . '/themes/' . $opnTheme['thename'] . '/style/style.css';
	$css_path = _OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/style/style.css';
	if (file_exists ($css_path) ) {
		echo '<link href="' . $css . '" rel="stylesheet" type="text/css" />' . _OPN_HTML_NL;
	}
	echo '<!--[if IE]>' . _OPN_HTML_NL;
	echo '<style type="text/css">' . _OPN_HTML_NL;
	echo '.editorimage {cursor:hand;}' . _OPN_HTML_NL;
	echo '</style>' . _OPN_HTML_NL;
	echo '<![endif]-->' . _OPN_HTML_NL;
	echo '<link href="' . $opnConfig['opn_url'] . '/favicon.ico" rel="SHORTCUT ICON" />' . _OPN_HTML_NL;
	echo '<link href="' . $opnConfig['opn_url'] . '/favicon.ico" rel="icon" type="image/ico" />' . _OPN_HTML_NL;

}

function autotheme_theme_init_css () {

	global $opnConfig, $opnTheme;

	$opncss = $opnConfig['opnOutput']->getcss ('opn_themes_include');
	$txt = '';
	if ($opncss != '') {
		$txt .= '<link href="' . $opncss . '" rel="stylesheet" type="text/css" />' . _OPN_HTML_NL;
	}
	$css = $opnConfig['opn_url'] . '/themes/' . $opnTheme['thename'] . '/style/style.css';
	$css_path = _OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/style/style.css';
	if (file_exists ($css_path) ) {
		$txt .= '<link href="' . $css . '" rel="stylesheet" type="text/css" />' . _OPN_HTML_NL;
	}
	$txt .= '<!--[if IE]>' . _OPN_HTML_NL;
	$txt .= '<style type="text/css">' . _OPN_HTML_NL;
	$txt .= '.editorimage {cursor:hand;}' . _OPN_HTML_NL;
	$txt .= '</style>' . _OPN_HTML_NL;
	$txt .= '<![endif]-->' . _OPN_HTML_NL;
	$txt .= '<link href="' . $opnConfig['opn_url'] . '/favicon.ico" rel="SHORTCUT ICON" />' . _OPN_HTML_NL;
	$txt .= '<link href="' . $opnConfig['opn_url'] . '/favicon.ico" rel="icon" type="image/ico" />' . _OPN_HTML_NL;
	return $txt;

}

function file_get_content ($filename) {
	if (file_exists ($filename) ) {
		if (is_file ($filename) ) {
			$result = '';
			$handle = @fopen ($filename, 'r');
			if (!$handle) {
				return false;
			}
			while (!feof ($handle) ) {
				$result .= fread ($handle, 4096);
			}
			return $result;
		}
	}
	return false;

}

function TemplateRead ($filename) {

	$temp = @file_get_content ($filename);
	return $temp;

}

function InsertDefaulsVar (&$txt) {

	global $opnConfig, $opnTheme;

	$txt = str_replace ('{image-path}', $opnConfig['opn_url'] . '/themes/' . $opnTheme['thename'] . '/images/', $txt);
	$txt = str_replace ('{sitename}', $opnConfig['sitename'], $txt);
	$txt = str_replace ('{slogan}', $opnConfig['slogan'], $txt);
	$txt = str_replace ('<!-- [site-name] -->', $opnConfig['sitename'], $txt);
	$txt = str_replace ('<!-- [site-slogan] -->', $opnConfig['slogan'], $txt);
	$txt = str_replace ('{color1}', $opnTheme['bgcolor1'], $txt);
	$txt = str_replace ('{color2}', $opnTheme['bgcolor2'], $txt);
	$txt = str_replace ('{color3}', $opnTheme['bgcolor3'], $txt);
	$txt = str_replace ('{color4}', $opnTheme['bgcolor4'], $txt);

}

function themeheader () {

	global $opnConfig, $opnTheme;
	if ( ($opnConfig['opnOption']['show_lblock'] == 1) OR ($opnConfig['opnOutput']->GetDisplay () == '') ) {
		ob_start ();
		make_box ('left', 'side');
		$opnTheme['privat_at']['left'] = ob_get_contents ();
		ob_end_clean ();
	}
	if ($opnConfig['opnOption']['show_rblock'] == 1) {
		ob_start ();
		make_box ('right', 'side');
		$opnTheme['privat_at']['right'] = ob_get_contents ();
		ob_end_clean ();
	}
	if ($opnConfig['opnOption']['show_middleblock'] == 1) {
		ob_start ();
		make_box ('left', 'middle');
		$opnTheme['privat_at']['center'] = ob_get_contents ();
		ob_end_clean ();
	}
	$opnTheme['privat_at']['page'] = false;
	if ($opnTheme['privat_at']['page'] === false) $opnTheme['privat_at']['page'] = TemplateRead (_OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/theme.html');
	if ($opnTheme['privat_at']['page'] === false) $opnTheme['privat_at']['page'] = TemplateRead (_OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/header.html');
	InsertDefaulsVar ($opnTheme['privat_at']['page']);
	ob_start ();

}

function themebox_side (&$txt, $title, $content, $foot = '') {

	global $opnConfig, $opnTheme;
	if ($opnConfig['theme_aktuell_sidebox_side'] == 'left') {
		$txt = TemplateRead (_OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/leftblock.html');
	} else {
		$txt = TemplateRead (_OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/rightblock.html');
	}
	$txt = str_replace ('<!-- [block-content] -->', $content, $txt);
	$txt = str_replace ('<!-- [block-title] -->', $title, $txt);
	$txt = str_replace ('<!-- [block-foot] -->', $foot, $txt);

}

function themesidebox ($title, $content) {

	$txt = '';
	themebox_side ($txt, $title, $content, '');
	echo $txt;
	unset ($txt);

}

function themebox_center (&$txt, $title, $content, $foot = '') {

	global $opnTheme;

	$txt = TemplateRead (_OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/centerblock.html');
	$txt = str_replace ('<!-- [block-content] -->', $content, $txt);
	$txt = str_replace ('<!-- [block-title] -->', $title, $txt);
	$txt = str_replace ('<!-- [block-foot] -->', $foot, $txt);

}
if (!function_exists ('makenav_box') ) {

	function makenav_box ($i, $url, $urltext, $urllight, $wechsel, $target, $css, $title) {

		global $opnConfig;

		$t = $i;
		$t = $urllight;
		$opnConfig['cleantext']->OPNformatURL ($url);
		if ($target) {
			$new = ' target="_blank"';
		} else {
			$new = '';
		}
		if ($css == '') {
			$css = 'button';
		}
		if ($title != '') {
			$title = ' title="' . $title . '"';
		} else {
			$title = '';
		}
		$txt = '<a href="' . $url . '"' . $new . $title . ' class="' . $css . '">' . $urltext . '</a>';
		return $txt . $wechsel;

	}
}
if (!function_exists ('makenav_box_build') ) {

	function makenav_box_build () {

		global $opnConfig;

		$rt = '';
		$ii = 0;
		if ( (isset ($opnConfig['theme_nav']) ) && (is_array ($opnConfig['theme_nav']) ) ) {
			foreach ($opnConfig['theme_nav'] as $var) {
				$max=count($var);
				for ($i=0; $i<$max; $i++) {
					$ii++;
					if ($var[$i]['img'] != '') {
						$var[$i]['urltext'] = '<img src="' . $var[$i]['img'] . '" alt="' . $var[$i]['urltext'] . '" />';
					}
					if (!isset ($var[$i]['target']) ) {
						$var[$i]['target'] = 0;
					}
					if (!isset ($var[$i]['css']) ) {
						$var[$i]['css'] = 'button';
					}
					if (!isset ($var[$i]['title']) ) {
						$var[$i]['title'] = '';
					}
					$rt .= makenav_box ($ii, $var[$i]['url'], $var[$i]['urltext'], $var[$i]['show'], '', $var[$i]['target'], $var[$i]['css'], $var[$i]['title']);
				}
			}
		}
		return $rt;

	}
}

function themefooter () {

	global $opnTheme, $opnConfig;

	$opnTheme['privat_at']['center'] .= ob_get_contents ();
	ob_end_clean ();
	$txt = TemplateRead (_OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/footnav.html');
	if ($txt === false) {
		$txt = '';
	} else {
		InsertDefaulsVar ($txt);
	}
	if ($opnTheme['privat_at']['page'] !== false) {
		$txt = $opnTheme['privat_at']['page'] . $txt;
	}
	$txt = str_replace ('<!-- [left-blocks] -->', $opnTheme['privat_at']['left'], $txt);
	$txt = str_replace ('<!-- [right-blocks] -->', $opnTheme['privat_at']['right'], $txt);
	$txt = str_replace ('<!-- [center-blocks] -->', $opnTheme['privat_at']['center'], $txt);
	$txt = str_replace ('<!-- [footer-msg] -->', $opnConfig['opnOutput']->GetFootMsg (), $txt);
	$dummy_txt = '';
	OpenTable ($dummy_txt);
	$txt = str_replace ('<!-- [open-table] -->', $dummy_txt, $txt);
	$dummy_txt = '';
	CloseTable ($dummy_txt);
	$txt = str_replace ('<!-- [close-table] -->', $dummy_txt, $txt);
	$ui = $opnConfig['permission']->GetUserinfo ();
	$txt = str_replace ('<!-- [opn-date] -->', "", $txt);
	$txt = str_replace ('<!-- [opn-time] -->', "", $txt);
	$txt = str_replace ('<!-- [opn-user] -->', $ui['uname'], $txt);
	$txt = str_replace ('<!-- [user] -->', $ui['uname'], $txt);
	$txt = str_replace ('<!-- [opn-search] -->', "", $txt);
	$txt = str_replace ('<!-- [nav-blocks] -->', makenav_box_build (), $txt);
	if ( (isset ($opnConfig['opn-theme-logo']) ) && ($opnConfig['opn-theme-logo'] != '') ) {
		$opnTheme['opn-theme-logo'] = '<img src="' . $opnConfig['url_datasave'] . '/logo/' . $opnConfig['opn-theme-logo'] . '" border="0" valign="bottom" width="500" height="110">';
		$txt = str_replace ('<!-- [opn-theme-logo] -->', $opnTheme['opn-theme-logo'], $txt);
	} elseif ( (isset ($opnTheme['opn-theme-logo']) ) && ($opnTheme['opn-theme-logo'] != '') ) {
		$txt = str_replace ('<!-- [opn-theme-logo] -->', $opnTheme['opn-theme-logo'], $txt);
	} else {
		$txt = str_replace ('<!-- [opn-theme-logo] -->', "", $txt);
	}
	InsertDefaulsVar ($txt);
	echo $txt;
	return '<div align="center" class="smalltext">' . _OPN_HTML_NL . '%s' . _OPN_HTML_NL . '</div>' . _OPN_HTML_NL;

}

?>